// LJ.h
#ifndef __LennardJones__
#define __LennardJones__

#define  kScreenAtomTypesRezID  141 
#define  kScreenNeighborsRezID  142 

#include "LJRegistry.h"
#include "kSanPotentialPlugIn.h"
#include "string.h" // to get def for strlen
#define kDefaultPotentialDialogResID 141

#define	iLJAExponentItem 		10
#define	iLJRExponentItem 		6
#define	iLJAPrefactorItem 		8
#define	iLJRPrefactorItem 		4
#define	iLJForceShiftItem 		12
#define	iLJRNoughtItem 			14

#define  kPlugInRezType  'k3PI'
#define  kPlugInIDRezID  128 // use 129 if you need an internal ID
#define  kPlugInAtomTypesRezID  130 
#define  kPlugInNeighborsRezID  131 

#define 	k3LJAttractiveExponentResID		142	
#define 	k3LJRepulsiveExponentResID		143
#define 	k3LJAttractivePrefactorResID	144	
#define 	k3LJRepulsivePrefactorResID		145
#define 	k3LJForceShiftResID				146
#define 	k3LJRNoughtResID				147


typedef struct LJPlugInType 
{
	kSanPotentialPlugIn *ppi;
 	double AttractiveExponent;
	double RepulsiveExponent;
	double AttractivePrefactor;
	double RepulsivePrefactor;
	double ForceShift;
	double InverseRNought;
	double RNought;
	double APrefactorTimesAExponent;
	double RPrefactorTimesRExponent;
}
LJPlugIn;

short LJConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma);
short  LJDestructor(KozoDispatchStack *ds, destructorMethodArgs *dma);
short LJGetData (KozoDispatchStack *ds, getMethodArgs *gma);
short LJSetData (KozoDispatchStack *ds, setMethodArgs *sma);
short LJDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma);


short LJManyParticleEnergyCalc ( kSanPotentialPlugIn *ppi, kSanSimulation *sim, long firstPart, long lastPart, double *retVal) ;
short LJManyParticleForceCalc ( kSanPotentialPlugIn *ppi, kSanSimulation *sim, long firstPart, long lastPart) ; 
short LJOneParticleForceCalc ( kSanPotentialPlugIn *ppi, kSanSimulation *sim, long whichPart) ;
short LJOneParticleEnergyCalc ( kSanPotentialPlugIn *ppi, kSanSimulation *sim, long whichPart, double *retVal) ;
short LJOneParticleVirialCalc ( kSanPotentialPlugIn *ppi,  kSanSimulation *sim, long whichPart, kSanMatrix *rMat) ;
				

#endif