#ifndef __kSanAGWindow__
#define __kSanAGWindow__

#define kAGWindowSettingsDialog 'AGgd'
#define kAGWindowShowBondsToggle 'AGbt'
#define kAGWindowDefaultView 'AGdv'
#define kAGWindowMouseFunctionToggle 'AGmf'
#define kAGRollCellButton 'Roll'
#define kAGSelectHighlightButton 'SelH'

#include <Controls.h>
#include <fp.h>
#include "OHWindowPrivate.h"
#include "OHBufferedView.h"
#include "OHWindow.h"
#include "kSanObject.h"
#include "kSanSimulation.h"
#include "kSanApplicationPublic.h"
#include "kSanAGWindowPublic.h"
#include "kSanColourPlugIn.h"

//extern kozoObject *agMenu;

 
typedef struct AGWindowType
{
	OHWindow *win;
	long lastIdle;
	short lastToggle;
	char doColourCalc;// if true, update the colours and pattern in makeWorld
	char transparentAtoms;
	
	cellManip manip;
	viewInfo	windowView;	
	DescType  mode; // roll cell or select
 
	//Handle grafDataHandle; // a grafData structure array
	//long grafLockCount;
	VSList grafDataList;
	OHList particleList; 
	BitList partBits; 
	OHList orderList;
	RGBColor BGColour;
	short unuzed;
	char orderListDirty;
	char grafDataDirty;
	char partListDirty;  // when true, the list must be rebuilt from partBits
 	char nowBeingHacked;
 	GWorldPtr redChannel;
 	GWorldPtr blueChannel;
 	
	float (*setMySize) (struct AGWindowType * , kSanAtomtype **atArray, viewInfo * , particle *, long );
	float (*setMyActualSize) (struct AGWindowType *, kSanAtomtype **atArray , viewInfo * , particle *, long ); // needed in calculating bond lengths
	void (*setForeColour) ( struct AGWindowType *, grafData * );

	kSanAtomtype **atArray; // used to optimize calls to the size functions;
	kSanSimulation *sim; // the simData
	
//	void *cpiData;
//	kozoObject *cpiObj;
	kSanColourPlugIn *cpi;
}
AGWindow ;

typedef struct AGWindowAnimateArgsType
{
	AGWindow *ag;
	RgnHandle activeRgn;
	Point center;
	short fullHoriz;
	short fullVert;
}
AGWindowAnimateArgs;

#define agWinData(obj) ((AGWindow *)kozoObjectGetPrivateData(obj, ClassAGWindow))

void AGWindowSetDragActiveRegion(AGWindow *ag, RgnHandle activeRegion);

 void initAGWindowClass(void);
short AGWindowConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma);
short AGWindowDestructor (KozoDispatchStack *ds, destructorMethodArgs* dma);
 short AGWindowSetData (KozoDispatchStack *ds, setMethodArgs *sma);
short AGWindowGetData (KozoDispatchStack *ds, getMethodArgs *gma);
short AGWindowDraw(KozoDispatchStack *ds, viewDrawArgs *args);
short AGWindowDoKey(KozoDispatchStack *ds, viewDoKeyArgs *args);
short AGWindowDoClick (KozoDispatchStack *ds, viewDoClickArgs *args);
short AGWindowFindObject(KozoDispatchStack *ds, viewFindObjectArgs *args);

short magnifyButtonProc(AGWindow *ag);
short unmagnifyButtonProc(AGWindow *ag);
short closerButtonProc(AGWindow *ag);
short furtherButtonProc(AGWindow *ag);
short largerButtonProc(AGWindow *ag);
short smallerButtonProc(AGWindow *ag);
short rollCellButtonProc(AGWindow *ag);
short selectFingerButtonProc(AGWindow *ag);

void AGDefaultView(viewInfo *dView);
void	AGWindowHandleRollChoice	(AGWindow *ag, short item);
void	AGWindowHandlePushChoice	(AGWindow *ag, short item);
void 	AGWindowKeypadRotate (AGWindow *ag, char myKeyCode, short timesFive);
void 	AGWindowArrowMove (AGWindow *ag, char myKeyCode, short timesFive, short selectedOnly);


void SetAllMouseModeButtons(AGWindow *gw);
short	AGWinDoDialog	(AGWindow *gw);

short AGSetColourMethodMenuChoice(AGWindow *gw, short menuIndex);
void AGSetMouseMode(AGWindow *gw, DescType whichMode);
//void AGSetCenter(AGWindow *gw, short hVal, short vVal);
void  AGSetViewMatrix(AGWindow *gw, kSanMatrix *trix);

 short AGWinInstallModule (AGWindow *gw, DescType whichModule, kozoObject *newPlugIn);
short AGSetColorModule(AGWindow *gw, const AEDesc *dataDesc);
short AGSetColourPlugIn(AGWindow *gw, DescType colourClass);
short AGSetSizeMethod (AGWindow *gw, long enumeratedID);
short AGSetShadeMethod (AGWindow *gw, long enumeratedID);
short AGSetGraphicsMethod (AGWindow *gw, long descriptorType, long enumeratedID);
viewInfo *gwGetViewPtr (kozoObject *gwObj);
short AGSetView (AGWindow*gw, viewInfo *theView);
short AGSetModule(AGWindow *gw, DescType theProp, AEDesc *dataDesc);
void AGSetBondsVisible	(AGWindow *gw, short viz);
void AGWindowSetShowBondsMenuItem (AGWindow *gw);
void AGWindowSetMouseMode(AGWindow *gw);
short AGWindowSetBounds(AGWindow *gw, AEDesc *data);
void AGWindowGetAngles(AGWindow *ag,char myKeyCode,float * latAngle,float * longAngle,float * spinAngle);
short AGWindowReinitializeGrafDataList( AGWindow *ag);

grafData *  AGWindowLockGrafDataC(AGWindow * ag, long *numItems) ;
grafData *  AGWindowLockGrafData(AGWindow * ag) ;
#define AGWindowReleaseGrafData(ag) VSListRelease(&ag->grafDataList)
 
// short AGWindowGrafDataResize  (kozoObject *agObj,AGWindow *ag, long numParts) ;
short AGWindowInitializeWindowOrderList(AGWindow *ag );
 
void setForeColourNoShade(AGWindow *ag, grafData *thisPart);

#ifndef __2DVectors__ 
void setForeColourWithShade(AGWindow *ag, grafData *thisGrafPtr);
#endif

float setNoActualSize(AGWindow *ag, kSanAtomtype **atArray,viewInfo *theView,  particle *basePart, long partArrIndex);
float setMyActualSizeByAtomType (AGWindow *ag, kSanAtomtype **atArray, viewInfo *theView,  particle *basePart, long partArrIndex);
float setMyActualSizeByWindow(AGWindow *ag, kSanAtomtype **atArray,viewInfo *theView,  particle *basePart, long partArrIndex);
float setNoSize( AGWindow *ag, kSanAtomtype **atArray,viewInfo *theView,  particle *basePart, long partArrIndex);
float setMySizeByAtomType(AGWindow *ag, kSanAtomtype **atArray,viewInfo *theView, particle *basePart, long partArrIndex);
float setMySizeByWindow(AGWindow *ag, kSanAtomtype **atArray,viewInfo *theView,  particle *basePart, long partArrIndex);

short AGWindowAddParticleList (AGWindow *ag, OHList *newPartList)	;
short AGWindowAddToPartList(AGWindow *ag, long partToAdd);
short AGWindowAddAllParticles( AGWindow *ag );
void AGWindowChangeParticleIndex(AGWindow * ag, long oldIndex, long newIndex);
void AGWindowRemoveParticleList(AGWindow *ag, OHList * list);
short AGWindowRemoveParticle(AGWindow *ag, long whichPart);

 short agCheckOrderList(AGWindow *ag);
short agCheckPartList(AGWindow *ag);
short agCheckGrafDataList(AGWindow *ag);
long AGWindowNumParts (AGWindow *ag)  ;

#endif