#ifndef __kSanAGWindowPublic__
#define __kSanAGWindowPublic__

#include <fp.h>

#include "OHBufferedView.h"
#include "kSanObject.h"
#include "kSanSimulationPublic.h"
#include "kSanApplicationPublic.h"
#include "kSanAGWindowRegistry.h"

#define kSetMouseModeButtonsMessage 'MMBM'

#define 	kNoSize 0
#define 	kSizeByAtomType 1
#define 	kSizeByWindow 2
#define 	 kNoShade 0
#define 	 kShadeByDepth 1




#define kInitializeWindowOrderListMessage 'iwoL'
#define kChangeParticleIndexMessage 'chpi'
#define kAddParticleListMessage '+ptl'
#define kRemoveParticleListMessage '-ptl'
#define kRemoveParticleMessage '-atm'
#define kAddParticleMessage '+atm'	 


#define kMaxWindowHeight 100
#define kMaxWindowWidth 100
#define kMagnifyButton 5	
#define kUnmagnifyButton 6	
#define kCloserButton 7	
#define kFurtherButton 8	
#define kLargeBallButton 9	
#define kSmallBallButton 10	
#define kRollCellButton 11	
#define kSelectFingerButton 12	

#define kMagnifyPictResID 200
#define kUnmagnifyPictResID 202
#define kQuestionMarkPictResID 186
#define kCloserPictResID 196
#define kFurtherPictResID 198
#define kLargeBallPictResID 192
#define kSmallBallPictResID 194
#define kRollCellPictResID 188
#define kSelectFingerPictResID 190

#define kNoColour 'null'
#define kDefaultColour 'kSan'

#define kLinePairBlackColour 0
#define kLinePairRedColour 1
#define kLinePairGreenColour 2
#define kLinePairBlueColour 3

typedef struct viewInfoType
{
	float magnification, perspective, particleSizeFactor;
	kSanMatrix viewMatrix;
	Point lastOffsetUsed;  
	long shadeMethod, sizeMethod; // id of the plug-in which owns these functions
 	float neutralShadeDepth, shadeRange;
	char showBonds;
	char unuzed;
	short unused;
	float maxBondLength;
}
viewInfo;
typedef struct grafBondPointsType 
{
	Point start ; 
	Point end ;
}
grafBondPoints;

typedef struct grafBondsType 
{
	short numberOfBackbonds; // draw these before drawing particle
	short unused;
	VSList bondList;
}
grafBonds;

typedef struct grafDataType 
 {
 	long index;
 	short grapha ;
 	short  graphb ;
#ifndef __2DVectors__ 
 	short  graphc;
#else
 	short  graphcUnused;
#endif
	char inWindow;
	char selected;
 	Rect circle;
	RGBColor colour;
	grafBonds *bonds; // if this is nil, then don't show bonds
}
 grafData;
	


typedef struct cellManipType 
 {
	float latRotateAngle;
	float longRotateAngle;
	float axialRotateAngle;
	float horizShift;
	float vertShift;
	float hikiShift;
 }
 cellManip;		
 
typedef struct LinePairType
{
	short start, end, colour;
}
LinePair;

typedef struct frameEdgeDataType
{
	Point edgePoints[6];
}
frameEdgeData;

typedef struct cubeFrameDataType
{
	frameEdgeData edge[NUMCUBEEDGES];
	short cornerZValues[NUMCUBEVERTICES];
	short edgeOrder[NUMCUBEEDGES];
	short edgeValues[NUMCUBEEDGES];
	Point cornerPoints[NUMCUBEVERTICES];
}
cubeFrameData;


//extern  cubeFrameData gCubeFrame;
//extern  UniversalProcPtr defaultSetAllColoursUPP;
extern  LinePair gCubeEdges[NUMCUBEEDGES];
extern  kSanVector gCubeVerticies[NUMCUBEVERTICES];



#endif
