
#ifndef __kSanApplication__
#define __kSanApplication__


#include "OHApplication.h"
#include "kSanObject.h"
#include "kSanApplicationPublic.h"
#include "kSanCursor.h"
#include "kSanPlugIn.h"
#include "kSanSimulation.h"
#include "kSanDialog.h"
//#include "kSanAE.h"
#include "randomGenerator.h"
 
typedef struct kSanApplicationType
{
 	Handle paddingHandle; 
	Handle emergencyHandle; 
	
	OHList colours;
	OHList patterns;
	long plugMenuRefCount;
	AEDesc kSanAETE;
}
kSanApplication;     
 #define kSanAppData(obj) ((kSanApplication *)kozoObjectGetPrivateData(obj, ClasskSanApplication))

short kSanAppConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma);
short kSanAppDestructor (KozoDispatchStack *ds, destructorMethodArgs* dma);
short kSanAppGetData (KozoDispatchStack *ds, getMethodArgs *gma);
short kSanAppSetData (KozoDispatchStack *ds, setMethodArgs *sma);
short kSanAppDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma);
void yieldToSimulationThreads(void);
kSanSimulation **lockSimulations( void) ;
void releaseSimulations(void) ;
RGBColor **lockColours(void) ; 
void releaseColours(void) ;
Pattern **lockPatterns(void) ;
void releasePatterns( void) ;

void AppMainEventLoop (void);
void	handleMenuChoice	(long menuChoice);

void handleMouseDown(EventRecord *eventPtr);
void doMainLoopEvent(EventRecord *eventPtr);
kSanSimulation *	createSimulation (void);
 
// kSanAppMain

//void InitToolbox(void);
//pascal void *userInterfaceThread(void *);
void kSanYieldToThread(ThreadID thisThread);
//long appProgressFunction(void);
//void appHandleKeyDown(EventRecord *eventPtr, OHWindow *myWindow);
//void handleOSEvent(EventRecord *EventPtr);
int doGroupAppleEvent(void);
//short TrapExists(short theTrap);
//TrapType GetTrapType(short theTrap);
//void IncreaseStackSize(Size extraBytes);
//short NumToolboxTraps(void);
//short isThereSpaceOnDisk(short rootRefNum);


short	doNewDialog	(short * xPtr, short * yPtr, short * zPtr,
			short * structureTypePtr, double * lcPtr);

//void findRezOffset(void);
//short checkMemory (void);
//short removeAllSimulations (void);
//short removeSimulation (kSanSimulation *theSim);


// app menus
void 	kSanMenuBarInit	(void);

void	handleAppleChoice	(short item);
short	doCloseMenuChoice	(void);
void	doOpenMenuChoice	(void);
void	doNewMenuChoice	(void);
void	handleFileChoice	(short item);
void	handleParticleChoice	(short item);
void	handleSimulationChoice	(short item);
void	AGWinHandleMenuChoice	(short item);
void	handleRollChoice	(short item);
void	handlePushChoice	(short item);
short enableMenuItem(short whichMenu, short whichItem, short enable);
short kSanMenuInstall (void);

//void 	DisableItems(void);
//void 	EnableItems(void);

void setPopupText(short whichType, MenuHandle theMenu);
MenuHandle  makeMenuOfPlugInList(OHList *pList);
MenuHandle  buildPopupMenu(short withNewType);

// app plugIns
//void unloadPlugIn(long plugID);
//kSanPlugIn *addPlugIn(long type);
//void importPlugIn(FSSpec *thisSpec);
//short functionCaller(long whichFunction, Ptr *functionData);

// app inits
void disposePatterns(kSanApplication *kSanApp);
void disposeColours(kSanApplication *kSanApp);
void initPatterns(kSanApplication *kSanApp);
void initColours(kSanApplication *kSanApp);
void staticInits(void);
void initAppFlags(void);

// atom types

short makeAtomtypeObjSpecifier(long whichType, AEDesc *partDesc);
short makeAtomtypePropertyObjSpecifier(long whichType, AEDesc *partDesc, long propID);
short atomicNumberOfAtomicSymbol(char *p);
void removeLeadingSpaces(char *p, long maxCopy);
float periodicTableValue(short aNum, long whatValue);

// alerts
void doThreadedAlert(long stringResID);
void doAlert(Str255 myString);
void doFatal(Str255 myString);
void doMemAlert(Str255 errString);



// handles
typespecs *lockAtomTypes(void) ;
void releaseAtomTypes(void) ;

long	countReturns	(Handle theHandle);
void	doCopy	(void);
short doAShortDialog	(kozoObject *obj, short rezID, long ptr);


#endif
