#ifndef __kSanAtomtype__
#define __kSanAtomtype__
#include "kSanAtomtypeRegistry.h"

#include "kozoObject.h"

typedef struct typespecsType
{
	double mass;
	double inverseMass;
	double drawingRadius;
	double radius;
	char symbol[6];
	short atNumber;
	RGBColor colour;
}
typespecs;

typedef struct kSanAtomtypeType
{
	typespecs specs;
	kozoObject *atObj;
}
kSanAtomtype;
#define atomtypeData(obj) ((kSanAtomtype *)kozoObjectGetPrivateData(obj, ClassAtomType))

short AtomtypeConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma);
short AtomtypeDestructor (KozoDispatchStack *ds, destructorMethodArgs *cma);
short AtomtypeGetData (KozoDispatchStack *ds, getMethodArgs *gma);
short AtomtypeSetData (KozoDispatchStack *ds, setMethodArgs *sma);
short AtomtypeInit (kozoObject *obj, kozoObject *container, AEDesc *props);
 
char atomtypeGetRefFromTypespecsCallback(kozoObject *nthAtObj, typespecs * types);
char atomtypeGetRefFromNameCallback(kozoObject *nthAtObj, char * theName);
kozoObject * findAtomtypeInListFromMassAndAN(OHList *atList, double theMass, short atNum);
kozoObject * atomtypeGetRefFromName(char * theName);
kozoObject *atomtypeGetRefFromMassAndAN(double theMass, short atNum);
kozoObject * atomtypeGetRefFromTypespecs(typespecs * types);

kozoObject *makeNewAtomtype (kozoObject *container, double theMass, short atNum, char * name);
short notUniqueAtomtypeName(kozoObject *obj, kSanAtomtype *at);

void defaultTypespecs (kSanAtomtype *at);

short atomicNumberOfAtomicSymbol(char *p);
void removeLeadingSpaces(char *p, long maxCopy);
short periodicTableString(short aNum, long whatValue, char * tableString);
float periodicTableValue(short aNum, long whatValue);
void setSpecs(kozoObject *obj, kSanAtomtype *at, typespecs *theSpecs);
void getSpecs(kozoObject *obj, kSanAtomtype *at, typespecs * theSpecs);


#endif