#ifndef __kSanCell__
#define __kSanCell__



#include "kSanCellRegistry.h"
#include "kSanVector.h"

typedef struct simCellDataType 
{
 	kSanVector cellEdges;
 	kSanVector areas; // stores the areas purpendicular to 
 			// orthogonal x y z axes
 	kSanVector reciprocalCellEdges;
 	kSanMatrix primitiveVectors; // real space vectors which define the unit cell
 	kSanMatrix reciprocalVectors; // -- the inverse of these values are
 	  // vectors which point to points in the cell sides, and which are
 	  // normal to the cell sides.
 	kSanVector cellDim;
 	kSanVector invCellDim;

 	double alpha, beta, gamma;  // can be a  
 	double volume, reciprocalVolume;
 	kSanVector appliedShearStress ;
 	kSanVector appliedStrainStress ;
}
kSanCell;

void calcDimensions (kSanCell * thisCell);
double getMinimumDimension (kSanCell * thisCell);
void getAreas (kSanCell *thisCell, kSanVector * theAreas);
void calcAreas (kSanCell * thisCell);
void calcCellPropertiesFromEdgesAndAngles (kSanCell * thisCell);
void setAlpha(kSanCell * thisCell,double a);
void setBeta(kSanCell * thisCell,double a);
void setGamma(kSanCell * thisCell,double a);
void calcFromPrimitives (kSanCell * thisCell);
short isOrthorhombic(kSanCell * thisCell);
void mVector (kSanCell * thisCell,kSanVector * scaleVec);
void XYZtoUVW (kSanCell * thisCell,kSanVector * tricPos, kSanVector * uvwPos);
void UVWtoXYZ (kSanCell * thisCell,kSanVector * tricPos, kSanVector * uvwPos);
//short positionIsInsideCell(kSanCell * thisCell,kSanVector * thePos);
void recoverRealPosition(kSanCell * thisCell,kSanVector * tricPos, kSanVector * adjPos);
void getAdjustedPosition(kSanCell * thisCell,kSanVector * tricPos, kSanVector * adjPos);
short getAdjustedPositionWithWrap(kSanCell *thisCell,kSanVector * tricPos, kSanVector * adjPos);

short vectorIsInsideCell(kSanCell * thisCell,kSanVector * vec); // returns whether point is inside or not

#endif