//kSanGroup.h
#ifndef __kSanParticleGroup__
#define __kSanParticleGroup__
#include <fp.h>
#include "kSanObject.h"
#include "vecMath.h"
typedef struct kSanGroupType
{
	OHList particles;
	short gpIndex;
	short XYZConstraints[3];
	char doCooling;
	char applyAForce;
	RGBColor colour;
	double eqTemp;
	double actualTemp;
	double coolingTimeConstant;
	kSanVector forceApplied;
	double recentTempDeviation;   // use this for "smart cooling estimation"
	       //  this is the recent averaged difference between the actual temperature and the eqTemperature
	double recentTempDeviationCollTime;   // use this for initializing "smart cooling estimation" 
	//      (when starting the collection, make the feedback stronger so it initializes faster)
}
kSanGroup;

#define gpData(obj) ((kSanGroup *)kozoObjectGetPrivateData(obj, ClassParticleGroup))

typedef struct kSanGroupInfoType
{
 	short gpIndex;
	short XYZConstraints[3];
	char doCooling;
	char applyAForce;
	RGBColor colour;
	double eqTemp;
	double actualTemp;
	double coolingTimeConstant;
	kSanVector forceApplied; // 64 bytes
}
kSanGroupInfo;

#include "kSanParticle.h"
#include "kSanApplicationPublic.h"
#include "kSanGroupRegistry.h"

#define kNoGroup 0xFF
#define kGroupIsFixed 0
#define kGroupMovesAsABlock 1
#define kGroupMovesFreely 2


 short kSanGroupRemoveIfEmpty(kozoObject *gpObj) ;

 void getTempWindowWidth(kSanGroup *gp,  double *width);
void setEqTemp(kSanGroup *gp,  double whatTemp);
void	setConstraints(kSanGroup *gp, long whichC, short theC);
  void defaultGroupInfo(kozoObject *gpObj , kSanGroup *grp) ;
 
 void addExternalForces(kSanGroup *gp, particle * basePart, kSanVector * areas);
void setAppliedForce(kSanGroup *gp, kSanVector * theForce);



#endif