#ifndef __kSanParticle__
#define __kSanParticle__


#include "kSanVector.h"
 


#include "kSanParticleRegistry.h"
#include "VSList.h"
 
 #define kNotHighlighted -1
#define kNotSelected 0
#define kSelected 1
#define kSanShortList
//#define NNIRemembersVec  // comment out to remove vec from NNInfo field
#define NNIRemembersSep  // comment out to remove sep from NNInfo field
#define NNIRemembersScreening  // comment out to remove screening from NNInfo field


 typedef struct NNInfoType
{
	//long condensedInfo;
	//long unused; // force 8 byte boundary
	long thisIndex;
	short thisType;
	char  translationFlags;
	char unused;
#ifdef  NNIRemembersSep
	double separation;
#endif
#ifdef  NNIRemembersScreening
	double screening;
#endif
#ifdef  NNIRemembersVec
	kSanVector vec;
#endif
 }
 NNeighborInfo; 
 

typedef struct kSanParticleType
{
// 	long  label; // this indicates a particle's position in the array (i.e. redundant info)
	long  uniqueID; // this is unique to the particle -- see notes below.
	long  boxIndex;
	
	unsigned char group;
	char type;
	char highlighted;
 	char selected;
 	
 	char clipboardFlag;
	char unusedChar;
// 	short unusedShort;
// 	long unusedLong;
 	
// old kSanNeighbors struct
	char neighborScreeningDirty;
	char neighborInfoDirty;
	short extraNumNeighbors;  // used for remembering sizes of the array on reconfiguring memory
	                                             // and for remembering how much extra space is needed
	short actualNumNeighbors;
//	short unused;
	long neighborSpaceAvailable;
	NNeighborInfo *firstNeighborInfo ;
// end old kSanNeighbors struct

 	
}
kSanParticle;

typedef struct particleType
{
         kSanParticle   * basePi;
   	double * basePotential;    
  	kSanVector *basePosition;
 	kSanVector *baseVelocity; 
 	kSanVector *baseForce; 
 }
 particle;   // this structure created to replace the struct returned from simGetParts

// 	double potential;   // these quantities now in their own handles
// 	doubleVector position;
 //	doubleVector velocity; 
 //	doubleVector force; 
 
#define BPNthUniqueID(basePart,arrayIndex)  (basePart->basePi[arrayIndex].uniqueID)
#define BPNthBoxIndex(basePart,arrayIndex)  (basePart->basePi[arrayIndex].boxIndex)
#define BPNthType(basePart,arrayIndex)  (basePart->basePi[arrayIndex].type)
#define BPNthGroup(basePart,arrayIndex)  (basePart->basePi[arrayIndex].group)
#define BPNthHighlighted(basePart,arrayIndex)  (basePart->basePi[arrayIndex].highlighted)
#define BPNthSelected(basePart,arrayIndex)  (basePart->basePi[arrayIndex].selected)
 
short getPartType(particle * part);
double getPartKE(particle * part); // in eV
double kineticEInEV(kSanVector * velocity, double mass);


long numNNs(particle *basePart, long partArrIndex);
 
// note: there are different types of monte carlo swaps which can occur given 
// all the different labelling schemes. i.e. you can swap the positions
// of two particles and nothing else. You could swap the positions and unique ID's.
// you could swap the types and nothing else. You could swap the types and 
// unique IDs


#endif