
#ifndef __kSanPlugIn__
#define __kSanPlugIn__

#include "kSanObject.h"
 
 #include "kSanSimulation.h"
#include "kSanApplicationPublic.h"
#include "kSanPlugInRegistry.h"

//#define kPotentialPlugIn 1
//#define kScreeningPlugIn 2
//#define kMethodPlugIn 3
//#define kColourPlugIn 4
//#define kFilePlugIn 5
//#define kGenericPlugIn 6
//#define kCellSizerPlugIn 7

#define kPlugInNameRezID 128
#define kPlugInMenuTitleRezID 200
#define kDefaultAlertID 400 // kSan has this resource

typedef struct kSanSelectedSiteCopyDataType
{
	AEDesc desc;
	long message;
	long partArrIndex;
}
kSanSelectedSiteCopyData;

#define typeSelectedSiteCopyData 'sscd'
#define selectedSiteMessageGetTitles 'titl'
#define selectedSiteMessageCopySite 'sccs'
#define kSanSelectedSiteCopyMessage 'sCpy' // if the plugIn supports selected copies
#define kSanLoadDataMessage 'load'
#define kSanSaveDataMessage 'save'
#define kSanPotentialPlugInDataRezType 'pDat'
 #define kSanMethodPlugInDataRezType 'mDat'
 #define kSanCellResizePlugInDataRezType 'zDat'
 #define kSanColourPlugInDataRezType 'cDat'
 #define kSanFilePlugInDataRezType 'fDat'
 #define kSanDataCollectionPlugInDataRezType 'dSig'
 
#define kChangedAtomTypes 1
#define kChangedCutoffs 2
#define kChangedNeighbors 4
#define kChangedNumParts 8
#define kChangedGroups 32
#define kChangedPartPositions 64
#define kChangedCellSize 16

#define kSanErrAbortRequested -100
#define kSanErrPropertyNotFound -200
#define kSanErrUnknownObject -201
#define kSanErrCouldNotInitialize -300
#define kSanErrRadiusNotGreaterThanZero -301
#define kSanErrNoMemoryAvailable - 302
#define kSanErrResourceError - 303
#define kSanErrOnePartECalcNotAvailable -400
#define functionDisposeGWorld '^DGW'
#define functionSizeWindow  '^SzW'
#define functionNewGWorld  '^NGW'

#define kSanCleanupMessage 'soji'
#define kSanDoDialogMessage kDoDialogMessage
#define kSanDoAboutBoxMessage kDoAboutBoxMessage
#define kSanChangedInfoMessage 'chng'

//#define typeChangedDataStructPtr 'CDSP'
#define kSanChangedForceMessage 'ChFr'
#define kSanChangedPositionMessage 'ChPs'
#define kSanChangedVelocityMessage 'ChVl'
//#define kSanAccessObjectMessage 'AxSO'
#define kSanAllParts -1L

typedef struct whatWasChangedStructType 
 {
 	kSanSimulation *sim;
	short neighbors;
	short atomTypes;
	short cutoffs;
	short numParts;
 	short cellSize;
 	short groups;
 	short other;
 	short another;
 } 
 whatWasChangedStruct; 
 #define typeWhatWasChangedStruct 'Wwcs'

typedef struct kSanActivePlugInDataType 
{
	kSanPlugIn *gpi;
	Handle dataHandle;
	long counter;
	long threshhold;
}
kSanActivePlugInData; // this struct is held by each sim

extern kSanPlugFile *currentPlugFile;
extern OHList plugFileList;

short kSanPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma);
void lookupPlugInFile(kSanPlugIn *pi);
short kSanPlugInDestructor (KozoDispatchStack *ds, destructorMethodArgs* dma);
short kSanPlugInGetData (KozoDispatchStack *ds, getMethodArgs *gma);
short kSanPlugInSetData (KozoDispatchStack *ds, setMethodArgs *sma);

short kSanPlugInDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma);
 short kSanResolveModule (DescType theProp, const AEDesc *dataDesc, DescType *classID);

short kSanPlugFileAllocator(FSSpec *fs);
void kSanPlugFileDeallocator(kSanPlugFile *pf);

void insertPlugInMenu(void);

void deletePlugInMenus(void);
void makePlugInMenus(void);

// void doCommandPeriod(kSanPlugIn *thisPlug);

void makeWhatWasChangedStruct (kSanSimulation *sim, short whichChange, whatWasChangedStruct *weChanged);
void informPluginOfChange(kSanPlugIn *thisPlug,whatWasChangedStruct *weChanged);
short IDIsWhichPlugInMenuItem(DescType whichModule , DescType thePlugID);
short whichPlugInMenuItem(DescType whichModule , kozoObject *plugObj);

// function prototype for all plug in files!!
short kSanPlugInInit (kSanPlugFile *pf);

short   searchFilesForPlugIns(void);
void  disposeFoundPlugIns(void);


#endif