#ifndef __kSanSimDataWindow__
#define __kSanSimDataWindow__
#define kLineHeight 12

#include "OHBufferedView.h"
#include "OHWindow.h"
#include "kSanObject.h"
//#include "kSanSimStructs.h"
#include "kSanSimulation.h"
#include "kSanApplicationPublic.h"

typedef struct kSanSimDataWindowType
{
	short totalLines;
	short showErrors;
	short showSimInfo;
	short showCellInfo;
	short showTemperatureInfo;
	short showMethodInfo;
	short showSeps;
	short showAngles;
	long lastUpdate;
	kSanSimulation *sim;
}
kSanSimDataWindow;

short SimDataWindowConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma);
short SimDataWindowDestructor(kozoObject *obj );

short SimDataWindowGetData (KozoDispatchStack *ds, getMethodArgs *gma);
short SimDataWindowSetData (KozoDispatchStack *ds, setMethodArgs *sma);
short SimDataWindowDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma);
 	// sim data win
void writeXOfAAndBIs(short hVal, short *vVal, Point offset, Str255 firstString, long a, long b, particle *part, double theValue);
void writeXOfABCIs(short hVal, short *vVal, Point offset, Str255 firstString, long a, long b, long c, particle *part, double theValue);
void DrawStringsAt(short hVal, short vVal, Point offset, Str255 firstString, Str255 secondString);
void DrawLongAt(short hVal, short *vVal, Point offset, Str255 firstString, long theLong, Str255 secondString);
void DrawDoubleAt(short hVal, short *vVal, Point offset, Str255 firstString, double theDouble, Str255 secondString);
void SimDataWindowSetCenter(kSanSimDataWindow *sdp); // sets the offset of v and h relative
void SimDataWindowSetSize(kSanSimDataWindow *sdp, short newHeight, short newWidth);
 void SimDataWindowDrawDebugString(kozoObject *obj, char *c);

#endif