#ifndef __kSanSimPublic__
#define __kSanSimPublic__
#include "sharedTypedefs.h"
//#include "kSanSimStructs.h"
#include "kSanGroup.h"
#include "kSanPlugIn.h"
#include "kSanAtomtype.h"
// k is 1.38 E-23 J/K or  
// 8.625 E-5  eV/K  or  using  9636.8 ( (g/mol) A / ps ps ) per (eV /A)
// 0.831174 (g/mol) A A / ps ps K
// so 2over3K is 0.82078
#define  kBoltzK 0.831174
#define kVirialFunction 'virl'
typedef struct cellConstraintsType
{
	short XAxis;
	short YAxis;
	short ZAxis;
	short Alpha;
	short Beta;
	short Gamma;
}
cellConstraints, *cellConstraintsPtr;



void  randomizePart (OHObject *sim, long thisPart, float thisTemp);
void	 simDoTimeSwitch	(OHObject *sim);

// get 
short simGetName (OHObject*sim, char *p);

long simGetNumGroups(OHObject *simObj); 
float  simGetGroupEqTemp(OHObject *sim, long whichGroup) ;
long simGetNumParts(OHObject *simObj) ; 
long simGetNumIters(OHObject *simObj) ; 
long simGetNumHighlights(OHObject *simObj) ; 
long simGetNumSelections(OHObject *simObj) ; 
long simGetNumAtomtypes(OHObject  *simObj);

NNInfoStructOffsets *simGetNNDataOffsetsPtr(OHObject *simObj) ; 
short simGetMaxNeighbors(OHObject *sim);
short simGetDoEConsevation(OHObject *sim) ;

simScreeningInfo *simGetScreeningInfo (OHObject *sim);
simPotentialInfo *simGetPotentialInfo (OHObject *sim);
simMethodInfo *simGetMethodInfo (OHObject *sim);
long simGetPotentialBeingUsed(OHObject *sim);
long simGetScreeningBeingUsed(OHObject *sim);
long simGetMethodBeingUsed(OHObject *sim);

short simCallOnePartVirialCalc(OHObject *simObj, long partIndex, doubleVector *vec);
double simGetNeighborCutoffExtra(OHObject *sim);
//double getDeltaT(OHObject *sim);
double simGetTimeElapsed(OHObject *simObj) ; 
double simGetKineticEnergy(OHObject *sim);
double simGetTotalEnergy(OHObject *simObj) ; 
double simGetPotentialEnergy(OHObject *simObj) ; 
double simGetTemperature(OHObject *sim);
double  simGetOuterCutoff(OHObject *sim);
double  simGetInnerCutoff(OHObject *sim);
double simGetDeltaT(OHObject *simObj);
float simGetPartKE(OHObject *simObj, particle * part);
short  simGetClockRunning(OHObject *thisSim);
void simGetCellPrimitives(OHObject *simObj, newMatrixD *primitiveVectors);
void  simGetGenericSeparations(OHObject *simObj, long partA, long partB, float *theSeps);
double simGetNoseDensity(OHObject  *simObj);
double simGetNoseTimeConst(OHObject  *simObj);

// set
void simSetPlugNotificationSuspended (OHObject *sim, short suspend);
short simSetName (OHObject *sim, char *p);

short   simSetParticleType   (OHObject *sim, long whichPart, Handle typeName);

void  simSetClockRunning(OHObject *thisSim,short going, long iteration);
void  simSetCutoffParams(OHObject *thisSim,double inner, double outer);
void  simSetNeighborCutoffExtra(OHObject *simObj, double extra);
void simSetDeltaT(OHObject *simObj, double *delT);

short  simSetMethod(OHObject *sim,kSanMethodPlugIn *mpi);
short  simSetScreening(OHObject *sim, kSanScreeningPlugIn *spi);
short   simSetPotential(OHObject *sim, kSanPotentialPlugIn *ppi);
void simSetNoseDensity(OHObject  *simObj, double *dens);
void simSetNoseTimeConst(OHObject  *simObj, double *tc);


// locks
kSanGroup ** simLockGroups(OHObject *simObj); 
void simReleaseGroups(OHObject *simObj); 
long * simLockHighlights(OHObject *simObj) ; 
void simReleaseHighlights(OHObject *simObj) ;
long * simLockSelections(OHObject *simObj) ; 
void simReleaseSelections(OHObject *simObj) ;
Ptr simLockNNData(OHObject *simObj) ; 
void simReleaseNNData(OHObject *simObj) ;
particle *simLockParts(OHObject *simObj) ; 
void simReleaseParts(OHObject *simObj) ;
lksPtr simLockLinkArray(OHObject *simObj) ; 
void simReleaseLinkArray(OHObject *simObj) ;
kSanGroup **simLockGroups(OHObject *thisSim) ;
void simReleaseGroups(OHObject *thisSim) ;
long * simLockBoxList(OHObject *simObj)  ;
void  simReleaseBoxList(OHObject *simObj) ;
Ptr  simLockBoxes(OHObject *simObj) ;
void  simReleaseBoxes(OHObject *simObj) ;
kSanAtomtype ** simLockAtomTypes(OHObject *simObj) ;
void  simReleaseAtomTypes(OHObject *simObj) ;

short calculateEnergiesAndReturn(OHObject * simObj, double *energy);
short calculateEnergies(OHObject * simObj);
short	 simCalculateForce (OHObject *simObj);
short calcOneParticleEnergy(OHObject *thisSim,long thePart, short redoScreeningCalc);
short calcOneParticleForce(OHObject *thisSim,long thePart);

long howManyNeighborsDoesItHave(OHObject *thisSim , long whichPart);
short   simGetAllSepsAndScreenings(OHObject *simObj, particle * thisPart, particle * nPart, 
					doubleVecPtr mSepVecArray, double * mRadArray, double * mScreenArray);

void getPrimitiveVectors(OHObject *simObj , newMatrixD *trix);
void rotateParticles(OHObject *simObj, newMatrixF *fMat, short selectedOnly);
void  translateParticles  (OHObject *simObj, floatVecPtr tVec, short selectedOnly);

void  eraseSelections(OHObject *simObj);
void  setSimSelectionsMenuItems(OHObject *simObj);

short  getParticleSelected(OHObject *simObj, long partIndex);
void  setParticleSelected(OHObject *simObj, long partIndex, short select);
void addToSelections(OHObject *simObj,long whichParticle);
void  removeFromSelections(OHObject *simObj, long partIndex);
void  makeSelectionsThisType(OHObject *simObj, kSanAtomtype * whichType);
kSanAtomtype *  simGetNthAtomtype(OHObject  *sim,  short index);

void  toggleParticleSelected(OHObject *simObj, long partIndex);
void  toggleListSelected(OHObject *simObj, kSanList *list);
void  setListSelected (OHObject *simObj, kSanList *list, short shouldSelect);
long  getNthSelection(OHObject *simObj, long whichIndex);

short  getParticleHighlighted(OHObject *simObj , long whichParticle);
void setParticleHighlighted(OHObject *simObj , long whichParticle, short select);
void  addToHighlights(OHObject *simObj, long partIndex);
void  removeFromHighlights(OHObject *simObj, long partIndex);


void  setNeedsEnergyUpdate(OHObject *simObj,short needsIt) ;

short calcNeighbors(OHObject *simObj);

void  doParticleDialog  (OHObject *simObj, long partIndex);

short  SimPlugDoEvent (OHObject  *simObj, kSanPlugIn *plug,long message, EventRecord *event,
	 					kSanEventData *ksEvent);
//launchers

short launchSetHighlight(OHObject *simObj,  long partIndex, short highlite);
short launchEraseSelections(OHObject *simObj);  
short launchSetSelected(OHObject *simObj,   long partIndex, short select);


void simSetDebugString(OHObject *sim, char *c);
Handle simGetDebugStringHandle(OHObject *sim);

#endif