#ifndef __kSanSimulation__
#define __kSanSimulation__

#include <Threads.h>
#ifndef __MRC__
#include <profiler.h>
#endif
#include "OHDocument.h"
#include "OHFile.h"
#include "kSanObject.h"
#include "kSanApplicationPublic.h"
#include "kSanSimulationPublic.h"
#include "kSanCursor.h"
#include "kSanCell.h"
/*
#include "kSanPlugIn.h"
#include "kSanMethodPlugIn.h"
#include "kSanPotentialPlugIn.h"
#include "kSanDataCollectionPlugIn.h"
#include "kSanCellResizePlugIn.h"
*/
#define kThreadHasReturned 1
#define kSanLargeModelPBC 1
#define kSanMediumModelPBC 2
#define kSanSmallModelPBC 3
#define kSanTooSmallModelPBC 4
#define kSanNoThread 0

/*
#define kSanTranslationAddXDim 0x01
#define kSanTranslationSubtractXDim 0x02
#define kSanTranslationChangeXDim 0x03
#define kSanTranslationAddYDim 0x04
#define kSanTranslationSubtractYDim 0x08
#define kSanTranslationChangeYDim 0x0C
#define kSanTranslationAddZDim 0x10
#define kSanTranslationSubtractZDim 0x20
#define kSanTranslationChangeZDim 0x30
*/
#define kSanTransAddXDimSign 0x01
#define kSanTransChangeXDim 0x02
#define kSanTransAddYDimSign 0x04
#define kSanTransChangeYDim 0x08
#define kSanTransAddZDimSign 0x10
#define kSanTransChangeZDim 0x20

#define kSanTransMinusX 0x02
#define kSanTransPlusX 0x03
#define kSanTransMinusY 0x08
#define kSanTransPlusY 0x0C
#define kSanTransMinusZ 0x20
#define kSanTransPlusZ 0x30
// use of translation flags:
//  for x,  if the kSanTransChangeXDim flag is set, you have to either add or subtract 
//  XDim to get the true separation 
// if the kSanTransAddXDimSign bit is set, it means add
// if the kSanTransAddXDimSign bit is not set, it means subtract
// if the kSanTransChangeXDim bit is not set, it means don't do an add or subtract
 
#define kSanBaseBoxIsMiddleX 0x00
#define kSanBaseBoxIsMaxX 0x01
#define kSanBaseBoxIsMinX 0x02
#define kSanBaseBoxXMask 0x03
#define kSanMaskNotMiddleXBox 0x03

#define kSanBaseBoxIsMiddleY 0x00
#define kSanBaseBoxIsMaxY 0x04
#define kSanBaseBoxIsMinY 0x08
#define kSanBaseBoxYMask 0x0C
#define kSanMaskNotMiddleYBox 0x0C

#define kSanBaseBoxIsMiddleZ 0x00
#define kSanBaseBoxIsMaxZ 0x10
#define kSanBaseBoxIsMinZ 0x20
#define kSanBaseBoxZMask 0x30
#define kSanMaskNotMiddleZBox 0x30

#define kSanNeighboringBoxXMask  0x03
#define kSanNeighboringBoxAtSameX 0x01
#define kSanNeighboringBoxAtPlusX 0x02
#define kSanNeighboringBoxAtMinusX 0x00

#define kSanNeighboringBoxYMask  0x0C
#define kSanNeighboringBoxAtSameY 0x04
#define kSanNeighboringBoxAtPlusY 0x08
#define kSanNeighboringBoxAtMinusY 0x00

#define kSanNeighboringBoxZMask  0x30
#define kSanNeighboringBoxAtSameZ 0x10
#define kSanNeighboringBoxAtPlusZ 0x20
#define kSanNeighboringBoxAtMinusZ 0x00

#define wrapAroundNeighborMemoryErr -2
#define wrapAroundHyperspaceErr -4
#define kSanErrPartNotInBox -101
#define kSanErrUnallocatedBox -102
#define kSanErrGotAllNeighbors -104
#define kSanErrBoxMemory -106

 
typedef struct kSanPlugFileType
{
	OHFile file;
	OHList residentClasses;
	CFragConnectionID connID;
	UniversalProcPtr loadUPP;
	void (*doAboutPlugIn)(struct kSanPlugFileType* thePlugFile);
	OHString name; //??
}
kSanPlugFile;


typedef struct LCHandleType
{
	Handle handle;  
 	long lockCount;  
 	long handleSize;  
 }
LCHandle;
typedef struct kSanPlugInType
{
	DescType piType; // potential or method or resize or .....
 	OHFile *piFile; // -- the plugInFile which defined the plugIn class
 	void * plugPrivateData; // a pointer to one on the plugin derived types, i.e. (kSanMethodPlugIn *)
 }
kSanPlugIn;
#define plugData(obj) ((kSanPlugIn *)kozoObjectGetPrivateData(obj, ClasskSanPlugIn))

typedef struct kSanMethodPlugInType 
{
 	kozoObject *mpiObj;
  short (*doIteration) (struct kSanMethodPlugInType *mpi, struct kSanSimulationType *sim);
  short (*doCooling) ( struct kSanMethodPlugInType *mpi, struct kSanSimulationType *sim, double *netTime, double *totKinEnergy);
 	void * methodPlugPrivateData; // for use of a class derived from kSanMethodPlugIn i.e. a (MonteCarlo *)
}
kSanMethodPlugIn;
#define mpiData(obj) ((kSanMethodPlugIn *)kozoObjectGetPrivateData(obj, ClassMethodPlugIn))


typedef struct kSanCellResizePlugInType 
{
	kozoObject *rpiObj;
  short (*doCellResize) (struct kSanCellResizePlugInType *crpiPlug, struct kSanSimulationType *sim);
 	void * crPlugPrivateData; // for use of a class derived from kSanCellResizePlugIn
}
kSanCellResizePlugIn;
#define rpiData(obj) ((kSanCellResizePlugIn *)kozoObjectGetPrivateData(obj, ClassCellResizePlugIn))


typedef struct kSanDataCollectionPlugInType 
{
   kozoObject *dcpObj;
   short (*doCollection) (struct kSanDataCollectionPlugInType *dcPlug, struct kSanSimulationType *sim);
   long threshhold;
   long counter;
   void * dcPlugPrivateData; // for use of a class derived from kSanDataCollectionPlugIn
}
kSanDataCollectionPlugIn;
#define dcpData(obj) ((kSanDataCollectionPlugIn *)kozoObjectGetPrivateData(obj, ClassDataCollectionPlugIn))

typedef struct kSanPotentialPlugInType 
{
	kozoObject *ppiObj;
	short (* onePartECalc) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, long whichPart, double *retVal) ;
	short (* onePartFCalc) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, long whichPart) ;
	short (* onePartVirialCalc) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, long whichPart, kSanMatrix *rMat) ;
	short (* manyPartEFCalc) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, long firstPart, long lastPart, double *retVal) ;
    short (* manyPartECalc) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, long firstPart, long lastPart, double *retVal) ;
	short (* manyPartFCalc) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, long firstPart, long lastPart) ;
	short (* fillScreeningArray) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, particle *basePart, long partIndex) ;
	short (* screeningFunction) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, particle *basePart, long partIndex,long whichNeighbor, double *returnScreening) ;
	short (* fillScreeningDifferentialArray) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, particle *basePart,long partIndex, kSanVector * screeningDifferentialArray) ;
	short (* screeningDifferential) (struct kSanPotentialPlugInType *ppi, struct kSanSimulationType *sim, particle *basePart, long partIndex,long whichNeighbor,  kSanVector * theScreeningDifferential) ;
  void * potentialPlugPrivateData; // for use of a class derived from kSanPotentialPlugIn
}
kSanPotentialPlugIn;
#define ppiData(obj) ((kSanPotentialPlugIn *)kozoObjectGetPrivateData(obj, ClassPotentialPlugIn))


typedef struct kSanSimulationType 
{
	kozoObject *simulationObj;
 	unsigned long stateCount; // substitute for dirty variable;
	   // this gets incremented at every change that could affect system state
	unsigned long lastEnergyCalcStateCount; 
	unsigned long lastEnergyCalcTicks; 
	short  weChanged ;
	char  doEConservation;
	char  doVCentering;
	
 	unsigned long howManyParts;
 	unsigned long uniqueParticleCounter;  // this is the value of the unique ID of the most recently created particle
	unsigned long totalNumberOfIterations;
 	double 	neighborCutoffExtra;
	double	deltaT;
 	double 	totalTimeElapsed;
 	double  potEnergy;
	double 	kinEnergy;
	double 	simTemperature;
	double outerCutoff;
	double innerCutoff;
 	double middleCutoff;
	double piOverRange;
	
	ThreadID 	iterationThreadID ;
//	ProfilerThreadRef iterationThreadRef;

	OHNamedList uniqueIDList; // a cross reference of unique ID to index
	OHNamedList particlePropertyOwners;
	OHList waitingThreads;
    short 	suspendNeighborUpdates; // old gBoxInfo->partInBox[0]
    long  howManyBoxes;
    kSanLongVector boxDim; // old Xindex, Yindex, Zindex
 	long lowestYieldFlag;
	OHList   yieldFlags; // this is a list of iteration numbers at which to temporarily stop the clock
	BitList   selectedBits;
	OHList   highlights;
 	
	kSanCell   simCell;
	cellConstraints gConstrained;
	iterLimits  counters;
 	iterLimits  countThreshholds;

	Ptr  neighborsPtr;   // so that particle neighbors are aligned in memory

 	//LCHandle linkArrayLCH;
	LCHandle boxArrayLCH;

	LCHandle  forceLCH;   // the five basic info fields
	LCHandle  positionLCH;
	LCHandle  velocityLCH;
	LCHandle  potentialLCH;
	LCHandle  particlesLCH;
 
 	long particlesRefCount;
 	particle  basePtrs;   // this contains pointers to the five basic info fields:  
 	
	kSanGroup **groupArray; // for the lockGroups  call , this is a temporary list for storing an array of the specialTypes
	kSanAtomtype **atomtypeArray; // for the  lockAtomtypes call , this is a temporary list for storing an array of the specialTypes
	long groupListRefCount;
	long atomtypeListRefCount;

	kSanMethodPlugIn *methodPlugIn;
	kSanPotentialPlugIn *potentialPlugIn;
	kSanCellResizePlugIn *resizePlugIn;
 	simFlags flags;
// function pointers
	void (*getSepVec) (struct kSanSimulationType *sim, particle *basePart, long firstPart, 
			long secondPart,   char translationFlags, kSanVector * sepVec);
	double (*getSepSquared) (struct kSanSimulationType *sim, particle *basePart, long firstPart, 
			long secondPart,   char translationFlags, kSanVector * sepVec);
	short (*setBoxForPart) (struct kSanSimulationType *thisSim,long partIndex);
	short (*wrapAround) (struct kSanSimulationType *thisSim); // and fill in the box info
	long (*determineBoxForPart) (struct kSanSimulationType *thisSim,long partIndex);
	short plugNotificationSuspended;
	long recentAverageNeighborSlots;
	long neighborSpaceFrontSlack; // a buffer that can be used to increase the size of the neighbor space of the zeroeth particle;

} kSanSimulation;

#define typeSimulationPtr 'Sim>'
#define typeSimulationPtrPtr 'Sm>>'

#define simOBJ(sim) (sim->simulationObj)
#define simData(obj) ((kSanSimulation *)kozoObjectGetPrivateData(obj, ClassSimulation))
#define simGetNumParts(sim) (sim->howManyParts) 
#define basePartPtr(sim) ((kSanParticle *)(*sim->particlesLCH.handle))

DescType  simGetPlugInBeingUsed(kozoObject *simObj, DescType whatModule);

#define simGetPotentialBeingUsed(sim) simGetPlugInBeingUsed( simOBJ(sim), ClassPotentialPlugIn)
#define simGetMethodBeingUsed(sim) simGetPlugInBeingUsed( simOBJ(sim), ClassMethodPlugIn)
#define simGetCellResizeBeingUsed(sim) simGetPlugInBeingUsed( simOBJ(sim), ClassCellResizePlugIn)




short simGetNumGroups(kSanSimulation *sim );
short refindGroups(kSanSimulation *sim);

short kSanSimConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma);
short kSanSimDestructor (KozoDispatchStack *ds, destructorMethodArgs* dma);
short kSanSimGetData (KozoDispatchStack *ds, getMethodArgs *gma);
short kSanSimSetData (KozoDispatchStack *ds, setMethodArgs *sma);
short kSanSimDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma);


void	 handleSimError	(kSanSimulation *sim);
void simSetDebugString(kSanSimulation *sim, char *c);


short simSetModuleDesc( kSanSimulation *sim, DescType theProp, const AEDesc *dataDesc);
short simMakeAndInstallModule(kSanSimulation *sim,DescType theProp, DescType classID);
void getPrimitiveVectors(kSanSimulation *sim, kSanMatrix *trix);
short simInstallUniqueModule(kSanSimulation *sim, DescType whichModule, kozoObject *newPlugIn);


double simSumPotentialEnergy(kSanSimulation *sim) ;

short kSanSimCleanUp(kSanSimulation *sim );

short kSanSimRemoveContainedObject(kSanSimulation *sim , kozoObject *itemToClose);
short kSanSimAddContainedObject(kSanSimulation *sim , kozoObject *itemToAdd);

 short resetNeighborInfoForOnePart(kSanSimulation *sim , long partIndex);
short resetNeighborInfoForTwoParts(kSanSimulation *sim , long partA, long partB);
short resetNeighborInfoForNParts(kSanSimulation *sim , OHList *list);

long addParticle(kSanSimulation *sim ,kSanVector * pos, long type, long group, short isSelected);

short simDoIterateEvent(kSanSimulation *sim , AEMessageData *md );
short simDoStrainEvent(kSanSimulation *sim , AEMessageData *md );

//void setCursorState(kSanSimulation *sim);

float kSanParticleGetKE(kSanSimulation *sim, particle *basePart, long partIndex);
unsigned long kSanParticleGetUniqueID(kSanSimulation *sim, long partIndex );
short kSanParticleGetPosition (kSanSimulation *sim, long partIndex, kSanVector * thePos);
short kSanParticleGetPotential(kSanSimulation *sim, long partIndex, double *pot);
short  kSanParticleSetTypeByName  (kSanSimulation *sim, long partIndex, char * typeName);
short  kSanParticleSetTypeByNum  (kSanSimulation *sim, long partIndex, long typeNum);
short  kSanParticleSetTypeByObj  (kSanSimulation *sim, long partIndex, kozoObject *atObj);

void kSanParticleSetPosition(kSanSimulation *sim, long partIndex, kSanVector * thePos);
void kSanParticleSetVelocity(kSanSimulation *sim, long partIndex, kSanVector * theVel);
void kSanParticleSetForce (kSanSimulation *sim, long partIndex, kSanVector * theVel);
void kSanParticleSetUniqueID(kSanSimulation *sim, long partIndex, long theID);
short kSanParticleSwapUniqueIDs(kSanSimulation *sim, long partIndex, long otherPart);
short  callParticleSetDataI0( kSanSimulation *sim, long partIndex, DescType property, AEDesc *data);
short  callParticleGetDataI0( kSanSimulation *sim, long partIndex, DescType property, AEDesc *result, DescType desiredType);


// locks
Ptr LCHandleLock(LCHandle *lch );
void LCHandleRelease(LCHandle *lch );
short LCHandleInit(LCHandle *lch );
void LCHandleDispose(LCHandle *lch );
short LCHSetHandleSize(LCHandle *lch, long size );

//#define simLockLinkArray(sim) ((lksPtr)(LCHandleLock(&sim->linkArrayLCH)))
//#define simReleaseLinkArray(sim) LCHandleRelease(&sim->linkArrayLCH)

#define simLockPositions(sim) ((doubleVector *)(LCHandleLock(&sim->positionsLCH)))
#define simReleasePositions(sim) LCHandleRelease(&sim->positionsLCH)
#define simLockVelocities(sim) ((particle *)(LCHandleLock(&sim->velocitiesLCH)))
#define simReleaseVelocities(sim) LCHandleRelease(&sim->velocitiesLCH)
#define simLockForces(sim) ((particle *)(LCHandleLock(&sim->forcesLCH)))
#define simReleaseForces(sim) LCHandleRelease(&sim->forcesLCH)
#define simLockPotentials(sim) ((particle *)(LCHandleLock(&sim->potentialsLCH)))
#define simReleasePotentials(sim) LCHandleRelease(&sim->potentialsLCH)

#define simLockkSanParts(sim) ((kSanParticle *)(LCHandleLock(&sim->particlesLCH)))
#define simReleasekSanParts(sim) LCHandleRelease(&sim->particlesLCH)

particle * simLockParts(kSanSimulation *sim) ;
void  simReleaseParts(kSanSimulation *sim);

#define simLockBoxes(sim) ((box *)(LCHandleLock(&sim->boxArrayLCH)))
#define simReleaseBoxes(sim) LCHandleRelease(&sim->boxArrayLCH)

#define simLockSelections(sim) ((long *)anyListLock((anyList *)&(sim->selections)))
#define simLockHighlights(sim) ((long *)anyListLock((anyList *)&(sim->highlights)))
#define simReleaseSelections(sim) (anyListRelease((anyList *)&(sim->selections)))
#define simReleaseHighlights(sim) (anyListRelease((anyList *)&(sim->highlights))) 
#define getSelectionsList(sim) (&(sim->selections)) 
#define getHighlightsList(sim) (&(sim->highlights)) 
 
kSanGroup ** simLockGroups(kSanSimulation *sim); 
void simReleaseGroups(kSanSimulation *sim); 
 
kSanGroup **simLockGroups(kSanSimulation *sim) ;
void simReleaseGroups(kSanSimulation *sim) ;

kSanAtomtype ** simLockAtomTypes(kSanSimulation *sim) ;
void simReleaseAtomTypes(kSanSimulation *sim) ;

long simIncrementStateCount(kSanSimulation *sim);
long simGetStateCount(kSanSimulation *sim);
short	kSanSimGetCopyText	(kSanSimulation *sim, AEDesc *result);

short calculateEnergiesAndReturn(kSanSimulation *sim, double *energy);
short calculateEnergies(kSanSimulation *sim);
short calcOneParticleEnergy(kSanSimulation *sim,long thePart);
short calcOneParticleForce(kSanSimulation *sim,long thePart);

short  simNumNeighbors(kSanSimulation *sim, particle *basePart, long partIndex);
 void rotateParticles(kSanSimulation *sim, kSanMatrix *fMat, short selectedOnly);

void translateParticles (kSanSimulation *sim, kSanVector * tVec, short selectedOnly);
void translateListOfParticles(kSanSimulation *sim ,kSanVector * tVec, OHList *aList);
void translateParticle(kSanSimulation *sim, long whichPart, kSanVector * tVec);
void rotateAllParticles(kSanSimulation *sim ,short whichAxis, double angle);

void eraseSelections(kSanSimulation *sim);
void setSimSelectionsMenuItems(kSanSimulation *sim);

char getParticleSelected(kSanSimulation *sim, long partIndex);
short setParticleSelected(kSanSimulation *sim, long partIndex, char select);
short addToSelections(kSanSimulation *sim,long whichParticle);
short removeFromSelections(kSanSimulation *sim, long partIndex);
void makeSelectionsThisType(kSanSimulation *sim, kSanAtomtype * whichType);
kSanAtomtype * simGetNthAtomtype(kSanSimulation *sim, short index);

short toggleParticleSelected(kSanSimulation *sim, long partIndex);
void toggleListSelected(kSanSimulation *sim, OHList *list);
void setListSelected (kSanSimulation *sim, OHList *list, char shouldSelect);
long getNthSelection(kSanSimulation *sim, long whichIndex);

char getParticleHighlighted(kSanSimulation *sim , long whichParticle);
short setParticleHighlighted(kSanSimulation *sim , long whichParticle, char select);
short addToHighlights(kSanSimulation *sim, long partIndex);
short removeFromHighlights(kSanSimulation *sim, long partIndex);
void setListHighlighted (kSanSimulation *sim, OHList *list, char shouldHighlight);


void setNeedsEnergyUpdate(kSanSimulation *sim,short needsIt) ;
short calcNeighbors(kSanSimulation *sim);
short  getAllSepsAndScreenings(kSanSimulation *sim , particle * basePart, long thisPartIndex, long nPartIndex, 
					kSanVector * mSepVecArray, double * mRadArray, double * mScreenArray);
short simRemoveNthNeighbor (kSanSimulation *sim, particle *basePart, long partIndex, long whichNeighbor);
short resetNeighborPtrs(kSanSimulation *sim, long extraRoom);
short calcNeighborsFromScratch(kSanSimulation *sim);

// dialogs
void doParticleDialog (kSanSimulation *sim, long partIndex);
short	doEditParticleDialog	(kSanSimulation *sim, long partIndex);
short	DoGroupInfoDialog	(kSanSimulation *sim, long whichGroup);

short	ShouldWeSaveDialog	(kSanSimulation *sim);
short	DoParametersDialog	(kSanSimulation *sim);
short	DoFrequenciesDialog	(kSanSimulation *sim);
short	DoCutoffParamsDialog	(kSanSimulation *sim);
short	DoCellConstraintsDialog	(kSanSimulation *sim);
short	DoScaleCellDialog	(kSanSimulation *sim);
short	DoCellManipulationDialog	(kozoObject *winObj);

short	DoCellExpansionHuhDialog	(void);
short	DoCellExpansionDialog	(kSanSimulation *sim);
short	DoCellStressDialog	(kSanSimulation *sim);
short	DoCellSizeDialog	(kSanSimulation *sim);
void  simSetGroupValues (kSanSimulation *sim, short whichGroup, kSanGroupInfo *grInfo);
short	simDoAtomInfoDialog (kSanSimulation *sim, long whichType);




void simZeroVelocities (kSanSimulation *sim);
void simRandomizeVelocities (kSanSimulation *sim);
short randomizePart ( long partArrIndex, kSanSimulation *sim, double *thisTemp);
void	simDoTimeSwitch	(kSanSimulation *sim);
void resetGroups(kSanSimulation *sim);
void doGroupSelectedParticles (kSanSimulation *sim);
short  simGroupOfParticle(kSanSimulation *sim, long partNumber);
long	 simParticleIndexFromUniqueID (kSanSimulation *sim, long theID ); // arrayIndex + 1
long	 simParticleLabelFromUniqueID (kSanSimulation *sim, long theID ); // the arrayIndex of the particle
 short  simGetParticlePropertyMinMax (kSanSimulation *sim, DescType property, AEDesc *min, AEDesc *max);

short simGetDoEConsevation(kSanSimulation *sim) ;

kozoObject * simGetModule(kSanSimulation *sim, DescType whichModule);
short simCallOnePartVirialCalc(kSanSimulation *sim, long partIndex, kSanMatrix *vec);
short kSanParticleGetNeighborOverlapFractions(kSanSimulation *sim, long partIndex, OHFloatList *fl);

void simGetCellPrimitives(kSanSimulation *sim, kSanMatrix *primitiveVectors);
void simGetGenericSeparations(kSanSimulation *sim, long partA, long partB, float *theSeps);
void simRaiseYieldFlag(kSanSimulation *sim, unsigned long iterationNumber);
void simRemoveYieldFlag	(kSanSimulation *sim, unsigned long iter);

// set
void simSetPlugNotificationSuspended (kSanSimulation *sim, short suspend);
void simSetPlugNeighborUpdatesSuspended (kSanSimulation *sim, short suspend);
short kSanNeighborsConstructor(kSanSimulation *sim, particle *basePart, long partIndex);
void kSanNeighborsDestructor(kSanSimulation *sim, particle *basePart, long partIndex);

// callbacks
void processParticleIndexList (kSanSimulation *sim, 
			 void (* callback)( kSanSimulation *, particle *, long , void * ) ,
			 OHList *list, void * arg);
void processParticleBitList (kSanSimulation *sim, 
			 void (* callback)( kSanSimulation *, particle *, long , void * ) ,
			 BitList *list, void * arg);
void processParticles (kSanSimulation *sim, void (* callback)(  kSanSimulation *, particle *, long , void * ) , 
		long firstPart, long lastPart, void * arg);
void processEveryParticle (kSanSimulation *sim, void (* proc)( kSanSimulation *, particle *, long , void * ), void * arg);

void kSanParticleSetForceCallback (kSanSimulation *sim, particle *basePart, long partIndex, void *theForce); // 
void kSanParticleSetVelocityCallback (kSanSimulation *sim, particle *basePart, long i, kSanVector * theVel);
void kSanParticleSetPositionCallback (kSanSimulation *sim, particle *basePart, long partIndex, kSanVector * thePos);
 #endif