#ifndef __kSanSimulationPrivate__
#define __kSanSimulationPrivate__

#include <stdio.h>
#include <string.h>

#include "kSanPlugIn.h"
#include "kSanSimulation.h"
#include "kSanVector.h"

void addPopupItem(MenuHandle aMenu);
void setAtomTypePopupText(kSanSimulation *sim , MenuHandle aMenu, long item) ;// this is the user interface type -- start at 1
void 	setStringText(Handle theTextHandle, short theID);


void simSetCursorState(kSanSimulation *sim);
short simMakeModuleObjectSpecifier(kSanSimulation *sim , kSanPlugIn *plug, AEDesc *retDesc);
short	simMakeContainedParticle(kSanSimulation *sim, long newIndex, AEDesc *initialDataDesc, AEDesc *newObjectDesc);

// cell	
void doCellPressure (kSanSimulation *sim ) ;

void reflectCell (kSanSimulation *sim );
short expandCell (kSanSimulation *sim , kSanLongVector * nA, kSanLongVector * nB, kSanLongVector * nC);
void setOrthorhombicTriclinicSwitch(kSanSimulation *sim );
short scaleAxis (kSanSimulation *sim ,long whichAxis, void *ratio);
void scaleAngles (kSanSimulation *sim ,double alpha, double beta, double gamma);

void setNewCellProperties(kSanSimulation *sim);

void handleEditChoice	(kSanSimulation *sim);
// memory
short resizeMemory(kSanSimulation *sim ,long numParts);
//short 	 linkArrayResize  (kSanSimulation *sim ,long newNumber) ;
short nnDataHandleResize(kSanSimulation *sim ,short numberOfNeighbors,long numberOfParts);
short compressNeighborMemory(kSanSimulation *sim);
short reorderParticles(kSanSimulation *sim);

// neighbors
short lookForNeighbors(kSanSimulation *sim );
short findWhichNeighbor(kSanSimulation *sim ,long partIndex, long neighborIndex, OHList *theNNDataIndexList);
short deleteNeighborFromList(kSanSimulation *sim , long partArrIndex, long neighborIndex);
short  getAllSeparations(kSanSimulation *sim , long partArrIndex, long nPartIndex, 
					kSanVector * mSepVecArray, double * mRadSquArray);
short  getOneSepAndScreening(kSanSimulation *sim , particle * basePart, long oneIndex, 
			long twoIndex , double * theSep, kSanVector * theSepVec, double * theScreening);
short 	 wrapAroundAndBitfields (kSanSimulation *sim );
void  deleteHyperspaceParticles(kSanSimulation *sim ) ;
short addPartToBox (kSanSimulation *sim , particle * basePart,long partIndex, long whichBox, box * boxes);
short addParticleToBox (kSanSimulation *sim , particle * basePart,long partIndex, long whichBox );
// short lookForParticleListNNs(kSanSimulation *sim, OHList *partList );
short lookForParticleListsNeighbors(kSanSimulation *sim ,particle * basePart, OHList *list, box * boxes);

// short lookForOneParticlesNNs(kSanSimulation *sim, long partIndex );
short setBoxForPartList(kSanSimulation *sim , OHList *partList);
short zeroNeighborInfo (kSanSimulation *sim , long partIndex);


char  setBoxPositionFlags(kSanSimulation *sim, box *aBox );
char  setBoxRelationFlags(short index );
char  setTranslationFlags(char boxRelations, char boxPositions);
char  setTranslationFlagsFromDels(char delX, char delY, char delZ);

short addNNData(kSanSimulation *sim ,  particle * basePart, long partIndex, long j, char translationFlags, double *radSqu, kSanVector * sepVec);
//void    NNIGetNthVec(kSanSimulation *sim, particle *basePart, long partIndex, long nthNeighbor, kSanVector *vec);
//double  NNIGetNthSep(kSanSimulation *sim, particle *basePart, long partIndex, long nthNeighbor);
//double  NNIGetNthScreening(kSanSimulation *sim, particle *basePart, long partIndex, long nthNeighbor);
//double  NNIGetNthSepAndVec(kSanSimulation *sim, particle *basePart, long partIndex, long nthNeighbor, kSanVector  *vec);
#define NNIGetNNI(sim,basePart,partIndex) (basePart->basePi[partIndex].firstNeighborInfo)
#define NNIGetNthIndex(sim,basePart,partIndex,nthNeighbor) (basePart->basePi[partIndex].firstNeighborInfo[nthNeighbor].thisIndex)
#define NNIGetNthType(sim,basePart,partIndex,nthNeighbor) (basePart->basePi[partIndex].firstNeighborInfo[nthNeighbor].thisType)
#define NNIGetNthTranslationFlags(sim,basePart,partIndex,nthNeighbor) (basePart->basePi[partIndex].firstNeighborInfo[nthNeighbor].translationFlags)
#define nniGetNthIndex(nni,nthNeighbor) (nni[nthNeighbor].thisIndex)
#define nniGetNthType(nni,nthNeighbor) (nni[nthNeighbor].thisType)
#define nniGetNthTranslationFlags(nni,nthNeighbor) (nni[nthNeighbor].translationFlags)

inline void NNIGetNthVec(kSanSimulation *sim, particle *basePart, long partArrIndex, long nthNeighbor, kSanVector  *vec)
{
#ifdef NNIRemembersVec
    *vec = basePart->basePi[partArrIndex].firstNeighborInfo[nthNeighbor].sepVec;
#else
 	char tFlags = NNIGetNthTranslationFlags(sim, basePart, partArrIndex, nthNeighbor);
 	char unusedChar;
#pragma unused(unusedChar)
 	short unusedShort;
#pragma unused(unusedShort)
	long neighborIndex = NNIGetNthIndex(sim, basePart, partArrIndex, nthNeighbor);
	double sepSqu = 0;
 	sim->getSepVec(sim, basePart, partArrIndex, neighborIndex, tFlags, vec);
#endif    
}
inline double  NNIGetNthSep(kSanSimulation *sim, particle *basePart, long partArrIndex, long nthNeighbor)
{
#pragma unused(sim)
#ifdef NNIRemembersSep
    return ((basePart->basePi[partArrIndex].firstNeighborInfo[nthNeighbor].separation));
#else
 	char tFlags = NNIGetNthTranslationFlags(sim, basePart, partArrIndex, nthNeighbor);
 	char unusedChar;
 	short unusedShort;
	long neighborIndex = NNIGetNthIndex(sim, basePart, partArrIndex, nthNeighbor);
	double sepSqu = 0;
	kSanVector  sepVec;
	sepSqu = sim->getSepSquared(sim, basePart, partArrIndex, neighborIndex, tFlags, &sepVec);
	return(sqrt(sepSqu));
#endif
}
inline double  NNIGetNthSepAndVec(kSanSimulation *sim, particle *basePart, long partArrIndex, long nthNeighbor, kSanVector  *vec)
{
#ifdef NNIRemembersVec
    *vec = basePart->basePi[partArrIndex].firstNeighborInfo[nthNeighbor].sepVec;
    return( basePart->basePi[partArrIndex].firstNeighborInfo[nthNeighbor].separation);
#else
 	char tFlags = NNIGetNthTranslationFlags(sim, basePart, partArrIndex, nthNeighbor);
 	char unusedChar;
#pragma unused(unusedChar)
 	short unusedShort;
#pragma unused(unusedShort)
	long neighborIndex = NNIGetNthIndex(sim, basePart, partArrIndex, nthNeighbor);
	double sep = 0;
	double sepSqu = 0;
	sepSqu = sim->getSepSquared(sim, basePart, partArrIndex, neighborIndex, tFlags, vec);
	sep = sqrt(sepSqu);
#endif    
	return(sep);
}

inline double  NNIGetNthScreening(kSanSimulation *sim, particle *basePart, long partArrIndex, long nthNeighbor)
{
#pragma unused(sim)
#ifdef NNIRemembersScreening
    return ((basePart->basePi[partArrIndex].firstNeighborInfo[nthNeighbor].screening));
#else
	double screening = 0;
	return (screening);
#endif
}

inline long numNNs(particle *basePart, long partArrIndex)
{
	return ( basePart->basePi[partArrIndex].actualNumNeighbors);
}


/*
#define NNIGetNNI(sim,basePart,partIndex) (basePart[partIndex].neighbors.firstNeighborInfo)
#define NNIGetNthIndex(sim,basePart,partIndex,nthNeighbor) (basePart[partIndex].neighbors.firstNeighborInfo[nthNeighbor].condensedInfo & 0x000FFFFF)
#define NNIGetNthType(sim,basePart,partIndex,nthNeighbor) ((basePart[partIndex].neighbors.firstNeighborInfo[nthNeighbor].condensedInfo & 0x00F00000) >> 20)
#define NNIGetNthTranslationFlags(sim,basePart,partIndex,nthNeighbor) ((basePart[partIndex].neighbors.firstNeighborInfo[nthNeighbor].condensedInfo & 0x3F000000) >> 24)
#define nniGetNthIndex(nni,nthNeighbor) (nni[nthNeighbor].condensedInfo & 0x000FFFFF)
#define nniGetNthType(nni,nthNeighbor) ((nni[nthNeighbor].condensedInfo & 0x00F00000) >> 20)
#define nniGetNthTranslationFlags(nni,nthNeighbor) ((nni[nthNeighbor].condensedInfo & 0x3F000000) >> 24)
*/
// sim particles

long	 kSanSimGetTokenIndex (kSanSimulation *sim , OHToken *myToken);

short ParticleMakeObjSpecifier(kSanSimulation *sim , long partIndex, AEDesc *partDesc);
short ParticlePropertyMakeObjSpecifier(kSanSimulation *sim , long partIndex, DescType propID, AEDesc *propDesc);

// gotcha! these function interpret index starting from 1
short standardParticleGetData(kozoObject *simuObj, void *sim, long partIndex, getMethodArgs *gma);
short  standardParticleSetData(kozoObject *simuObj, void *sim, long partIndex, setMethodArgs *sma);
#define  ParticleSetData(sim, partIndex, sma)  standardParticleSetData(sim->obj, sim, partIndex, sma)
#define  ParticleGetData(sim, partIndex, gma)  standardParticleGetData(sim->obj, sim, partIndex, gma)
 
long addParticleWithoutWrap(kSanSimulation *sim ,kSanVector * pos, long type, long group, short isSelected);
void deleteOverlappingParticles(kSanSimulation *sim ,float tolerance, short callGetNeighbors);
short doPartsOverlap(kSanSimulation *sim , particle * part, long i, long j, float tolerance);

short doParticlesOverlap( particle * part, long i, long j, float tolerance);
short pointOverlapsWithParticle(kSanSimulation *sim , kSanVector * aPoint, float tolerance);

short recalcPartEnergy(kSanSimulation *sim , long partIndex);
short getOneParticleEnergy(kSanSimulation *sim ,long partIndex, double *theEnergy);
short getOneParticleForce(kSanSimulation *sim ,long partIndex, kSanVector * theForce);
void zeroForces(kSanSimulation *sim );

void invertParticlesCallback (kSanSimulation *sim, particle *basePart, long i, void *voidArg); // void arg is a kSanVector Ptr
//void translateAllParticles(kSanSimulation *thisSim,floatVecPtr tVec);
//void translateSelectedParticles(kSanSimulation *thisSim,floatVecPtr tVec);

// sim selections
void refindHighlights(kSanSimulation *sim );
void refindSelections(kSanSimulation *sim );
RGBColor getUniqueHighlightColour(kSanSimulation *sim );


// kSanSim	

short expandPartMemory(kSanSimulation *sim ,long numParts);
void doTimeSwitch(kSanSimulation *sim );
short doPlugInFunctions(kSanSimulation *sim );
short initBoxes(kSanSimulation *sim );

void removeIterationThread (kSanSimulation *sim );

void getSepVecOrthorhombic (kSanSimulation *sim, particle *basePart, long firstPartIndex, long secondPartIndex, 
		 char translationFlags, kSanVector * sepVec);
void getSepVecTriclinic(kSanSimulation *sim, particle *basePart, long firstPartIndex, long secondPartIndex,
		 char translationFlags, kSanVector * sepVec);
double getSepSquaredOrthorhombic (kSanSimulation *sim, particle *basePart, long firstPartIndex, long secondPartIndex, 
		 char translationFlags, kSanVector * sepVec);
double getSepSquaredTriclinic(kSanSimulation *sim, particle *basePart, long firstPartIndex, long secondPartIndex,
		 char translationFlags, kSanVector * sepVec);
short wrapAroundTriclinic(kSanSimulation *sim ) ;
short wrapAroundOrthorhombic(kSanSimulation *sim ) ;
short setBoxForPartTriclinic(kSanSimulation *sim ,long partIndex);
short setBoxForPartOrthorhombic(kSanSimulation *sim ,long partIndex);
long determineBoxForPartOrthorhombic(kSanSimulation *sim ,long partIndex);
long determineBoxForPartTriclinic(kSanSimulation *sim ,long partIndex);

//atomtypes 
void getTypespecValues(DialogPtr dialog, typespecs *tempSpecs);
void 	insertTypespecValues(DialogPtr dialog, typespecs *tempSpecs);

MenuHandle  buildAtomTypesPopupMenu(kSanSimulation *sim , short withNewType);
kozoObject * simGetTypeFromTypespecs(kSanSimulation *sim , typespecs *types) ;  
kozoObject *simGetTypeFromSymbolMassAndAN(kSanSimulation *sim , char *symbol, double theMass, short atNum)  ;
kozoObject * simGetTypeFromName(kSanSimulation *sim , char * name);
short simGetNthTypespecs(kSanSimulation *sim , typespecs *types, short index);
void simSetFirstAtomType (kSanSimulation *sim );
// clipboard
short	kSanSimClear	(kSanSimulation *sim );
short	kSanSimCut	(kSanSimulation *sim);
short  kSanSimPaste (kSanSimulation *sim);

short	 kSanSimCopy	(kSanSimulation *sim);
void	 kSanSimRemoveParticle	(kSanSimulation *sim, long whichPart, short callGetNeighborFuncs);
void	 kSanSimRemoveParticleArrayIndexList	(kSanSimulation *sim, OHList * theList, short callGetNeighborFuncs);
void	 kSanSimRemoveParticleASIndexList	(kSanSimulation *sim, OHList * theList, short callGetNeighborFuncs);
short	 kSanSimRemoveParticleToken	(kSanSimulation *sim, OHToken *myToken);

void	 changeIndexInGroups	(kSanSimulation *sim, long newIndex, long oldIndex);
void	 changeIndexInPartList	(kSanSimulation *sim, long partToReplace, long partToMove);
void	 changeIndexInHighlights (kSanSimulation *sim, long newIndex, long oldIndex);
void	 changeIndexInSelections (kSanSimulation *sim, long newIndex, long oldIndex);
void	 removeFromGroups	(kSanSimulation *sim, long index);
void	 changeIndexInGroups	(kSanSimulation *sim, long newIndex, long oldIndex);

void changeIndexInWindowLists (kSanSimulation *sim,long oldIndex, long newIndex);
void removeFromWindows (kSanSimulation *sim,long indexToRemove); 
long	countReturns	(Handle theHandle);
short	goToNextLine	(long *pos, Ptr ptr);

long findFlagType (kSanSimulation *sim,particle * basePart) ;
void  zeroPartInfo (particle * basePart, long partArrIndex);


// new
short loadOldSimulation(kSanSimulation *sim, OHFile *aFile);
short makeSimStructure(kSanSimulation *sim,short xCells, short yCells, short zCells, 
							short structureType, double latCon);
short	DoNewDialog	(short *xPtr, short *yPtr, short *zPtr,
					 short *structureTypePtr, double *lcPtr);
void	kSanSimNewInitialStructureDialog	(kSanSimulation *sim);

// sim iter
short updateEnergy(kSanSimulation *sim) ;
pascal void *iterationThread  (kSanSimulation *sim);
void checkYield(kSanSimulation *sim);

short 	calculateForce (kSanSimulation *sim);
void      addAppliedForces(kSanSimulation *sim);
double 	temperatureChange(kSanSimulation *sim);
double 	kineticEInEV(kSanVector * velocity, double mass);
double 	 getKineticEnergyOfList(kSanSimulation *sim, OHList *theList);
double     groupKinECalc(kSanSimulation *sim);
double 	 kinECalc(kSanSimulation *sim);
void 	stabilize  (kSanSimulation *sim) ;
void waitForIterationToFinish(kSanSimulation *sim);
void abortIteration(kSanSimulation *sim,short stopTime);

// sim group
 short  addGroupForces( kozoObject *gpObj, particle *basePart, kSanVector * areas );
short refindGroups(kSanSimulation *sim);

void addForceToGroups(kSanSimulation *sim);
short  kSanSimAddParticleToGroup(kSanSimulation *sim, long groupIndex, long partIndex);
short simRandomizeGroup (kSanSimulation *sim, kozoObject *gpObj);
short kSanSimNewGroup(kSanSimulation *sim, long *newGroupIndex);
void  kSanSimRemoveGroup(kSanSimulation *sim, long gIndex);

void mergeGroups(kSanSimulation *sim, long groupA, long groupB);
void doGroupParticles(kSanSimulation *sim, OHList *list);
char groupExists(kSanSimulation *sim,short index);
short addGroup(kSanSimulation *sim);
void removeEmptyGroups(kSanSimulation *sim);
void  kSanSimRemoveGroupObj(kSanSimulation *sim, kozoObject *gpObj);
void removeAllGroups(kSanSimulation *sim);
MenuHandle  buildGroupPopupMenu(kSanSimulation *sim);
void  rebuildGroups(kSanSimulation *sim);
void getGroupInfo (kSanSimulation *sim, long gIndex, kSanGroupInfo *gpInfo);

// sim init
short initBoxInfo(kSanSimulation *sim);
void disposeBoxInfo(kSanSimulation *sim); 
void initGThreshholds(kSanSimulation *sim);
void initGCounters(kSanSimulation *sim);
short makeIterationThread(kSanSimulation *sim);
short initFlags(kSanSimulation *sim);
void simDefaultValues(kSanSimulation *sim);

// simReadWrite
short doDataSave(kSanSimulation *sim,long askForFileSpec);
short 	loadNewInfo(kSanSimulation *sim);

// appPlugIns
void kSanSimCallActivePlugIns(kSanSimulation *sim);
short simHandlePlugInError(kSanSimulation *sim, kozoObject *plug, short plugInError);

short	doDataCollectionDialog	(kSanSimulation *sim);
void disposeCollectorMenu(void);
short makeCollectorMenu(kSanSimulation *sim);
short	simNewDataCollectorChoice( long item);


void makeDefaultModule(kSanSimulation *sim, DescType moduleClass);
short setModuleMenuChoice(kSanSimulation *sim, DescType moduleClass, short theIndex);

void simInformMethodOfChangedPosition(kSanSimulation *sim, long partIndex);
void simInformPluginsOfChange(kSanSimulation *sim, short whichChange);
void removeActivePlugIn(kSanSimulation *sim,DescType moduleClass);

// win

void 	drawAllWindows (kSanSimulation *sim);
#define drawAllWindows(sim)  kozoDoMessage (simOBJ(sim), kInvalWorldsMessage, 0L, 0L)
#define simRedraw(sim)  kozoDoMessage (simOBJ(sim), kInvalWorldsMessage, 0L, 0L)
void 	invalAllWorlds(kSanSimulation *sim);
short  spawnWindow (kSanSimulation *sim, BitList *useThisList, kozoObject **theNewWindow);
void changeParticleIndexInAllWindows (kSanSimulation *sim, long oldIndex, long newIndex);


//short simGetDoDiffAccounting(kozoObject *sim);
short simWhichCursor(kozoObject *sim);
//void setDoDiffAccounting(kSanSimulation *sim, short yesOrNo);

//file

short kSanSimDoContinuingBackup (kSanSimulation *sim);


#endif
