#ifndef __kSanSimulationPublic__
#define __kSanSimulationPublic__

#include "kSanSimRegistry.h"
#define kPotentialDialog 'ptD'
#define kResizeDialog 'szD'
#define kMethodDialog 'mtD'
 #define kCutoffDialog 'ctD'
#define kFrequenciesDialog 'nuD'
#define kDataCollectionDialog 'dcD'
#define kConstraintsDialog 'fxD'
#define kScaleCellDialog 'scD'
#define kCellSizeDialog 'czD'
#define kExpandCellDialog 'xpD'
#define kCellStressDialog 'ssD'
#define kGroupInfoDialog 'giD'
#define kSpawnWindow 'spw'

	
#include "kSanParticle.h"
#include "kSanGroup.h"
 #include "kSanAtomtype.h"

/*
typedef struct linktype
{
	long label;
	long value;
	struct linktype *next;
}
links, *lksPtr;
links was used in ordering particles.  not used anymore
*/ 
/*
typedef struct NNInfoStructOffsetsType
{
	long neighborNumberOffset;
	long thisLabelOffset;
	long labelArrayOffset;
	long separationArrayOffset;
	long invSepArrayOffset;
	long sepVecArrayOffset;
	long screeningArrayOffset;
	long typeArrayOffset;
	long recordSize;
	// Ptr rest of data goes here;
}	
NNInfoStructOffsets;

*/


typedef struct simFlagsType
{
	short error;
	short clockRunning;
	short pbcMode;
	short tooManyNeighbors;
	char done; // abort the sim
	char abortNow;  // abort the iteration
	char iterationInProgress;
	char automaticUpdate;
	char dirty;
	char menusDirty;
	char uniqueIDListDirty;
	char neighborOverrun; // the neighbor list needs help
	unsigned long lowestYieldFlag;
	void * threadHasReturned;
}
simFlags;

 typedef struct iterLimitsType
{
 	long		therm;
	long		redraw;
 	long		cellPressure;
 //	long		rotate;
 	long		neighbor;
 	long		velocityCentering;
 	long		dataSave;
 	long		memoryCleanup;
}
iterLimits;

 typedef struct boxType 
 { 	
	long label;
	long neighboringBoxes[NUMNEIGHBORINGBOXES];   
 	short Xindex, Yindex, Zindex, dummy;
 	OHList boxPartList;
 }
 box; 	
 
typedef struct  relativeBoxInfoType
 { 	
 	long localIndex;
 	short Xdiff, Ydiff, Zdiff, dummy;
 }
 relativeBoxInfo; 
 
typedef struct  particlePropertyOwnerType
 { 	
 	DescType property;
 	kozoObject *owner;
 	char nowRegistering;
 	char unuzed;
 	short unused;
 }
 particlePropertyOwner; 
#define particlePropertyOwnerDataPtr 'Ppo>' 
#define  kSimRegisterParticlePropertyOwner 'Ppo>' 


typedef struct cellConstraintsType
{
	short XAxis;
	short YAxis;
	short ZAxis;
	short Alpha;
	short Beta;
	short Gamma;
}
cellConstraints, *cellConstraintsPtr;



void	kSanSimulationNewMenuChoice	(void);
void	handleSimulationChoice	(short item);
 
short simDoProgressFunction (struct kSanSimulationType *sim);
short simGetNumAtomtypes(struct kSanSimulationType *sim);


//launchers

short launchSetHighlight(struct kSanSimulationType *sim, long partIndex, short highlite);
short launchEraseSelections(struct kSanSimulationType *sim); 

#endif