#ifndef __kSanVector__
#define __kSanVector__

//#include "kSanVectorSwitch.h"
//this should be in the prefix file

#ifdef __2DVectors__
#define  NUMDIMENSIONS 2
#include "vecMath2d.h"
#else
#define  NUMDIMENSIONS 3
#include "vecMath3d.h"
#include "vecMath2d.h"
#endif


 
#ifdef __2DVectors__
   #define MIDDLEBOXINDEX 4 // 0-3 , 4, 5-8
   #define NUMNEIGHBORINGBOXES 9
   #define NUMCUBEEDGES 4 
   #define NUMCUBEVERTICES 4
 #else
   #define MIDDLEBOXINDEX 13  // 0-12 , 13, 14-16
   #define NUMNEIGHBORINGBOXES 27
   #define NUMCUBEEDGES 12 
   #define NUMCUBEVERTICES 8
#endif

#ifdef __2DVectors__
   #define kSanVector double2dVector 
   #define kSanMatrix  double2dMatrix
   #define kSanMatrixF  float2dMatrix
   #define kSanLongVector long2dVector
#else
   #define kSanVector double3dVector
   #define kSanMatrix  double3dMatrix 
   #define kSanMatrixF  float3dMatrix 
   #define kSanLongVector long3dVector
#endif


#ifdef __2DVectors__
    #define OHCoerceTokSanVectorD OHCoerceTo2dVectorD
    #define makekSanVectorDescD  make2dVectorDescD
    #define OHCoerceTokSanMatrixD OHCoerceTo2dMatrixD
    #define makekSanMatrixDescD make2dMatrixDescD
    
    #define addkSanVectorsD add2dVectorsD
    #define subkSanVectorsD sub2dVectorsD
    #define zerokSanVectorD zero2dVectorD
    #define zerokSanVectorL zero2dVectorL

    #define multkSanVectorD mult2dVectorD
    #define multkSanVectorL mult2dVectorL
    #define multkSanVectorDFD mult2dVectorDFD
    #define multAddkSanVectorsD multAdd2dVectorsD
    #define prodkSanVectorsD prod2dVectorsD
    
    #define dotkSanVectorsD dot2dVectorsD
    #define normalizekSanVectorD normalize2dVectorD
    #define recipkSanVectorD recip2dVectorD
    #define divkSanVectorsD div2dVectorsD
    #define setkSanVectorD(a,b,c,d)  set2dVectorD(a,b,c)
    
    #define getOrthogonalkSanVectorsD getOrthogonal2dVectorsD
    #define lengthOfkSanVectorD lengthOf2dVectorD
    #define angleOfTwokSanVectorsD angleOfTwo2dVectorsD
    #define closekSanVectorsD close2dVectorsD
    #define swapkSanVectorsD swap2dVectorsD
    
    #define vecDotkSanMatrixD vecDot2dMatrixD
    
    #define identitykSanMatrixD identity2dMatrixD
    #define zerokSanMatrixD zero2dMatrixD
     #define addkSanMatricesD add2dMatricesD
    #define  multkSanMatrixD mult2dMatrixD
    #define meshkSanMatrixD mesh2dMatrixD
    
    #define rotatekSanMatrixD rotate2dMatrixD
    #define rotatekSanVectorD rotate2dVectorD
    #define cramerskSanTransformD cramers2dTransformD
    #define cramersCoordsOfkSanPoint cramersCoordsOfXYPoint
    #define getCramerskSanOperatorsD getCramers2dOperatorsD
    #define SpinkSanMatrixInDegreesD Spin2dMatrixInDegreesD
    #define SetkSanMatrixInDegreesD Set2dMatrixInDegreesD
    
    #define addMultiplykSanMatricesD 	addMultiply2dMatricesD 
	#define multiplyAddkSanMatricesD multiplyAdd2dMatricesD 

    #define angleBetweenThreekSanPointsInDegreesD angleBetweenThree2dPointsInDegreesD
    #define distFromkSanPlaneThroughOriginD distFrom2dLineThroughOriginD
     #define getkSanCellVolumeL(a,b,c)  get2dCellAreaL(a,b)
     #define solvekSanCramersD solve2dCramersD
   #define magnitudeOfkSanTensorInDirectionX magnitudeOf2dTensorInDirectionX
#else
    #define OHCoerceTokSanVectorD OHCoerceTo3dVectorD
    #define makekSanVectorDescD  make3dVectorDescD
    #define OHCoerceTokSanMatrixD OHCoerceTo3dMatrixD
    #define makekSanMatrixDescD make3dMatrixDescD
    
    #define addkSanVectorsD add3dVectorsD
    #define subkSanVectorsD sub3dVectorsD
    #define zerokSanVectorD zero3dVectorD
    #define zerokSanVectorL zero3dVectorL

    #define multkSanVectorD mult3dVectorD
    #define multkSanVectorL mult3dVectorL
    #define multkSanVectorDFD mult3dVectorDFD
    #define multAddkSanVectorsD multAdd3dVectorsD
    #define prodkSanVectorsD prod3dVectorsD
    
    #define dotkSanVectorsD dot3dVectorsD
    #define crosskSanVectorsD cross3dVectorsD
    #define normalizekSanVectorD normalize3dVectorD
    #define recipkSanVectorD recip3dVectorD
    #define divkSanVectorsD div3dVectorsD
    #define setkSanVectorD(a,b,c,d)  set3dVectorD(a,b,c,d)
    
    #define getOrthogonalkSanVectorsD getOrthogonal3dVectorsD
    #define lengthOfkSanVectorD lengthOf3dVectorD
    #define angleOfTwokSanVectorsD angleOfTwo3dVectorsD
    #define closekSanVectorsD close3dVectorsD
    #define swapkSanVectorsD swap3dVectorsD
    
    #define vecDotkSanMatrixD vecDot3dMatrixD
    
    #define identitykSanMatrixD identity3dMatrixD
    #define zerokSanMatrixD zero3dMatrixD
     #define addkSanMatricesD add3dMatricesD
    #define  multkSanMatrixD mult3dMatrixD
    #define meshkSanMatrixD mesh3dMatrixD
    #define rotatekSanMatrixD rotate3dMatrixD
    #define rotatekSanVectorD rotate3dVectorD
    #define cramerskSanTransformD cramers3dTransformD
    #define cramersCoordsOfkSanPoint cramersCoordsOfXYZPointD
    #define getCramerskSanOperatorsD getCramers3dOperatorsD
     #define SpinkSanMatrixInDegreesD Spin3dMatrixInDegreesD
    #define SetkSanMatrixInDegreesD Set3dMatrixInDegreesD
     #define solvekSanCramersD solve3dCramersD
    #define angleBetweenThreekSanPointsInDegreesD angleBetweenThree3dPointsInDegreesD
    #define distFromkSanPlaneThroughOriginD distFromPlaneThroughOriginD
   
    #define addMultiplykSanMatricesD 	addMultiply3dMatricesD 
	#define multiplyAddkSanMatricesD multiplyAdd3dMatricesD 

   #define magnitudeOfkSanTensorInDirectionX magnitudeOf3dTensorInDirectionX
     #define getkSanCellVolumeL(a,b,c)  get3dCellVolumeL(a,b,c)
#endif

#endif