
#ifndef __VerletMethod__
#define __VerletMethod__
#include "kSanMethodPlugIn.h"


typedef struct VerletMethodType 
{
	char dirtyNextPositions;
	char dirtyPrevPositions;
	char dirtyPrevForces;
	char unused;
	long numSequentialNoTimestepChange;
	kSanSimulation *sim;
  	VSList nextDelPositions;
 	VSList prevDelPositions;
  	VSList prevForces;
  	double nextTimestep;
  	double prevTimestep;
  	double maxDelPos;
  	double maxDelSafetyFactor;
  	double verletDeltaT;
  	long verletItersPerSimIter;
  	long verletItersDone;
}
VerletMethod;

typedef struct nextGpPositionsInfoType
{
	kozoObject *verletObj;
	VerletMethod *verlet;
	kSanSimulation *sim;
	particle *basePart;
	kSanAtomtype **baseAT;
	kSanGroup *gp;
	long numPartsInGroup;
	long *gpPartList;
	// the issue here is that kSan is allowed to and does switch atoms to the other side of the cell
	// so, we always have to record these as delPos rather than absolute!
	kSanVector *prevDelPosArray ;
	kSanVector *nextDelPosArray ;
	kSanVector *prevForceArray ;
}
nextGpPositionsInfo;


#endif