#include "kSanAtomGraphicsWindow.h"
#include "MacOSDefines.h"

void 	doKeypadRotate (AGWindow *ag, char myKeyCode, short timesFive)
{
	float latAngle;	
	float longAngle;
	float spinAngle;
	float multFactor = 1.0;
		
	if (timesFive) multFactor*= 5.0;
	getAngles(ag, myKeyCode,&latAngle, &longAngle, &spinAngle);	
	SpinMatrixInDegrees(&(ag->windowView.viewMatrix), latAngle*multFactor, longAngle*multFactor, spinAngle*multFactor);
}
void AGWinDoNonButtonClick (kSanWindow *wp,EventRecord *eventPtr)
{
	EventRecord theNextEvent;
	AGWindow *ag;
	short mouseStillDown = true;
	short wasADoubleClick = false;
	short done = false;
	ag = (AGWindow *)wp;
	if (ag->mode == kSelectAndHighlight)
	{
		while ((TickCount() < (eventPtr->when + GetDblTime())) && (!done))
		{
			GetNextEvent((mDownMask | mUpMask), &theNextEvent);
			if (theNextEvent.what == mouseUp) mouseStillDown = FALSE;
			else if (theNextEvent.what == mouseDown)  
			{
				wasADoubleClick = TRUE;	
				done = true;
			}
		}
	          selectHighlightClick(ag, eventPtr, mouseStillDown, wasADoubleClick);
	}
	else 
	{
		doDragRotate(ag, eventPtr->where);
	}
}
void selectHighlightClick (AGWindow *ag, EventRecord *eventPtr, short mouseStillDown, short wasADoubleClick)				
{
	short isHigh;
	short clickWasInParticle;
	short wasSelected;
	short shiftKeyDown;
	short optionKeyDown;
	long whichParticle;
	
	shiftKeyDown =((eventPtr->modifiers & shiftKey) != 0);
	optionKeyDown = ((eventPtr->modifiers & optionKey) != 0);

	clickWasInParticle = wasClickInParticle(ag, eventPtr->where,  &whichParticle);
	if (clickWasInParticle)
	{
		wasSelected = getParticleSelected(ag->win.obj.container, whichParticle);
		if  (wasADoubleClick)
		{
			doParticleDialog(ag->win.obj.container, whichParticle);
		}
		else if (optionKeyDown)
		{
			isHigh = getParticleHighlighted(ag->win.obj.container, whichParticle);
			setParticleHighlighted(ag->win.obj.container, whichParticle, (isHigh == kNotHighlighted));
			callDoMessage((kozoObject *)ag, kInvalWorldMessage, 0L);
		}
		else if (!shiftKeyDown && !wasSelected)
		{
			eraseSelections(ag->win.obj.container); // simulation method
			setParticleSelected(ag->win.obj.container, whichParticle, true);
			doDragMove(ag, eventPtr) ; 
			setSimSelectionsMenuItems(ag->win.obj.container);
		}
		else 
		{
			if (mouseStillDown && wasSelected)
			{
			}
			else
			{
				isHigh = getParticleHighlighted(ag->win.obj.container, whichParticle);
				setParticleHighlighted(ag->win.obj.container, whichParticle, (!isHigh));
				setSimSelectionsMenuItems(ag->win.obj.container);
			}
			doDragMove(ag, eventPtr);								
		}
	}
	else if (mouseStillDown)
	{
		doDragSelectInWindow(ag, eventPtr->where, shiftKeyDown);
	}
	else  // avoid nested elses
	{
		eraseSelections(ag->win.obj.container); // simulation method
	}
}	
void doDragMove (AGWindow *ag,EventRecord *eventPtr)  
{
	short didDrag = FALSE;
	short mouseIsDown;
	
	mouseIsDown = StillDown();
	while (WaitMouseUp())
	{// don't do drag if mouse is not still down or nothing to drag// avoid nested elses in if statements above
	 	//make a region for dragging
	 	grafData * thisPart;
	 	grafData * thisGrafPtr;
	 	RgnHandle myRegion;
	 	RgnHandle tempRegion;
	 	long partsInWindow;
	 	newMatrixFPtr thisViewMatrix;
	 	short i, counter;
	 	
	 	thisGrafPtr = lockGrafData(ag);
	 	partsInWindow = numItems(&ag->partList);
		myRegion = NewRgn();
	 	tempRegion = NewRgn();
	
		thisViewMatrix = &(ag->windowView.viewMatrix);
		counter = 1;  // will count through selections list
		i = 0;  // counts through grafdata structure
		while ((i<(partsInWindow)) &&	(counter<100) )
		{
			thisPart = &(thisGrafPtr[i]);
			if (getParticleSelected(ag->win.obj.container, thisPart->index))
			{
				SetEmptyRgn(tempRegion);
		 		OpenRgn();
				FrameOval(&(thisPart->circle));
				CloseRgn(tempRegion);
				UnionRgn(tempRegion,myRegion,myRegion);	
				++counter;	
			}
			++i;
		}
	 	//track mouse with info display
	 	{
		 	long dummyLong;
		 	Point movedVH;
		 	
		 	dummyLong = DragGrayRgn(myRegion,eventPtr->where,
		 				&(ag->win.thisWindowPtr->portRect),
		 				&(ag->win.thisWindowPtr->portRect),
		 				noConstraint,nilPointer);  // noConstraint means both axes, nil means no callback
		 	movedVH.v = ((Point *)&dummyLong)->v;
		 	movedVH.h = ((Point *)&dummyLong)->h;
	 	//check for abort
	 		if (keyIsPressed(kOptionKeyCode) || (dummyLong == 0x80008000) )  // value for released outside window
	 		{	 		
	 		}// bail
	 		else  // do move
	 		{
		 	// get movement vectors
	 			float movedV, movedH, mag;
	 			floatVector delVec;
	 			mag = ag->windowView.magnification;
	 			movedV =  (float)movedVH.v / mag;
	 			movedH = (float)movedVH.h / mag;
	 			
	 			delVec.a = movedH * thisViewMatrix->A.a - movedV * thisViewMatrix->B.a;
	 			delVec.b = movedH * thisViewMatrix->A.b - movedV * thisViewMatrix->B.b;
	 			delVec.c = movedH * thisViewMatrix->A.c - movedV * thisViewMatrix->B.c;
	 			translateParticles(ag->win.obj.container, &delVec, true); // selectedOnly
				didDrag = TRUE;
	 		}
	 	}
	 	// clean up
	 	DisposeRgn(tempRegion);
	 	DisposeRgn(myRegion);
	 	releaseGrafData( ag );	 
	 	setNeedsEnergyUpdate (ag->win.obj.container, true);	
	}
	if (didDrag) 
	{
		long gnErr;
		callInvalWorld(ag->win.obj.container);
		gnErr = calcNeighbors(ag->win.obj.container);
	}
}
void doDragSelectInWindow  (AGWindow *ag,Point where, short shiftKeyWasDown)
{	
	short err;
	GrafPtr	oldPort;
	PixPatHandle oldPat;
	Point newPoint, oldPoint;
	Rect r;
 	
 	OHList tList;
	grafData *gd;
	grafData *thisGrafData;
	char grayPat[8];
	RgnHandle oldClip;
	PixMapHandle 	thePixMap;
	GWorldFlags theFlags;
 
 	err = initializeList(&tList);
 	if (!err)
 	{
 	 	gd = lockGrafData(ag);
	 	
		GetPort( &oldPort);
		SetPort (ag->win.thisWindowPtr);
		oldPat= ((CGrafPtr)(ag->win.world))->pnPixPat;
		GetIndPattern((PatPtr)grayPat,kSystemPattern,kGrayPattern);
		PenPat((PatPtr)grayPat);
		oldClip = NewRgn();  // save the clipRgn
		GetClip (oldClip);
		ClipRect (&(ag->win.worldRect));  //correct clip region so scrollbars stay OK
		thePixMap = GetGWorldPixMap(ag->win.world);
		theFlags = GetPixelsState(thePixMap);
	 	if (!(LockPixels (thePixMap))) doAlert("\pGWorld Purged");
		GetMouse( &newPoint);
		Pt2Rect ( where, newPoint, &r); // define the rectangle r

		while ( WaitMouseUp() ) // this is the drag rect
		{
			GetMouse( &newPoint);
			
			if ( DeltaPoint(oldPoint, newPoint) ) // fancy way of testing if mouse has moved
			{	// if it moved:
				 setColour(myBlackColour);
				CopyBits((BitMapPtr)(*thePixMap),(BitMapPtr) &qd.thePort->portBits,
								&r, &r,srcCopy,0);
				Pt2Rect ( where, newPoint, &r); // define the rectangle r
					
				setColour(myRedColour);
				FrameRect( &r );	
				oldPoint=newPoint;
			}
		}
	 	SetPixelsState(thePixMap, theFlags);

		newPoint.h -= where.h;
		newPoint.v -= where.v;  // find how far away the points are
		if ((newPoint.h > 2) || (newPoint.h < -2) || (newPoint.v > 2) || (newPoint.v < -2))
		{
			long i;
			long numberSelected = 0;
			Rect *thisCircle;
			short notBetweenPts;
			RgnHandle circleRegion;
			RgnHandle selectedRegion;
			RgnHandle testRegion;
			
			i = numItems(&ag->partList) - 1;
			selectedRegion = NewRgn();
			OpenRgn();
			FrameRect(&r);
			CloseRgn(selectedRegion); // now the rectangle is in selected region
			
			testRegion = NewRgn();
			circleRegion = NewRgn();
			
			while ( i>=0 ) // we count down from numParts-1
			{
				thisGrafData =  &(gd[i]);
				if (!(thisGrafData->inWindow))
				{
					i = i - 1;  // many i=i-1s so that the loops go fast???
				}
				else
				{
					thisCircle = &(thisGrafData->circle);			
					notBetweenPts = (( r.left > thisCircle->right) || ( r.right < thisCircle->left));
					if (notBetweenPts)
					{
						i = i - 1;
					}
					else 
					{		
						notBetweenPts = (( r.top > thisCircle->bottom) || ( r.bottom < thisCircle->top));
						if (notBetweenPts)
						{
							i = i - 1;
						}
						else //if (thisGrafData->inWindow)
						{		
							OpenRgn();  // this timeconsuming operation only occurs if we are very close
							FrameOval(thisCircle);
							CloseRgn(circleRegion);
							SectRgn(selectedRegion, circleRegion, testRegion);
							if (!(EmptyRgn(testRegion)))
							{
								addToList(&tList,   thisGrafData->index);
							}
							else  // avoid nested elses 
							{
							
							}
							i = i - 1;
						}
					}
				}
			}
			if  (!shiftKeyWasDown) eraseSelections(ag->win.obj.container); // shortened alot!!!
			 setListSelected(ag->win.obj.container, &tList, true);

			DisposeRgn(circleRegion);
			DisposeRgn(selectedRegion);
			DisposeRgn(testRegion);
		}
		setSimSelectionsMenuItems(ag->win.obj.container);

		SetClip(oldClip);
		DisposeRgn(oldClip);

 		setColour(myBlackColour);  
 		GetIndPattern((PatPtr)grayPat,kSystemPattern,kBlackPattern);
 		PenPat((PatPtr)grayPat);
		SetPort(oldPort);

		releaseGrafData(ag);
		disposeList(&tList);
		callInvalWorld(ag->win.obj.container);
	}
	else
	{
	 	SysBeep(20);
	}
}
void setDragActiveRegion(AGWindow *ag, RgnHandle activeRegion)
{
	Point centerPoint;
	Point windowSize;
	short activeRadius;
	Rect ovalRect;

 	centerPoint.h = (ag->win.worldRect.right + ag->win.worldRect.left)/2;
 	centerPoint.v = (ag->win.worldRect.bottom + ag->win.worldRect.top)/2;
 	windowSize.h = (ag->win.worldRect.bottom - ag->win.worldRect.top);
 	windowSize.v = (ag->win.worldRect.right - ag->win.worldRect.left);
 	if (windowSize.v < windowSize.h) 
 	{
 		activeRadius = (windowSize.v * 3) / 7;
 	}
 	else 
 	{
 		activeRadius = (windowSize.h * 3) / 7;
 	}
 	ovalRect.top = centerPoint.v - activeRadius;
 	ovalRect.bottom = centerPoint.v + activeRadius;
 	ovalRect.right = centerPoint.h + activeRadius;
 	ovalRect.left = centerPoint.h - activeRadius;
 	OpenRgn();
 	FrameOval(&ovalRect);
 	CloseRgn(activeRegion);
}


void doDragRotate (AGWindow *ag,Point startPoint)
{	
	GrafPtr	oldPort;
	short oldColourCalc;
	Point oldPoint, newPoint;
	Point centerPoint;
	RgnHandle activeRegion;
	float fullHoriz;
	float fullVert;
	float delHoriz;
	float delVert;
 	
 	RgnHandle oldClip;
	PixMapHandle 	thePixMap;
	GWorldFlags theFlags;
 	
 	activeRegion = NewRgn();
 	setDragActiveRegion(ag, activeRegion);
 	centerPoint.h = (ag->win.worldRect.right + ag->win.worldRect.left)/2;
 	centerPoint.v = (ag->win.worldRect.bottom + ag->win.worldRect.top)/2;
	GetPort( &oldPort);
	SetPort (ag->win.thisWindowPtr);
	oldClip = NewRgn();  // save the clipRgn
	GetClip (oldClip);
	ClipRect (&ag->win.worldRect);  //correct clip region so scrollbars stay OK
	thePixMap = GetGWorldPixMap(ag->win.world);
	theFlags = GetPixelsState(thePixMap);

	fullHoriz = (-1.0/180.0) * (ag->win.worldRect.right - ag->win.worldRect.left);
	fullVert = (1.0/180.0) * (ag->win.worldRect.bottom - ag->win.worldRect.top);
	// setMyCursor(kRotateCursor);
	oldPoint = startPoint;  // init old point
	oldColourCalc = ag->doColourCalc;
//	ag->doColourCalc = false;  // so that we don't recalculate the colour every time
	while ( WaitMouseUp() )  
	{
		GetMouse( &newPoint);
		if ( DeltaPoint(oldPoint, newPoint) ) // fancy way of testing if mouse has moved
		{	// if it moved:
			delHoriz = newPoint.h - oldPoint.h;	
			delVert = oldPoint.v - newPoint.v;
			if (PtInRgn(newPoint, activeRegion)) // do a spin
			{
				appSetCursor(kRollCellCursor);
				SpinMatrixInDegrees(&(ag->windowView.viewMatrix),  
					delHoriz/fullHoriz,delVert/fullVert,  0);	// 0 is spin
			}
			else 
			{
				float spinAngle;
				appSetCursor(kSpinCellCursor);
				spinAngle = pointAngle (oldPoint, centerPoint, newPoint);
				SpinMatrixInDegrees(&(ag->windowView.viewMatrix),  
					0,0,-spinAngle);	// 0 for lat and long				
			}
			drawWorld(&ag->win);
			oldPoint=newPoint;
		}
	}
 		ag->doColourCalc = oldColourCalc;
	SetPixelsState(thePixMap, theFlags);
	SetClip(oldClip);
	DisposeRgn(oldClip);
	SetPort(oldPort);
	DisposeRgn (activeRegion);
//	setColour(myBlackColour);  
}
	
short wasClickInParticle(AGWindow *ag,Point where, long * whichParticle)
{
	long i,j;
	short horiz, vert;
	short notBetweenPts;
	short foundIt = false;
	long *orderListPtr;
	grafData * myGrafData;
	grafData * thisGrafData;
	RgnHandle testRgn;
	Rect *thisCircle;
	
	testRgn = NewRgn();
	
	myGrafData = lockGrafData( ag);
	orderListPtr = lockList (&ag->orderList);
	
	i = numItems(&ag->partList) -1;
	horiz = where.h;
	vert = where.v;
	while ((!foundIt) && (i>=0))  // count down from nearest to viewer
	{
		j = orderListPtr[i];
		thisGrafData =  &(myGrafData[j]);
		if (!(thisGrafData->inWindow))
		{
			i = i - 1;  // many i=i-1s so that the loops go fast???
		}
		else
		{
			thisCircle = &(thisGrafData->circle);			
			notBetweenPts = (( horiz > thisCircle->right) || ( horiz < thisCircle->left));
			if (notBetweenPts)
			{
				i = i - 1;
			}
			else 
			{		
				notBetweenPts = (( vert > thisCircle->bottom) || ( vert < thisCircle->top));
				if (notBetweenPts)
				{
					i = i - 1;
				}
				else 
				{		
					OpenRgn();  // this timeconsuming operation only occurs if we are very close
					FrameOval(thisCircle);
					CloseRgn(testRgn);
					if (PtInRgn(where, testRgn)) foundIt = true; 
					SetEmptyRgn(testRgn);
					i = i - 1;
				}			
			}
		}
	}
	(*whichParticle) = thisGrafData->index;
	
	releaseGrafData( ag);
	releaseList(&ag->orderList);
	DisposeRgn(testRgn);

	return (foundIt);
}


void AGWinHandleKeyDown(AGWindow *ag,char theChar)
{
	short optionKeyPressed;
	short shiftKeyPressed;
	optionKeyPressed = keyIsPressed(kOptionKeyCode);
	shiftKeyPressed = keyIsPressed(kShiftKeyCode);
	if ( (theChar >=leftArrowKeyCode  &&
			 theChar <= downArrowKeyCode) || (theChar == '[') || (theChar == ']') )
	{
		doArrowMove (ag, theChar, optionKeyPressed, shiftKeyPressed);
		callInvalWorld(&ag->win.obj);
	}
	else if ( ((theChar >= '1')  && (theChar <= '9'))  || (theChar == '*') || (theChar == '/') )
	{
		if (!optionKeyPressed) doKeypadRotate (ag, theChar, shiftKeyPressed);
		else doSelectedRotate(ag, theChar, shiftKeyPressed);
		callInvalWorld(&ag->win.obj);
	}
}

void 	doArrowMove  (AGWindow *ag, char myKeyCode, short timesFive, short selectedOnly)
{
	floatVector wVec;
	float multFactor = 1.0;
	
	zeroVectorF(&wVec);
	if (timesFive) multFactor *= 5.0;
	switch (myKeyCode)
	{		
		case leftArrowKeyCode:
			wVec.a = -1*(ag->manip.horizShift) * multFactor;
			break;					

		case rightArrowKeyCode:		
			wVec.a = (ag->manip.horizShift)* multFactor;
			break;			
							
		case upArrowKeyCode:		
			wVec.b = ag->manip.vertShift* multFactor;
			break;
			
		case downArrowKeyCode:		
			wVec.b = -1*(ag->manip.vertShift)* multFactor;
			break;

		case '[':		
			wVec.c = -1*(ag->manip.hikiShift)* multFactor;
			break;

		case ']':		
			wVec.c = ag->manip.hikiShift* multFactor;
			break;
	}	
	{
		floatVector translationVec;
		vecDotMatrixF(&wVec, &ag->windowView.viewMatrix, &translationVec);
		translateParticles (ag->win.obj.container, &translationVec, selectedOnly);	
	}			
}
