#include "kSanAGWindow.h"
#include "kSanSimAtomtypes.h"
void 	 swapColours(AGWindow *ag)  ;
void 	 stashColours(AGWindow *ag, RGBColor *rgbs)  ;
void 	 unstashColours(AGWindow *ag, RGBColor *rgbs)  ;

void  makeAGWorld(kSanWindow *wp)
{
	PixMapHandle 	thePixMap;
	grafData *theGrafPtr;
	particle * part;
	GWorldFlags theFlags;
	AGWindow *ag;
	newMatrixD trix;
	cubeFrameData aCubeFrame;
	ag = (AGWindow *) wp;
		
	theGrafPtr = lockGrafData( ag);
	part = simLockParts(wp->obj.container);

	thePixMap = GetGWorldPixMap(wp->world);	
	theFlags = GetPixelsState(thePixMap);
	LockPixels (thePixMap);
	PenMode (patCopy);
	PenPat (&qd.black);
	
	RGBForeColor(&ag->windowView.BGColour);
	PaintRect(&(wp->world->portRect)); 

	// trix = &simInfo->simCell.primitiveVectors;
	getPrimitiveVectors( wp->obj.container , &trix);
	findLinePoints(ag, &aCubeFrame, &trix);
	setLineOrder(&(aCubeFrame.edgeValues[0]),  &(aCubeFrame.edgeOrder[0]));
	
	drawLines(&aCubeFrame, 0 , 7);  // firstEightLines
	if (ag->doColourCalc)
	{
		findParticles(ag, part);
		sortParticles(ag);
		CallUniversalProc(ag->cPlug->colourParticleList, kVoidFourStackPtrProc, 
				ag->colourPiHandle, ag->win.obj.container, theGrafPtr, numItems(&ag->partList));
	}
	else
	{
//		long *savedList = nilPointer;
//		long size;
//		size = sizeof(long) *ag->howManyParts
//		savedList = NewPtr(size) ;
//		if (savedList != nilPointer) BlockMove(*ag->orderList.listData, savedList, size);
		RGBColor *tempRGB;
		long count;
		count =  numItems(&ag->partList);
		tempRGB = (RGBColor *)NewPtr (sizeof(RGBColor) * count);
		if (tempRGB != nilPointer) stashColours(ag, tempRGB);
		findParticles(ag, part);
	 	if (tempRGB != nilPointer) unstashColours(ag, tempRGB);
 		sortParticles (ag );
		if (tempRGB != nilPointer) DisposePtr ((Ptr)tempRGB);
	}
	if (ag->windowView.showBonds == kBondsVisible)  
	{
		findBonds(ag, part);
	}
	drawContents(ag);

	drawLines(&aCubeFrame, 8 , 11);  // lastFourLines

	PenPat (&qd.black);
//	drawColourBar(theWindow);   taken out for first compile
	SetPixelsState(thePixMap, theFlags);
	
	releaseGrafData(ag);
	simReleaseParts(wp->obj.container);
}

void 	 stashColours(AGWindow *ag, RGBColor *rgbs)  
{
	long count;
	long i;
	long *orderListPtr;
	grafData * theGrafPtr;
	count =  numItems(&ag->partList);

	theGrafPtr = lockGrafData( ag);
	orderListPtr = lockList( &ag->orderList);
	for (i = 0; i< count; ++i)
	{
		rgbs[i] = theGrafPtr[i].colour;
	}
	releaseGrafData( ag);
	releaseList( &ag->orderList);	

}

void 	 unstashColours(AGWindow *ag, RGBColor *rgbs)  
{
	long count;
	long i;
	long *orderListPtr;
	grafData * theGrafPtr;
	count =  numItems(&ag->partList);

	theGrafPtr = lockGrafData( ag);
	orderListPtr = lockList( &ag->orderList);
	for (i = 0; i< count; ++i)
	{
		  theGrafPtr[i].colour = rgbs[orderListPtr[i]];
	}
	releaseGrafData( ag);
	releaseList( &ag->orderList);	

}

void 	 sortParticles(AGWindow *ag)  
{
	grafData *theGrafPtr;
	long * orderList;
	lksPtr firstlink;
	lksPtr thislink;
	lksPtr somelink;
	lksPtr nextlink;
	lksPtr myPtr;
	long i = 0;
	long j = 0;
	long count;
		
	theGrafPtr = lockGrafData( ag );
	myPtr = simLockLinkArray( ag->win.obj.container);
	orderList = lockList( &ag->orderList);

	firstlink = &(myPtr[0]);
	firstlink->label = 0;
	firstlink->value = theGrafPtr[i].graphc;
	firstlink->next = nilPointer;
	count = numItems(&ag->partList);
	
	for (i=1 ; i < count ; ++i)
	{
		thislink = &(myPtr[i]);
		thislink->label = i;
		thislink->value = theGrafPtr[i].graphc;
		if (thislink->value >= firstlink->value)  // firstlink has highest value of stack
		{
			thislink->next = firstlink;  // make thislink the top of stack
			firstlink = thislink;
		}
		else 
		{
			   somelink = firstlink;  // find place in stack
			   nextlink = somelink->next;
			   while ((nextlink != nilPointer) &&  (thislink->value < nextlink->value) )
			   			
			   {
				 somelink = nextlink;
			           nextlink = somelink->next;
			   }
			   
	/* we drop through this while statement when we are at the end of the list or when */
	/* the value of thislink is in between somelink and nextlink                  */

			  thislink->next = nextlink;
			  somelink->next = thislink; 
		}
	}
	somelink = firstlink;
	for(i= (numItems(&ag->partList)) -1 ; i>=0 ; i = i-1)
	{	
		orderList[i] = somelink->label;
		somelink = somelink->next;		
	}
	releaseGrafData( ag );
	simReleaseLinkArray( ag->win.obj.container );
	releaseList( &ag->orderList );
}

void findLinePoints(AGWindow *ag, cubeFrameData *thisFrame,  newMatrixDPtr trix)
{
	short centerX, centerY;			// for drawing cell outline
	short shortGraphA, shortGraphB, shortGraphC;	
	short j,k;
	floatVector lineBeginning;
	floatVector lineEnd;
	floatVector linePointOne;
	floatVector linePointTwo;
	float calcX, calcY, calcZ, depthFactor, viewLen;
	float mag;
	float graphA, graphB, graphC;	
	viewInfo *view;

	newMatrixF cMat;
	newMatrixFPtr theMatPtr;
	view = &ag->windowView;
	
	theMatPtr = &(view->viewMatrix);
	centerX = view->cellCenter.h + (0.5 * (ag->win.worldRect.right - ag->win.worldRect.left));
	centerY = view->cellCenter.v+ (0.5 * (ag->win.worldRect.bottom - ag->win.worldRect.top));

	mag = view->magnification;
	
	getCramersOperatorsF(theMatPtr, &cMat);
	viewLen = view->perspective * mag;
	for (j= 0; j<=11 ;++j)
	{
	    floatVector startCorner;
	    floatVector endCorner;
	   
	         
		thisFrame->edgeValues[j] = 0;
		startCorner = gCubeVerticies[gCubeEdges[j].start];
		endCorner = gCubeVerticies[gCubeEdges[j].end];
		
 		lineBeginning.a = startCorner.a * trix->A.a +
 		                  startCorner.b * trix->B.a + 
 		                  startCorner.c * trix->C.a ;
 		lineBeginning.b = startCorner.a * trix->A.b + 
 		                  startCorner.b * trix->B.b +
 		                  startCorner.c * trix->C.b ;
 		lineBeginning.c = startCorner.a * trix->A.c +
 		    		      startCorner.b * trix->B.c +
 						  startCorner.c * trix->C.c ;
 		lineEnd.a = endCorner.a * trix->A.a +
 		            endCorner.b * trix->B.a + 
 		            endCorner.c * trix->C.a ;
 		lineEnd.b = endCorner.a * trix->A.b + 
 					endCorner.b * trix->B.b + 
 		            endCorner.c * trix->C.b ;
 		lineEnd.c = endCorner.a * trix->A.c +
 					endCorner.b * trix->B.c +
 					endCorner.c * trix->C.c ;

		for (k= 0; k<=5 ;++k)
		{
			float multFactorOne = ((float)k) / 5.0 ;
			float multFactorTwo = ((float)(5 - k)) / 5.0 ;
			multVector(&lineBeginning, multFactorOne, &linePointOne);
			multVector(&lineEnd, multFactorTwo, &linePointTwo);
			
			calcX = linePointOne.a + linePointTwo.a ; 
			calcY = linePointOne.b + linePointTwo.b ; 
			calcZ = linePointOne.c + linePointTwo.c ; 			

			graphA = ((float) (calcX * ( cMat.A.a ) +
							  calcY * ( cMat.A.b ) +
							  calcZ  * ( cMat.A.c ) ) * mag);
			
			graphB = ((float) (calcX * ( cMat.B.a ) +
						      calcY * ( cMat.B.b ) +
							  calcZ  * ( cMat.B.c ) ) * mag);
						
			graphC = ((float) (calcX * ( cMat.C.a ) +
							  calcY * ( cMat.C.b ) +
						  	  calcZ  * ( cMat.C.c ) ) * mag );
						  	  
			shortGraphA = (floatToShort(graphA));  // keeps them in range
			shortGraphB = (floatToShort(graphB));
			shortGraphC = (floatToShort(graphC));
			
			thisFrame->edgeValues[j] += graphC;

//			if (graphC  < viewLen)   // floatToShort handles nans
			{
				float aFloat, bFloat;
				depthFactor = (viewLen / (viewLen - graphC)); // floatToShort handles nans
				aFloat = - (graphB * depthFactor) + centerY;
				bFloat = (graphA * depthFactor) + centerX;
				thisFrame->edge[j].edgePoints[k].v = floatToShort (aFloat);
				thisFrame->edge[j].edgePoints[k].h = floatToShort (bFloat);
			}
		}
	}
}

void setLineOrder(short * lineValPtr, short * lineOrderPtr)  // sort by zval
{
	short i;
	for (i = 0;i<=11;++i)
	{
		lineOrderPtr[i] = i;
		checkLineOrder(i, lineOrderPtr, lineValPtr);
	}
}
void  checkLineOrder(short index, short * myPtr,short * lineValPtr)
{
	short temp;
	if (index > 0)
	{
		if (lineValPtr[myPtr[index]] < lineValPtr[myPtr[index-1]])
		{
			temp = myPtr[index];
			myPtr[index] = myPtr[index-1];
			myPtr[index-1] = temp;
			checkLineOrder((index-1), myPtr, lineValPtr);
		}
	}
}
void drawLines(cubeFrameData *thisFrame, short begin, short end) 
{
	int i, j;
	short whichEdge;
	LinePair *myPair;
	Point *myPoint;
	PenSize(2,2);
	PenPat(&(qd.dkGray));
	for (i = begin; i<=end; ++i)
	{
		whichEdge = thisFrame->edgeOrder[i];
		myPair = &(gCubeEdges[whichEdge]);  // retrieve the pair from the global list
		setColour(myPair->colour); 
		myPoint = &(thisFrame->edge[whichEdge].edgePoints[0]);
		MoveTo(myPoint->h, myPoint->v);
		for (j = 1; j <= 5 ; ++j)
		{
		   myPoint = &(thisFrame->edge[whichEdge].edgePoints[j]);
		   LineTo(myPoint->h, myPoint->v);		
		}
	}
	PenSize(1,1);
}
void  setForeColourNoShade(AGWindow *ag, grafData *thisPart)
{
	RGBForeColor (&(thisPart->colour)); 
}
void  setForeColourWithShade(AGWindow *ag, grafData *thisGrafPtr)
{
	RGBColor shadedColour;
	float range;
	float neutralDepth;
	float disp;
	float factor;
	
	neutralDepth = ag->windowView.neutralShadeDepth * ag->windowView.magnification;
	range = ag->windowView.shadeRange * ag->windowView.magnification;
	disp = thisGrafPtr->graphc - neutralDepth;
	shadedColour = thisGrafPtr->colour;
	if (disp > 0)
	{
		factor = erf(disp/range);
		shadedColour.red += (0xFFFF - thisGrafPtr->colour.red) * factor;
		shadedColour.blue +=(0xFFFF - thisGrafPtr->colour.blue) * factor;
		shadedColour.green +=(0xFFFF - thisGrafPtr->colour.green) * factor;
	}
	else if (disp < 0)
	{
		factor = erf(-disp/range);
		shadedColour.red -= (0xFFFF - thisGrafPtr->colour.red) * factor;
		shadedColour.blue -=(0xFFFF - thisGrafPtr->colour.blue) * factor;
		shadedColour.green -=(0xFFFF - thisGrafPtr->colour.green) * factor;
	}
	RGBForeColor (&shadedColour); 
}
void  drawContents(AGWindow *ag)
{
	long i, k;
	long count;
	long * listPtr;
	grafData *thisPart;
	grafData *thisGrafPtr;
	RGBColor blackRGB;
	thisGrafPtr = lockGrafData( ag);
	listPtr = lockList( &ag->orderList);
	
	PenMode (srcCopy);
	PenSize (1,1);
	blackRGB = getColour(myBlackColour);
	count = numItems(&ag->partList);
	if (ag->windowView.showBonds)
	{
		RGBForeColor (&blackRGB); 
		PenPat(&qd.black); 
		for (i= 0;  i<count ; ++i)
		{
			thisPart = &(thisGrafPtr[listPtr[i]]);
			if (thisPart->inWindow)
			{	
				for (k = 0; k< thisPart->howManyBackbonds;++k)
				{
					MoveTo(thisPart->backbondStart[k].h,thisPart->backbondStart[k].v);
					LineTo(thisPart->backbondEnd[k].h,thisPart->backbondEnd[k].v);
				}
				ag->setForeColour ( ag, thisPart); 
				
				if (!thisPart->selected)
				{
					PaintOval(&(thisPart->circle));
					RGBForeColor (&blackRGB); 
					FrameOval(&(thisPart->circle));
				}
				else
				{
					PenPat(&qd.gray); 
					PaintOval(&(thisPart->circle));
					PenPat(&qd.black); 
					PenSize (2,2);
					RGBForeColor (&blackRGB); 
					FrameOval(&(thisPart->circle));
					PenSize (1,1);
				}
				
				for (k = 0; k< thisPart->howManyForebonds;++k)
				{
					MoveTo(thisPart->forebondStart[k].h,thisPart->forebondStart[k].v);
					LineTo(thisPart->forebondEnd[k].h,thisPart->forebondEnd[k].v);
				}
			}
			else
			{
			}
		}
	}
	else // don't show bonds
	{
		PenPat(&qd.black); 
		for (i= 0; i<count ; ++i)
		{
			thisPart = &(thisGrafPtr[listPtr[i]]);
			if (thisPart->inWindow)
			{	
				ag->setForeColour (ag, thisPart); 
				if (!thisPart->selected)
				{
					
					PaintOval(&(thisPart->circle));
					RGBForeColor (&blackRGB); 
					FrameOval(&(thisPart->circle));
				}
				else
				{
					PenPat(&qd.gray); 
					PaintOval(&(thisPart->circle));
					PenPat(&qd.black); 
					PenSize (2,2);
					RGBForeColor (&blackRGB); 
					FrameOval(&(thisPart->circle));
					PenSize (1,1);
				}
			}
		}	
	}
	releaseGrafData( ag);
	releaseList( &ag->orderList);
}

void  findParticles(AGWindow *ag, particle *basePart)
{
	short centerX, centerY;
	short j,  realSize;
	long howManyParts;
	long *orderListPtr;
	long * partListPtr;
	grafData * theGrafPtr;
	grafData *thisGrafPtr;
	viewInfo *theView;
	Rect *vizRect;
	float graphA, graphB;
	float graphC, depthFactor;	
	float sizeFactor; // cellVec, halfCellVec;
	float calcX, calcY, calcZ;
	newMatrixF cMat;
	float mag, viewLen, partSize;
	
		
	theGrafPtr = lockGrafData( ag);
	orderListPtr = lockList( &ag->orderList);
	partListPtr = lockList( &ag->partList);
	howManyParts = numItems(&ag->partList);
	
	theView = &(ag->windowView);
	mag = theView->magnification;
	viewLen = theView->perspective * mag;
	centerX = theView->cellCenter.h + (0.5 * (ag->win.worldRect.right - ag->win.worldRect.left));
	centerY = theView->cellCenter.v+ (0.5 * (ag->win.worldRect.bottom - ag->win.worldRect.top));
	
	vizRect = &(ag->win.worldRect);

	getCramersOperatorsF(&(theView->viewMatrix), &cMat);
	multMatrixF(&cMat, mag, &cMat);
	
	for (j= 0; j<howManyParts ;++j)
	{
	      //  copy the order of the particles in the grafData structure to the partList
	      partListPtr[j] = theGrafPtr[orderListPtr[j]].index ;
	}
	for (j= 0; j<howManyParts ;++j)
	{
		Rect *thisCircle;
		particle * thisPart;
		thisPart =  &( basePart[partListPtr[j]]); 
		calcX = thisPart->position.a;
		calcY = thisPart->position.b;		
		calcZ = thisPart->position.c;
		thisGrafPtr = &(theGrafPtr[j]);
		thisGrafPtr->index = thisPart->label;
		thisCircle = &(thisGrafPtr->circle);
		
		graphC = ((float) (calcX * (cMat.C.a) +
						  calcY * (cMat.C.b) +
					  	  calcZ  * (cMat.C.c) ) );

		graphA = ((float) (calcX * (cMat.A.a) +
						  calcY * (cMat.A.b) +
						  calcZ  * (cMat.A.c) ) );
						  
		graphB = ((float) (calcX * (cMat.B.a) +
					      calcY *  (cMat.B.b ) +
						  calcZ  * (cMat.B.c ) ) );
						  
		depthFactor = viewLen / (viewLen - graphC);
		
//		thisGrafPtr->graphb = floatToShort (graphB);					
//		thisGrafPtr->graphc = floatToShort (graphC);		
//		thisGrafPtr->grapha = floatToShort (graphA);
 		thisGrafPtr->graphb =  graphB;					
 		thisGrafPtr->graphc =  graphC;		
 		thisGrafPtr->grapha =  graphA;
		
//		partSize = theView->particleSize;
 		partSize = ag->setMySize(ag->win.obj.container, theView, thisPart);
		sizeFactor = partSize * depthFactor;
		realSize = floatToShort(sizeFactor);
		sizeFactor *= 0.5;

		{
			thisCircle->left = centerX + (graphA  * depthFactor) - sizeFactor;
			thisCircle->right = thisCircle->left + realSize;
			thisCircle->top = centerY - (graphB * depthFactor) - sizeFactor;
			thisCircle->bottom = thisCircle->top  + realSize;
	
			if ((thisCircle->left > vizRect->right) ||
			    (thisCircle->right < vizRect->left) ||
			    (thisCircle->top > vizRect->bottom) ||
			    (thisCircle->bottom < vizRect->top) ||
			    ( !(depthFactor > 0)              )     )		
		           {		
		          	thisGrafPtr->inWindow = FALSE;
		           }
		           else 
		           {
		          	thisGrafPtr->inWindow = TRUE;	
		          	thisGrafPtr->selected = thisPart->selected;
		           }
	           }	
	}
	releaseGrafData( ag);
	releaseList( &ag->orderList);
	releaseList( &ag->partList);
}


void findBonds(AGWindow *ag, particle *part)
{
	long i, j, numberOfParts;
	grafData *theGrafPtr;
	grafData *thisGrafData;
	long *  orderListPtr;   // need to create a label table to do cross-referencing
	Ptr thisNNData;
	Ptr baseNNData;
	particle * thisPart;
	viewInfo *theView;
	newMatrixF cMat;
	NNInfoStructOffsets *offsets;
	short centerX, centerY;
  	float viewLen;
         float depthFactor;
	
	offsets = simGetNNDataOffsetsPtr(ag->win.obj.container) ; 
	
	orderListPtr = lockList(&ag->orderList);
	theGrafPtr = lockGrafData(ag);
	baseNNData = simLockNNData(ag->win.obj.container );  
	numberOfParts = numItems(&ag->partList);
	
	theView = &ag->windowView;
	centerX =  theView->cellCenter.h +(0.5 * (ag->win.worldRect.right - ag->win.worldRect.left));
	centerY = theView->cellCenter.v + (0.5 * (ag->win.worldRect.bottom - ag->win.worldRect.top));
	viewLen = theView->perspective * theView->magnification;
	getCramersOperatorsF(&theView->viewMatrix, &cMat);

	multMatrixF(&cMat, theView->magnification, &cMat);
	
	for (j= 0;  j<numberOfParts ;++j)  // j is index in theList
	{
		short howManyForebonds;
		short howManyBackbonds;
		Point *thisFStart;
		Point *thisFEnd;
		Point *thisBStart;
		Point *thisBEnd;
		NNDataPtrs nnd;
		floatVector centerVec, startVec, endVec, partVec, normBondVec;
		floatVector tStartVec, tEndVec;
		float bondLength, shortenBy;
		float thisSize, thatSize;
		
		thisGrafData = &( theGrafPtr[j]);
		
		if (!(thisGrafData->inWindow))
		{  
			thisGrafData->howManyForebonds = 0;
			thisGrafData->howManyBackbonds = 0;
		}
		else    // its in the window --  lets make the bonds
		{
			thisPart =  &( part[thisGrafData->index]);  // this part has the particleData
			thisBStart = thisGrafData->backbondStart;
			thisBEnd = thisGrafData->backbondEnd;
			thisFStart = thisGrafData->forebondStart;
			thisFEnd = thisGrafData->forebondEnd;
			partVec.a = thisPart->position.a;
			partVec.b = thisPart->position.b; // double to float
			partVec.c = thisPart->position.c;
			thisSize = ag->setMyActualSize(ag->win.obj.container, theView, thisPart);
			thisSize *= 0.5;
			cramersCoordsOfXYZPointF(&cMat, &partVec, &centerVec);
			
			//adjustForDepth(&centerVec, theView,  viewLen);  
			// view len calculated above
			depthFactor = viewLen / (viewLen - centerVec.c);		
			centerVec.a =  (centerVec.a * depthFactor) ;
 			centerVec.b =  (centerVec.b * depthFactor) ;


			howManyForebonds = 0;
			howManyBackbonds = 0;
			
		// centerVec IS THE SCREEN COORDS OF THE  PARTICLE from which the bonds are coming
			thisNNData = (Ptr) (baseNNData + offsets->recordSize * thisGrafData->index );
			getNndPtrs( thisNNData, offsets, &nnd);

			i = 0;
			while ((i<nnd.howManyNeighbors) && ((howManyForebonds < kMaxBonds) || (howManyBackbonds < kMaxBonds)) )
			{
				// strategy first, check screening != zero
				if (nnd.screenArray[i] >0)
				{
				// then find bond length.
					bondLength = nnd.sepArray[i];
						
					shortenBy = bondLength * 0.5;
					thatSize = ag->setMyActualSize(ag->win.obj.container, theView, &part[nnd.labelArray[i]]);
					thatSize *= 0.5;
			// adjust end bond to either half the separation, or by radius of neighbor, whichever longer
					if (thatSize > shortenBy) shortenBy = thatSize;
					
					bondLength = bondLength - shortenBy;
			// check that 
					if (bondLength > thisSize)
					{
						// adjust beginning of bond length by radius of part
						normBondVec.a = nnd.vecArray[i].a * nnd.invSepArray[i];
						normBondVec.b = nnd.vecArray[i].b * nnd.invSepArray[i];
						normBondVec.c = nnd.vecArray[i].c * nnd.invSepArray[i];
						// if length is positive, transform beginning and end points into points in graph space
						endVec.a = partVec.a + normBondVec.a * bondLength ;
						endVec.b = partVec.b + normBondVec.b * bondLength ;
						endVec.c = partVec.c + normBondVec.c * bondLength ;
						startVec.a = partVec.a + normBondVec.a * thisSize ;
						startVec.b = partVec.b + normBondVec.b * thisSize ;
						startVec.c = partVec.c + normBondVec.c * thisSize ;

						cramersCoordsOfXYZPointF(&cMat, &endVec, &tEndVec);

					//	adjustForDepth(&tEndVec,theView, viewLen);
					//  depth fac calculated above
 						tEndVec.a = (tEndVec.a * depthFactor) ;
 						tEndVec.b =  (tEndVec.b * depthFactor) ;

						cramersCoordsOfXYZPointF(&cMat, &startVec, &tStartVec);

					//	adjustForDepth(&tStartVec, theView, viewLen);
					//  depth fac calculated above
 						tStartVec.a = (tStartVec.a * depthFactor) ;
 						tStartVec.b = (tStartVec.b * depthFactor) ;

						// check if its a forebond or back bond
						if (tEndVec.c > tStartVec.c)
						{ // its a forebond
							if (howManyForebonds < kMaxBonds)
							{
								thisFStart[howManyForebonds].h = tStartVec.a + centerX;
								thisFStart[howManyForebonds].v =   centerY - tStartVec.b;
								thisFEnd[howManyForebonds].h = tEndVec.a + centerX;
								thisFEnd[howManyForebonds].v = centerY -  tEndVec.b ;
								++howManyForebonds;
							} else {}
						}
						else // its a backbond
						{
							if (howManyBackbonds < kMaxBonds)
							{
								thisBStart[howManyBackbonds].h = tStartVec.a + centerX;
								thisBStart[howManyBackbonds].v = centerY - tStartVec.b ;
								thisBEnd[howManyBackbonds].h = tEndVec.a + centerX;
								thisBEnd[howManyBackbonds].v = centerY -  tEndVec.b ;
								++howManyBackbonds;
							}
							else {}
						}
					} // end bond had positive length
				} // end screening was not 0
				++i;  // effective loop over i ( number of neighbors )
			}  // end while (loop over neighbors 
			thisGrafData->howManyForebonds = howManyForebonds;
			thisGrafData->howManyBackbonds = howManyBackbonds;
		}  // end of this part is in window
	}  // end of loop over number of parts in window
	releaseList(&ag->orderList);
	releaseGrafData( ag);
	simReleaseNNData( ag->win.obj.container);  
}
//void adjustForDepth(floatVecPtr centerVec, viewInfo *theView, float viewLen)
//{
//	float depthFactor;

//	depthFactor = viewLen / (viewLen - centerVec->c);		
//	centerVec->a = theView->cellCenter.h + (centerVec->a * depthFactor) ;
//	centerVec->b = theView->cellCenter.v - (centerVec->b * depthFactor) ;
//}

void  screenCoordsOfXYZPoint
		( viewInfo *theView, doubleVecPtr thePos, doubleVecPtr theCoords);
void  screenCoordsOfXYZPoint
		( viewInfo *theView, doubleVecPtr thePos, doubleVecPtr theCoords)
{
	short centerX, centerY;
	float depthFactor;	
	newMatrixF cMat;
	float mag, viewLen;

	mag = theView->magnification;
	viewLen = theView->perspective * mag;
	centerX = theView->cellCenter.h;
	centerY = theView->cellCenter.v;

	getCramersOperatorsF(&(theView->viewMatrix), &cMat);
	multMatrixF(&cMat, mag, &cMat);
	cramersCoordsOfXYZPoint(&cMat, thePos, theCoords);
						  
	depthFactor = viewLen / (viewLen - theCoords->c);
		
 	theCoords->a = centerX + (theCoords->a  * depthFactor) ;
	theCoords->b = centerY - (theCoords->b * depthFactor) ;
}


float setNoActualSize(AGPane *ag,viewInfo *theView, particle *thePart)
{
	return (5.0 / theView->magnification);
}

float setMyActualSizeByAtomType(AGPane *ag, viewInfo *theView, particle *thePart)
{
	float rad;
	kSanAtomtype *at;
	at = simGetNthAtomtype(owningSim, thePart->type);
	rad = at->specs.radius;
	return (rad  );
}

float setMyActualSizeByWindow(AGPane *ag,viewInfo *theView, particle *thePart)
{
	float rad;
	kSanAtomtype *at;
	at = simGetNthAtomtype(owningSim, thePart->type);
	rad = at->specs.radius;
	return (rad  * theView->particleSize );
}

float setNoSize(AGPane *ag,viewInfo *theView, particle *thePart)
{
	return (5.0);
}

float setMySizeByAtomType(AGPane *ag,,viewInfo *theView,particle *thePart)
{
	float rad;
	kSanAtomtype *at;
	at = simGetNthAtomtype(owningSim, thePart->type);
	rad = at->specs.radius;
	return (rad * theView->magnification);
}

float setMySizeByWindow(AGPane *ag,viewInfo *theView, particle *thePart)
{
	float rad;
	kSanAtomtype *at;
	at = simGetNthAtomtype(owningSim, thePart->type);
	rad = at->specs.radius;
	return (rad * theView->magnification * theView->particleSize);
}

