
#include "atomtypeColourPlugIn.h"

short initClassAtomTypeColourPlugIn (void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClassAtomTypeColourPlugIn, ClassColourPlugIn, 0L, "Colour by Atom Type");
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  AtomTypeColourPlugInConstructor,
		nilPointer, nilPointer, nilPointer, nilPointer,
		 nilPointer, nilPointer, nilPointer, nilPointer);
	}
	else
	{
		err = true;
	}
	return (err);
}
short  AtomTypeColourPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
#pragma unused (cma)
	short err = noErr;
	kSanColourPlugIn *api;
	api = KDSGetPrivateData(ds, ClassColourPlugIn );
	
 	api->colourOneParticle = colourOneParticleByAtomType;
	api->colourParticleList = setAllColoursByAtomType;
	api->colourPlugPrivateData = nilPointer;
	KDSReturnError(ds, err);
}
void setAllColoursByAtomType(  kSanColourPlugIn *api, kSanSimulation *sim, grafData *baseGrafData, long howMany)
{
#pragma unused(api)
	long j;
	particle *basePart;
	long partArrIndex;
	kSanAtomtype ** baseAT;
	grafData *thisGrafData;
	
	baseAT = simLockAtomTypes(sim);
	basePart = simLockParts (sim);
	
	for (j= 0; j< howMany ;++j)
	{
		thisGrafData = &(baseGrafData[j]);
		partArrIndex =  thisGrafData->index ;
		if (BPNthHighlighted(basePart, partArrIndex)  == kNotHighlighted) thisGrafData->colour = baseAT[BPNthType(basePart, partArrIndex)]->specs.colour;
		else thisGrafData->colour = getColour (highlightColour + BPNthHighlighted(basePart, partArrIndex));
	}
	simReleaseParts(sim);
	simReleaseAtomTypes(sim);
}

void colourOneParticleByAtomType(  kSanColourPlugIn *api, kSanSimulation *sim, grafData *thisGrafData)
{
#pragma unused(api)
	particle *basePart;
 	long partArrIndex;
	kSanAtomtype ** baseAT;
	
	basePart = simLockParts(sim);
	partArrIndex =  thisGrafData->index ;

	if (BPNthHighlighted(basePart, partArrIndex) == kNotHighlighted) 
	{
		baseAT = simLockAtomTypes(sim);
		thisGrafData->colour = baseAT[BPNthType(basePart, partArrIndex)]->specs.colour;
		simReleaseAtomTypes(sim);
	}
	else 
	{
		thisGrafData->colour = getColour (highlightColour + BPNthHighlighted(basePart, partArrIndex));
	}

	simReleaseParts(sim);
}



