
#include "GroupColourPlugIn.h"

short  GroupColourPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma);
//short  GroupColourPlugInDestructor (KozoDispatchStack *ds, destructorMethodArgs* dma);
//short  GroupColourPlugInGetData (KozoDispatchStack *ds, getMethodArgs *gma);
//short  GroupColourPlugInSetData (KozoDispatchStack *ds, setMethodArgs *sma);
//short  GroupColourPlugInDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma);

short initClassGroupColourPlugIn (void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClassGroupColourPlugIn, ClassColourPlugIn, 0L, "Colour by Group");
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  GroupColourPlugInConstructor,
		nilPointer, nilPointer, nilPointer, nilPointer,
		 nilPointer, nilPointer, nilPointer, nilPointer);
	}
	return (err);
}
short  GroupColourPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
#pragma unused (cma)
	short err = noErr;
	kSanColourPlugIn *api;
 	api = KDSGetPrivateData(ds, ClassColourPlugIn );
	
 	api->colourOneParticle = colourOneParticleByGroup;
	api->colourParticleList = setAllColoursByGroup;
 
	KDSReturnError(ds, err);
}

void setAllColoursByGroup( kSanColourPlugIn *api,  kSanSimulation *sim, grafData *baseGrafData, long howMany)
{
#pragma unused(api)
	long j;
	long partArrIndex;
	particle *basePart;
 	kSanGroup ** baseGroup;
	grafData *thisGrafData;
	
	baseGroup = simLockGroups(sim);
	basePart = simLockParts(sim);
	
	for (j= 0; j< howMany ;++j)
	{
		thisGrafData = &(baseGrafData[j]);
 		partArrIndex =  thisGrafData->index ;
		if (BPNthHighlighted(basePart, partArrIndex) == kNotHighlighted) thisGrafData->colour = baseGroup[BPNthGroup(basePart, partArrIndex)]->colour;
		else thisGrafData->colour = getColour (highlightColour + BPNthHighlighted(basePart, partArrIndex));
	}
	simReleaseParts(sim);
	simReleaseGroups(sim);
}

void colourOneParticleByGroup(  kSanColourPlugIn *api, kSanSimulation *sim, grafData *thisGrafData)
{
#pragma unused(api)
	particle *basePart;
	long partArrIndex;
	kSanGroup ** baseGroup;
	
	basePart = simLockParts(sim);
	partArrIndex =  thisGrafData->index ;
	if (BPNthHighlighted(basePart, partArrIndex) == kNotHighlighted) 
	{
		baseGroup = simLockGroups(sim);
		thisGrafData->colour = baseGroup[BPNthGroup(basePart, partArrIndex)]->colour;
		simReleaseGroups(sim);
	}
	else 
	{
		thisGrafData->colour = getColour (highlightColour + BPNthHighlighted(basePart, partArrIndex));
	}

	simReleaseParts(sim);
}



