
#include "PEColourPlugIn.h"
 short updateInverseRange (kozoObject *obj, PEColourPlugIn *pecpi) ;
short  PEColourReset(kozoObject *obj,  PEColourPlugIn *pecpi);

short initClassPEColourPlugIn (void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClassPEColourPlugIn, ClassColourPlugIn, sizeof (PEColourPlugIn), "Colour by Potential");
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  PEColourPlugInConstructor,
		nilPointer, PEColourPlugInGetData, PEColourPlugInSetData, PEColourPlugInDoMessage,
		 nilPointer, nilPointer, nilPointer, nilPointer);
	}
	return (err);
}
short  PEColourPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
	short err = noErr;
	PEColourPlugIn *pecpi;
 	kSanColourPlugIn *cpi;
 	cpi = KDSGetPrivateData(ds, ClassColourPlugIn );
 	pecpi 	  = KDSGetPrivateData(ds, ClassPEColourPlugIn );

 	pecpi->maxPE = 0;
	pecpi->minPE = -5;
	err = dispatchLoop(ds, cma);
	cpi->colourPlugPrivateData = (void *)pecpi;
	 cpi->colourOneParticle = colourOneParticleByPE;
	 cpi->colourParticleList = setAllColoursByPE;
	updateInverseRange (ds->obj, pecpi) ;
	KDSReturnError(ds,err);
}
short  PEColourPlugInGetData (KozoDispatchStack *ds, getMethodArgs *gma)
{
	short err = noErr;
	PEColourPlugIn *pecpi;
	pecpi 	  = KDSGetPrivateData(ds, ClassPEColourPlugIn );
	switch (gma->property)
	{
		case pMaximumColour:
			AECreateDesc(typeShortFloat, (Ptr) &pecpi->maxPE, sizeof(float), gma->result);
			break;
		case pMinimumColour:
			AECreateDesc(typeShortFloat, (Ptr) &pecpi->minPE, sizeof(float), gma->result);
			break;
		default:
			KDSReturnContinue(ds);
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}
short  PEColourPlugInSetData (KozoDispatchStack *ds, setMethodArgs *sma)
{
	short err = noErr;
	float val;
	PEColourPlugIn *pecpi;
	pecpi 	  = KDSGetPrivateData(ds, ClassPEColourPlugIn );
	switch (sma->property)
	{
		case pMaximumColour:
			err = OHCoerceToFloat(sma->data, &val);
			if (!err) pecpi->maxPE = val;
			updateInverseRange (ds->obj, pecpi) ;
			break;
		case pMinimumColour:
			err = OHCoerceToFloat(sma->data, &val);
			if (!err) pecpi->minPE = val;
			updateInverseRange (ds->obj, pecpi) ;
			break;
		default:
			KDSReturnContinue(ds);
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}
short  PEColourPlugInDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma)
{
	short err = noErr;
	PEColourPlugIn *pecpi;
	pecpi 	  = KDSGetPrivateData(ds, ClassPEColourPlugIn );
	switch (dmma->message)
	{
		case kAEReset :
			err = PEColourReset (ds->obj, pecpi) ;
			break;
		default :
			KDSReturnContinue(ds);
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}

void setAllColoursByPE(  kSanColourPlugIn *api, kSanSimulation *sim, grafData *baseGrafData, long howMany)
{
	long j;
	particle *basePart;
	particle *thisPart;	
	grafData *thisGrafData;
	PEColourPlugIn *pecpi = (PEColourPlugIn *) api->colourPlugPrivateData;
	
	basePart = simLockParts (sim);
	
	for (j= 0; j< howMany ;++j)
	{
		thisGrafData = &(baseGrafData[j]);
		thisPart = &basePart[thisGrafData->index];
		if (thisPart->highlighted == kNotHighlighted) getPEColour (pecpi, thisPart->potential,  &thisGrafData->colour);
		else thisGrafData->colour = getColour (highlightColour + thisPart->highlighted);
	}
	simReleaseParts(sim);
}

void colourOneParticleByPE(  kSanColourPlugIn *api, kSanSimulation *sim, grafData *thisGrafData)
{
	particle *basePart;
	particle *thisPart;	
	PEColourPlugIn *pecpi = (PEColourPlugIn *) api->colourPlugPrivateData;
	
	basePart = simLockParts (sim);
	thisPart = &basePart[thisGrafData->index];

	if (thisPart->highlighted == kNotHighlighted) 
	{
		getPEColour (pecpi, thisPart->potential,  &thisGrafData->colour);
	}
	else 
	{
		thisGrafData->colour = getColour (highlightColour + thisPart->highlighted);
	}

	simReleaseParts(sim);
}

void getPEColour (PEColourPlugIn *pecpi, double energy, RGBColor *rgb)
{
	float val;
	if (energy >= pecpi->maxPE) val = 1;
	else if (energy <= pecpi->minPE) val = 0;
	else
	{
		val = (energy - pecpi->minPE) * pecpi->inverseRange;
	}
	getTemperatureColour(val, rgb);
}
short updateInverseRange (kozoObject *obj, PEColourPlugIn *pecpi) 
{
#pragma unused(obj)
	short err = 0;
	pecpi->inverseRange = 1.0  / (pecpi->maxPE - pecpi->minPE);
	return (noErr);
}

short  PEColourReset(kozoObject *obj,  PEColourPlugIn *pecpi)
{
	short err = noErr;
	AEDesc minDesc = {typeNull, nilPointer};
	AEDesc maxDesc = {typeNull, nilPointer};
	kSanSimulation *sim = nilPointer;
	
	err =  kozoObjectGetObjectInHierarchy(obj->container, ClassSimulation , nilPointer, (void **)&sim);
	//err = dispatchMessageReport ( obj ,  ClassColourPlugIn, kGetSimulationPtrMessage, typeSimulationPtrPtr,  &sim);
	if (!err)
	{
		err =  simGetParticlePropertyMinMax (sim,  pPotentialEnergy, &minDesc, &maxDesc);
		if (!err) 
		{
			OHCoerceToFloat (&minDesc, &pecpi->minPE);
			OHCoerceToFloat (&maxDesc, &pecpi->maxPE);
			updateInverseRange (obj, pecpi) ;
		}
		AEDisposeDesc (&minDesc);
		AEDisposeDesc (&maxDesc);
	}
	return(err);
}

