#include "kSanObjects.h"
#include "kSanApplication.h"
#include "kSanSimulation.h"
#include "kSanAEHandlers.h"
#include "OHToken.h"
#include "kSanAECallbacks.h"
short	createElementAGWindow(DescType theClass,  kozoObject *container,  AEDesc *propDesc, AEDesc *newObj);

short getkSanTokenData( AEDesc *token, AEDesc *reply);
short getParticleData( AEDesc *token, AEDesc *reply);
short getParticleSelfSpecifier( AEDesc *token, AEDesc *reply);
short getTokenListData ( AEDesc *token, AEDesc *replyData );
short setTokenData( AEDesc *token, AEDesc *dataDesc );
short setTokenListData ( AEDesc *token, AEDesc *dataDesc );
short setParticleData ( AEDesc *token, AEDesc *dataDesc );
short setPlugInData ( AEDesc *token, AEDesc *dataDesc );
short setkSanTokenData( AEDesc *token, AEDesc *dataDesc);
short packagePlugInObjectSpec( AEDesc *token, AEDesc *reply);
short redrawToken( AEDesc *token);
short	startToken( AEDesc *token, AEDesc *fileDesc, AEDesc *replyDesc);
short	startTokenList( AEDesc *tokenList, AEDesc *fileList, AEDesc *replyDesc);

short strainTokenList(AEDesc *token, long typeOfStrain, double theValue);
short strainToken(AEDesc *token, long typeOfStrain, double theValue);
short iterateTokenList(AEDesc *token, long iters);
short iterateToken(AEDesc *token, long iters);
short	saveATokenList( AEDesc *tokenList);
short	saveAToken( AEDesc *aToken);


short	processTokenList( AEDesc *tokenList, short (*aFunc) (AEDesc *token));
short	stopToken( AEDesc *token);
short  getDefaultInsertionLocation( AEDesc *locObj );
short	createElementkozoObject(DescType theClass,  kozoObject *container,  AEDesc *propDesc, AEDesc *newObj);
short	createElementParticle( AppleEvent *event, kozoObject  *theContainer, AEDesc *propDesc, AEDesc *newObj);

short kSanResolve( AEDesc *theTarget, AEDesc *theToken)
{
	short err = noErr;
	if (theTarget->descriptorType == typeObjectSpecifier)
	{
		err = AEResolve(theTarget, kAEIDoWhose, theToken);	
	}
	else if (theTarget->descriptorType == typeAEList)
	{
		long count;
		long i;
		AEKeyword aKeyword;
		AEDesc nthDesc = {typeNull, nilPointer};
		AEDesc nthToken = {typeNull, nilPointer};
		err = AECountItems(theTarget, &count);
		if (!err)
		{
			if (count == 1)
			{
				err = AEGetNthDesc(theTarget, 1, typeWildCard, &aKeyword, &nthDesc);
				if (!err) err = kSanResolve(&nthDesc, theToken);
				AEDisposeDesc(&nthDesc);
			}
			else if (count > 1)
			{
				err = AECreateList(nilPointer, 0, false, theToken);
				for (i=1; i<=count ; ++i)
				{
					if (!err) err = AEGetNthDesc(theTarget, i, typeWildCard, &aKeyword, &nthDesc);
					if (!err) err = kSanResolve(&nthDesc, &nthToken);
					if (!err) err = AEPutDesc(theToken, 0, &nthToken);
					AEDisposeDesc(&nthToken);
					AEDisposeDesc(&nthDesc);
				}
			}
			else
			{
				err = errAEWrongDataType;
			}
		}
	}
	
	return (err);
}

short	saveATokenList( AEDesc *tokenList)
{
	short	err = noErr;
	short i;
	long count;
	AEKeyword aKeyword;
	AEDesc nthToken = {typeNull, nilPointer};
	AECountItems (tokenList, &count);
	if (count >= 1)
	{
		for (i=1; i<=count ; ++i)
		{
			err = AEGetNthDesc(tokenList, 1, typeWildCard, &aKeyword, &nthToken);
			if (!err) saveAToken(&nthToken);
			AEDisposeDesc(&nthToken);
		}
	}
	return (err);
}

short	saveAToken( AEDesc *aToken)
{
	short	err = noErr;
// cant process a list of windows
	if (aToken->descriptorType == typeAEList) // must be a movie frame
	{
		saveATokenList (aToken);
	}
	if (aToken->descriptorType == ClassProperty) // must be a movie frame
	{
		kSanPropertyToken    myToken;	
		myToken = (*(kSanPropertyToken *)*aToken->dataHandle);
		if (myToken.propCode == pMovieFrame)
		 err = WinSaveMovieFrame((kSanWindow *)myToken.objPtr); 
		 // else if ... other classes
	}
	else if  (aToken->descriptorType == ClassSimulation)
	{
		// save a doc
	}
	else if  (aToken->descriptorType == ClassWindow)
	{
		// save a pict
	}
	return (err);
}

pascal OSErr		DoSaveEvent( AppleEvent *event, AppleEvent *reply, long refcon )
{
	OSErr 			err;
	AEDesc			target = {typeNull, NULL}, 
					token = {typeNull, NULL};
	err = AEGetParamDesc(event, keyDirectObject, typeWildCard, &target);
// try typeWildCard instead and then test for if its a list or not!

	if (!err ) err = kSanResolve(&target,&token);	
	if (!err) saveAToken(&token);
	AEDisposeDesc( &target );
	AEDisposeDesc( &token );

	return ( err );
}
short getkSanTokenData( AEDesc *token, AEDesc *reply)
{
	short err = noErr;
	kSanPropertyToken myToken;
	myToken = (*(kSanPropertyToken *) (*token->dataHandle));
	err = callGetData((kozoObject *)myToken.objPtr, myToken.propCode,  reply);
	return (err);
}

short getParticleSelfSpecifier( AEDesc *token, AEDesc *reply)
{
	short err = noErr;
	long i;
	long count;
	kSanParticleToken *partToken;
	partToken = (*(kSanParticleToken **) *token->dataHandle);
	count = numItems(&partToken->partList);
	if (count == 1)
	{
		err =   ParticleMakeObjSpecifier((kSanSimulation *)partToken->owningSim,  getNthItem(&partToken->partList,0) - 1,  reply);
	}   // minus 1 because we are calling a kernel function
	else if (count > 1)
	{
		AEDesc  nthReplyData = {typeNull, NULL};
		err = AECreateList(nilPointer, nilPointer, false, reply);
		for (i = 0; ((i< count) && (!err)); ++i)
		{
			err =   ParticleMakeObjSpecifier((kSanSimulation *)partToken->owningSim, getNthItem(&partToken->partList,i) - 1, &nthReplyData);
			if (!err)    // minus 1 because we are calling a kernel function
			{
				err = AEPutDesc(reply, 0, &nthReplyData);
				AEDisposeDesc( &nthReplyData );	
			}	
		}
	}

	return (err);
}

pascal OSErr DoCreateElementEvent( AppleEvent *event, AppleEvent *reply, long refcon )
{
	OSErr  err = noErr;
	long positionEnum = kAEEnd;
	AEDesc target = {typeNull, NULL};
	AEDesc retDesc = {typeNull, NULL};
	AEDesc locDesc = {typeNull, NULL};
	AEDesc locObj = {typeNull, NULL};
	AEDesc propDesc = {typeNull, NULL};
	kozoObject  *theContainer;
	
	DescType typeOfNewObject;
			
 	err = AEGetParamDesc(event, keyClassParameter, typeType, &target);
 	if (err ) goto CLEANUP;
  	err = AEGetParamDesc(event, keyAEPropData, typeWildCard, &propDesc);
  	if (err == errAEDescNotFound) err = noErr;
 	if (err)  goto CLEANUP;

  	typeOfNewObject = *(DescType *)(*target.dataHandle);
	
 	if (!err)
 	{
		switch (typeOfNewObject)
		{
			case ClassSimulation:
				theContainer = appObj;
				break;   // no need to get insertion location
			case ClassAtomType:
			case ClassParticleGroup:
			case ClassParticle:
			case ClassWindow:
				err = AEGetParamDesc(event, keyAEInsertHere, typeWildCard, &locDesc);
			          if (!err) err = resolveInsertionLocation( &locDesc, &locObj, &positionEnum);
			          if (!err) err = resolveSingleObjSpec (&locObj, (long *)&theContainer);
				else  err = getDefaultInsertionLocation(&locObj);
				break;   // no need to get insertion location
		}
	} 		
	if (err) goto CLEANUP;
	switch (typeOfNewObject)
	{
		case ClassSimulation:
		case ClassParticleGroup:
		case ClassAtomType:
			err = createElementkozoObject(typeOfNewObject, theContainer, &propDesc, &retDesc);
			break;
		case ClassWindow:
			err = createElementAGWindow(ClassAGWindow, theContainer, &propDesc, &retDesc);
			break;
		case ClassParticle:
			err = createElementParticle(event, theContainer, &propDesc, &retDesc);
			break;
	}
//	if (positionEnum != kAEEnd) 
//	{
//		long newIndex;
//		err = resolveIndexEnumeration(positionEnum, theContainer
//		setIndexOfContainedObject(theContainer, newObject, newIndex);
//	}
	if (!err) err = AEPutParamDesc(reply, keyAEResult, &retDesc);

	CLEANUP:
	return (err);
}
short	createElementParticle( AppleEvent *event, kozoObject  *theContainer, AEDesc *propDesc, AEDesc *newObj)
{
	short	err = noErr;
	char isSelected = false;
	long typeIndex;
	long newIndex;
	short gpIndex;
	doubleVector pos;
	kSanAtomtype *at;
	AEDesc boolDesc = {typeNull, nilPointer};
	AEDesc atToken = {typeNull, nilPointer};
	AEDesc coordsDesc = {typeNull, nilPointer};
	AEDesc atomTypeDesc = {typeNull, nilPointer};
	kSanSimulation  *sim;
// get group and sim
	if (theContainer->oClass == ClassParticleGroup)
	{
		sim = (kSanSimulation  *)theContainer->container;
		gpIndex = whichItem(&sim->groups, (long) theContainer);
	}
	else if (theContainer->oClass == ClassSimulation)
	{
		sim = (kSanSimulation  *)theContainer;
		gpIndex = 1;
	}
	else err = true;
// get the coords
	if (!err) err =  AEGetParamDesc(event, keyMyCoords, typeAEList, &coordsDesc);
	if (err) err = AEGetParamDesc(event, pPosition, typeAEList, &coordsDesc);
	if (!err)  err = kSanCoerceToVectorD(&coordsDesc, (double *)&pos);
// get the type
	if (!err)
	{
		err = AEGetParamDesc(propDesc, pType, typeWildCard, &atomTypeDesc);
		if (err) 
		{
			typeIndex = 1;
			err = noErr;
		}
		else
		{
			if (atomTypeDesc.descriptorType == typeObjectSpecifier)
			{
				err = AEResolve(&atomTypeDesc, kAEIDoMinimum,  &atToken);
				if (!err) at = (*(kSanAtomtype **)(atToken.dataHandle));
				if (!err) typeIndex = whichItem(&sim->atList, (long)at);
			}
			else if (atomTypeDesc.descriptorType == typeChar)
			{
				at = atomtypeGetRefFromName(atomTypeDesc.dataHandle);
				if (at == nilPointer) err = true;
				else typeIndex = whichItem(&sim->atList, (long)at);
			}
			else
			{
				err = kSanCoerceToLong(&atomTypeDesc, &typeIndex);
			}
		}
	}
// get selected
	if (!err)
	{
		err = AEGetParamDesc(propDesc, pSelected, typeBoolean, &boolDesc);
		if (err) 
		{
			isSelected = false;
			err = false;
		}
		else
		{
			isSelected = (*(char *)(*boolDesc.dataHandle));
		}
	}
	if (!err)  newIndex = addParticle(sim, &pos,typeIndex  , gpIndex - 1, isSelected);
	if (newIndex != -1) ParticleMakeObjSpecifier(sim, newIndex,  newObj);
	AEDisposeDesc(&boolDesc);
	AEDisposeDesc(&atToken);
	AEDisposeDesc(&coordsDesc);
	AEDisposeDesc(&atomTypeDesc);

	return (err);
}


short strainTokenList(AEDesc *tokenList, long typeOfStrain, double theValue)
{
	short  err = noErr;
	short i;
	long count;
	AEKeyword aKeyword;
	AEDesc nthToken = {typeNull, nilPointer};
	AECountItems (tokenList, &count);
	if (count >= 1)
	{
		for (i=1; i<=count ; ++i)
		{
			if (!err) err = AEGetNthDesc(tokenList, i, typeObjectSpecifier, &aKeyword, &nthToken);
			if (!err) strainToken(&nthToken, typeOfStrain,  theValue);
			AEDisposeDesc(&nthToken);
		}
	}
	return err;
}								
short strainToken(AEDesc *token, long typeOfStrain, double theValue)
{
	short  err = noErr;
	AEDesc reply = {typeNull, nilPointer};
	kSanPropertyToken propToken;
	kSanSimulation *sim;
	switch (token->descriptorType)
	{
		default :
			err = errAEWrongDataType;
			break;
		case typeAEList:
			strainTokenList (token, typeOfStrain, theValue);
			break;
		case ClassProperty:
			propToken = (*(kSanPropertyToken *) (*token->dataHandle));
			sim = (kSanSimulation *)propToken.objPtr;
			switch (typeOfStrain)
			{
				case keyAEData:  // an absolute strain
					switch (propToken.propCode)
					{
						case pCellXLength:									
							theValue = theValue / sim->simCell.cellEdges.a;	
							break;
						case pCellYLength:
							theValue = theValue / sim->simCell.cellEdges.b;	
							break;
						case pCellZLength:
							theValue = theValue / sim->simCell.cellEdges.c;	
							break;
						case pCellXYZLength:
						default:	
							err= errAEEventNotHandled;
							break;
			    		}	
			    		err = scaleAxis(sim, propToken.propCode, &theValue);	
					break;
				case keyFractionalStrain:
					err = scaleAxis(sim,pCellXYZUniform, &theValue);
					break;		
			}
			break;
	}	
	return ( err );
}						
pascal OSErr DoStrainEvent( AppleEvent *event, AppleEvent *reply, long refcon )
{
	OSErr 			err;
	AEDesc			target = {typeNull, NULL},
					token = {typeNull, NULL},
					data = {typeNull, NULL};
	long typeOfStrain = keyFractionalStrain;
	double theValue;
		
	err = AEGetParamDesc(event, keyDirectObject, typeObjectSpecifier, &target);
	
	if (!err) err = kSanResolve(&target,  &token);	// Resolve ospec.
	
	if (!err)  err = AEGetParamDesc( event, keyAEData, typeLongFloat, &data );
	if (!err) typeOfStrain = keyAEData;
	else  
	{
		err = AEGetParamDesc( event, keyFractionalStrain, typeLongFloat, &data );
		if (!err)  typeOfStrain = keyFractionalStrain;
	}
	if (!err)  kSanCoerceToDouble(&data, &theValue);
	if (!err)  err = strainToken(&token, typeOfStrain,  theValue);
		

	  AEDisposeDesc( &target );
	  AEDisposeDesc( &token );
	  AEDisposeDesc( &data );
	return err;
}								
								
/****************** DoIterateEvent ***********************/
short iterateTokenList(AEDesc *tokenList, long iters)
{
	short  err = noErr;
	short i;
	long count;
	AEKeyword aKeyword;
	AEDesc nthToken = {typeNull, nilPointer};
	AECountItems (tokenList, &count);
	if (count >= 1)
	{
		for (i=1; i<=count ; ++i)
		{
			if (!err) err = AEGetNthDesc(tokenList, i, typeObjectSpecifier, &aKeyword, &nthToken);
			if (!err) iterateToken(&nthToken, iters);
			AEDisposeDesc(&nthToken);
		}
	}
	return err;
}								
								
short iterateToken(AEDesc *token, long iters)
{
	short  err = noErr;
	AEDesc reply = {typeNull, nilPointer};
	switch (token->descriptorType)
	{
		case typeAEList:
			iterateTokenList (token, iters);
			break;
		case ClassSimulation:
			{
				kSanSimulation *sim;
				long targetIters;
				sim = (*(kSanSimulation **)(*token->dataHandle));
				targetIters = sim->totalNumberOfIterations + iters;
				simSetClockRunning(&sim->obj, true, targetIters);
				while ((sim->totalNumberOfIterations < targetIters) && (!err))
				{
					err = doProgressFunction();
					if ((sim->flags.clockRunning == false) && (!sim->totalNumberOfIterations >= targetIters))  err = true;
				}
			}
			break;
	}
	return ( err );
}						
pascal OSErr		DoIterateEvent( AppleEvent *event, AppleEvent *reply, long refcon )
{

	OSErr 			err;
	AEDesc			target = {typeNull, NULL};
	AEDesc			itersDesc = {typeNull, NULL};
	AEDesc			token = {typeNull, NULL};
	long iters;
	err = AEGetParamDesc(event, keyDirectObject, typeWildCard, &target);
// try typeWildCard instead and then test for if its a list or not!

	if (!err ) err = kSanResolve(&target,&token);	
	
	if (!err)
	{
		err = AEGetParamDesc(event, keyIterationParameter, typeLongInteger, &itersDesc);
		
		if (err) 
		{
			iters = 1;
			err = noErr;
		}
		else
		{
			iters = (*(long *)(*itersDesc.dataHandle));
		}
	}
	if (!err) err = iterateToken(&token, iters);
	AEDisposeDesc( &target );
	AEDisposeDesc( &token );
	AEDisposeDesc( &itersDesc );

	return (err);
}
short	processTokenList( AEDesc *tokenList, short (*aFunc) (AEDesc *token))
{
	short	err = noErr;
	short i;
	long count;
	AEKeyword aKeyword;
	AEDesc nthToken = {typeNull, nilPointer};
	AECountItems (tokenList, &count);
	if (count >= 1)
	{
		for (i=1; i<=count ; ++i)
		{
			err = AEGetNthDesc(tokenList, i, typeWildCard, &aKeyword, &nthToken);
			if (!err) aFunc(&nthToken);
			AEDisposeDesc(&nthToken);
		}
	}
	return (err);
}
