#include <Sound.h>
#include "kSanAGPane.h"
#include "MacOSUtils.h"
char getCharFromNudgeItem(short theItem);
char getCharFromRollItem(short theItem);
void	AGPaneHandleRollChoice	(AGPane *ag, short item)
{
	short selectedOnly;
	short timesFive;
	char aChar;
	
	selectedOnly = keyIsPressed(kOptionKeyCode);
	timesFive = keyIsPressed(kShiftKeyCode);
	switch(item)
	{
		case iRollUp:
		case iRollDown:
		case iRollRight:
		case iRollLeft:
		case iRollClockwise:
		case iRollCClockwise:
			aChar = getCharFromRollItem(item);
			AGPaneKeypadRotate(ag, aChar, timesFive);
			break;
	}
}
void	AGPaneHandlePushChoice	(AGPane *ag, short item)
{
	short selectedOnly;
	short timesFive;
	char aChar;
	
	selectedOnly = keyIsPressed(kOptionKeyCode);
	timesFive = keyIsPressed(kShiftKeyCode);
	switch(item)
	{
		case iRollUp:
		case iRollDown:
		case iRollRight:
		case iRollLeft:
		case iRollClockwise:
		case iRollCClockwise:
			aChar = getCharFromNudgeItem(item);
			AGPaneArrowMove(ag, aChar, timesFive, selectedOnly);
			break;
	}
}

void 	AGPaneKeypadRotate (AGPane *ag, char myKeyCode, short timesFive)
{
	float latAngle;	
	float longAngle;
	float spinAngle;
	float multFactor = 1.0;
		
	if (timesFive) multFactor*= 5.0;
	getAngles(ag, myKeyCode,&latAngle, &longAngle, &spinAngle);	
	SpinMatrixInDegrees(&(ag->windowView.viewMatrix), latAngle*multFactor, longAngle*multFactor, spinAngle*multFactor);
}
void 	AGPaneArrowMove  (AGPane *ag, char myKeyCode, short timesFive, short selectedOnly)
{
	floatVector wVec;
	float multFactor = 1.0;
	
	zeroVectorF(&wVec);
	if (timesFive) multFactor *= 5.0;
	switch (myKeyCode)
	{		
		case leftArrowKeyCode:
			wVec.a = -1*(ag->manip.horizShift) * multFactor;
			break;					

		case rightArrowKeyCode:		
			wVec.a = (ag->manip.horizShift)* multFactor;
			break;			
							
		case upArrowKeyCode:		
			wVec.b = ag->manip.vertShift* multFactor;
			break;
			
		case downArrowKeyCode:		
			wVec.b = -1*(ag->manip.vertShift)* multFactor;
			break;

		case '[':		
			wVec.c = -1*(ag->manip.hikiShift)* multFactor;
			break;

		case ']':		
			wVec.c = ag->manip.hikiShift* multFactor;
			break;
	}	
	{
		floatVector translationVec;
		vecDotMatrixF(&wVec, &ag->windowView.viewMatrix, &translationVec);
		translateParticles (ag->sim, &translationVec, selectedOnly);	
	}			
}

short AGPaneDoClick ( OHView*view, EventRecord *eventPtr, Point offset)
{
	EventRecord theNextEvent;
	AGPane *ag;
	short mouseStillDown = true;
	short wasADoubleClick = false;
	short done = false;
	ag = (AGPane *)view;
	if (ag->mode == kSelectAndHighlight)
	{
		while ((TickCount() < (eventPtr->when + GetDblTime())) && (!done))
		{
			GetNextEvent((mDownMask | mUpMask), &theNextEvent);
			if (theNextEvent.what == mouseUp) mouseStillDown = FALSE;
			else if (theNextEvent.what == mouseDown)  
			{
				wasADoubleClick = TRUE;	
				done = true;
			}
		}
	         AGPaneSelectHighlightClick(ag, eventPtr, offset, mouseStillDown, wasADoubleClick);
	}
	else 
	{
		AGPaneDragRotate(ag, eventPtr->where, offset);
	}
	return (noErr);
}
void AGPaneSelectHighlightClick (AGPane *ag, EventRecord *eventPtr, Point offset, short mouseStillDown, short wasADoubleClick)				
{
	short isHigh;
	short clickWasInParticle;
	short wasSelected;
	short shiftKeyDown;
	short optionKeyDown;
	long whichParticle;
	
	shiftKeyDown =((eventPtr->modifiers & shiftKey) != 0);
	optionKeyDown = ((eventPtr->modifiers & optionKey) != 0);

	clickWasInParticle = AGPaneWasClickInParticle(ag, eventPtr->where,  &whichParticle);
	if (clickWasInParticle)
	{
		wasSelected = getParticleSelected(ag->sim, whichParticle);
		if  (wasADoubleClick)
		{
			doParticleDialog(ag->sim, whichParticle);
		}
		else if (optionKeyDown)
		{
			isHigh = getParticleHighlighted(ag->sim, whichParticle);
			setParticleHighlighted(ag->sim, whichParticle, (isHigh == kNotHighlighted));
			callDoMessage((kozoObject *)ag, kInvalWorldMessage, 0L);
		}
		else if (!shiftKeyDown && !wasSelected)
		{
			eraseSelections(ag->sim); // simulation method
			setParticleSelected(ag->sim, whichParticle, true);
			AGPaneDragMove(ag, eventPtr, offset) ; 
			setSimSelectionsMenuItems(ag->sim);
		}
		else 
		{
			if (mouseStillDown && wasSelected)
			{
			}
			else
			{
				isHigh = getParticleHighlighted(ag->sim, whichParticle);
				setParticleHighlighted(ag->sim, whichParticle, (!isHigh));
				setSimSelectionsMenuItems(ag->sim);
			}
			AGPaneDragMove(ag, eventPtr, offset);								
		}
	}
	else if (mouseStillDown)
	{
		AGPaneDragSelect(ag, eventPtr->where, offset, shiftKeyDown);
	}
	else  // avoid nested elses
	{
		eraseSelections(ag->sim); // simulation method
	}
}	
void AGPaneDragMove (AGPane *ag,EventRecord *eventPtr,Point offset)  
{
	short didDrag = FALSE;
	short mouseIsDown;
	
	mouseIsDown = StillDown();
	while (WaitMouseUp())
	{// don't do drag if mouse is not still down or nothing to drag// avoid nested elses in if statements above
	 	//make a region for dragging
	 	grafData * thisPart;
	 	grafData * thisGrafPtr;
	 	RgnHandle myRegion;
	 	RgnHandle tempRegion;
	 	long partsInWindow;
	 	newMatrixFPtr thisViewMatrix;
	 	short i, counter;
	 	
	 	thisGrafPtr = lockGrafData(ag);
	 	partsInWindow = numItems(&ag->partList);
		myRegion = NewRgn();
	 	tempRegion = NewRgn();
	
		thisViewMatrix = &(ag->windowView.viewMatrix);
		counter = 1;  // will count through selections list
		i = 0;  // counts through grafdata structure
		while ((i<(partsInWindow)) &&	(counter<100) )
		{
			thisPart = &(thisGrafPtr[i]);
			if (getParticleSelected(ag->sim, thisPart->index))
			{
				SetEmptyRgn(tempRegion);
		 		OpenRgn();
				FrameOval(&(thisPart->circle));
				CloseRgn(tempRegion);
				UnionRgn(tempRegion,myRegion,myRegion);	
				++counter;	
			}
			++i;
		}
	 	//track mouse with info display
	 	{
		 	long dummyLong;
		 	Point movedVH;
		 	
		 	dummyLong = DragGrayRgn(myRegion,eventPtr->where,
		 				&(ag->attachedWindow->portRect),
		 				&(ag->attachedWindow->portRect),
		 				noConstraint,nilPointer);  // noConstraint means both axes, nil means no callback
		 	movedVH.v = ((Point *)&dummyLong)->v;
		 	movedVH.h = ((Point *)&dummyLong)->h;
	 	//check for abort
	 		if (keyIsPressed(kOptionKeyCode) || (dummyLong == 0x80008000) )  // value for released outside window
	 		{	 		
	 		}// bail
	 		else  // do move
	 		{
		 	// get movement vectors
	 			float movedV, movedH, mag;
	 			floatVector delVec;
	 			mag = ag->windowView.magnification;
	 			movedV =  (float)movedVH.v / mag;
	 			movedH = (float)movedVH.h / mag;
	 			
	 			delVec.a = movedH * thisViewMatrix->A.a - movedV * thisViewMatrix->B.a;
	 			delVec.b = movedH * thisViewMatrix->A.b - movedV * thisViewMatrix->B.b;
	 			delVec.c = movedH * thisViewMatrix->A.c - movedV * thisViewMatrix->B.c;
	 			translateParticles(ag->sim, &delVec, true); // selectedOnly
				didDrag = TRUE;
	 		}
	 	}
	 	// clean up
	 	DisposeRgn(tempRegion);
	 	DisposeRgn(myRegion);
	 	releaseGrafData( ag );	 
	}
	if (didDrag) 
	{
		long gnErr;
		callDoMessage(OHOb(ag), kInvalSelfMessage, 0L);
		gnErr = calcNeighbors(ag->sim);
	}
}
void AGPaneDragSelect   (AGPane *ag,Point where, Point offset,  short shiftKeyWasDown)
{	
	short err;
	Rect finalRect;
  	OHList tList;
	grafData *gd;
	grafData *thisGrafData;
  	err = initializeList(&tList);
 	if (!err)
 	{
 	 	gd = lockGrafData(ag);
	 	
		err =  OHGWorldPaneAnimateDragRect (&ag->gwp,  where,  offset,  &finalRect);
	} // final rect comes back in gworld rect coordinates
	if (!err)
	{
		Point newPoint;
		newPoint.h -= where.h;
		newPoint.v -= where.v;  // find how far away the points are
		if ((newPoint.h > 2) || (newPoint.h < -2) || (newPoint.v > 2) || (newPoint.v < -2))
		{
			long i;
			long numberSelected = 0;
			Rect *thisCircle;
			short notBetweenPts;
			RgnHandle circleRegion;
			RgnHandle selectedRegion;
			RgnHandle testRegion;
			
			i = numItems(&ag->partList) - 1;
			selectedRegion = NewRgn();
			SetRectRgn(selectedRegion, finalRect.left, finalRect.top, finalRect.right, finalRect.bottom);
			
			testRegion = NewRgn();
			circleRegion = NewRgn();
			
			while ( i>=0 ) // we count down from numParts-1
			{
				thisGrafData =  &(gd[i]);
				if (!(thisGrafData->inWindow))
				{
					i = i - 1;  // many i=i-1s so that the loops go fast???
				}
				else
				{
					thisCircle = &(thisGrafData->circle);			
					notBetweenPts = (( finalRect.left > thisCircle->right) || ( finalRect.right < thisCircle->left));
					if (notBetweenPts)
					{
						i = i - 1;
					}
					else 
					{		
						notBetweenPts = (( finalRect.top > thisCircle->bottom) || ( finalRect.bottom < thisCircle->top));
						if (notBetweenPts)
						{
							i = i - 1;
						}
						else //if (thisGrafData->inWindow)
						{		
							OpenRgn();  // this timeconsuming operation only occurs if we are very close
							FrameOval(thisCircle);
							CloseRgn(circleRegion);
							SectRgn(selectedRegion, circleRegion, testRegion);
							if (!(EmptyRgn(testRegion)))
							{
								addToList(&tList,   thisGrafData->index);
							}
							else  // avoid nested elses 
							{
							
							}
							i = i - 1;
						}
					}
				}
			}
			if  (!shiftKeyWasDown) eraseSelections(ag->sim); // shortened alot!!!
			 setListSelected(ag->sim, &tList, true);

			DisposeRgn(circleRegion);
			DisposeRgn(selectedRegion);
			DisposeRgn(testRegion);
		}
		setSimSelectionsMenuItems(ag->sim);

		releaseGrafData(ag);
		disposeList(&tList);
		callDoMessage(OHOb(ag), kInvalSelfMessage, 0L);
	}
	else
	{
	 	OHSystemBeep();
	}
}
void AGPaneSetDragActiveRegion(AGPane *ag, RgnHandle activeRegion)
{
	Point centerPoint;
	Point windowSize;
	short activeRadius;
	Rect ovalRect;
	Rect worldRect;
	OHGWorldPaneGetWorldRect(&ag->gwp, &worldRect);
 	centerPoint.h = (worldRect.right + worldRect.left)/2;
 	centerPoint.v = (worldRect.bottom +worldRect.top)/2;
 	windowSize.h = (worldRect.bottom - worldRect.top);
 	windowSize.v = (worldRect.right - worldRect.left);
 	if (windowSize.v < windowSize.h) 
 	{
 		activeRadius = (windowSize.v * 3) / 7;
 	}
 	else 
 	{
 		activeRadius = (windowSize.h * 3) / 7;
 	}
 	ovalRect.top = centerPoint.v - activeRadius;
 	ovalRect.bottom = centerPoint.v + activeRadius;
 	ovalRect.right = centerPoint.h + activeRadius;
 	ovalRect.left = centerPoint.h - activeRadius;
 	OpenRgn();
 	FrameOval(&ovalRect);
 	CloseRgn(activeRegion);
}


void AGPaneDragRotate (AGPane *ag,Point startPoint, Point offset)
{	
	GrafPtr	oldPort;
	short oldColourCalc;
	Point oldPoint, newPoint;
	Point centerPoint;
	Rect worldRect;
	RgnHandle activeRegion;
	float fullHoriz;
	float fullVert;
	float delHoriz;
	float delVert;
 	
 	RgnHandle oldClip;
	PixMapHandle 	thePixMap;
	GWorldFlags theFlags;
	OHGWorldPaneGetWorldRect(&ag->gwp, &worldRect);
 
 	activeRegion = NewRgn();
 	AGPaneSetDragActiveRegion(ag, activeRegion);
 	centerPoint.h = (worldRect.right + worldRect.left)/2;
 	centerPoint.v = (worldRect.bottom + worldRect.top)/2;
	GetPort( &oldPort);
	SetPort (ag->attachedWindow);
	oldClip = NewRgn();  // save the clipRgn
	GetClip (oldClip);
	ClipRect (&worldRect);  //correct clip region so scrollbars stay OK
	thePixMap = GetGWorldPixMap(ag->gwp.world);
	theFlags = GetPixelsState(thePixMap);

	fullHoriz = (-1.0/180.0) * (worldRect.right - worldRect.left);
	fullVert = (1.0/180.0) * (worldRect.bottom - worldRect.top);
	// setMyCursor(kRotateCursor);
	oldPoint = startPoint;  // init old point
	oldColourCalc = ag->doColourCalc;
//	ag->doColourCalc = false;  // so that we don't recalculate the colour every time
	while ( WaitMouseUp() )  
	{
		GetMouse( &newPoint);
		if ( DeltaPoint(oldPoint, newPoint) ) // fancy way of testing if mouse has moved
		{	// if it moved:
			delHoriz = newPoint.h - oldPoint.h;	
			delVert = oldPoint.v - newPoint.v;
			if (PtInRgn(newPoint, activeRegion)) // do a spin
			{
			//	appSetCursor(kRollCellCursor);
				SpinMatrixInDegrees(&(ag->windowView.viewMatrix),  
					delHoriz/fullHoriz,delVert/fullVert,  0);	// 0 is spin
			}
			else 
			{
				float spinAngle;
			//	appSetCursor(kSpinCellCursor);
				spinAngle = pointAngle (oldPoint, centerPoint, newPoint);
				SpinMatrixInDegrees(&(ag->windowView.viewMatrix),  
					0,0,-spinAngle);	// 0 for lat and long				
			}
			ag->gwp.pane.view.draw(&ag->gwp.pane.view, offset);
			oldPoint=newPoint;
		}
	}
 	ag->doColourCalc = oldColourCalc;
	SetPixelsState(thePixMap, theFlags);
	SetClip(oldClip);
	DisposeRgn(oldClip);
	SetPort(oldPort);
	DisposeRgn (activeRegion);
//	setColour(myBlackColour);  
}
	
short AGPaneWasClickInParticle(AGPane *ag,Point where, long * whichParticle)
{
	long i,j;
	short horiz, vert;
	short notBetweenPts;
	short foundIt = false;
	long *orderListPtr;
	grafData * myGrafData;
	grafData * thisGrafData;
	RgnHandle testRgn;
	Rect *thisCircle;
	
	testRgn = NewRgn();
	
	myGrafData = lockGrafData( ag);
	orderListPtr = lockList (&ag->orderList);
	
	i = numItems(&ag->partList) -1;
	horiz = where.h;
	vert = where.v;
	while ((!foundIt) && (i>=0))  // count down from nearest to viewer
	{
		j = orderListPtr[i];
		thisGrafData =  &(myGrafData[j]);
		if (!(thisGrafData->inWindow))
		{
			i = i - 1;  // many i=i-1s so that the loops go fast???
		}
		else
		{
			thisCircle = &(thisGrafData->circle);			
			notBetweenPts = (( horiz > thisCircle->right) || ( horiz < thisCircle->left));
			if (notBetweenPts)
			{
				i = i - 1;
			}
			else 
			{		
				notBetweenPts = (( vert > thisCircle->bottom) || ( vert < thisCircle->top));
				if (notBetweenPts)
				{
					i = i - 1;
				}
				else 
				{		
					OpenRgn();  // this timeconsuming operation only occurs if we are very close
					FrameOval(thisCircle);
					CloseRgn(testRgn);
					if (PtInRgn(where, testRgn)) foundIt = true; 
					SetEmptyRgn(testRgn);
					i = i - 1;
				}			
			}
		}
	}
	(*whichParticle) = thisGrafData->index;
	
	releaseGrafData( ag);
	releaseList(&ag->orderList);
	DisposeRgn(testRgn);

	return (foundIt);
}
char getCharFromNudgeItem(short theItem)
{
	char aChar;
	switch (theItem)
	{
		case iShiftUp:
			aChar = upArrowKeyCode;
			break;
		case iShiftDown:
			aChar = downArrowKeyCode;
			break;
		case iShiftRight:
			aChar = rightArrowKeyCode;
			break;
		case iShiftLeft:
			aChar = leftArrowKeyCode;
			break;
		case iPullOut:
			aChar = ']';
			break;
		case iPushIn:
			aChar = '[';
			break;
	}
	return (aChar);
}
char getCharFromRollItem(short theItem)
{
	char aChar;
	switch (theItem)
	{
		case iRollUp:
			aChar = '8';
			break;
		case iRollDown:
			aChar = '2';
			break;
		case iRollRight:
			aChar = '6';
			break;
		case iRollLeft:
			aChar = '4';
			break;
		case iRollClockwise:
			aChar = '*';
			break;
		case iRollCClockwise:
			aChar = '/';
			break;
	}
	return (aChar);
}

