#include "kSanAGWindow.h"
#include "kSanDialog.h"

#define	iLatitudeEditItem 	 5
#define	iLongitudeEditItem 	 7
#define	iAxialEditItem 		 9
#define	ihorizEditItem 		12
#define	ivertEditItem 		14
#define	ihikiEditItem 		16



#define	iMagnificationEditItem 	3
#define	iParticleSizeEditItem 	5
#define	iParticleSizeTextItem 	6
#define	iPerspectEditItem 		7
#define	iShowBondsCheckItem 	9
#define	iColourPopupItem 11
#define	iShadePopupItem 13
#define	iSizePopupItem 15
#define	iBGCButtonItem 22
#define	iColourButtonItem 23

#define iNeutralShadeDepthEditItem 18
#define iShadeRangeEditItem 19
#define iNeutralShadeDepthTextItem 20
#define iShadeRangeTextItem 21


void	getShadeDItems( DialogPtr dialog, viewInfo *theView);
void	setShadeDItems( DialogPtr dialog, viewInfo *theView);
void	getSizeDItems( DialogPtr dialog, viewInfo *theView);
void	setSizeDItems( DialogPtr dialog, viewInfo *theView);

short	DoCellManipulationDialog	(kozoObject *winObj)
{
	AGWindow *ag;
	OHBasicDialog dialog;
	
	ag = agWinData (winObj);
	setupAppDialog	(&dialog, kManipDialogResID);
	if (! dialog.done )
	{
		prepDoubleItem(dialog.dp, iLatitudeEditItem,ag->manip.latRotateAngle);
		prepDoubleItem(dialog.dp, iLongitudeEditItem,ag->manip.longRotateAngle);
		prepDoubleItem(dialog.dp, iAxialEditItem,ag->manip.axialRotateAngle);
		prepDoubleItem(dialog.dp, ihorizEditItem,ag->manip.horizShift);
		prepDoubleItem(dialog.dp, ivertEditItem,ag->manip.vertShift);
		prepDoubleItem(dialog.dp, ihikiEditItem,ag->manip.hikiShift);
	}
	while ( ! dialog.done )
	{
		ModalDialog(nilPointer, &dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
		ag->manip.latRotateAngle = getDoubleItem(dialog.dp, iLatitudeEditItem, 10.0, 0.01);
		ag->manip.longRotateAngle = getDoubleItem(dialog.dp, iLongitudeEditItem, 10.0, 0.01);
		ag->manip.axialRotateAngle = getDoubleItem(dialog.dp, iAxialEditItem, 10.0, 0.01);
		ag->manip.horizShift = getDoubleItem(dialog.dp, ihorizEditItem, 10.0, 0.01);
		ag->manip.vertShift = getDoubleItem(dialog.dp, ivertEditItem, 10.0, 0.01);
		ag->manip.hikiShift = getDoubleItem(dialog.dp, ihikiEditItem, 10.0, 0.01);
	}
	OHBreakdownDialog(&dialog);
	return (dialog.itemHit);
}

short	AGWinDoDialog	( AGWindow *ag)
{
 	OHBasicDialog dialog;
	short tempColourIndex;
	viewInfo   tempView;
	ControlHandle      colourPopupHandle;
	ControlHandle      shadePopupHandle;
	ControlHandle      sizePopupHandle;
//	ControlHandle      patternPopupHandle;
//	ControlHandle      BGCPopupHandle;
	
 	makePlugInMenus();
	setupAppDialog (&dialog, kGraphicsDialogResID);
	if (! dialog.done )
	{
		tempView = ag->windowView;

		prepDoubleItem(dialog.dp, iMagnificationEditItem, tempView.magnification);	
		prepDoubleItem(dialog.dp, iPerspectEditItem, tempView.perspective);	
		prepCheckItem(dialog.dp, iShowBondsCheckItem, 	tempView.showBonds);

		GetDialogItem (dialog.dp, iColourPopupItem,&dialog.itemType,&(Handle)colourPopupHandle,&dialog.itemRect);	
		tempColourIndex = whichPlugInMenuItem(ClassColourPlugIn, ag->win->obj);
 	    SetControlValue (colourPopupHandle, tempColourIndex);
// 	    setColourDItems(dialog.dp, &tempView);
	    
		GetDialogItem (dialog.dp,iShadePopupItem,&dialog.itemType,&(Handle)shadePopupHandle,&dialog.itemRect);	
	    SetControlValue (shadePopupHandle, tempView.shadeMethod+1);
	    setShadeDItems(dialog.dp, &tempView);
	    
		GetDialogItem (dialog.dp,iSizePopupItem,&dialog.itemType,&(Handle)sizePopupHandle,&dialog.itemRect);	
	    SetControlValue (sizePopupHandle, tempView.sizeMethod + 1);
	    setSizeDItems(dialog.dp, &tempView);
	}
	while ( ! dialog.done )
	{
		ModalDialog(nilPointer, &dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
			case iShowBondsCheckItem:
				tempView.showBonds = !tempView.showBonds;
				prepCheckItem(dialog.dp, iShowBondsCheckItem, 	tempView.showBonds);
				break;
			case iColourPopupItem:
				{
					short tempMeth;
 					tempMeth  = GetControlValue(colourPopupHandle);
 					if (tempMeth != tempColourIndex) 
 					{
 						AGSetColourMethodMenuChoice( ag, tempMeth);
 						tempColourIndex = tempMeth;
 					}
 				}
 				break;
			case iColourButtonItem:
				dispatchNilMessage (OHGetNamedReference(ag->win->obj, ClassColourPlugIn), kSanDoDialogMessage);
				break;
			case iShadePopupItem:
				getShadeDItems(dialog.dp, &tempView);
				tempView.shadeMethod = GetControlValue(shadePopupHandle) - 1;
				setShadeDItems(dialog.dp, &tempView);
				break;
			case iSizePopupItem:
				getSizeDItems(dialog.dp, &tempView);
				tempView.sizeMethod = GetControlValue(sizePopupHandle) - 1;
				setSizeDItems(dialog.dp, &tempView);
				break;
 			case iBGCButtonItem:
	 			{
	 				RGBColor aColor;
	 				RGBColor bColor;
	 				kozoGetDataPtr(ag->win->obj, pBackgroundColor, typeRGBColor, &aColor, sizeof(RGBColor));
	 				bColor = aColor;
	 				myPickAColor(&bColor, (unsigned char *)" Choose Background Colour");
	 				if ((bColor.red != aColor.red) || (bColor.green != aColor.green) || (bColor.blue != aColor.blue)) kozoSetDataPtr(ag->win->obj, pBackgroundColor, typeRGBColor, &bColor, sizeof(RGBColor));
	 			}
 				break;
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
//		getColourDItems(dialog.dp, &tempView);
		getSizeDItems(dialog.dp, &tempView);
		getShadeDItems(dialog.dp, &tempView);
		if (tempView.shadeMethod != ag->windowView.shadeMethod) AGSetShadeMethod ( ag, tempView.shadeMethod);
		if (tempView.sizeMethod != ag->windowView.sizeMethod) AGSetSizeMethod ( ag, tempView.sizeMethod);

		tempView.magnification = getDoubleItem(dialog.dp, iMagnificationEditItem, 10000.0, 0.1);	
		tempView.perspective = getDoubleItem(dialog.dp, iPerspectEditItem, 10000.0, 0.1);	
		ag->windowView = tempView;

		kozoSetDataPtr (ag->win->obj, pMagnification, typeShortFloat, (Ptr) &tempView.magnification, sizeof(float) );
		kozoSetDataPtr (ag->win->obj, pPerspective, typeShortFloat, (Ptr) &tempView.perspective, sizeof(float) );
		kozoSetDataPtr (ag->win->obj, pParticleSize, typeShortFloat, (Ptr) &tempView.particleSizeFactor, sizeof(float) );
	}
	OHBreakdownDialog(&dialog);
	deletePlugInMenus();
	dispatchNilMessage(ag->win->obj, kInvalGraphicsMessage);
	return (dialog.itemHit);
}
void	getShadeDItems( DialogPtr dialog, viewInfo *theView)
{
	switch (theView->shadeMethod)
	{
		case kShadeByDepth:
			theView->neutralShadeDepth = getDoubleItem(dialog, iNeutralShadeDepthEditItem, 10000.0, -10000.0);	
			theView->shadeRange = getDoubleItem(dialog, iShadeRangeEditItem,100000.0, 0.00001);	
			break;
		default:
			break;
	}
}
void	setShadeDItems( DialogPtr dialog, viewInfo *theView)
{
	switch (theView->shadeMethod)
	{
		case kShadeByDepth:
			ShowDialogItem(dialog, iNeutralShadeDepthEditItem);
			ShowDialogItem(dialog, iShadeRangeEditItem);
			ShowDialogItem(dialog, iNeutralShadeDepthTextItem);
			ShowDialogItem(dialog, iShadeRangeTextItem);
			prepDoubleItem(dialog, iNeutralShadeDepthEditItem, theView->neutralShadeDepth);	
			prepDoubleItem(dialog, iShadeRangeEditItem, theView->shadeRange);	
			break;
		default:
			HideDialogItem(dialog, iNeutralShadeDepthEditItem);
			HideDialogItem(dialog, iShadeRangeEditItem);
			HideDialogItem(dialog, iNeutralShadeDepthTextItem);
			HideDialogItem(dialog, iShadeRangeTextItem);
			break;
	}
}
void	getSizeDItems( DialogPtr dialog, viewInfo *theView)
{
	switch (theView->sizeMethod)
	{
		case kSizeByWindow:
			 theView->particleSizeFactor = getDoubleItem(dialog, iParticleSizeEditItem, 10.0, 0.1);	
			break;
		default:
			break;
	}
}
void	setSizeDItems( DialogPtr dialog, viewInfo *theView)
{
	switch (theView->sizeMethod)
	{
		case kSizeByWindow:
			ShowDialogItem(dialog, iParticleSizeEditItem);
			ShowDialogItem(dialog, iParticleSizeTextItem);
			prepDoubleItem(dialog, iParticleSizeEditItem, theView->particleSizeFactor);	
			break;
		default:
			HideDialogItem(dialog, iParticleSizeEditItem);
			HideDialogItem(dialog, iParticleSizeTextItem);
			break;
	}
}

