#include <Sound.h>
#include "OHScrollableView.h"
#include "kSanAGWindow.h"
#include "MacOSUtils.h"
char getCharFromNudgeItem(short theItem);
char getCharFromRollItem(short theItem);
void AGWindowSelectHighlightClick (AGWindow *ag, viewDoClickArgs *args, short mouseStillDown, short wasADoubleClick);				
 void AGWindowDragSelect   (AGWindow *ag, viewDoClickArgs *args,  short shiftKeyWasDown);
 void AGWindowDragMove (AGWindow *ag, viewDoClickArgs *args)  ;
short AGWindowWasClickInParticle(AGWindow *ag, viewDoClickArgs *args, long * partArrIndex);
void AGWindowDragRotate (AGWindow *ag, viewDoClickArgs *args);
 
short AGWindowDoKey(KozoDispatchStack *ds, viewDoKeyArgs *args)
{
 	AGWindow *ag;
 	char doInval = false;
	short err;
	short optionKeyPressed;
	short shiftKeyPressed;
 	ag = KDSGetPrivateData(ds, ClassAGWindow );
	optionKeyPressed = keyIsPressed(kOptionKeyCode);
	shiftKeyPressed = keyIsPressed(kShiftKeyCode);
	if ( (args->theKey >=leftArrowKeyCode  &&
			 args->theKey <= downArrowKeyCode) || (args->theKey == '[') || (args->theKey == ']') )
	{
		AGWindowArrowMove ( ag, args->theKey, optionKeyPressed, shiftKeyPressed);
		doInval = true;
	}
	else if ( ((args->theKey >= '1')  && (args->theKey <= '9'))  || (args->theKey == '*') || (args->theKey == '/') )
	{
		AGWindowKeypadRotate ( ag, args->theKey, shiftKeyPressed);
		//else doSelectedRotate(ag, theChar, shiftKeyPressed);
		doInval = true;
	}
	else if (args->theKey == kBackspaceKeyCode)
	{
		err =dispatchNilMessage (OHOCtr(ds->obj),  kCutMessage);
		doInval = true;
	}
	if (doInval) dispatchNilMessage(ds->obj, kInvalSelfMessage);
	KDSReturnContinue(ds);
}

void	AGWindowHandleRollChoice	(AGWindow *ag, short item)
{
	short selectedOnly;
	short timesFive;
	char aChar;
	
	selectedOnly = keyIsPressed(kOptionKeyCode);
	timesFive = keyIsPressed(kShiftKeyCode);
	switch(item)
	{
		case iRollUp:
		case iRollDown:
		case iRollRight:
		case iRollLeft:
		case iRollClockwise:
		case iRollCClockwise:
			aChar = getCharFromRollItem(item);
			AGWindowKeypadRotate( ag, aChar, timesFive);
			break;
	}
}
void	AGWindowHandlePushChoice	(AGWindow *ag, short item)
{
	short selectedOnly;
	short timesFive;
	char aChar;
	
	selectedOnly = keyIsPressed(kOptionKeyCode);
	timesFive = keyIsPressed(kShiftKeyCode);
	switch(item)
	{
		case iRollUp:
		case iRollDown:
		case iRollRight:
		case iRollLeft:
		case iRollClockwise:
		case iRollCClockwise:
			aChar = getCharFromNudgeItem(item);
			AGWindowArrowMove( ag, aChar, timesFive, selectedOnly);
			break;
	}
}

void 	AGWindowKeypadRotate (AGWindow *ag, char myKeyCode, short timesFive)
{
	float latAngle;	
	float longAngle;
	float spinAngle;
	float multFactor = 1.0;
		
	if (timesFive) multFactor*= 5.0;
	 AGWindowGetAngles(  ag, myKeyCode,&latAngle, &longAngle, &spinAngle);	
	SpinkSanMatrixInDegreesD(&(ag->windowView.viewMatrix), latAngle*multFactor, longAngle*multFactor, spinAngle*multFactor);
}
void 	AGWindowArrowMove  (AGWindow *ag, char myKeyCode, short timesFive, short selectedOnly)
{
	kSanVector wVec;
	float multFactor = 1.0;
	
	zerokSanVectorD(&wVec);
	if (timesFive) multFactor *= 5.0;
	switch (myKeyCode)
	{		
		case leftArrowKeyCode:
			wVec.a = -1*(ag->manip.horizShift) * multFactor;
			break;					

		case rightArrowKeyCode:		
			wVec.a = (ag->manip.horizShift)* multFactor;
			break;			
							
		case upArrowKeyCode:		
			wVec.b = ag->manip.vertShift* multFactor;
			break;
			
		case downArrowKeyCode:		
			wVec.b = -1*(ag->manip.vertShift)* multFactor;
			break;
#ifndef __2DVectors__

		case '[':		
			wVec.c = -1*(ag->manip.hikiShift)* multFactor;
			break;

		case ']':		
			wVec.c = ag->manip.hikiShift* multFactor;
			break;
#endif
	}	
	{
		kSanVector translationVec;
		vecDotkSanMatrixD(&wVec, &ag->windowView.viewMatrix, &translationVec);
		translateParticles ( ag->sim,  &translationVec, selectedOnly);	
	}			
}
short AGWindowFindObject(KozoDispatchStack *ds, viewFindObjectArgs *args)
{
	AGWindow *ag = (AGWindow *) ds->thisPD;
	Point adjustedPoint;
 	
	if (!(args->cd->clickedView))
	{
		adjustedPoint.h = args->cd->localPt.h - args->cd->offset.h;
		adjustedPoint.v = args->cd->localPt.v - args->cd->offset.v;
		if (!args->view) args->view =  KDSGetPrivateData(ds, ClassView);

		if (PtInRect(adjustedPoint, &(args->view->rect)))
		{
			args->cd->clickedView = ds->obj;
		}
	}
	if (args->cd->clickedView) KDSDoneDispatch(ds);
	KDSReturnContinue(ds);
}

 short AGWindowDoClick (KozoDispatchStack *ds, viewDoClickArgs *args)
{ // the click routine of the gworld pane
	EventRecord theNextEvent;
	AGWindow *ag;
	short mouseStillDown = true;
	short wasADoubleClick = false;
	short done = false;
	ag = KDSGetPrivateData(ds, ClassAGWindow );
	if (ag->mode == kSelectAndHighlightMode)
	{
		while ((TickCount() < (args->cd->clickEvent->when + GetDblTime())) && (!done))
		{
			GetNextEvent((mDownMask | mUpMask), &theNextEvent);
			if (theNextEvent.what == mouseUp) mouseStillDown = false;
			else if (theNextEvent.what == mouseDown)  
			{
				wasADoubleClick = true;	
				done = true;
			}
		}
	    AGWindowSelectHighlightClick( ag, args, mouseStillDown, wasADoubleClick);
	}
	else 
	{
		AGWindowDragRotate( ag, args);
	}
	KDSReturnContinue(ds);
}
void AGWindowSelectHighlightClick (AGWindow *ag, viewDoClickArgs *args, short mouseStillDown, short wasADoubleClick)				
{
	short isHigh;
	short clickWasInParticle;
	short wasSelected;
	short shiftKeyDown;
	short optionKeyDown;
	long partArrIndex;
	
	shiftKeyDown =((args->cd->clickEvent->modifiers & shiftKey) != 0);
	optionKeyDown = ((args->cd->clickEvent->modifiers & optionKey) != 0);

	clickWasInParticle = AGWindowWasClickInParticle( ag, args,  &partArrIndex);
	if (clickWasInParticle)
	{
		wasSelected = getParticleSelected( ag->sim, partArrIndex);
		if  (wasADoubleClick)
		{
			doParticleDialog( ag->sim, partArrIndex);
		}
		else if (optionKeyDown)
		{
			isHigh = getParticleHighlighted( ag->sim,  partArrIndex);
			setParticleHighlighted(  ag->sim, partArrIndex, (isHigh == kNotHighlighted));
			dispatchNilMessage( ag->win->obj , kInvalGraphicsMessage);
		}
		else if (!shiftKeyDown && !wasSelected)
		{
			eraseSelections(  ag->sim); // simulation method
			setParticleSelected( ag->sim, partArrIndex, true);
			AGWindowDragMove(  ag, args) ; 
			setSimSelectionsMenuItems(  ag->sim);
			dispatchNilMessage( ag->win->obj , kInvalGraphicsMessage);
		}
		else 
		{
			if (mouseStillDown && wasSelected)
			{
			}
			else
			{
				isHigh = getParticleHighlighted( ag->sim, partArrIndex);
				setParticleHighlighted( ag->sim, partArrIndex, (!isHigh));
				setSimSelectionsMenuItems( ag->sim);
			    dispatchNilMessage( ag->win->obj , kInvalGraphicsMessage);
			}
			AGWindowDragMove( ag, args);								
		}
	}
	else if (mouseStillDown)
	{
		AGWindowDragSelect( ag, args, shiftKeyDown);
	}
	else  // avoid nested elses
	{
		eraseSelections(  ag->sim); // simulation method
	}
}	
long AGWindowNumParts (AGWindow *ag )  
{
	agCheckPartList(ag);
    return( OHListCount(&ag->particleList));
}	
void AGWindowDragMove (AGWindow *ag, viewDoClickArgs *args)  
{
	short didDrag = false;
	short mouseIsDown;
	
	mouseIsDown = StillDown();
	while (WaitMouseUp())
	{// don't do drag if mouse is not still down or nothing to drag// avoid nested elses in if statements above
	 	//make a region for dragging
	 	grafData * thisPart;
	 	grafData * thisGrafPtr;
	 	RgnHandle myRegion;
	 	RgnHandle tempRegion;
	 	long partsInWindow;
	 	kSanMatrix * thisViewMatrix;
	 	short i, counter;
	 	
	 	thisGrafPtr = AGWindowLockGrafData( ag);
	 	partsInWindow = AGWindowNumParts(ag);
		myRegion = NewRgn();
	 	tempRegion = NewRgn();
	
		thisViewMatrix = &(ag->windowView.viewMatrix);
		counter = 1;  // will count through selections list
		i = 0;  // counts through grafdata structure
		while ((i<(partsInWindow)) &&	(counter<100) )
		{
			thisPart = &(thisGrafPtr[i]);
			if (getParticleSelected( ag->sim, thisPart->index))
			{
				SetEmptyRgn(tempRegion);
		 		OpenRgn();
				FrameOval(&(thisPart->circle));
				CloseRgn(tempRegion);
				UnionRgn(tempRegion,myRegion,myRegion);	
				++counter;	
			}
			++i;
		}
	 	//track mouse with info display
	 	{
		 	long dummyLong;
		 	Rect portRect;
		 	Point movedVH;
		 	kozoGetDataPtr (ag->win->obj, pBufferedBounds, typeQDRectangle, &portRect, 8L);
		 	dummyLong = DragGrayRgn(myRegion,args->cd->localPt,
		 				&portRect, &portRect, noConstraint,nilPointer);  // noConstraint means both axes, nil means no callback
		 	movedVH.v = ((Point *)&dummyLong)->v;
		 	movedVH.h = ((Point *)&dummyLong)->h;
	 	//check for abort
	 		if (keyIsPressed(kOptionKeyCode) || (dummyLong == 0x80008000) )  // value for released outside window
	 		{	 		
	 		}// bail
	 		else  // do move
	 		{
		 	// get movement vectors
	 			float movedV, movedH, mag;
	 			kSanVector delVec;
	 			mag = ag->windowView.magnification;
	 			movedV =  (float)movedVH.v / mag;
	 			movedH = (float)movedVH.h / mag;
	 			
	 			delVec.a = movedH * thisViewMatrix->A.a - movedV * thisViewMatrix->B.a;
	 			delVec.b = movedH * thisViewMatrix->A.b - movedV * thisViewMatrix->B.b;
#ifndef __2DVectors__ 
	 			delVec.c = movedH * thisViewMatrix->A.c - movedV * thisViewMatrix->B.c;
#endif
	 			translateParticles(  ag->sim, &delVec, true); // selectedOnly
				didDrag = true;
	 		}
	 	}
	 	// clean up
	 	DisposeRgn(tempRegion);
	 	DisposeRgn(myRegion);
	 	AGWindowReleaseGrafData( ag );	 
	}
	if (didDrag) 
	{
		long gnErr;
		dispatchNilMessage(ag->win->obj, kInvalSelfMessage);
		gnErr = calcNeighbors(  ag->sim);
	}
}
void AGWindowDragSelect   (AGWindow *ag, viewDoClickArgs *args, short shiftKeyWasDown)
{	
	short err;
	Point noOffset = {0,0};
	Rect finalRect;
  	OHList tList;
	grafData *gd;
	OHScrollableView *sv;
	grafData *thisGrafData;
    sv = svData(ag->win->obj);
	err = initializeList(&tList);
	if (!err)
 	{
 		 AEDesc dragProps = {typeNull, nilPointer};
	 	
	 	 OHMakeAERecord(&dragProps);
 		 err = OHBufferedViewAnimateDragRectProc  (ag->win->obj, args->cd->localPt, noOffset, sv->selfOffset, &dragProps);
 		   // WE SUPPLY NOOFFSET FOR THE ADJUST POINT, WHICH MEANS WE WILL ADJUST IT OURSELVES
		 OHGetKeyPtr (&dragProps, pBounds, typeQDRectangle, &finalRect, sizeof(Rect));
		 AEDisposeDesc (&dragProps);
 	} 
	if ( (!err) && (((finalRect.bottom - finalRect.top)  > 2) || ((finalRect.right - finalRect.left) > 2)) )
	{ // far enough away to do a selection
		long i;
		long numberSelected = 0;
 		short notBetweenPts;
		RgnHandle circleRegion;
		RgnHandle selectedRegion;
		RgnHandle testRegion;
			
   		gd = AGWindowLockGrafData( ag);
		i = AGWindowNumParts(ag)  - 1;
 		OHOffsetRect (&finalRect, args->cd->offset, &finalRect)	;	
		selectedRegion = NewRgn();
		SetRectRgn(selectedRegion, finalRect.left, finalRect.top, finalRect.right, finalRect.bottom);
		
		testRegion = NewRgn();
		circleRegion = NewRgn();
		
		while ( i>=0 ) // we count down from numParts-1
		{
			thisGrafData =  &(gd[i]);
			if (!(thisGrafData->inWindow))
			{
				i = i - 1;  // many i=i-1s so that the loops go fast???
			}
			else
			{ 	
				notBetweenPts = (( finalRect.left > thisGrafData->circle.right) || ( finalRect.right < thisGrafData->circle.left));
				if (notBetweenPts)
				{
					i = i - 1;
				}
				else 
				{		
					notBetweenPts = (( finalRect.top > thisGrafData->circle.bottom) || ( finalRect.bottom < thisGrafData->circle.top));
					if (notBetweenPts)
					{
						i = i - 1;
					}
					else //if (thisGrafData->inWindow)
					{		
						OpenRgn();  // this timeconsuming operation only occurs if we are very close
						FrameOval(&thisGrafData->circle);
						CloseRgn(circleRegion);
						SectRgn(selectedRegion, circleRegion, testRegion);
						if (!(EmptyRgn(testRegion)))
						{
							addToList(&tList,   thisGrafData->index);
						}
						else  // avoid nested elses 
						{
						
						}
						i = i - 1;
					}
				}
			}
		}
		if  (!shiftKeyWasDown) eraseSelections( ag->sim); // shortened alot!!!
		setListSelected(  ag->sim, &tList, true);

 		setSimSelectionsMenuItems(  ag->sim);

		AGWindowReleaseGrafData( ag);
		dispatchNilMessage(ag->win->obj, kInvalSelfMessage);
		disposeList(&tList);
		DisposeRgn(circleRegion);
		DisposeRgn(selectedRegion);
		DisposeRgn(testRegion);
	}
	else
	{
	 	OHSystemBeep();
	}
}
void AGWindowSetDragActiveRegion(AGWindow *ag, RgnHandle activeRegion)
{
	Point centerPoint;
	Point windowSize;
	short activeRadius;
	Rect ovalRect;
	Rect worldRect;
	kozoGetDataPtr (ag->win->obj, pBufferedBounds, typeQDRectangle, &worldRect, 8L);
 	centerPoint.h = (worldRect.right + worldRect.left)/2;
 	centerPoint.v = (worldRect.bottom +worldRect.top)/2;
 	windowSize.h = (worldRect.bottom - worldRect.top);
 	windowSize.v = (worldRect.right - worldRect.left);
 	if (windowSize.v < windowSize.h) 
 	{
 		activeRadius = (windowSize.v * 3) / 7;
 	}
 	else 
 	{
 		activeRadius = (windowSize.h * 3) / 7;
 	}
 	ovalRect.top = centerPoint.v - activeRadius;
 	ovalRect.bottom = centerPoint.v + activeRadius;
 	ovalRect.right = centerPoint.h + activeRadius;
 	ovalRect.left = centerPoint.h - activeRadius;
 	OpenRgn();
 	FrameOval(&ovalRect);
 	CloseRgn(activeRegion);
}
short AGWindowAnimateRotatePackageResult(animateDragCallbackParam *adp);
short AGWindowAnimateRotateInitialize(animateDragCallbackParam *adp);
short AGWindowAnimateRotateDraw (animateDragCallbackParam *adp);
short AGWindowAnimateRotateFinish(animateDragCallbackParam *adp);
short AGWindowAnimateDragRotate  (kozoObject *obj, Point startPoint, Point bvOffset, Point adjustOffset, AEDesc *result);

short AGWindowAnimateRotatePackageResult(animateDragCallbackParam *adp)
{
	short err = noErr;
	AEDesc trixDesc = {typeNull, nilPointer};
	AGWindowAnimateArgs *agaa = (AGWindowAnimateArgs *) adp->initArg ;
	err =  makekSanMatrixDescD(&(agaa->ag->windowView.viewMatrix), &trixDesc);
	AEPutKeyDesc(adp->result, pViewMatrix,  &trixDesc);
 	return (err);
}

short AGWindowAnimateRotateInitialize(animateDragCallbackParam *adp)
{
#pragma unused(adp)
 	return (noErr);
}
short AGWindowAnimateRotateFinish(animateDragCallbackParam *adp)
{
#pragma unused(adp)
  	return (noErr);
}
short AGWindowAnimateRotateDraw (animateDragCallbackParam *adp)
{
	short err  = noErr; 
	short delHoriz;
	short delVert;
	AGWindowAnimateArgs *agaa = (AGWindowAnimateArgs *) adp->initArg ;
	if (PtInRgn(adp->nowPoint, agaa->activeRgn)) // do a spin
	{
	//	appSetCursor(kRollCellCursor);
	 	delHoriz = adp->nowPoint.h - adp->pointAtPreviousDraw.h;	
		delVert = adp->nowPoint.v - adp->pointAtPreviousDraw.v;	
		if ((delVert) || (delHoriz)) SpinkSanMatrixInDegreesD(&(agaa->ag->windowView.viewMatrix),  
			((float)delHoriz)/ ((float) agaa->fullHoriz),((float)(- delVert))/((float)agaa->fullVert),  0);	// 0 is spin
			// delVert is negative because the QD coord system has positive pointing down
	}
	else 
	{
		float spinAngle;
	//	appSetCursor(kSpinCellCursor);
		spinAngle = angleBetweenThreeQDPointsInDegreesF (adp->pointAtPreviousDraw, agaa->center, adp->nowPoint);
		SpinkSanMatrixInDegreesD(&(agaa->ag->windowView.viewMatrix),  
			0,0,-spinAngle);	// 0 for lat and long				
			// spinAngle is negative because the QD coord system has positive pointing down
	}
	err = dispatchNilMessage(adp->obj, kDrawWorldMessage);
	return (err);
}

 

void AGWindowDragRotate (AGWindow *ag, viewDoClickArgs *args)
{	
	short err = noErr;
 	short oldColourCalc;
 	AGWindowAnimateArgs agaa;
 	AEDesc result = {typeNull, nilPointer};
	Point noOffset = {0,0};
	Rect worldRect;
  	
  	agaa.ag = ag;
  	agaa.activeRgn = NewRgn();
  	
	kozoGetDataPtr (ag->win->obj, pBufferedBounds, typeQDRectangle, &worldRect, 8L); 	
 	AGWindowSetDragActiveRegion( ag, agaa.activeRgn);
 	agaa.center.h = (worldRect.right + worldRect.left)/2;
 	agaa.center.v = (worldRect.bottom + worldRect.top)/2;
	agaa.fullHoriz = (-1.0/180.0) * (worldRect.right - worldRect.left);
	agaa.fullVert = (1.0/180.0) * (worldRect.bottom - worldRect.top);
	// setMyCursor(kRotateCursor);
 	oldColourCalc = ag->doColourCalc;
//	ag->doColourCalc = false;  // so that we don't recalculate the colour every time
	err = OHMakeAERecord( &result);

	if (!err) 
	{
		dispatchAnimateDrag(ag->win->obj, &agaa, args->cd->localPt, noOffset, noOffset, 
			AGWindowAnimateRotateInitialize, waitMouseUpContinueTestCallback, AGWindowAnimateRotateDraw,
			AGWindowAnimateRotatePackageResult,  AGWindowAnimateRotateFinish, &result);
	}	
 	ag->doColourCalc = oldColourCalc;
 	DisposeRgn (agaa.activeRgn);
 	AEDisposeDesc (&result);
//	setColour(myBlackColour);  
}
	
 	
short AGWindowWasClickInParticle(AGWindow *ag, viewDoClickArgs *args, long * partArrIndex)
{
	long i,j;
	short horiz, vert;
	short notBetweenPts;
	short foundIt = false;
	long *orderListPtr;
	grafData * myGrafData;
	grafData * thisGrafData;
	RgnHandle testRgn;
 	
	testRgn = NewRgn();
	
	myGrafData =AGWindowLockGrafData(  ag);
	agCheckOrderList(ag);
	orderListPtr = lockListC (&ag->orderList, &i);
	
	i = i - 1;
	horiz = args->cd->localPt.h;
	vert = args->cd->localPt.v;
  
	while ((!foundIt) && (i>=0))  // count down from nearest to viewer
	{
		j = orderListPtr[i];
		thisGrafData =  &(myGrafData[j]);
		if (!(thisGrafData->inWindow))
		{
			i = i - 1;  // many i=i-1s so that the loops go fast???
		}
		else
		{
 			notBetweenPts = (( horiz > thisGrafData->circle.right) || ( horiz < thisGrafData->circle.left));
			if (notBetweenPts)
			{
				i = i - 1;
			}
			else 
			{		
				notBetweenPts = (( vert > thisGrafData->circle.bottom) || ( vert < thisGrafData->circle.top));
				if (notBetweenPts)
				{
					i = i - 1;
				}
				else 
				{		
					OpenRgn();  // this timeconsuming operation only occurs if we are very close
					FrameOval(&thisGrafData->circle);
					CloseRgn(testRgn);
					if (PtInRgn(args->cd->localPt, testRgn)) foundIt = true; 
					SetEmptyRgn(testRgn);
					i = i - 1;
				}			
			}
		}
	}
	(*partArrIndex) = thisGrafData->index;
	
	AGWindowReleaseGrafData(  ag);
	releaseList(&ag->orderList);
	DisposeRgn(testRgn);

	return (foundIt);
}
char getCharFromNudgeItem(short theItem)
{
	char aChar;
	switch (theItem)
	{
		case iShiftUp:
			aChar = upArrowKeyCode;
			break;
		case iShiftDown:
			aChar = downArrowKeyCode;
			break;
		case iShiftRight:
			aChar = rightArrowKeyCode;
			break;
		case iShiftLeft:
			aChar = leftArrowKeyCode;
			break;
		case iPullOut:
			aChar = ']';
			break;
		case iPushIn:
			aChar = '[';
			break;
	}
	return (aChar);
}
char getCharFromRollItem(short theItem)
{
	char aChar;
	switch (theItem)
	{
		case iRollUp:
			aChar = '8';
			break;
		case iRollDown:
			aChar = '2';
			break;
		case iRollRight:
			aChar = '6';
			break;
		case iRollLeft:
			aChar = '4';
			break;
		case iRollClockwise:
			aChar = '*';
			break;
		case iRollCClockwise:
			aChar = '/';
			break;
	}
	return (aChar);
}

