#include "kSanAGWindow.h"

short  setupAGHackData(AGWindow *ag, char hack);
short  setupAGHackData(AGWindow *ag, char hack)
{
     short err = noErr;
         OHBufferedView *bv = bvData (ag->win->obj);
     if (hack && (!ag->nowBeingHacked))
     {
             if (!ag->redChannel)   err = makeOffscreenGWorld ( &bv->world->portRect, 16, &ag->redChannel);
           if (!ag->blueChannel)  err = makeOffscreenGWorld ( &bv->world->portRect, 16, &ag->blueChannel);

     }
     else if ((!hack) && (ag->nowBeingHacked))
     {
              if (ag->redChannel)  DisposeGWorld(ag->redChannel );
              if (!ag->blueChannel) DisposeGWorld(ag->blueChannel );
           ag->redChannel = nilPointer;
           ag->blueChannel = nilPointer;
     }
     ag->nowBeingHacked = hack;
     return (noErr);
}

short  AGWindowSetData (KozoDispatchStack *ds, setMethodArgs *sma)
{
	short err = noErr;
	AGWindow *gw = (AGWindow *) ds->thisPD;

	switch (sma->property)
	{
	         case pBounds:
	             {
	                  char oldState = gw->nowBeingHacked;
	                  err = setupAGHackData(gw,false);
	                  dispatchLoop(ds, sma);
	                  if (oldState) err = setupAGHackData(gw,false);
	              }
	              break;
	              
	         case pAGNowHacking:
	              err = setupAGHackData(gw, trueDesc(sma->data));
	              break;
	              
		case pAGParticleList:
			{
				OHList aList;
				initializeList (&aList);
				err = OHCoerceToOHList(sma->data, &aList);
				AGWindowAddParticleList ( gw,  &aList);
				disposeList(&aList);
			}
			break;
		case pIncludeAllParticles:
		        
		        break;
		case pParticleSizeFactor:
		case pShadeRange:
		case pPerspective:
		case pMagnification:
		case pShadeEven:
			{
				float val;
				OHCoerceToFloat (sma->data, &val);
				switch (sma->property)
				{
					case pMagnification:
						gw->windowView.magnification    =  val;
						break;
					case pPerspective:
						 gw->windowView.perspective    = val;
						break;
					case pShadeRange:
						  gw->windowView.shadeRange    = val;
						break;
					case pShadeEven:
						 gw->windowView.neutralShadeDepth    = val;
						break;
					case pParticleSizeFactor:
						 gw->windowView.particleSizeFactor    = val;
						break;
				}
			}
			break;
 	//	case pColourMethodObj:
 		case pColourMethod:
 		case pColourMethodID:
			AGSetColorModule(gw, sma->data);
			break;		         
		case pSizeMethod:
		case pShadeMethod:
			{
				DescType methodID;
				OHCoerceToLong (sma->data, (long *)&methodID);
 				if (!err)  AGSetGraphicsMethod(gw, sma->property, methodID);
			}
			break;
		case pViewMatrix:	
			OHCoerceTokSanMatrixD(sma->data, &(gw->windowView.viewMatrix));
 			break;
		case pViewAngle:					
			{
				kSanVector viewVec;
 				err = OHCoerceTokSanVectorD(sma->data, &viewVec);
				if (!err)
				{
  #ifndef __2DVectors__
 					SetkSanMatrixInDegreesD(viewVec.a, viewVec.b, viewVec.c,&(gw->windowView.viewMatrix));
#else
					SetkSanMatrixInDegreesD(viewVec.a, viewVec.b, 0, &(gw->windowView.viewMatrix));
#endif
				}
			}
			break;
		case pMinimumColour:
		case pMaximumColour:
			 err = kozoSetData(OHGetNamedReference(ds->obj, ClassColourPlugIn) , sma->property, sma->data );
			break;
		default:
			KDSReturnContinue(ds);
		         break;
	}

	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}

short AGSetColourPlugIn( AGWindow *ag, DescType  colourClassID)
{
	short err = noErr;
	kozoObject *newCPI;
 	
 	newCPI = kozoObjectGetNthItemOfClassX ( ag->win->obj, colourClassID, 0L);
 	if (!newCPI) kozoNewNoData(&newCPI, colourClassID, ag->win->obj);    
    	err =  AGWinInstallModule (ag, ClassColourPlugIn, newCPI);

	return (err);
}
short AGSetColourMethodMenuChoice(AGWindow *gw,  short menuIndex)
{
	short err = noErr;
	unsigned short theIndex = menuIndex ;
	OHList *cpiList;
	kozoClass * colourClass;

	cpiList = getSubclassList (ClassColourPlugIn);	
	if (theIndex > OHListCount(cpiList))theIndex = 0;
	if (theIndex) colourClass = castTokozoClass (getNthItem (cpiList, theIndex - 1));
	else  colourClass = getClassPtr(ClassColourPlugIn);
	err = AGSetColourPlugIn(gw, colourClass->classID);
	return (err);
}

void AGSetMouseMode(AGWindow *gw, DescType whichMode)
{
	gw->mode = whichMode;
	dispatchNilMessage ( gw->win->obj  , kSetMouseModeButtonsMessage);
}

/*
void AGSetCenter(kozoObject *agObj,AGWindow *gw, short hVal, short vVal)
{
	 gw->windowView.cellCenter.h = hVal;
	 gw->windowView.cellCenter.v = vVal;
}
*/

void   AGSetViewMatrix(AGWindow *gw, kSanMatrix *trix)
{
      gw->windowView.viewMatrix    = *trix;
}

short AGSetSizeMethod (AGWindow *gw, long enumeratedID)
{
	gw->windowView.sizeMethod = enumeratedID;
	switch (gw->windowView.sizeMethod)
	{
 		case kSizeByWindow:
 			gw->setMySize = setMySizeByWindow;
 			gw->setMyActualSize = setMyActualSizeByWindow;
 			break;
		case kNoSize:
			gw->setMySize = setNoSize;
			gw->setMyActualSize = setNoActualSize;
			break;
		default:
		case kSizeByAtomType:
			gw->setMySize = setMySizeByAtomType;
			gw->setMyActualSize = setMyActualSizeByAtomType;
			break;
	}
	return (noErr);
}
short AGSetShadeMethod (AGWindow *gw, long enumeratedID)
{
	gw->windowView.shadeMethod = enumeratedID; // boolean
	switch (gw->windowView.shadeMethod)
	{
#ifndef __2DVectors__ 
		case kShadeByDepth:
			gw->setForeColour = setForeColourWithShade;
			break;			
#endif
		case kNoShade:
		default:
			gw->setForeColour= setForeColourNoShade;
			break;
	}			
	return (noErr);
}
short AGSetGraphicsMethod (AGWindow *gw, long descriptorType, long enumeratedID)
{
	short err = 0;
	switch (descriptorType)
	{
		case pSizeMethod:
			AGSetSizeMethod( gw, enumeratedID);
			break;
		case pShadeMethod:
			AGSetShadeMethod(  gw, enumeratedID);
			break;
		default:
			err = true;
			break;
	}
	return err;
}
 short  AGSetView  (AGWindow*gw, viewInfo *theView)
{
	gw->windowView = *theView;
	return (noErr);
}

short  AGSetColorModule( AGWindow *ag,  const  AEDesc *dataDesc)
{
	short err = noErr;
	DescType classID;
	kozoObject *obj;
	err = OHCoerceTokozoObject (dataDesc, &obj);
	if (!err)  AGWinInstallModule ( ag, ClassColourPlugIn, obj);
 	else
	{
		err =  kSanResolveModule ( ClassColourPlugIn, dataDesc, &classID);
		if (!err)  AGSetColourPlugIn( ag, classID);	
	}
	return (err);
}
short  AGWinInstallModule (AGWindow *ag, DescType whichModule, kozoObject *newPlugIn)
{  // here, we've separated the plug-in ownership from the identity in the pointers
 	 OHStoreUniqueReference (newPlugIn, ag->win->obj, whichModule);   // clone paired with unclone
	switch (whichModule)
	{
		case ClassColourPlugIn:
  			 if (newPlugIn) ag->cpi  = cpiData(newPlugIn);
 			 else ag->cpi  = nilPointer;
 			break;
		default:
			 OHUnstoreReference (newPlugIn, ag->win->obj, whichModule);
 	}
 	return (noErr);
}

void AGSetBondsVisible	(AGWindow *ag, short viz)
{
	ag->windowView.showBonds = viz;
	dispatchNilMessage (   ag->win->obj , kMaintainMenusMessage);
}

void AGWindowSetShowBondsMenuItem (AGWindow *ag)
{
	short theID;
	short nowShowing ;
	 nowShowing = ag->windowView.showBonds;
	if (nowShowing)
	{
		theID = kHideBondsStringID ;
	}
	else
	{
		 theID = kShowBondsStringID ;
	}
	 setMenuToSTR( iBondsMenuItem, theID, "\p bond visability");
}

void AGWindowSetMouseMode(AGWindow *ag)
{
	short theID;
	DescType whichMode;
	
	whichMode = ag->mode ;
	switch (whichMode) 
	{
		case kSelectAndHighlightMode:
			theID =  kMouseManipulationStringID ;
			break;
		case kMouseManipulationMode:
			theID = kSelectAndHighlightStringID ;
			break;
	}
	SetAllMouseModeButtons( ag);
	 setMenuToSTR( iMouseModeMenuItem, theID , "\p mouse mode");
}

short AGWindowGetData (KozoDispatchStack *ds, getMethodArgs *gma)
{
	short err = noErr;
	AGWindow *gw = (AGWindow *) ds->thisPD;
	switch (gma->property)
	{
		case pAGParticleList:
		        agCheckPartList(gw);
			err = OHListToAEDesc(&gw->particleList, gma->result);
			break;
		case pViewMatrix:	
			err = makekSanMatrixDescD(&gw->windowView.viewMatrix, gma->result);
			break;
		case pParticleSize:
			err = AECreateDesc(typeShortFloat, &gw->windowView.particleSizeFactor,sizeof(float), gma->result);
			break;
		case pShadeRange:
			err = AECreateDesc(typeShortFloat, &gw->windowView.shadeRange,sizeof(float), gma->result);
			break;
		case pPerspective:
			err = AECreateDesc(typeShortFloat, &gw->windowView.perspective,sizeof(float), gma->result);
			break;
		case pMagnification:
			err = AECreateDesc(typeShortFloat, &gw->windowView.magnification,sizeof(float), gma->result);
			break;
		case pShadeEven:
			err = AECreateDesc(typeShortFloat, &gw->windowView.neutralShadeDepth,sizeof(float), gma->result);
			break;
		case pMinimumColour:
		case pMaximumColour:
			 err = kozoGetData(OHGetNamedReference(ds->obj, ClassColourPlugIn), gma->property, gma->result );
			break;
		case pColourMethodID:
			err = kozoGetData(OHGetNamedReference(ds->obj, ClassColourPlugIn), pClass, gma->result);
			break;
		case pColourMethod:
			err = kozoGetData(OHGetNamedReference(ds->obj, ClassColourPlugIn), pReference, gma->result);
			break;
//		case pColourMethodObj:
//			err =  AECreateDesc (typekozoObjectPtr, &gw->cpiObj, sizeof(gw->cpiObj) , gma->result);
//			break;
		case pSizeMethod:
			err = AECreateDesc(typeLongInteger, &gw->windowView.sizeMethod, sizeof(long), gma->result);
			break;
		case pShadeMethod:
			err = AECreateDesc(typeLongInteger, &gw->windowView.shadeMethod, sizeof(long), gma->result);
			break;
		default:
		KDSReturnContinue(ds);
		         break;
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}
 