#include <string.h>
#include "OHApplicationPublic.h"
#include "kSanApplication.h"


RGBColor **lockColours(void) 
{
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
	RGBColor **myPtr;
 	myPtr = (RGBColor **)lockList(&kSanApp->colours);
	return (myPtr);
}
void releaseColours(void) 
{
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
 	releaseList(&kSanApp->colours);
}
Pattern **lockPatterns(void) 
{
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
	Pattern **myPtr;
	myPtr = (Pattern **)lockList(&kSanApp->patterns);
	return (myPtr);
}
void releasePatterns(void) 
{
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
	releaseList(&kSanApp->patterns);
}

void setColour(short index)
{
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
	RGBColor aColour;
	aColour = *(   ((RGBColor **)(*kSanApp->colours.listData))[index]  );	
	RGBForeColor(&aColour);
}
RGBColor randomColour(void)
{
	RGBColor theColour;
	theColour.red = getRandomShort( 65535);
	theColour.blue = getRandomShort( 65535);
	theColour.green = getRandomShort( 65535);
	return (theColour);
}
RGBColor newColour(short index)
{
	RGBColor theColour;
	if (index<= 60) theColour = getColour  (index);
	else theColour = randomColour();
	return(theColour);	
}
RGBColor getColour(short index)
{
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
	RGBColor aColour;
	aColour = *(   ((RGBColor **)(*kSanApp->colours.listData))[index]  );		 
	return  (aColour);	
}

short myPickAColor(RGBColor *theColor, unsigned char * displayText) 
{
	ColorPickerInfo cpInfo;
	short err=noErr;
	
	cpInfo.theColor.color.rgb.red=theColor->red;
	cpInfo.theColor.color.rgb.green=theColor->green;
	cpInfo.theColor.color.rgb.blue=theColor->blue;
	cpInfo.theColor.profile=0L;
	cpInfo.dstProfile=0L;
	cpInfo.flags= kColorPickerAppIsColorSyncAware | kColorPickerCanModifyPalette | kColorPickerCanAnimatePalette;
	cpInfo.placeWhere=kDeepestColorScreen;
	cpInfo.pickerType=0L;
	
	cpInfo.eventProc=0L;
	cpInfo.colorProc=0L;
	cpInfo.colorProcData=0L;
	strcpy (((char*)cpInfo.prompt), ((const char *)displayText));
	
	cpInfo.mInfo.editMenuID=3;
	cpInfo.mInfo.cutItem=3;
	cpInfo.mInfo.copyItem=4;
	cpInfo.mInfo.pasteItem=5;
	cpInfo.mInfo.undoItem=2;
	cpInfo.mInfo.clearItem=6;
	
	if (PickColor(&cpInfo)==noErr && cpInfo.newColorChosen)
		theColor->red=cpInfo.theColor.color.rgb.red;
		theColor->green=cpInfo.theColor.color.rgb.green;
		theColor->blue=cpInfo.theColor.color.rgb.blue;
	return (err);
}


void setPattern(short index)
{
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
	Pattern aPat;
	aPat = ( (*(Pattern **)(*kSanApp->colours.listData))[index]);	
	PenPat(&aPat);
}
Pattern getPattern(short index)
{
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
	return( (*(Pattern **)(*kSanApp->patterns.listData))[index]);	
}

kozoObject *getFrontSim (void)
{ 
	kozoObject *fSim = nilPointer;
	OHList *simList;
	simList = getListOfObjectsOfClassX (globalAppObject, ClassSimulation);
	if (simList) 
	{
		if (OHListCount(simList ) > 0) fSim = castTokozoObject( getNthItem (simList, kFirstInList));
		releaseListOfObjectsOfClassX (globalAppObject, ClassSimulation);
	}
	return (fSim);
}
