#include "kSanObject.h"
#include "kSanApplication.h"
void insertRGB(kSanApplication *kSanApp, RGBColor *newRGB);
void insertColour(kSanApplication *kSanApp, short r, short g, short b);
void makeMyAlias (FSSpec *theSpec);

void initPatterns(kSanApplication *kSanApp)
{
	short k;
	Pattern *patPtr;
	PatHandle aPat;
 	initializeList(&kSanApp->patterns);
   	for (k = 0; k<9; ++k)
   	{ 
   		patPtr = (Pattern *) NewPtr (sizeof(Pattern));
   		aPat = GetPattern(kBaseResID + k);
   		HLock ((Handle)aPat);
   		BlockMove (*aPat, patPtr, (sizeof(Pattern)));
   		addToList (&kSanApp->patterns, (long) patPtr);
   		HUnlock ((Handle)aPat);
   		ReleaseResource((Handle)aPat);
   	}
}
void insertRGB(kSanApplication *kSanApp, RGBColor *newRGB)
{
	RGBColor *rgb;
 	if (kSanApp)
	{
		rgb = (RGBColor *) NewPtr (sizeof(RGBColor));
		*rgb = *newRGB;
		addToList (&kSanApp->colours, (long )rgb);
	}
}
void insertColour(kSanApplication *kSanApp, short r, short g, short b)
{
	RGBColor rgb;
	rgb.red = r;
	rgb.green = g;
	rgb.blue = b;
	insertRGB (kSanApp, &rgb);
}
void disposePatterns(kSanApplication *kSanApp)
{
	Ptr nthPtr;
 	while (OHListCount(&kSanApp->patterns) > 0)
	{
		nthPtr = (Ptr) popTopItem(&kSanApp->patterns);
		DisposePtr (nthPtr);
	}
	disposeList(&kSanApp->patterns);
}
void disposeColours(kSanApplication *kSanApp)
{
	Ptr nthPtr;
 	while (OHListCount(&kSanApp->colours) > 0)
	{
		nthPtr = (Ptr) popTopItem(&kSanApp->colours);
		DisposePtr (nthPtr);
	}
	disposeList(&kSanApp->colours);
}
void initColours(kSanApplication *kSanApp)
{
 	initializeList(&kSanApp->colours);

	insertColour( kSanApp, 0xFFFF, 0xFFFF, 0xFFFF);
	insertColour( kSanApp, 0xDFFF, 0xDFFF, 0xDFFF);
	insertColour( kSanApp,0xFFFF, 0x4000, 0x4000);
	insertColour( kSanApp, 0x4000, 0xFFFF, 0x4000);
	insertColour( kSanApp, 0x4000, 0x4000, 0xFFFF);
	insertColour( kSanApp, 0x2241, 0xCB54, 0xFFFF);
	insertColour( kSanApp, 0xFFFF, 0x1856, 0xA0EC);
	insertColour( kSanApp,0xFFFF, 0xFFFF, 0x252F);
	insertColour( kSanApp,  0x0000,  0x0000,  0x0000);
	insertColour( kSanApp, 0xC000, 0xC000, 0xC000);
	insertColour( kSanApp, 0x6000, 0xFFFF, 0xC000);
	insertColour( kSanApp, 0xFFFF, 0xD000, 0x4000);
	insertColour( kSanApp, 0x4000, 0xFFFF, 0xD000);
	insertColour( kSanApp, 0xD000, 0x4000, 0xFFFF);
	insertColour( kSanApp, 0xFFFF, 0x9000, 0x9000);
	insertColour( kSanApp, 0x9000, 0x9000, 0xFFFF);
	insertColour( kSanApp, 0x9000, 0xFFFF, 0x9000);
	insertColour( kSanApp, 0x2241, 0xFFFF, 0xCB54);
	insertColour( kSanApp, 0xFFFF, 0xA0EC, 0x1856);
	insertColour( kSanApp, 0xFFFF, 0x252F, 0xC000);
	insertColour( kSanApp, 0x0000, 0xA6A2, 0x11B0);
	insertColour( kSanApp, 0x9000, 0xFFFF, 0x9000);
	insertColour( kSanApp, 0xFFFF, 0xFFFF, 0x8000);
	insertColour( kSanApp, 0xFFFF, 0x8000, 0xFFFF);
	insertColour( kSanApp, 0x8000, 0xFFFF, 0xFFFF);
	insertColour( kSanApp, 0xFFFF, 0xA000, 0xA000);
	insertColour( kSanApp, 0xA000, 0xA000, 0xFFFF);
	insertColour( kSanApp, 0xA000, 0xFFFF, 0xA000);
	insertColour( kSanApp, 0xFFFF, 0xB000, 0x9000);
	insertColour( kSanApp, 0x9000, 0xB000, 0xFFFF);
	insertColour( kSanApp, 0xA000, 0x0000, 0xFFFF);
	insertColour( kSanApp,0xFFFF, 0x0000, 0xA000);
	insertColour( kSanApp, 0xFFFF, 0xA000, 0x0000);
	insertColour( kSanApp, 0x0000, 0xA000, 0xFFFF);
	insertColour( kSanApp, 0x7FFF, 0x7FFF, 0x4000);
	{
		short i;
		RGBColor gradedC;
		float fraction;
		insertColour( kSanApp, 0x3000, 0x3000, 0x3000);
		for (i=1;i<4;++i)
		{
			fraction = ((float) i ) * 0.33; // ranges up to one
			gradedC.red = 0x2000 + (fraction * (float) 0x3000);
			gradedC.blue = 0x1FFF + (fraction * (float) 0xA000);
			gradedC.green = 0x2000;
			insertRGB( kSanApp, &gradedC);
		}
		for (i=4;i<8;++i)
		{
			fraction = (((float) i - 3.0 )) * 0.25; // ranges up to one
			gradedC.red = 0x5000 - (fraction * (float) 0x4000);
			gradedC.blue = 0xBFFF - (fraction * (float) 0x5000);
			gradedC.green = 0x1FFF + (fraction * (float) 0xA000);
			insertRGB( kSanApp, &gradedC);
		}
		for (i=8;i<12;++i)
		{
			fraction = (((float) i ) - 7.0 ) * 0.25; // ranges up to one
			gradedC.blue = 0x7000 - (fraction * (float) 0x4000);
			gradedC.green = 0xBFFF - (fraction * (float) 0xA000);
			gradedC.red = 0x2000 + (fraction * (float) 0x9000);
			insertRGB( kSanApp, &gradedC);
		}
		for (i=12;i<16;++i)
		{
			fraction = (((float) i ) - 11.0 ) * 0.25; // ranges up to one
			gradedC.blue = 0x0000;
			gradedC.green = 0x2000 + (fraction * (float) 0x9000);
			gradedC.red = 0xA000 + (fraction * (float) 0x2800);
			insertRGB( kSanApp, &gradedC);
		}
		for (i=16;i<20;++i)
		{
			fraction = (((float) i ) - 15.0 ) * 0.25; // ranges up to one
			gradedC.blue = 0x2000 + (fraction * (float) 0x3000);
			gradedC.green = 0xB000 + (fraction * (float) 0x3000);
			gradedC.red = 0xC800 + (fraction * (float) 0x27FF);
			insertRGB( kSanApp, &gradedC);
		}
		for (i=20;i<25;++i)
		{
			fraction = (((float) i ) - 19.0 ) * 0.2; // ranges up to close to one
			gradedC.blue = 0x5000 + (fraction * (float) 0x9000);
			gradedC.green = 0xE000 + (fraction * (float) 0x1FFF);
			gradedC.red = 0xFFFF  ;
			insertRGB( kSanApp, &gradedC);
		}
	}
}

