
#include <Sound.h>
#include "OHMenu.h"
//#include "OHUPP.h"
#include "OHAELauncher.h"
#include "OHMenuItem.h"
#include "OHApplication.h"
#include "kSanApplication.h"
#include "kSanSimulationPublic.h"
#include "MacOSUtils.h"
#include "kSanAtomtype.h"
#include "kSanSimAtomtypes.h"
//#include "kSanScript.h"
#include "kSanDialog.h"
#include "kSanFilePlugIn.h"

void handleAboutPlugInsChoice(short item);
void insertHeirarchical(short menuID,short subMenuID, short menuItem);
short	kSanHandleFileExportChoice(  long item);
short	kSanHandleFileImportChoice(  long item);
short kSanFileMenu (kozoObject *mBarObj);
short	kSanHandleNewMenuChoice(void );
 
short kSanMenuInstall (void)
{
	short err = noErr;
	
	kozoObject *mBarObj = getMenuBarRef();
	if (mBarObj)
	{
	  	 err = kSanFileMenu(mBarObj);
		if (!err) OHAppAddEditMenu();
	 	if (!err) initParticleMenu(mBarObj);
	 	if (!err) initSimMenu(mBarObj);
	 	if (!err) initAGMenu(mBarObj);
	 	if (!err) addScriptsMenu();
	}
	return (err);
}

 
short kSanFileMenuPlugInCallback (kozoClass *nthPlug,  kozoObject *importMenu , kozoObject *exportMenu);
short kSanFileMenuPlugInCallback (kozoClass *nthPlug,  kozoObject *importMenu , kozoObject *exportMenu)
{
	short err = noErr;

	AEDesc nameDesc = {typeNull, nilPointer};
	long menuItemIndex;
	long numArgs = 1;
	ProcPtr theProc;
	kozoObject *newItem;

	if  (!nthPlug->classID != ClassFilePlugIn) // dont add the virtual class to the menu
	{
		OHStringGetAEDesc(nthPlug->obj->name, typeIntlText, &nameDesc);
		err = kozoNewOneDatum(&newItem, ClassMenuItem, importMenu, pName, &nameDesc);
		if (!err)
		{
			dispatchCount(importMenu, ClassMenuItem, &menuItemIndex);
			theProc = (ProcPtr)kSanHandleFileImportChoice;
			if (newItem) err = kozoSetDataPtr (newItem, pProcPtr, typeProcPtr, &(theProc), sizeof(long));
			if (newItem) err = kozoSetDataPtr (newItem, pNumArgs, typeLongInteger, &numArgs, sizeof(long));
			if (newItem) err = kozoSetDataPtr (newItem, pArgument1, typeLongInteger, &menuItemIndex, sizeof(long));
		}
		err = kozoNewOneDatum(&newItem, ClassMenuItem, exportMenu, pName, &nameDesc);
		if (!err)
		{
			dispatchCount(importMenu, ClassMenuItem, &menuItemIndex);
			theProc =  (ProcPtr)kSanHandleFileExportChoice;
			if (newItem) err = kozoSetDataPtr (newItem, pProcPtr, typeProcPtr, &(theProc), sizeof(long));
			if (newItem) err = kozoSetDataPtr (newItem, pNumArgs, typeLongInteger, &numArgs, sizeof(long));
			if (newItem) err = kozoSetDataPtr (newItem, pArgument1, typeLongInteger, &menuItemIndex, sizeof(long));
		}
		AEDisposeDesc (&nameDesc);
	}
	return (err);
}

short kSanFileMenu (kozoObject *mBarObj)
{
	short err = noErr;
  	
	kozoObject *aMenu = nilPointer;
	kozoObject *anItem = nilPointer;
	kozoObject *importMenu = nilPointer;
	kozoObject *exportMenu = nilPointer;
	
  	if (mBarObj) kozoNewWithCName(&aMenu, ClassMenu, mBarObj, "File");
       if (aMenu) 
      {
// new item
	    anItem = OHMenuCreateMenuItem(aMenu,  "\pNew", 'N', true);
		if (anItem) OHProcSetProc0Args (anItem, (ProcPtr)OHAppHandleNewMenuChoice );
// open item	
 	    anItem = OHMenuCreateMenuItem(aMenu,  "\pOpen", 'O', true);
		if (anItem) OHProcSetProc0Args (anItem, (ProcPtr)OHAppHandleOpenMenuChoice );
 	OHMenuAddADivider(aMenu);
// close item	
 	    anItem = OHMenuCreateMenuItem(aMenu,  "\pClose", 'W', true);
		// if (anItem) OHProcSetProc2Args (anItem, (ProcPtr)OHAppHandleFrontDocEvent,  kAECoreSuite, kAEClose);
	 if (anItem) OHProcSetProc0Args (anItem, (ProcPtr)OHAppHandleCloseMenuChoice );
// save item	
  	    anItem = OHMenuCreateMenuItem(aMenu,  "\pSave", 'S', true);
		if (anItem) OHProcSetProc2Args (anItem, (ProcPtr)OHAppHandleFrontDocEvent, kAECoreSuite, kAESave);
 //save as
  	    anItem = OHMenuCreateMenuItem(aMenu,  "\pSave as", 0L , true);
		if (anItem) OHProcSetProc0Args (anItem, (ProcPtr)OHAppHandleSaveAsMenuChoice );
// divider	
	OHMenuAddADivider(aMenu);
// print item	
   	    anItem = OHMenuCreateMenuItem(aMenu,  "\pPrint", 'P', true);
		if (anItem) OHProcSetProc2Args (anItem, (ProcPtr)OHAppHandleFrontDocEvent,  kAECoreSuite, kAEPrint);
// divider	
	OHMenuAddADivider(aMenu);
	
	if (!err) err =  kozoNewWithCName(&importMenu, ClassSubmenu, aMenu, "Import");
	if (!err) err =  kozoNewWithCName(&exportMenu, ClassSubmenu, aMenu, "Export");

	if (!err)
	{
		OHList *plugList;
		plugList = getSubclassList (ClassFilePlugIn);
		if (plugList) OHListEveryItemDoTwoArgs( plugList, kSanFileMenuPlugInCallback ,   importMenu,  exportMenu);
	}							
// divider	
	OHMenuAddADivider(aMenu);
							
// quit item	
	    anItem = OHMenuCreateMenuItem(aMenu,  "\pQuit", 'Q', true);
		if (anItem) OHProcSetProc3Args (anItem, (ProcPtr)launchMenuEvent,  nilPointer, kRequiredEventClass, kAEQuitApplication);
	}
	return (err);
}


/************  CloseMenuChoice   ****************/
short	kSanHandleNewMenuChoice(void )
{
	short err = noErr;
	kozoObject *theObj = nilPointer;
	char trueBool = true;
	err = UINewObject(ClassSimulation,   nilPointer,   nilPointer,   (&theObj), kAEBeginning);
	dispatchNilMessage (theObj, kSanSimDoInitialCellMessage);
	return (err);
}

void handleAboutPlugInsChoice(short item)
{
	kSanPlugFile *plugFile;

	plugFile = (kSanPlugFile *) getNthItem(&plugFileList, item - 1);
	if (plugFile->doAboutPlugIn) plugFile->doAboutPlugIn(plugFile);
	else SysBeep(20);
}


short	kSanHandleFileExportChoice( long item)
{
	short err = noErr;
	kozoClass * plugClass;
	kozoObject  *simuObj= nilPointer;
	kozoObject  *plug = nilPointer;
	OHList *filePlugIns;
	kSanIOArgs io;
	 simuObj=  getFrontSim();
	 if (simuObj)
	 {
		io.sim = simData(simuObj);
		io.useThisFile = false;
 		filePlugIns = getSubclassList(ClassFilePlugIn);
		plugClass = (kozoClass *) getNthItem(filePlugIns, item - 1);
		err = kozoNewNoData (&plug, plugClass->classID,  globalAppObject);
		if (!err) err = kozoDoMessage (plug, kSaveMessage,  typekSanIOArgsPtr,  &io);
		if (plug) kozoDispose (plug);
	}
 	else err = true;
	return (err);
}

short	kSanHandleFileImportChoice	(long item)
{
	short err = noErr;
	kozoClass *  plugClass;
	kozoObject  *simuObj= nilPointer;
	kozoObject  *plug;
 	OHList *filePlugIns;
 	kSanIOArgs io;
	
	filePlugIns =  getSubclassList(ClassFilePlugIn);
	plugClass = castTokozoClass (getNthItem(filePlugIns, item - 1));
	err = kozoNewNoData (&plug, plugClass->classID, globalAppObject );
	if (!err)
	{
		 err = kozoNewNoData (&simuObj, ClassSimulation, globalAppObject );
		 if (!err)
		 {
		 	io.sim = simData(simuObj);	
		 	io.useThisFile = false;
 			err = kozoDoMessage (plug, kLoadMessage,  typekSanIOArgsPtr,  &io);
			if (err) kozoDispose(simuObj);
			else dispatchNilMessage (simuObj, kActivateMessage);
		}
 		kozoDispose (plug);
	}
	return (err);
}

