
#include "kSanObject.h"
#include "OHApplicationPublic.h"
#include "kSanApplication.h"
#include "kSanAtomtype.h"
#include "kSanAEHandlers.h"
short addPlugInAetes(long langCode, AEDesc *aeteList);

 
short initClasskSanApplication(void) // constructor
{
//	appData = &thisAppData; now in app constructor
	
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co; 

	newClass = addClass(&co,ClasskSanApplication, ClassApplication, sizeof (kSanApplication), "kSan application");
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  kSanAppConstructor,
		kSanAppDestructor, kSanAppGetData, nilPointer, kSanAppDoMessage,
		 nilHandleReportFunc, nilCountFunc, nilResolveFunc, nilCreateElementFunc);
	}
	return (err);
}

short kSanAppConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
	short err = noErr;
 	short rezID = noErr;	
 	long fiveTicks = 5;
 	long thirtyTicks = 30;
   	DescType dpDocType = ClassSimulation;
    kSanApplication *kSanApp = ( kSanApplication *) ds->thisPD;
 	
  	insertParam (cma->initialData, pDefaultDocumentType, typeType, &dpDocType, sizeof(DescType));
  	insertParam (cma->initialData, pSleepTicks, typeLongInteger, &fiveTicks, sizeof(long));
  	insertParam (cma->initialData, pRunTicks, typeLongInteger, &thirtyTicks, sizeof(long));
  	insertParam (cma->initialData, pThreadTicks, typeLongInteger, &thirtyTicks, sizeof(long));
	kSanApp->paddingHandle = NewHandle(5000); 
	kSanApp->emergencyHandle= NewHandle(5000); 
	kSanApp->plugMenuRefCount = 0;
	kSanApp->kSanAETE = gNilDesc;
	OHMakeAERecord(&kSanApp->kSanAETE);
	err = dispatchLoop(ds, cma);
	

	initPatterns(kSanApp);
	initColours(kSanApp);
    kSanCursorInit( );
	KDSReturnError(ds,err);
}
long plugMenuRefCountAdd(long val) 
{
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
	kSanApp->plugMenuRefCount += val;
	return (kSanApp->plugMenuRefCount);
}
short kSanAppDestructor (KozoDispatchStack *ds, destructorMethodArgs* dma)
{
#pragma unused(dma)
          kSanApplication *kSanApp = ( kSanApplication *) ds->thisPD;
	
	disposePatterns(kSanApp);
	disposeColours(kSanApp);
	OHDisposeHandle (&kSanApp->paddingHandle);
	OHDisposeHandle (&kSanApp->emergencyHandle);
	KDSReturnContinue(ds);
}

short kSanAppGetData (KozoDispatchStack *ds, getMethodArgs *gma)
{
	short err = noErr;
	kSanApplication *kSanApp = kSanAppData(globalAppObject);
	switch (gma->property)
	{
		case  'aete' :
		    {
			    AEDesc nthDesc = gNilDesc;
		        long langCode  = gma->desiredType;
		        
			    err = AEGetKeyDesc ( &kSanApp->kSanAETE, langCode, typeAEList, gma->result);
			    if (err) // the result was not found previously
			    {
		 		    err = dispatchLoop(ds, gma);
		 			if (!err) err =  addPlugInAetes(langCode, gma->result);
			    	if (!err) AEPutKeyDesc( &kSanApp->kSanAETE, langCode, gma->result);
			    }
		    }
			break;
		default:
			KDSReturnContinue(ds);
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}

 
short addPlugInAetes(long langCode, AEDesc *aeteList)
{
	Handle aeteHandle = nilPointer;
	OHFile *nthFile;
	short rezID;
	short err = noErr;
	long numAetes = 0;
	useAppResFile();
	rezID = getResIDFromLangCode(langCode);
    if (! err) 
    {	
		short i;
		long count;
				
		count = OHListCount(&plugFileList);
		for (i = 0; i< count; ++i)
		{
			nthFile = (OHFile *)getNthItem(&plugFileList, i);
			err = useResFile (nthFile);
			if (!err)
			{
				 err = addAeteOfCurrentResFile(rezID, aeteList); 
				usePreviousResFile(nthFile);
			}
		}
	}
	 unuseAppResFile ( ) ;
	return(err);
}

short kSanAppTryImport (OHOpenDocumentInfo *oDocInfo);
short kSanAppTryImport (OHOpenDocumentInfo *oDocInfo)
{
#pragma unused(oDocInfo)
	short err = noErr;
	return(err);
}
short kSanAppDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma)
{
	short err = noErr;
           kSanApplication *kSanApp = ( kSanApplication *) ds->thisPD;
	switch (dmma->message)
	{
		case kOpenAppMessage:
			dispatchLoop(ds,dmma);
			kSanMenuInstall();
			break;
		case kOpenDocumentMessage: // check if its a plug-in type or version 1 type...
			err = dispatchLoop(ds, dmma);
			if (err) err = kSanAppTryImport( (OHOpenDocumentInfo *)dmma->data );
			break;
		default :
			KDSReturnContinue(ds);
			break;
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}

short yieldToSimulationThread (kozoObject *simuObj);
short yieldToSimulationThread (kozoObject *simuObj)
{
	kSanSimulation *sim = simData(simuObj);
	OHAppPushThread(globalAppObject, (sim->iterationThreadID));
	return (noErr);
}

void yieldToSimulationThreads (void)
{
	OHList *simList;
	simList = getListOfObjectsOfClassX(globalAppObject, ClassSimulation);
	
	if (simList)   
	{
		OHListEveryItemDoNoArgs( simList, yieldToSimulationThread);
		 releaseListOfObjectsOfClassX (globalAppObject, ClassSimulation);
		}
	yieldToThread(true);
}

