#include <string.h>
#include <memory.h>
#include "OHSharedUtils.h"
#include "kSanObject.h"
//#include "kSanApplicationPublic.h"
//#include "kSanSimulationPublic.h"
#include "kSanAtomtype.h"
#include "kSanDialog.h"
#include "OHList.h"

// atomtypes
short AtomtypeDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma);

void  setNthAtomtype(long  thisIndex, typespecs * theSpecs);
void  getTypespecValues(DialogPtr dialog, typespecs *tempSpecs);
void  	insertTypespecValues(DialogPtr dialog,  typespecs *tempSpecs);
void  addPopupItem(MenuHandle aMenu);
MenuHandle   buildAtomTypesMenu(short withNewType);

void setPopupText(MenuHandle aMenu, short rezID);

short initClassAtomTypes(void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClassAtomType, ClassKozoObject, sizeof (kSanAtomtype), "atomtype");
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  AtomtypeConstructor,
		nilPointer, AtomtypeGetData, AtomtypeSetData, nilPointer,
		 nilHandleReportFunc, nilCountFunc, nilResolveFunc, nilCreateElementFunc);

		err =  kozoClassAddRemove3ItemsToSave(newClass, true,  pAtomicNumber, pAtomicSymbol, pAtomicMass);
		err =  kozoClassAddRemove3ItemsToSave(newClass, true,  pAtomicRadius,  pAtomicDrawingRadius,   pColor);
	}
	else
	{
		err = true;
	}
	return (err);
}

short AtomtypeConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
#pragma unused(cma)
	short err = noErr;
 	kSanAtomtype *at = (kSanAtomtype *) ds->thisPD;
  	
	defaultTypespecs(at);
         at->atObj = ds->obj;
	KDSReturnError(ds,err);
}

void defaultTypespecs (kSanAtomtype *at)
{
	at->specs.mass = 40;
	at->specs.inverseMass = 1.0 / at->specs.mass;
	at->specs.colour.red = 50000;
	at->specs.colour.green = 30000;
	at->specs.colour.blue = 60000;
	at->specs.drawingRadius = 1.5;
	at->specs.radius = 2.5;
	at->specs.atNumber = 18;
}


short AtomtypeGetData (KozoDispatchStack *ds, getMethodArgs *gma)
{
	short err = noErr;
 	kSanAtomtype *at = (kSanAtomtype *) ds->thisPD;
	switch (gma->property)
	{
		case pAtomicNumber :
			err = AECreateDesc(typeShortInteger, &at->specs.atNumber, sizeof(short), gma->result);
			break;
		case pAtomicSymbol :
			err = AECreateDesc(typeChar, at->specs.symbol, strlen(at->specs.symbol), gma->result);
			break;
		case  pAtomicMass :
			err = AECreateDesc(typeLongFloat, &at->specs.mass, sizeof(double), gma->result);
			break;
		case  pAtomicRadius  :
			err = AECreateDesc(typeLongFloat, &at->specs.radius, sizeof(double), gma->result);
			break;
		case  pAtomicDrawingRadius :
			err = AECreateDesc(typeLongFloat, &at->specs.drawingRadius, sizeof(double), gma->result);
			break;
		case  pColor :
			err = AECreateDesc(typeRGBColor, &at->specs.colour, sizeof(RGBColor), gma->result);
			break;
		default: 
			KDSReturnContinue(ds);
			break;
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}
short AtomtypeSetData (KozoDispatchStack *ds, setMethodArgs *sma)
{
	short err = noErr;
 	kSanAtomtype *at = (kSanAtomtype *) ds->thisPD;
	switch (sma->property)
	{
		case pAtomicNumber :
			err = OHCoerceToShort(sma->data, &at->specs.atNumber);
			break;
		case pAtomicSymbol :
			err = OHCoerceToCString(sma->data, at->specs.symbol, 6);
			break;
		case  pAtomicMass :
			err = OHCoerceToDouble(sma->data, &at->specs.mass);
			at->specs.inverseMass = 1.0 / at->specs.mass;
			break;
		case  pAtomicRadius  :
			err = OHCoerceToDouble(sma->data, &at->specs.radius);
			break;
		case  pAtomicDrawingRadius :
			err = OHCoerceToDouble(sma->data, &at->specs.drawingRadius);
			break;
		case  pColor :
			err = OHCoerceToRGB(sma->data, &at->specs.colour);
			break;
		default: 
			KDSReturnContinue(ds);
			break;
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}
kozoObject *makeNewAtomtype (kozoObject *container, double theMass, short atNum, char *newSymbol )
{   // must add to some sims atList
	short err;
	kozoObject *at;
	AEDesc propList;
	char dummyName [4];
	err = OHMakeAERecord(&propList);
	sprintf (dummyName, "??\0");
 	
	if (!err)
	{
		if (theMass != 0) AEPutKeyPtr(&propList, pAtomicMass, typeLongFloat, &theMass, sizeof(double));
		if (atNum != 0) AEPutKeyPtr(&propList, pAtomicNumber, typeShortInteger, &atNum, sizeof(short));
		if (newSymbol == nilPointer) newSymbol =  dummyName;
		AEPutKeyPtr(&propList, pAtomicSymbol, typeChar, newSymbol, strlen(newSymbol));
		 
		err = kozoNew  (&at, ClassAtomType,  container, &propList);
		AEDisposeDesc (&propList);
	}
         return (at);
}
kozoObject * atomtypeGetRefFromMassAndAN(double theMass, short atNum)
{
	kozoObject *at = nilPointer;
	kozoClass *cData = nilPointer;
	cData = getClassPtr (ClassAtomType);
	if (cData != nilPointer) at =  findAtomtypeInListFromMassAndAN((OHList *) &cData->instances,  theMass,  atNum);
	return (at);
}
kozoObject * findAtomtypeInListFromMassAndAN(OHList *atList, double theMass, short atNum)
{
	kozoObject *at = nilPointer;
	kozoObject *nthAtObj;
	kSanAtomtype *nthAtomtype;
	long count;
	long i;
	double tol = 0.01;
	count = OHListCount(atList);
	for (i = 0; ((i < count) && (at == nilPointer)) ; ++i)
	{
		nthAtObj = castTokozoObject( getNthItem(atList, i));
		nthAtomtype = atomtypeData(nthAtObj);
		if ((closeDoubles  (&theMass, &nthAtomtype->specs.mass, &tol)) && ( atNum == nthAtomtype->specs.atNumber )) at = nthAtObj;
	}
	return (at);
}
char atomtypeGetRefFromNameCallback(kozoObject  *nthAtObj, char * theName)
{
	kSanAtomtype *nthAtomtype;
	nthAtomtype = atomtypeData(nthAtObj);
	return (EqualCString  (theName, nthAtomtype->specs.symbol));
}
kozoObject * atomtypeGetRefFromName(char * theName)
{
	kozoObject *at = nilPointer;
	kozoClass *cData = nilPointer;
	cData = getClassPtr (ClassAtomType);
	if (cData != nilPointer)  findItemInListPassingTest ((OHList *)&cData->instances, (char const (*)(long , void *)) atomtypeGetRefFromNameCallback, (void *) theName, &at);

	return (at);
}
char atomtypeGetRefFromTypespecsCallback(kozoObject  *nthAtObj, typespecs * types)
{
	double tol = 0.01;
	kSanAtomtype *nthAtomtype;
	nthAtomtype = atomtypeData(nthAtObj);
	return ( (EqualCString (types->symbol, nthAtomtype->specs.symbol)) &&
				(closeDoubles (&nthAtomtype->specs.mass , &types->mass, &tol  )) &&
				       (nthAtomtype->specs.atNumber == types->atNumber ));
}
kozoObject * atomtypeGetRefFromTypespecs(typespecs * types)
{
	kozoObject *at = nilPointer;
	kozoClass *cData = nilPointer;
	cData = getClassPtr (ClassAtomType);
	if (cData != nilPointer)  findItemInListPassingTest ((OHList *)&cData->instances,(char const(*)(  long , void *)) atomtypeGetRefFromTypespecsCallback,  types, &at);
	return (at);
}
void setSpecs(kozoObject  *atObj, kSanAtomtype *at, typespecs *theSpecs)
{
	at->specs= *theSpecs;
	OHStringSetC (atObj->name,theSpecs->symbol);
}
void getSpecs(kozoObject  *atObj, kSanAtomtype *at,  typespecs * theSpecs)
{
#pragma unused(atObj)
	*theSpecs = at->specs;
}
short atomicNumberOfAtomicSymbol(char *p)
{
	short atNum = 0;
	short i=1;
	char tableString[8];
	char pCopy[8];
	memcpy(pCopy, p, 8);
	removeLeadingSpaces(pCopy, 8);
	while ((i<104) && (atNum == 0))
	{
		periodicTableString(i, pAtomicSymbol, tableString);
		removeLeadingSpaces(tableString, 8);
		if ((tableString[0] == p[0]) && (tableString[1] == p[1]))
		{
		    atNum = i;
		}
		++i;
	}
	return (atNum);
}
void removeLeadingSpaces(char *p, long maxCopy)
{
	short i = 0;
	short len;
	while (p[i] == ' ')
	{
	    ++i;
	}
	len = strlen(p);
	if (i != 0)
	{
		if (len > maxCopy ) len = maxCopy;
		memmove(&p[0], &p[i], len);
	}
}
short periodicTableString(short aNum, long whatValue, char * cString)
{
	short err = noErr;
	Handle rezH;
	if ((aNum < 1) || (err > 103))
	{
		err = -1;
	}
	else
	{
		switch (whatValue)
		{
			case pAtomicSymbol:
				rezH = GetResource (pAtomicSymbol, kBaseResID);
				HLock(rezH);
				BlockMove (((*rezH) + (4 * aNum)), cString, 2);
				HUnlock(rezH);
				ReleaseResource (rezH);
				break;
			case pAtomicName:
				rezH = GetResource (pAtomicName, kBaseResID);
				HLock(rezH);
				BlockMove (((*rezH) + (16 * aNum)), cString, 12);
				cString[12] = 0;
				HUnlock(rezH);
				ReleaseResource (rezH);
				break;
			default:
			    err = -1;
		}
	}
	return (err);
}

float periodicTableValue(short aNum, long whatValue)
{
	float retVal = 0;
	double aDoub = 0.0;
	Handle rezH;
	char p[16];
	switch (whatValue)
	{
		case pAtomicMass:
			rezH = GetResource (pAtomicMass, kBaseResID);
			BlockMove (((*rezH) + (8 * aNum)), p, 8);
			p[8] = 0;
			sscanf(p, "%lf", &aDoub);
			retVal = aDoub;
			ReleaseResource (rezH);
			break;
	}
	return (retVal);
}

