
#include "kSanColourPlugIn.h"
short  ColourModuleGetData (KozoDispatchStack *ds, getMethodArgs *gma);

short initClassColourPlugIn (void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClassColourPlugIn, ClasskSanPlugIn, sizeof (kSanColourPlugIn), "No Colour");
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  ColourPlugInConstructor,
		nilPointer, ColourModuleGetData, nilPointer, nilPointer,
		 nilHandleReportFunc, nilCountFunc, nilResolveFunc, nilCreateElementFunc);
	}
	else
	{
		err = true;
	}
	return (err);
}
short  ColourPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
	short err = noErr;
	kSanColourPlugIn *api = (kSanColourPlugIn *)ds->thisPD;
	kSanPlugIn *plug;
 	
	plug = KDSGetPrivateData(ds, ClasskSanPlugIn  );
	err = dispatchLoop(ds, cma);
  	plug->plugPrivateData = api;
  	plug->piType = ClassColourPlugIn;
	api->cpiObj = ds->obj;

	if (!api->colourOneParticle )  api->colourOneParticle = colourOneParticleNoColour;
	if (!api->colourParticleList )  api->colourParticleList = setAllColoursNoColour; 

	KDSReturnError(ds,err);
}
short  ColourModuleGetData (KozoDispatchStack *ds, getMethodArgs *gma)
{
	short err = noErr;
	DescType theKind = ClassColourPlugIn;
	kSanColourPlugIn *api = (kSanColourPlugIn *)ds->thisPD;

  	switch (gma->property)
	{
		case pKind:
			err = AECreateDesc(typeType, &theKind, sizeof(DescType), gma->result);
			break;
 		default:
			KDSReturnContinue(ds);
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}

void setAllColoursNoColour(  kSanColourPlugIn *api, kSanSimulation *sim, grafData *baseGrafData, long howMany)
{
#pragma unused(api)
	long j;
	long partArrIndex;
	RGBColor whiteColour = {0xFFFF,0xFFFF,0xFFFF} ;
	particle *basePart;
 	grafData *thisGrafData;
	
	basePart = simLockParts (sim);	
	for (j= 0; j< howMany ;++j)
	{
		thisGrafData = &(baseGrafData[j]);
		partArrIndex = thisGrafData->index;
 		if (BPNthHighlighted(basePart, partArrIndex) == kNotHighlighted) thisGrafData->colour = whiteColour;
		else thisGrafData->colour = getColour (highlightColour + BPNthHighlighted(basePart, partArrIndex));
	}
	simReleaseParts(sim);
}
void colourOneParticleNoColour(  kSanColourPlugIn *api, kSanSimulation *sim, grafData *thisGrafData)
{
#pragma unused(api)
	particle *basePart;
	long partArrIndex;
 	RGBColor whiteColour = {0xFFFF,0xFFFF,0xFFFF} ;
	
	basePart = simLockParts(sim);
	partArrIndex =  thisGrafData->index ;

	if (BPNthHighlighted(basePart, partArrIndex) == kNotHighlighted) 
	{
		thisGrafData->colour = whiteColour;
	}
	else 
	{
		thisGrafData->colour = getColour (highlightColour + BPNthHighlighted(basePart, partArrIndex));
	}
	simReleaseParts(sim);
}
void getGrayscaleColour(float temp, RGBColor *theColour)
{
   // temp between 0 and 1
	float scale = 1.0 - temp;
	theColour->blue = theColour->green = theColour->red =  ((float)0xFFFF) * (  scale );
}
void getTemperatureColour(float temp, RGBColor *theColour)
{
   // temp between 0 and 1
	RGBColor  rgb;
	float threeAndAThird = 3.33333;
	if (temp < 0.2) //       {0,0,1}         at 0
	{
		rgb.blue = ((float)0xFFFF) * (0.3 -  temp ) * threeAndAThird;
		rgb.green = ((float)0xFFFF) * (  temp * 2.4 );
		rgb.red = 0;
	}
	else if (temp < 0.25) // {0,    .48,    .33}    at .2
	{
		rgb.blue = ((float)0xFFFF) * (0.3 -  temp ) * threeAndAThird;
		rgb.green = ((float)0xFFFF) * (temp * 2.4);
		rgb.red = ((float)0xFFFF) * ((temp - 0.2) * threeAndAThird);
	}
	else if (temp < 0.3)  //{.16,    .6 ,   .166}  at .25
	{
		rgb.blue = ((float)0xFFFF) * (0.3 -  temp ) * threeAndAThird;
		rgb.green = ((float)0xFFFF) *  ( 0.3 +  ((0.5 -  temp) * 1.2));
		rgb.red = ((float)0xFFFF) * ((temp - 0.2) * threeAndAThird);
	}
	else if (temp < 0.4) // { .33 ,   .54 ,   0} at     .3
	{
		rgb.blue = 0;
		rgb.green = ((float)0xFFFF) *  ( 0.3 +  ((0.5 -  temp) * 1.2));
		rgb.red =  ((float)0xFFFF) * ((temp - 0.2) * threeAndAThird);
	}
	else if (temp < 0.5)  //  { .66,   .42 ,   0} at  .4
	{
		rgb.blue = 0;
		rgb.green = ((float)0xFFFF) *  ( 0.3 +  ((0.5 -  temp) * 1.2));
		rgb.red =  ((float)0xFFFF) * ((temp - 0.2) * threeAndAThird);
	}
	else if (temp < 0.7)  //    {1,    .3,      0 }         at .5
	{
		rgb.blue = 0;
		rgb.green =  ((float)0xFFFF) * (0.3 + (( temp - 0.5) * 3.5));
		rgb.red =  0xFFFF;
	}
	else if (temp < 1.0)  //    {1,     1,      0}             at .7
	{
		rgb.blue = ((float)0xFFFF) * ((temp - 0.7) * threeAndAThird);
		rgb.green = 0xFFFF ;
		rgb.red =  0xFFFF;
	}
	else    // { 1,1,1 }    at 1.0 
	{
		rgb.blue =  0xFFFF ;
		rgb.green = 0xFFFF ;
		rgb.red =  0xFFFF;
	}
	*theColour = rgb;
}


