#include <profiler.h>
#include "kozoObject.h"
#include "OHMainRoutines.h"
#include "OHApplication.h"
#include "kSanApplication.h"
#include  "kozoClassInit.h"
#include "OHGraph.h"

 short OHCustomizeMenus (kozoObject *mBar);
short kSanCustomClasses (void);

short kSanCustomize(void);
short kSanCustomClasses (void);
void kSanCleanup (void);
void kSanAEInit (void);
 
void	main( void )
{
	short err;
	err = ToolboxInit(100);
 #if __profile__   // codeWarrior profiler entry 
	if (ProfilerInit(collectDetailed, bestTimeBase, 5000, 24) == noErr)
	{
		ProfilerSetStatus(false);
#endif
 
  	 	if (!err) 
		{
			
			initKozoClassData(); // initialize classes in class library
			kSanCustomize(); // init classes unique to this app
			kozoNewNoData(&globalAppObject, ClasskSanApplication, nilPointer);
		    OHCloneSelf(globalAppObject);
			if (!err) searchFilesForPlugIns(); // app must be allocated first

		    { // copy the aete once and save it -- needed for nasty bug fix
		    	AEDesc dummyDesc = gNilDesc;
		    	kozoGetDataWType(globalAppObject, 'aete', 0L, &dummyDesc);
		     	AEDisposeDesc ( & dummyDesc);
		    }

	// 		if (!(checkAlias())) // something about plugins folder here
	//		{
				AEInit();
	 			appEventLoop();
	//		}
		    OHUncloneSelf(globalAppObject);
			kSanCleanup();
 			cleanupClassData();
		}
		
		
 #if __profile__   // codeWarrior profiler exit
			 ProfilerSetStatus(true);
		{
			Str255 pStr ;
			char *myString;
			myString = (char *)pStr;
			sprintf (myString, " kSan.profile");
			myString[0] = strlen (&myString[1]);
			ProfilerDump((unsigned char *)myString);
			ProfilerTerm();
		}
	}
#endif
}
 

short kSanCustomize(void)
{
	short err = noErr;
	//initGraphClasses();
	err =  kSanCustomClasses();
	kSanAEInit ();
	return (err);
}
short kSanCustomClasses (void)
{ // all classes derived from kozoClasses
	short err = noErr;

	 randomGeneratorInitialize();
	if (!err) err = initClasskSanApplication ();
   	if (!err) err =	initClassParticleGroup();
	if (!err) err =	initClassAGWindow();
	if (!err) err = initClassSimDataWindow();
 	if (!err) err = initClassSimulation();
	if (!err) err = initClassAtomTypes();
	if (!err) err = initClassPlugIn();
	if (!err) err = initClassPlugFile();

// plugin types
	if (!err) err =  initClassMethodPlugIn();
	if (!err) err =  initClassPotentialPlugIn();
	if (!err) err =  initClassCellResizePlugIn();
	if (!err) err =  initClassFilePlugIn();
	if (!err) err =  initClassDataCollectionPlugIn();
	if (!err) err =  initClassColourPlugIn();

// potential plugins
	if (!err) err =  initClassLJPotential();

// method plugins
	initClassPCMDMethod();
	initClassVerletMethod();

// cell resize plugins
if (!err) 	err = initClassNoseCellResize();

// color plug ins
	if (!err) err =  initClassAtomTypeColourPlugIn();
	if (!err) err =  initClassGroupColourPlugIn();
	if (!err) err =  initClassPEColourPlugIn();
	
// data collection plugins
	
// file import/export plugins


		
	return (err);
}
void kSanCleanup (void)
{ // all classes derived from kozoClasses
	disposeFoundPlugIns();
}

void kSanAEInit (void)
{
	short err;
	err = AEInstallEventHandler(kSanSuite, kSanAEIterateMessage,
				NewAEEventHandlerProc(DoGenericEvent), 0L, false );
	err = AEInstallEventHandler(kSanSuite, kSanAEStrainMessage,
				NewAEEventHandlerProc(DoGenericEvent), 0L, false );
	err = AEInstallEventHandler(kSanSuite, kSanSimResetIDsEvent,
				NewAEEventHandlerProc(DoGenericEvent), 0L, false );
	err = AEInstallEventHandler(kSanSuite, kSanSimReorderEvent,
				NewAEEventHandlerProc(DoGenericEvent), 0L, false );
		err = AEInstallEventHandler(kSanSuite, kRotateMessage,
				NewAEEventHandlerProc(DoGenericEvent), 0L, false );
}

