
#include "kSanDataCollectionPlugIn.h"
short doNoCollection ( kSanDataCollectionPlugIn *api, kSanSimulation *sim);
short  DataCollectionPlugInGetData (KozoDispatchStack *ds, getMethodArgs *gma);
short  DataCollectionPlugInSetData (KozoDispatchStack *ds, setMethodArgs *sma);

short initClassDataCollectionPlugIn (void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClassDataCollectionPlugIn, ClasskSanPlugIn, sizeof (kSanDataCollectionPlugIn),""); 
	// empty string so that  no menu gets made
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  DataCollectionPlugInConstructor,
		nilPointer, DataCollectionPlugInGetData, DataCollectionPlugInSetData, nilPointer,
		 nilHandleReportFunc, nilCountFunc, nilResolveFunc, nilCreateElementFunc);
		 
		 err =  kozoClassAddRemove2ItemsToSave(newClass, true,   pCounter,  pThreshhold);
	}
	else
	{
		err = true;
	}
	return (err);
}

short  DataCollectionPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
	short err = noErr;
 	kSanDataCollectionPlugIn *api =  (kSanDataCollectionPlugIn *) ds->thisPD;
	kSanPlugIn *plug;
	plug = KDSGetPrivateData(ds, ClasskSanPlugIn  );
 
	err = dispatchLoop(ds, cma);
	api->dcpObj = ds->obj;
	api->threshhold = 1;
	api->counter = 1;
	if (!api->doCollection )  api->doCollection = doNoCollection;
	
  	plug->piType = ClassDataCollectionPlugIn;
  	plug->plugPrivateData = api;
  	
	KDSReturnError(ds,err);
}
 
short  DataCollectionPlugInGetData (KozoDispatchStack *ds, getMethodArgs *gma)
{
	short err = noErr;
	DescType theKind = ClassDataCollectionPlugIn;
 	kSanDataCollectionPlugIn *api =  (kSanDataCollectionPlugIn *) ds->thisPD;
 	switch (gma->property)
	{
 		case pKind:
			err = AECreateDesc(typeType, &theKind, sizeof(DescType), gma->result);
			break;
		case pCounter:
		 	err = makeLongDesc (api->counter,  gma->result);
			break;
		case pThreshhold:
		 	err = makeLongDesc (api->threshhold,  gma->result);
			break;
 		default:
			KDSReturnContinue(ds);
	} 
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}
short  DataCollectionPlugInSetData (KozoDispatchStack *ds, setMethodArgs *sma)
{
	short err = noErr;
 	kSanDataCollectionPlugIn *api =  (kSanDataCollectionPlugIn *) ds->thisPD;
	switch (sma->property)
	{
		case pCounter:
		 	OHCoerceToLong (sma->data, &api->counter);
			break;
		case pThreshhold:
			OHCoerceToLong (sma->data, &api->threshhold);
			break;
 		default:
			KDSReturnContinue(ds);
	}
 	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}


  short doNoCollection ( kSanDataCollectionPlugIn *api, kSanSimulation *sim)
  {
#pragma unused(sim)
#pragma unused(api)
           return (noErr);
  }


