#include "kSanMethodPlugIn.h"
#include "VerletMethod.h"
#include "PCMD.h"
short  MethodModuleGetData (KozoDispatchStack *ds, getMethodArgs *gma);

short initClassMethodPlugIn (void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClassMethodPlugIn, ClasskSanPlugIn, sizeof (kSanMethodPlugIn), "no iteration");
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  MethodPlugInConstructor ,
		nilPointer, MethodModuleGetData, nilPointer, MethodPlugInDoMessage,
		 nilPointer, nilPointer, nilPointer, nilPointer);
	}
	else
	{
		err = true;
	}
	return (err);
}
short  MethodPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
	short err = noErr;
	kSanMethodPlugIn *api = (kSanMethodPlugIn *)ds->thisPD;
	kSanPlugIn *plug;
	plug = KDSGetPrivateData(ds, ClasskSanPlugIn  );
 	err = dispatchLoop(ds, cma);
 
  	plug->plugPrivateData = api;
 	plug->piType = ClassMethodPlugIn;
	api->mpiObj = ds->obj;
	if (!api->doIteration)  api->doIteration = defaultIteration;
	if (!api->doCooling)  api->doCooling =defaultCooling;
	
	KDSReturnError(ds,err);
}
short  MethodModuleGetData (KozoDispatchStack *ds, getMethodArgs *gma)
{
	short err = noErr;
	DescType theKind = ClassMethodPlugIn;
	kSanMethodPlugIn *api = (kSanMethodPlugIn *)ds->thisPD;

  	switch (gma->property)
	{
		case pKind:
			err = AECreateDesc(typeType, &theKind, sizeof(DescType), gma->result);
			break;
 		default:
			KDSReturnContinue(ds);
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}

short  MethodPlugInDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma)
{
	short err = noErr;
	kSanMethodPlugIn *api;
	api = KDSGetPrivateData(ds, ClassMethodPlugIn  );
	switch (dmma->message)
	{
		case kThermalizeMessage:
			simRandomizeVelocities ((kSanSimulation *)dmma->data );
			break;
		case kSetToZeroMessage:
			simZeroVelocities ((kSanSimulation *)dmma->data );
			break;
		default :
			KDSReturnContinue(ds);
			break;
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}
short defaultIteration (  kSanMethodPlugIn *mpi,  kSanSimulation *sim) // long	doVerletMDTimeStep (void)
{
#pragma unused(mpi)
#pragma unused(sim)
	short err = noErr;
	return (err);
}
short defaultCooling (  kSanMethodPlugIn *mpi,  kSanSimulation *sim, double *netTime, double *totKinEnergy)
{
#pragma unused(mpi)
	particle * basePart;
	kSanGroup *gp;
	kSanGroup **baseGroup;
	long numParts;
	long i;
	long partArrIndex;
	long *list;
	short numGroups;
	short groupI;
	float largerOfTemps;
	float myCoolFac;
	float frac;
	float eqTempToUse;

 	numGroups = simGetNumGroups(sim);

	baseGroup = simLockGroups(sim);
	basePart = simLockParts(sim);
	
	for (groupI = 0; groupI<numGroups; ++groupI)
	{
		gp = baseGroup[groupI];
		if ((gp->doCooling) && (gp->coolingTimeConstant >0 ))
		{
			numParts = OHListCount(&gp->particles);

			if (isnan(gp->actualTemp)) gp->actualTemp = 0;
			if (isnan(gp->eqTemp)) gp->eqTemp = 0;

				frac = ((*netTime) / (10.0 * gp->coolingTimeConstant));
				if (frac > 1.0) frac = 1.0;
				if (frac < 0) frac = 0;
 			    gp->recentTempDeviation +=  (gp->actualTemp - gp->eqTemp) *  frac ;
 			
  			eqTempToUse = gp->eqTemp - gp->recentTempDeviation;
  			
			list = lockList(&gp->particles);
			if (eqTempToUse > gp->actualTemp)  
			{
				largerOfTemps = eqTempToUse;
			}
			else   
			{
				largerOfTemps = gp->actualTemp;
			}
			

				myCoolFac = 1.0 +  (((eqTempToUse - gp->actualTemp ) * (*netTime) )/
					 (gp->coolingTimeConstant * largerOfTemps) ) ;

			          if (myCoolFac > 1.1) myCoolFac = 1.1;
			          else if (!(myCoolFac > 0.0)) myCoolFac = 0.0001;
			          
				for (i = 0; i < numParts; ++i)
				{
					partArrIndex = list[i] ;
					multkSanVectorD (&basePart->baseVelocity[partArrIndex], myCoolFac, &basePart->baseVelocity[partArrIndex] );
 				}

			releaseList (&gp->particles);
		}
	}
	*totKinEnergy = -1;
	 simReleaseGroups(sim);
	 simReleaseParts(sim);
	return (noErr);
}


