// kSanPlugIn.cpp

#include "OHApplicationPublic.h"
#include "kSanPlugIn.h"
#include "LJ.h"
#include "colour.h"
//#include "kSanScript.h"
#include "kSanRezIDs.h"


short  kSanPlugInMakeObjectSpec(kozoObject *thePlug, AEDesc *spec);
//short menuFromkozoClassList (OHList *oList, short menuRezID, Str255 title);
void deleteAPlugInMenu(short rezID);
short menuOfSubclasses (DescType whatClass, short menuRezID, Str255 title, char  includeBase);

short initClassPlugIn(void) 
{
 	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClasskSanPlugIn, ClassKozoObject, sizeof (kSanPlugIn), "kSan plugin");
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  kSanPlugInConstructor,
		nilPointer, nilPointer, nilPointer, nilPointer,
		 nilPointer, nilPointer, nilPointer, nilPointer);
		
	}
	else
	{
		err = true;
	}
	return (err);
}
void deleteAPlugInMenu(short rezID)
{
	MenuHandle aMenu = nilPointer;
	DeleteMenu(rezID);
	aMenu = GetMenuHandle(rezID);
	if (aMenu) ReleaseResource ((Handle)aMenu);
}
void deletePlugInMenus(void)
{
	if ( plugMenuRefCountAdd(-1) == 0)
	{
		deleteAPlugInMenu(mPlugInPotentials);
		deleteAPlugInMenu(mPlugInResize);
		deleteAPlugInMenu(mPlugInMethod);
		deleteAPlugInMenu(mPlugInDataCollection);
		deleteAPlugInMenu(mPlugInColours);
	}
}
void makePlugInMenus(void)
{
	if (plugMenuRefCountAdd(1)== 1)
	{
		menuOfSubclasses(ClassPotentialPlugIn, mPlugInPotentials, "\ppotentials", false);
		menuOfSubclasses(ClassCellResizePlugIn, mPlugInResize, "\pcell sizers", false);
		menuOfSubclasses( ClassMethodPlugIn, mPlugInMethod, "\pmethods", false);
		menuOfSubclasses( ClassDataCollectionPlugIn, mPlugInDataCollection, "\pdata collectors", false);
		menuOfSubclasses( ClassColourPlugIn, mPlugInColours, "\pcolouring methods", false);
	}
}


short menuOfSubclasses (DescType whatClass, short menuRezID, Str255 title, char  includeBase)
{
#pragma unused(title)
	short err = noErr;
	short i;
	short count;
	kozoClass *ohc;
	OHList *plugList;
	Str255 className;
	
	MenuHandle theMenu;
	theMenu = GetMenu (menuRezID);
	plugList = getSubclassList(whatClass);
	count = OHListCount(plugList);
	if (theMenu)
	{
		while (CountMenuItems(theMenu) > 0) DeleteMenuItem(theMenu,1);
		if (includeBase) 
		{
			ohc =  getClassPtr (whatClass);
			kozoObjectGetNameAs255(ohc->obj, className);
			AppendMenu (theMenu, className);
		}
		for (i = 0; i < count; ++i)
		{
			ohc = castTokozoClass( getNthItem (plugList, i));
			kozoObjectGetNameAs255(ohc->obj, className);
			AppendMenu (theMenu, className);
		}
		InsertMenu(theMenu, -1);
	}
	else err = true;
	
	return (err);
}

short  kSanPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
#pragma unused(cma)
	short err = noErr;

	kSanPlugIn *plug;
	plug = KDSGetPrivateData(ds, ClasskSanPlugIn  );

	 getAppOHFile(&plug->piFile);  // for plug-ins from external files, use a global in the file

	KDSReturnError(ds,err);
}

short  whichPlugInMenuItem(DescType whichModule , kozoObject *plugObj)
{
	short menuIndex;
	kozoClass *ohc;
	kozoClass *plugClass;
	kSanPlugIn *plug ;
	plug = plugData (plugObj);
	
	ohc = getClassPtr(whichModule);
	plugClass = getClassPtr(OHOCID(plugObj));
	
	if (ohc == plugClass) menuIndex = 0;
	else
	{
 		 menuIndex = whichItem(&ohc->subclasses, (long)  plugClass);
		 menuIndex += 1;
	}
	return (menuIndex);
}

 // called when you get a command like 'set colour method of window 3 to "Colour by Atom Type"'
short kSanResolveModule (DescType theProp, const AEDesc *dataDesc, DescType *classID)
{
	short err = true;
	short localErr;
	AEDesc tDesc;
	OHToken  plugToken;
	if (dataDesc->descriptorType == typeObjectSpecifier) 
	{ //'set colour method of graphics window 3 to colour method of graphics window 2'
		localErr = OHResolve(dataDesc, &tDesc);
		if (!localErr) 
		{
			plugToken = (* (OHToken *)*tDesc.dataHandle);

			if (plugToken.subObjectClass == ClassClass)
			{  // the token represents module "colour by x" of application 
	                        *classID = (*(DescType *)*plugToken.keydata.dataHandle);
		                err = noErr;
			}
			AEDisposeDesc(&tDesc);
		}
	}
	else  if (dataDesc->descriptorType == typeType) 
	{   
	      *classID = (*(DescType *)*dataDesc->dataHandle);
	}
	else  // 'set colour method of window 3 to "Colour by Atom Type"'
	{  // try to coerce to text and find an appropriate module with that name
		OHString ohs;
		AEDesc coerced = {typeNull, nilPointer};
  		kozoClass * ohc ;
 		OHList * subclassList ;
 		long whichClass;
 		subclassList = getSubclassList (theProp);
 		OHStringCreate(&ohs);
 		AECoerceDesc (dataDesc, typeChar, &coerced);
 		OHStringSetAEDesc(&ohs, &coerced);
 		AEDisposeDesc (&coerced);
 		ohc = getClassByName(&ohs);
 	         OHStringDispose(&ohs);

 		if ((subclassList) && (ohc))
 		{
 			whichClass = whichItem(subclassList, (long) ohc);
 			if (whichClass != -1) 
 			{
 				*classID = ohc->classID ;
 				err = noErr;
 			}
 		}
 	}
	return (err);
}
