
#include "kSanPotentialPlugIn.h"
#include "kSanSimulationPrivate.h"
#include "LJ.h"
short  PotentialModuleGetData (KozoDispatchStack *ds, getMethodArgs *gma);
 
short initClassPotentialPlugIn (void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClassPotentialPlugIn, ClasskSanPlugIn, sizeof (kSanPotentialPlugIn), "No Interaction");
	if (newClass)
	{
		err =	setFuncs(newClass, 0L,  PotentialPlugInConstructor,
		nilPointer, PotentialModuleGetData, nilPointer, nilPointer,
		 nilPointer, nilPointer, nilPointer, nilPointer);

	}
	else
	{
		err = true;
	}
	return (err);
}
short  PotentialPlugInConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
	short err = noErr;
	kSanPotentialPlugIn *api = (kSanPotentialPlugIn *)ds->thisPD;
	kSanPlugIn *plug;
 	plug = KDSGetPrivateData(ds, ClasskSanPlugIn  );
	err = dispatchLoop(ds, cma);

 	plug->plugPrivateData = api;
  	plug->piType = ClassPotentialPlugIn;

 	api->ppiObj = ds->obj;
 	if (!api->onePartECalc) api->onePartECalc = NoInteractionOneParticleEnergyCalc;
	if (!api->onePartFCalc) api->onePartFCalc = NoInteractionOneParticleForceCalc;
	if (!api->onePartVirialCalc) api->onePartVirialCalc = NoInteractionOneParticleVirialCalc;
	if (!api->manyPartEFCalc) api->manyPartEFCalc =NoInteractionManyParticleForceAndEnergyCalc;
    if (!api->manyPartECalc) api->manyPartECalc =  NoInteractionManyParticleEnergyCalc;
	if (!api->manyPartFCalc) api->manyPartFCalc =   NoInteractionManyParticleForceCalc;
	if (!api->fillScreeningArray) api->fillScreeningArray = NoInteractionFillScreeningArray;
	if (!api->screeningFunction) api->screeningFunction = NoInteractionScreeningFunction;
	if (!api->fillScreeningDifferentialArray) api->fillScreeningDifferentialArray = NoInteractionFillScreeningDifferentialArray;
	if (!api->screeningDifferential) api->screeningDifferential = NoInteractionScreeningDifferential;


	KDSReturnError(ds,err);
}
short  PotentialModuleGetData (KozoDispatchStack *ds, getMethodArgs *gma)
{
	short err = noErr;
	DescType theKind = ClassPotentialPlugIn;
	kSanPotentialPlugIn *api = (kSanPotentialPlugIn *)ds->thisPD;

  	switch (gma->property)
	{
		case pKind:
			err = AECreateDesc(typeType, &theKind, sizeof(DescType), gma->result);
			break;
 		default:
			KDSReturnContinue(ds);
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}

 void NoInteractionCallback ( kSanSimulation *sim,  particle *basePart, long partArrIndex, void * arg);
void NoInteractionCallback ( kSanSimulation *sim,  particle *basePart, long partArrIndex, void * arg)
{
#pragma unused(sim)
#pragma unused(arg)
	basePart->basePotential[partArrIndex] = 0.0;
}
short NoInteractionManyParticleEnergyCalc (kSanPotentialPlugIn *ppi, kSanSimulation *sim,  long firstPart, long lastPart, double *retVal) 
{
#pragma unused(ppi)
	 processParticles (sim, NoInteractionCallback,  firstPart,  lastPart, 0L);
	*retVal = 0.0;
	return (noErr);
}
									
short  NoInteractionManyParticleForceCalc(kSanPotentialPlugIn *ppi, kSanSimulation *sim,  long firstPart, long lastPart) 
								// put forces in (*theParticleHandle)[i].force
								// return void
{
#pragma unused(ppi)
	short err = noErr;
	 kSanVector  zeroVec  ;
	 zerokSanVectorD(&zeroVec);
	 processParticles (sim, kSanParticleSetForceCallback,  firstPart,  lastPart, &zeroVec);
	return (err);
}					
short  NoInteractionManyParticleForceAndEnergyCalc (kSanPotentialPlugIn *ppi,kSanSimulation *sim, long firstPart, long lastPart, double *retVal) 
								// put forces in (*theParticleHandle)[i].force
								// put energy in (*theParticleHandle)[i].potential
								// return energy of system
{
	short err = noErr;
	err =  ppi->manyPartFCalc(  ppi,sim, firstPart, lastPart);
	if (!err) err = ppi->manyPartECalc(ppi, sim, firstPart, lastPart, retVal) ;
	return (err);
}
short  NoInteractionOneParticleForceCalc(kSanPotentialPlugIn *ppi, kSanSimulation *sim, long partArrIndex)  
								// put force in basePart->baseForce[partArrIndex]
								// return err
{
#pragma unused(ppi)
	short err = noErr;
	particle *basePart;

	basePart = simLockParts(sim); 
	zerokSanVectorD (&basePart->baseForce[partArrIndex]);
	simReleaseParts(sim); 

	return (err);
}
short  NoInteractionOneParticleVirialCalc  (kSanPotentialPlugIn *ppi, kSanSimulation *sim, long partArrIndex, kSanMatrix  *rMat) 
								// put virial in vec
								// return err
{
#pragma unused(sim)
#pragma unused(ppi)
#pragma unused(partArrIndex)
	short err = noErr;
	zerokSanMatrixD(rMat);	
	return (err);
}
short  NoInteractionOneParticleEnergyCalc (kSanPotentialPlugIn *ppi, kSanSimulation *sim, long partArrIndex, double *retVal)
								// put force in basePart->baseForce[partArrIndex]
								// return err
{
#pragma unused(ppi)
#pragma unused(retVal)
	short err = noErr;
	particle *basePart;

	basePart = simLockParts(sim); 

	basePart->basePotential[partArrIndex] = 0;
	
	simReleaseParts(sim); 
	return (err);
}
								
short NoInteractionScreeningDifferential(kSanPotentialPlugIn *ppi, kSanSimulation *sim,  particle *basePart, long partArrIndex, long whichNeighbor, 
		 kSanVector * theScreeningDifferential)
//short screeningDifferential( particle *thisPart,
//					PtrToShort howManyNeighbors,PtrToShort whichNeighbor, 
//			        PtrToShort typeArray, kSanVector * neighbors,
//					PtrToDouble sepArray, kSanVector * theScreeningDifferential)
{
#pragma unused(ppi)
	double r;
	short err = noErr;
	//NNeighborInfo *nni ;
	//nni =  basePart[partArrIndex].neighbors.firstNeighborInfo;
	//r = nni[whichNeighbor].sep;
	r = NNIGetNthSep(sim, basePart, partArrIndex, whichNeighbor);
	if ((r < sim->outerCutoff) && (r > sim->innerCutoff))
	{
 		double tempValue;
		double rMinusR;
		double dfdrOverR;
		double prefactor;
		kSanVector  vec;
		
		NNIGetNthVec(sim, basePart, partArrIndex, whichNeighbor, &vec);
 		rMinusR = r - sim->innerCutoff;
		tempValue = sin (sim->piOverRange * rMinusR);
		prefactor = sim->piOverRange *  (-0.5) / r ; // over r because we multiply by the seps
		dfdrOverR =  (prefactor * tempValue);
		multkSanVectorD (&vec, dfdrOverR, theScreeningDifferential);
		//theScreeningDifferential->a =  dfdrOverR * vec.a;
		//theScreeningDifferential->b =  dfdrOverR * vec.b;
		//theScreeningDifferential->c =  dfdrOverR * vec.c;
	}
	else  
	{
	    zerokSanVectorD (theScreeningDifferential );
		//theScreeningDifferential->a = 0.0;
		//theScreeningDifferential->b = 0.0;
		//theScreeningDifferential->c = 0.0;
	}
	return (err);
}
					
					
short NoInteractionFillScreeningDifferentialArray(kSanPotentialPlugIn *ppi, kSanSimulation *sim,  particle *basePart, long partArrIndex, 
		 kSanVector * screeningDifferentialArray)
//short fillScreeningDifferentialArray(  particle *thisPart, PtrToShort howManyNeighbors, 
//			        PtrToShort typeArray, kSanVector * neighbors,
//					PtrToDouble sepArray, kSanVector * screeningDifferentialArray)
{
#pragma unused(ppi)
	short err = noErr;
	kSanVector * theScreeningDifferential;
	long j;
	long NNNum;
//	NNeighborInfo *nni ;
	double r;
	double tempValue;
	double rMinusR;
	double dfdrOverR;
	double prefactor;
	kSanVector  vec;
//	nni =  basePart[partArrIndex].neighbors.firstNeighborInfo;
	NNNum = numNNs( basePart, partArrIndex);
	for(j=0;j<NNNum;++j)
	{
		r = NNIGetNthSep(sim, basePart, partArrIndex, j);  
		theScreeningDifferential = 	&screeningDifferentialArray[j];
		
		if ((r < sim->outerCutoff) && (r > sim->innerCutoff))
		{
			NNIGetNthVec(sim, basePart, partArrIndex, j, &vec);
			rMinusR = r - sim->innerCutoff;
			tempValue = sin (sim->piOverRange * rMinusR);
			prefactor = sim->piOverRange *  (-0.5) / r ; // over r because we multiply by the seps
			dfdrOverR =  (prefactor * tempValue);
			multkSanVectorD (&vec, dfdrOverR,  theScreeningDifferential);
			//theScreeningDifferential->a =  dfdrOverR * vec.a;
			//theScreeningDifferential->b =  dfdrOverR * vec.b;
			//theScreeningDifferential->c =  dfdrOverR * vec.c;
		}
		else  
		{
		    zerokSanVectorD ( theScreeningDifferential);
			//theScreeningDifferential->a = 0.0;
			//theScreeningDifferential->b = 0.0;
			//theScreeningDifferential->c = 0.0;
		}
	}
	return (err);
}								 	

short NoInteractionScreeningFunction(kSanPotentialPlugIn *ppi, kSanSimulation *sim,  particle *basePart, long partArrIndex,
			 long  whichNeighbor, double *theScreening)
{
#pragma unused(ppi)
	short err = noErr;
	double radVal = NNIGetNthSep(sim, basePart, partArrIndex, whichNeighbor);
 		
	if ( (radVal <= 	sim->innerCutoff)  && (radVal > 0))
	{
		(*theScreening) = 1.0;
	}
	else if (radVal >= sim->outerCutoff) 											
	{									
		(*theScreening) = 0.0;
	}
	else if ((radVal < sim->outerCutoff) && (radVal > sim->innerCutoff))
	{
		double tempValue;
		double rDiff;

		rDiff = radVal - sim->middleCutoff;
		tempValue = sin (sim->piOverRange * rDiff);
		(*theScreening) = 0.5 - (0.5 *tempValue);
	}
	else  // takes care of nan and negatives
	{
		(*theScreening) = 0;
		err = kSanErrRadiusNotGreaterThanZero;  // return an error
	}
	return (err);				
}

short NoInteractionFillScreeningArray(kSanPotentialPlugIn *ppi, kSanSimulation *sim,  particle *basePart, long partArrIndex )
{
#pragma unused(ppi)
	short err = noErr;
#ifdef NNIRemembersScreening
	short j;
	long NNNum;
	double radVal;
	double newScreen;
	NNeighborInfo *nni ;
	nni =  basePart->basePi[partArrIndex].firstNeighborInfo;
	NNNum = numNNs( basePart , partArrIndex );
	for(j=0; j<NNNum; ++j)
	{
		radVal = NNIGetNthSep(sim, basePart, partArrIndex, j);
		
		if ( (radVal <= sim->innerCutoff)  && (radVal > 0))
		{
			newScreen= 1.0;
		}
		else if (radVal >= sim->outerCutoff) 											
		{									
			newScreen= 0.0;
		}
		else if ((radVal < sim->outerCutoff) && (radVal > sim->innerCutoff))
		{
			double tempValue;
			double rDiff;

			rDiff = radVal - sim->middleCutoff;
			tempValue = sin (sim->piOverRange * rDiff);
			newScreen = 0.5 - (0.5 * tempValue);
		}
		else  // takes care of nan and negatives
		{
			newScreen = 0.0;
			(err) = kSanErrRadiusNotGreaterThanZero;  // return an error
		}

		nni[j].screening = newScreen;
	}
	basePart->basePi[partArrIndex].neighborScreeningDirty = false;
#endif
	return (err);				
}
 
