#include "fp.h"
#include "OHSharedUtils.h"
#include "kSanSharedUtils.h"

void  getDoubleVector (DialogPtr theDialog, short itemNumber,  kSanVector  *vec,
						double upperLimit, double lowerLimit)
{
	vec->a = getDoubleItem(theDialog,itemNumber , upperLimit, lowerLimit);
	vec->b = getDoubleItem(theDialog,itemNumber + 1, upperLimit, lowerLimit);
#ifndef __2DVectors__
	vec->c = getDoubleItem(theDialog,itemNumber + 2, upperLimit, lowerLimit);
#endif
 }


void  getLongVector (DialogPtr theDialog, short itemNumber,  kSanLongVector  *vec,
						long upperLimit, long lowerLimit)
{
	vec->a = getLongItem(theDialog,itemNumber , upperLimit, lowerLimit);
	vec->b = getLongItem(theDialog,itemNumber + 1, upperLimit, lowerLimit);
#ifndef __2DVectors__
	vec->c = getLongItem(theDialog,itemNumber + 2, upperLimit, lowerLimit);
#endif
 }


void prepDoubleVector (DialogPtr theDialog, short itemNumber, kSanVector  *vec)
{
	 prepDoubleItem(theDialog,itemNumber , vec->a);
	 prepDoubleItem(theDialog,itemNumber + 1, vec->b);
#ifndef __2DVectors__
	 prepDoubleItem(theDialog,itemNumber + 2, vec->c);
#else 
	 prepDoubleItem(theDialog,itemNumber + 2, 0);
	 setControlItemEnabled(theDialog,itemNumber + 2, false);
#endif
 }
void prepLongVector (DialogPtr theDialog, short itemNumber, kSanLongVector  *vec)
{
	 prepLongItem(theDialog,itemNumber , vec->a);
	 prepLongItem(theDialog,itemNumber + 1, vec->b);
#ifndef __2DVectors__
	 prepLongItem(theDialog,itemNumber + 2, vec->c);
#else 
	 prepLongItem(theDialog,itemNumber + 2, 0);
	 setControlItemEnabled(theDialog,itemNumber + 2, false);
#endif
 }


char vectorIsNan(kSanVector  *vec)
{
#ifndef __2DVectors__
  return(isnan (vec->a) || isnan(vec->b) || isnan(vec->c));
 #else 
  return(isnan (vec->a) || isnan(vec->b));
#endif
}

void fixNANVector(kSanVector  *vec)
{
	if (isnan(vec->a)) vec->a = 0;
	if (isnan(vec->b)) vec->b = 0;
#ifndef __2DVectors__
	if (isnan(vec->c)) vec->c = 0;
#endif
}