#include "kSanSimulationPrivate.h"

#include "kSanAtomtype.h"
#include "kSanDialog.h"

#define	iMassEditItem 	5
#define	iRadiusEditItem 	7
#define	iSymbolEditItem 	12
#define	iSetColourButtonItem 	8
#define	iAtomTypesPopupItem 9
#define	iSamplePictItem 10
#define	iConvertSelectionsItem 13
#define	iAtomicNumberTextItem 15
#define	iAtomicNumberUpItem 16
#define	iAtomicNumberDownItem 17

 
kozoObject *simGetTypeFromTypespecs(kSanSimulation *sim, typespecs *types)    
{								 
	short i = 0;
	short foundIt = false;
	double tol = 0.01;
	OHList *atList;
	kozoObject *at;
	
	atList = getListOfObjectsOfClassX (simOBJ(sim), ClassAtomType);
	if (atList)  
	{
		foundIt = findItemInListPassingTest (atList,  ( char const (*)(  long , void *))atomtypeGetRefFromTypespecsCallback, types, &at);
		if (!foundIt) 
		{
			at = makeNewAtomtype(simOBJ(sim), types->mass, types->atNumber, types->symbol);
		}
		releaseListOfObjectsOfClassX (simOBJ(sim), ClassAtomType);
	}
	return (at);
}
kozoObject *simGetTypeFromSymbolMassAndAN(kSanSimulation *sim, char *symbol, double theMass, short atNum)    
{								 
	OHList *atList;
	kozoObject *at;
	
	atList = getListOfObjectsOfClassX(simOBJ(sim), ClassAtomType);
	if (atList)  
	{
		at =  findAtomtypeInListFromMassAndAN(atList,  theMass,  atNum);
		if (!at)   at = makeNewAtomtype(simOBJ(sim), theMass, atNum, symbol);		
		releaseListOfObjectsOfClassX(simOBJ(sim), ClassAtomType);
	}

	return (at);
}
void simSetFirstAtomType (kSanSimulation *sim)
{
	kozoObject *at = nilPointer;	
	at = makeNewAtomtype (simOBJ(sim), 40, 18, nilPointer);
}
 short  simGetNumAtomtypes(kSanSimulation *sim)
{
	long count = 0;
	dispatchCount (simOBJ(sim), ClassAtomType, &count);
 	return (count);
}
short  simGetNthTypespecs(kSanSimulation *sim, typespecs *types, short index)
{
	short err = noErr;
	OHList *atList;
	kozoObject *atObj;
	kSanAtomtype *at;
	atList = getListOfObjectsOfClassX (simOBJ(sim), ClassAtomType);
	if (atList)
	{
		atObj = castTokozoObject (getNthItem(atList, index));
		at = atomtypeData(atObj);
		*types = at->specs;	
		releaseListOfObjectsOfClassX(simOBJ(sim), ClassAtomType);
	}
	else err = true;
	return (err);
}
kozoObject *simGetTypeFromName(kSanSimulation *sim, char *aSymbol)
{
	char foundIt = false;
	double tol = 0.01;
	OHList *atList;
	kozoObject *at;
	
	atList = getListOfObjectsOfClassX (simOBJ(sim), ClassAtomType);
	
	if (atList) 
	{
		foundIt =  findItemInListPassingTest (atList, ( char const (*)( long , void *)) atomtypeGetRefFromNameCallback,  aSymbol, &at);
		releaseListOfObjectsOfClassX(simOBJ(sim), ClassAtomType);
	}

		if (!foundIt)  at = makeNewAtomtype(simOBJ(sim), 0, 0, aSymbol);
		
	return (at);
}
short	simDoAtomInfoDialog (kSanSimulation *sim, long whichType)
{
	OHBasicDialog dialog;
	typespecs   tempTypespecs;
	Handle		tempHandle;
	ControlHandle popupHandle;
	MenuHandle   popupMenu;
	Rect		pictRect;
	Str255		nameText;
	kozoObject *atObj;
	long numAtomTypes;
	kSanAtomtype *at;
	popupMenu = buildAtomTypesPopupMenu(sim, true);
	InsertMenu (popupMenu, -1);
	setupAppDialog	(&dialog, kAtomInfoDialogResID);
	simSetPlugNotificationSuspended (sim, true);
	if (! dialog.done )
	{
		dispatchCount (simOBJ(sim), ClassAtomType, &numAtomTypes );
		if ((whichType >= numAtomTypes) ||  (whichType <= 0)  ) whichType = 0;

		PenPat(&qd.black);
		setColour(myBlackColour);
		atObj =  kozoObjectGetNthItemOfClassX (simOBJ(sim), ClassAtomType, whichType);
		if (atObj)
		{
	 		at = atomtypeData(atObj);
			getSpecs(atObj, at, &tempTypespecs);
			GetDialogItem (dialog.dp,iAtomTypesPopupItem,&dialog.itemType,&(Handle)popupHandle,&dialog.itemRect);	
			SetDialogItem (dialog.dp,iAtomTypesPopupItem,(dialog.itemType & (0xFFFF - kItemDisableBit)) ,(Handle)popupHandle,&dialog.itemRect);	
		         SetControlValue (popupHandle, whichType + 1);
		}
		insertTypespecValues(dialog.dp, &tempTypespecs);
		GetDialogItem (dialog.dp,iSamplePictItem,&dialog.itemType,&tempHandle,&pictRect);
		drawSample(dialog.dp,  tempTypespecs.drawingRadius, &tempTypespecs.colour, &pictRect);
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;
			case iSetColourButtonItem:
				myPickAColor(& tempTypespecs.colour , (unsigned char *) "Choose The Atom Type Colour");
				drawSample(dialog.dp,  tempTypespecs.drawingRadius, &tempTypespecs.colour, &pictRect);
				break;
			case iConvertSelectionsItem:
				if (sim != nilPointer)
				{
					long i;
					long numParts;
					numParts = simGetNumParts(sim);
					
 					for (i = 0; i < numParts ; ++ i)
					{
					    if (getNthBit(&sim->selectedBits, i)) 
					    {
						     kSanParticleSetTypeByObj(sim, i,  at->atObj );
						}
					}
				}
				break;
			case iMassEditItem:
			case iRadiusEditItem:
				getTypespecValues(dialog.dp, &tempTypespecs);
			         drawSample(dialog.dp,  tempTypespecs.drawingRadius,&tempTypespecs.colour, &pictRect);
			         break;
			case iAtomicNumberUpItem:
			case iAtomicNumberDownItem:
				{
					short firstTime = true;
					long numTicks;
					while (Button() || firstTime)
					{
					     if (dialog.itemHit == iAtomicNumberDownItem) 
					     	{tempTypespecs.atNumber = tempTypespecs.atNumber - 1;}
					     else 
					     	{++tempTypespecs.atNumber;}
					     if (tempTypespecs.atNumber < 1) tempTypespecs.atNumber =1 ;
					     if (tempTypespecs.atNumber >103) tempTypespecs.atNumber = 103 ;
					     tempTypespecs.mass = periodicTableValue( tempTypespecs.atNumber, pAtomicMass);
					     periodicTableString( tempTypespecs.atNumber, pAtomicSymbol, tempTypespecs.symbol);
					     CTo255 (tempTypespecs.symbol, nameText);
					     insertTypespecValues(dialog.dp, &tempTypespecs);
					     numTicks = TickCount();
					     if (firstTime)
					     {
					        firstTime = false;
					        while (TickCount() < (numTicks + 20)){}
					     }
					     else
					     {
					      	while (TickCount() < (numTicks + 5)){}
					     }
				     }
				 }
				 break;
			case iSymbolEditItem:
			        getTextItem (dialog.dp, iSymbolEditItem, nameText);	
				    two55ToC (nameText, tempTypespecs.symbol, 6);
			        tempTypespecs.atNumber = atomicNumberOfAtomicSymbol(tempTypespecs.symbol);
			        if (tempTypespecs.atNumber != 0)
			        {
			    	    tempTypespecs.mass = periodicTableValue( tempTypespecs.atNumber, pAtomicMass);
			    	    insertTypespecValues(dialog.dp, &tempTypespecs);
			        }
				break;
			case iAtomTypesPopupItem:
			{
				short tempType;
				
				tempType = GetControlValue(popupHandle); //minus one because we start at zero and 
				    // menus start at one
				if ((tempType != 0)&&(whichType != tempType - 1))
				{
					long numAtomTypes;
					getTypespecValues(dialog.dp, &tempTypespecs);
					setSpecs(atObj, at, &tempTypespecs);
					dispatchCount (simOBJ(sim), ClassAtomType, &numAtomTypes);
					whichType = tempType - 1;  
					if (whichType >= numAtomTypes)
					{
						atObj = makeNewAtomtype (simOBJ(sim),  40, 18, nilPointer);
					}
					else
					{
						atObj =  kozoObjectGetNthItemOfClassX( simOBJ(sim), ClassAtomType, whichType);
					}
					at = atomtypeData(atObj);
					getSpecs(atObj, at, &tempTypespecs);
					insertTypespecValues(dialog.dp, &tempTypespecs);
					drawSample(dialog.dp,  tempTypespecs.drawingRadius, &tempTypespecs.colour,  &pictRect);
				 }
			}		
			break;	
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
		getTypespecValues(dialog.dp, &tempTypespecs);
		setSpecs(atObj, at, &tempTypespecs);
	}
	OHBreakdownDialog(&dialog);
	simSetPlugNotificationSuspended (sim, false);
	DeleteMenu(100);
	ReleaseResource((Handle)popupMenu);
	dispatchNilMessage( simOBJ(sim),  kInvalWorldsMessage);
	return (dialog.itemHit);
}
void addPopupItem(MenuHandle aMenu)
{
	AppendMenu (aMenu, "\p s");
}

void setAtomTypePopupText(kSanSimulation *sim, MenuHandle aMenu, long item) // this is the user interface type -- start at 1
{
	Str255 theString;
	OHList *atList;
	kozoObject  *atObj;
	kSanAtomtype *at;
	char *p;
	p = (char *) theString;
	
	atList = getListOfObjectsOfClassX(simOBJ(sim), ClassAtomType);
	if ((atList) && (item <= OHListCount(atList)))
	{
		atObj = castTokozoObject (getNthItem(atList, item - 1));
		at = atomtypeData(atObj);
		sprintf(p, " type %ld -- %s ", item, at->specs.symbol);
		p[0] = strlen (&p[1]);
		releaseListOfObjectsOfClassX(simOBJ(sim), ClassAtomType);
	}
	else
	{
		sprintf(p, " New Type");
		p[0] = 8;
	}
	
	SetMenuItemText (aMenu, item, theString);
}

 
void getTypespecValues(DialogPtr dialog, typespecs *tempSpecs)
{	
    Str255 nameText;

	 tempSpecs->mass = getDoubleItem(dialog,iMassEditItem,1000, 1); 
	 tempSpecs->drawingRadius = getDoubleItem(dialog,iRadiusEditItem, 2.5, 0.01); 		
	 tempSpecs->atNumber = getLongItem (dialog,iAtomicNumberTextItem,103, 1);
	getTextItem (dialog,iSymbolEditItem, nameText);	
	two55ToC(nameText, tempSpecs->symbol, 6);
}

void  	insertTypespecValues(DialogPtr dialog,  typespecs *tempSpecs)
{
         Str255 nameText;
    
	CTo255 (tempSpecs->symbol, nameText);
	prepTextItem (dialog,iSymbolEditItem,nameText);
	prepLongItem (dialog,iAtomicNumberTextItem,tempSpecs->atNumber);
	prepDoubleItem(dialog,iMassEditItem,tempSpecs->mass); 
	prepDoubleItem(dialog,iRadiusEditItem,tempSpecs->drawingRadius); 
}
MenuHandle   buildAtomTypesPopupMenu(kSanSimulation *sim, short withNewType)
{
	MenuHandle theMenu;
	kSanAtomtype;
	short i;
	long  count;
	
	theMenu = GetMenu(100); // 100 is the popup ID
	if (theMenu != nilPointer) InsertMenu (theMenu, -1);
	dispatchCount (simOBJ(sim), ClassAtomType, &count);
 	for (i=1;i<=count;++i)
	{
		addPopupItem(theMenu);
		setAtomTypePopupText(sim, theMenu, i);
	}
	if (withNewType)
	{
		addPopupItem(theMenu);
		setAtomTypePopupText(sim, theMenu, i);
	}
	return (theMenu);	
}
