#include "kSanSimDataWindow.h"
#include "kSanSimulation.h"
void DrawHandleAt(short hVal,short *vVal, Point offset,Handle myHand);
short  SimDataWindowDraw(KozoDispatchStack *ds, viewDrawArgs *args);

short initClassSimDataWindow(void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co,ClassSimDataWindow, ClassView, sizeof (kSanSimDataWindow), "sim data window");
	if (newClass)
	{
		err = setFuncs(newClass, 0L,  SimDataWindowConstructor,
		nilPointer, nilPointer, nilPointer, nilPointer,
		 nilPointer, nilPointer, nilPointer, nilPointer);
		OHViewSetViewFuncs (newClass, SimDataWindowDraw, nilPointer, nilPointer, nilPointer, nilPointer);
		addInheritance(newClass, ClassScrollableView);
		addInheritance(newClass, ClassBufferedView);
		addInheritance(newClass, ClassPane);
		addInheritance(newClass, ClassWindow);
	}
	else
	{
		err = true;
	}
	return (err);
}

short SimDataWindowConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
	short err = noErr;
	kSanSimDataWindow * sdp = (kSanSimDataWindow *) ds->thisPD;
 
	err = dispatchLoop(ds, cma);
	if (!err)
	{		
 		sdp->totalLines =   0;
		sdp->showErrors =   true;
		sdp->showSimInfo =  true ;
		sdp->showCellInfo =   true;
		sdp->showTemperatureInfo =  true ;
		sdp->showMethodInfo =   true;
		sdp->showSeps =  true ;
		sdp->showAngles =   true;
		sdp->lastUpdate = 0;
		sdp->sim = nilPointer;
	}
	KDSReturnError(ds, err);
}
			
void writeXOfAAndBIs(short hVal, short * vVal, Point offset, Str255 firstString, 
			long a, long b, particle * basePart, double theValue)
{
	Str255 myString;
	MoveTo (offset.h +hVal, offset.v +(*vVal) * kLineHeight);
	setColour(myBlackColour);  	
	DrawString(firstString);

	setColour(highlightColour + basePart->basePi[a].highlighted);  	
	NumToString((long)( a + 1), myString);
	DrawString(myString);

	setColour(myBlackColour);  	
	DrawString("\p and ");
	
	setColour(highlightColour + basePart->basePi[b].highlighted);  	
	NumToString((long)( b + 1), myString);
	DrawString(myString);
	
	setColour(myBlackColour);  	
	DrawString("\p is ");
	doubleToPString(theValue, myString);  // write distance between 0 and 1 is 2.45555
	DrawString(myString);
	(*vVal) += 1;
}		
void writeXOfABCIs(short hVal, short * vVal, Point offset, Str255 firstString, 
					long a, long b, long c, particle * basePart, double theValue)
{
	Str255 myString;
	
	MoveTo (offset.h +hVal, offset.v +(*vVal) * kLineHeight);
	setColour(myBlackColour);  	
	DrawString(firstString);

	setColour(highlightColour + basePart->basePi[a].highlighted);  	
	NumToString((long)a+1, myString);
	DrawString(myString);

	setColour(myBlackColour);  	
	DrawString("\p - ");
	
	setColour(highlightColour + basePart->basePi[b].highlighted);  	
	NumToString((long)b+1, myString);
	DrawString(myString);

	setColour(myBlackColour);  	
	DrawString("\p - ");
	
	setColour(highlightColour + basePart->basePi[c].highlighted);  	
	NumToString((long)c+1, myString);
	DrawString(myString);
	
	setColour(myBlackColour);  	
	DrawString("\p is ");
	
	doubleToPString(theValue, myString);  // write distance between 0 and 1 is 2.45555
	DrawString(myString);
	(*vVal) += 1;
}		

void DrawHandleAt(short hVal,short *vVal, Point offset,Handle myHand)
{
	short length;
	char hState;
	length = GetHandleSize (myHand);
	MoveTo (offset.h +hVal,offset.v +((*vVal) * kLineHeight));
	hState = HGetState(myHand);
	HLock (myHand);
	DrawText (*myHand, 0, length);
	HSetState(myHand, hState);
	(*vVal) += 1;
}		

void DrawStringsAt(short hVal,short vVal, Point offset,Str255 firstString, Str255 secondString)
{
	MoveTo (offset.h +hVal, offset.v +(vVal) * kLineHeight);
	DrawString (firstString);
	DrawString (secondString);
}

void DrawLongAt(short hVal,short * vVal, Point offset,Str255 firstString, long theLong, Str255 secondString)
{
	Str255 longString;
	MoveTo (offset.h +hVal,offset.v + ((*vVal) * kLineHeight));
	NumToString(theLong,longString);
	DrawString (firstString);
	DrawString (longString);
	DrawString (secondString);
	(*vVal) += 1;
}

void DrawDoubleAt(short hVal,short * vVal, Point offset,Str255 firstString, double theDouble, Str255 secondString)
{
	Str255 doubleString;
	MoveTo (hVal + offset.h, offset.v + ((*vVal) * kLineHeight));
	doubleToPString(theDouble,doubleString);
	DrawString (firstString);
	DrawString (doubleString);
	DrawString (secondString);
	(*vVal) += 1;
}

short  SimDataWindowDraw(KozoDispatchStack *ds, viewDrawArgs *args)
{ // just a simple draw
         short err = noErr;
         short numHighlights;
  	particle * basePart;
	long *hilitePtr;
	long numParts, counter, aLong;
	short lineVal, colVal;
	double aDouble;
	OHList * aList;
 	kSanSimDataWindow * sdp = (kSanSimDataWindow *) ds->thisPD;
	OHView *view;
	view = KDSGetPrivateData(ds, ClassView );
 	if (sdp->lastUpdate < (TickCount() + 60))
	{
 		if (!sdp->sim)  sdp->sim = simData(ds->obj);
		// note make this more robust in the future
		if (sdp->sim)
		{
			PenMode (patCopy);
			
			EraseRect(&(view->rect)); 
			setColour(myBlackColour);  
			TextFont (kFontIDGeneva);
			TextSize (10);
			lineVal = 1; 
			colVal = 5 ;  
			
			basePart = simLockParts(sdp->sim);	
				DrawLongAt  (colVal,&lineVal, args->offset, "\pIteration # ",sdp->sim->totalNumberOfIterations,"\p ");
			// total E	
		         aDouble = sdp->sim->potEnergy + sdp->sim->kinEnergy;
				DrawDoubleAt(colVal,&lineVal, args->offset,"\pTotal E      ", aDouble, "\p ");
			// number of particles
		         numParts =  sdp->sim->howManyParts ;
				DrawLongAt  (colVal,&lineVal, args->offset,"\p",numParts,"\p particles ");
			// potential E	
				DrawDoubleAt(colVal,&lineVal, args->offset,"\pPotential E  ", sdp->sim->potEnergy, "\p ");
			// temperature or successful events	
			if (sdp->showTemperatureInfo)
			{	
				long numGroups;
				long numInGroup;
				kSanGroup **baseGroup;
				kSanGroup *gp;
				baseGroup = simLockGroups(sdp->sim);
		 		numGroups = simGetNumGroups(sdp->sim);
				for(counter = 0; counter<numGroups;++counter)
				{
					gp = baseGroup[counter];
					numInGroup = OHListCount(&gp->particles);
					RGBForeColor(&gp->colour);
					DrawLongAt  (colVal,&lineVal, args->offset,"\pGroup ", (counter + 1) ,"\p info ");
					DrawLongAt  (colVal,&lineVal, args->offset,"\p  ",numInGroup,"\p particles in group ");
					if (!gp->doCooling)
					{
							setColour(myRedColour);  	
					}
					else if (gp->actualTemp > gp->eqTemp)
					{
							setColour(myRedColour);  	
					}
					else 
					{
							setColour(myBlueColour);  		
					}
					DrawDoubleAt(colVal,&lineVal, args->offset,"\p  Temperature  ", gp->actualTemp, "\p");				
					setColour(myBlackColour);  	
					DrawDoubleAt(colVal,&lineVal, args->offset,"\p  Equilibrium Temp  ", gp->eqTemp, "\p");	
				}
				simReleaseGroups(sdp->sim);
			}
			if (sdp->showMethodInfo)
			{	
		//		DrawDoubleAt(colVal,&lineVal,"\pEnergy Change ", (cg.delEnergy), "\p eV");
		//		DrawDoubleAt(colVal,&lineVal,"\pMax displacement ", (cg.displacement), "\p A");
			}
			if (sdp->showCellInfo)
			{	
				kSanMatrix  trix;
				 getPrimitiveVectors(sdp->sim , &trix);
				 aDouble = lengthOfkSanVectorD(&trix.A);
				DrawDoubleAt(colVal,&lineVal, args->offset,"\p cell a length is ", aDouble, "\p A");
				 aDouble = lengthOfkSanVectorD(&trix.B);
				DrawDoubleAt(colVal,&lineVal, args->offset,"\p cell b length is ", aDouble, "\p A");
#ifndef __2DVectors__
				 aDouble = lengthOfkSanVectorD(&trix.C);
				DrawDoubleAt(colVal,&lineVal, args->offset,"\p cell c length is ", aDouble, "\p A");
#endif
			}
			counter = 0;
			aList = getHighlightsList(sdp->sim) ;

			hilitePtr = lockList(aList);
			numHighlights = OHListCount(aList);
			while (counter < numHighlights) // indices, NNs and potentials
			{
				long partArrIndex;
				partArrIndex = hilitePtr[counter];
				setColour(highlightColour + BPNthHighlighted(basePart, partArrIndex));  	
				DrawLongAt  (colVal,&lineVal, args->offset,"\pParticle number ",(partArrIndex + 1),"\p        ");
				
		//			aLong = (((NNInfoPtr)(*NNDataHandle))[partArrIndex]).neighborNumber;
				aLong = simNumNeighbors(sdp->sim, basePart,  partArrIndex);
				DrawLongAt  (colVal,&lineVal, args->offset,"\p  has ",aLong,"\p neighbors       ");
				DrawDoubleAt(colVal,&lineVal, args->offset,"\p  with potential of ", (basePart->basePotential[partArrIndex]), "\p eV");
				++ counter;
			}
			if (sdp->showSeps)
			{
				long thisLabel, thatLabel;
				short howManySeps, i;
				
				kSanVector  mSepArray[NUMNEIGHBORINGBOXES];
				double  mRadArray[NUMNEIGHBORINGBOXES] ;
				double  mScreenArray[NUMNEIGHBORINGBOXES] ;
				if (!err)
				{
					counter = 0;
					while (counter < numHighlights - 1) // separations, screening for two or more
					{
						long otherCounter = counter+1;
						while (otherCounter < numHighlights )
						{
							thisLabel = hilitePtr[counter];
							thatLabel = hilitePtr[otherCounter];
							howManySeps = getAllSepsAndScreenings(sdp->sim,
									basePart, thisLabel, thatLabel, mSepArray, mRadArray, mScreenArray);
		 									
							for (i = 0; i < howManySeps; ++i)
							{				
								writeXOfAAndBIs(colVal, &lineVal, args->offset,"\pSeparation of ", 
										hilitePtr[counter], hilitePtr[otherCounter], basePart, mRadArray[i]);
								writeXOfAAndBIs(colVal, &lineVal, args->offset,"\pScreening of ", 
										hilitePtr[counter], hilitePtr[otherCounter], basePart, mScreenArray[i]);
							}
							++otherCounter;	
						}
						++counter;
					}
				}
				
				else
				{
				      doAlert("\psim win error");
				}
			}
			if (sdp->showAngles)
			{
				counter = 0;
				while (counter < numHighlights - 2) // angles for three or more
				{
					short a,b,c;
					long secondCounter;
					a = hilitePtr[counter];
					secondCounter = counter+1;
					while (secondCounter < numHighlights - 1)
					{
						long thirdCounter;
						thirdCounter = secondCounter + 1;
						b = hilitePtr[secondCounter];
						while (thirdCounter < numHighlights )
						{
							double angle;
							c = hilitePtr[thirdCounter];
							angle  = angleBetweenThreekSanPointsInDegreesD(&(basePart->basePosition[a]),
													 &(basePart->basePosition[b]),
													 &(basePart->basePosition[c]));			
							writeXOfABCIs(colVal, &lineVal, args->offset,"\pAngle of ", a, b, c, basePart, angle);
							angle  = angleBetweenThreekSanPointsInDegreesD(&(basePart->basePosition[b]),
													 &(basePart->basePosition[c]),
													 &(basePart->basePosition[a]));			
							writeXOfABCIs(colVal, &lineVal, args->offset,"\pAngle of ", b, c, a, basePart, angle);
							angle  = angleBetweenThreekSanPointsInDegreesD(&(basePart->basePosition[c]),
													 &(basePart->basePosition[a]),
													 &(basePart->basePosition[b]));			
							writeXOfABCIs(colVal, &lineVal, args->offset,"\pAngle of ", c, a, b, basePart, angle);
							++thirdCounter;
						}					
						++secondCounter;
					}	
					++counter;
				}	
			}
			if (sdp->totalLines != lineVal )
			{
				Rect r;
				OHSetRect (&r, 0, 0, 400, ((lineVal + 2) * kLineHeight));
		                 kozoSetDataPtr (ds->obj, pEmbeddedBounds , typeQDRectangle, &r, sizeof(Rect));
		                 sdp->totalLines = lineVal;
		//                kozoDoMessage (ds->obj, kMaintainScrollsMessage , 0L);
			}  
			releaseList(aList);
			simReleaseParts(sdp->sim);
		}
		sdp->lastUpdate = TickCount();
	}
	KDSReturnError(ds, err);
}
void SimDataWindowDrawDebugString(kozoObject *obj, char *c)
{
	Rect eRect;
	OHWindow  *wp;
	Str255 pStr;
	wp = OHWin(obj);
	portSetGWorld ( &wp->gotPortList,(GWorldPtr) wp->window, 0L);
	PenMode (patCopy);
	
	setColour(myBlackColour);  
	TextFont (kFontIDGeneva);
	TextSize (10);
	OHSetRect (&eRect, 3, 3 , 200,18);
	EraseRect(&eRect); 

	MoveTo (5, 15);
	copyC2P(c, (unsigned char *)pStr, 255);
	DrawString (pStr);

	portRestoreGWorld ( &wp->gotPortList);
}
