#include "OHAELauncher.h"
#include "OHBufferedView.h"
#include "kSanSimulationPrivate.h"
#include "kSanUnits.h"
#include "kSanSharedUtils.h"
#include "kSanDialog.h"
#include "kSanDataCollectionPlugIn.h"

#include "kSanGroup.h"
#include "kSanSimDialog.h"
#include "kSanRezIDs.h"
#include "kSanMenuDefines.h"



short	DoDefaultDialog	(kSanSimulation *sim);
void  	insertGroupInfoValues(DialogPtr dialog, kSanSimulation *sim, short whichGroup, 
					kSanGroupInfo *grInfo, ControlHandle *radioHandle);

void insertEditAtomValues(DialogPtr dialog, particle * basePart, long partArrIndex);

void getDialogVectors (DialogPtr dialog, kSanLongVector * nA, kSanLongVector * nB,kSanLongVector * nC);

void getPlugItems (DialogPtr dp, kozoObject*dcPlugObj);
void setPlugItems (DialogPtr dp, kozoObject*dcPlugObj,  short useMe);



short	DoGroupInfoDialog	(kSanSimulation *sim, long whichGroup)
{
	OHBasicDialog dialog;
	short i;
	kSanGroupInfo tempGroupInfo;
	Handle		tempHandle;
	Handle      checkHandle;
	ControlHandle radioHandle[9];
	ControlHandle popupHandle;
	MenuHandle groupMenu;
	Rect		 pictRect;
	long numGroups;
	
	double      dummyDouble;

	groupMenu = buildGroupPopupMenu(sim);
	InsertMenu (groupMenu, -1);
	setupAppDialog	(&dialog, kGroupInfoDialogResID);
	if (! dialog.done )
	{
		dispatchCount (simOBJ(sim), ClassParticleGroup, &numGroups);
		if ((whichGroup < 0 ) || whichGroup >= numGroups) whichGroup = 1;
		getGroupInfo (sim, (whichGroup - 1), &tempGroupInfo);
		PenPat(&qd.black);
		setColour(myBlackColour);
		for (i=0;i<9;++i)
		{
			GetDialogItem (dialog.dp,iBaseRadioItem+i,&dialog.itemType,&tempHandle,&dialog.itemRect);	
			radioHandle[i] = (ControlHandle)tempHandle;
		}
		GetDialogItem (dialog.dp,iGroupPopup,&dialog.itemType,&(Handle)popupHandle,&dialog.itemRect);	
	    SetControlValue (popupHandle, whichGroup);
		insertGroupInfoValues(dialog.dp, sim,  whichGroup, &tempGroupInfo, radioHandle);
		GetDialogItem (dialog.dp,iGroupSamplePictItem,&dialog.itemType,&tempHandle,&pictRect);
		drawSample(dialog.dp, 1.5, &tempGroupInfo.colour,  &pictRect);
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
			case iSetGroupColourButtonItem:
				myPickAColor(&tempGroupInfo.colour, (unsigned char *) "Choose the Group Colour");
				break;
			case iGroupPopup:
			{
				long tempGroup;				
				tempGroup = GetControlValue(popupHandle); //minus one because we start at zero and 
				    // menus start at one
				if ((tempGroup != whichGroup) && (tempGroup != 0))
				{
					simSetGroupValues (sim,  whichGroup, &tempGroupInfo);
					whichGroup = tempGroup; 
					insertGroupInfoValues(dialog.dp, sim, whichGroup, &tempGroupInfo, radioHandle);
					drawSample(dialog.dp,  1.5, &tempGroupInfo.colour,  &pictRect);
				}
			}
				break;	
			case iBaseRadioItem:
			case iBaseRadioItem + 1:
			case iBaseRadioItem + 2:
				SetControlValue(radioHandle[tempGroupInfo.XYZConstraints[0]],kRadioUnselected);
				tempGroupInfo.XYZConstraints[0] = dialog.itemHit - (iBaseRadioItem);
				SetControlValue(radioHandle[tempGroupInfo.XYZConstraints[0]],kRadioSelected);
				break;								
			case iBaseRadioItem +3 :
			case iBaseRadioItem +4:
			case iBaseRadioItem +5:
				SetControlValue(radioHandle[ 3 + tempGroupInfo.XYZConstraints[1]],kRadioUnselected);
				tempGroupInfo.XYZConstraints[1] = dialog.itemHit - (iBaseRadioItem + 3);
				SetControlValue(radioHandle[3 + tempGroupInfo.XYZConstraints[1]],kRadioSelected);
				break;				
			case iBaseRadioItem +6:
			case iBaseRadioItem +7:
			case iBaseRadioItem +8:
				SetControlValue(radioHandle[ 6 + tempGroupInfo.XYZConstraints[2]],kRadioUnselected);
				tempGroupInfo.XYZConstraints[2] = dialog.itemHit - (iBaseRadioItem + 6);
				SetControlValue(radioHandle[6 + tempGroupInfo.XYZConstraints[2]],kRadioSelected);
				break;
			case iForceXEdit:
				dummyDouble = getDoubleItem(dialog.dp,iForceXEdit,10000000, -10000000); 		
				tempGroupInfo.forceApplied.a = dummyDouble * kHellmanPressuresPerMPa;
				break;	
			case iForceYEdit:
				dummyDouble = getDoubleItem(dialog.dp,iForceYEdit, 10000000, -10000000); 		
				tempGroupInfo.forceApplied.b = dummyDouble * kHellmanPressuresPerMPa;
				break;
#ifndef __2DVectors__
			case iForceZEdit:
				dummyDouble = getDoubleItem(dialog.dp,iForceZEdit, 10000000, -10000000); 		
				tempGroupInfo.forceApplied.c = dummyDouble * kHellmanPressuresPerMPa;
				break;	
#endif
			case iGroupEqTemp:
				tempGroupInfo.eqTemp = getDoubleItem(dialog.dp,iGroupEqTemp, 100000, 0); 		
				break;	
			case iGroupCooling:
				tempGroupInfo.coolingTimeConstant = getDoubleItem(dialog.dp,iGroupCooling, 50.0, 0.001); 		
				break;	
			case iCoolingCheckItem:
				GetDialogItem(dialog.dp,iCoolingCheckItem,&dialog.itemType,&checkHandle,&dialog.itemRect);
				tempGroupInfo.doCooling = !(GetControlValue((ControlHandle)checkHandle));
				SetControlValue((ControlHandle)checkHandle,tempGroupInfo.doCooling);				
				break;	
			case iApplyAForce:
				GetDialogItem(dialog.dp,iApplyAForce,&dialog.itemType,&checkHandle,&dialog.itemRect);
				tempGroupInfo.applyAForce = !(GetControlValue((ControlHandle)checkHandle));
				SetControlValue((ControlHandle)checkHandle, tempGroupInfo.applyAForce);
				if (!GetControlValue((ControlHandle)checkHandle))
				{
					HideDialogItem (dialog.dp,iForceXEdit);
					HideDialogItem (dialog.dp,iForceYEdit);
					HideDialogItem (dialog.dp,iForceZEdit);
				}
				else
				{
					ShowDialogItem (dialog.dp,iForceXEdit);
					ShowDialogItem (dialog.dp,iForceYEdit);
					ShowDialogItem (dialog.dp,iForceZEdit);
				}
				break;	
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
		simSetGroupValues (sim, whichGroup, &tempGroupInfo);
	}
	OHBreakdownDialog(&dialog);
	DeleteMenu (mGroupPopup);
	DisposeMenu(groupMenu);
	kozoObjectMessageForContents(simOBJ(sim), ClassWindow,  kInvalGraphicsMessage, 0L, 0L);
	return (dialog.itemHit);
}

void simSetGroupValues (kSanSimulation *sim,  short whichGroup, kSanGroupInfo *grInfo)
{
	OHList *gpList;
	kozoObject *gpObj;
	kSanGroup *gp;
	gpList =  getListOfObjectsOfClassX (simOBJ(sim), ClassParticleGroup);
	if (gpList)
	{
 		gpObj = castTokozoObject (getNthItem(gpList,whichGroup -1));
		gp = gpData(gpObj);
		gp->applyAForce = grInfo->applyAForce;
		gp->doCooling = grInfo->doCooling;
		if (grInfo->applyAForce)
		{
			gp->forceApplied = grInfo->forceApplied;
		}
		else 
		{
			zerokSanVectorD (&gp->forceApplied); 
		}
		gp->coolingTimeConstant = grInfo->coolingTimeConstant;
		 gp->eqTemp =  grInfo->eqTemp ;
		gp->XYZConstraints[0] = grInfo->XYZConstraints[0] ;
		gp->XYZConstraints[1] = grInfo->XYZConstraints[1] ;
		gp->XYZConstraints[2] = grInfo->XYZConstraints[2] ;
		gp->colour = grInfo->colour;   
		 releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
	}
}
void  	insertGroupInfoValues(DialogPtr dialog, kSanSimulation *sim,  short whichGroup, 
					kSanGroupInfo *grInfo, ControlHandle *radioHandle)
{
	short i, j;
	double forceInMPa;
	OHList *gpList;
	kozoObject *gpObj;
	kSanGroup *gp;
	gpList = getListOfObjectsOfClassX (simOBJ(sim), ClassParticleGroup);
	if (gpList)
	{
 		gpObj = castTokozoObject (getNthItem (gpList , whichGroup -1));
		gp = gpData(gpObj);
		 prepCheckItem (dialog, iApplyAForce, gp->applyAForce);
		 prepCheckItem (dialog, iCoolingCheckItem, gp->doCooling );

		forceInMPa = gp->forceApplied.a  / kHellmanPressuresPerMPa;
		prepDoubleItem(dialog,iForceXEdit,forceInMPa); 
		forceInMPa = gp->forceApplied.b  / kHellmanPressuresPerMPa;
		prepDoubleItem(dialog,iForceYEdit,forceInMPa); 
#ifndef __2DVectors__
		forceInMPa = gp->forceApplied.c  / kHellmanPressuresPerMPa;
		prepDoubleItem(dialog,iForceZEdit,forceInMPa); 
#else
		prepDoubleItem(dialog,iForceZEdit,0); 
		setControlItemEnabled(dialog,iForceZEdit,false); 
#endif
		prepDoubleItem(dialog,iGroupCooling,gp->coolingTimeConstant); 
		prepDoubleItem(dialog,iGroupEqTemp,gp->eqTemp);
		if (!gp->applyAForce)
		{
			HideDialogItem (dialog,iForceXEdit);
			HideDialogItem (dialog,iForceYEdit);
			HideDialogItem (dialog,iForceZEdit);
		}
		else
		{
			ShowDialogItem (dialog,iForceXEdit);
			ShowDialogItem (dialog,iForceYEdit);
			ShowDialogItem (dialog,iForceZEdit);
		}
		if (!gp->doCooling)
		{
			HideDialogItem (dialog,iGroupCooling);
			HideDialogItem (dialog,iGroupEqTemp);
		}
		else
		{
			ShowDialogItem (dialog,iGroupCooling);
			ShowDialogItem (dialog,iGroupEqTemp);
		}
		for (i=0 ; i<3 ; ++i)
		{
			for (j=0 ; j<3 ; ++j)
			{
				SetControlValue(radioHandle[(3*i) + j],(short)kRadioUnselected);
			}	
			SetControlValue(radioHandle[(3*i) + gp->XYZConstraints[i]],(short)kRadioSelected);		
		}
		grInfo->XYZConstraints[0] = gp->XYZConstraints[0];
		grInfo->XYZConstraints[1] = gp->XYZConstraints[1];
		grInfo->XYZConstraints[2] = gp->XYZConstraints[2];
		grInfo->colour = gp->colour;
		grInfo->forceApplied = gp->forceApplied;
		grInfo->eqTemp = gp->eqTemp;
		grInfo->coolingTimeConstant = gp->coolingTimeConstant;
		grInfo->applyAForce = gp->applyAForce;
		grInfo->doCooling = gp->doCooling;
		releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
	}
}

void insertEditAtomValues(DialogPtr dialog, particle * basePart, long partArrIndex)
{
	prepDoubleItem(dialog, ipxEditItem, basePart->basePosition[partArrIndex].a);
	prepDoubleItem(dialog, ipyEditItem, basePart->basePosition[partArrIndex].b);
#ifndef __2DVectors__
	prepDoubleItem(dialog, ipzEditItem, basePart->basePosition[partArrIndex].c);
#endif
	prepDoubleItem(dialog, ivxEditItem, basePart->baseVelocity[partArrIndex].a);
	prepDoubleItem(dialog, ivyEditItem, basePart->baseVelocity[partArrIndex].b);
#ifndef __2DVectors__
	prepDoubleItem(dialog, ivzEditItem, basePart->baseVelocity[partArrIndex].c);
#endif
}

short	doEditParticleDialog	(kSanSimulation *sim, long partArrIndex)
{
	OHBasicDialog dialog;
	ControlHandle      popupHandle;
	particle *basePart;
 	kSanAtomtype **baseTypes;
	short whichType, tempType;
	double tempKE;
	kSanVector  tempVel;
	kSanVector  tempPos;
	kSanVector  oldPos;
	
	basePart = simLockParts(sim);
	baseTypes = simLockAtomTypes(sim);
 	setupAppDialog	(&dialog, kEditParticleDialogResID);
	if (! dialog.done )
	{
		insertEditAtomValues(dialog.dp, basePart, partArrIndex);
		prepLongItem (dialog.dp, iNumberOfParticleStaticItem, partArrIndex);
		GetDialogItem (dialog.dp,iEditAtomPopupItem,&dialog.itemType,&(Handle)popupHandle,&dialog.itemRect);
		whichType = BPNthType(basePart, partArrIndex);
	    SetControlValue (popupHandle, (whichType+1));
		tempVel = basePart->baseVelocity[partArrIndex];
		tempPos = basePart->basePosition[partArrIndex];
		oldPos = basePart->basePosition[partArrIndex];
		tempKE = kineticEInEV(&tempVel, baseTypes[whichType - 1]->specs.mass);
		prepDoubleItem(dialog.dp, ikineticEStaticItem, tempKE);
		prepDoubleItem(dialog.dp, ipotentialEStaticItem, basePart->basePotential[partArrIndex]);
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case iEditAtomPopupItem:
				tempType = GetControlValue(popupHandle) - 1; //minus one because we start at zero and 
				    // menus start at one
				if (tempType != whichType)
				{
					double massRatio, scalingFactor;
					massRatio = baseTypes[whichType - 1]->specs.mass / baseTypes[tempType - 1]->specs.mass;
					scalingFactor = sqrt(massRatio);
					  getDoubleVector (dialog.dp, ivxEditItem, &tempVel,kMaxDouble, kMinDouble);
 					multkSanVectorD(&tempVel, scalingFactor, &tempVel);
					prepDoubleVector (dialog.dp, ivxEditItem, &tempVel);
 					whichType = tempType;
				}
	 			break;
			case ivxEditItem:
			case ivyEditItem:
			case ivzEditItem:
			    getDoubleVector (dialog.dp, ivxEditItem, &tempVel, kMaxDouble, kMinDouble);

 				if (! vectorIsNan(&tempVel))
				{
					tempKE = kineticEInEV(&tempVel, baseTypes[whichType - 1]->specs.mass);
					prepDoubleItem(dialog.dp, ikineticEStaticItem, tempKE);
				}
	 			break;
			case ipxEditItem:
			case ipyEditItem:
			case ipzEditItem:
				tempPos.a = getDoubleItem(dialog.dp, ipxEditItem, sim->simCell.cellDim.a, -sim->simCell.cellDim.a);
				tempPos.b = getDoubleItem(dialog.dp, ipyEditItem, sim->simCell.cellDim.b, -sim->simCell.cellDim.b);
#ifndef __2DVectors__
				tempPos.c = getDoubleItem(dialog.dp, ipzEditItem, sim->simCell.cellDim.c, -sim->simCell.cellDim.c);
#endif
				if (!(vectorIsNan(&tempVel )) )
				{
					if ((sim->potentialPlugIn->onePartECalc != nilPointer) &&
					    vectorIsInsideCell(&sim->simCell, &basePart->basePosition[partArrIndex]))
 
					{
						double tempPE;
						kSanParticleSetPosition (sim,   partArrIndex, &tempPos);
	 					tempPE = basePart->basePotential[partArrIndex];
	 					prepDoubleItem(dialog.dp, ipotentialEStaticItem, tempPE);
 					}
					else 
					{
						prepTextItem(dialog.dp, ipotentialEStaticItem, "\p????");
					}
				}
	 			break;
			case iEditAtomRevertButton:
			    insertEditAtomValues(dialog.dp, basePart, partArrIndex );
				whichType = BPNthType(basePart, partArrIndex);
		        SetControlValue (popupHandle, whichType);
				tempVel = basePart->baseVelocity[partArrIndex];
				tempPos = basePart->basePosition[partArrIndex];
				tempKE = kineticEInEV(&tempVel, baseTypes[whichType - 1]->specs.mass);
				prepDoubleItem(dialog.dp, ikineticEStaticItem, tempKE);
	 			break;
			case ok:
			case cancel:
				dialog.done = true;
				break;		
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
	}
	OHBreakdownDialog(&dialog);
	simReleaseParts(sim);
	simReleaseAtomTypes(sim);
	return (dialog.itemHit);
}
short	ShouldWeSaveDialog	(kSanSimulation *sim)
{
#pragma unused(sim)
	OHBasicDialog dialog;
	
	setupAppDialog	(&dialog, kShouldWeSaveDialogResID);
	if (! dialog.done )
	{
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
			case kDontSaveData:
				dialog.done = true;
				break;		
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
	}
	OHBreakdownDialog(&dialog);
	return (dialog.itemHit);
}

short	DoParametersDialog	(kSanSimulation *sim)
{
 	char wasViz;
	char tempViz;
	short tempPotentialBeingUsed;
	short tempResizeBeingUsed;
	short tempMethodBeingUsed;
	double tempTime;
	ControlHandle  screeningPopup;
	ControlHandle  potentialPopup;
	ControlHandle  methodPopup;
	OHBasicDialog dialog;
	Str255 simName;
 	
	makePlugInMenus();
	kozoObjectGetNameAs255 (simOBJ(sim), simName);
 	setupAppDialog	(&dialog, kSimParamsDialogResID);
	kozoGetDataPtr(simOBJ(sim), pVisible,  typeShortInteger, (Ptr) &tempViz, 2L);
	wasViz = tempViz;
	tempTime = sim->deltaT;
	if (! dialog.done )
	{
		prepTextItem (dialog.dp, iSimNameStatic, simName);
 		prepDoubleItem (dialog.dp, iDeltaT, tempTime);
		tempPotentialBeingUsed =   whichPlugInMenuItem(ClassPotentialPlugIn, OHGetNamedReference (simOBJ(sim), ClassPotentialPlugIn));
		tempResizeBeingUsed = whichPlugInMenuItem(ClassCellResizePlugIn,  OHGetNamedReference (simOBJ(sim), ClassCellResizePlugIn));
		tempMethodBeingUsed =  whichPlugInMenuItem(ClassMethodPlugIn, OHGetNamedReference (simOBJ(sim), ClassMethodPlugIn));
		GetDialogItem (dialog.dp,iPotentialPopup,&dialog.itemType,&(Handle)potentialPopup,&dialog.itemRect);	
	         SetControlValue (potentialPopup,tempPotentialBeingUsed );
		GetDialogItem (dialog.dp,iScreeningPopup,&dialog.itemType,&(Handle)screeningPopup,&dialog.itemRect);	
	          SetControlValue (screeningPopup,tempResizeBeingUsed);
		GetDialogItem (dialog.dp,iMethodPopup,&dialog.itemType,&(Handle)methodPopup,&dialog.itemRect);	
	          SetControlValue (methodPopup,tempMethodBeingUsed);
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
			case iPotentialPopup:
				tempPotentialBeingUsed = GetControlValue(potentialPopup);
				break;
			case iScreeningPopup:
				tempResizeBeingUsed = GetControlValue(screeningPopup);
				break;
			case iMethodPopup:
				tempMethodBeingUsed = GetControlValue(methodPopup);
				break;
 		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
		waitForIterationToFinish(sim);
		
 		tempTime = getDoubleItem (dialog.dp, iDeltaT,  1000, 0.0000001);
		packageAndCallSetDouble(simOBJ(sim), pDeltaT, &tempTime);

		if (tempPotentialBeingUsed != whichPlugInMenuItem(ClassPotentialPlugIn, OHGetNamedReference (simOBJ(sim), ClassPotentialPlugIn)))
 		setModuleMenuChoice(sim, ClassPotentialPlugIn , tempPotentialBeingUsed);

		if (tempResizeBeingUsed != whichPlugInMenuItem(ClassCellResizePlugIn,  OHGetNamedReference (simOBJ(sim), ClassCellResizePlugIn)))
		setModuleMenuChoice(sim, ClassCellResizePlugIn, tempResizeBeingUsed);

		if (tempMethodBeingUsed != whichPlugInMenuItem(ClassMethodPlugIn, OHGetNamedReference (simOBJ(sim), ClassMethodPlugIn)))
		setModuleMenuChoice(sim, ClassMethodPlugIn, tempMethodBeingUsed);

		 simIncrementStateCount(sim);
	}
	OHBreakdownDialog(&dialog);
	deletePlugInMenus();

	return (dialog.itemHit);
}

short	DoFrequenciesDialog	(kSanSimulation *sim)
{
	OHBasicDialog dialog;
	
	setupAppDialog	(&dialog, kSimFrequenciesDialogResID);
	if (! dialog.done )
	{
		prepLongItem(dialog.dp,iItersPerDrawEditItem,sim->countThreshholds.redraw);
		prepLongItem(dialog.dp,iItersPerDataCalcEditItem,sim->countThreshholds.velocityCentering);
		prepLongItem(dialog.dp,iItersPerDataSaveEditItem,sim->countThreshholds.dataSave);
		prepLongItem(dialog.dp,iItersPerNeighborCheckEditItem,sim->countThreshholds.neighbor);
		prepLongItem(dialog.dp,iItersPerRenormEditItem,sim->countThreshholds.cellPressure);
		prepLongItem(dialog.dp,iItersPerMemCleanEditItem,sim->countThreshholds.memoryCleanup);
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
		sim->countThreshholds.redraw = getLongItem(dialog.dp,iItersPerDrawEditItem, 100000, 1);
		sim->countThreshholds.velocityCentering = getLongItem(dialog.dp,iItersPerDataCalcEditItem,  25, 1);
		sim->countThreshholds.dataSave = getLongItem(dialog.dp,iItersPerDataSaveEditItem, 100000, 1);
		sim->countThreshholds.neighbor = getLongItem(dialog.dp,iItersPerNeighborCheckEditItem, 25, 1);
		sim->countThreshholds.cellPressure = getLongItem(dialog.dp,iItersPerRenormEditItem, 1000, 1);	
		sim->countThreshholds.memoryCleanup = getLongItem(dialog.dp,iItersPerMemCleanEditItem, 10000, 1);	
	}
	OHBreakdownDialog(&dialog);
	return (dialog.itemHit);
}
short	DoCutoffParamsDialog	(kSanSimulation *sim)
{
	OHBasicDialog dialog;
	
	setupAppDialog	(&dialog, kCutoffParamsDialogResID);
	if (! dialog.done )
	{
		prepDoubleItem(dialog.dp,iInnerEditItem, sim->innerCutoff);	
		prepDoubleItem(dialog.dp,iOuterEditItem, sim->outerCutoff);	
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
		double inner;
		double outer;
		inner = getDoubleItem(dialog.dp,iInnerEditItem, 50000.0, 0.0);	
		outer = getDoubleItem(dialog.dp,iOuterEditItem, 50000.0, 0.0);	
		if (inner != sim->innerCutoff) UISetData( simOBJ(sim), pInnerCutoff, typeLongFloat, &inner, 8L);
		if (outer != sim->outerCutoff) UISetData( simOBJ(sim), pOuterCutoff, typeLongFloat, &outer, 8L);
 	}
	OHBreakdownDialog(&dialog);
	return (dialog.itemHit);
}

short	DoCellSizeDialog	(kSanSimulation *sim)
{
	OHBasicDialog dialog;
	kSanVector oldSize;
	kSanVector newSize;
 	double oldGamma;
	double oldBeta;
	double oldAlpha;
	double newAlpha; // xy
	double newBeta; // yz
	double newGamma; // zx
	
	setupAppDialog	(&dialog, kConstraintsDialogResID);
	if (! dialog.done )
	{
	   oldSize = sim->simCell.cellEdges;
 		prepDoubleVector (dialog.dp, iCellXDimEditItem , &sim->simCell.cellEdges);

 		oldAlpha = sim->simCell.alpha;
		oldBeta = sim->simCell.beta;
		oldGamma = sim->simCell.gamma;
		newAlpha = oldAlpha * 180 / kPi;
		newBeta = oldBeta * 180 / kPi;
		newGamma = oldGamma * 180 / kPi;
		prepDoubleItem(dialog.dp,iCellAlphaEditItem , newAlpha);
		prepDoubleItem(dialog.dp,iCellBetaEditItem , newBeta);
		prepDoubleItem(dialog.dp,iCellGammaEditItem , newGamma);
		prepCheckItem(dialog.dp,iXCheckItem , sim->gConstrained.XAxis);
		prepCheckItem(dialog.dp,iYCheckItem , sim->gConstrained.YAxis);
		prepCheckItem(dialog.dp,iZCheckItem , sim->gConstrained.ZAxis);
		prepCheckItem(dialog.dp,iXYAngleCheckItem , sim->gConstrained.Gamma);
		prepCheckItem(dialog.dp,iYZAngleCheckItem , sim->gConstrained.Alpha);
		prepCheckItem(dialog.dp,iZXAngleCheckItem , sim->gConstrained.Beta);
		prepCheckItem(dialog.dp,iScaleWithCellCheckItem , true);
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
			case iXCheckItem:
			case iYCheckItem:
			case iZCheckItem:
			case iXYAngleCheckItem :
			case iYZAngleCheckItem :
			case iZXAngleCheckItem :
			case iScaleWithCellCheckItem:
				switchCheckItem(dialog.dp, dialog.itemHit);
				break;	
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
		short weShouldScale;			
			
		sim->gConstrained.XAxis = getCheckItem(dialog.dp,iXCheckItem );
		sim->gConstrained.YAxis = getCheckItem(dialog.dp,iYCheckItem );
		sim->gConstrained.ZAxis = getCheckItem(dialog.dp,iZCheckItem );
		sim->gConstrained.Alpha = getCheckItem(dialog.dp,iXYAngleCheckItem );
		sim->gConstrained.Beta = getCheckItem(dialog.dp,iYZAngleCheckItem );
		sim->gConstrained.Gamma = getCheckItem(dialog.dp,iZXAngleCheckItem );
		weShouldScale = getCheckItem(dialog.dp,iScaleWithCellCheckItem );
		
		getDoubleVector ( dialog.dp,iCellXDimEditItem , &newSize, kMaxDouble, 0.000001);
 
		newAlpha = getDoubleItem(dialog.dp,iCellAlphaEditItem , 179, 1);
		newBeta = getDoubleItem(dialog.dp,iCellBetaEditItem , 179, 1);
		newGamma = getDoubleItem(dialog.dp,iCellGammaEditItem , 179, 1);
		newAlpha *= (kPi / 180);
		newBeta *= (kPi / 180);
		newGamma *= (kPi / 180);
		if (!weShouldScale)
		{
		    sim->simCell.cellEdges = newSize;
 		    sim->simCell.alpha = newAlpha;
		    sim->simCell.beta = newBeta;
		    sim->simCell.gamma = newGamma;
		    calcCellPropertiesFromEdgesAndAngles(&sim->simCell );
		    setOrthorhombicTriclinicSwitch(sim);
		}
		else 
		{
			kSanVector  scaleVec;
			scaleAngles (sim, newAlpha, newBeta, newGamma);
			scaleVec.a =  newSize.a / oldSize.a;
			scaleVec.b = newSize.b / oldSize.b;
#ifndef __2DVectors__
			scaleVec.c =  newSize.c / oldSize.c;
#endif
		    scaleAxis (sim, pCellXYZLength, &scaleVec);
		}
		initBoxes(sim);
	}
	OHBreakdownDialog(&dialog);
	return (dialog.itemHit);
}
short	DoCellStressDialog	(kSanSimulation *sim)
{
	OHBasicDialog dialog;
	kSanVector  strain;
	kSanVector  shear;
	short aShort;
	strain = sim->simCell.appliedStrainStress;
	shear = sim->simCell.appliedShearStress;
	setupAppDialog	(&dialog, kStrainDialogResID);
	if (! dialog.done )
	{
		prepDoubleVector(dialog.dp,iStressXEditItem , &strain);
		prepDoubleVector(dialog.dp,iStressXYEditItem , &shear);
		prepCheckItem(dialog.dp,iStressXCheckItem , !sim->gConstrained.XAxis);
		prepCheckItem(dialog.dp,iStressYCheckItem , !sim->gConstrained.YAxis);
		prepCheckItem(dialog.dp,iStressZCheckItem , !sim->gConstrained.ZAxis);
		prepCheckItem(dialog.dp,iStressXYCheckItem , !sim->gConstrained.Gamma);
		prepCheckItem(dialog.dp,iStressYZCheckItem , !sim->gConstrained.Alpha);
		prepCheckItem(dialog.dp,iStressZXCheckItem , !sim->gConstrained.Beta);
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
			case iStressXCheckItem:
			case iStressYCheckItem:
			case iStressZCheckItem:
			case iStressXYCheckItem :
			case iStressYZCheckItem :
			case iStressZXCheckItem :
				switchCheckItem(dialog.dp, dialog.itemHit);
				break;	
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
		aShort = getCheckItem(dialog.dp,iXCheckItem );
		sim->gConstrained.XAxis = !aShort;
		aShort = getCheckItem(dialog.dp,iYCheckItem );
		sim->gConstrained.YAxis = !aShort;
		aShort = getCheckItem(dialog.dp,iZCheckItem);
		sim->gConstrained.ZAxis = !aShort;
		aShort = getCheckItem(dialog.dp,iXYAngleCheckItem);
		sim->gConstrained.Alpha = !aShort;
		aShort = getCheckItem(dialog.dp,iYZAngleCheckItem);
		sim->gConstrained.Beta = !aShort;
		aShort = getCheckItem(dialog.dp,iZXAngleCheckItem);
		sim->gConstrained.Gamma = !aShort;
		getDoubleVector(dialog.dp,iStressXEditItem , &sim->simCell.appliedStrainStress, kMaxDouble, 0.0);
		getDoubleVector(dialog.dp,iStressXYEditItem , &sim->simCell.appliedShearStress, kMaxDouble, 0.0);
	}
	OHBreakdownDialog(&dialog);
	return (dialog.itemHit);
}
short	DoScaleCellDialog	(kSanSimulation *sim)
{
 	OHBasicDialog dialog;
	
 	setupAppDialog	(&dialog, kScaleCellDialogResID);
	if (! dialog.done )
	{
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
		double ratio;
		ratio =getDoubleItem (dialog.dp, iScaleFactorEditItem, 10000.0, 0.00001); 
		scaleAxis (sim, pCellXYZUniform, &ratio);
		initBoxes(sim);
	}
	OHBreakdownDialog(&dialog);
 	return (dialog.itemHit);
}
short	DoCellExpansionHuhDialog	(void)
{
	OHBasicDialog dialog;
	short i;
	Str255 myStr;
	
	setupAppDialog	(&dialog, kExpandCellHuhDialogResID);
	if (! dialog.done )
	{
		for (i = 3 ; i<=11 ; ++i)
		{
			getTextItem(dialog.dp, i , myStr);
			prepTextItem(dialog.dp, i , myStr);
		}
	}
	while ( ! dialog.done )
	{
		ModalDialog( nilPointer,&dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
	}
	OHBreakdownDialog(&dialog);
	return (dialog.itemHit);
}

short	DoCellExpansionDialog	(kSanSimulation *sim)
{
	OHBasicDialog dialog;
	float vol;	
	kSanLongVector nA, nB, nC;
	
	setupAppDialog	(&dialog, kExpandCellDialogResID);
	if (! dialog.done )
	{
		nA.a=1;
		nA.b=0;
		nB.a=0;
		nB.b=1;
		nC.a=0;
		nC.b=0;
#ifndef __2DVectors__
		nA.c=0;
		nB.c=0;
		nC.c=1;

		  prepDoubleVector (dialog.dp,ioCxItem, &sim->simCell.primitiveVectors.C);
		  prepLongVector (dialog.dp,inCxItem, &nC);
#else
		{
		  short dplus;
		  for ( dplus = 0 ; dplus < 3 ; ++ dplus)
		  {
          setControlItemEnabled(dialog.dp,ioCxItem + dplus, false);
          setControlItemEnabled(dialog.dp,inCxItem + dplus, false);
          }
         }
#endif			
		  prepDoubleVector (dialog.dp,ioAxItem, &sim->simCell.primitiveVectors.A);
		  prepDoubleVector (dialog.dp,ioBxItem, &sim->simCell.primitiveVectors.B);

		  prepLongVector (dialog.dp,inAxItem, &nA);
		  prepLongVector (dialog.dp,inBxItem, &nB);
 		
		HideDialogItem(dialog.dp, iErrorString);
	}
	while ( ! dialog.done )
	{
		ModalDialog(nilPointer, &dialog.itemHit);
		switch (dialog.itemHit)
		{
			case ok:
			case cancel:
				dialog.done = true;
				break;		
			case iHuhButton:
  				 DoCellExpansionHuhDialog();
				break;
			case  inAxItem :
			case  inAyItem :
			case  inAzItem :
			case  inBxItem :
			case  inByItem :
			case  inBzItem :
			case  inCxItem :
			case  inCyItem :
	 		case  inCzItem :
		        getDialogVectors (dialog.dp, &nA, &nB, &nC);
				vol = getkSanCellVolumeL(&nA, &nB, &nC);
				if (vol == 0) 
				{					
					dimControlItem(dialog.dp, ok);
					prepTextItem(dialog.dp, iErrorString, "\pzero volume cell");
					ShowDialogItem(dialog.dp, iErrorString);
				}
				else if (vol > 32000) 
				{
					dimControlItem(dialog.dp, ok);
					prepTextItem(dialog.dp, iErrorString, "\pcell multiple too large");
					ShowDialogItem(dialog.dp, iErrorString);
				}
				else if (vol * simGetNumParts(sim) > 32000)
				{
					dimControlItem(dialog.dp, ok);
					prepTextItem(dialog.dp, iErrorString, "\ptoo many particles");
					ShowDialogItem(dialog.dp, iErrorString);
				}
				else
				{
					undimControlItem(dialog.dp, ok);					
					if (vol < 0)
					{
						if (nA.a < 0)
						{
						 	prepTextItem(dialog.dp, iErrorString, "\pcell will reflect in X");
						}
						else
						{
							 prepTextItem(dialog.dp, iErrorString, "\pcell will invert");
						}
					  	ShowDialogItem(dialog.dp, iErrorString);
					}
					else
					{
					    HideDialogItem(dialog.dp, iErrorString);
					}
				}
				break;			
		}
	}
	if  ((dialog.itemHit != cancel) && (dialog.itemHit != -1))
	{
	    short err;
    	waitForIterationToFinish(sim);
		getDialogVectors (dialog.dp, &nA, &nB, &nC);
		vol = getkSanCellVolumeL(&nA, &nB, &nC);
		if ( vol<0 )
		{
			if (nA.a < 0)
			{
			     reflectCell(sim);
			     multkSanVectorL( &nA, -1, &nA);			     
			}
			else
			{
			    multkSanVectorL( &nA, -1, &nA);
			    multkSanVectorL( &nB, -1, &nB);
			    multkSanVectorL( &nC, -1, &nC); // change to right handed
			    processEveryParticle (sim, (void (*)( kSanSimulation *, particle *, long , void * ))invertParticlesCallback, 0L);
		    }
		}
		err = expandCell(sim, &nA, &nB, &nC);
	}
	OHBreakdownDialog(&dialog);
	return (dialog.itemHit);
}
void getDialogVectors (DialogPtr dialog, kSanLongVector * nA, kSanLongVector *  nB,kSanLongVector * nC)
{
	  getLongVector(dialog, inAxItem, nA, 5000, -5000);
	  getLongVector(dialog, inBxItem, nB, 5000, -5000);
	  getLongVector(dialog, inCxItem, nC, 5000, -5000);
}
short doDataCollectionDialog	(kSanSimulation *sim)
{
	short err = noErr;
	short count;
	short i;
	OHList *dcList;
	OHList useMeList;
	kozoObject *dcpObj;
	short PIIndex ;
	ControlHandle popupHandle;
	OHBasicDialog dialog;
	
	initializeList (&useMeList);
	dcList = getListOfObjectsOfClassX  (simOBJ(sim), ClassDataCollectionPlugIn);
	if (dcList)
	{
		count = OHListCount(dcList);
		if ( count == 0) 
		{
			
		}
		else
		{
			for (i = 0; i<count; ++i) addToList (&useMeList, 1L);  // set all useMes to true
			err = makeCollectorMenu(sim);
			
			setupAppDialog	(&dialog, kDataCollectionDialogResID);
			if (! dialog.done )
			{
				PIIndex = 0;
				dcpObj = castTokozoObject( getNthItem (dcList, PIIndex));
				GetDialogItem (dialog.dp,iDataPlugInPopup,&dialog.itemType,&(Handle)popupHandle,&dialog.itemRect);	
			    SetControlValue (popupHandle, PIIndex);
			    setPlugItems (dialog.dp, dcpObj, true);
			}
			while ( ! dialog.done )
			{
				ModalDialog(nilPointer, &dialog.itemHit);
				switch (dialog.itemHit)
				{
					case ok:
					case cancel:
						dialog.done = true;
						break;
					case iInUseCheckItem:
						{
							char aChar;						
							aChar =  switchCheckItem  ( dialog.dp,iInUseCheckItem);
							setNthItem (&useMeList, PIIndex, aChar);
							setPlugItems (dialog.dp, dcpObj,  aChar);
						}
					case iDataPlugInPopup:
						{					
							getPlugItems (dialog.dp, dcpObj);
							PIIndex = GetControlValue(popupHandle) - 1; 
							dcpObj = castTokozoObject( getNthItem (dcList, PIIndex));
						    setPlugItems(dialog.dp, dcpObj, getNthItem (&useMeList, PIIndex));
						}		
						break;			
					case iSetDataPlugInValuesButton:
						getPlugItems(dialog.dp, dcpObj );
						break;			
					case iEditPlugInParamsButton:
						err = dispatchNilMessage (dcpObj, kDoDialogMessage);
						break;
					case iCallDataPlugInButton:
						err = kozoDoMessage (dcpObj, kDoCollectionMessage, typeSimulationPtr, sim);
						break;			
				}
			}
			if (dialog.itemHit != cancel)
			{
		 		getPlugItems(dialog.dp, dcpObj);	
		 		for (i = count - 1; i >= 0; --i)
		 		{
		 			long useIt;
		 			kozoObject *plugToDestroy;
		 			useIt = getNthItem (&useMeList, i);
		 			if (useIt == 0) 
		 			{
		 				plugToDestroy = castTokozoObject( getNthItem (dcList, i));
		 				kozoDispose(plugToDestroy);
		 			}
		 		}
			}	
			
			OHBreakdownDialog (&dialog);
			disposeCollectorMenu();
		}
		releaseListOfObjectsOfClassX (simOBJ(sim), ClassDataCollectionPlugIn);
	}
	disposeList (&useMeList);
	ret:
	return (dialog.itemHit)	;
}

void setPlugItems (DialogPtr dp, kozoObject *dcPlug, short useMe)
{
	long threshhold;
	callAndUnwrapGetLong (dcPlug, pThreshhold, &threshhold);
	prepLongItem (dp, iLoopNumberEditItem, threshhold);
	setControlItemEnabled(dp, iSetDataPlugInValuesButton, useMe);
	setControlItemEnabled(dp, iEditPlugInParamsButton, useMe);
	setControlItemEnabled(dp, iCallDataPlugInButton, useMe);
	setDialogItemVisible(dp, iLoopNumberEditItem, useMe);
	prepCheckItem (dp, iInUseCheckItem, useMe);
}
void getPlugItems (DialogPtr dp, kozoObject *dcPlug)
{
	long threshhold;
	threshhold = getLongItem (dp, iLoopNumberEditItem, 100000, 0);
	packageAndCallSetLong(dcPlug, pThreshhold, &threshhold);
}