#include "OHFileUtils.h"
#include "OHAELauncher.h"
#include "kSanSimulationPrivate.h"
#include "kSanSimAtomtypes.h"
#include "kSanFileDefinitions.h"

short generateDefaultFSSpec(kSanSimulation *sim, FSSpec *fs);
short  doWriteDataToFile (kSanSimulation *sim);
void writeResources(kSanSimulation *thisSim);
void writeWindows(kSanSimulation *thisSim);
long writeParticle(kSanSimulation *thisSim,particle * myPart);
void  writeTypespecs (kSanSimulation *sim);
short  doDataSave(kSanSimulation *sim, long askForFileSpec);

short generateDefaultFSSpec(kSanSimulation *sim, FSSpec *fs)
{
	short err = noErr;
 	OHDocument *doc;
	OHString newStr;
	char buffer[16];
	doc = docData (simOBJ(sim));
	
	*fs = doc->file->fs;
	err = OHStringDuplicate (simOBJ(sim)->name, &newStr);
	if (!err) 
	{
		if  (OHStringIsEmpty(&newStr)) err = OHStringAppendC(&newStr, "sim");
		if (!err)  err = OHStringAppendC(&newStr, ".");
		
		sprintf(buffer,"%ld", sim->totalNumberOfIterations);
		if (!err)  err = OHStringAppendC(&newStr, buffer);
		
		if (!err)  err = OHStringGetP(&newStr, fs->name);

		OHStringDispose (&newStr);
	}
	return (err);
}
short kSanSimDoContinuingBackup (kSanSimulation *sim)
{
	short err = noErr;
 	FSSpec fs;
	FSSpec oldSpec;
	OHDocument *doc;
	doc = docData(simOBJ(sim));
// set temp file spec, continue save, reset file spec
	oldSpec = doc->file->fs;
 	err = generateDefaultFSSpec(sim, &fs);
	if (!err)  err = kozoSetDataPtr(simOBJ(sim), keyAEFile, typeFSS, &fs, sizeof(FSSpec));
	UIEvent(simOBJ(sim), kAECoreSuite, kAESave);
	if (!err)  err = kozoSetDataPtr(simOBJ(sim), keyAEFile, typeFSS, &oldSpec, sizeof(FSSpec));
	return(err);
}

/*
short  doDataSave(kSanSimulation *sim, long askForFileSpec) // this also masquerades as an FSSpec ptr
{
	short err;
	FSSpec newSpec;
	OHDocument *doc;
	
	doc = docData (simOBJ(sim));
	if ( askForFileSpec == true)
	{
		StandardFileReply reply;
		err = generateDefaultFSSpec(sim, &newSpec);
		if (!err)  StandardPutFile("\p select location and name of file",newSpec.name, &reply);
		if (reply.sfGood) newSpec = reply.sfFile;
		else err = true;
	}
	else if ( askForFileSpec == false)
	{
		err = generateDefaultFSSpec(sim, &newSpec);
	}
	
	if (!err)  
	{
		OHFile *newFile;
		err =  OHFileAllocator (&newFile);
		if (!err)  
		{
			newFile->fs = newSpec;
			err = createThatFile(newFile);	
		}
		if (!err) 
		{
			OHFileDeallocator(doc->file);
			doc->file = newFile;
		}
	}
//	if (format == macMolFormat) doWriteMacMoleculeFile(sim);
//	else  doWriteDataToFile (sim);		 
	if (!err) 
	{
		err = doWriteDataToFile (sim);
		FlushVol(nilPointer, doc->file->fs.vRefNum);
	}
	else doAlert ("\p could not generate a proper file specification");
	
	sim->counters.dataSave = 0;
	return (0);
}
*/
/************ writeHeader   ****************/
/*
void  writeResources (kSanSimulation *sim)
{
	long i;
	long count;
	short err = noErr;
	short aShort;
	DescType dt;
		
	OHAddAndWriteResource(&sim->howManyParts , sizeof( long), k3longRezType, k3numPartsResID, "\pNumber Of Particles");	
	OHAddAndWriteResource(&sim->totalNumberOfIterations , sizeof( long), k3longRezType, k3numItersResID, "\pTotal Number Of Iterations");
	OHAddAndWriteResource(&sim->uniqueParticleCounter , sizeof( long), k3longRezType, k3uniqueParticleCounterResID, "\pparticle counter");
	
	OHAddAndWriteResource(&sim->deltaT , sizeof( double), k3doubleRezType, k3deltaTResID, "\pTimestep");
	OHAddAndWriteResource(&sim->totalTimeElapsed , sizeof( double), k3doubleRezType,k3timeElapsedResID, "\pTime Elapsed");
	OHAddAndWriteResource(&sim->simCell.appliedStrainStress , sizeof( kSanVector ),  k3kSanVector RezType,k3StrainStressResID, "\px strain stress");
	OHAddAndWriteResource(&sim->simCell.appliedShearStress , sizeof( kSanVector ),  k3kSanVector RezType,k3ShearStressResID, "\px shear stress");
	OHAddAndWriteResource(&sim->simCell.cellEdges , sizeof( kSanVector ),  k3kSanVector RezType,k3CellEdgesResID, "\px cell edges");

	OHAddAndWriteResource(&sim->simCell.alpha , sizeof( double), k3doubleRezType, k3cellAlphaResID, "\pCell Alpha angle");
	OHAddAndWriteResource(&sim->simCell.beta , sizeof( double), k3doubleRezType, k3cellBetaResID, "\pCell Beta angle");
	OHAddAndWriteResource(&sim->simCell.gamma , sizeof( double), k3doubleRezType, k3cellGammaResID, "\pCell Gamma angle");
		
	OHAddAndWriteResource(&sim->outerCutoff , sizeof( double), k3doubleRezType, k3outerCutoffResID, "\pOuterCutoff");
	OHAddAndWriteResource(&sim->innerCutoff , sizeof( double), k3doubleRezType, k3innerCutoffResID, "\pInnerCutoff");
		
	OHAddAndWriteResource(&sim->gConstrained.XAxis , sizeof( short),  k3shortRezType, k3constrainedInXResID, "\pCell X Constraint");
	OHAddAndWriteResource(&sim->gConstrained.YAxis , sizeof( short),  k3shortRezType, k3constrainedInYResID, "\pCell Y Constraint");
	OHAddAndWriteResource(&sim->gConstrained.ZAxis , sizeof( short),  k3shortRezType, k3constrainedInZResID, "\pCell Z Constraint");
	OHAddAndWriteResource(&sim->neighborCutoffExtra , sizeof( double), k3doubleRezType, k3neighborCutoffExtraResID, "\pNeighbor Cutoff Leeway");
			
	aShort = OHListCount (getListOfObjectsOfClassX releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup));

	OHAddAndWriteResource(&aShort , sizeof( short),  k3shortRezType,  k3howManyGroupsResID, "\pnumber of groups");
	
	dt = OHOCID(sim->potentialPlugInObj);
	OHAddAndWriteResource(&dt, sizeof(long), ClassPotentialPlugIn, kBaseResID, "\ppotential signature");
	kozoDoMessage (sim->potentialPlugInObj,  kSanSaveDataMessage, 0L);

	dt = OHOCID(sim->methodPlugInObj);
	OHAddAndWriteResource(&dt, sizeof(long), ClassMethodPlugIn, kBaseResID, "\pmethod signature");
	kozoDoMessage (sim->methodPlugInObj,  kSanSaveDataMessage, 0L);

	dt = OHOCID(sim->resizePlugInObj);
	OHAddAndWriteResource(&dt, sizeof(long), ClassCellResizePlugIn, kBaseResID, "\presizer signature");
	kozoDoMessage (sim->resizePlugInObj,  kSanSaveDataMessage, 0L);
	
	{ // save data collectors
		OHList *dcList;
		dcList = getListOfObjectsOfClassX releaseListOfObjectsOfClassX(simOBJ(sim), ClassDataCollectionPlugIn);
		if (dcList)
		{
			count = OHListCount(dcList);
			
			for (i=0;i<count;++i)
			{
				kozoObject *dcPlug;
				
				dcPlug = castTokozoObject(getNthItem(dcList, i));
				dt = OHOCID(dcPlug);
				OHAddAndWriteResource(&dt, sizeof( DescType), ClassDataCollectionPlugIn,  kBaseResID + i, "\pdata collector signature");
				kozoDoMessage (dcPlug,  kSanSaveDataMessage, (void *) ( kBaseResID + i));
			}
		}
	}
	
	{
		OHList *gpList;
		gpList = getListOfObjectsOfClassX releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
		if (gpList)
		{
			count = OHListCount(gpList);
			for ( i=0; i<count; ++i)
			{
				kozoObject *gpObj;
				kSanGroup *gp;
				gpObj = castTokozoObject(getNthItem(gpList, i));
				gp = gpData(gpObj);
				
				OHAddAndWriteResource(&gp->index , sizeof( kSanGroupInfo),  k3groupInfoRezType,  kBaseResID + i, "\pGroupInfo");
				OHAddAndWriteString(gpObj->name, k3groupNameRezType, kBaseResID + i, "\pGroupName");	
				OHAddAndWriteHandle(gp->particles.listData, k3groupListRezType, kBaseResID + i, "\pGroupList");	
				OHAddAndWriteResource(&gp->particles.howManyItems , sizeof( long),  k3groupNumPartsRezType,  kBaseResID + i, "\pGroupPartNum");
						
			}
		}
	}
	// writeWindows(sim);

}
 
void  writeTypespecs (kSanSimulation *sim)
{ // types contains list of atomtypes which are actually present in this sim!
	short count;
	short i;
	OHList *atList;
	typespecs thisTypespecs;

	atList = getListOfObjectsOfClassX releaseListOfObjectsOfClassX (simOBJ(sim), ClassAtomType);
	if (atList) count =  OHListCount(atList);	
	else count = 0;
	
	OHAddAndWriteResource(&count , sizeof( short),  k3shortRezType,  k3typesOfAtomsResID, "\patom types");

	for (i=0;i<count;++i)
	{
		simGetNthTypespecs(sim, &thisTypespecs, i);
	    OHAddAndWriteResource( &thisTypespecs , sizeof( typespecs),  k3typespecsRezType, kBaseResID + i, "\ptypespecs");
 // 		myAddAndWriteResource(thisTypespecs.name, k3typespecsNameRezType, kBaseResID + i, "\ptypespec name");	
	}
}


long  writeParticle (kSanSimulation *sim, particle * myPart)
{
	OHDocument *doc;
	long bytesWritten;
	long bytesToWrite;
	long buffplace;
	char  buffer[kBufferSize];
	char  aCString[96];
	char mySelectedChar;
	short err;		
	buffplace = 0;
	
	doc = docData (simOBJ(sim));
		
		
 	sprintf(aCString,"\t%.9G\t%.9G\t%.9G\t",myPart->position.a ,myPart->position.b ,myPart->position.c);
	strcpy(buffer + buffplace,aCString);
	buffplace += strlen(aCString);
		
 	sprintf(aCString,"%.9G\t%.9G\t%.9G\t",myPart->velocity.a ,myPart->velocity.b ,myPart->velocity.c);
	strcpy(buffer + buffplace,aCString);
	buffplace += strlen(aCString);
	
 	if (myPart->selected)
	{
		mySelectedChar = 'T';
	}
	else 
	{
		mySelectedChar = 'F';
	}
		
	sprintf(aCString,"%d\t%c\t%ld\n", myPart->type ,mySelectedChar ,myPart->uniqueID);
	strcpy(buffer + buffplace,aCString);
	buffplace += strlen(aCString);
 
 	sprintf(aCString,"\n");
	strcpy(buffer + buffplace,aCString);
	buffplace += strlen(aCString);
	
	bytesToWrite = buffplace;
	bytesWritten = buffplace;
	
	err = OHFileWrite(doc->file, &bytesWritten, buffer);
	if ((err) || (bytesWritten != bytesToWrite) )
	{
		doAlert("\pWrite to file unsuccessful");
		bytesWritten = 0;
	}
	return (bytesWritten);
}


short  doWriteDataToFile (kSanSimulation *sim)
{
	short err = noErr;
	long fileOffset = 0;
	long returnValue = 0;
	
	long i= 0;
	
	particle *  basePart;
	OHDocument *doc;
	
	doc = docData (simOBJ(sim));
	
	err = resForkWriteOpen(doc->file); 
	if (!err) 
	{
		err = useResFile(doc->file);
		if (!err)
		{
			writeResources (sim);
			writeTypespecs(sim);	
			FlushVol(nilPointer, doc->file->fs.vRefNum);

			usePreviousResFile(doc->file);
			resForkClose(doc->file); 
						
		 	dataForkWriteOpen(doc->file); 
			basePart = simLockParts(sim);
			for (i=0;i<= sim->howManyParts-1;++i)
			{
				returnValue = writeParticle (sim, &(basePart[i]));
				if (!(returnValue == 0))
				{
					fileOffset = fileOffset + returnValue;
				}
				else 
				{
					i = sim->howManyParts;
				}
			}
		}
		if ((returnValue == 0) && (sim->howManyParts > 0))
		{
			err = true;
		}
	}
	dataForkClose(doc->file); 
	simReleaseParts(sim);
	return (err);
}

*/



