#include "kSanSimulationPrivate.h"
#include "kSanMenuDefines.h"
void  changeGroupIndex(kSanSimulation *sim,kSanGroup *gp, long newIndex) ;
void  resetGroups(kSanSimulation *sim);

short   addGroupForces( kozoObject *gpObj, particle *basePart, kSanVector * areas )
{
	long count ;
	long i ;
	long partArrIndex;
	kSanVector  appForce;
	kSanGroup *gp = gpData(gpObj);
	if (gp->applyAForce)
	{
		count = OHListCount (&gp->particles);
		appForce.a  =  gp->forceApplied.a * (1.0 / (areas->a * count));
		appForce.b  = gp->forceApplied.b * (1.0 / (areas->b * count));
#ifndef __2DVectors__
		appForce.c  =  gp->forceApplied.c * (1.0 / (areas->c * count));
#endif		
		for (i=0;i<count; ++i)
		{
			partArrIndex = getNthItem(&gp->particles, i);
			basePart->baseForce[partArrIndex].a += appForce.a;
			basePart->baseForce[partArrIndex].b += appForce.b;
#ifndef __2DVectors__
			basePart->baseForce[partArrIndex].c += appForce.c;
#endif
		}
	}
	return (noErr);
}


void  resetGroupsCallback ( kSanSimulation *sim,  particle *basePart, long partArrIndex, long arg);
void  resetGroupsCallback ( kSanSimulation *sim,  particle *basePart, long partArrIndex, long arg)
{  // put all particles in group 1
#pragma unused(arg)
	if (BPNthGroup(basePart, partArrIndex) != 0) kSanSimAddParticleToGroup(sim, 0, partArrIndex);
}



short refindGroups(kSanSimulation *sim)

{
	short err = noErr;
	long  i;
	long partArrIndex;
	long  numGroups;
 	
	if (simGetNumGroups(sim) == 0)
	{
		kozoObject *ob;
		kozoNewNoData(&ob, ClassParticleGroup, simOBJ(sim));
	}
	if (simGetNumGroups(sim) != 0)
	{
	         kSanGroup ** gp;
 	         particle *basePart;
 	         basePart = simLockParts(sim);
		gp = simLockGroups(sim);
		numGroups = simGetNumGroups(sim);
		for (i = 0 ; i < numGroups; ++i)
		{
			gp[i]->particles.howManyItems = 0 ;
		}
		for (partArrIndex = 0 ; partArrIndex < simGetNumParts(sim); ++partArrIndex)
		{
 			if (BPNthGroup(basePart, partArrIndex) >= numGroups) BPNthGroup(basePart, partArrIndex) = 0;
			addToList (&(gp[BPNthGroup(basePart, partArrIndex)]->particles), partArrIndex);
		}
		simReleaseGroups(sim);
	         simReleaseParts(sim);
	}
	else err = true;
	return (noErr);	
}
void  resetGroups(kSanSimulation *sim)
{  // put all particles in group 1
	processEveryParticle (sim, (void (*)( kSanSimulation *, particle *, long , void * ))resetGroupsCallback, 0L);
	removeEmptyGroups(sim);
	simRedraw(sim);
}
void	 changeIndexInGroups	(kSanSimulation *sim, long newIndex, long oldIndex)
{
	long groupIndex ;
	groupIndex =  ((basePartPtr(sim))[oldIndex].group );
 	kSanSimAddParticleToGroup(sim, groupIndex, newIndex);
}

short   kSanSimAddParticleToGroup(kSanSimulation *sim, long groupIndex, long partArrIndex)
{
	kSanGroup **baseGroup;
	particle * basePart;

	basePart = simLockParts(sim);
	baseGroup = simLockGroups(sim);

	if (BPNthGroup(basePart, partArrIndex) != groupIndex)
	{
		if (BPNthGroup(basePart, partArrIndex) != kNoGroup) 
			removeItem(&baseGroup[BPNthGroup(basePart, partArrIndex)]->particles,partArrIndex);
			// take it out of the particles list
		if (groupIndex != kNoGroup) addToList(&baseGroup[groupIndex]->particles, partArrIndex);
		BPNthGroup(basePart, partArrIndex) = groupIndex;
	}
	simReleaseParts(sim);
	simReleaseGroups(sim);
	return (noErr);
 }
void   mergeGroups(kSanSimulation *sim, long groupIndexA, long groupIndexB)
{ // put group B particles in group A
	long partArrIndex;
	OHList *gpList;
	kozoObject *gpAObj;
	kozoObject *gpBObj;
	kSanGroup *gpA;
	kSanGroup *gpB;
	gpList = getListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
	if (gpList)
	{
		gpAObj = castTokozoObject (getNthItem(gpList, groupIndexA));
		gpBObj = castTokozoObject (getNthItem(gpList, groupIndexB));
		gpA = gpData(gpAObj);
		gpB = gpData(gpBObj);
 		while (OHListCount(&gpB->particles) > 0)
		{
			partArrIndex = getNthItem(&gpB->particles, 0);
			kSanSimAddParticleToGroup(sim, groupIndexA, partArrIndex);
		}
	 releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
	}
}
void  doGroupSelectedParticles (kSanSimulation *sim)
{
	OHList  selList;
	OHListInitialize (&selList);
	BitListToOHList( &sim->selectedBits, &selList);
 	doGroupParticles(sim, &selList);
 	OHListDispose (&selList);
}

 void  doGroupParticles (kSanSimulation *sim, OHList *aList) 
{
	short err = noErr;
	long newGroupIndex;
	err = kSanSimNewGroup(sim, &newGroupIndex);
	if (!err) err =   OHListEveryItemAsThirdArg(aList,  kSanSimAddParticleToGroup, sim, (void *)newGroupIndex );
}

char   groupExists(kSanSimulation *sim, short index)
{ // remove ptr from groupPtrlist and delete
   // index from zero
	return (kozoObjectGetNthItemOfClassX (simOBJ(sim), ClassParticleGroup, index) != nilPointer);
}

short kSanSimNewGroup(kSanSimulation *sim, long *newGroupIndex)
{
	short err = noErr;
	long index;
	kozoObject *gpObj;
	kSanGroup *gp;
	err = kozoNewNoData ( &gpObj, ClassParticleGroup, simOBJ(sim));
	gp = gpData(gpObj);
	
	err =  getContainmentInfo( simOBJ(sim), gpObj, &index, ClassParticleGroup);
            // if this is the second group, getContainmentInfo returns 2.  we want to use it for the index in a list, so we subtract 1
 	if (newGroupIndex) *newGroupIndex = index - 1;
	return (err);
}

void   kSanSimRemoveGroupObj(kSanSimulation *sim, kozoObject *gpObj)
{ // remove ptr from groupPtrlist and delete
	kSanGroup *gp;
	gp = gpData (gpObj);
	kSanSimRemoveGroup(sim, gp->gpIndex);
}

void   kSanSimRemoveGroup(kSanSimulation *sim, long gIndex)
{ // remove ptr from groupPtrlist and delete
	short i;
	kozoObject *gpObj;
	kSanGroup *gp;
	OHList *gpList;
	gpList = getListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
	// can't remove group zero
	if ((gIndex > 0) && (gpList))
	{
		mergeGroups(sim, 0L, gIndex);	
		for (i = gIndex + 1; i < OHListCount(gpList) ; ++i)
		{ // copy group i into  i - 1
			gpObj = castTokozoObject ( getNthItem(gpList, i));
			gp =  gpData(gpObj);
			swapItemsByIndex(gpList, i -1 , i);
			changeGroupIndex (sim, gp, i-1);
		}
		// now all the groups above gIndex have been moved down by one
		 releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
	}
}
short  changeGroupIndexCallback(long partArrIndex, particle *basePart, long newIndex) ;
short  changeGroupIndexCallback(long partArrIndex, particle *basePart, long newIndex) 
{ // set the index of the group to index
	BPNthGroup(basePart, partArrIndex) = newIndex;
	return (noErr);
}
void  changeGroupIndex(kSanSimulation *sim, kSanGroup *gp, long newIndex) 
{ // set the index of the group to index
	particle * basePart;
		
	basePart = simLockParts(sim);
	OHListEveryItemDoTwoArgs( &gp->particles,  changeGroupIndexCallback,  basePart, (void *)newIndex);
	gp->gpIndex = newIndex;
	simReleaseParts(sim);
}

void   removeEmptyGroups(kSanSimulation *sim)
{ // change to message for list?
	OHList *gpList;
	gpList = getListOfObjectsOfClassX (simOBJ(sim), ClassParticleGroup);
	if (gpList) 
	{
		OHListEveryItemDoNoArgs(gpList, kSanGroupRemoveIfEmpty);
		releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
	}
}

void  rebuildGroupsParticleCallback ( kSanSimulation *sim,  particle *basePart, long partArrIndex, long arg);
void  rebuildGroupsParticleCallback ( kSanSimulation *sim,  particle *basePart, long partArrIndex, long arg)
{  // put all particles in group 1
#pragma unused(arg)
	OHList *gpList;
	kozoObject *gpObj;
	kSanGroup * gp;
	long gpIndex;
	gpIndex = BPNthGroup(basePart, partArrIndex);

	gpList = getListOfObjectsOfClassX (simOBJ(sim), ClassParticleGroup);
	if (gpList)
	{
		gpObj = castTokozoObject ( getNthItem(gpList, gpIndex));
		gp =  gpData(gpObj);
	 	addToList(&gp->particles,partArrIndex);
	 	releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
 	}
}

short   rebuildGroupsCallback(kozoObject * gpObj);
short   rebuildGroupsCallback(kozoObject * gpObj)
{
	kSanGroup * gp;
 	gp =  gpData(gpObj);
	gp->particles.howManyItems = 0;
	return (noErr);
}

void   rebuildGroups(kSanSimulation *sim)
{
	OHList *gpList;
	gpList = getListOfObjectsOfClassX (simOBJ(sim), ClassParticleGroup);
	if (gpList)  
	{
		OHListEveryItemDoNoArgs( gpList,  rebuildGroupsCallback);
		releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
	}
	processEveryParticle (sim, (void (*)( kSanSimulation *, particle *, long , void * ))rebuildGroupsParticleCallback, 0L);
}

MenuHandle   buildGroupPopupMenu(kSanSimulation *sim)
{
	MenuHandle theMenu;
	Str255 theTitle;
 	short i;
	long count;
  	
  	dispatchCount (simOBJ(sim), ClassParticleGroup, &count);
 	theMenu = GetMenu(mGroupPopup); // 106 is the groupPopup ID
	for (i=0;i< count; ++i)
	{
		sprintf((char *)theTitle, "Group %d ", (i + 1) );
		 CToPascal((char *)theTitle);
		AppendMenu (theMenu, theTitle);
	}
	return (theMenu);
}
void getGroupInfo (kSanSimulation *sim, long gpIndex, kSanGroupInfo  *gpInfo)
{
 	kSanGroup **gpList = simLockGroups(sim) ;
 	 BlockMove ((Ptr)&(gpList[gpIndex]->gpIndex), (Ptr)gpInfo, sizeof(kSanGroupInfo));
         simReleaseGroups(sim);
 }