#include "kSanSimulationPrivate.h"

short   initFlags(kSanSimulation *sim)
{
	short err = noErr;
	sim->flags.abortNow = false;
	sim->flags.clockRunning = false ;
	sim->flags.pbcMode = 0; // ????
	sim->flags.iterationInProgress = false;
	sim->flags.tooManyNeighbors = false;
	sim->flags.error = true;
	return (err);
}
short   initBoxInfo(kSanSimulation *sim)
{	
	short err = noErr;
	err = LCHandleInit(&sim->boxArrayLCH);
	if (!err) err = LCHSetHandleSize(&sim->boxArrayLCH, sizeof (box) *2);
 	if (!err)
	{
		long i;
		box *boxes;
		boxes =  simLockBoxes(sim); 
		for (i =0; i < 2; ++i)
		{
			initializeList (&(boxes[i].boxPartList));
		}
		simReleaseBoxes(sim);
		// zero is the temporary box for unplaced particles
		// sim->numBoxes + 1 is the hyperspace box
	}
	zerokSanVectorL(&sim->boxDim);
	return (err);
}
void  disposeBoxInfo(kSanSimulation *sim)
{	
	short err = noErr;
 	if (!err)
	{
		long i;
		box *boxes;
			
		boxes =  simLockBoxes(sim); 
		for (i = 0; i < sim->howManyBoxes+2; ++i)
		{
			disposeList (&(boxes[i].boxPartList));
		}
		simReleaseBoxes(sim);
 	}
	LCHandleDispose (&sim->boxArrayLCH);
}
void  initGThreshholds(kSanSimulation *sim)
{
	sim->countThreshholds.therm = 1;
	sim->countThreshholds.neighbor = 1;
	sim->countThreshholds.redraw = 1;
	sim->countThreshholds.cellPressure  = 100;
	//sim->countThreshholds.rotate = 2;
	sim->countThreshholds.velocityCentering = 20;
	sim->countThreshholds.dataSave = 5000;
	sim->countThreshholds.memoryCleanup = 1000;
}
void  initGCounters(kSanSimulation *sim)
{
//	sim->counters = (iterLimitsPtr )NewPtr(sizeof(iterLimits));
	sim->counters.therm = 1;
	sim->counters.neighbor = 400;
	sim->counters.redraw = 1;
	sim->counters.cellPressure = -1;  /** this will include cell relaxation ****/
	//sim->counters.rotate = 1;
	sim->counters.velocityCentering = 1;
	sim->counters.dataSave = 0;
	sim->counters.memoryCleanup = 0;
}

