#include "kSanSimulationPrivate.h"

 
Ptr LCHandleLock(LCHandle *lch )
{
	++lch->lockCount;
	if (lch->lockCount < 2) HLock(lch->handle);
	return (*lch->handle);
}
void LCHandleRelease(LCHandle *lch )
{
	--lch->lockCount;
	if (lch->lockCount <1) HUnlock(lch->handle);
 }
short LCHandleInit(LCHandle *lch )
{
	 lch->lockCount = 0;
	 lch->handle = NewHandle(0);
	 return (MemError());
 }
void LCHandleDispose(LCHandle *lch) 
{
	if (lch->handle) DisposeHandle(lch->handle);
	lch->handle = nilPointer;
}

short LCHSetHandleSize(LCHandle *lch, long size )
{
	short err = noErr;
	 SetHandleSize( lch->handle, size);
	 err = MemError();
	 
	if (!err) lch->handleSize = size;
	return (err);
 }

void  simReleaseThing(kSanSimulation *sim, DescType whatClass) ;
void ** simLockThing(kSanSimulation *sim, DescType whatClass) ;

void ** simLockThing(kSanSimulation *sim, DescType whatClass) 
{
	long i, count;
	OHList *objList;
	kozoObject **objPtr;
	void **thing = nilPointer;

	objList = getListOfObjectsOfClassX (simOBJ(sim), whatClass);
	if (objList)
	{
		count = OHListCount(objList);
		thing = (void **) NewPtr( 4L * count);
		objPtr = (kozoObject **) lockList(objList);
		for (i = 0; i < count; ++i)
		{
			thing[i] =   kozoObjectGetPrivateData(objPtr[i], whatClass);
		}
 		releaseList(objList);
	}
 	else
 	{	 	
 		OHSystemBeep();
 	}

	return (thing);
}
void  simReleaseThing(kSanSimulation *sim, DescType whatClass) 
{
 	 releaseListOfObjectsOfClassX(simOBJ(sim), whatClass);
}
  
particle * simLockParts(kSanSimulation *sim) 
{
	++sim->particlesRefCount;
	if (sim->particlesRefCount< 2) 
	{
	      sim->basePtrs.baseForce = (kSanVector  *) LCHandleLock(&sim->forceLCH);
	      sim->basePtrs.baseVelocity = (kSanVector  *) LCHandleLock(&sim->velocityLCH);
	      sim->basePtrs.basePosition =  (kSanVector  *) LCHandleLock(&sim->positionLCH);
	      sim->basePtrs.basePotential = (double *)LCHandleLock(&sim->potentialLCH);
	      sim->basePtrs.basePi = (kSanParticle *) LCHandleLock(&sim->particlesLCH);
	}
	return (&sim->basePtrs);     
}
void  simReleaseParts(kSanSimulation *sim)
{
	--sim->particlesRefCount;
	if (sim->particlesRefCount<1) 
	{
	      LCHandleRelease(&sim->forceLCH);
	      LCHandleRelease(&sim->velocityLCH);
	      LCHandleRelease(&sim->positionLCH);
	      LCHandleRelease(&sim->potentialLCH);
	      LCHandleRelease(&sim->particlesLCH);
	}
}

kSanGroup ** simLockGroups(kSanSimulation *sim) 
{
  	if (sim->groupListRefCount == 0)
	{
		sim->groupArray = (kSanGroup ** ) simLockThing(sim, ClassParticleGroup);
	}
	 ++ sim->groupListRefCount;
	return (sim->groupArray);
}
void  simReleaseGroups(kSanSimulation *sim) 
{
 	-- sim->groupListRefCount;
	if  (sim->groupListRefCount == 0)
	{
		 simReleaseThing(sim, ClassParticleGroup);
		if (sim->groupArray)
		{
			DisposePtr((Ptr)sim->groupArray);
			sim->groupArray= nilPointer;
		}
	}
}
 
kSanAtomtype ** simLockAtomTypes(kSanSimulation *sim) 
{
  	if (sim->atomtypeListRefCount == 0)
	{
		sim->atomtypeArray  =  (kSanAtomtype ** )simLockThing(sim, ClassAtomType);
	 }
	 ++ sim->atomtypeListRefCount;
	return (sim->atomtypeArray);
}
void  simReleaseAtomTypes(kSanSimulation *sim) 
{
 	-- sim->atomtypeListRefCount;
	if  (sim->atomtypeListRefCount == 0)
	{
		 simReleaseThing(sim, ClassAtomType);
		if (sim->atomtypeArray)
		{
			DisposePtr((Ptr)sim->atomtypeArray);
			sim->atomtypeArray = nilPointer;
		}
	}
}
