#include "kSanUniversal.h"
#include "kSanSimulation.h"
#include "OHList.h"
#include "OHToken.h"

short extractPropertyDesc(AEDesc *aDesc, long *whichProperty)
{ // returns true or false
	short err  = false;
	AEDesc specRec = {typeNull, nilPointer};
	AEDesc dataDesc = {typeNull, nilPointer};
	err = AECoerceDesc (aDesc , typeAERecord, &specRec);
	if (!err) err = AEGetParamDesc(&specRec, keyAEKeyData, typeWildCard, &dataDesc);
	if (!err) *whichProperty = (*(long *) (*dataDesc.dataHandle));
	AEDisposeDesc (&dataDesc);
	AEDisposeDesc (&specRec);
	return (err);
}

short testParticleList (kozoObject *sim, AEDesc *testDesc, kSanList *listToTest, kSanList *passedTest)
{
	short err = noErr ;
	if (testDesc->descriptorType == typeCompDescriptor) comparisonTestParticleList (sim, testDesc, listToTest, passedTest);
	else if (testDesc->descriptorType == typeLogicalDescriptor) logicalTestParticleList (sim, testDesc, listToTest, passedTest);
	return (err);
}
short doAndParticleTest(kozoObject *sim, AEDesc *termsDesc, kSanList *listToTest, kSanList *passedList)
{
	short err = noErr ;
	kSanList *tempList;
	long termsCount;
	long i;
	AEKeyword keyword;
	AEDesc nthTest = {typeNull, nilPointer};
	
	tempList = (kSanList *)NewPtr (sizeof(kSanList));
	initializeList (tempList);
	
	err  = AECountItems(termsDesc , &termsCount);
	if (termsCount == 1)
	{
		AEGetNthDesc(termsDesc, 1, typeWildCard, &keyword, &nthTest);
		testParticleList (sim, &nthTest, listToTest, passedList);
		AEDisposeDesc (&nthTest);
	}
	else
	{
		for (i = 1; i<= termsCount; ++i)
		{
			AEGetNthDesc(termsDesc, i, typeWildCard, &keyword, &nthTest);
			if (i == 1) testParticleList (sim,&nthTest, listToTest, tempList);
			else if (i == termsCount) testParticleList (sim,&nthTest, tempList, passedList);
			else 
			{
				kSanList * zList;
				zList = (kSanList *)NewPtr (sizeof(kSanList));
				initializeList (zList);
				testParticleList (sim,&nthTest, tempList, zList);
				disposeList (tempList);
				DisposePtr ((Ptr)tempList);
				tempList = (zList);
			}
			AEDisposeDesc (&nthTest);
		}
	}
	disposeList (tempList);
	DisposePtr ((Ptr)tempList);
	return (err);
}
short doNotParticleTest(kozoObject *sim, AEDesc *termsDesc, kSanList *listToTest, kSanList *passedList)
{   // strategy at each test, move the succeeding particles out of the listToTest
	short err = noErr ;
	kSanList tempList;
	long termsCount;
	long listCount;
	long i;
	long ithItem;
	long whichItemInList;
	AEKeyword keyword;
	AEDesc nthTest = {typeNull, nilPointer};
	
	initializeList (&tempList);
	duplicateList  (listToTest, &tempList);
	err = AECountItems(termsDesc, &termsCount);
	listCount = numItems(listToTest);
	if (termsCount == 1)
	{
		AEGetNthDesc(termsDesc, 1, typeWildCard, &keyword, &nthTest);
		testParticleList (sim,&nthTest, listToTest, &tempList);
		for (i = 0; i < listCount; ++i)
		{
			ithItem = getNthItem (listToTest, i);
			whichItemInList = whichItem(&tempList, ithItem);
			if (whichItemInList == -1)
			{
				addToList(passedList, ithItem);
			}
			else
			{
				removeNthItem(passedList, whichItemInList);
			}
		}
		tempList.itemsInList = 0;
		AEDisposeDesc (&nthTest);
	}
	else  err = errAEBadKeyForm;
	disposeList (&tempList);
	return (err);
}
short doOrParticleTest(kozoObject *sim, AEDesc *termsDesc, kSanList *listToTest, kSanList *passedList)
{   // strategy at each test, move the succeeding particles out of the listToTest
	short err = noErr ;
	kSanList tempList;
	long termsCount;
	long jCount;
	long jthItem;
	long i, j;
	AEKeyword keyword;
	AEDesc nthTest = {typeNull, nilPointer};
	
	initializeList (&tempList);
	duplicateList  (listToTest, &tempList);
	err = AECountItems(termsDesc, &termsCount);
	if (termsCount == 1)
	{
		AEGetNthDesc(termsDesc, 1, typeWildCard, &keyword, &nthTest);
		testParticleList (sim,&nthTest, listToTest, passedList);
	}
	else
	{
		for (i = 1; i<= termsCount; ++i)
		{
			kSanList * zList;
			zList = (kSanList *)NewPtr (sizeof(kSanList));
			initializeList (zList);
			AEGetNthDesc(termsDesc, i, typeWildCard, &keyword, &nthTest);
			testParticleList (sim,&nthTest, &tempList, zList);
			jCount = numItems(zList);
			for (j = 0 ; j< jCount; ++j)
			{
				jthItem = getNthItem(zList, j);
				removeItem (&tempList, jthItem);
				addToList (passedList, jthItem);
			}
			disposeList (zList);
			DisposePtr ((Ptr)zList);
		}
	}
	disposeList (&tempList);
	return (err);
}
short logicalTestParticleList(kozoObject *sim, AEDesc *testDesc, kSanList *listToTest, kSanList *passedTest)
{
	short err = noErr ;
	long theOperator;
	AEDesc testReco = {typeNull, nilPointer};
	AEDesc operatorDesc = {typeNull, nilPointer};
	AEDesc termsDesc = {typeNull, nilPointer};
	
	err = AECoerceDesc (testDesc, typeAERecord, &testReco);
	if (!err) err =  AEGetParamDesc(&testReco, keyAELogicalOperator, typeWildCard, &operatorDesc);
	if (!err) err = AEGetParamDesc(&testReco, keyAELogicalTerms, typeWildCard, &termsDesc);
	if (!err)
	{ 
		theOperator = (*(long *) (*operatorDesc.dataHandle));
		switch (theOperator)
		{
			case kAEAND:  // strategy:  pile each sequentially through each test, paring it down on the way
				err = doAndParticleTest(sim,&termsDesc, listToTest, passedTest);
				break;
			case kAEOR:
				err = doOrParticleTest(sim,&termsDesc, listToTest, passedTest);
				break;
			case kAENOT:
				err = doNotParticleTest(sim,&termsDesc, listToTest, passedTest);
				break;
			default:
				err = errAEBadKeyForm;
				break;
		}
	}
	
	AEDisposeDesc (&testReco);
	AEDisposeDesc (&operatorDesc);
	AEDisposeDesc (&termsDesc);	
	return (err);
}
short comparisonTestParticle(kozoObject *sim, long whichIndex, AEDesc *testDesc, short *comparisonResult)
{ // returns true or false
	short result  = false;
	short err  = noErr;
	long whichProperty;
	long whichOperator;
	AEDesc operatorDesc = {typeNull, nilPointer};
	AEDesc objOneDesc = {typeNull, nilPointer};
	AEDesc objTwoDesc = {typeNull, nilPointer};
	AEDesc compDesc = {typeNull, nilPointer};
	AEDesc dataDesc = {typeNull, nilPointer};
	err = AECoerceDesc (testDesc , typeAERecord, &compDesc);
	if (!err) err =  AEGetParamDesc(&compDesc, keyAECompOperator, typeWildCard, &operatorDesc);
	if (!err) err = AEGetParamDesc(&compDesc, keyAEObject1, typeWildCard, &objOneDesc);
	if (!err) err = AEGetParamDesc(&compDesc, keyAEObject2, typeWildCard, &objTwoDesc);
	whichOperator = (*(long *) (*operatorDesc.dataHandle));
	if (objOneDesc.descriptorType == typeObjectSpecifier)  // it will hold which property to get
	{
		extractPropertyDesc (&objOneDesc, &whichProperty); // subtract 1 for calls to kernel functions
		ParticleGetData((kSanSimulation *) sim, (whichIndex - 1), whichProperty, &dataDesc);
		kSanDoNumericComparison ( whichOperator, &dataDesc, &objTwoDesc, &result);
	}
	else
	{
		err = errAEBadKeyForm;
	}
	AEDisposeDesc (&compDesc);
	AEDisposeDesc (&dataDesc);
	AEDisposeDesc (&objTwoDesc);
	AEDisposeDesc (&objOneDesc);
	AEDisposeDesc (&operatorDesc);
	*comparisonResult = result;
	return (err);
}
short comparisonTestParticleList(kozoObject *sim, AEDesc *testDesc, kSanList *listToTest, kSanList *passedTest)
{
	short err = noErr ;
	short result;
	long count;
	long thisIndex;
	long i;
 	count = numItems(listToTest);					
	for (i = 0; i < count ; ++i)
	{
		thisIndex = getNthItem (listToTest, i);
		err = comparisonTestParticle(sim, thisIndex, testDesc, &result);
		if (result)
		{
			addToList (passedTest, thisIndex);
		} 
	}
	return (err);
}
