#include "kSanAGWindowPublic.h"
#include "kSanSimulationPrivate.h"
#include "randomGenerator.h"
#include "OHAEDescUtils.h"
short ParticleSetProperties(kSanSimulation *sim, long partArrIndex,  AEDesc *props);
void  rotateParticleCallback(kSanSimulation *sim, particle *basePart, long partArrIndex, void *fMat);
void  translateParticleCallback(kSanSimulation *sim, particle *basePart, long partArrIndex, void *fVec);

short	simMakeContainedParticle(kSanSimulation *sim, long desiredIndex,
 						 AEDesc *initialDataDesc, AEDesc *newObjectDesc)
 						// the index used here starts counting at 1
{
	short	err = noErr;
	short groupErr;
	long groupIndex;
	long newIndex;
	kozoObject *groupObj = nilPointer;
	kSanVector  pos ;
	pos.a = INFINITY;
	pos.b = INFINITY;
#ifndef __2DVectors__
	pos.c = INFINITY;
#endif	
	groupErr = OHGetKeyPtr (initialDataDesc, ClassParticleGroup , typekozoObjectPtr, &groupObj, sizeof(long));
    if (!groupErr)  groupErr = getContainmentInfo(OHOCtr(groupObj), groupObj, &groupIndex, ClassParticleGroup);
    if (groupErr) 
    {
    	groupIndex = 1;
    }	
 
	 newIndex = addParticle(sim, &pos, 0, groupIndex - 1, false);
	
	if (newIndex == -1) err = true;
	if ((!err) && (initialDataDesc != nilPointer))
	{ 
	// gotcha!  have to add 1 to ParticleSetData
		callParticleSetDataI0(sim,  newIndex, pProperties, initialDataDesc);
	}
	if ((!err) && (desiredIndex != (newIndex + 1))) 
	{
		++newIndex; // because 
		if (desiredIndex != newIndex)
		{
			// set the index (currently not supported)
		}
	}
	if (!err) err = ParticleMakeObjSpecifier(sim, newIndex , newObjectDesc);	

	return (err);
}
long  addParticleWithoutWrap(kSanSimulation *sim, kSanVector * pos,long type,long group,short isSelected)
{
	short err = noErr;
	long partArrIndex;
	particle *basePart;
	kSanVector  aPos;
	aPos = *pos;
	partArrIndex =  addParticle(sim,  pos, type, group, isSelected);
	 basePart = simLockParts(sim);
	 basePart->basePosition[partArrIndex] = aPos;
	 simReleaseParts(sim);
	return (partArrIndex);
}
long  addParticle(kSanSimulation *sim, kSanVector * pos,long type,long group,short isSelected)
{
	short err = noErr;
	short localErr = noErr;
	long retVal;
	long numAts;
	long newBoxIndex;
	long numGroups;
	long  newNumberOfParticles;
	dispatchCount (simOBJ(sim), ClassAtomType, &numAts);
 	if (type >= numAts) 
	{
		type = 0;
		if (numAts == 0) simSetFirstAtomType (sim);
	}	
	dispatchCount (simOBJ(sim), ClassAtomType, &numGroups);
	if (group >= numGroups) group = 0;
	
	newNumberOfParticles = 1 + simGetNumParts(sim);  // check that pHandle is big enough
	{
		err = resizeMemory(sim, newNumberOfParticles);
	}
	if (!err)
	{
		long partArrIndex;
		particle * basePart;
		basePart = simLockParts(sim);
		partArrIndex =  simGetNumParts(sim) ;
		err = kSanNeighborsConstructor(sim, basePart, simGetNumParts(sim));
		if (!err)
		{
			zeroPartInfo (basePart, partArrIndex);
			basePart->basePosition[partArrIndex] = *pos;
			BPNthType(basePart, partArrIndex) = type;
			++sim->uniqueParticleCounter;
			BPNthUniqueID(basePart, partArrIndex) = sim->uniqueParticleCounter;
			addToNL(&sim->uniqueIDList, BPNthUniqueID(basePart, partArrIndex), simGetNumParts(sim));
			BPNthGroup(basePart, partArrIndex) = kNoGroup;  // i.e. -1   so that theres no confusion in set group
			BPNthSelected(basePart, partArrIndex) = kNotSelected;   
			BPNthHighlighted(basePart, partArrIndex) = kNotHighlighted;   
			kozoObjectMessageForContents(simOBJ(sim), ClassAGWindow,  kAddParticleMessage, typeLongIntegerValue, (void *)sim->howManyParts);
			if (isSelected)
			{
				setParticleSelected(sim, simGetNumParts(sim), true);
			}
			setParticleHighlighted(sim, simGetNumParts(sim), false);
			if (group != kNoGroup) kSanSimAddParticleToGroup(sim, group, simGetNumParts(sim));
			++sim->howManyParts;
			simReleaseParts(sim);
			newBoxIndex = sim->determineBoxForPart(sim, sim->howManyParts-1);
			localErr = addParticleToBox(sim, basePart, sim->howManyParts-1,newBoxIndex);
			zeroNeighborInfo(sim, sim->howManyParts-1);
			simInformPluginsOfChange(sim, kChangedNumParts);
		}
	}	
	if (err) retVal = -1;
	else retVal = sim->howManyParts-1;
	return (retVal);
}  
void processParticleIndexList (kSanSimulation *sim, void (* callback)( kSanSimulation *, particle *, long , void * ) ,
			 OHList *list, void * arg)
{
 	particle *basePart;
	long i, count, partArrIndex;
 	basePart = simLockParts(sim);
	count = OHListCount(list);
	for (i = 0; i < count ; ++i)
	{
		partArrIndex = getNthItem(list, i);
		callback(sim, basePart, partArrIndex, arg);
	}
	simReleaseParts(sim);
}
void processParticleBitList (kSanSimulation *sim, void (* callback)( kSanSimulation *, particle *, long , void * ) ,
			 BitList *bits, void * arg)
{
 	particle *basePart;
	long  numParts, partArrIndex;
 	basePart = simLockParts(sim);
	numParts = simGetNumParts(sim);
	if (BitListCount(bits) < numParts) numParts = BitListCount(bits);
	for (partArrIndex = 0; partArrIndex < numParts ; ++partArrIndex)
	{
 		if (getNthBit(bits, partArrIndex))
 		{
		    callback(sim, basePart, partArrIndex, arg);
		}
	}
	simReleaseParts(sim);
}
void processParticles (kSanSimulation *sim,  void (* callback)( kSanSimulation *, particle *, long , void * ) , 
		long firstPart, long lastPart, void * arg)
{
	particle *basePart;
	long i;
 	if ((simGetNumParts(sim) >0) && (lastPart >= 0) && (firstPart >= 0))
	{
		basePart = simLockParts(sim);
		if (firstPart <= lastPart) 
		{
			for (i = firstPart; i <= lastPart ; i = i + 1)
			{
				callback(sim, basePart, i, arg);
			}
		}
		else
		{
			for (i = firstPart; i >= lastPart ; i = i - 1)
			{
				callback(sim, basePart, i, arg);
			}
		}
		simReleaseParts(sim);
 	}
}
void processEveryParticle (kSanSimulation *sim, void (* proc)( kSanSimulation *, particle *, long , void * ), void * arg)
{
	processParticles(sim, proc, 0L, simGetNumParts(sim) - 1,  arg);
}
void  deleteOverlappingParticles(kSanSimulation *sim, float tolerance, short callcalcNeighbors)
{
	long  i, j;
	OHList  sList;
	particle * basePart;
	short overlapping;
	
	initializeList(&sList);
	basePart = simLockParts(sim);
	for(i= simGetNumParts(sim) - 1 ; i > 0 ; i = i -1)  
	{	
		j = 0;
		overlapping = false;
		while ((j<i) && (!overlapping))
		{
			overlapping = doPartsOverlap(sim, basePart, i, j, tolerance);
			++j;
		}
		if (overlapping)
		{
			addToList(&sList, i); // list of parts to delete
		}
	}
	simReleaseParts(sim);
	kSanSimRemoveParticleArrayIndexList(sim, &sList, callcalcNeighbors); 
	disposeList(&sList);
}
short doPartsOverlap(kSanSimulation *sim, particle * basePart, long i, long j, float tolerance)
{
	short theyOverlap = false;
	short h,k,l;
	kSanVector  hVec, kVec, lVec;
	double dTol;
#ifdef __2DVectors__
#pragma unused ( l)
#pragma unused ( lVec)
  #endif	
	
	dTol = tolerance;	
	for (h = -1; h <2; ++h)
	{
		 multkSanVectorD(&sim->simCell.primitiveVectors.A, h, &hVec);
		 addkSanVectorsD (&hVec, &basePart->basePosition[i], &hVec);
		for (k = -1; k <2; ++k)
		{
			 multkSanVectorD(&sim->simCell.primitiveVectors.B, k, &kVec);
			addkSanVectorsD(&hVec, &kVec, &kVec);

 #ifndef __2DVectors__
			for (l = -1; l <2; ++l)
			{
			 	multkSanVectorD(&sim->simCell.primitiveVectors.C, l, &lVec);
				addkSanVectorsD(&kVec, &lVec, &lVec);
 				if (closekSanVectorsD(&lVec, &basePart->basePosition[j], &dTol))
				{
					theyOverlap = true;
				}
  			}
#else
			if (closekSanVectorsD(&kVec, &basePart->basePosition[j], &dTol))
			{
				theyOverlap = true;
			}
#endif
		}
	}
	return (theyOverlap);
}
 
void  simRandomizeVelocities (kSanSimulation *sim)
{
	OHList *gpList;
	gpList = getListOfObjectsOfClassX (simOBJ(sim), ClassParticleGroup);
	if (gpList)
	{
		OHListEveryItemAsSecondArg( gpList, simRandomizeGroup, sim);
		releaseListOfObjectsOfClassX(simOBJ(sim), ClassParticleGroup);
	}
}		
 short  simRandomizeGroup (kSanSimulation *sim, kozoObject *gpObj)
{
	short err;
	kSanGroup *gp = gpData(gpObj);
	err = OHListEveryItemDoTwoArgs(&gp->particles, randomizePart, sim, &gp->eqTemp);
	return (err);
}		
		
short  randomizePart ( long partArrIndex, kSanSimulation *sim, double *thisTemp)
{
	double  theStandardDeviation;
	kSanVector  newVel;
	particle *basePart;
	typespecs thisType;
	
	basePart = simLockParts(sim);
	simGetNthTypespecs(sim, &thisType,  BPNthType(basePart, partArrIndex) );
	theStandardDeviation = sqrt(kBoltzK * (*thisTemp) * 2.0  * thisType.inverseMass);
	newVel.a =	randomPointInGaussian (theStandardDeviation);	
	newVel.b =	randomPointInGaussian (theStandardDeviation);	
 #ifndef __2DVectors__
 	newVel.c =	randomPointInGaussian ( theStandardDeviation);	
#endif
	kSanParticleSetVelocity(sim, partArrIndex, &newVel);
	zerokSanVectorD (&basePart->baseForce[partArrIndex] );
 	simReleaseParts(sim);
	return (noErr);
}


short  pointOverlapsWithParticle(kSanSimulation *sim, kSanVector * aPoint, float tolerance)
{
	short theyOverlap = false;
	short h,k,l;
	long partArrIndex;
	particle * basePart;
	kSanVector  hVec, kVec, lVec;
	double dTol;
#ifdef __2DVectors__
#pragma unused ( l)
#pragma unused ( lVec)
  #endif	
	
	basePart = simLockParts(sim);
	dTol = tolerance;
	
	for (partArrIndex=0; partArrIndex<simGetNumParts(sim); ++partArrIndex)
	{
		for (h = -1; h <2; ++h)
		{
			 multkSanVectorD(&sim->simCell.primitiveVectors.A, h, &hVec);
			 addkSanVectorsD (&hVec, &basePart->basePosition[partArrIndex], &hVec);
			for (k = -1; k <2; ++k)
			{
				 multkSanVectorD(&sim->simCell.primitiveVectors.B, k, &kVec);
				addkSanVectorsD(&hVec, &kVec, &kVec);
 #ifndef __2DVectors__
				for (l = -1; l <2; ++l)
				{
				 	multkSanVectorD(&sim->simCell.primitiveVectors.C, l, &lVec);
					addkSanVectorsD(&kVec, &lVec, &lVec);
					if (closekSanVectorsD(&lVec, aPoint, &dTol))
					{
						theyOverlap = true;
					}
				}
#else
				if (closekSanVectorsD(&kVec, aPoint, &dTol))
				{
					theyOverlap = true;
				}
#endif
			}
		}
	}
	simReleaseParts(sim);
	return (theyOverlap);
}

void  kSanParticleSetForce (kSanSimulation *sim, long partArrIndex, kSanVector * theVel )
{
	particle *basePart;
	basePart = simLockParts(sim);
	kSanParticleSetForceCallback (sim, basePart,  partArrIndex,  theVel);
	simReleaseParts(sim);	
}

void  kSanParticleSetForceCallback (kSanSimulation *sim, particle *basePart, long partArrIndex, void *voidArg)
{  
	kSanVector * theVel = (kSanVector *)voidArg;
	basePart->baseForce[partArrIndex] = (*theVel);
	kozoDoMessage (OHGetNamedReference (simOBJ(sim), ClassMethodPlugIn), kSanChangedForceMessage, typeLongIntegerValue, (void *)partArrIndex);
}

unsigned long  kSanParticleGetUniqueID(kSanSimulation *sim, long partArrIndex )
{
	unsigned long theID;
	if ((partArrIndex < simGetNumParts(sim)) && (partArrIndex >= 0))
	{
		theID = (basePartPtr(sim))[partArrIndex].uniqueID;
	}
	else theID = -1;
	return (theID);
}
void  kSanParticleSetUniqueID(kSanSimulation *sim, long partArrIndex,  long uniqueID)
{
	simIncrementStateCount(sim);
	sim->flags.uniqueIDListDirty = true;
	(basePartPtr(sim))[partArrIndex].uniqueID = uniqueID;
}
short  kSanParticleGetPotential(kSanSimulation *sim, long partArrIndex, double *potential)
{
	short err = noErr;
	particle *basePart;
	basePart = simLockParts(sim);
	if ((partArrIndex < simGetNumParts(sim)) && (partArrIndex >= 0))
	{
		*potential = basePart->basePotential[partArrIndex];
	}
	else err = true;
	simReleaseParts(sim);	
	return (err);
}
void  kSanParticleSetVelocity (kSanSimulation *sim, long partArrIndex, kSanVector * theVel)
{
	particle *basePart;
	basePart = simLockParts(sim);
	simIncrementStateCount(sim);
	kSanParticleSetVelocityCallback(sim, basePart, partArrIndex,  theVel);
	simReleaseParts(sim);	
}

void  kSanParticleSetVelocityCallback (kSanSimulation *sim, particle *basePart, long partArrIndex, kSanVector  * theVel)
{  // put all particles in group 1
	basePart->baseVelocity[partArrIndex] = (*theVel);
	kozoDoMessage (OHGetNamedReference (simOBJ(sim), ClassMethodPlugIn), kSanChangedVelocityMessage, typeLongIntegerValue, (void *)partArrIndex);
}

short  kSanParticleGetPosition (kSanSimulation *sim, long partArrIndex, kSanVector * thePos)
{
	short err = noErr;
	particle *basePart;
	basePart = simLockParts(sim);
	if ((partArrIndex < simGetNumParts(sim)) && (partArrIndex >= 0))
	{
		(*thePos) =  basePart->basePosition[partArrIndex]  ;
	}
	else err = true;
	simReleaseParts(sim);	
	return (err);
}
void  kSanParticleSetPositionCallback (kSanSimulation *sim, particle *basePart, long partArrIndex, kSanVector  * thePos)
{  // put all particles in group 1
	short err;
	basePart->basePosition[partArrIndex] = (*thePos);
	err = resetNeighborInfoForOnePart(sim,  partArrIndex);
	simInformMethodOfChangedPosition(sim,  partArrIndex);
}
void  kSanParticleSetPosition (kSanSimulation *sim, long partArrIndex, kSanVector * thePos)
{
	short err = noErr;
	particle *basePart;
	basePart = simLockParts(sim);
	kSanParticleSetPositionCallback (sim, basePart,  partArrIndex,  thePos);
	simIncrementStateCount(sim);
	simReleaseParts(sim);
}
short   kSanParticleSetTypeByNum   (kSanSimulation *sim, long partArrIndex, long typeNum)
{
	short err= noErr;
	long oldType;
	particle *basePart;
	kSanAtomtype **baseTypes;
	double rootMassRatio;
	kSanVector  velocity;
	
	basePart = simLockParts(sim);
	baseTypes = simLockAtomTypes(sim);
		
	oldType = BPNthType(basePart, partArrIndex);
	if (oldType !=  typeNum)
	{
		BPNthType(basePart, partArrIndex) = typeNum  ;
		if (baseTypes[typeNum]->specs.mass > 0.0)
		{
			rootMassRatio = sqrt(baseTypes[oldType]->specs.mass / baseTypes[typeNum]->specs.mass);
			multkSanVectorD(&basePart->baseVelocity[partArrIndex], rootMassRatio, &velocity);
			kSanParticleSetVelocity(sim, partArrIndex, &velocity);
		}
		resetNeighborInfoForOnePart(sim, partArrIndex);
	}
	simReleaseParts(sim);
	simReleaseAtomTypes(sim);
	
	return err;
}

short   kSanParticleSetTypeByObj   (kSanSimulation *sim, long partArrIndex, kozoObject *atObj)
{
	short err = -1;
 	long typeNum = -1;
	OHList *atList;
	
	if (atObj != nilPointer)
	{
		atList = getListOfObjectsOfClassX (simOBJ(sim), ClassAtomType);
		if (atList) 
		{
			 typeNum = whichItem(atList, (long) atObj);
			 releaseListOfObjectsOfClassX(simOBJ(sim), ClassAtomType);
		}
		if (typeNum != -1) err = kSanParticleSetTypeByNum  (sim,  partArrIndex,  typeNum);
	}
	return err;
}
short   kSanParticleSetTypeByName   (kSanSimulation *sim, long partArrIndex, char * name)
{
	short err = -1;
	kozoObject *atObj;	
	
	atObj = simGetTypeFromName(sim, name);
	if (atObj != nilPointer) err = kSanParticleSetTypeByObj   (sim,  partArrIndex, atObj);
	return err;
}

float kSanParticleGetKE(kSanSimulation *sim, particle *basePart, long partArrIndex)
{
	kozoObject *atObj;
	kSanAtomtype *at;
	kSanVector  vec;
	float result = 0;
	short theType;
	theType =  BPNthType(basePart, partArrIndex);	
	vec =  basePart->baseVelocity[partArrIndex] ;	
	atObj = kozoObjectGetNthItemOfClassX (simOBJ(sim), ClassAtomType, theType);
 	if (atObj) 
 	{
 		at = atomtypeData(atObj);
 		result = kineticEInEV(&vec, at->specs.mass);
 	}
	return (result);
}

double 	kineticEInEV(kSanVector * velocity, double mass)
{
	double KE;
	KE =  (velocity->a * velocity->a);
	KE += (velocity->b * velocity->b);
 
 #ifndef __2DVectors__
	KE += (velocity->c * velocity->c);
#endif
	KE *= mass ;
	KE *= (0.00005188444297);       // this is 0.5 * ( 1 / 9636.8 )
	return (KE);
}

// is this used??? -- yes in virial tracker for example
short kSanParticleGetNeighborOverlapFractions(kSanSimulation *sim, long partArrIndex, OHFloatList *fl)
{
	short err = noErr;
 	particle *basePart;
	short howManyNeighbors;
	short i;
	float thisOverlap;
	double sep = 0;
	double totalOverlap = 0;
	double invTotalOverlap = 0;
 	
	basePart = simLockParts(sim);			
  	howManyNeighbors = numNNs( basePart, partArrIndex);
  	setNumItemsF(fl, 0 );
	for (i = 0;i < howManyNeighbors; ++i)  
	{
		sep = NNIGetNthSep(sim, basePart, partArrIndex, i);
		thisOverlap = pow(sep, -3) ;
		addToListF(fl, thisOverlap);
		totalOverlap += thisOverlap;
	}
	invTotalOverlap = 1.0 / totalOverlap;
	for (i = 0;i < howManyNeighbors; ++i)  
	{
 		thisOverlap = getNthItemF(fl, i) * invTotalOverlap;
		setNthItemF(fl, i, thisOverlap);
	}
	simReleaseParts(sim);

	return (err);
}

short calculateEnergies(kSanSimulation *sim)
{
	long lowPart, highPart;
	long progressErr = noErr;
	double energy;
	
	lowPart = 0;
	highPart = simGetNumParts(sim) -1;
	progressErr = (sim->potentialPlugIn)->manyPartECalc ( sim->potentialPlugIn,  sim,  lowPart, highPart, &energy) ;	
	sim->potEnergy = energy;		 
	return (progressErr);
}

short  recalcPartEnergy (kSanSimulation *sim, long partArrIndex)
{
	long err = noErr;
	particle *basePart;
	double newE;
	basePart = simLockParts(sim);
	if ((sim->potentialPlugIn->onePartECalc != nilPointer) && (!sim->flags.error))    
	{
		 err = getOneParticleEnergy (sim,  partArrIndex, &newE);
		 basePart->basePotential[partArrIndex] = newE;
	 }
	 else 
	 {
	 	 err = kSanErrOnePartECalcNotAvailable;
	 }
	 simReleaseParts(sim);
     return (err);
}

short  calcOneParticleEnergy (kSanSimulation *sim, long partArrIndex)
{
	short err;
 	particle * basePart;
	basePart = simLockParts(sim);
	err = getOneParticleEnergy  (sim,  partArrIndex, &basePart->basePotential[partArrIndex]);
	simReleaseParts(sim);
    return (err);
}
short  getOneParticleEnergy (kSanSimulation *sim, long partArrIndex, double *theEnergy)
{
 	short serr = noErr;
	particle *  basePart;
	basePart = simLockParts(sim);
	
	if (basePart->basePi[partArrIndex].neighborScreeningDirty)
	{
		sim->potentialPlugIn->fillScreeningArray ( sim->potentialPlugIn,  sim, basePart, partArrIndex);
	}
	if ((sim->potentialPlugIn->onePartECalc != nilPointer) && 
	    (sim->flags.pbcMode != kSanTooSmallModelPBC)  &&  (!serr))
	{
		serr = sim->potentialPlugIn->onePartECalc ( sim->potentialPlugIn,  sim,  partArrIndex, theEnergy)  ; 
	}
	else if (!serr)
	{
	    serr = kSanErrOnePartECalcNotAvailable;
	}
	simReleaseParts(sim);

	return (serr);
}
short  calcOneParticleForce (kSanSimulation *sim, long partArrIndex)
{
	short err;
	particle * basePart;
	basePart = simLockParts(sim);
	err = getOneParticleForce ( sim, partArrIndex, &basePart->baseForce[partArrIndex]);
	simReleaseParts(sim);
    return (err);
}
short  getOneParticleForce (kSanSimulation *sim, long partArrIndex, kSanVector * theForce)
{
	short serr = noErr;
	particle * basePart;

	serr = resetNeighborInfoForOnePart(sim, partArrIndex);
	if (serr) return (serr);
		
	basePart = simLockParts(sim);
					
	if (basePart->basePi[partArrIndex].neighborScreeningDirty)
	{
		 sim->potentialPlugIn->fillScreeningArray ( sim->potentialPlugIn,  sim, basePart, partArrIndex);
	}
	if (sim->potentialPlugIn->onePartFCalc != nilPointer)
	{
		serr = sim->potentialPlugIn->onePartFCalc ( sim->potentialPlugIn,  sim,  partArrIndex)  ; 
	}
	{
		kSanGroup **grp;
		grp = simLockGroups(sim);
		if (grp[BPNthGroup(basePart, partArrIndex)]->applyAForce)
		{
			addkSanVectorsD(theForce, &(grp[BPNthGroup(basePart, partArrIndex)]->forceApplied), theForce);
		}
		simReleaseGroups(sim);
	}
	simReleaseParts(sim);

	return (serr);
}
 short  simGetParticlePropertyMinMax (kSanSimulation *sim, DescType property, AEDesc *min, AEDesc *max)
{
	short err = noErr;
	long i;
	AEDesc nthDesc;
	double nthVal = 0;
	double theMin = 0;
	double theMax= 0;
	if (simGetNumParts(sim) >0)
	{
		err = callParticleGetDataI0(sim, 1, property, &nthDesc, typeWildCard);
		OHCoerceToDouble (&nthDesc, &theMin);
		theMax = theMin;
		AEDisposeDesc (&nthDesc);
	}
	for (i = 2; i <= simGetNumParts(sim); ++i)
	{
		err = callParticleGetDataI0(sim, i, property, &nthDesc, typeWildCard);
		OHCoerceToDouble (&nthDesc, &nthVal);
		theMin = MIN(theMin, nthVal);
		theMax = MAX(theMin, nthVal);
		AEDisposeDesc (&nthDesc);
	}	
	err = AECreateDesc (typeLongFloat, (Ptr) &theMin, sizeof(double) , min);
	err = AECreateDesc (typeLongFloat, (Ptr) &theMax, sizeof(double) , max);
	return (noErr);
}


void 	 zeroForces (kSanSimulation *sim)
{
	kSanVector  zeroVec;
	zerokSanVectorD(&zeroVec);
	processEveryParticle (sim, (void (*)( kSanSimulation *, particle *, long , void * ))kSanParticleSetForceCallback,  &zeroVec);
}
 
void 	 simZeroVelocities (kSanSimulation *sim)
{
	kSanVector  zeroVec; 
	zerokSanVectorD( &zeroVec);
	processEveryParticle (sim, (void (*)( kSanSimulation *, particle *, long , void * ))kSanParticleSetVelocityCallback, &zeroVec);
}

void  invertParticlesCallback (kSanSimulation *sim, particle *basePart, long partArrIndex, void *dummy)
{  // put all particles in group 1
#pragma unused(dummy)
 	kSanVector  pVec;
	long minusOne = -1L;
	multkSanVectorD(&basePart->basePosition[partArrIndex], minusOne, &pVec);
	kSanParticleSetPosition(sim, partArrIndex, &pVec);
	multkSanVectorD(&basePart->baseVelocity[partArrIndex], minusOne, &pVec);
	kSanParticleSetVelocity(sim, partArrIndex, &pVec);
}

void rotateParticles(kSanSimulation *sim, kSanMatrix  *fMat, short selectedOnly)
{	
	simSetPlugNotificationSuspended (sim, true);
	if (selectedOnly)
	{
		OHList  selList;
		OHListInitialize (&selList);
		BitListToOHList( &sim->selectedBits, &selList);
 		processParticleIndexList (sim, rotateParticleCallback, &selList,  fMat);
	 	OHListDispose (&selList);
	}
	else
	{
		processEveryParticle (sim, (void (*)( kSanSimulation *, particle *, long , void * ))rotateParticleCallback,  fMat);
	}
	simIncrementStateCount(sim);
 	simInformPluginsOfChange(sim, kChangedPartPositions);
 	simSetPlugNotificationSuspended (sim, false);
}
void  rotateAllParticles (kSanSimulation *sim, short whichAxis, double angle)
{
	particle * basePart;
 	long partArrIndex;

	basePart = simLockParts(sim);
	for (partArrIndex = 0; partArrIndex< simGetNumParts(sim);++partArrIndex)
	{
 	    rotatekSanVectorD (whichAxis, angle, &basePart->basePosition[partArrIndex]);
	    rotatekSanVectorD (whichAxis, angle, &basePart->baseVelocity[partArrIndex]);
	}
	simReleaseParts(sim);
	simIncrementStateCount(sim);
}
void  rotateParticleCallback(kSanSimulation *sim, particle *basePart, long partArrIndex, void *voidArg)
{
	kSanMatrix *fMat = ( kSanMatrix *)voidArg;
	kSanVector newPos;
	cramerskSanTransformD(&basePart->basePosition[partArrIndex] ,fMat, &newPos);
	kSanParticleSetPositionCallback (sim, basePart, partArrIndex, &newPos);
}


void  translateParticles  (kSanSimulation *sim, kSanVector *tVec, short selectedOnly)
{
	simSetPlugNotificationSuspended (sim, true);
	simSetPlugNeighborUpdatesSuspended (sim, true);
	if (selectedOnly)
	{
		processParticleBitList (sim, translateParticleCallback,  &sim->selectedBits, tVec);
	}
	else
	{
		processEveryParticle (sim, (void (*)( kSanSimulation *, particle *, long , void * ))translateParticleCallback, tVec);
	}
	simIncrementStateCount(sim);
	wrapAroundAndBitfields(sim);
	simSetPlugNeighborUpdatesSuspended (sim, false);
	simSetPlugNotificationSuspended (sim, false);
}

void  doParticleDialog  (kSanSimulation *sim, long partArrIndex)
{
#pragma unused(sim)
#pragma unused(partArrIndex)
//	dialogResult = doAShortDialog(kEditParticleDialog);
}
void  translateParticleCallback(kSanSimulation *sim, particle *basePart, long partArrIndex, void *voidArg)
{
	kSanVector * tVec = voidArg;
	kSanVector  newPos;
	addkSanVectorsD  (&(basePart->basePosition[partArrIndex]), tVec, &newPos);
	kSanParticleSetPositionCallback (sim, basePart, partArrIndex, &newPos);
}

void  translateParticle(kSanSimulation *sim,  long partArrIndex, kSanVector * tVec)
{
	particle * basePart;
	basePart = simLockParts(sim);
	translateParticleCallback(sim, basePart,  partArrIndex,  tVec);
	simReleaseParts(sim);
	simIncrementStateCount(sim);
}


