 #include "kSanSimulationPrivate.h"
#include "OHMenuRegistry.h"

void setSelectionsMenuItems( short somethingIsSelected)
{
  	short thisRezID;
  	   if (somethingIsSelected)
	   {
		 thisRezID = kEditParticleStringID  ;
 	   }
	   else 
	   {
	 	 thisRezID = kMakeParticleStringID  ;		  
 	   }
 	setMenuToSTR( iEditParticleMenuItem, thisRezID, "\pedit");
 }

void setSimSelectionsMenuItems(kSanSimulation *sim)
{
	short somethingIsSelected;
	
	somethingIsSelected = (BitListNumTrue(&sim->selectedBits ) > 0);
	setSelectionsMenuItems(somethingIsSelected);
}

void  refindHighlights(kSanSimulation *sim)
{
	particle *basePart;
	long partArrIndex;
	
	sim->highlights.howManyItems = 0;	
	basePart = simLockParts(sim);
	for (partArrIndex=0; partArrIndex< simGetNumParts(sim); ++partArrIndex)
	{
		if (BPNthHighlighted(basePart, partArrIndex) != kNotHighlighted )
		{
			long numH;
			numH = OHListCount(&sim->highlights);
			if (numH < 255)
			{
				BPNthHighlighted(basePart, partArrIndex) = OHListCount(&sim->highlights);
				addToList(&sim->highlights, partArrIndex);
			}
		}
	}
	simReleaseParts(sim);
}

void  refindSelections(kSanSimulation *sim)
{
	particle *basePart;
	long partArrIndex;
	long numParts;
 	
	basePart = simLockParts(sim);
	numParts =  simGetNumParts(sim);
	BitListSetNumItems (&sim->selectedBits, numParts);
	for (partArrIndex=0; partArrIndex<numParts; ++partArrIndex)
	{
	        BitListAccommodate (&sim->selectedBits, partArrIndex);
 		 setNthBit (&sim->selectedBits, partArrIndex, (BPNthSelected(basePart, partArrIndex) == kSelected ));
 	}
	simReleaseParts(sim);
	setSimSelectionsMenuItems(sim);
}
short  addToHighlights(kSanSimulation *sim, long partArrIndex)
{
	short err = noErr;
	particle *basePart;
	basePart = simLockParts(sim);
	
	if (BPNthHighlighted(basePart, partArrIndex) == kNotHighlighted)
	{
		BPNthHighlighted(basePart, partArrIndex) = OHListCount(&(sim->highlights));
		err = addToList(&(sim->highlights), partArrIndex);
	}
	simReleaseParts(sim);
	return (err);
}
short  removeFromHighlights(kSanSimulation *sim, long partArrIndex)
{
	particle *basePart;
	
	basePart = simLockParts(sim);	
	if (BPNthHighlighted(basePart, partArrIndex) != kNotHighlighted)
	{
		BPNthHighlighted(basePart, partArrIndex) = kNotHighlighted;
		removeItem(&(sim->highlights), partArrIndex);
	}
	simReleaseParts(sim);
	return (noErr);
}


short  addToSelections(kSanSimulation *sim, long partArrIndex)
{
	short err = noErr;
	particle *basePart;
	basePart = simLockParts(sim);
	BitListAccommodate(& sim->selectedBits, partArrIndex);
	
	if (BPNthSelected(basePart, partArrIndex) == kNotSelected)
	{
		BPNthSelected(basePart, partArrIndex) = kSelected;
		setNthBitTrue(& sim->selectedBits, partArrIndex);
	}
	simReleaseParts(sim);
	return (err);
}
short  removeFromSelections(kSanSimulation *sim, long partArrIndex)
{
	particle *basePart;
	basePart = simLockParts(sim);	
	BitListAccommodate(& sim->selectedBits, partArrIndex);
	if (BPNthSelected(basePart, partArrIndex) != kNotSelected)
	{
		BPNthSelected(basePart, partArrIndex) = kNotSelected;
		setNthBitFalse(& sim->selectedBits, partArrIndex);
	}
	simReleaseParts(sim);
	return (noErr);
}

char  getParticleSelected(kSanSimulation *sim, long partArrIndex)
{
	particle *basePart;
	char selected;
	basePart = simLockParts(sim);
	selected = BPNthSelected(basePart, partArrIndex);
	simReleaseParts(sim);
	return (selected);
}

short  setParticleSelected(kSanSimulation *sim, long partArrIndex, char shouldSelect)
{
	short err = noErr;
	short (* callback)( void * , const long );
	
	callback = (short (* )( void * , const long )) (shouldSelect ? addToSelections : removeFromSelections);
	err = callback(sim, partArrIndex);
 	setSelectionsMenuItems(BitListNumTrue(&(sim->selectedBits)) > 0); // anything selected ?
	return(err);
}

short  toggleParticleSelected(kSanSimulation *sim, long partArrIndex)
{
	return(setParticleSelected(sim, partArrIndex, (!getParticleSelected(sim, partArrIndex))));
}

char  getParticleHighlighted(kSanSimulation *sim , long partArrIndex)
{
	char  isHighlighted; 
	particle *basePart;
	basePart = simLockParts(sim);	
	
	isHighlighted = BPNthHighlighted(basePart, partArrIndex);
	
	simReleaseParts(sim);
	return (isHighlighted);
}
short  setParticleHighlighted(kSanSimulation *sim, long partArrIndex, char shouldHighlight)
{
	short (* callback)( void * , const long );
	
	callback =  (short (* )( void * , const long )) (shouldHighlight ? addToHighlights : removeFromHighlights);
	return(callback(sim, partArrIndex));
	/*
	if (hilite) 
	{
		addToHighlights(sim, partArrIndex);
	}	
	else
	{
		removeFromHighlights(sim, partArrIndex);	
	}
	*/
}

void  makeSelectionsThisTypeCallback( kSanSimulation *sim, particle *basePart, long partArrIndex, void * voidAtomtype);
void  makeSelectionsThisTypeCallback(kSanSimulation *sim, particle *basePart, long partArrIndex,  void * voidAtomtype)
{
#pragma unused (basePart)
	kSanAtomtype * whichType = (kSanAtomtype * )voidAtomtype;
	kSanParticleSetTypeByObj(sim, partArrIndex, whichType->atObj);
}
 
void  makeSelectionsThisType(kSanSimulation *sim, kSanAtomtype * whichType)
{
 	processParticleBitList(sim, makeSelectionsThisTypeCallback, &sim->selectedBits, (void *) whichType);
	//  OHListEveryItemDoTwoArgs( &(sim->selections),  makeSelectionsThisTypeCallback, sim, (void *) whichType);
 }
void  eraseSelections(kSanSimulation *sim)
{
 	long numParts = simGetNumParts(sim) ;
	long partArrIndex;
	particle * basePart;

	 BitListSetAll(&sim->selectedBits, false); 

	basePart = simLockParts(sim);
 	for (partArrIndex = 0;partArrIndex< numParts ; ++partArrIndex)
	{
 		BPNthSelected(basePart, partArrIndex) = kNotSelected;
	}
	simReleaseParts(sim);
	setSelectionsMenuItems(false); // nothing selected
}
void  toggleListSelected(kSanSimulation *sim, OHList *list)
{
	particle * basePart;
	basePart = simLockParts(sim);
		
	 OHListEveryItemAsSecondArg( list,  toggleParticleSelected, sim);

	simReleaseParts(sim);
}
 void  setListSelected (kSanSimulation *sim, OHList *list, char shouldSelect)
{
	particle * basePart;
	short (* callback)( void * , const long );
	
	callback =  (short (* )( void * , const long )) (short (* )( void * , const long )) (shouldSelect ? addToSelections : removeFromSelections);
	basePart = simLockParts(sim);
	 OHListEveryItemAsSecondArg( list,  callback, sim);
	simReleaseParts(sim);
	setSelectionsMenuItems(BitListNumTrue(&(sim->selectedBits)) > 0); 
	 /*
	if (shouldSelect)
	{
		 OHListEveryItemAsThirdArg( list,  addToSelections, sim);
	}
	else
	{
		 OHListEveryItemAsThirdArg( list,  removeFromSelections,  sim);
	}
	*/
}
void  setListHighlighted (kSanSimulation *sim, OHList *list, char shouldHighlight)
{
	particle * basePart;
	
	short (* callback)(  void * , const long );
	
	callback = (short (* )(  void * , const long )) (shouldHighlight ? addToHighlights : removeFromHighlights);
	basePart = simLockParts(sim);
	 OHListEveryItemAsSecondArg( list,  callback, sim);
	simReleaseParts(sim);
	 /*
	if (shouldHighlight)
	{
		 OHListEveryItemAsThirdArg( list,  addToHighlights, sim);
	}
	else
	{
		 OHListEveryItemAsThirdArg( list,  removeFromHighlights,  sim);
	}
	*/
}
/*
long  getNthSelection(kSanSimulation *sim, long whichIndex)
{
	return (getNthItem(&(sim->selections), whichIndex) );
}
*/