#include <fp.h>

#include "kSanSimulationPrivate.h"
#include "kSanApplicationPublic.h"
#include "kozoObjectContents.h"
#include "OHBufferedView.h"
#include "OHCOTests.h"

#include "OHToken.h"
#include "OHMenu.h"
#include "OHProc.h"
#include "kSanDialog.h"

//kozoObject *gParticleMenu;
//kozoObject *gSimMenu;
short kSanSimResolveContainedClass(KozoDispatchStack *ds, resolveMethodArgs *rma);
short kSanSimHandleCreateElement(KozoDispatchStack *ds, crelMethodArgs *cma);
short  kSanSimCountContained(KozoDispatchStack *ds, countMethodArgs *cma);
short kSanSimHandleReport (KozoDispatchStack *ds, reportMethodArgs *rd);

short SimAddContainedObject(kSanSimulation *sim, AEDesc *itemToAdd);
 //short  simSetDoubleVal(kSanSimulation *sim,DescType theProp, AEDesc *dataDesc);
 short messageForFrontSim (DescType message, DescType dataType, void * data);
short simParticleDoMessage (kozoObject *simuObj, void *sim, long partArrIndex, doMessageMethodArgs *dmma);

short  simParticlesWhoseFilter(kSanSimulation *sim,  AEDesc* keydata,  OHList *resultList );
short  particleListWhoseFilter(kSanSimulation *sim,  AEDesc* keydata,  OHList *startList,  OHList *resultList );
short  ParticleFromSimulation(KozoDispatchStack *ds, kSanSimulation *sim, resolveMethodArgs *rma);
short  ParticleFromParticle(KozoDispatchStack *ds, kSanSimulation *sim, resolveMethodArgs *rma);
short kSanSimCOMessage(KozoDispatchStack *ds, kSanSimulation *sim, doMessageMethodArgs *dmma);
short  extractUniqueIDList(AEDesc* keydata, kSanSimulation *sim,   OHList *partList);
short resetParticleIDs(kSanSimulation *sim);
void   kSanSimDoCommandPeriod	(kSanSimulation *sim );
short kSanSimDoUnflattenFinish(kSanSimulation *sim);

short initClassSimulation (void)
{
	short err = noErr;
	kozoClass *newClass;
	kozoObject *co;

	newClass = addClass(&co, ClassSimulation, ClassSimDataWindow, sizeof (kSanSimulation), "simulation");
	if (newClass)
	{
		addInheritance (newClass, ClassDocument);
		err =	setFuncs(newClass, 0L,  kSanSimConstructor,
		kSanSimDestructor, kSanSimGetData, kSanSimSetData, kSanSimDoMessage,
		 kSanSimHandleReport, kSanSimCountContained, kSanSimResolveContainedClass, kSanSimHandleCreateElement);
 
 		err =  kozoClassAddRemove4ItemsToSave(newClass, true,  pNeighborCutoffExtra, pCutoffs, pXConstraint, pYConstraint );
 		err =  kozoClassAddRemove4ItemsToSave(newClass, true, pZConstraint, pCellAngles, pCellXYZLength, pAppliedForce);
 		err =  kozoClassAddRemove4ItemsToSave(newClass, true, pParticleData, pIterations, pUniqueParticleCounter, pTime);
 		err =  kozoClassAddRemove4ItemsToSave(newClass, true, pRedrawPeriod, pTempCorrPeriod, pMemoryCleanupPeriod, pAutoSavePeriod);
 		err =  kozoClassAddRemove3ItemsToSave(newClass, true, pNeighborRecalcPeriod, pVelocityCenteringPeriod, pCellPressureCheckPeriod );
 		
  	}
	else
	{
		err = true;
	}
	return (err);
}
short kSanSimConstructor (KozoDispatchStack *ds, constructorMethodArgs *cma)
{
	short err = noErr;
	char beingUnflattened = false;
	kSanSimulation *sim = (kSanSimulation *) ds->thisPD;
 	err = extractParam (ds, cma->initialData, pBeingUnflattened, typeBoolean, &beingUnflattened, sizeof(char));
 	
 	sim->simulationObj = ds->obj;
	err = makeIterationThread(sim);
	if (!err) err = initBoxInfo(sim);
	if (!err) initGThreshholds(sim);
	if (!err) initGCounters(sim);
	if (!err) err = initializeList (&sim->waitingThreads);
	if (!err) err = BitListInitialize  (&sim->selectedBits);
	if (!err) err = initializeList (&sim->highlights);
	if (!err) err = initializeList(&sim->yieldFlags);
	if (!err) err = initializeNL (&sim->uniqueIDList);
	if (!err) err = initializeNL (&sim->particlePropertyOwners);
	sim->neighborSpaceFrontSlack = 0;
	sim->neighborsPtr = nilPointer;
	sim->neighborsPtr = NewPtr(2000000);
	if (sim->neighborsPtr == nilPointer) err = true;
	
	if (!err) err = LCHandleInit(&sim->forceLCH);
	if (!err) err = LCHandleInit(&sim->positionLCH);
	if (!err) err = LCHandleInit(&sim->velocityLCH);
	if (!err) err = LCHandleInit(&sim->potentialLCH);
	if (!err) err = LCHandleInit(&sim->particlesLCH);
 	sim->particlesRefCount = 0;
  	
	sim->groupArray = nilPointer;
	sim->atomtypeArray = nilPointer;
	sim->groupListRefCount = 0;
	sim->atomtypeListRefCount = 0;

   // end used to be simDefaultValues
	sim->stateCount = 0;
	sim->lastEnergyCalcStateCount = 0;
	sim->howManyParts = 0;
	sim->uniqueParticleCounter = 0;
	sim->flags.uniqueIDListDirty = true;
	sim->flags.abortNow = false;
	sim->flags.done = false;
	sim->flags.clockRunning = false;
	sim->flags.error = false;
	sim->flags.automaticUpdate = true;
	sim->flags.pbcMode = 1;
	sim->flags.lowestYieldFlag = 0xFFFFFFFF;
	sim->deltaT 			= 0.001;
	sim->potEnergy 		= 0;
	sim->kinEnergy 		= 0;
	sim->totalTimeElapsed 		= 0;
	sim->totalNumberOfIterations = 0;
	sim->doEConservation = false;
	sim->doVCentering = false;
	sim->neighborCutoffExtra = 0.5;
  	sim->simCell.alpha = kPi * 0.5;
	sim->simCell.beta = kPi * 0.5;
	sim->simCell.gamma = kPi * 0.5;
	sim->simCell.cellEdges.a = 15;
	sim->simCell.cellEdges.b = 15;
#ifndef __2DVectors__
	sim->simCell.cellEdges.c = 15;
#endif
	sim->gConstrained.XAxis = true;
	sim->gConstrained.YAxis = true;
	sim->gConstrained.ZAxis = true;
	sim->gConstrained.Gamma = true;
	sim->gConstrained.Alpha = true;
	sim->gConstrained.Beta = true;
	sim->boxDim.a = 3;
	sim->boxDim.b = 3;
#ifndef __2DVectors__
	sim->boxDim.c = 3;
#endif
	sim->innerCutoff = 3.5;
	sim->outerCutoff = 4;
	sim->middleCutoff = 0.5 * (sim->innerCutoff + sim->outerCutoff);
 	sim->piOverRange = (kPi / ( sim->outerCutoff - sim->innerCutoff ));

	zerokSanVectorD(&sim->simCell.appliedStrainStress);
	zerokSanVectorD(&sim->simCell.appliedShearStress);
	calcCellPropertiesFromEdgesAndAngles (&sim->simCell);
	sim->wrapAround = wrapAroundOrthorhombic;
	sim->getSepVec = getSepVecOrthorhombic;
	sim->getSepSquared = getSepSquaredOrthorhombic;
	sim->setBoxForPart = setBoxForPartOrthorhombic;
	sim->determineBoxForPart = determineBoxForPartOrthorhombic;
	sim->plugNotificationSuspended = false; 
   // end used to be simDefaultValues

	sim->howManyBoxes = 0;
	sim->suspendNeighborUpdates = 0;
	sim->recentAverageNeighborSlots = 24;
	err = initBoxes(sim);
	if (!err) err = dispatchLoop(ds, cma);
	
	sim->potentialPlugIn = nilPointer;
	sim->resizePlugIn = nilPointer;
	sim->methodPlugIn = nilPointer;
	
	if ((!err) && (!beingUnflattened)) 
	{
		 makeDefaultModule(sim, ClassPotentialPlugIn) ;
		 makeDefaultModule(sim, ClassCellResizePlugIn) ;
		 makeDefaultModule(sim, ClassMethodPlugIn) ;
 	 	 err = kSanSimNewGroup(sim, 0L);
		 simSetFirstAtomType(sim);
	}
 	{
		 err = kozoSetData(OHGetNamedReference(globalAppObject, mParticleMenu), pEnabled, &gTrueDesc);  
		 err = kozoSetData(OHGetNamedReference(globalAppObject, mSimulationMenu), pEnabled, &gTrueDesc); 
		 dispatchNilMessage (simOBJ(sim), kMaintainMenusMessage);
  	}
	KDSReturnError(ds,err);
}
 short kSanSimDoUnflattenFinish(kSanSimulation *sim)
{
	short err = noErr;
	kozoObject *aPlugIn;
	
	 simSetPlugNotificationSuspended(sim, true); //  add particle would call simInformPluginsOfChange a lot if we didn't do this
	
	
	aPlugIn = OHGetNamedReference(simOBJ(sim), ClassMethodPlugIn);
	if (!aPlugIn) 
	{
	   aPlugIn = kozoObjectGetNthItemOfClassX(simOBJ(sim), ClassMethodPlugIn, 0);
	   if (aPlugIn) OHStoreUniqueReference(aPlugIn, simOBJ(sim), ClassMethodPlugIn);
	}
	if (aPlugIn) 
	{
	    if (aPlugIn) sim->methodPlugIn = kozoObjectGetPrivateData(aPlugIn, ClassMethodPlugIn) ;
	}
	else
	{
 		 makeDefaultModule(sim, ClassMethodPlugIn) ;
 	}
	
	
	aPlugIn = OHGetNamedReference(simOBJ(sim), ClassPotentialPlugIn);
	if (!aPlugIn) 
	{
	   aPlugIn = kozoObjectGetNthItemOfClassX(simOBJ(sim), ClassPotentialPlugIn, 0);
	   if (aPlugIn) OHStoreUniqueReference(aPlugIn, simOBJ(sim), ClassPotentialPlugIn);
	}
	if (aPlugIn) 
	{
	    if (aPlugIn) sim->potentialPlugIn = kozoObjectGetPrivateData(aPlugIn, ClassPotentialPlugIn) ;
	}
	else
	{
		 makeDefaultModule(sim, ClassPotentialPlugIn) ;
 	}
	
	
	aPlugIn = OHGetNamedReference(simOBJ(sim), ClassCellResizePlugIn);
	if (!aPlugIn) 
	{
	   aPlugIn = kozoObjectGetNthItemOfClassX(simOBJ(sim), ClassCellResizePlugIn, 0);
	   if (aPlugIn) OHStoreUniqueReference(aPlugIn, simOBJ(sim), ClassCellResizePlugIn);
	}
	if (aPlugIn) 
	{
		sim->resizePlugIn = kozoObjectGetPrivateData(aPlugIn, ClassCellResizePlugIn) ;
	}
	else
	{
 		 makeDefaultModule(sim, ClassCellResizePlugIn) ;
	}
	
	
 	if (!err) err = refindGroups(sim);
	  simInformPluginsOfChange(sim, kChangedNeighbors);   
	if (!err) err = initBoxes(sim);
	if (!err) err = calcNeighbors(sim);
	 simSetPlugNotificationSuspended(sim, false);  //  add particle would call simInformPluginsOfChange a lot if we didn't do this
	return (err);
}
short   kSanSimDestructor (KozoDispatchStack *ds, destructorMethodArgs *cma)
{
#pragma unused(cma)
	kSanSimulation *sim = (kSanSimulation *) ds->thisPD;
	removeIterationThread(sim);
	sim->flags.done = true;
	
	if (numInstances( ClassSimulation ) == 1)
 	{
		 kozoSetData(OHGetNamedReference(globalAppObject, mParticleMenu), pEnabled, &gFalseDesc); 
		 kozoSetData(OHGetNamedReference(globalAppObject, mSimulationMenu), pEnabled, &gFalseDesc); 
   	}
 	simInstallUniqueModule(sim,  ClassPotentialPlugIn,  nilPointer);
	simInstallUniqueModule(sim,  ClassCellResizePlugIn,  nilPointer);
	simInstallUniqueModule(sim,  ClassMethodPlugIn,  nilPointer);
   	
    dispatchLoop(ds, cma);
   	
  	disposeList (&sim->waitingThreads);
	BitListDispose  (&sim->selectedBits);
	disposeList (&sim->highlights);
	disposeList (&sim->yieldFlags);
	disposeNL (&sim->uniqueIDList);
	disposeNL (&sim->particlePropertyOwners);

	DisposePtr(sim->neighborsPtr);

	LCHandleDispose(&sim->forceLCH);
	LCHandleDispose(&sim->positionLCH);
	LCHandleDispose(&sim->velocityLCH);
	LCHandleDispose(&sim->potentialLCH);
	LCHandleDispose(&sim->particlesLCH);
	
	disposeBoxInfo(sim);
	
	KDSReturnContinue(ds);
}

short  kSanSimCountContained(KozoDispatchStack *ds, countMethodArgs *cma)
{	
	short err = noErr;
	kSanSimulation *sim = (kSanSimulation *) ds->thisPD;


	if (cma->whatClass == ClassParticle) 
 	{
 		if (( !ds->coToken) || (ds->coToken->identifier == pSelf))
		{
		   *cma->result = simGetNumParts(sim);  
		}
		else if ((ds->coToken->identifier == ClassContainedObject) && ( ds->coToken->subObjectClass == ClassParticle))
		{
			err = OHCOTokenGetNumItems(ds->coToken);
		}
		else
		{  
		   err = errAECoercionFail;		
		}
   		KDSDoneDispatch(ds);
  	}

	KDSReturnError(ds,err);
}
short kSanSimHandleCreateElement(KozoDispatchStack *ds, crelMethodArgs *cma)
{ // only works if for creating classes which are a subclass of kozoObject
  // objects which support contained object which are not a subclass of kozoObject need to override
  // especially for the case of kAEReplace!
	short err = noErr;
	long theIndex;
	kSanSimulation *sim = (kSanSimulation *) ds->thisPD;
	if (cma->whatClass != ClassParticle) 
	{
		KDSReturnContinue(ds);
	}
	else
	{
	    OHToken insertHereToken;
	    OHTokenExtract (&insertHereToken,  cma->insertionObjectToken);
	    if ((!err) && (kozoObjectIsSubclass(insertHereToken.theObject, ClassSimulation)))
	    {
		    if (cma->positionEnum == kAEDefaultLocation) cma->positionEnum = kAEEnd;
			if (((cma->positionEnum == kAEBeginning) || (cma->positionEnum == kAEEnd)))
			{
				if (cma->positionEnum == kAEBeginning) theIndex = 1;
				else theIndex  = sim->howManyParts + 1;  
			}
		}
		else if (cma->insertionObjectToken->descriptorType == typeContainedObject) 
		{ // type of token had better be ClassParticle
 			if (insertHereToken.subObjectClass == ClassParticle)
			{
				switch (cma->positionEnum)
				{
					case kAEReplace:  
						theIndex  =  kSanSimGetTokenIndex(sim, &insertHereToken);
					    kSanSimRemoveParticleToken(sim, &insertHereToken);
						break;
					case kAEBefore:
					case kAEAfter:
						theIndex  = kSanSimGetTokenIndex(sim, &insertHereToken);
						if (cma->positionEnum == kAEAfter) ++theIndex;
						break;
					default:
						err = errAEBadKeyForm;
				}
			}
			else
			{
				err = errAEBadKeyForm;
			}
		}
		else
		{
			err = errAEBadKeyForm;
		}
		if (!err) 
		{
 			err =  simMakeContainedParticle(sim,  theIndex,  cma->initialDataDesc, cma->newObjectDesc);
			KDSDoneDispatch(ds);
		}
	}
	KDSReturnError(ds, err);
}
short kSanSimResolveContainedClass(KozoDispatchStack *ds, resolveMethodArgs *rma)
{
	short err = noErr;
	kSanSimulation *sim = (kSanSimulation *) ds->thisPD;
	if (rma->classWanted == ClassParticle) 
 	{
		OHToken startToken;
		OHTokenExtract (&startToken, rma->startToken);
		if (kozoObjectIsSubclass(startToken.theObject, ClassSimulation) )
		{
			if (startToken.identifier == pSelf)
			{
				err = ParticleFromSimulation (ds, sim, rma);
			}
			else if ((startToken.identifier == ClassContainedObject) && ( startToken.subObjectClass == ClassParticle))
			{
				err = ParticleFromParticle (ds, sim, rma);
			}
		}
 		KDSDoneDispatch(ds);
  	}
	KDSReturnError(ds,err);
}

short kSanSimHandleReport (KozoDispatchStack *ds, reportMethodArgs *rd)
{
	short err = noErr;
	short shouldContinue = true;

	kSanSimulation *sim = (kSanSimulation *) ds->thisPD;
 	switch (rd->functionForContainer)
	{
		case fDoMessage:
			switch (rd->args.dmma.message)
			{
 			//	case  kGetSimulationPtrReport:   
 			//		if (rd->args.dmma.dataType == typeSimulationPtrPtr) (*((kSanSimulation **)rd->args.dmma.data)) =  sim;
			//	    shouldContinue = false;
			}
			break;
	}
	if (!shouldContinue) KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}

short kSanSimDoMessage (KozoDispatchStack *ds, doMessageMethodArgs *dmma)
{
	short err = noErr;
	kSanSimulation *sim = (kSanSimulation *) ds->thisPD;
	switch (dmma->message)
	{
// if message is kContainedObjectMessage,
// then otherValue is a (OHToken *)
// and data is an doCOMData *
		case kInvalWorldsMessage:   
		 	updateEnergy(sim);
        	kozoObjectMessageForContents(ds->obj, ClassWindow, kInvalGraphicsMessage, 0L, 0L);
        	dispatchNilMessage(ds->obj, kInvalGraphicsMessage); // because we want to update the sim window as well
 		    sim->counters.redraw = 0;
 		     break; 
		case kSimRegisterParticlePropertyOwner:
			if (dmma->dataType == particlePropertyOwnerDataPtr) 
			{
			    particlePropertyOwner * ppo = (particlePropertyOwner *) dmma->data;
			    if (ppo->nowRegistering)
			    {
			    	addToNL( &sim->particlePropertyOwners, (long) ppo->owner, ppo->property);
			    }
			    else
			    {
 					long nthItem;
 			    	nthItem = whichItemAndNameNL(&sim->particlePropertyOwners, (long) ppo->owner, ppo->property );
			   		if (nthItem != -1) removeNthItemNL (&sim->particlePropertyOwners, nthItem); 
			    }
 			}
			break;
		case kSimContinuingBackupMessage:
			err = kSanSimDoContinuingBackup(sim);
			break;
		case kContainedObjectMessage:
			err = kSanSimCOMessage(ds, sim, dmma);
			KDSReturnError(ds, err);
		case kSanAEIterateMessage:
			err = simDoIterateEvent(sim, (AEMessageData *) dmma->data);
			break;
		case kSanAEStrainMessage:
			err = simDoStrainEvent(sim, (AEMessageData *) dmma->data);
			break;
		case kSanSimReorderEvent:
			err = reorderParticles(sim);
		    break;
		case kSanSimResetIDsEvent:
			err = resetParticleIDs(sim);
		    break;
		case kUnflattenFinishedMessage: // we'll get this after the sim has been read from a file and all objects added
			err = dispatchLoop(ds, dmma);
			kSanSimDoUnflattenFinish(sim);
			goto Default;
		case kSanSimDoInitialCellMessage:
			kSanSimNewInitialStructureDialog(sim);
			break;							
		case kDoDialogMessage:
			err = DoParametersDialog(sim);
			break;							
		case kSimUpdateEnergyMessage:
			updateEnergy(sim);
			break;		
		case kSimClockToggleMessage:
			simDoTimeSwitch(sim);
			break;		
		case kPotentialDialog:
			if (sim->potentialPlugIn != nilPointer)
			err = dispatchNilMessage (OHGetNamedReference (simOBJ(sim), ClassPotentialPlugIn), kDoDialogMessage);
			break;
		case kResizeDialog:
			if (sim->resizePlugIn != nilPointer)
			err = dispatchNilMessage (OHGetNamedReference (simOBJ(sim), ClassCellResizePlugIn),kDoDialogMessage);
			break;			
		case kMethodDialog:
 			if (sim->methodPlugIn != nilPointer)
			err = dispatchNilMessage ( OHGetNamedReference (simOBJ(sim), ClassMethodPlugIn),kDoDialogMessage);
 			break;			
		case kCutoffDialog:
			err = DoCutoffParamsDialog(sim);
			break;
		case kFrequenciesDialog:
			err = DoFrequenciesDialog(sim);
			break;	
		case kDataCollectionDialog: // subMenu??
      		err =  doDataCollectionDialog	(sim);
			break;	
//		case kConstraintsDialog:
//			err = DoCellConstraintsDialog(OHOb(sim));
//			break;
		case kScaleCellDialog:
			err = DoScaleCellDialog(sim);
			break;
		case kExpandCellDialog:
			err = DoCellExpansionDialog(sim);
			break;
		case kCellStressDialog:
			err = DoCellStressDialog(sim);
			break;
		case kCellSizeDialog:
			err = DoCellSizeDialog(sim);
			break;
		case kGroupInfoDialog:
			err = DoGroupInfoDialog(sim, 1L);
			break;
		case kAtomInfoMessage:
			err = simDoAtomInfoDialog(sim, 0L);
			break;
		case kThermalizeMessage:
		case kSetToZeroMessage:
			kozoDoMessage (OHGetNamedReference (simOBJ(sim), ClassMethodPlugIn), dmma->message, typeSimulationPtr, (void *) sim);
			break;
		case kGroupSelectedParticlesMessage:
			doGroupSelectedParticles (sim);
			break;
		case kResetGroupsMessage:
			resetGroups (sim);
			break;
		case kSpawnWindow:
			{
				kozoObject *newWin;
				if (BitListNumTrue(&sim->selectedBits) == 0)
				{
					spawnWindow (sim, nilPointer,  &newWin);
				}
				else
				{
					spawnWindow (sim, &sim->selectedBits,  &newWin);
				}
				 dispatchNilMessage (newWin, kActivateMessage);
			}
			break;
		case kAECut:
			err = kSanSimCut(sim);
			break;
		case kCopyMessage:
			err = kSanSimCopy(sim);
			break;
		case kAEPaste:
			err = kSanSimPaste(sim);
			break;
		case kMaintainMenusMessage:
  			 setSelectionsMenuItems(BitListNumTrue(&sim->selectedBits) > 0);  
			goto Default;
		case kRemoveObjectMessage:
 			if (!(kozoObjectNowDestructing(simOBJ(sim)))) 
 			{
 				if (classIsSubclass( (castTokozoObject(dmma->data))->oClass, ClassParticleGroup) )
				{
					kSanSimRemoveGroupObj(sim, castTokozoObject(dmma->data));
				}
 			}
			goto Default;
		Default:
 		default :
			KDSReturnContinue(ds);
			break;
	}
	KDSDoneDispatch(ds);
	KDSReturnError(ds, err);
}
  

 short  simParticleDoMessage(kozoObject *simuObj, void *voidArg,  long partArrIndex, doMessageMethodArgs *dmma)
{ // simuObj is here because  the standard call in kozo supports it
 #pragma unused(simuObj)
	short err = noErr;
 	particle *basePart;
	kSanSimulation *sim = ( kSanSimulation *)voidArg;
	partArrIndex -= 1;
	basePart = simLockParts(sim);
	switch (dmma->message)
	{	
		default:
			break;
	} // end ClassParticle
	simReleaseParts(sim);
	return (err);
}

short kSanSimCOMessage(KozoDispatchStack *ds, kSanSimulation *sim, doMessageMethodArgs *dmma)
{ 
	short err = noErr;
 	if ( ds->coToken->identifier == cProperty)
 	{
	    switch (dmma->subMessage)
	    {
	        case kSanAEStrainMessage:
			    err = simDoStrainEvent(sim, (AEMessageData *) dmma->data);
				KDSDoneDispatch(ds);
			break;
	    }
 	}
 	else if ( ds->coToken->identifier == ClassContainedObject)
 	{
	 	switch  (ds->coToken->subObjectClass)
		{
 			case ClassParticle:
				err =  standardCOMessage(ds, sim, dmma, simParticleDoMessage);
				goto Done;
			Done:
				KDSDoneDispatch(ds);
		}
	}
  	KDSReturnError(ds, err);
}

short  extractUniqueIDList(AEDesc* keydata, kSanSimulation *sim,  OHList *partList)
{  // for each unique ID, translate to the index and package as a list
	short err = noErr ;
	if (keydata->descriptorType == typeLongInteger) 
	{
		long theID;
		long partArrIndex;
		theID = (*(long *)(*keydata->dataHandle));
		partArrIndex = simParticleIndexFromUniqueID(sim, theID);
		  // partArrIndex starts indexing from 1
		if (partArrIndex != 0) addToList(partList, partArrIndex);
	}
	else if (keydata->descriptorType == typeAEList) 
		AEListEveryItemDoTwoArgs( keydata, typeLongInteger, extractUniqueIDList, sim, partList);
	else
	{
		long theCoercedID;
		long theCoercedPartIndex;
		err = OHCoerceToLong(keydata, &theCoercedID);
		if (!err)
		{
			theCoercedPartIndex = simParticleIndexFromUniqueID(sim, theCoercedID);
	    	  // theCoercedPartIndex starts indexing from 1
			if (theCoercedPartIndex != 0) addToList(partList, theCoercedPartIndex);
		}
	}	
	return (err);
}

short  ParticleFromSimulation(KozoDispatchStack *ds, kSanSimulation *sim, resolveMethodArgs *rma)
{
	short err = noErr ;
	if (rma->keyform == formUniqueID)
	{
		OHToken  aToken;
 		OHList *partList;
 		partList = (OHList *)NewPtr(sizeof(OHList));
		initializeList (partList);
 	
		OHTokenConstructor(&aToken, ds->obj);
		aToken.identifier = ClassContainedObject;
		aToken.subObjectClass = ClassParticle;
		aToken.keyform = formAbsolutePosition;
  		AECreateDesc(typeOHListPtr, (Ptr) &partList, 4L, &aToken.keydata);
		err =  extractUniqueIDList(rma->keydata,  sim, partList); // translate unique ids into particle indices
		err = AECreateDesc(typeOHToken, (Ptr)&aToken, sizeof(OHToken), rma->resultToken );	
		KDSDoneDispatch(ds);
		KDSReturnError(ds, err); 	
	}
	else
	{
	     err = standardCOResolve(ds->obj, rma, ClassParticle);
	}
	KDSReturnError(ds,err);
}
short  ParticleFromParticle(KozoDispatchStack *ds, kSanSimulation *sim, resolveMethodArgs *rma)
{
#pragma unused(sim)
	short err = errAEBadKeyForm ;
	err = standardCOResolve(ds->obj, rma, ClassParticle);
	KDSReturnError(ds,err);
}

short messageForFrontSim (DescType message, DescType dataType,  void * data)
{
 	return (kozoDoMessage(getFrontSim(), message, dataType, data));
}

void initParticleMenu(kozoObject *mBarObj)
{

	kozoObject *particleMenu = nilPointer;
	kozoObject *newItem = nilPointer;
	
	kozoNew2DataPtrs(&particleMenu, ClassMenu, mBarObj, 
						pName, typeChar,  "Particle", 8L,
						pEnabled, typeFalse, nilPointer, 0L);  // disable as there is no sim at start
	
 	if (particleMenu) OHStoreUniqueReference(particleMenu, globalAppObject, mParticleMenu);
	
 	newItem =  kSanMenuItemAllocateWithThreeArgs(particleMenu, (ProcPtr) messageForFrontSim, kMakeParticleMessage, typeNull, nilPointer, "Make Particle");
 	OHStoreUniqueReference(newItem, globalAppObject, iEditParticleMenuItem);
	newItem =  kSanMenuItemAllocateWithThreeArgs(particleMenu, (ProcPtr) messageForFrontSim, kAtomInfoMessage, typeNull, nilPointer, "Atom Info");
	newItem =  kSanMenuItemAllocateWithThreeArgs(particleMenu, (ProcPtr) messageForFrontSim, kThermalizeMessage, typeNull, nilPointer, "Thermalize");
	newItem =  kSanMenuItemAllocateWithThreeArgs(particleMenu, (ProcPtr) messageForFrontSim, kSetToZeroMessage, typeNull, nilPointer, "Zero Velocities");
	newItem =  kSanMenuItemAllocateWithThreeArgs(particleMenu, (ProcPtr) messageForFrontSim, kCalcEMessage, typeNull, nilPointer, "Calculate Energy");

	OHMenuAddADivider(particleMenu);	

	newItem =  kSanMenuItemAllocateWithThreeArgs(particleMenu, (ProcPtr) messageForFrontSim, kGroupSelectedParticlesMessage, typeNull, nilPointer, "Group");
	newItem =  kSanMenuItemAllocateWithThreeArgs(particleMenu, (ProcPtr) messageForFrontSim, kResetGroupsMessage, typeNull, nilPointer, "Reset Groups");
	newItem =  kSanMenuItemAllocateWithThreeArgs(particleMenu, (ProcPtr) messageForFrontSim, kMergeGroupsMessage, typeNull, nilPointer, "Merge Groups");
				     
	
}

short kSanDCPlugInCallback (kozoClass *nthPlug,  kozoObject *dcSubmenu);
short kSanDCPlugInCallback (kozoClass *nthPlug,  kozoObject *dcSubmenu)
{
	short err = noErr;

	AEDesc nameDesc = {typeNull, nilPointer};
	long menuItemIndex;
	long numArgs = 1;
	ProcPtr theProc;
	kozoObject *newItem;

 	if  (nthPlug->classID  != ClassDataCollectionPlugIn)  // filters out the virtual class
	{
		OHStringGetAEDesc(nthPlug->obj->name, typeIntlText, &nameDesc);
		err = kozoNewOneDatum(&newItem, ClassMenuItem, dcSubmenu, pName, &nameDesc);
		if (!err)
		{
			dispatchCount(dcSubmenu, ClassMenuItem, &menuItemIndex);
			theProc = (ProcPtr)simNewDataCollectorChoice;
			if (newItem) err = kozoSetDataPtr (newItem, pProcPtr, typeProcPtr, &(theProc), sizeof(long));
			if (newItem) err = kozoSetDataPtr (newItem, pNumArgs, typeLongInteger, &numArgs, sizeof(long));
			if (newItem) err = kozoSetDataPtr (newItem, pArgument1, typeLongInteger, &menuItemIndex, sizeof(long));
		}
		AEDisposeDesc (&nameDesc);
	}
	return (err);
}


void initSimMenu(kozoObject *mBarObj)
{
 	kozoObject *dcSubmenu = nilPointer;
 	kozoObject *simMenu = nilPointer;
	kozoObject *newItem = nilPointer;
  	
	 kozoNew2DataPtrs(&simMenu, ClassMenu, mBarObj,  pName, typeChar, "kSan", 4L,
																pEnabled, typeFalse, nilPointer, 0L); // disable as there is no sim at start
	
 	if (simMenu) OHStoreUniqueReference(simMenu, globalAppObject, mSimulationMenu);
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kDoDialogMessage, typeNull, nilPointer, "Simulation...");
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kSimClockToggleMessage, typeNull, nilPointer, "Go")	;
 	OHStoreUniqueReference(newItem, globalAppObject, iGoMenuItem);

	OHMenuAddADivider(simMenu);	
	
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kPotentialDialog, typeNull, nilPointer, "Potential Parameters...")	;
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kResizeDialog, typeNull, nilPointer, "Resize Parameters...")	;
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kMethodDialog, typeNull, nilPointer, "Method Parameters...")	;
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kCutoffDialog, typeNull, nilPointer, "Cutoff Parameters...")	;
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kFrequenciesDialog, typeNull, nilPointer, "Frequencies...")	;
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kDataCollectionDialog, typeNull, nilPointer, "Data Collectors...");	
				     
	 kozoNewWithCName(&dcSubmenu, ClassSubmenu, simMenu, "New Data Collector");

	if (dcSubmenu)
	{
		OHList *plugList;
		plugList = getSubclassList (ClassDataCollectionPlugIn);
		if (plugList) OHListEveryItemDoOneArg( plugList, kSanDCPlugInCallback ,  dcSubmenu);
	}							

	OHMenuAddADivider(simMenu);
	
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kScaleCellDialog, typeNull, nilPointer, "Scale Cell");		
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kExpandCellDialog, typeNull, nilPointer, "Expand Cell")	;	
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kCellStressDialog, typeNull, nilPointer, "Cell Stress")	;		
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kCellSizeDialog, typeNull, nilPointer, "Cell Size")	;		
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kGroupInfoDialog, typeNull, nilPointer, "Group Info")	;		
	newItem =  kSanMenuItemAllocateWithThreeArgs(simMenu, (ProcPtr) messageForFrontSim, kSpawnWindow, typeNull, nilPointer, "Spawn Viewer")	;		
}
void resetIDsCallback(kSanSimulation *sim, particle *basePart, long partArrIndex, long dummy);
void resetIDsCallback(kSanSimulation *sim, particle *basePart, long partArrIndex, long dummy)
{
#pragma unused(dummy)
#pragma unused(sim)
	BPNthUniqueID(basePart, partArrIndex) = partArrIndex+1;	
}
short resetParticleIDs(kSanSimulation *sim)
{
	short err = noErr;
	
	kozoObjectMessageForContents(simOBJ(sim), ClasskSanPlugIn,  kSanSimResetIDsEvent, 0L,  0L);
	processEveryParticle (sim, (void (*)( kSanSimulation *, particle *, long , void * ))resetIDsCallback,  0L);

	sim->uniqueParticleCounter = simGetNumParts(sim);  // ids go from 1 to sim->numParts
	sim->flags.uniqueIDListDirty = true;
    ++sim->stateCount;
	return (err);
}
void stuffSortingListCallback(kSanSimulation *sim, particle *basePart, long partArrIndex, long sList);
void stuffSortingListCallback(kSanSimulation *sim, particle *basePart, long partArrIndex, long sList)
{
#pragma unused(sim)
	OHNamedList * sortList = (OHNamedList *)sList;
	long xCoord;
	xCoord = (long) (basePart->basePosition[partArrIndex].a  * 100.0); // its OK if its not exact sorting!
	addToNL (sortList, xCoord, partArrIndex); // data is xCoord , name is index
}
short reorderParticles(kSanSimulation *sim)
{ // sort on long axis
	short err = noErr;
	long partArrIndex;
	long numToAlloc = 0;
	long count = simGetNumParts(sim);
	long thisIndex;
	particle *basePart;
	Handle savedPartHandle = nilPointer;
	Handle savedPosHandle = nilPointer;
	Handle savedVelHandle = nilPointer;
	Handle savedForceHandle = nilPointer;
	Handle savedPotHandle = nilPointer;
	OHNamedList partsAndPositions;	// data is xCoord , name is index
	// strategy:  make OHNamedLists of index and position
	// use sortNLByData to sort, then rearrange

    
	initializeNL(&partsAndPositions);
	processEveryParticle (sim, (void (*)( kSanSimulation *, particle *, long , void * ))stuffSortingListCallback,  &partsAndPositions);
	sortNLByData(&partsAndPositions);
	// now the name fields of partsAndPositions contains the ideal order of the particles
	
    basePart = simLockParts(sim);
	for (partArrIndex = 0; partArrIndex < count; ++partArrIndex)
	{// deallocate all the neighbor data
		basePart->basePi[partArrIndex].extraNumNeighbors += basePart->basePi[partArrIndex].actualNumNeighbors;
		basePart->basePi[partArrIndex].actualNumNeighbors = 0;
 	}
 	
 	
	savedPartHandle = sim->particlesLCH.handle;	
	savedPosHandle = sim->positionLCH.handle;	
	savedVelHandle = sim->velocityLCH.handle;	
	savedForceHandle = sim->forceLCH.handle;	
	savedPotHandle = sim->potentialLCH.handle;
		
	err = HandToHand (&savedPartHandle); // copy the old data
	err = HandToHand (&savedPosHandle); // copy the old data
	err = HandToHand (&savedVelHandle); // copy the old data
	err = HandToHand (&savedForceHandle); // copy the old data
	err = HandToHand (&savedPotHandle); // copy the old data

	for (partArrIndex = 0; partArrIndex < count; ++partArrIndex)
	{
		// transfer all data from old handle to new handle
		 thisIndex = getNthNameNL(&partsAndPositions, partArrIndex);
		 
		 basePart->baseVelocity[partArrIndex] = ((kSanVector  *) (*savedVelHandle))[thisIndex];
		 basePart->basePosition[partArrIndex] = ((kSanVector  *) (*savedPosHandle))[thisIndex];
		 basePart->baseForce[partArrIndex] = ((kSanVector  *) (*savedForceHandle))[thisIndex];
		 basePart->basePotential[partArrIndex] = ((double *) (*savedPotHandle))[thisIndex];
		 basePart->basePi[partArrIndex]  = ((kSanParticle *) (*savedPartHandle))[thisIndex];
	}
	OHDisposeHandle(&savedPartHandle);
	OHDisposeHandle(&savedPosHandle);
	OHDisposeHandle(&savedVelHandle);
	OHDisposeHandle(&savedForceHandle);
	OHDisposeHandle(&savedPotHandle);

 	simReleaseParts(sim);
 	err =  calcNeighborsFromScratch(sim);

 	sim->flags.uniqueIDListDirty = true;
    ++sim->stateCount;
	disposeNL(&partsAndPositions);
 	return (err);
}

short simCallOnePartVirialCalc(kSanSimulation *sim, long partArrIndex, kSanMatrix *rMat)
{
 	short err;
	err = sim->potentialPlugIn->onePartVirialCalc (sim->potentialPlugIn , sim,   partArrIndex, rMat);
	return (err);
}
 
void	 kSanSimDoCommandPeriod	(kSanSimulation *sim)
{
    sim->flags.abortNow = true;
}

short	simDoProgressFunction (kSanSimulation *sim)
{	
 	 if ((!sim) || (!sim->flags.abortNow))
	{
 		yieldToThread(true);
 	}
	return (sim ? sim->flags.abortNow : noErr);
}

short 	 makeIterationThread   (kSanSimulation *sim)
{
	short threadErr = noErr;
	
	sim->flags.iterationInProgress = false;
	sim->flags.threadHasReturned = 0L;
	threadErr = NewThread(kCooperativeThread, 
		(ThreadEntryProcPtr)iterationThread, 
		(void *) sim, 32768, kCreateIfNeeded + kNewSuspend, 
				(void **)&sim->flags.threadHasReturned, &sim->iterationThreadID);
	SetThreadState(sim->iterationThreadID, kReadyThreadState, sim->iterationThreadID);
	if (threadErr) doAlert("\pProblem with Thread Manager.  Could be fatal.");
	return (threadErr);
}
void removeIterationThread (kSanSimulation *sim)
{
	long ticks ;
	ticks = TickCount() + 600;
	sim->flags.done = true;
	if (sim->iterationThreadID != kSanNoThread) 
	{
		while ((!sim->flags.threadHasReturned) && (ticks > TickCount() ))
		{
 			yieldToThread(kYieldNow);
 		}
	}
	if (!sim->flags.threadHasReturned)
	{
		DisposeThread(sim->iterationThreadID,(long) 0, false); // (don't recycle)
	}
	sim->iterationThreadID = kSanNoThread;
}

short kSanSimCleanUp (kSanSimulation *sim)
{  // called before SimDeallocate to check if 
  // deallocate is OK?
	short err = noErr;
	err = kozoObjectMessageForContents(simOBJ(sim),  ClassWindow,  kPrepareToCloseMessage, 0L,  0L);
	return (err);
}



short  resizeMemory(kSanSimulation *sim, long newPartNum)
{ // memory sizes dependent on num parts
	long newSize;
	long oldSize;
	short resizeErr = noErr;

	//resizeErr = linkArrayResize(sim, newPartNum);
	if (!resizeErr)	
	{		
		oldSize = GetHandleSize(sim->particlesLCH.handle);
		newSize =   sizeof(kSanParticle) * (newPartNum + 2);
		if (newSize > oldSize) 
		{
			resizeErr = LCHSetHandleSize(&sim->particlesLCH, newSize);
  		}
  		
		oldSize = GetHandleSize(sim->potentialLCH.handle);
		newSize =   sizeof(double) * (newPartNum + 2);
		if (newSize > oldSize) 
		{
			resizeErr = LCHSetHandleSize(&sim->potentialLCH, newSize);
  		}
  		
		oldSize = GetHandleSize(sim->velocityLCH.handle);
		newSize =   sizeof(kSanVector ) * (newPartNum + 2);
		if (newSize > oldSize) 
		{
			resizeErr = LCHSetHandleSize(&sim->velocityLCH, newSize);
  		}
  		
		oldSize = GetHandleSize(sim->positionLCH.handle);
		newSize =   sizeof(kSanVector ) * (newPartNum + 2);
		if (newSize > oldSize) 
		{
			resizeErr = LCHSetHandleSize(&sim->positionLCH, newSize);
  		}
  		
		oldSize = GetHandleSize(sim->forceLCH.handle);
		newSize =   sizeof(kSanVector ) * (newPartNum + 2);
		if (newSize > oldSize) 
		{
			resizeErr = LCHSetHandleSize(&sim->forceLCH, newSize);
  		}
	}
	return (resizeErr);
}


short  compressNeighborMemory(kSanSimulation *sim)
{
// now set the mem allocation		
	return (resetNeighborPtrs(sim,  4L));
}


short  scaleAxis (kSanSimulation *sim, long whichAxis, void *ratioData)
{
	short err = noErr;
	particle * basePart;
	long partArrIndex;
	kSanVector  uvwPos;
	kSanVector  scaleVec;
	double * ratio = ( double *) ratioData;

	waitForIterationToFinish(sim);
	basePart = simLockParts(sim);
	
	for (partArrIndex = 0; partArrIndex<simGetNumParts(sim);++partArrIndex)
	{
		XYZtoUVW(&sim->simCell, &basePart->basePosition[partArrIndex], &uvwPos);
		switch (whichAxis)
		{
			case pCellXLength:
				uvwPos.a *= *ratio;
				break;
			case pCellYLength:
				uvwPos.b *= *ratio;
				break;
#ifndef __2DVectors__
			case pCellZLength:
				uvwPos.c *= *ratio;
				break;
#endif
			case pCellXYZLength:
				uvwPos.a *= ratio[0];
				uvwPos.b *= ratio[1];
#ifndef __2DVectors__
				uvwPos.c *= ratio[2];
#endif
				break;
			case pCellXYZUniform:
				multkSanVectorD(&uvwPos, *ratio, &uvwPos);
				break;
		}
		UVWtoXYZ(&sim->simCell, &basePart->basePosition[partArrIndex], &uvwPos);
	}
	simReleaseParts(sim);
	scaleVec.a = 1;
	scaleVec.b = 1;
#ifndef __2DVectors__
	scaleVec.c = 1;
#endif
	switch (whichAxis)
	{
		case pCellXLength:
			scaleVec.a = *ratio;
			break;
		case pCellYLength:
			scaleVec.b = *ratio;
			break;
#ifndef __2DVectors__
		case pCellZLength:
			scaleVec.c = *ratio;
			break;
#endif
		case pCellXYZLength:
			scaleVec.a = ratio[0];
			scaleVec.b = ratio[1];
#ifndef __2DVectors__
			scaleVec.c = ratio[2];
#endif
			break;
		case pCellXYZUniform:
			multkSanVectorD (&scaleVec, *ratio, &scaleVec);
			break;
		default:
			err = errAEWrongDataType;
			break;
	}
	mVector(&sim->simCell, &scaleVec);
	setNewCellProperties(sim);
	calcNeighbors(sim);
	return (err);
}

void  setNewCellProperties(kSanSimulation *sim)
{
	calcFromPrimitives(&sim->simCell);
	setOrthorhombicTriclinicSwitch(sim);
} 

void  setOrthorhombicTriclinicSwitch(kSanSimulation *sim)
{
	if (isOrthorhombic(&sim->simCell))
	{
		sim->getSepVec = getSepVecOrthorhombic;
		sim->getSepSquared = getSepSquaredOrthorhombic;
	    sim->setBoxForPart = setBoxForPartOrthorhombic;
	    sim->determineBoxForPart = determineBoxForPartOrthorhombic;
	    sim->wrapAround = wrapAroundOrthorhombic;
	}
	else 
	{
		sim->getSepVec = getSepVecTriclinic;
		sim->getSepSquared = getSepSquaredTriclinic;
	    sim->setBoxForPart = setBoxForPartTriclinic;
	    sim->determineBoxForPart = determineBoxForPartTriclinic;
	    sim->wrapAround = wrapAroundTriclinic;
	}
}

double  getSepSquaredOrthorhombic (kSanSimulation *sim, particle *basePart, 
		long firstPartIndex,  long secondPartIndex,  char translationFlags, kSanVector * v) // return the sep vec too
{	
 	getSepVecOrthorhombic (sim, basePart, firstPartIndex, secondPartIndex, translationFlags, v); 	 
#ifndef __2DVectors__
 	return (v->a * v->a + v->b * v->b + v->c * v->c);
#else
 	return (v->a * v->a + v->b * v->b );
#endif
}
void  getSepVecOrthorhombic (kSanSimulation *sim, particle *basePart, 
		long firstPartIndex,  long secondPartIndex,  char translationFlags, kSanVector * sepVec)
{
 	double yValue;
	double xValue;
	double zValue;
#ifdef __2DVectors__
#pragma unused ( zValue)
   #endif	
  	
    xValue =  basePart->basePosition[secondPartIndex].a -  basePart->basePosition[firstPartIndex].a;
    yValue =  basePart->basePosition[secondPartIndex].b -  basePart->basePosition[firstPartIndex].b;
#ifndef __2DVectors__
    zValue =  basePart->basePosition[secondPartIndex].c -  basePart->basePosition[firstPartIndex].c;
#endif
    if (translationFlags)
    {
	    if (translationFlags & kSanTransChangeXDim)
	    {
	    	xValue += ((translationFlags & kSanTransAddXDimSign ) ? sim->simCell.cellDim.a : (-sim->simCell.cellDim.a));
	    }
	    if (translationFlags & kSanTransChangeYDim)
	    {
	    	yValue += ((translationFlags & kSanTransAddYDimSign ) ? sim->simCell.cellDim.b : (-sim->simCell.cellDim.b));
	     }
#ifndef __2DVectors__
	    if (translationFlags & kSanTransChangeZDim)
	    {
	    	zValue += ((translationFlags & kSanTransAddZDimSign ) ? sim->simCell.cellDim.c : (-sim->simCell.cellDim.c));
	    }
#endif
    }
	sepVec->a = xValue;
	sepVec->b = yValue;
#ifndef __2DVectors__
	sepVec->c = zValue;
#endif
}

short  wrapAroundOrthorhombic(kSanSimulation *sim)  
	// and fill in the box info
{
	short err = noErr;
	short maxx;
	short maxy;
	short maxz;	
#ifdef __2DVectors__
#pragma unused ( maxz)
#endif	

	long partArrIndex;	
	long boxIndex;	
 	box * boxes;

	kSanVector  partPos;
	kSanVector  inverseDim;
	kSanVector  cutoff;
  	
 	multkSanVectorD (&sim->simCell.cellDim, 0.5, &cutoff);
 	
  	maxx = sim->boxDim.a;
	maxy = sim->boxDim.b;
#ifndef __2DVectors__
	maxz = sim->boxDim.c;
#endif

	boxes = simLockBoxes(sim);
	for (boxIndex=0; boxIndex <= sim->howManyBoxes; ++boxIndex)  // bug here:  box zero is the hyperspace box
	{
 		boxes[boxIndex].boxPartList.howManyItems = 0;  // clear box contents
	}
	inverseDim.a = ((float)maxx) / (sim->simCell.cellDim.a + 0.01); // these small number give a little leeway
	inverseDim.b = ((float)maxy) / (sim->simCell.cellDim.b + 0.01);
#ifndef __2DVectors__
	inverseDim.c = ((float)maxz) / (sim->simCell.cellDim.c + 0.01);
#endif
	
/** lets wraparound particles that have moved outside the cell   **/
	if (simGetNumParts(sim) > 0)
	{
	    particle *basePart;
		char positionChanged;
  		char unusedChar;
#pragma unused(unusedChar)
 		short dummyLoop;
		basePart = simLockParts(sim);
		for (partArrIndex=0; partArrIndex < simGetNumParts(sim)  ; ++partArrIndex)						
		{	
			partPos = basePart->basePosition[partArrIndex];
			positionChanged = true;
			dummyLoop = 0;
			while ((positionChanged == true) && (dummyLoop < 5))
			{
				positionChanged = false;
				++ dummyLoop;
				if (partPos.a > cutoff.a)  
				{
					partPos.a -= sim->simCell.cellDim.a;
					positionChanged = true;
				}
				else if (partPos.a < (0.0 - cutoff.a))  
				{
					partPos.a += sim->simCell.cellDim.a;
					positionChanged = true;
				}
				if (partPos.b > cutoff.b)  
				{
					partPos.b -= sim->simCell.cellDim.b;
					positionChanged = true;
				}
				else if (partPos.b < (0.0 - cutoff.b))  
				{
					partPos.b += sim->simCell.cellDim.b;
					positionChanged = true;
				}
#ifndef __2DVectors__

				if (partPos.c > cutoff.c)  
				{
					partPos.c -= sim->simCell.cellDim.c;
					positionChanged = true;
				}
				else if (partPos.c < ( 0.0 - cutoff.c))  
				{
					partPos.c += sim->simCell.cellDim.c;
					positionChanged = true;
				}
#endif
			}
			if (dummyLoop < 5)
			{
			
				long whichBox;	
			
				long whichX;	
				long whichY;
				long whichZ;
#ifdef __2DVectors__
#pragma unused ( whichZ)
#endif	

				basePart->basePosition[partArrIndex] = partPos;

				whichX = trunc((partPos.a + cutoff.a) * inverseDim.a);
				whichY = trunc((partPos.b + cutoff.b) * inverseDim.b);
#ifndef __2DVectors__
				whichZ = trunc((partPos.c + cutoff.c) * inverseDim.c);
#endif
				if (whichX >= maxx) whichX = maxx-1;
				else if (whichX < 0) whichX = 0;
				if (whichY >= maxy) whichY = maxy-1;
				else if (whichY < 0) whichY = 0;
				
#ifndef __2DVectors__
				if (whichZ >= maxz) whichZ = maxz-1;
				else if (whichZ < 0) whichZ = 0;
				whichBox = maxz*maxy*whichX + maxz*whichY + whichZ + 1;
#else
				whichBox = maxy*whichX +  whichY +   1;
#endif
				
				addToList (&boxes[whichBox].boxPartList, partArrIndex);
				BPNthBoxIndex(basePart, partArrIndex) = whichBox;
				
			}
			else
			{
			    OHSystemBeep();
			}
		}	
		simReleaseParts(sim);
	}
	simReleaseBoxes(sim);
	return (err);
}

double	 getSepSquaredTriclinic(kSanSimulation *sim, particle *basePart, 
			long firstPartIndex,  long secondPartIndex,   char translationFlags, kSanVector * v)
{
 	getSepVecTriclinic (sim, basePart, firstPartIndex, secondPartIndex, translationFlags, v); 	 
#ifndef __2DVectors__
 	return (v->a * v->a + v->b * v->b + v->c * v->c);
 #else
 	return (v->a * v->a + v->b * v->b );
 #endif
}
void	 getSepVecTriclinic(kSanSimulation *sim, particle *basePart, 
			long firstPartIndex,  long secondPartIndex,   char translationFlags, kSanVector * sepVec)
{
 	double yValue;
	double xValue;
#ifndef __2DVectors__
	double zValue;
 	
    zValue =  basePart->basePosition[secondPartIndex].c -  basePart->basePosition[firstPartIndex].c;
#endif
     xValue =  basePart->basePosition[secondPartIndex].a -  basePart->basePosition[firstPartIndex].a;
    yValue =  basePart->basePosition[secondPartIndex].b -  basePart->basePosition[firstPartIndex].b;

    if (translationFlags & kSanTransChangeXDim)
    {
 	    if (translationFlags & kSanTransAddXDimSign )
		{
 			xValue +=  sim->simCell.primitiveVectors.A.a;
 		}
		else  
		{
			xValue -=  sim->simCell.primitiveVectors.A.a;
 		}
   }
    if (translationFlags & kSanTransChangeYDim)
    {
 	    if (translationFlags & kSanTransAddYDimSign )
		{
			yValue +=  sim->simCell.primitiveVectors.B.b;
			xValue +=  sim->simCell.primitiveVectors.B.a;
  		}
		else  
		{
			yValue -=  sim->simCell.primitiveVectors.B.b;
			xValue -=  sim->simCell.primitiveVectors.B.a;
  		}
   }
#ifndef __2DVectors__
    if (translationFlags & kSanTransChangeZDim)
    {
 	    if (translationFlags & kSanTransAddZDimSign )
		{
 			zValue +=  sim->simCell.primitiveVectors.C.c;
			yValue +=  sim->simCell.primitiveVectors.C.b;
			xValue +=  sim->simCell.primitiveVectors.C.a;
  		}
		else  
		{
			zValue -=  sim->simCell.primitiveVectors.C.c;
			yValue -=  sim->simCell.primitiveVectors.C.b;
			xValue -=  sim->simCell.primitiveVectors.C.a;
   		}
   } 
   
 	sepVec->c = zValue;
#endif
  	
 	sepVec->a = xValue;
 	sepVec->b = yValue;
 }
short  wrapAroundTriclinic(kSanSimulation *sim)  // and fill in the box info
{
	particle *basePart; 
	short maxx;
	short maxy;
	short maxz;
	short err;
	long partArrIndex;
	long whichBox;
	long whichX;
	long whichY;
	long whichZ;
	box * boxes;
	box * thisBox;
    double distFromCenterPlaneA;
    double distFromCenterPlaneB;
    double distFromCenterPlaneC;
    kSanVector  centerPlaneA;
    kSanVector  centerPlaneB;
    kSanVector  centerPlaneC;
     double XPlaneSep;
    double YPlaneSep;
    double ZPlaneSep;
    double XCut;
    double YCut;
    double ZCut;
    double mXCut;
    double mYCut;
    double mZCut;
 	double inverseBoxXDim;
	double inverseBoxYDim;
	double inverseBoxZDim;
#ifdef __2DVectors__
#pragma unused ( inverseBoxZDim)
#pragma unused ( mZCut)
#pragma unused ( ZCut)
#pragma unused ( ZPlaneSep)
#pragma unused ( centerPlaneC)
#pragma unused ( distFromCenterPlaneC)
#pragma unused ( whichZ)
#pragma unused ( maxz)
  #endif	
	
	err = 0;
	basePart = simLockParts(sim);
	boxes = simLockBoxes(sim);
	maxx = sim->boxDim.a;
	maxy = sim->boxDim.b;
#ifndef __2DVectors__
	maxz = sim->boxDim.c;
#endif
	for (whichBox=1; whichBox <= sim->howManyBoxes ; ++whichBox)
	{
		thisBox = &boxes[whichBox];
		thisBox->boxPartList.howManyItems = 0;  // clear box contents
	}
	
	multkSanVectorD(&sim->simCell.reciprocalVectors.A, 0.5, &centerPlaneA);
	multkSanVectorD(&sim->simCell.reciprocalVectors.B, 0.5, &centerPlaneB);
#ifndef __2DVectors__
	multkSanVectorD(&sim->simCell.reciprocalVectors.C, 0.5, &centerPlaneC);
#endif

    XPlaneSep = 1 / sim->simCell.reciprocalCellEdges.a;
    YPlaneSep = 1 / sim->simCell.reciprocalCellEdges.b;
#ifndef __2DVectors__
    ZPlaneSep = 1 / sim->simCell.reciprocalCellEdges.c;
#endif
    
    inverseBoxXDim = maxx / (XPlaneSep + 0.01); // these small number give a little leeway
	inverseBoxYDim = maxy / (YPlaneSep + 0.01);
#ifndef __2DVectors__
	inverseBoxZDim = maxz / (ZPlaneSep + 0.01);
#endif

    XCut = XPlaneSep * 0.500000000;
    YCut = YPlaneSep * 0.500000000;
    mXCut = -XCut;
    mYCut = -YCut;
#ifndef __2DVectors__
    ZCut = ZPlaneSep * 0.500000000;
    mZCut = -ZCut;
#endif
    
	for (partArrIndex=0;partArrIndex< simGetNumParts(sim) ;++partArrIndex)
	{	
 		
    	distFromCenterPlaneA = distFromkSanPlaneThroughOriginD(&basePart->basePosition[partArrIndex], &centerPlaneA);
    	if (distFromCenterPlaneA > XCut)
    	{
    		while (distFromCenterPlaneA > XCut)
    		{
    	    	subkSanVectorsD(&basePart->basePosition[partArrIndex], &sim->simCell.primitiveVectors.A, &basePart->basePosition[partArrIndex]); 
    	    	distFromCenterPlaneA = distFromkSanPlaneThroughOriginD(&basePart->basePosition[partArrIndex], &centerPlaneA); 
    	    }  	    
    	}
    	else if (distFromCenterPlaneA < mXCut)
    	{
    		while (distFromCenterPlaneA < mXCut)
    		{
    	    	addkSanVectorsD(&basePart->basePosition[partArrIndex], &sim->simCell.primitiveVectors.A, &basePart->basePosition[partArrIndex]); 
    	    	distFromCenterPlaneA = distFromkSanPlaneThroughOriginD(&basePart->basePosition[partArrIndex], &centerPlaneA); 
    	    }  	    
    	}
    	// use dist to put in box!
	
    	distFromCenterPlaneB = distFromkSanPlaneThroughOriginD(&basePart->basePosition[partArrIndex] , &centerPlaneB);
    	if (distFromCenterPlaneB > YCut)
    	{
    		while (distFromCenterPlaneB > YCut)
    		{
    	    	subkSanVectorsD(&basePart->basePosition[partArrIndex], &sim->simCell.primitiveVectors.B, &basePart->basePosition[partArrIndex]); 
    	    	distFromCenterPlaneB = distFromkSanPlaneThroughOriginD(&basePart->basePosition[partArrIndex], &centerPlaneB); 
    	    }  	    
    	}
    	else if (distFromCenterPlaneB < mYCut)
    	{
    		while (distFromCenterPlaneB < mYCut)
    		{
    	    	addkSanVectorsD(&basePart->basePosition[partArrIndex], &sim->simCell.primitiveVectors.B, &basePart->basePosition[partArrIndex]); 
    	    	distFromCenterPlaneB = distFromkSanPlaneThroughOriginD(&basePart->basePosition[partArrIndex], &centerPlaneB); 
    	    }  	    
    	}
	
#ifndef __2DVectors__
    	distFromCenterPlaneC = distFromkSanPlaneThroughOriginD(&basePart->basePosition[partArrIndex], &centerPlaneC);
    	if (distFromCenterPlaneC > ZCut)
    	{
    		while (distFromCenterPlaneC > ZCut)
    		{
    	    	subkSanVectorsD(&basePart->basePosition[partArrIndex], &sim->simCell.primitiveVectors.C, &basePart->basePosition[partArrIndex]); 
    	    	distFromCenterPlaneC = distFromkSanPlaneThroughOriginD(&basePart->basePosition[partArrIndex], &centerPlaneC); 
    	    }  	    
    	}
    	else if (distFromCenterPlaneC < mZCut)
    	{
    		while (distFromCenterPlaneC < mZCut)
    		{
    	    	addkSanVectorsD(&basePart->basePosition[partArrIndex], &sim->simCell.primitiveVectors.C, &basePart->basePosition[partArrIndex]); 
    	    	distFromCenterPlaneC = distFromkSanPlaneThroughOriginD(&basePart->basePosition[partArrIndex], &centerPlaneC); 
    	    }  	    
    	}
#endif
		
		whichX = trunc((distFromCenterPlaneA + XCut) * inverseBoxXDim);
		whichY = trunc((distFromCenterPlaneB + YCut) * inverseBoxYDim);
#ifndef __2DVectors__
		whichZ = trunc((distFromCenterPlaneC + ZCut) * inverseBoxZDim);
		whichBox = maxz*maxy*whichX + maxz*whichY + whichZ + 1;
#else
		whichBox =  maxy*whichX +  whichY  + 1;
#endif
 		thisBox = &boxes[whichBox];
		
		addToList (&thisBox->boxPartList, partArrIndex);
		BPNthBoxIndex(basePart, partArrIndex) = whichBox;
	}	
	simReleaseParts(sim);
	simReleaseBoxes(sim);

	return (err);
}


void  scaleAngles (kSanSimulation *sim,double alpha, double beta, double gamma)
{
	particle * basePart;
 	long partArrIndex;

	waitForIterationToFinish(sim);
	basePart = simLockParts(sim);
	
	for (partArrIndex = 0; partArrIndex<simGetNumParts(sim);++partArrIndex)
	{
 		XYZtoUVW (&sim->simCell, &basePart->basePosition[partArrIndex], &basePart->basePosition[partArrIndex]);
	}
	sim->simCell.alpha = alpha;
	sim->simCell.beta = beta;
	sim->simCell.gamma = gamma;
	setNewCellProperties(sim);
	
	for (partArrIndex = 0; partArrIndex< simGetNumParts(sim);++partArrIndex)
	{
		UVWtoXYZ (&sim->simCell, &basePart->basePosition[partArrIndex], &basePart->basePosition[partArrIndex]);
	}
	simReleaseParts(sim);
}

void  simSetCursorState(kSanSimulation *sim)
{
#pragma unused(sim)
//	short cursVal;
//	if (sim->flags.error) handleSimError(OHOb(sim));
//	if (sim->flags.error) cursVal = kErrorCursor ;
//	else cursVal = kArrowCursor;
//	appSetCursor (cursVal);
}				
 
