
#include <Sound.h>
#include "kSanApplication.h"
#include "printFuncs.h"

#define kDontScaleOutput    nilPointer
#define kEmptyString    "\p"
#define nilPointer    0L

THPrint   PrintInit(void)
{
	THPrint printRecordH;
	
	printRecordH = nilPointer;
	printRecordH = (THPrint) NewHandle(sizeof(TPrint));  // error june 6 didn't throw away this handle
	if (printRecordH == nilPointer)
	{
		doAlert("\pCan't print for some reason");
	}
	else
	{
		PrOpen();
		PrintDefault(printRecordH);
	}
	return (printRecordH);
}


void      PrintPicture(PicHandle picture , THPrint printRecordH, Rect *picRect)
{
	GrafPtr savePort;
	TPPrPort printPort;
	TPPrStatus printStatus;
	
	GetPort(&savePort);
	printStatus = (TPPrStatus)NewPtr(sizeof(TPrStatus));
	printPort = (TPPrPort)NewPtr(sizeof(TPrPort));
	printPort = PrOpenDoc(printRecordH, printPort, nil);
	SetPort (&printPort->gPort);
	PrOpenPage(printPort, kDontScaleOutput);
	if (PrError() != noErr)
	{
		OHSystemBeep();
	}
	else
	{
 		DrawPicture(picture, picRect);
	}
	PrClosePage(printPort);
	PrCloseDoc(printPort);
	if (( (**printRecordH).prJob.bJDocLoop == bSpoolLoop) && (!(PrError())))
	{ 
		PrPicFile(printRecordH, nil, nil, nil, printStatus);
	}
	PrClose();
	SetPort (savePort);
	DisposePtr((Ptr) printPort);
	DisposePtr((Ptr) printStatus);
}

 
short    DoPrintDialogs( THPrint printRecordH)
{
	short confirmed = true;
	
	confirmed = PrStlDialog(printRecordH);
	if (confirmed) confirmed = PrJobDialog(printRecordH);
	return (confirmed);
}

