/************************************************************************

DebuggerWindow.h

This file is furnished to you by Adobe Systems Incorporated 
under the terms of the Acrobat(r) Plug-ins Software 
Development Kit License Agreement.


A catalog of all the functions exported by the DebuggerWindow plug-in.

****************************************************************************/

#ifndef _H_DebuggerWindow
#define _H_DebuggerWindow

#include "ASExpT.h"
#include "AVExpT.h"

enum
{
	DebuggerWindowBAD_SELECTOR,
	ShowDebuggerWindowSEL,
	HideDebuggerWindowSEL,
	DebuggerEmitStringSEL,
	GetDebuggerWindowSEL,
	DebuggerWindowFlushSEL,
	DebuggerWindowNUMSELECTORSPlusOne
};

extern HFT gDebuggerWindowHFT;

#define DebuggerWindowNUMSELECTORS (DebuggerWindowNUMSELECTORSPlusOne - 1)

/* ShowDebuggerWindow
** Shows the debugger window.
*/
typedef ACCBPROTO1 void (ACCBPROTO2 *ShowDebuggerWindowSELPROTO)(void);
#define ShowDebuggerWindow (*((ShowDebuggerWindowSELPROTO)(gDebuggerWindowHFT[ShowDebuggerWindowSEL])))

/* HideDebuggerWindow
** Hides the debugger window
*/
typedef ACCBPROTO1 void (ACCBPROTO2 *HideDebuggerWindowSELPROTO)(void);
#define HideDebuggerWindow (*((HideDebuggerWindowSELPROTO)(gDebuggerWindowHFT[HideDebuggerWindowSEL])))

/* DebuggerEmitString
** Emits a C string to the debugger window.  Carriage returns must be explicit in msg.
*/
typedef ACCBPROTO1 void (ACCBPROTO2 *DebuggerEmitStringSELPROTO)(const char *msg);
#define DebuggerEmitString (*((DebuggerEmitStringSELPROTO)(gDebuggerWindowHFT[DebuggerEmitStringSEL])))

/* GetDebuggerWindow
** Gets the Debugger Window's AVWindow object.
*/
typedef ACCBPROTO1 AVWindow (ACCBPROTO2 *GetDebuggerWindowSELPROTO)(void);
#define GetDebuggerWindow (*((GetDebuggerWindowSELPROTO)(gDebuggerWindowHFT[GetDebuggerWindowSEL])))

/* DebuggerWindowFlush
** Empties the contents of the Debugger Window
*/
typedef ACCBPROTO1 void (ACCBPROTO2 *DebuggerWindowFlushSELPROTO)(void);
#define DebuggerWindowFlush (*((DebuggerWindowFlushSELPROTO)(gDebuggerWindowHFT[DebuggerWindowFlushSEL])))

#endif
