/******************************************************************************

StampPr.h

This file is furnished to you by Adobe Systems Incorporated 
under the terms of the Acrobat(r) Plug-ins Software 
Development Kit License Agreement.

Copyright (C) 1994-1997, Adobe Systems Inc.  All Rights Reserved.


Interface to private ImageSelector UI-related functions.
Most of these only need to appear in a .h because their
implementation is platform-specific.

******************************************************************************/

#ifndef _H_StampPr
#define _H_StampPr

#include "AVExpT.h"

/* GetStamperCursor
** Returns the AVCursor for the Stamper tool
*/
AVCursor GetStamperCursor(void);

/* GetStamperToolButton
** Returns the icon for the Stamper tool button
*/
void *GetStamperToolButtonIcon(void);

/* GetStamperMenuItemIcon
** Returns the icon for the Stamper menu item
*/
void *GetStamperMenuItemIcon(void);

/* DrawKnobs
** Draws the knobs around a Stamp in the given page view in the given
** AVRect.
*/
void DrawKnobs(AVPageView pageView, const AVRect *avRect);

/* EraseKnobs
** Generates update events for the knobs around a Stamp in the given page
** view in the given AVRect.
*/
void EraseKnobs(AVPageView pageView, const AVRect *avRect);

/* StampSound
** Makes the Stamp sound.
*/
void StampSound(void);

#endif /* !_H_ISPriv */
