#define IGNORE_STDIO_STUBS
#define __string_h


#include <PalmOS.h>
#include <PalmCompatibility.h>
#include <Unix/sys_types.h>
#include <INetMgr.h>
#include <CTP.h>


#include "stringil.h"
#include "stdio2.h"


int GetURL(char *host)
{
  FILE *fd;
  UInt16 INRef, CfIn;

  VoidHand inh, sock;
  Err err;
  unsigned long len, lact;
  UInt32 set;
  char *buf, *fnp;

  /* bypass until URL */
  while( *host && strncmp(host, "http://", 7) )
    host++;

  if( !*host )
    return 2;

  WinDrawChars(host,strlen(host), 0,0);

  err = SysLibFind("INet.lib", &INRef);

  INetLibConfigIndexFromName(INRef, inetCfgNameCTPDefault, &CfIn);

  err = INetLibOpen(INRef, CfIn, 0, 0, 0, &inh);
  set = 64000;
  err |= INetLibSettingSet(INRef, inh, inetSettingMaxRspSize, &set, 4);
  set = ctpConvNone;
  err |= INetLibSettingSet(INRef, inh, inetSettingConvAlgorithm, &set, 4);
  err |= INetLibURLOpen(INRef, inh, host, NULL, &sock, 2000, 0);

  if (err) {
    INetLibClose(INRef, inh);
    return 1;
  }

  WinDrawChars("Open      ", 10, 0, 15);

  fnp = host;
  if( strlen(host) > 30 )
    fnp += strlen(host) - 30;

  fd = FileOpen(0, fnp, 'DATA', 'BRWS', fileModeReadWrite, NULL);

  len = 0;
  buf = MemPtrNew(2050);
  for (;;) {

    WinDrawChars("get  ", 5, 0, 15);

    err = INetLibSockRead(INRef, sock, buf, 2048, &lact, 3000);

    if (!lact)
      break;

    if (err) {
      StrIToH(buf, len);
      strcat(buf, "    ");
      WinDrawChars(buf, strlen(buf), 60, 0);
      SysTaskDelay(300);
      break;
    }

    len += lact;

    WinDrawChars("More      ", 10, 0, 15);
    if (lact != fwrite(buf, 1, lact, fd)) {
      WinDrawChars("WERR      ", 10, 0, 15);
      fclose(fd);
      unlink(fnp);
      INetLibClose(INRef, inh);
      MemPtrFree(buf);
      SysTaskDelay(200);
      return 3;
    }

    StrIToA(buf, len);
    strcat(buf, "    ");
    WinDrawChars(buf, strlen(buf), 0, 30);
  }

  MemPtrFree(buf);
  INetLibClose(INRef, inh);
  fclose(fd);

  if (!len) {
    unlink(fnp);
    return 1;
  }

  return 0;
}

#if 1

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
  LocalID lid;

  if( !cmdPBP || !strlen(cmdPBP) )
    return 0;

  if( cmd != sysAppLaunchCmdURLParams && cmd != sysAppLaunchCmdNormalLaunch )
    return 0;

  // normal launch for palm:, URLP for palmcall:

  if( GetURL(cmdPBP) )
    return 1;

#if 0
  lid = DmFindDatabase(0, "Boxer");
  SysUIAppSwitch(0, lid, sysAppLaunchCmdNormalLaunch, NULL);
#endif 
  return 0;
}

#endif
