
#include "DriverInstall.h"

typedef long (*MyProcPtr)(short funcNo, void *par);

enum {
	uppMyProcInfo = kThinkCStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(long)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(short)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(void*)))
};

#if USESROUTINEDESCRIPTORS
	#define CallMyProc(userRoutine, funcNo, par)		\
			CallUniversalProc((UniversalProcPtr)(userRoutine), uppMyProcInfo, (funcNo), (par))
#else
	#define CallMyProc(userRoutine, funcNo, par)		\
			(*(userRoutine))((funcNo), (par))
#endif


static	Handle		theCode = nil;
static	MyProcPtr	theMainProc;

static long callDiskDriver (short funcNo, void *par)
{
	return CallMyProc (theMainProc, funcNo, par);
}

OSErr InstallDriver ()
{
	{
		// attn: rsrc must have "system heap" rsrc bit set!
		theCode = Get1NamedResource ('CODE', "\pDisk Driver");
		if (!theCode) return ResError ();
		DetachResource (theCode);
		HLock (theCode);
		theMainProc = (MyProcPtr)*theCode;
	}
	return callDiskDriver (0, nil);
}

OSErr DeinstallDriver (Boolean deleteFiles)
{
	OSErr err = callDiskDriver (1, &deleteFiles);
	if (!err && theCode && *theCode) {
		DisposeHandle (theCode);
	}
	return err;
}

OSErr InstallADrive (Boolean createNew, FSSpec *spec, DriveCreationDesc *creationParms, short &drvNum)
{
	OSErr res;
	InstallADrivePar r = {createNew, spec, creationParms, drvNum};
	res = callDiskDriver (2, &r);
	drvNum = r.drvNum;
	return res;
}

void MountAllDrives (void)
{
	callDiskDriver (3, nil);
}

void RemoveADrive (short &drvNum)
{
	callDiskDriver (4, &drvNum);
}

DriveGlobalsPtr GetDriveGlobalsPtr (short drvNum)
{
	return (DriveGlobalsPtr)callDiskDriver (5, &drvNum);
}

// EOF
