
#include <SIOUX.h>
#include <stdio.h>
#include "DriverInstall.h"

static short gDrvNum;

static UniversalProcPtr gOldHandler;

static void cleanup ()
{
	if (gOldHandler) {
		SetToolTrapAddress ((UniversalProcPtr)gOldHandler, _ExitToShell);
		gOldHandler = nil;
	}

	RemoveADrive (gDrvNum);
	DeinstallDriver (false);
}

static pascal void CleanupAndExit (void)
{
	cleanup ();
	ExitToShell ();
}

static void InitQuit ()
{
	if (gOldHandler == nil) {
		gOldHandler = NGetTrapAddress (_ExitToShell, 1);
		SetToolTrapAddress (NewRoutineDescriptor ((ProcPtr)CleanupAndExit, kPascalStackBased, GetCurrentISA()), _ExitToShell);
	}
}

void main ()
{
	OSErr err;
	DriveCreationDesc creationParms;
	short gDrvNum = 0;
	
	SIOUXSettings.autocloseonquit = false;
	SIOUXSettings.asktosaveonclose = false;

	creationParms.volumeSize = 1024;
	err = InstallDriver ();
	if (err == 1) {
		printf ("driver already installed.\n");
		err = 0;
	} else if (err) {
		printf ("Error: InstallDriver() failed with err %d.\n", err);
		return;
	}

	err = InstallADrive (false, nil, &creationParms, gDrvNum);
	if (err) {
		printf ("Error: InstallADrive() failed!\n");
		return;
	}

	printf ("Drive %d installed.\n", gDrvNum);

#if 1
	{
		VolumeParam pb;
		pb.ioVRefNum = gDrvNum;
		err = PBMountVol ((ParmBlkPtr)&pb);
		printf ("PBMountVol err: %d\n", err);
	}
#else
	InitQuit ();
#endif
}

// EOF
