/*
 * Globals.h
 */

#pragma once

#pragma options align=mac68k

typedef unsigned long	ulong;
typedef unsigned short	word;

typedef struct DriveGlobals *DriveGlobalsPtr;

typedef void (*GetBlkProc) (DriveGlobalsPtr globe, long blk, Ptr &blkAddr, long &virtOffset, long &size);

// Drive globals structure
typedef struct DriveGlobals {
	struct {
		ulong	dQFlags;
		DrvQEl	dQEl;
		word	dQFiller;	// don't remove!
	} dQAll;
	long		totalSize;	// in 512 byte blks
	struct {
		long		data[kLargeIconSize/4];	// IMPORTANT: icon-data and locationStr must be
		Str255		locationStr;			// end-to-end in memory!
	} physIcon;
	long		mediaIcon[kLargeIconSize/4];
	short		fRefNum;
	short		vRefNum;
	short		drvNum;
	short		drvrRef;
} DriveGlobals;

#define MyDriverMask	(dNeedTimeMask+dStatEnableMask+dCtlEnableMask+dWritEnableMask+dReadEnableMask)
#define	MyDriverDelay	10	/* in 1/60s units */

extern	short MyDriverRefNum;
extern	Handle MyDriverHandle;

#pragma options align=reset

// EOF
