/*
 * Block Read.h
 */

#pragma once

//#include "Basic Types.h"
//#include "UDF.h"

typedef long PhysBlk;
typedef long LogBlk;
typedef long BlkCnt;

#define		BLOCK_SIZE	2048L

typedef OSErr (*PhysReadBlockProc) (PhysBlk start, BlkCnt blks, Ptr buffer);

void FlushSectorBuffers (void);

typedef enum {
	directorySector,
	volInfoSector,
	pathTableSector,
	fileDataSector
} SectorTypes;

//OSErr ReadPhysBlock (short vRefNum, PhysBlk blockNumber, void* blockBuf, Boolean temporary);

OSErr GetDirSector (long sectorNumber, void* &sectorAddress, Boolean temporary);
OSErr ReleaseDirSector (void* blockAddress);

OSErr DeviceRead (short drive, short refnum, long start, long bytes, Ptr buffer, short cacheOptions);
/*
 * Liest nur Vielfaches von 512 Bytes!
 *
 * cacheOptions:
 *   noCacheMask  (don't store blocks into cache),
 *   rdVerifyMask (force read from disk, not from cache).
 */

Boolean GetSectorBuffer (Ptr &p);
void ReleaseSectorBuffer (Ptr p);
// holds a 2KB static buffer

short FreeSectorBuffers ();

void InitBlockRead ();

// EOF
