/*
 * FSM Client Msgs.h
 */

#pragma once

enum {
	kSampleFSID = 'FS',
	kSampleFSMsgEnquireStatus = 'enqM',	// msgSize = 18
	kSampleFSMsgEnable = 'setM',		// msgSize = 18
	kSampleFSMsgGetVers = 'enqV',		// msgSize = 20
	kSampleFSMsgSetDrive = 'driv',		// msgSize = 18
	kSampleFSMsgUninstall = 'quit',		// msgSize = 16
	kSampleFSMsgPassFSDataPtr = 'priv'	// msgSize = 20
};

#pragma options align = mac68k

	struct tSampleFSMessage {
		UInt16	msgSize;	// length of the used fields of the message structure (always >= 16)
		SInt16	version;	// 1
		UInt32	senderID;	// usually the creator signature of the app sending this message
		UInt32	senderVer;	// version of sender (for identification of sender by the FS)
		UInt32	message;	// the message
		union {
			SInt16	enable;
			long	ffsVersion;
			SInt16	driveNum;
			Ptr		ptr;
		};
	};

#pragma options align = reset
