/*
 * main init of ISO 9660 / Joliet File System
 */

#include <string.h>
#include <stddef.h>

#include "PascalLib.h"
#include "ShowInitIcon.h"
#include "FSM Main.h"


#define	SuccessIconID	1312
#define	FailureIconID	1313

static Boolean VolMountedByFS (short fsID)
// checks if any volumes are mounted by the given File System
{
	HVolumeParam pb;
	short err, idx = 1;
	Str63 name;
	do {
		pb.ioVolIndex = idx++;
		pb.ioNamePtr = name;
		err = PBHGetVInfoSync ((HParamBlockRec*)&pb);
		if (err) break;
		if (pb.ioVFSID == fsID) {
			return true;
		}
	} while (true);
	return false;
}

static void error (short /*errCode*/, StringPtr msg_)
{
	// set up a notification record.
	static NMRec	myNotification;
	myNotification.qType = nmType;
	myNotification.nmMark = 0;
	myNotification.nmIcon = nil;
	myNotification.nmSound = (Handle)-1;	// play system sound
	myNotification.nmStr = msg_;			// display alert box
	myNotification.nmResp = nil;			// no response procedure
	myNotification.nmRefCon = 0;			// not needed
	NMInstall (&myNotification);
	ShowInitIcon (FailureIconID, true);
}

static Str255 msg;

void main (void)
{
	Handle h = Get1Resource ('INIT', 0);
	DetachResource (h);

	OSErr	err;

	// show our success Icon
	ShowInitIcon (SuccessIconID, false);

	if (!FSMClientInstall (&err, msg, false)) {
		error (err, msg);
		return;
	}

	// show our success Icon again, advance this time
	ShowInitIcon (SuccessIconID, true);
}

// EOF
