/*
 * FS Utils.h
 */

#pragma once

#include <FSM.h>
#include "FS API.h"

#pragma push
#pragma cplusplus on

short HasRequiredFSM (unsigned long *fsmVersion);


/*
 * Icons
 */

typedef struct {
	Handle	large1BitIcon;
	Handle	large4BitIcon;
	Handle	large8BitIcon;
	Handle	small1BitIcon;
	Handle	small4BitIcon;
	Handle	small8BitIcon;
	//	Handle	all32BitIcon;
} IconSet;

OSErr LoadIcons ();
void UnloadIcons ();
OSErr DoGetIcon (FSMGetIconRec *icon);


/*
 * file name parsing
 */

typedef struct {
	long	dirID;				// the directory ID
	Str31	fileName;			// the file name if it's not a directory
	Boolean	isDir;				// TRUE if the object is a directory
} ObjectInfoRec, *ObjectInfoRecPtr;

OSErr GetCurrentDir (ParmBlkPtr pb, ItemID dirID, ItemID *currentDirectory, short *status);
OSErr ParsePathName (ItemID currentDirectory, StringPtr namePtr, ObjectInfoRecPtr objectInfo);

// imported:
OSErr FFSGetDir (StringPtr dirName, ItemID parID, ItemID &destDirID);
OSErr FFSGetParent (ItemID dirID, ItemID &parID);


Boolean EnterVCB (short vRefNum, VCBPtr *vcbOut, OSErr *err);
void ExitVCB ();



// Constants for use in the DrvFlags fields.

enum {
	kDrvQElLockedMask = 0x0080,
	kDrvQElNoDiskPresent = 0,
	kDrvQElEjectableDiskPresent = 1,
	kDrvQElNonEjectableDiskPresent = 8,
	kDrvQElNonEjectableDiskPresentButDriverWantsCall = 0x048,
	kDrvQElSingleSidedMask = 0x0080
};

#pragma options align=mac68k

	// The DrvFlags structure mirrors the four bytes of flags in front
	// of each Drive Queue element.

	typedef struct {
		UInt8 dQFlagLocked;
		UInt8 dQFlagDiskInPlace;
		UInt8 dQFlagReserved;
		UInt8 qQFlagSingleSided;
	} DrvFlags, *DrvFlagsPtr;

#pragma options align=reset


Boolean IsVolumeEjected (VCBPtr theVCB);
DrvFlagsPtr FlagsForDrv (DrvQElPtr drvQEl);
Boolean DriveIsEjectable (DrvQElPtr drvQEl);
Boolean IsVolumeOffline (VCBPtr theVCB);

#pragma pop

// EOF
