
#pragma once

#pragma push
#pragma cplusplus on

#include "FSM.h"

// global vars

extern	VCBPtr	CurrVCB;

// Internal setup functions:

void Entering (VCBPtr vcb);
void Exiting (void);

// FSM support functions:

OSErr DoLg2Phys (VCBPtr theVCB, FCBRecPtr theFCB, 
				short fileRefNum, unsigned long filePosition, unsigned long reqCount,
				unsigned long *volOffset, long *contiguousBytes);
OSErr DoIDDisk (Ptr diskBlock);
OSErr DoIDVolMount (VolumeMountInfoHeader *volMountInfo);

// Mac OS functions:

OSErr DoOpen (Boolean highLevel, void *paramBlock);
OSErr DoClose (Boolean highLevel, void *paramBlock);
OSErr DoRead (Boolean highLevel, void *paramBlock);
OSErr DoGetVolInfo (Boolean highLevel, void *paramBlock);
OSErr DoOpenRF (Boolean highLevel, void *paramBlock);
OSErr DoGetFInfo (Boolean highLevel, void *paramBlock);
OSErr DoUnmountVol (Boolean highLevel, void *paramBlock);
OSErr DoMountVol (Boolean highLevel, void *paramBlock);
OSErr DoGetEOF (Boolean highLevel, void *paramBlock);
OSErr DoEject (Boolean highLevel, void *paramBlock);
OSErr DoGetFPos (Boolean highLevel, void *paramBlock);
OSErr DoOffline (Boolean highLevel, void *paramBlock);
OSErr DoSetFPos (Boolean highLevel, void *paramBlock);

OSErr DoOpenWD (Boolean highLevel, void *paramBlock);
OSErr DoCloseWD (Boolean highLevel, void *paramBlock);
OSErr DoGetWDInfo (Boolean highLevel, void *paramBlock);
OSErr DoGetFCBInfo (Boolean highLevel, void *paramBlock);
OSErr DoGetCatInfo (Boolean highLevel, void *paramBlock);

OSErr DoGetVolParms (Boolean highLevel, void *paramBlock);
OSErr DoResolveFileIDRef (Boolean highLevel, void *paramBlock);
OSErr DoCreateFileIDRef (Boolean highLevel, void *paramBlock);
OSErr DoDeleteFileIDRef (Boolean highLevel, void *paramBlock);
OSErr DoMakeFSSpec (Boolean highLevel, void *paramBlock);
OSErr DoSetVol (Boolean highLevel, void *paramBlock);

OSErr DoDTGetPath (Boolean highLevel, void *paramBlock);
OSErr DoDTCloseDown (Boolean highLevel, void *paramBlock);
OSErr DoDTGetInfo (Boolean highLevel, void *paramBlock);
OSErr DoDTGetIcon (Boolean highLevel, void *paramBlock);
OSErr DoDTGetAPPL (Boolean highLevel, void *paramBlock);
OSErr DoDTGetIconInfo (Boolean highLevel, void *paramBlock);
OSErr DoDTGetComment (Boolean highLevel, void *paramBlock);

OSErr DoCatSearch (Boolean highLevel, void *paramBlock);

#pragma pop

// EOF
