unit InternetConfig;

(* Start Header *)

(* File:         InternetConfig.p
 * Generated by: 1.0d6
 * For:          IC 2.0
 * On:           Wednesday, 24 December 1997, 8:29:16
 * 
 * This file is part of the Internet Configuration system and
 * is placed in the public domain for the benefit of all.
 *)

(* End Header *)

interface

{$ifc undefined THINK_Pascal}
	uses
		Types,
		Files, 
		QuickDraw, 
		AppleTalk, 
		Aliases, 
		Components;
{$endc}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

	const
		icPrefNotFoundErr = -666;			(* preference not found (duh!) *)
		icPermErr = -667;					(* cannot set preference *)
		icPrefDataErr = -668;				(* problem with preference data *)
		icInternalErr = -669;				(* hmm, this is not good *)
		icTruncatedErr = -670;				(* more data was present than was returned *)
		icNoMoreWritersErr = -671;			(* you cannot begin a write session because someone else is already doing it *)
		icNothingToOverrideErr = -672;		(* no component for the override component to capture *)
		icNoURLErr = -673;					(* no URL found *)
		icConfigNotFoundErr = -674;			(* no configuration was found *)
		icConfigInappropriateErr = -675;	(* incorrect manufacturer code *)
		icProfileNotFoundErr = -676;		(* profile not found *)
		icTooManyProfilesErr = -677;		(* too many profiles in database  *)

	const
		ICattr_no_change = -1;				(* supply this to ICSetPref to tell it not to change the attributes *)

		ICattr_locked_bit = 0;				(* bits in the preference attributes *)
		ICattr_locked_mask = $00000001;		(* masks for the above *)
		ICattr_volatile_bit = 1;
		ICattr_volatile_mask = $00000002;

		icNoUserInteraction_bit = 0;
		icNoUserInteraction_mask = $00000001;

		ICfiletype = 'ICAp';
		ICcreator = 'ICAp';
		ICdefault_file_name = 'Internet Preferences';	(* default file name, for internal use, overridden by a component resource *)
	type
		ICDirSpec = record							(* a record that specifies a folder *)
				vRefNum: integer;
				dirID: longint;
			end;
		ICDirSpecArray = array[0..3] of ICDirSpec;	(* an array of the above *)
		ICDirSpecArrayPtr = ^ICDirSpecArray;		(* a pointer to that array *)
		ICAttr = longint;							(* type for preference attributes *)
		ICError = longint;							(* type for error codes *)
		ICInstance = Ptr;							(* opaque type for preference reference *)
		ICPerm = (icNoPerm, icReadOnlyPerm, icReadWritePerm);
		ICConfigRef = record
				manufacturer: OSType;
				(* other private data follows *)
			end;
		ICConfigRefPtr = ^ICConfigRef;
		ICConfigRefHandle = ^ICConfigRefPtr;

	const
		kICNilProfileID = 0;
	type
		ICProfileID = longint;
		ICProfileIDPtr = ^ICProfileID;

	const
		kICEditPreferenceEventClass = 'ICAp';
		kICEditPreferenceEvent = 'ICAp';
		keyICEditPreferenceDestination = 'dest';

	const

(* Start ICKeys.p *)

		kICRealName = 'RealName';  (* PString -- real name of user *)
		kICEmail = 'Email';  (* PString -- user@host.domain, email address of user, ie return address *)
		kICMailAccount = 'MailAccount';  (* PString -- user@host.domain, account from which to fetch mail *)
		kICMailPassword = 'MailPassword';  (* PString -- scrambled, password for MailAccount *)
		kICNewsAuthUsername = 'NewsAuthUsername';  (* PString -- user name for authorised news servers *)
		kICNewsAuthPassword = 'NewsAuthPassword';  (* PString -- scrambled, password for NewsAuthUsername *)
		kICArchiePreferred = 'ArchiePreferred';  (* PString -- formatted, preferred Archie server *)
		kICArchieAll = 'ArchieAll';  (* STR# -- formatted, list of Archie servers *)
		kICUMichPreferred = 'UMichPreferred';  (* PString -- formatted, preferred UMich server *)
		kICUMichAll = 'UMichAll';  (* STR# -- formatted, list of UMich servers *)
		kICInfoMacPreferred = 'InfoMacPreferred';  (* PString -- formatted, preferred Info-Mac server *)
		kICInfoMacAll = 'InfoMacAll';  (* STR# -- formatted, list of Info-Mac servers *)
		kICPhHost = 'PhHost';  (* PString -- host.domain, default Ph server *)
		kICWhoisHost = 'WhoisHost';  (* PString -- host.domain, default whois server *)
		kICFingerHost = 'FingerHost';  (* PString -- host.domain, default finger server *)
		kICFTPHost = 'FTPHost';  (* PString -- host.domain, default FTP server *)
		kICTelnetHost = 'TelnetHost';  (* PString -- host.domain, default Telnet address *)
		kICSMTPHost = 'SMTPHost';  (* PString -- host.domain, SMTP server *)
		kICNNTPHost = 'NNTPHost';  (* PString -- host.domain, NNTP server *)
		kICGopherHost = 'GopherHost';  (* PString -- host.domain, default Gopher server *)
		kICLDAPServer = 'LDAPServer';  (* PString -- host.domain *)
		kICLDAPSearchbase = 'LDAPSearchbase';  (* PString -- string LDAP thing *)
		kICWWWHomePage = 'WWWHomePage';  (* PString -- URL, users default WWW page *)
		kICWAISGateway = 'WAISGateway';  (* PString -- no idea *)
		kICListFont = 'ListFont';  (* ICFontRecord -- font used for lists of items (eg news article lists) *)
		kICScreenFont = 'ScreenFont';  (* ICFontRecord -- font used for monospaced text (eg news articles) *)
		kICDocumentFont = 'DocumentFont';  (* ICFontRecord -- font used for proportional text *)
		kICPrinterFont = 'PrinterFont';  (* ICFontRecord -- font used to print ScreenFont *)
		kICDownloadFolder = 'DownloadFolder';  (* ICFileSpec -- where to put newly downloaded files *)
		kICSignature = 'Signature';  (* TEXT -- append to news and mail messages *)
		kICOrganization = 'Organization';  (* PString -- for X-Organization string *)
		kICPlan = 'Plan';  (* TEXT -- default response for finger servers *)
		kICQuotingString = 'QuotingString';  (* PString -- used to quote responses in news and mail *)
		kICMailHeaders = 'MailHeaders';  (* TEXT -- extra headers for mail messages *)
		kICNewsHeaders = 'NewsHeaders';  (* TEXT -- extra headers for news messages *)
		kICMapping = 'Mapping';  (* ICMapEntries -- file type mapping, see documentation *)
		kICCharacterSet = 'CharacterSet';  (* ICCharTable -- Mac-to-Net and Net-to-Mac character translation *)
		kICHelper = 'Helper';  (* ICAppSpec -- helpers for URL schemes *)
		kICServices = 'Services';  (* ICServices -- TCP and IP port-to-name mapping *)
		kICNewMailFlashIcon = 'NewMailFlashIcon';  (* Boolean -- how to announce new mail *)
		kICNewMailDialog = 'NewMailDialog';  (* Boolean *)
		kICNewMailPlaySound = 'NewMailPlaySound';  (* Boolean *)
		kICNewMailSoundName = 'NewMailSoundName';  (* PString *)
		kICWebBackgroundColour = 'WebBackgroundColour';  (* RGBColor -- background colour for web pages *)
		kICNoProxyDomains = 'NoProxyDomains';  (* STR# -- list of domains not to be proxied *)
		kICUseSocks = 'UseSocks';  (* Boolean *)
		kICSocksHost = 'SocksHost';  (* PString -- host.domain, remember that host.domain format allows ":port" and " port" *)
		kICUseHTTPProxy = 'UseHTTPProxy';  (* Boolean *)
		kICHTTPProxyHost = 'HTTPProxyHost';  (* PString -- host.domain *)
		kICUseGopherProxy = 'UseGopherProxy';  (* Boolean *)
		kICGopherProxy = 'GopherProxy';  (* PString -- host.domain, see note in Prog Docs *)
		kICUseFTPProxy = 'UseFTPProxy';  (* Boolean *)
		kICFTPProxyHost = 'FTPProxyHost';  (* PString -- host.domain *)
		kICFTPProxyUser = 'FTPProxyUser';  (* PString -- first level FTP proxy authorisation *)
		kICFTPProxyPassword = 'FTPProxyPassword';  (* PString -- scrambled, password for FTPProxyUser *)
		kICFTPProxyAccount = 'FTPProxyAccount';  (* PString -- second level FTP proxy authorisation *)
		kICUsePassiveFTP = 'UsePassiveFTP';  (* Boolean -- use PASV command for FTP transfers *)
		kICSnailMailAddress = 'SnailMailAddress';  (* TEXT -- preferred mailing address *)
		kICMacSearchHost = 'MacSearchHost';  (* PString -- host for MacSearch queries *)
		kICWebSearchPagePrefs = 'WebSearchPagePrefs';  (* PString -- URL, users default search page *)
		kICWebTextColor = 'WebTextColor';  (* RGBColor -- colour for normal text *)
		kICWebReadColor = '646F6777WebReadColor';  (* RGBColor -- colour for read links *)
		kICWebUnreadColor = '646F6777WebUnreadColor';  (* RGBColor -- colour for unread links *)
		kICWebUnderlineLinks = '646F6777WebUnderlineLinks';  (* Boolean -- whether to underline links *)
		kICNTPHost = 'NTPHost';  (* PString -- host.domain, Network Time Protocol (NTP) *)

(* End ICKeys.p *)

	type
		ICFontRecord = record
				size: integer;
				face: Style;
				font: Str255;
			end;
		ICFontRecordPtr = ^ICFontRecord;
		ICFontRecordHandle = ^ICFontRecordPtr;

		ICCharTable = record
				net_to_mac: packed array[char] of char;
				mac_to_net: packed array[char] of char;
			end;
		ICCharTablePtr = ^ICCharTable;
		ICCharTableHandle = ^ICCharTablePtr;

		ICAppSpec = record
				fCreator: OSType;
				name: Str63;
			end;
		ICAppSpecPtr = ^ICAppSpec;
		ICAppSpecHandle = ^ICAppSpecPtr;

{$ifc OLDROUTINENAMES}
		
		(*	ICFileInfo was originally used to define the format of a key.
			That key was removed, but we forgot to remove ICFileInfo.
			I hope to remove it entirely, but for the moment it's available
			if you define OLDROUTINENAMES.
		*)
		
		ICFileInfo = record
				fType: OSType;
				fCreator: OSType;
				name: Str63;
			end;
		ICFileInfoPtr = ^ICFileInfo;
		ICFileInfoHandle = ^ICFileInfoPtr;
{$endc}

		ICFileSpec = record
				vol_name: Str31;
				vol_creation_date: longint;
				fss: FSSpec;					(* vRefNum field is of no value *)
				alias: AliasRecord; 			(* plus extra data, aliasSize 0 means no alias manager present when ICFileSpecification was created *)
			end;
		ICFileSpecPtr = ^ICFileSpec;
		ICFileSpecHandle = ^ICFileSpecPtr;
	const
		ICfile_spec_header_size = sizeof(ICFileSpec) - sizeof(AliasRecord);

	type
		ICMapEntry = record
				total_length: integer;			(* from beginning of record *)
				fixed_length: integer;			(* from beginning of record *)
				version: integer;
				file_type: OSType;
				file_creator: OSType;
				post_creator : OSType;
				flags: longint;
				(* variable part starts here *)
				extension: Str255;					(* these strings are tightly packed *)
				creator_app_name: Str255;			(* which means, these ones might have an *)
				post_app_name : Str255;				(* odd address *)
				MIME_type: Str255;					
				entry_name: Str255;
			end;
		ICMapEntryPtr = ^ICMapEntry;
		ICMapEntryHandle = ^ICMapEntryPtr;

	const
		(* bits and masks for the flags of the ICMapEntry *)
		ICmap_binary_bit = 0;					(* file should be transfered in binary as opposed to text mode *)
		ICmap_binary_mask = $00000001;
		ICmap_resource_fork_bit = 1;			(* the resource fork of the file is significant *)
		ICmap_resource_fork_mask = $00000002;
		ICmap_data_fork_bit = 2;				(* the data fork of the file is significant *)
		ICmap_data_fork_mask = $00000004;

		ICmap_post_bit = 3;						(* post process using post fields *)
		ICmap_post_mask = $00000008;

		ICmap_not_incoming_bit = 4;				(* ignore this mapping for incoming files *)
		ICmap_not_incoming_mask = $00000010;
		ICmap_not_outgoing_bit = 5;				(* ignore this mapping for outgoing files *)
		ICmap_not_outgoing_mask = $00000020;

		ICmap_fixed_length = 22;				(* number in fixed_length field *)
		
	type
		ICServiceEntry = record
				name: Str255;					(* this strings is tightly packed *)
				port: integer;					(* which means, these fields might have an *)
				flags: integer;					(* odd address *)
			end;
		ICServiceEntryPtr = ^ICServiceEntry;
		ICServiceEntryHandle = ICServiceEntryPtr;

		ICServices = record
				count: integer;
				services: array[1..1] of ICServiceEntry;	(* this array is packed, so you can't index it directly *)
			end;
		ICServicesPtr = ^ICServices;
		ICServicesHandle = ^ICServicesPtr;

	const
		(* bits and masks for the flags of the ICServiceEntry *)
		ICservices_tcp_bit = 0;					(* this is a TCP service *)
		ICservices_tcp_mask = $00000001;
		ICservices_udp_bit = 1;					(* this is a UDP service *)
		ICservices_udp_mask = $00000002;
		(* both bits can be set, which means the service is both TCP and UDP, eg daytime *)

	(* ***** Notes Relevant To All API Routines ***** *)

	(*
		[r1] Requires IC 1.1 or higher.
		[r2] Requires IC 1.2 or higher.
		[r3] Requires IC 2.0 or higher.
		
		[c1] You must have specified a configuration before
			 calling this routine.
		[c2] You must have specified the default configuration
			 before calling this routine.
		[c3] You do not need to specify a configuration before
			 calling this routine.

		[b1] You must be inside a Begin/End pair when calling
			 this routine.
		[b2] You must be inside a Begin/End read/write pair when
			 calling this routine.
		[b3] You do not need to be inside a Begin/End pair when
		 	 calling this routine.
		[b4] If you are getting or setting multiple preferences,
			 you should make this call inside a Begin/End pair.
			 If you do not make this call inside a Begin/End pair,
			 the call will automatically do it for you.
		[b5] It is illegal to call this routine inside a
			 Begin/End pair.
	*)

(* Start ICAPI.p *)

	(* ***** Starting Up and Shutting Down ***** *)
	
	function ICStart(var inst : ICInstance; creator : OSType) : ICError;
	  (* Call this at application initialisation. Set creator to your application
	   * creator to allow for future expansion of the IC system. Returns
	   * inst as a connection to the IC system.
	   *)
	
	function ICStop(inst : ICInstance) : ICError;
	  (* [b5] 
	   * Call this at application initialisation, after which inst
	   * is no longer valid connection to IC.
	   *)
	
	(* ***** Specifying a Configuration ***** *)
	
	function ICFindConfigFile(inst : ICInstance; count : integer; folders : ICDirSpecArrayPtr) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 6, 2, $7000, $A82A;
	{$endc}
	  (* [b5] 
	   * Call to configure this connection to IC.
	   * Set count as the number of valid elements in folders.
	   * Set folders to a pointer to the folders to search.
	   * Setting count to 0 and folders to nil is OK.
	   * Searches the specified folders and then the Preferences folder
	   * in a unspecified manner.
	   *)
	
	function ICFindUserConfigFile(inst : ICInstance; var where : ICDirSpec) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 14, $7000, $A82A;
	{$endc}
	  (* [r1] [b5] 
	   * Similar to ICFindConfigFile except that it only searches the folder
	   * specified in where.  If the input parameters are valid the routine
	   * will always successful configure the instance, creating an
	   * empty configuration if necessary
	   * For use with double-clickable preference files.
	   *)
	
	function ICGeneralFindConfigFile(inst : ICInstance; searchPrefs : Boolean; canCreate : Boolean; count : integer; folders : ICDirSpecArrayPtr) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 10, 30, $7000, $A82A;
	{$endc}
	  (* [r2] [b5] 
	   * Call to configure this connection to IC.
	   * This routine acts as a more general replacement for
	   * ICFindConfigFile and ICFindUserConfigFile.
	   * Set search_prefs to true if you want it to search the preferences folder.
	   * Set can_create to true if you want it to be able to create a new config.
	   * Set count as the number of valid elements in folders.
	   * Set folders to a pointer to the folders to search.
	   * Setting count to 0 and folders to nil is OK.
	   * Searches the specified folders and then optionally the Preferences folder
	   * in a unspecified manner.
	   *)
	
	function ICChooseConfig(inst : ICInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 33, $7000, $A82A;
	{$endc}
	  (* [r2] [b5] 
	   * Requests the user to choose a configuration, typically using some
	   * sort of modal dialog. If the user cancels the dialog the configuration
	   * state will be unaffected.
	   *)
	
	function ICChooseNewConfig(inst : ICInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 34, $7000, $A82A;
	{$endc}
	  (* [r2] [b5] 
	   * Requests the user to create a new configuration, typically using some
	   * sort of modal dialog. If the user cancels the dialog the configuration
	   * state will be unaffected.
	   *)
	
	function ICGetConfigName(inst : ICInstance; longname : Boolean; var name : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 6, 35, $7000, $A82A;
	{$endc}
	  (* [r2] [c1] [b3] 
	   * Returns a string that describes the current configuration at a user
	   * level. Set longname to true if you want a long name, up to 255
	   * characters, or false if you want a short name, typically about 32
	   * characters.
	   * The returned string is for user display only. If you rely on the
	   * exact format of it, you will conflict with any future IC
	   * implementation that doesn't use explicit preference files.
	   *)
	
	function ICGetConfigReference(inst : ICInstance; ref : ICConfigRefHandle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 31, $7000, $A82A;
	{$endc}
	  (* [r2] [c1] [b3] 
	   * Returns a self-contained reference to the instance's current
	   * configuration.
	   * ref must be a valid non-nil handle and it will be resized to fit the
	   * resulting data.
	   *)
	
	function ICSetConfigReference(inst : ICInstance; ref : ICConfigRefHandle; flags : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 32, $7000, $A82A;
	{$endc}
	  (* [r2] [b5] 
	   * Reconfigures the instance using a configuration reference that was
	   * got using ICGetConfigReference reference. Set the
	   * icNoUserInteraction_bit in flags if you require that this routine
	   * not present a modal dialog. Other flag bits are reserved and should
	   * be set to zero.
	   * ref must not be nil.
	   *)
	
	(* ***** Private Routines *****
	 * 
	 * If you are calling these routines, you are most probably doing something
	 * wrong.  Please read the documentation for more details.
	 *)
	
	function ICSpecifyConfigFile(inst : ICInstance; var config : FSSpec) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 3, $7000, $A82A;
	{$endc}
	  (* [b5] 
	   * For use only by the IC application.
	   * If you call this routine yourself, you will conflict with any
	   * future IC implementation that doesn't use explicit preference files.
	   *)
	
	function ICRefreshCaches(inst : ICInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 47, $7000, $A82A;
	{$endc}
	  (* [r3] [c1] [b3] 
	   * For use only by the IC application.
	   * If you call this routine yourself, you will conflict with any
	   * future IC implementation that doesn't use explicit preference files.
	   *)
	
	(* ***** Getting Information ***** *)
	
	function ICGetSeed(inst : ICInstance; var seed : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 4, $7000, $A82A;
	{$endc}
	  (* [c3] [b3] 
	   * Returns the current seed for the IC prefs database.
	   * This seed changes each time a non-volatile preference is changed.
	   * You can poll this to determine if any cached preferences change.
	   *)
	
	function ICGetPerm(inst : ICInstance; var perm : ICPerm) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 13, $7000, $A82A;
	{$endc}
	  (* [c3] [b3] 
	   * Returns the access permissions currently associated with this instance.
	   * While applications normally know what permissions they have,
	   * this routine is designed for use by override components.
	   *)
	
	function ICDefaultFileName(inst : ICInstance; var name : Str63) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 11, $7000, $A82A;
	{$endc}
	  (* [c3] [b3] 
	   * Returns the default file name for IC preference files.
	   * Applications should never need to call this routine.
	   * If you rely on information returned by this routine yourself,
	   * you may conflict with any future IC implementation that doesn't use
	   * explicit preference files.
	   * The component calls this routine to set up the default IC file name.
	   * This allows this operation to be intercepted by a component that has
	   * captured us. It currently gets it from the component resource file.
	   * The glue version is hardwired to "Internet Preferences".
	   *)
	
	function ICGetComponentInstance(inst : ICInstance; var componentInst : ComponentInstance) : ICError;
	  (* [r3] [c3] [b3] 
	   * Returns noErr and the connection to the IC component,
	   * if we're using the component.
	   * Returns badComponenInstance and nil if we're operating with glue.
	   *)
	
	(* ***** Reading and Writing Preferences ***** *)
	
	function ICBegin(inst : ICInstance; perm : ICPerm) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 2, 5, $7000, $A82A;
	{$endc}
	  (* [c1] [b5] 
	   * Starting reading or writing multiple preferences.
	   * A call to this must be balanced by a call to ICEnd.
	   * Do not call WaitNextEvent between these calls.
	   * The perm specifies whether you intend to read or read/write.
	   * Only one writer is allowed per instance.
	   * Note that this may open resource files that are not closed
	   * until you call ICEnd.
	   *)
	
	function ICGetPref(inst : ICInstance; key : Str255; var attr : ICAttr; buf : Ptr; var size : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 16, 6, $7000, $A82A;
	{$endc}
	  (* [c1] [b4] 
	   * Reads the preference specified by key from the IC database to the
	   * buffer pointed to by buf and size.
	   * key must not be the empty string.
	   * If buf is nil then no data is returned.
	   * size must be non-negative.
	   * attr and size are always set on return. On errors (except icTruncatedErr)
	   * attr is set to ICattr_no_change and size is set to 0.
	   * size is the actual size of the data.
	   * attr is set to the attributes associated with the preference.
	   * If this routine returns icTruncatedErr then the other returned
	   * values are valid except that only the first size bytes have been
	   * return. size is adjusted to reflect the true size of the preference.
	   * Returns icPrefNotFound if there is no preference for the key.
	   *)
	
	function ICSetPref(inst : ICInstance; key : Str255; attr : ICAttr; buf : Ptr; size : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 16, 7, $7000, $A82A;
	{$endc}
	  (* [c1] [b4] 
	   * Sets the preference specified by key from the IC database to the
	   * value pointed to by buf and size.
	   * key must not be the empty string.
	   * size must be non-negative. 
	   * If buf is nil then the preference value is not set and size is ignored.
	   * If buf is not nil then the preference value is set to the size
	   * bytes pointed to by buf.
	   * If attr is ICattr_no_change then the preference attributes are not set.
	   * Otherwise the preference attributes are set to attr.
	   * Returns icPermErr if the previous ICBegin was passed icReadOnlyPerm.
	   * Returns icPermErr if current attr is locked, new attr is locked and buf <> nil.
	   *)
	
	function ICFindPrefHandle(inst : ICInstance; key : Str255; var attr : ICAttr; prefh : Handle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 36, $7000, $A82A;
	{$endc}
	  (* [r2] [c1] [b4] 
	   * This routine effectively replaces ICGetPrefHandle.
	   * Reads the preference specified by key from the IC database into
	   * a handle, prefh.
	   * key must not be the empty string.
	   * attr is set to the attributes associated with the preference.
	   * You must set prefh to a non-nil handle before calling this routine.
	   * If the preference does not exist, icPrefNotFoundErr is returned.
	   *)
	
	function ICGetPrefHandle(inst : ICInstance; key : Str255; var attr : ICAttr; var prefh : Handle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 26, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b4] 
	   * This routine is now obsolete. Use ICFindPrefHandle instead.
	   * Reads the preference specified by key from the IC database into
	   * a newly created handle, prefh.
	   * key must not be the empty string.
	   * attr is set to the attributes associated with the preference.
	   * The incoming value of prefh is ignored.
	   * A new handle is created in the current heap and returned in prefh.
	   * If the routine returns an error, prefh is set to nil.
	   * If the preference does not exist, no error is returned and prefh is set
	   * to an empty handle.
	   *)
	
	function ICSetPrefHandle(inst : ICInstance; key : Str255; attr : ICAttr; prefh : Handle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 27, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b4] 
	   * Sets the preference specified by key from the IC database to the
	   * value contained in prefh.
	   * key must not be the empty string.
	   * If prefh is nil then the preference value is not set.
	   * If buf is not nil then the preference value is set to the data
	   * contained in it.
	   * If attr is ICattr_no_change then the preference attributes are not set.
	   * Otherwise the preference attributes are set to attr.
	   * Returns icPermErr if the previous ICBegin was passed icReadOnlyPerm.
	   * Returns icPermErr if current attr is locked, new attr is locked and prefh <> nil.
	   *)
	
	function ICCountPref(inst : ICInstance; var count : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 8, $7000, $A82A;
	{$endc}
	  (* [c1] [b1] 
	   * Counts the total number of preferences.
	   * If the routine returns an error, count is set to 0.
	   *)
	
	function ICGetIndPref(inst : ICInstance; index : longint; var key : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 9, $7000, $A82A;
	{$endc}
	  (* [c1] [b1] 
	   * Returns the key of the index'th preference.
	   * index must be positive.
	   * Returns icPrefNotFoundErr if index is greater than the total number of preferences.
	   * If the routine returns an error, key is undefined.
	   *)
	
	function ICDeletePref(inst : ICInstance; key : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 12, $7000, $A82A;
	{$endc}
	  (* [c1] [b2] 
	   * Deletes the preference specified by key.
	   * key must not be the empty string.
	   * Returns icPrefNotFound if the preference specified by key is not present.
	   *)
	
	function ICEnd(inst : ICInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 10, $7000, $A82A;
	{$endc}
	  (* [c1] [b1] 
	   * Terminates a preference session, as started by ICBegin.
	   * You must have called ICBegin before calling this routine.
	   *)
	
	(* ***** User Interface Stuff ***** *)
	
	function ICEditPreferences(inst : ICInstance; key : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 15, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Instructs IC to display the user interface associated with editing
	   * preferences and focusing on the preference specified by key.
	   * If key is the empty string then no preference should be focused upon.
	   * You must have specified a configuration before calling this routine.
	   * You do not need to call ICBegin before calling this routine.
	   * In the current implementation this launches the IC application
	   * (or brings it to the front) and displays the window containing
	   * the preference specified by key.
	   * It may have a radically different implementation in future
	   * IC systems.
	   *)
	
	(* ***** URL Handling ***** *)
	
	function ICParseURL(inst : ICInstance; hint : Str255; data : Ptr; len : longint; var selStart : longint; var selEnd : longint; url : Handle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 24, 16, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Parses a URL out of the specified text and returns it in a canonical form
	   * in a handle.
	   * hint indicates the default scheme for URLs of the form "name@address".
	   * If hint is the empty string then URLs of that form are not allowed.
	   * data points to the start of the text. It must not be nil.
	   * len indicates the length of the text. It must be non-negative.
	   * selStart and selEnd should be passed in as the current selection of
	   * the text. This selection is given in the same manner as TextEdit,
	   * ie if selStart = selEnd then there is no selection only an insertion
	   * point. Also selStart  selEnd and 0  selStart  len and 0  selEnd  len.
	   * selStart and selEnd are returned as the bounds of the URL. If the
	   * routine returns an error then these new boundaries may be
	   * invalid but they will be close.
	   * The incoming url handle must not be nil.  The resulting URL is normalised
	   * and copied into the url handle, which is resized to fit.
	   *)
	
	function ICLaunchURL(inst : ICInstance; hint : Str255; data : Ptr; len : longint; var selStart : longint; var selEnd : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 20, 17, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Parses a URL out of the specified text and feeds it off to the
	   * appropriate helper.
	   * hint indicates the default scheme for URLs of the form "name@address".
	   * If hint is the empty string then URLs of that form are not allowed.
	   * data points to the start of the text. It must not be nil.
	   * len indicates the length of the text. It must be non-negative.
	   * selStart and selEnd should be passed in as the current selection of
	   * the text. This selection is given in the same manner as TextEdit,
	   * ie if selStart = selEnd then there is no selection only an insertion
	   * point. Also selStart  selEnd and 0  selStart  len and 0  selEnd  len.
	   * selStart and selEnd are returned as the bounds of the URL. If the
	   * routine returns an error then these new boundaries may be
	   * invalid but they will be close.
	   * The URL is parsed out of the text and passed off to the appropriate
	   * helper using the GURL AppleEvent.
	   *)
	
	(* ***** Mappings Routines *****
	 * 
	 * Routines for interrogating mappings database.
	 * 
	 * ----- High Level Routines -----
	 *)
	
	function ICMapFilename(inst : ICInstance; filename : Str255; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 24, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b4] 
	   * Takes the name of an incoming file and returns the most appropriate
	   * mappings database entry, based on its extension.
	   * filename must not be the empty string.
	   * Returns icPrefNotFoundErr if no suitable entry is found.
	   *)
	
	function ICMapTypeCreator(inst : ICInstance; fType : OSType; fCreator : OSType; filename : Str255; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 16, 25, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b4] 
	   * Takes the type and creator (and optionally the name) of an outgoing
	   * file and returns the most appropriate mappings database entry.
	   * The filename may be either the name of the outgoing file or
	   * the empty string.
	   * Returns icPrefNotFoundErr if no suitable entry found.
	   *)
	
	(* ----- Mid Level Routines ----- *)
	
	function ICMapEntriesFilename(inst : ICInstance; entries : Handle; filename : Str255; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 28, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Takes the name of an incoming file and returns the most appropriate
	   * mappings database entry, based on its extension.
	   * entries must be a handle to a valid IC mappings database preference.
	   * filename must not be the empty string.
	   * Returns icPrefNotFoundErr if no suitable entry is found.
	   *)
	
	function ICMapEntriesTypeCreator(inst : ICInstance; entries : Handle; fType : OSType; fCreator : OSType; filename : Str255; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 20, 29, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Takes the type and creator (and optionally the name) of an outgoing
	   * file and returns the most appropriate mappings database entry.
	   * entries must be a handle to a valid IC mappings database preference.
	   * The filename may be either the name of the outgoing file or
	   * the empty string.
	   * Returns icPrefNotFoundErr if no suitable entry found.
	   *)
	
	(* ----- Low Level Routines ----- *)
	
	function ICCountMapEntries(inst : ICInstance; entries : Handle; var count : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 18, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Counts the number of entries in the mappings database.
	   * entries must be a handle to a valid IC mappings database preference.
	   * count is set to the number of entries.
	   *)
	
	function ICGetIndMapEntry(inst : ICInstance; entries : Handle; index : longint; var pos : longint; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 16, 19, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Gets the index'th entry in the mappings database.
	   * entries must be a handle to a valid IC mappings database preference.
	   * index must be in the range from 1 to the number of entries in the database.
	   * The value of pos is ignored on input. pos is set to the position of
	   * the index'th entry in the database and is suitable for passing back
	   * into ICSetMapEntry.
	   * Does not return any user data associated with the entry.
	   *)
	
	function ICGetMapEntry(inst : ICInstance; entries : Handle; pos : longint; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 20, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Returns the entry located at position pos in the mappings database.
	   * entries must be a handle to a valid IC mappings database preference.
	   * pos should be 0 to get the first entry. To get the subsequent entries, add
	   * entry.total_size to pos and iterate.
	   * Does not return any user data associated with the entry.
	   *)
	
	function ICSetMapEntry(inst : ICInstance; entries : Handle; pos : longint; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 21, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Sets the entry located at position pos in the mappings database.
	   * entries must be a handle to a valid IC mappings database preference.
	   * pos should be either a value returned from ICGetIndMapEntry or a value
	   * calculated using ICGetMapEntry.
	   * entry is a var parameter purely for stack space reasons. It is not
	   * modified in any way.
	   * Any user data associated with the entry is unmodified.
	   *)
	
	function ICDeleteMapEntry(inst : ICInstance; entries : Handle; pos : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 22, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Deletes the mappings database entry at pos.
	   * entries must be a handle to a valid IC mappings database preference.
	   * pos should be either a value returned from ICGetIndMapEntry or a value
	   * calculated using ICGetMapEntry.
	   * Also deletes any user data associated with the entry.
	   *)
	
	function ICAddMapEntry(inst : ICInstance; entries : Handle; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 23, $7000, $A82A;
	{$endc}
	  (* [r1] [c1] [b3] 
	   * Adds an entry to the mappings database.
	   * entries must be a handle to a valid IC mappings database preference.
	   * The entry is added to the end of the entries database.
	   * No user data is added.
	   *)
	
	(* ***** Profile Management Routines ***** *)
	
	function ICGetCurrentProfile(inst : ICInstance; var currentID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 37, $7000, $A82A;
	{$endc}
	  (* [r3] [c1] [b3] 
	   * Returns the profile ID of the current profile.
	   *)
	
	function ICSetCurrentProfile(inst : ICInstance; newID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 38, $7000, $A82A;
	{$endc}
	  (* [r3] [c1] [b3] 
	   * Sets the current profile to the profile specified in newProfile.
	   *)
	
	function ICCountProfiles(inst : ICInstance; var count : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 39, $7000, $A82A;
	{$endc}
	  (* [r3] [c1] [b1] 
	   * Returns the total number of profiles.
	   *)
	
	function ICGetIndProfile(inst : ICInstance; index : longint; var thisID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 40, $7000, $A82A;
	{$endc}
	  (* [r3] [c1] [b1] 
	   * Returns the profile ID of the index'th profile.  index must be positive.
	   * Returns icProfileNotFoundErr if index is greater than the total number
	   * of profiles.
	   *)
	
	function ICGetProfileName(inst : ICInstance; thisID : ICProfileID; var name : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 41, $7000, $A82A;
	{$endc}
	  (* [r3] [c1] [b3] 
	   * Returns the name of a profile given its ID.  The name may not uniquely
	   * identify the profile.  [That's what the profile ID is for!]  The name
	   * is assumed to be in the system script.
	   *)
	
	function ICSetProfileName(inst : ICInstance; thisID : ICProfileID; name : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 42, $7000, $A82A;
	{$endc}
	  (* [r3] [c1] [b3] 
	   * This routine sets the name of the specified profile.  Profile names
	   * need not be unique.  The name should be in the system script.
	   *)
	
	function ICAddProfile(inst : ICInstance; prototypeID : ICProfileID; var newID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 43, $7000, $A82A;
	{$endc}
	  (* [r3] [c1] [b2] 
	   * If prototypeID = kICNilProfileID, this routine
	   * creates a default profile, otherwise it creates a
	   * profile by cloning the prototype profile.  The ID
	   * of the new profile is returned in newID.
	   * The new profile will be give a new, unique, name.
	   * This does not switch to the new profile.
	   *)
	
	function ICDeleteProfile(inst : ICInstance; thisID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 44, $7000, $A82A;
	{$endc}
	  (* [r3] [c1] [b2] 
	   * This routine deletes the profile specified by
	   * thisID.  Attempting to delete the current profile
	   * or the last profile will return error.
	   *)
	
	(* ***** Interrupt Safe Routines ***** *)
	
	function ICRequiresInterruptSafe(inst : ICInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 45, $7000, $A82A;
	{$endc}
	  (* [r3] [c2] [b3] 
	   * You must call this routine before calling GetMapEntryInterruptSafe
	   * to give IC chance to cache the mappings data in memory.  The only
	   * way to clear this state is to close the instance.  You can not reconfigure
	   * the instance after calling this routine.
	   *)
	
	function ICGetMappingInterruptSafe(inst : ICInstance; var mappingPref : Ptr; var mappingPrefSize : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 46, $7000, $A82A;
	{$endc}
	  (* [r3] [c2] [b3] 
	   * Returns the "Mapping" preference in an interrupt safe fashion.
	   * The preference returned pointer is valid until the next
	   * non-interrupt safe call to IC.  Typically this API is used
	   * by software that needs to map extensions to type and creator
	   * at interrupt time, eg foreign file systems.
	   *)
	
	function ICGetSeedInterruptSafe(inst : ICInstance; var seed : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 48, $7000, $A82A;
	{$endc}
	  (* [r3] [c2] [b3] 
	   * An interrupt safe version of ICGetSeed.
	   *)
	

(* End ICAPI.p *)

	const
		kICComponentType = 'PREF';				(* the component type *)
		kICComponentSubType = 'ICAp';			(* the component subtype *)
		kICComponentManufacturer = 'JPQE';
		kICComponentInterfaceVersion0 = $00000000;	(* IC >= 1.0 *)
		kICComponentInterfaceVersion1 = $00010000;	(* IC >= 1.1 *)
		kICComponentInterfaceVersion2 = $00020000;	(* IC >= 1.2 *)
		kICComponentInterfaceVersion3 = $00030000;	(* IC >= 2.0 *)
		(* current version number is version 3 *)
		kICComponentInterfaceVersion = kICComponentInterfaceVersion3;

{$ifc OLDROUTINENAMES}

	(*	This definitions are a) very long, and b) don't conform
		to Mac OS standards for naming constants, so I've put
		them in only if you're using OLDROUTINENAMES.  Please switch
		to the new names given above.
	*)
	const
		internetConfigurationComponentType = 'PREF';					(* the component type *)
		internetConfigurationComponentSubType = 'ICAp';					(* the component subtype *)
		internetConfigurationComponentInterfaceVersion0 = $00000000;	(* IC >= 1.0 *)
		internetConfigurationComponentInterfaceVersion1 = $00010000;	(* IC >= 1.1 *)
		internetConfigurationComponentInterfaceVersion2 = $00020000;	(* IC >= 1.2 *)
		internetConfigurationComponentInterfaceVersion3 = $00030000;	(* IC >= 2.0 *)
		(* current version number is version 3 *)
		internetConfigurationComponentInterfaceVersion = internetConfigurationComponentInterfaceVersion3;
{$endc}

	const
(* Start ICCSelectors.p *)

		kICCStart = 0;
		kICCStop = 1;
		kICCFindConfigFile = 2;
		kICCFindUserConfigFile = 14;
		kICCGeneralFindConfigFile = 30;
		kICCChooseConfig = 33;
		kICCChooseNewConfig = 34;
		kICCGetConfigName = 35;
		kICCGetConfigReference = 31;
		kICCSetConfigReference = 32;
		kICCSpecifyConfigFile = 3;
		kICCRefreshCaches = 47;
		kICCGetSeed = 4;
		kICCGetPerm = 13;
		kICCDefaultFileName = 11;
		kICCBegin = 5;
		kICCGetPref = 6;
		kICCSetPref = 7;
		kICCFindPrefHandle = 36;
		kICCGetPrefHandle = 26;
		kICCSetPrefHandle = 27;
		kICCCountPref = 8;
		kICCGetIndPref = 9;
		kICCDeletePref = 12;
		kICCEnd = 10;
		kICCEditPreferences = 15;
		kICCParseURL = 16;
		kICCLaunchURL = 17;
		kICCMapFilename = 24;
		kICCMapTypeCreator = 25;
		kICCMapEntriesFilename = 28;
		kICCMapEntriesTypeCreator = 29;
		kICCCountMapEntries = 18;
		kICCGetIndMapEntry = 19;
		kICCGetMapEntry = 20;
		kICCSetMapEntry = 21;
		kICCDeleteMapEntry = 22;
		kICCAddMapEntry = 23;
		kICCGetCurrentProfile = 37;
		kICCSetCurrentProfile = 38;
		kICCCountProfiles = 39;
		kICCGetIndProfile = 40;
		kICCGetProfileName = 41;
		kICCSetProfileName = 42;
		kICCAddProfile = 43;
		kICCDeleteProfile = 44;
		kICCRequiresInterruptSafe = 45;
		kICCGetMappingInterruptSafe = 46;
		kICCGetSeedInterruptSafe = 48;
    kICCFirstSelector = kICCStart;
    kICCLastSelector = 48;

(* End ICCSelectors.p *)

(* Start ICCAPI.p *)

	(* ***** Starting Up and Shutting Down ***** *)
	
	function ICCStart(var inst : ComponentInstance; creator : OSType) : ICError;
	(* See comment for ICStart. *)
	
	function ICCStop(inst : ComponentInstance) : ICError;
	(* See comment for ICStop. *)
	
	(* ***** Specifying a Configuration ***** *)
	
	function ICCFindConfigFile(inst : ComponentInstance; count : integer; folders : ICDirSpecArrayPtr) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 6, 2, $7000, $A82A;
	{$endc}
	(* See comment for ICFindConfigFile. *)
	
	function ICCFindUserConfigFile(inst : ComponentInstance; var where : ICDirSpec) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 14, $7000, $A82A;
	{$endc}
	(* See comment for ICFindUserConfigFile. *)
	
	function ICCGeneralFindConfigFile(inst : ComponentInstance; searchPrefs : Boolean; canCreate : Boolean; count : integer; folders : ICDirSpecArrayPtr) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 10, 30, $7000, $A82A;
	{$endc}
	(* See comment for ICGeneralFindConfigFile. *)
	
	function ICCChooseConfig(inst : ComponentInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 33, $7000, $A82A;
	{$endc}
	(* See comment for ICChooseConfig. *)
	
	function ICCChooseNewConfig(inst : ComponentInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 34, $7000, $A82A;
	{$endc}
	(* See comment for ICChooseNewConfig. *)
	
	function ICCGetConfigName(inst : ComponentInstance; longname : Boolean; var name : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 6, 35, $7000, $A82A;
	{$endc}
	(* See comment for ICGetConfigName. *)
	
	function ICCGetConfigReference(inst : ComponentInstance; ref : ICConfigRefHandle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 31, $7000, $A82A;
	{$endc}
	(* See comment for ICGetConfigReference. *)
	
	function ICCSetConfigReference(inst : ComponentInstance; ref : ICConfigRefHandle; flags : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 32, $7000, $A82A;
	{$endc}
	(* See comment for ICSetConfigReference. *)
	
	(* ***** Private Routines *****
	 * 
	 * If you are calling these routines, you are most probably doing something
	 * wrong.  Please read the documentation for more details.
	 *)
	
	function ICCSpecifyConfigFile(inst : ComponentInstance; var config : FSSpec) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 3, $7000, $A82A;
	{$endc}
	(* See comment for ICSpecifyConfigFile. *)
	
	function ICCRefreshCaches(inst : ComponentInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 47, $7000, $A82A;
	{$endc}
	(* See comment for ICRefreshCaches. *)
	
	(* ***** Getting Information ***** *)
	
	function ICCGetSeed(inst : ComponentInstance; var seed : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 4, $7000, $A82A;
	{$endc}
	(* See comment for ICGetSeed. *)
	
	function ICCGetPerm(inst : ComponentInstance; var perm : ICPerm) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 13, $7000, $A82A;
	{$endc}
	(* See comment for ICGetPerm. *)
	
	function ICCDefaultFileName(inst : ComponentInstance; var name : Str63) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 11, $7000, $A82A;
	{$endc}
	(* See comment for ICDefaultFileName. *)
	
	function ICCGetComponentInstance(inst : ComponentInstance; var componentInst : ComponentInstance) : ICError;
	(* See comment for ICGetComponentInstance. *)
	
	(* ***** Reading and Writing Preferences ***** *)
	
	function ICCBegin(inst : ComponentInstance; perm : ICPerm) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 2, 5, $7000, $A82A;
	{$endc}
	(* See comment for ICBegin. *)
	
	function ICCGetPref(inst : ComponentInstance; key : Str255; var attr : ICAttr; buf : Ptr; var size : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 16, 6, $7000, $A82A;
	{$endc}
	(* See comment for ICGetPref. *)
	
	function ICCSetPref(inst : ComponentInstance; key : Str255; attr : ICAttr; buf : Ptr; size : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 16, 7, $7000, $A82A;
	{$endc}
	(* See comment for ICSetPref. *)
	
	function ICCFindPrefHandle(inst : ComponentInstance; key : Str255; var attr : ICAttr; prefh : Handle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 36, $7000, $A82A;
	{$endc}
	(* See comment for ICFindPrefHandle. *)
	
	function ICCGetPrefHandle(inst : ComponentInstance; key : Str255; var attr : ICAttr; var prefh : Handle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 26, $7000, $A82A;
	{$endc}
	(* See comment for ICGetPrefHandle. *)
	
	function ICCSetPrefHandle(inst : ComponentInstance; key : Str255; attr : ICAttr; prefh : Handle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 27, $7000, $A82A;
	{$endc}
	(* See comment for ICSetPrefHandle. *)
	
	function ICCCountPref(inst : ComponentInstance; var count : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 8, $7000, $A82A;
	{$endc}
	(* See comment for ICCountPref. *)
	
	function ICCGetIndPref(inst : ComponentInstance; index : longint; var key : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 9, $7000, $A82A;
	{$endc}
	(* See comment for ICGetIndPref. *)
	
	function ICCDeletePref(inst : ComponentInstance; key : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 12, $7000, $A82A;
	{$endc}
	(* See comment for ICDeletePref. *)
	
	function ICCEnd(inst : ComponentInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 10, $7000, $A82A;
	{$endc}
	(* See comment for ICEnd. *)
	
	(* ***** User Interface Stuff ***** *)
	
	function ICCEditPreferences(inst : ComponentInstance; key : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 15, $7000, $A82A;
	{$endc}
	(* See comment for ICEditPreferences. *)
	
	(* ***** URL Handling ***** *)
	
	function ICCParseURL(inst : ComponentInstance; hint : Str255; data : Ptr; len : longint; var selStart : longint; var selEnd : longint; url : Handle) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 24, 16, $7000, $A82A;
	{$endc}
	(* See comment for ICParseURL. *)
	
	function ICCLaunchURL(inst : ComponentInstance; hint : Str255; data : Ptr; len : longint; var selStart : longint; var selEnd : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 20, 17, $7000, $A82A;
	{$endc}
	(* See comment for ICLaunchURL. *)
	
	(* ***** Mappings Routines *****
	 * 
	 * Routines for interrogating mappings database.
	 * 
	 * ----- High Level Routines -----
	 *)
	
	function ICCMapFilename(inst : ComponentInstance; filename : Str255; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 24, $7000, $A82A;
	{$endc}
	(* See comment for ICMapFilename. *)
	
	function ICCMapTypeCreator(inst : ComponentInstance; fType : OSType; fCreator : OSType; filename : Str255; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 16, 25, $7000, $A82A;
	{$endc}
	(* See comment for ICMapTypeCreator. *)
	
	(* ----- Mid Level Routines ----- *)
	
	function ICCMapEntriesFilename(inst : ComponentInstance; entries : Handle; filename : Str255; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 28, $7000, $A82A;
	{$endc}
	(* See comment for ICMapEntriesFilename. *)
	
	function ICCMapEntriesTypeCreator(inst : ComponentInstance; entries : Handle; fType : OSType; fCreator : OSType; filename : Str255; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 20, 29, $7000, $A82A;
	{$endc}
	(* See comment for ICMapEntriesTypeCreator. *)
	
	(* ----- Low Level Routines ----- *)
	
	function ICCCountMapEntries(inst : ComponentInstance; entries : Handle; var count : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 18, $7000, $A82A;
	{$endc}
	(* See comment for ICCountMapEntries. *)
	
	function ICCGetIndMapEntry(inst : ComponentInstance; entries : Handle; index : longint; var pos : longint; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 16, 19, $7000, $A82A;
	{$endc}
	(* See comment for ICGetIndMapEntry. *)
	
	function ICCGetMapEntry(inst : ComponentInstance; entries : Handle; pos : longint; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 20, $7000, $A82A;
	{$endc}
	(* See comment for ICGetMapEntry. *)
	
	function ICCSetMapEntry(inst : ComponentInstance; entries : Handle; pos : longint; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 12, 21, $7000, $A82A;
	{$endc}
	(* See comment for ICSetMapEntry. *)
	
	function ICCDeleteMapEntry(inst : ComponentInstance; entries : Handle; pos : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 22, $7000, $A82A;
	{$endc}
	(* See comment for ICDeleteMapEntry. *)
	
	function ICCAddMapEntry(inst : ComponentInstance; entries : Handle; var entry : ICMapEntry) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 23, $7000, $A82A;
	{$endc}
	(* See comment for ICAddMapEntry. *)
	
	(* ***** Profile Management Routines ***** *)
	
	function ICCGetCurrentProfile(inst : ComponentInstance; var currentID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 37, $7000, $A82A;
	{$endc}
	(* See comment for ICGetCurrentProfile. *)
	
	function ICCSetCurrentProfile(inst : ComponentInstance; newID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 38, $7000, $A82A;
	{$endc}
	(* See comment for ICSetCurrentProfile. *)
	
	function ICCCountProfiles(inst : ComponentInstance; var count : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 39, $7000, $A82A;
	{$endc}
	(* See comment for ICCountProfiles. *)
	
	function ICCGetIndProfile(inst : ComponentInstance; index : longint; var thisID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 40, $7000, $A82A;
	{$endc}
	(* See comment for ICGetIndProfile. *)
	
	function ICCGetProfileName(inst : ComponentInstance; thisID : ICProfileID; var name : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 41, $7000, $A82A;
	{$endc}
	(* See comment for ICGetProfileName. *)
	
	function ICCSetProfileName(inst : ComponentInstance; thisID : ICProfileID; name : Str255) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 42, $7000, $A82A;
	{$endc}
	(* See comment for ICSetProfileName. *)
	
	function ICCAddProfile(inst : ComponentInstance; prototypeID : ICProfileID; var newID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 43, $7000, $A82A;
	{$endc}
	(* See comment for ICAddProfile. *)
	
	function ICCDeleteProfile(inst : ComponentInstance; thisID : ICProfileID) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 44, $7000, $A82A;
	{$endc}
	(* See comment for ICDeleteProfile. *)
	
	(* ***** Interrupt Safe Routines ***** *)
	
	function ICCRequiresInterruptSafe(inst : ComponentInstance) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 0, 45, $7000, $A82A;
	{$endc}
	(* See comment for ICRequiresInterruptSafe. *)
	
	function ICCGetMappingInterruptSafe(inst : ComponentInstance; var mappingPref : Ptr; var mappingPrefSize : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 8, 46, $7000, $A82A;
	{$endc}
	(* See comment for ICGetMappingInterruptSafe. *)
	
	function ICCGetSeedInterruptSafe(inst : ComponentInstance; var seed : longint) : ICError;
	{$ifc not GENERATINGCFM}
	  inline $2F3C, 4, 48, $7000, $A82A;
	{$endc}
	(* See comment for ICGetSeedInterruptSafe. *)
	

(* End ICCAPI.p *)

{$ALIGN RESET}
{$POP}

{$ifc not undefined THINK_Pascal}
implementation
{$endc}

end. (* InternetConfig *)
