/*

	ResForkInfo.h

	Not the most memory efficient way to store these, but certainly the most stable...
	
*/
#pragma once

const OSType kRFIDirectoryType 		= 'RDir';
const OSType kRFIResourceType		= 'RRes';

struct tRFINode {
	OSType			nodeType;				// kRFIDirectoryType or similar
	Str255			nodeName;				// name of this node
	UInt32			nodeSize;				// number of Bytes in this node record including subdirs
	tRFINode 		*parent;				// parent ID of this item

	UInt32			numItems;				// number of items if this is a directory

	long			crDate;					// creation date
	long			mdDate;					// modification date

	// used by root dir only
	short			rfRefNum;				// these are used by the root info only
	short			reserved;
	
	// Fields used by resources only:
	OSType			resType;				// type of this resource
	ResID			resID;					// id of this resource
	SInt16			resAttrs;				// resource attrs
	UInt32			resSize;				// size of resource in bytes
	UInt32			rfOffset;				// offset of resource data in file
	OSType			fileType;				// FInfo type for this item
	OSType			fileCreator;			// FInfo creator for this item
	
};
typedef tRFINode * tRFINodePtr;
