#!perl -w
# Special MPW glue
undef;

# Premake.pl

use strict;

use FileHandle;

use MakeSource;
use MakeImports;

Main();

sub Main {
	my $rulesdir = $ENV{RULESDIR};
	my $srclist = ":Manifest:Source.list";
	my $importsSCF = ":Manifest:Imports.scf";
	my $srcMk = $rulesdir . "Sources.mk";
	my $importsMk = $rulesdir . "Imports.mk";
	
	if (!-e $srcMk || ModificationDate($srcMk) < ModificationDate($srclist)) {
		my $output = MakeSource($srclist);
		my $out = new FileHandle $srcMk, ">";
		defined $out or die "Couldn't write '$srcMk'";
		print $out @$output;
	}
	if (!-e $importsMk || ModificationDate($importsMk) < ModificationDate($importsSCF)) {
		my $output = MakeImports($importsSCF);
		my $out = new FileHandle $importsMk, ">";
		defined $out or die "Couldn't write '$importsMk'";
		print $out @$output;
	}
}

sub ModificationDate {
	my ($file) = @_;
	return (stat $file)[9];
}
