/*	=============
 *	AEAHandler.hh
 *	=============
 */

#pragma once

#include <AppleEvents.h>
#include <Errors.h>

#include "NGLList.hh"

class AEADescAppleEvent;

class AEAHandler {
// Member functions
public:
	AEAHandler(AEEventClass inEventClass, AEEventID inEventID);
	virtual ~AEAHandler();
	
	virtual void HandleEvent(const AEADescAppleEvent &inAppleEvent, AEADescAppleEvent &outReply);
	virtual void HandleEventSelf(const AEADescAppleEvent &inAppleEvent, AEADescAppleEvent &outReply);
	virtual void TouchParameters(const AEADescAppleEvent &inAppleEvent);
	virtual void MakeNoteToTouchParam(AEKeyword inParamKey);
protected:
	static pascal OSErr GenericAEHandler(const AppleEvent *inAppleEvent, AppleEvent *outReply, long int inRefCon);
	static AEEventHandlerUPP sAEEventHandlerUPP;
	virtual void Install();
	virtual void Remove();
// Data members
protected:
	AEEventClass mEventClass;
	AEEventID mEventID;
	NGLList<AEKeyword> mParamsToTouch;
};
