/*	===============
 *	AEAMetatoken.hh
 *	===============
 *	
 *	Implemented by AEAMetatoken.cc
 */

#pragma once

#include "AEADebugging.h"

#include <AppleEvents.h>

class AEAToken;

class AEAMetatokenX {
	friend class AEAMetatoken;
private:
	AEAMetatokenX(AEAToken &inToken);
	virtual ~AEAMetatokenX();
	
	virtual void Retain();
	virtual void Release();
	
private:
	long refCount;
	bool owned;
	AEAToken *mToken;
};


class AEAMetatoken {
public:
	AEAMetatoken();
	AEAMetatoken(const AEAMetatoken &inMetatoken);
	AEAMetatoken(AEDesc inAEDesc);
	virtual ~AEAMetatoken();
	virtual AEAMetatoken operator=(const AEAMetatoken &inMetatoken);
	virtual void MakeDataDescriptor(AEDesc &outAEDesc);
	virtual AEAToken &Ref();
	
protected:
	static AEAToken *NewToken(const AEDesc &inAEDesc);
	
protected:
	AEAMetatokenX &mX;
	
};
