/*	==============
 *	AEAModelSub.cc
 *	==============
 */

#include "AEADebugging.h"

#include <AEBuild.h>

#include "AEAModelSub.hh"
#include "AEATokenModel.hh"
#include "AEADesc.hh"

void
AEAModelSub::GetKeyData(DescType inKeyForm, AEDesc &outAEDesc) const
{
	outAEDesc.descriptorType = typeNull;
	outAEDesc.dataHandle = NULL;
}

void
AEAModelSub::GetContainerObjSpec(AEDesc &containerSpec) const
{
	Container().MakeObjSpecifier(containerSpec);
}

void
AEAModelSub::MakeObjSpecifier(AEDesc &outAEDesc) const
{
	OSErr err;
	AEDesc containerSpec;
	DescType keyForm;
	AEADesc keyData;
	
	keyForm = PreferredKeyForm();
	GetKeyData(keyForm, keyData.Ref());
	
	GetContainerObjSpec(containerSpec);
	
	err = ::AEBuild(&outAEDesc, 
		"obj{want:type(@), form:enum(@), seld:@, from:@}", 
		Class(), 
		keyForm, 
		&keyData.Ref(), 
		&containerSpec);
	ThrowIfOSErr_(err);
}
