/*	==========
 *	C3DPort.hh
 *	==========
 *	
 *	Implemented by C3DPort.cc
 */

#pragma once

//#include "PedObject.hh"

#include "NGLList.hh"


enum {
	cmdMoveLeft,
	cmdMoveRight,
	cmdMoveUp,
	cmdMoveDown,
	cmdMoveForward,
	cmdMoveBackward,
	cmdYawLeft,
	cmdYawRight,
	cmdPitchUp,
	cmdPitchDown,
	cmdRollLeft,
	cmdRollRight,
	cmdExpand,
	cmdContract
};

class C3DModel;
class C3DPoint;
class C3DCamera;

class C3DPort /*: public PedObject*/ {
public:
	C3DPort(C3DModel &inModel);
	virtual ~C3DPort();
	virtual void SetCamera(C3DCamera *inCamera);
	virtual void SendCameraCommand(short inCmd);
	virtual void GetCameraFrame();
public:
	C3DModel &mModel;
	C3DCamera *mCamera;
	NGLList<C3DPoint *> mPoints;
};
