/* C3DMatrix.cc */

#include <math.h>
#include <stddef.h>
#include "C3DGeometry.hh"

C3DTranslation::C3DTranslation(double dx, double dy, double dz)
{
	Cell(3, 0) = dx;
	Cell(3, 1) = dy;
	Cell(3, 2) = dz;
	Cell(3, 3) = 1;
}

C3DYaw::C3DYaw(double theta)
{
	Cell(0, 0) = cos(theta);
	Cell(0, 1) = -sin(theta);
	Cell(1, 0) = sin(theta);
	Cell(1, 1) = cos(theta);
}

C3DPitch::C3DPitch(double phi)
{
	Cell(1, 1) = cos(phi);
	Cell(1, 2) = -sin(phi);
	Cell(2, 1) = sin(phi);
	Cell(2, 2) = cos(phi);
}

C3DRoll::C3DRoll(double psi)
{
	Cell(0, 0) = cos(psi);
	Cell(0, 2) = sin(psi);
	Cell(2, 0) = -sin(psi);
	Cell(2, 2) = cos(psi);
}

C3DScale::C3DScale(double factor)
{
	Cell(0, 0) = factor;
	Cell(1, 1) = factor;
	Cell(2, 2) = factor;
}
