/* versionmacros.h */

#ifndef VERSIONMACROS_H
#define VERSIONMACROS_H

#ifndef VERSION_MAJOR
#define VERSION_MAJOR 0
#endif
#ifndef VERSION_MINOR
#define VERSION_MINOR 0
#endif
#ifndef VERSION_MAINT
#define VERSION_MAINT 0
#endif
#ifndef VERSION_PHASE
#define VERSION_PHASE
#endif
#ifndef VERSION_BUILD
#define VERSION_BUILD
#endif

#define VERSION_WORD ((VERSION_MAJOR) << 8 + (VERSION_MINOR) << 4 + VERSION_BUILD)
#define VERSION_LONG ((VERSION_MAJOR) << 16 + (VERSION_MINOR) << 8 + VERSION_BUILD)

#define QUOTE(str) #str
#define VersionString_(major, minor, maint, phase, build) \
	QUOTE(major) "." QUOTE(minor) "." QUOTE(maint) QUOTE(phase) QUOTE(build)
#define VERSION_STRING VersionString_( \
	VERSION_MAJOR, VERSION_MINOR, VERSION_MAINT, VERSION_PHASE, VERSION_BUILD)

#endif
