/* source.cc */

#include <stdio.h>

#include <Errors.h>

#include "MoreFilesExtras.h"

#include "PedestalDebugging.h"
#include "pstring.h"

#include "SiesString.hh"

#include "PedFSRef.hh"
#include "PedDataSourceFile.hh"
#include "PedStreamInputBufferedText.hh"

#include "pathnames.hh"

#define NAM

#ifdef NAM
extern "C" int source_main(int argc, char *argv[]);
#else
#define source_main main
#endif

static int DumpFile(
	short vol, long dir, const unsigned char *name);
	
int source_main(int argc, char *argv[])
{
	OSErr err;
	FSDirSpec cwdir = {0, 0, 0}, *cwdp;
	FSDirSpec srcDir;
	SiesString str;
	Str31 name;
	int index, fail;
	
	// Current working directory: either passed 'under the table' or set to default.
	cwdp = (argv[-1] != NULL) ? (FSDirSpec *)argv[-1] : (&cwdir);
	
	// Check for sufficient number of args
	if (argc < 2) {
		fprintf(stderr, "source: missing arguments\n");
		return 1;
	}
	
	fail = 0;
	err = UnixRelativePathname2DirAndName(*cwdp, argv[index], srcDir, str); 
	str.GetPStr(name, 31);
	if (err == noErr)
		fail += SourceFile(srcDir.vRefNum, srcDir.dirID, name);
	else  {
		fprintf(stderr, "source: %s: %s\n", argv[index], "No such file or directory");
		fail++;
	}
	return (fail == 0) ? 0 : 1;
}

int SourceFile(
	short vol, long dir, const unsigned char *inName)
{
	OSErr err;
	Boolean isDir;
	
	try {
		PedFSRef ref(vol, dir, inName);
		PedDataSourceFile source(ref);
		PedStreamInputBufferedText stream(source);
		PedDispenserString dispenser(stream);
		
		SiesString string("\p");
		stream.Flush();
		while (dispenser.GetString(string)) {
			long result = ::ExecuteCommand(string);
		}
		
	} catch (ExceptionCode err) {
		char name[32];
		strPcpy(name, inName);
		fprintf(stderr, "wish: %s: %s %ld\n", name, "exception", err);
		return 1;
	}
	return 0;
}
