/*	=================
 *	Ped1AppProcess.hh
 *	=================
 *	
 *	Implemented by Ped1AppProcess.cc
 */

#pragma once

// Mac OS Universal Headers
#include <Files.h>

// AEA
#include "AEAModelRoot.hh"

// Pedestal
#include "PedMenuBar.hh"

typedef short AccessPath;

class PedApplication;

enum EProcessState {
	kProcessNull,
	kProcessInstantiated,
	kProcessInitializing,
	kProcessReady,
	kProcessRunning,
	kProcessExiting
};

class Ped1AppProcess {
public:
	// Constructor & destructor.
	Ped1AppProcess();
	virtual ~Ped1AppProcess();
	
	virtual void Init();
	virtual void Call(PedApplication &inApp);
	virtual void Call();
	
	virtual AccessPath ResFileAccessPath() {return mResFile;}
	virtual const FSSpec &FSS() {return mFSS;}
	virtual const VersRec &Version() {return mVersion;}
	
	static Ped1AppProcess &Me();
	virtual PedApplication &MainModule();
	
protected:
	static Ped1AppProcess *sMe;
	static EProcessState sProcessState;
	
protected:
	AccessPath mResFile;
	FSSpec mFSS;
	VersRec mVersion;
	PedApplication *mMainModule;
};
