/*	============
 *	PedAccess.hh
 *	============
 *	
 *	Implemented by PedAccess.cc
 */

#pragma once

#include <Types.h>

#include "PedObject.hh"

class PedFSRef;


typedef short AccessPath;
typedef SInt8 AccessPerm;


class PedAccess : public PedObject {
public:
	PedAccess(AccessPath inAccess);
	virtual ~PedAccess();
	
	virtual void Close() = 0;
	
protected:
	AccessPath mAccess;
	bool mPrivate;
};


class PedAccessRaw : public PedAccess {
protected:
	PedAccessRaw(AccessPath inAccess);
	virtual ~PedAccessRaw();
	
public:
	virtual void Close();
	
	virtual long Read(long inCount, char *inBuf);
	
};


class PedAccessData : public PedAccessRaw {
public:
	PedAccessData(AccessPath inAccess);
	PedAccessData(const PedFSRef &inFSRef, AccessPerm inPerm);
	virtual ~PedAccessData();
	
};


class PedAccessRF : public PedAccessRaw {
public:
	PedAccessRF(AccessPath inAccess);
	PedAccessRF(const PedFSRef &inFSRef, AccessPerm inPerm);
	virtual ~PedAccessRF();
	
};


class PedAccessRes : public PedAccess {
public:
	PedAccessRes(AccessPath inAccess);
	PedAccessRes(const PedFSRef &inFSRef, AccessPerm inPerm);
	virtual ~PedAccessRes();
	
	virtual void Close();
	
};
