/*	===========
 *	PedFSRef.hh
 *	===========
 *	
 *	Implemented by PedFSRef.cc
 */

#pragma once

#include <Types.h>
#include <Files.h>

#include "PedObject.hh"

typedef short AccessPath;

class PedFSRef : public PedObject {
public:
	PedFSRef();
	PedFSRef(const FSSpec &inFSS);
	PedFSRef(short inVRefNum, long inDir, const char *inName);
	PedFSRef(short inVRefNum, long inDir, const unsigned char *inName);
	PedFSRef(const char *inPathname);
	PedFSRef(const unsigned char *inPathname);
	virtual ~PedFSRef();
	
	virtual const FSSpec &FSS() const;
	virtual void SetFSSpec(const FSSpec &inFSS);
	virtual void SetVolDefault(short inVRefNum);
	virtual void SetVolRoot(short inVRefNum);
	virtual void SetVolDir(short inVRefNum, long inDir);
	virtual void SetVolDirName(short inVRefNum, long inDir, const char *inName);
	virtual void SetVolDirName(short inVRefNum, long inDir, const unsigned char *inName);
	virtual void SetPathname(const char *inPathname);
	virtual void SetPathname(const unsigned char *inPathname);
	
	virtual bool Exists();
	virtual bool IsFile();
	virtual bool IsDirectory();
	
	virtual void CreateFile(OSType inCreator, OSType inType);
	virtual void CreateDirectory();
	
	virtual AccessPath OpenData(SInt8 inPerm) const;
	virtual AccessPath OpenRF(SInt8 inPerm) const;
	virtual AccessPath OpenResFile(SInt8 inPerm) const;
	
	virtual PedFSRef &operator-(short inLevels);
	virtual PedFSRef &operator-=(short inLevels);
	virtual PedFSRef &operator--();
	
	virtual PedFSRef &operator+(const char *inName);
	virtual PedFSRef &operator+(const unsigned char *inName);
	virtual PedFSRef &operator+=(const char *inName);
	virtual PedFSRef &operator+=(const unsigned char *inName);
	
protected:
	FSSpec mFSS;
};
