/*	==========
 *	PedPane.hh
 *	==========
 *
 *	Implemented by PedPane.cc
 */

#pragma once

#include <Events.h>

#include "PedObject.hh"

class PedView;

class PedPane : public PedObject {
public:
	PedPane(PedView &inSuperView);
	virtual ~PedPane();
	
	virtual void Dispose();
	
	virtual void GetBounds(Rect &outBounds);
	virtual void SetBounds(const Rect &inBounds);
	virtual void GetAperture(Rect &outAperture);
	virtual void SetAperture(const Rect &inAperture);
	virtual bool PointInBounds(Point inPoint);
	virtual bool PointInAperture(Point inPoint);
	
	virtual void Open();
	virtual void Close();
	virtual void Activate();
	virtual void Deactivate();
	
	virtual void Resize(short inWidth, short inHeight);
	virtual void DrawContent();
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	virtual void DispatchKey(EventRecord &inEvent);
	virtual void DoKey(char inChar) {}
	
	virtual void Cut();
	virtual void Copy();
	virtual void Paste();
	virtual void Clear();
	
protected:
	virtual void Draw();
	
	PedView &mSuperView;
	Rect mBounds;  // Bounds of this pane, in superview coordinates
	Rect mAperture;  // The visible area of this pane
};
