/*	=========================
 *	PedStreamInputBuffered.hh
 *	=========================
 *	
 *	Implemented by PedStreamInputBuffered.cc
 */

#pragma once

#include "NGLList.hh"
#include "PedStreamInput.hh"

class PedBuffer;
class PedDataSource;

class PedStreamInputBuffered : public PedStreamInput {
public:
	PedStreamInputBuffered(PedDataSource &inDataSource);
	virtual ~PedStreamInputBuffered();
	
	virtual short Flush();
	virtual short GetByte();
	virtual short Unget();
	virtual long GetChunk(long inCount, char *inBuf);
	
	virtual long SizeOfNextChunk();
	virtual long CountAheadThroughChar(char inChar);
	//virtual bool AtEOF();
	
	virtual short GetRawByte();
	virtual PedBuffer *NextBuffer();
	virtual void ReadMore();
	
protected:
	PedDataSource &mDataSource;
	PedBuffer *mCurrentBuffer;
	NGLList<PedBuffer *> mBufferChain;
	long mMark;
	bool mCanUnget;
	//bool mEOF;
};
