/*	================
 *	PedViewScroll.hh
 *	================
 *	
 *	Implemented by PedViewScroll.cc
 */

#pragma once

#include <Events.h>
#include <Types.h>

#include "PedViewSub.hh"

class PedScrollbar;
class PedViewScroller;

class PedViewScroll : public PedViewSub {
public:
	PedViewScroll(PedPaneSubView &inSuperPane);
	virtual ~PedViewScroll();
	
	virtual void Dispose();
	
	virtual long Message(long inMsgCode, void *inData);
	
	//virtual bool IsInExistence() {return false;}
	virtual void GetScrollPos(Point &outPos);
	virtual void GetFrame(Rect &outFrame);
	//virtual void SetScrollPos(const Point &inPos);
	virtual void GetWindowToLocalOffset(Point &outOffset);
	
	virtual PedPane *Pane();
	virtual void SetPane(PedPane *inPane);
	virtual void SetScroller(PedViewScroller *inScroller);
	
	virtual void Focus();
	virtual void Open();
	virtual void Close();
	virtual void Activate();
	virtual void Deactivate();
	virtual void DrawContent();
	virtual void DoScroll(short inH, short inV);
	virtual void Scroll(short inH, short inV, bool inUpdate = 0);
	virtual void Resize(short inWidth, short inHeight);
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	virtual void DispatchKey(EventRecord &inEvent);
	
protected:
	PedPane *mPane;
	Point mScrollPos;
	PedViewScroller *mScroller;  // optional
};
