/*	================
 *	PedMenuEdit.cpp
 *	================
 */

#include "PedestalDebugging.h"

#include "PedMenuEdit.hh"
#include "PedCommand.hh"

enum {
	idAppleMENU = 128, // menu ID = 1
	idFileMENU,
	idEditMENU
};


PedMenuEdit::PedMenuEdit()
: mUndoCmd(NULL), mCutCmd(NULL), mCopyCmd(NULL), mPasteCmd(NULL), mClearCmd(NULL)
, mSelectAllCmd(NULL)
{
	GetFromResource(idEditMENU);
}

void
PedMenuEdit::InstallCommand(PedCommand *inCmd, CmdCode inCode)
{
	switch (inCode) {
		case 'undo':
			mUndoCmd = inCmd;
			break;
		case 'cut ':
			mCutCmd = inCmd;
			break;
		case 'copy':
			mCopyCmd = inCmd;
			break;
		case 'pste':
			mPasteCmd = inCmd;
			break;
		case 'clea':
			mClearCmd = inCmd;
			break;
		case 'slct':
			mSelectAllCmd = inCmd;
			break;
		default:
			break;
	}
}

void
PedMenuEdit::DoMenuItem(short inItem)
{
	PedCommand *cmd;
	
	switch (inItem) {
		case 1:
			cmd = mUndoCmd;
			break;
		case 3:
			cmd = mCutCmd;
			break;
		case 4:
			cmd = mCopyCmd;
			break;
		case 5:
			cmd = mPasteCmd;
			break;
		case 6:
			cmd = mClearCmd;
			break;
		case 7:
			cmd = mSelectAllCmd;
			break;
		default:
			cmd = NULL;
			break;
	}
	if (cmd)
		cmd->Execute();
}
