/*	==================
 *	PedPaneSubView.cc
 *	==================
 */

#include "PedestalDebugging.h"

#include "PedPaneSubView.hh"


PedPaneSubView::PedPaneSubView(PedView &inSuperView)
: PedPane(inSuperView), mSubView(NULL)
{
}

PedPaneSubView::~PedPaneSubView()
{
}

void
PedPaneSubView::Dispose()
{
	if (mSubView) {
		mSubView->Dispose();
		mSubView->release();
		mSubView = NULL;
	}
	PedPane::Dispose();
}

PedView &
PedPaneSubView::SuperView()
{
	return mSuperView;
}

void
PedPaneSubView::SetSubView(PedViewSub *inView)
{
	if (inView) {
		inView->retain();
	}
	if (mSubView) {
		mSubView->release();
	}
	mSubView = inView;
}

void
PedPaneSubView::Open()
{
	if (mSubView) {
		mSubView->Open();
	}
}

void
PedPaneSubView::Close()
{
	if (mSubView) {
		mSubView->Close();
	}
}

void
PedPaneSubView::Activate()
{
	if (mSubView) {
		mSubView->Activate();
	}
}

void
PedPaneSubView::Deactivate()
{
	if (mSubView) {
		mSubView->Deactivate();
	}
}

void
PedPaneSubView::Resize(short inWidth, short inHeight)
{
	PedPane::Resize(inWidth, inHeight);
	if (mSubView) {
		mSubView->Resize(inWidth, inHeight);
	}
}

void
PedPaneSubView::DrawContent()
{
	//Draw();
	if (mSubView) {
		mSubView->DrawContent();
	}
}

void
PedPaneSubView::DispatchNullEvent(EventRecord &inEvent)
{
	if (mSubView) {
		mSubView->DispatchNullEvent(inEvent);
	}
}

void
PedPaneSubView::DispatchClickEvent(EventRecord &inEvent)
{
	if (mSubView) {
		mSubView->DispatchClickEvent(inEvent);
	}
}

void
PedPaneSubView::DispatchKey(EventRecord &inEvent)
{
	if (mSubView) {
		mSubView->DispatchKey(inEvent);
	}
}
