/*	=======================
 *	PedStreamInputFilter.cc
 *	=======================
 */

#include <string.h>

#include "PedStreamInputFilter.hh"
#include "PedBuffer.hh"
#include "PedDataSource.hh"

PedStreamInputFilter::PedStreamInputFilter(PedStreamInput &inStream)
: mStream(inStream), mCanUnget(false), mUngotten(false), mUngetChar('\0')
{
	mStream.retain();
}

PedStreamInputFilter::~PedStreamInputFilter()
{
	mStream.release();
}

short
PedStreamInputFilter::Flush()
{
	mCanUnget = false;
	return mEOF ? -1 : 0;
}

short
PedStreamInputFilter::GetByte()
{
	if (mUngotten) {
		mUngotten = false;
		mCanUnget = true;
		return mUngetChar;
	}
	short c = FilterByte();
	if (c == -1) {
		mEOF = true;
		return -1;
	}
	mUngetChar = c;
	return c;
}

short
PedStreamInputFilter::Unget()
{
	if (!mCanUnget) {
		return -1;
	}
	mUngotten = true;
	mCanUnget = false;
	return 0;
}

short
PedStreamInputFilter::FilterByte()
{
	return mStream.GetByte();
}
