// =================================================================================
//	MyTypes.h	 				1998 Sustainable Softworks. All rights reserved.
// =================================================================================
// Basic types shared among different modules

#ifndef _H_MyTypes
#define _H_MyTypes
#pragma once
#pragma options align=power

typedef struct NetNumber {
	UInt32 address;
	UInt32 mask;
} NetNumber_t;

typedef struct PortRange {
	UInt16 hi;
	UInt16 lo;
} PortRange_t;

struct xEndpoint {
	UInt32	address;
	UInt16	port;
};
typedef struct xEndpoint xEndpoint_t;

#define kNatNumDim 4	// MAX number of NAT interfaces
struct proxy_names {
	UInt32		NatPortName[kNatNumDim];
	UInt32		NatIPAddr[kNatNumDim];
};
typedef struct proxy_names proxy_names_t;

struct PortMapEntry {		// size is 20 bytes.
	xEndpoint_t	apparent;
	UInt16		portRange;
	xEndpoint_t	actual;
	UInt16		age;
	UInt16		flags;
	UInt16		protocol;	// only need UInt8
//	UInt16		pad;		// pad to multiple of 4 bytes
};
typedef struct PortMapEntry PortMapEntry_t;

struct FilterEntry {	// size is 36 bytes
	UInt32		portName;	// hashed port name
	UInt16		flags;		// bit flags (direction, action, selectAddr)
	UInt16		protocol;	// tcp, udp, icmp, gre, any
	NetNumber_t	sourceNet;
	PortRange_t	sourcePorts;
	NetNumber_t	destNet;
	PortRange_t	destPorts;
	UInt16		pad;		// pad to 4 byte boundary
	UInt16		entryID;	// index for this entry
};
typedef struct FilterEntry FilterEntry_t;

// Ethernet Hardware Address
typedef struct MACAddr {
	UInt32	first4;
	UInt16	last2;
} MACAddr_t;

#pragma options align=native

#endif