// =================================================================================
//	NatDNS.h	 				2000 Sustainable Softworks. All rights reserved.
// =================================================================================
//	Network Address Translation DNS querries.
//	Block FAKE domain names of the form
//	<real-name>.dialing-please-wait-

#ifndef _H_NatDNS
#define _H_NatDNS
#pragma once

// dns protocol ports
#define kDNSServerPort	53

// Generic message descriptor
struct msg_descriptor {
	UInt8*	data;	// pointer to buffer containing message
	UInt32	size;	// size of message in buffer
	UInt16	offset;	// offset to next item in message
};
typedef struct msg_descriptor msg_descriptor_t;

Boolean IsFakeDNSLookup(msg_descriptor_t* md);

Boolean GetDName(msg_descriptor_t* md, Str255 outStr);

UInt8 IsFakeDialingName(Str255 inStr);

StringPtr CopyPStr(
	StringPtr	inSourceString,
	StringPtr	outDestString,
	SInt16		inDestSize);

StringPtr AppendPStr(
	Str255			ioBaseString,
	StringPtr		inAppendString,
	SInt16			inDestSize);

#endif