#define kJustDoItGestalt	'Nike'
#define kDeskAccessories	'DRVR'
#define kJustDoItCheckBoxItem 2

enum {
	eConfigureDialog = 128,
	eNotInstalled = 129
};

enum {
	eMenuBar = 128
};

enum {
	eAppleMenu = 1,
	eFileMenu = 2
};

enum {
	eAbout = 1
};

enum {
	eQuitting = 1
};


/* Prototypes */
void Initialize(void);
void InitApp(void);
SInt16 doDlgEvt (EventRecord *theEvent);
void DoMenuCommand(UInt32 menuCommand);


// 
//	Main body of program SillyBalls
//

ControlHandle gEnableCheckBoc = nil;
SInt16* gJustDoItPointer = nil;
Boolean gQuitting = false;


//MW specified argument and return type.
int main(void)
{
	DialogPtr theDialog;
	EventRecord	theEvent;
	WindowPtr whichWin;
	UInt32 menuResult;
	SInt16 dItem, winpart;
	OSErr err;
	char theKey;
	Boolean	evtOccured, filtered;

	Initialize();

	InitApp();

	err = Gestalt(kJustDoItGestalt, (long*)&gJustDoItPointer);
	
	if (err) {
		dItem = StopAlert(eNotInstalled, nil);
	}
	else {
		theDialog = GetNewDialog(eConfigureDialog, nil, (WindowPtr)-1);
		err = GetDialogItemAsControl(theDialog, kJustDoItCheckBoxItem, &gEnableCheckBoc);
		SetControlValue(gEnableCheckBoc, *gJustDoItPointer);

		err =  SetDialogDefaultItem	(theDialog, ok);
		
		while( !gQuitting ) {
			evtOccured =  WaitNextEvent( everyEvent, &theEvent, 0, nil);

			if (evtOccured) {
				filtered = StdFilterProc(theDialog, &theEvent, &dItem);
				if (filtered && dItem == ok) {
					gQuitting = true;
					continue;
				}

				switch ( theEvent.what ) {
					case keyDown:
						theKey = theEvent.message & charCodeMask;
						if ((theEvent.modifiers & cmdKey) != 0) {
							menuResult = MenuKey( theKey );
							if ( HiWord( menuResult) != 0 )	{
								DoMenuCommand( menuResult );
								HiliteMenu( 0 );
							}
						}
						break;

					case mouseDown:
						winpart = FindWindow(*((Point*)&theEvent.where),&whichWin);
						switch (winpart) {
							case inDrag:
								DragWindow(whichWin,*((Point*)&theEvent.where),&qd.screenBits.bounds);
								break;
								
							case inGoAway:
								if(TrackGoAway(whichWin,*((Point*)&theEvent.where))) {
									gQuitting = true;
								}
								break;
								
							case inMenuBar:
								menuResult = MenuSelect(*((Point*)&theEvent.where));
								if (HiWord(menuResult) != 0) {
									DoMenuCommand(menuResult);									
								}
								HiliteMenu(0);
								break;

							default:
								break;
						}
						break;
				}

				if ( IsDialogEvent( &theEvent) ) {
					SetCursor(&qd.arrow);
					doDlgEvt( &theEvent );
					continue;
				}
			}
		}

	}
	return 0;	
}


//MW specified argument and return type.
void Initialize(void)
{	
	/* Initialize all the needed managers. */
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();
}

void DoMenuCommand(UInt32 menuCommand)
{
	UInt16 theMenu, theItem;
	Str255 menuName;
	GrafPtr thePort;
	
	theMenu = HiWord(menuCommand);
	theItem = LoWord(menuCommand);
	GetMenuItemText(GetMenu(theMenu), theItem, menuName);

	switch (theMenu) {
		case eAppleMenu:
			switch (theItem) {
				case eAbout:
					SysBeep(1);
					break;
	
				default:
					GetPort(&thePort);
					OpenDeskAcc(menuName);
					SetPort(thePort);
					break;
			}
			break;

		case eFileMenu:
			switch (theItem) {
				case eQuitting:
					gQuitting = true;
					break;

				default:
					break;
			}
			break;
	}
}

void InitApp(void)
{
	SetMenuBar(GetNewMBar(eMenuBar));
	AppendResMenu(GetMenu(eAppleMenu), kDeskAccessories);
	DrawMenuBar();
}

SInt16 doDlgEvt(EventRecord *evp)
{
	DialogPtr whichDlg;
	SInt16 itemHit;
	char theKey;

	if ( evp->what == keyDown ) {
		if ( evp->modifiers & cmdKey ) {	/*command key pressed */
			theKey =  evp->message & charCodeMask;
			return(0);
		}
	}

	if (DialogSelect( evp, &whichDlg, &itemHit ) == FALSE )
		return(0);		/* no extra work needed ,  just return */

	if ( whichDlg) {			/* process the interaction */
		switch ( itemHit ) {
			case ok:
				gQuitting = true;
				return true;

			case kJustDoItCheckBoxItem:
				*gJustDoItPointer = *gJustDoItPointer ? 0 : 1;
				SetControlValue(gEnableCheckBoc, *gJustDoItPointer);
				return true;
		}	/* end of switch */
	}

	return 0;
}

