/*
 * Copyright (c) 1998-2000 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 *
 * The contents of this file constitute Original Code as defined in and
 * are subject to the Apple Public Source License Version 1.1 (the
 * "License").  You may not use this file except in compliance with the
 * License.  Please obtain a copy of the License at
 * http://www.apple.com/publicsource and read it before using this file.
 *
 * This Original Code and all software distributed under the License are
 * distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT.  Please see the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * @APPLE_LICENSE_HEADER_END@
 */

extern int mach_task_self(void);
extern int bootstrap_ports(int master, int *port, int *device,
			   int *wledger, int *pledger, int *security);

extern int host_processors(int port, int **procs, int *count);
extern int processor_start(int num);

int main(int argc, char **argv)
{
  int ret, count, *procs, port, device, wledger, pledger, security;
  
  printf("Starting Second CPU.\n", argv[0]);
  
  ret = bootstrap_ports(mach_task_self(), &port,
			&device, &wledger, &pledger, &security);
  
  count = 2;
  ret = host_processors(port, &procs, &count);
  
  ret = processor_start(procs[0]);
  
  return 0;
}
