#include <MacTypes.h>
#include <Quickdraw.h>
#include <QDOffscreen.h>

#include <LPeriodical.h>
#include <Timer.h>

#include "GDeviceUtils.h"

typedef UInt32 MultiMonitorEffectT;

enum
{
	kMultiMonitorCount			= 1
};

enum
{
	kEffectsTypeNormal			= 0,
	kEffectsTypeThrob			= 1,
	kEffectsTypeDontThrob		= 2
};

class MultiMonitorController
{
	public:
		MultiMonitorController();
		
		virtual
		~MultiMonitorController();
		
		static MultiMonitorController &
		GetInstance()
		{
			return *sMMController;
		}

		void
		Enable();

		void
		Disable();

		void
		SetEffectsType(
			MultiMonitorEffectT		inEffect);

		void
		SetEffectsValue(
			UInt32					inValueIndex,
			double					inValue);

		static void
		CursorTimer(
			TMTaskPtr 				inTimerTaskPtr);
		
	private:
		CapturedGDevice *					mCapturedDevice;

		VirtualGDevice *					mVirtualDevices[kMultiMonitorCount];
		
		MultiMonitorEffectT					mEffectType;
		
		static MultiMonitorController *		sMMController;
		static TMTask						sTimerTask;
		static TimerUPP						sTimerRoutineDescriptor;
};


