#include "bcd.h"

//////////////////////////////////////////////
//
//	NormalizeBCD
//
//////////////////////////////////////////////
UInt8 NormalizeBCD(UInt8 theNum)
{
	UInt8 low, hi;
	
	low = theNum & 0x0F;
	hi = theNum & 0xF0;

	if (low > 0x09) {
		low -= 0x0A;
		hi += 0x10;
	}
	if (hi > 0x90) {
		hi -= 0xA0;
	}
	return hi | low;
}

//////////////////////////////////////////////
//
//	ConvertNumToBCD
//
//////////////////////////////////////////////
UInt8 ConvertNumToBCD(UInt8 theNum)
{
	UInt8 low, hi;
	
	hi = theNum >> 4;
	low = theNum - (hi << 4);
	hi << 4;
	return hi | low;
}

//////////////////////////////////////////////
//
//	ConvertBCDToNum
//
//////////////////////////////////////////////
UInt8 ConvertBCDToNum(UInt8 theNum)
{
	UInt8 low, hi;
	
	low = theNum & 0x0F;
	hi = theNum & 0xF0;
	return hi*10 + low;
}
