#include <MacTypes.h>
#include <Quickdraw.h>
#include <QDOffscreen.h>

#include <LPeriodical.h>
#include <Timer.h>

#include "GDeviceUtils.h"

class MultiMonitorController
{
	public:
		MultiMonitorController();
		
		virtual
		~MultiMonitorController();
		
		static MultiMonitorController &
		GetInstance()
		{
			return *sMMController;
		}

		void
		Enable();

		void
		Disable();

		void
		EnableMagnify(
			Boolean					inEnable);

		static void
		CursorTimer(
			TMTaskPtr 				inTimerTaskPtr);
		
	private:
		CapturedGDevice *					mCapturedDevice;
		LargeBlendEffect *					mCurrentEffect;
		VirtualGDevice *					mVirtualDevice;
		
		static MultiMonitorController *		sMMController;
		static TMTask						sTimerTask;
		static TimerUPP						sTimerRoutineDescriptor;
};


