// Includes
#include <Events.h>
#include <Resources.h>
#include <Memory.h>
#include <ToolUtils.h>
#include <Sound.h>
#include <Gestalt.h>
#include <QDOffscreen.h>
#include <math64.h>
#include <CodeFragments.h>

/* Autre stuff.  Basically just makes sure that the correct code to patch the
   trap is for the right system.
*/
	#define SetCurrentA4() 0
	#define SetA4(x) 0
#define kLogReps 10 //the keys gathered before the result is logged
	ProcInfoType __procinfo = kCStackBased
			 | RESULT_SIZE(kFourByteCode)
			 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(void *)));

#ifndef kPowerPCArch
#define kPowerPCArch 'pwpc'
#endif

typedef struct {
	UInt32	fCode;
	UInt32	fData;
} TVec, *TVecPtr;


// Prototypes
pascal void (*gOldInitGraf)(void* qdGlobals);
pascal void NewInitGraf(void* qdGlobals);

OSErr InitLogFile( void );
void Do32BitBlockMove(register char* source, register char* dest, register unsigned long bytes );
UInt32 DoCompare(void* pParam1, void* pParam2);




enum {
	uppSystemEventProcInfo = kPascalStackBased | RESULT_SIZE(kTwoByteCode) | 
		STACK_ROUTINE_PARAMETER(1, kFourByteCode)
};


enum {
	kInitGrafInfo = kPascalStackBased | RESULT_SIZE(SIZE_CODE(0)) | 
		STACK_ROUTINE_PARAMETER(1, kFourByteCode)
};

typedef UInt32(*MyProcPtr)(void* pParam1, void* pParam2);
//typedef UInt32 (*MyProcPtr)(void* pParam1,pParam2);
// Constants


#pragma mark Globals
// globals
short				gLogFile = -1;
Ptr				gSysBuf = nil;
TVecPtr			gOldVec = nil;

void main(void)
{
	
	THz		oldZone;
	Handle	iCode = nil;
	OSErr		theErr = noErr;
	
	iCode = Get1Resource('INIT',0);
	DetachResource(iCode);
	HLock(iCode);
	if(!iCode)
	{
		Debugger();
		return;
	}
	
	oldZone = GetZone();						// get the old sone before we SetZone to SystemZone();
	SetZone(SystemZone());					// so we can restore it on the way out
	
	theErr = InitLogFile();
	if(theErr) Debugger();
	
	gSysBuf = NewPtrSys(1024 * 1024 * 16);
	if(gSysBuf) DebugStr("\pNo Buffer!");
	
	gOldInitGraf = (void *) GetToolTrapAddress(_InitGraf); // get old trap data into our var..

	SetToolTrapAddress(NewRoutineDescriptor((ProcPtr) &NewInitGraf,
	    kInitGrafInfo,kPowerPCISA), _InitGraf); 		// patch ourselves in.	
	
	SetZone(oldZone);							// restore old zone as we leave
}



OSErr InitLogFile( void )
{
	OSErr		theErr = noErr;
	FSSpec		logFile;
	
	short		sysVRefNum;
	long		sysDirID;
	
	
	
	
	
	theErr = FindFolder(kOnSystemDisk, kSystemFolderType, 
			kDontCreateFolder, &sysVRefNum, &sysDirID);
	
	
	theErr = FSMakeFSSpec(sysVRefNum, sysDirID, "\pVRAM Diffs.txt", &logFile); //6 chars long
	if ( theErr )
	{
		/*if( theErr == -48 )
		{
			theErr = FSpDelete( &logFile );
			if(theErr == 48) theErr = noErr;
		}*/
		
		if(theErr != -43) //-43 = file does not exist error
		{
			SysBeep(0);
			return theErr;
		}
		theErr = FSpCreate(&logFile, 'ttxt', 'TEXT', smSystemScript);
		if ( theErr != noErr)// && theErr != -48)
		{
			SysBeep(0);
			return theErr;
		}
	}
	
	theErr = FSpOpenDF(&logFile, fsWrPerm, &gLogFile);
	if( theErr != noErr )
	{
		SysBeep(0);
		return theErr;
	}
	theErr = SetFPos(gLogFile, fsFromLEOF,0);
	if( theErr != noErr )
	{
		SysBeep(0);
		return theErr;
	}
	return theErr;
}


pascal void NewInitGraf(void* qdGlobals)
{
	if((*(long*)0x0910) == 0x1A417070)
	{
		OSErr						theErr = noErr;
		CFragLoadOptions		findFlags =	1;//kFindCFrag;
		CFragConnectionID		connID = nil;
		Ptr						mainAddr;
		Str255					symName = "MCAM_ShowBuffer";
		CFragSymbolClass		symClass;
		Ptr						symAddr = nil;
		Str255						errStr;
		
		theErr = GetSharedLibrary("\pATI IDCT", kPowerPCArch, findFlags, &connID, &mainAddr, errStr);
		if(theErr) DebugStr("\pError, GetSharedLibrary!");
		
		theErr = GetIndSymbol(connID, 10, symName, &symAddr, &symClass); //10 = MCAM_ShowBuffer
		if(theErr) DebugStr("\pError, GetIndSymbol!");
		//we already know is a TVector
		
		
		
		gOldVec = (TVecPtr)NewPtrSys(sizeof(TVec));
		*gOldVec = *(TVecPtr)symAddr;
		
		(*(TVecPtr*)symAddr) = (TVecPtr)&DoCompare;
		
		
		
		BlockMoveData((Ptr)*((Ptr*)0x94008000),gSysBuf,1024 * 1024 * 16);
	}
	
	
	CallUniversalProc((RoutineDescriptor*)gOldInitGraf,kInitGrafInfo,qdGlobals);
}


UInt32 DoCompare(void* pParam1, void* pParam2)
{	
	long		n = 0;
	Str15		numStr;
	OSErr		theErr = noErr;
	long		bytes = 0;
	
	
	
	do{
		n++;
	}while(gSysBuf[n] == *((Ptr*)0x94008000)[n]);
	
	
	NumToString(n, numStr);
	bytes = numStr[0];
	theErr = FSWrite(gLogFile,&bytes,numStr + 1);
	if(theErr)Debugger();
	
	
	
	
	bytes = 1;
	theErr = FSWrite(gLogFile,&bytes,"\r");
	if(theErr)Debugger();
	
	n = 1024 * 1024 * 16 - 1;
	do{
		n--;
	}while(gSysBuf[n] == *((Ptr*)0x94008000)[n]);
	NumToString(n, numStr);
	bytes = numStr[0];
	theErr = FSWrite(gLogFile,&bytes,numStr + 1);
	if(theErr)Debugger();
	
	
	bytes = 2;
	theErr = FSWrite(gLogFile,&bytes,"\r\r");
	if(theErr)Debugger();
	
	
	
	return ((MyProcPtr)gOldVec)(pParam1,pParam2);
}