#include <MacTypes.h>
#include <StandardFile.h>

#include <stdio.h>
#include <SIOUX.h>

#include "QDMP.h"

typedef struct SWH_struce
{
	SInt32	fStart;
	SInt32	fWidth;
	SInt32	fHeight;
} SWH_Rec;

//static SWH_Rec gYhySWH = {158,736,480);
//static SWH_Rec gYouSWH = {421888,368,240);
//static SWH_Rec gVeeSWH = {532288,368,240);

static RGBColor YUV2RGBColor(UInt8 pY,UInt8 pU,UInt8 pV)
{
	RGBColor tRGBColor;
	UInt8 Y = pY,U = pU,V = pV;

	tRGBColor.blue =	1.164f * (pY - 16) 								+ 2.018f * (pU - 128);
	tRGBColor.green = 	1.164f * (pY - 16)		- 0.813f * (pV - 128) 	- 0.391f * (pU - 128);
	tRGBColor.red = 	1.164f * (pY - 16) 		+ 1.596f * (pV - 128);

	if (tRGBColor.red > 255)
		tRGBColor.red = 255;
	if (tRGBColor.green > 255)
		tRGBColor.green = 255;
	if (tRGBColor.blue > 255)
		tRGBColor.blue = 255;

	tRGBColor.red |= tRGBColor.red << 8;
	tRGBColor.green |= tRGBColor.green << 8;
	tRGBColor.blue |= tRGBColor.blue << 8;

	return tRGBColor;
}

int main(void)
{
	Str255 			tWindowTitle = "\pWhyYouVee";
	FSSpec 			tFSSpec;
	GDHandle 		tGDHdl = nil;
	PixMapHandle 	tPixMapHdl = nil;
	Rect 			tBounds;
	RGBColor 		tRGBColor = {0,0,0};
	SInt32			logEOF;
	SInt32			line,col;
	SInt32			width = 736,height = 480;
	SInt32			startYY = 158;
	SInt32			startU = 422623;
	SInt32			startV = 527870;
	SInt16			rowBytes;
	Ptr				tBufferPtr = nil;
	Ptr				baseAddr = nil;
	Boolean			loopFlag = true;
	short 			refNum;
	short			mode = 0;
	OSErr 			anErr = noErr;

	SIOUXSettings.autocloseonquit = false;
	SIOUXSettings.asktosaveonclose = false;
	SIOUXSettings.userwindowtitle = tWindowTitle;
	SIOUXSettings.columns = 80;
	SIOUXSettings.rows = 24;

	printf("Hello World, this is CodeWarrior!\n");

	do {
		anErr = FSMakeFSSpec(0, 0, "\p   FBI 2", &tFSSpec);
//		anErr = FSMakeFSSpec(0, 0, "\p USE ME", &tFSSpec);
		if (noErr != anErr) break;

		anErr = FSpOpenDF(&tFSSpec, fsRdPerm, &refNum);
		if (noErr != anErr) break;

		anErr = GetEOF(refNum, &logEOF);
		if (noErr != anErr) break;

		tBufferPtr = NewPtr(logEOF);
		if (nil == tBufferPtr) break;

		anErr = FSRead(refNum, &logEOF, tBufferPtr);
		if (nil == tBufferPtr) break;

		anErr = FSClose(refNum);
//		if (noErr != anErr) break;

		tGDHdl = GetGDevice();
		if (nil == tGDHdl) break;
		
		tPixMapHdl = (*tGDHdl)->gdPMap;
		if (nil == tPixMapHdl) break;

		tBounds = (*tPixMapHdl)->bounds;
		rowBytes = 0x3FFF & (*tPixMapHdl)->rowBytes;
		baseAddr = GetPixBaseAddr(tPixMapHdl);
loop:
#if 0
		if (width > (tBounds.right - tBounds.left))
			width = tBounds.right - tBounds.left;

		if (height > (tBounds.bottom - tBounds.top))
			height = tBounds.bottom - tBounds.top;

		for (line = 0;line < height;line++)
		{
			UInt8* scanPtr = (UInt8*) (tBufferPtr + (line * width) + startYY);
			for (col = 0;col < width;col++)
			{
				tRGBColor.red = tRGBColor.green = tRGBColor.blue = scanPtr[col] << 8;
				QDMP_Set_Pixel(tPixMapHdl,col,line,&tRGBColor);
			}
		}
#else
		for (line = 0;line < 480;line++)
		{
			UInt16* scanYPtr = (UInt16*) (tBufferPtr + (line * 736) + startYY);
			UInt8* scanUPtr = (UInt8*) (tBufferPtr + ((line / 2) * 368) + startU);
			UInt8* scanVPtr = (UInt8*) (tBufferPtr + ((line / 2) * 368) + startV);
			for (col = 0;col < 368;col++)
			{
				UInt16 YY = scanYPtr[col];
				UInt8 U = scanUPtr[col];
				UInt8 V = scanVPtr[col];

				QDMP_Set_Pixel(tPixMapHdl,(col * 2) + 0,line,&tRGBColor);
				tRGBColor = YUV2RGBColor(YY >> 8,U,V);
				tRGBColor = YUV2RGBColor(YY & 0xFF,U,V);
				QDMP_Set_Pixel(tPixMapHdl,(col * 2) + 1,line,&tRGBColor);
			}
		}
#endif 0
		printf("\nmode: %d, width: %d, height: %d, startY: %d, startU: %d, startV: %d",mode,width,height,startYY,startU,startV);
		fflush(stdout);
		while (loopFlag)
		{
			EventRecord theEvent;
			Boolean	gotEvent;

			gotEvent = WaitNextEvent(everyEvent, &theEvent, -1, nil);
			if ((keyDown == theEvent.what) || (autoKey == theEvent.what))
			{
				Boolean cmdKeyDown = (0 != (theEvent.modifiers & cmdKey));
				Boolean shiftKeyDown = (0 != (theEvent.modifiers & shiftKey));
				Point	delta;

				if (shiftKeyDown)
				{
					delta.v = height >> 3;
					delta.h = width >> 3;
				}
				else
				{
					delta.v = 1;
					delta.h = 1;
				}

				switch (theEvent.message & charCodeMask)
				{
					case	0x09:	// tab
						mode = (mode + 1) % 3;
						goto loop;
						break;
					case	0x20:	// space
						goto loop;
						break;
					case	0x1B:
						loopFlag = false;
						break;
					case	0x1C:	// left
						if (cmdKeyDown)
						{
							switch (mode % 3)
							{
							case	0:	// YY
								if (startYY >= delta.h)
									startYY -= delta.h;
								else
									startYY = 0;
								break;
							case	1:	// U
								if (startU >= delta.h)
									startU -= delta.h;
								else
									startU = 0;
								break;
							case	2:	// V
								if (startV >= delta.h)
									startV -= delta.h;
								else
									startV = 0;
								break;
							}
						}
						else
						{
							if (width >= delta.h)
								width -= delta.h;
							else
								width = 0;
						}
						goto loop;
						break;
					case	0x1D:	// right
						if (cmdKeyDown)
						{
							switch (mode % 3)
							{
							case 0:	// YY
								startYY += delta.h;
								break;
							case 1:	// U
								startU += delta.h;
								break;
							case 2:	// V
								startV += delta.h;
								break;
							}
						}
						else
							width += delta.h;
						goto loop;
						break;
					case	0x1E:	// up
						if (cmdKeyDown)
						{
							switch (mode % 3)
							{
							case 0:	// YY
								if (startYY >= delta.v * width)
									startYY -= delta.v * width;
								else
									startYY = 0;
								break;
							case 1:	// U
								if (startU >= delta.v * width)
									startU -= delta.v * width;
								else
									startU = 0;
								break;
							case 2:	// V
								if (startV >= delta.v * width)
									startV -= delta.v * width;
								else
									startV = 0;
								break;
							}
						}
						else
						{
							if (height >= delta.v)
								height -= delta.v;
							else
								height = 0;
						}
						goto loop;
						break;
					case	0x1F:	// down
						if (cmdKeyDown)
						{
							switch (mode % 3)
							{
							case 0:	// YY
								startYY += delta.v * width;
								break;
							case 1:	// U
								startU += delta.v * width;
								break;
							case 2:	// V
								startV += delta.v * width;
								break;
							}
						}
						else
							height += delta.v;
						goto loop;
						break;
				}
			}
			if (gotEvent)
				gotEvent = SIOUXHandleOneEvent(&theEvent);
		}		
	} while (false);
	return 0;
}