/**\
|**|	QDMP.h
\**/

#include <Quickdraw.h>

#if PRAGMA_ONCE
#pragma once
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT
#pragma import on
#endif

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=mac68k
#elif PRAGMA_STRUCT_PACKPUSH
	#pragma pack(push,2)
#elif PRAGMA_STRUCT_PACK
	#pragma pack(2)
#endif

#define QDMP_DegreesToRadians(x)		((float)((x) * 3.1415926535898f / 180.0f))

extern OSStatus QDMP_Init(void);

extern void QDMP_Set_Rect(Rect *pRectPtr,const SInt16 pLeft,const SInt16 pTop,const SInt16 pRight,const SInt16 pBottom);
extern void QDMP_Offset_Rect(Rect *pRectPtr,const SInt16 pDeltaH,const SInt16 pDeltaV);
extern void QDMP_Inset_Rect(Rect *pRectPtr,const SInt16 pDeltaH,const SInt16 pDeltaV);
extern Boolean QDMP_Intersect_Rects(const Rect* pRectA,const Rect* pRectB,Rect* pRectC);

extern Point QDMP_Set_Point(Point* pPoint,const SInt16 pH,const SInt16 pV);
extern Boolean QDMP_PointInRect(const Point pPoint,const Rect* pRect);
extern Point QDMP_MidPoint(const Point pPointA,const Point pPointB);
extern Point QDMP_MidPointRect(const Rect* pRect);

extern RGBColor QDMP_Get_Pixel(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV);
extern UInt32 QDMP_Get_Pixel32(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV);
extern UInt16 QDMP_Get_Pixel16(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV);
extern UInt8 QDMP_Get_Pixel8(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV);

extern RGBColor QDMP_Get_PixelP(PixMapHandle pPixMapHdl,const Point pPoint);
extern UInt32 QDMP_Get_PixelP32(PixMapHandle pPixMapHdl,const Point pPoint);
extern UInt16 QDMP_Get_PixelP16(PixMapHandle pPixMapHdl,const Point pPoint);
extern UInt8 QDMP_Get_PixelP8(PixMapHandle pPixMapHdl,const Point pPoint);

extern void QDMP_Set_Pixel(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const RGBColor* pColor);
extern void QDMP_Set_Pixel32(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt32 pColor);
extern void QDMP_Set_Pixel16(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt16 pColor);
extern void QDMP_Set_Pixel8(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt8 pColor);

extern void QDMP_Set_PixelP(PixMapHandle pPixMapHdl,const Point pPoint,const RGBColor* pColor);
extern void QDMP_Set_PixelP32(PixMapHandle pPixMapHdl,const Point pPoint,const UInt32 pColor);
extern void QDMP_Set_PixelP16(PixMapHandle pPixMapHdl,const Point pPoint,const UInt16 pColor);
extern void QDMP_Set_PixelP8(PixMapHandle pPixMapHdl,const Point pPoint,const UInt8 pColor);

extern void QDMP_Copy_Scan(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const SInt16 pSrcY,const SInt16 pSrcX1,const SInt16 pSrcX2,const SInt16 pDstY,const SInt16 pDstX1,const SInt16 pDstX2);
extern void QDMP_Copy_Scan32(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const SInt16 pSrcY,const SInt16 pSrcX1,const SInt16 pSrcX2,const SInt16 pDstY,const SInt16 pDstX1,const SInt16 pDstX2);
extern void QDMP_Copy_Scan16(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const SInt16 pSrcY,const SInt16 pSrcX1,const SInt16 pSrcX2,const SInt16 pDstY,const SInt16 pDstX1,const SInt16 pDstX2);
extern void QDMP_Copy_Scan8(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const SInt16 pSrcY,const SInt16 pSrcX1,const SInt16 pSrcX2,const SInt16 pDstY,const SInt16 pDstX1,const SInt16 pDstX2);

extern void QDMP_Copy_Scan32A(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const SInt16 pSrcY,const SInt16 pSrcX1,const SInt16 pSrcX2,const SInt16 pDstY,const SInt16 pDstX1,const SInt16 pDstX2);

extern void QDMP_Copy_Rect(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const Rect* pSrcRect,const Rect* pDstRect);
extern void QDMP_Copy_Rect8(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const Rect* pSrcRect,const Rect* pDstRect);
extern void QDMP_Copy_Rect16(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const Rect* pSrcRect,const Rect* pDstRect);
extern void QDMP_Copy_Rect32(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const Rect* pSrcRect,const Rect* pDstRect);
extern void QDMP_Copy_Rect32A(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl,const Rect* pSrcRect,const Rect* pDstRect);

extern void QDMP_Draw_Line(PixMapHandle pPixMapHdl,const SInt16 pX1,const SInt16 pY1,const SInt16 pX2,const SInt16 pY2,const RGBColor* pColor);
extern void QDMP_Draw_Line32(PixMapHandle pPixMapHdl,const SInt16 pX1,const SInt16 pY1,const SInt16 pX2,const SInt16 pY2,const UInt32 pColor);
extern void QDMP_Draw_Line16(PixMapHandle pPixMapHdl,const SInt16 pX1,const SInt16 pY1,const SInt16 pX2,const SInt16 pY2,const UInt16 pColor);
extern void QDMP_Draw_Line8(PixMapHandle pPixMapHdl,const SInt16 pX1,const SInt16 pY1,const SInt16 pX2,const SInt16 pY2,const UInt8 pColor);

extern void QDMP_Draw_LineP(PixMapHandle pPixMapHdl,const Point pPointA,const Point pPointB,const RGBColor* pColor);
extern void QDMP_Draw_LineP32(PixMapHandle pPixMapHdl,const Point pPointA,const Point pPointB,const UInt32 pColor);
extern void QDMP_Draw_LineP16(PixMapHandle pPixMapHdl,const Point pPointA,const Point pPointB,const UInt16 pColor);
extern void QDMP_Draw_LineP8(PixMapHandle pPixMapHdl,const Point pPointA,const Point pPointB,const UInt8 pColor);

extern void QDMP_Fill_Rect(PixMapHandle pPixMapHdl,const Rect pRect,const RGBColor* pColor);
extern void QDMP_Fill_Rect32(PixMapHandle pPixMapHdl,const Rect pRect,const UInt32 pColor);
extern void QDMP_Fill_Rect16(PixMapHandle pPixMapHdl,const Rect pRect,const UInt16 pColor);
extern void QDMP_Fill_Rect8(PixMapHandle pPixMapHdl,const Rect pRect,const UInt8 pColor);

extern void QDMP_Draw_Circle(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt16 pRadius,const RGBColor* pColor);
extern void QDMP_Draw_Circle32(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt16 pRadius,const UInt32 pColor);
extern void QDMP_Draw_Circle16(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt16 pRadius,const UInt16 pColor);
extern void QDMP_Draw_Circle8(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt16 pRadius,const UInt8 pColor);

extern void QDMP_Draw_CircleP(PixMapHandle pPixMapHdl,const Point pCenter,const UInt16 pRadius,const RGBColor* pColor);
extern void QDMP_Draw_CircleP32(PixMapHandle pPixMapHdl,const Point pCenter,const UInt16 pRadius,const UInt32 pColor);
extern void QDMP_Draw_CircleP16(PixMapHandle pPixMapHdl,const Point pCenter,const UInt16 pRadius,const UInt16 pColor);
extern void QDMP_Draw_CircleP8(PixMapHandle pPixMapHdl,const Point pCenter,const UInt16 pRadius,const UInt8 pColor);

extern void QDMP_Fill_Circle(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt16 pRadius,const RGBColor* pColor);
extern void QDMP_Fill_Circle32(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt16 pRadius,const UInt32 pColor);
extern void QDMP_Fill_Circle16(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt16 pRadius,const UInt16 pColor);
extern void QDMP_Fill_Circle8(PixMapHandle pPixMapHdl,const SInt16 pH,const SInt16 pV,const UInt16 pRadius,const UInt8 pColor);

extern void QDMP_Fill_CircleP(PixMapHandle pPixMapHdl,const Point pCenter,const UInt16 pRadius,const RGBColor* pColor);
extern void QDMP_Fill_CircleP32(PixMapHandle pPixMapHdl,const Point pCenter,const UInt16 pRadius,const UInt32 pColor);
extern void QDMP_Fill_CircleP16(PixMapHandle pPixMapHdl,const Point pCenter,const UInt16 pRadius,const UInt16 pColor);
extern void QDMP_Fill_CircleP8(PixMapHandle pPixMapHdl,const Point pCenter,const UInt16 pRadius,const UInt8 pColor);

extern void QDMP_Draw_Curve(PixMapHandle pPixMapHdl,const Point pPointA,const Point pPointB,const Point pPointC,const RGBColor* pColor);
extern void QDMP_DownMip32A(PixMapHandle pSrcPixMapHdl,PixMapHandle pDstPixMapHdl);

extern SInt16 QDMP_RandomSInt16(void);
extern SInt16 QDMP_Random_RangeSInt16(const SInt16 pMin,const SInt16 pMax);
extern SInt32 QDMP_Random_RangeSInt32(const SInt32 pMin,const SInt32 pMax);

extern RGBColor QDMP_Mix_RGBColors(const RGBColor pRGBColorA,const RGBColor pRGBColorB,const float pMix);
extern UInt32 QDMP_RGBColorDistance(const RGBColor pRGBColorA,const RGBColor pRGBColorB);

extern Boolean gMP_Flag;
#if __VEC__
extern Boolean gAltiVec_Flag;
#endif __VEC__

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=reset
#elif PRAGMA_STRUCT_PACKPUSH
	#pragma pack(pop)
#elif PRAGMA_STRUCT_PACK
	#pragma pack()
#endif

#ifdef PRAGMA_IMPORT_OFF
#pragma import off
#elif PRAGMA_IMPORT
#pragma import reset
#endif

#ifdef __cplusplus
}
#endif
