/*
	File:		SignatureToApp.h

	Contains:	

	Written by:	Jens Alfke 	

	Copyright:	Copyright  1991-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				7/27/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/

#ifndef __SIGNATURETOAPP__
	#define __SIGNATURETOAPP__

#ifndef __PROCESSES__
	#include <Processes.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef enum{
	Sig2App_FindProcess		=0,
	Sig2App_FindApplication,
	Sig2App_LaunchApplication
} Sig2App_Mode;

OSErr
SignatureToApp(	OSType sig,						// Signature of app
				ProcessSerialNumber *psn,		// Returns PSN of app (ignored if NULL)
				FSSpec *fileSpec,				// Returns location of app (ignored if NULL)
				Boolean *launched,				// Set to TRUE if I had to launch (ignored if NULL)
				Sig2App_Mode mode,				// Mode -- find proc/find app/launch app
				LaunchFlags launchControlFlags	// Launch control flags; see Process Mgr
			  );
#ifdef __cplusplus
}
#endif

#endif