// ActionLocus.h

#ifndef ActionLocus_h
#define ActionLocus_h

#ifndef Undoing_h
#include "Undoing.h"
#endif
#ifndef CommandHandler_h
#include "CommandHandler.h"
#endif
#ifndef Str_h
#include "Str.h"
#endif
#ifndef Action_h
#include "Action.h"
#endif

class ActionLocus: public CommandHandler< Undoing >
  {
	private:
		Action *action;
		String255 name;
		bool done;
		
	public:
		ActionLocus( Focus& );
	
		virtual bool ActionIsDone() const		{ return done; }
		virtual ConstData ActionName() const	{ return name; }
		
		virtual bool CanUndo() const;
		virtual void Undo();
		
		virtual bool CanRedo() const;
		virtual void Redo();

		void SetAction( bool done,
							 ConstStr255Param name = "\p",
							 Action& action = Action::Irreversible() );

		void CommitAction();
  };

#endif
