// Enableable.h

#ifndef Enableable_h
#define Enableable_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

class Enableable
  {
	private:
		bool enabled;

	protected:
		virtual void BeEnabled()				{}
		virtual void BeDisabled()				{}

		~Enableable()								{}
					
	public:
		Enableable( bool startEnabled )
		  : enabled( startEnabled )
		  {
			Assert( startEnabled == !!startEnabled );
		  }

		bool Enabled() const			{ return enabled; }
		void Enable();
		void Disable();
		void SetEnabled( bool b );
  };

#endif
