// SubWindowFocus.h

#ifndef SubWindowFocus_h
#define SubWindowFocus_h

#ifndef WindowFocus_h
#include "WindowFocus.h"
#endif
#ifndef TabKeys_h
#include "TabKeys.h"
#endif
#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef CommandLink_h
#include "CommandLink.h"
#endif

class SubWindowFocus: public Focus,
							 public Enableable,
							 public TabKeys
  {
	private:
		ListLink< SubWindowFocus > link;
		const ListOf< SubWindowFocus >& siblings;
		CommandLink<TabKeys> tabber;
	
	protected:
		virtual void BeEnabled();
		virtual void BeDisabled();
		
	public:
		SubWindowFocus( WindowFocus&, AtStart );
		SubWindowFocus( WindowFocus&, AtEnd a = atEnd );
		SubWindowFocus( WindowFocus&, Before, SubWindowFocus& );
		SubWindowFocus( WindowFocus&, After, SubWindowFocus& );

		SubWindowFocus( WindowFocus&, TabKeys&, AtStart );
		SubWindowFocus( WindowFocus&, TabKeys&, AtEnd a = atEnd );
		SubWindowFocus( WindowFocus&, TabKeys&, Before, SubWindowFocus& );
		SubWindowFocus( WindowFocus&, TabKeys&, After, SubWindowFocus& );
		
		virtual void TabForward( const KeystrokeEvent& );
		virtual void TabBackward( const KeystrokeEvent& );
		
		void PassFocusForward();
		void PassFocusBackward();
  };

#endif
