// Announcing.h

#ifndef Announcing_h
#define Announcing_h

#ifndef Announcer_h
#include "Announcer.h"
#endif

template < class ValueType > class Modifier;

template < class ValueType >
class Announcing: public Announcer
  {
	friend class Modifier< ValueType >;
	
	private:
		ValueType value;
	
	public:
		Announcing( const ValueType& initialValue )
		  : value( initialValue )
		  {}
		
		operator const ValueType&() const	{ return value; }
		const ValueType& Value() const		{ return value; }
		
		void operator=( const ValueType& newValue )
		  {
			value = newValue;
			Announce();
		  }
  };

#endif
