// Ear.h

#ifndef Ear_h
#define Ear_h

#ifndef EarBase_h
#include "EarBase.h"
#endif

template < class Head >
class Ear: public EarBase
  {
	typedef void (Head::*Nerve)();
	
	private:
		Head& head;
		const Nerve announcement;
		const Nerve destruction;
	
	public:
		Ear( Head& theHead, Nerve announce, Nerve destroy = 0 )
		  : EarBase(),
			 head( theHead ),
			 announcement( announce ),
			 destruction( destroy )
		  {
			Assert( announcement != 0 );
		  }
		
		Ear( const Announcer& announcer, Head& theHead, Nerve announce, Nerve destroy = 0 )
		  : EarBase( announcer ),
			 head( theHead ),
			 announcement( announce ),
			 destruction( destroy )
		  {
			Assert( announcement != 0 );
		  }
		
		virtual void HearAnnouncement()
		  {
			(head.*announcement)();
		  }
		
		virtual void HearDestruction()
		  {
			Assert( destruction != 0 );
			(head.*destruction)();
		  }
  };

#endif
