// EarBase.h

#ifndef EarBase_h
#define EarBase_h

#ifndef Announcer_h
#include "Announcer.h"
#endif
#ifndef ListLink_h
#include "ListLink.h"
#endif

class EarBase
  {
	private:
		ListLink<EarBase> link;
	
	protected:
		~EarBase();
	
	public:
		EarBase();
		EarBase( const Announcer& );
		
		bool Listening() const						{ return link.Owned(); }
		void ListenToNothing()						{ link.Owner().Remove( link ); }
		void ListenTo( const Announcer& a )
		  {
			a.ears.Add( link, afterEnd );
		  }
		
		virtual void HearAnnouncement() = 0;
		virtual void HearDestruction() = 0;
  };

#endif
