// PostponedEarBase.cp

#ifndef PostponedEarBase_h
#include "PostponedEarBase.h"
#endif

PostponedEarBase::PostponedEarBase( Functor< void(*)() >& action )
  : scheduler( action )
  {
  }

PostponedEarBase::PostponedEarBase( Functor< void(*)() >& action,
												const Announcer& announcer )
  : EarBase( announcer ),
	 scheduler( action )
  {
  }

PostponedEarBase::~PostponedEarBase()
  {
  }

void PostponedEarBase::HearAnnouncement()
  {
	if ( !scheduler.Pending() )
		scheduler.Schedule();
  }

void PostponedEarBase::HearDestruction()
  {
	Assert( 0 );
  }
