// AEParameter.cp

#ifndef AEParameter_h
#include "AEParameter.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif
#ifndef ConstData_h
#include "ConstData.h"
#endif
#ifndef AEEvent_h
#include "AEEvent.h"
#endif

void AEParameter::Remove()
  {
	Assert( !Event().IsNull() );
	ThrowOSError( AEDeleteParam( &Event(), Key().Key() ) );
  }

void AEParameter::operator=( const AEDescriptor& in )
  {
	Assert( !Event().IsNull() );
	ThrowOSError( AEPutParamDesc( &Event(), Key().Key(), &in ) );
  }

void AEParameter::Set( AEType type, ConstData data )
  {
	Assert( !Event().IsNull() );
	ThrowOSError( AEPutParamPtr( &Event(),
										  Key().Key(),
										  type.Type(),
										  data.Start(),
										  data.Length() ) );
  }
