// ConstAEAttribute.h

#ifndef ConstAEAttribute_h
#define ConstAEAttribute_h

#ifndef AEType_h
#include "AEType.h"
#endif
#ifndef AEKey_h
#include "AEKey.h"
#endif
#ifndef Data_h
#include "Data.h"
#endif
#ifndef AEAtomicType_h
#include "AEAtomicType.h"
#endif

class AEEvent;
class Buffer;

class ConstAEAttribute
  {
	private:
		const AEEvent& event;
		AEKey key;
	
	public:
		ConstAEAttribute( const AEEvent& theEvent, AEKey theKey )
		  : event( theEvent ),
			 key( theKey )
		  {}
		
		const AEEvent& Event() const		{ return event; }
		AEKey Key() const						{ return key; }
		
		bool Exists() const;
		
		uint32 Length() const;
		AEType Type() const;
		
		void operator>>( Data ) const;
		void operator>>( Buffer& ) const;

		void Get( AEType, Data ) const;
  };

#endif
