// ConstAEParameter.h

#ifndef ConstAEParameter_h
#define ConstAEParameter_h

#ifndef AEType_h
#include "AEType.h"
#endif
#ifndef AEKey_h
#include "AEKey.h"
#endif
#ifndef Data_h
#include "Data.h"
#endif

class AEEvent;
class Buffer;

class ConstAEParameter
  {
	private:
		const AEEvent& event;
		AEKey key;
	
	public:
		ConstAEParameter( const AEEvent& theEvent, AEKey theKey )
		  : event( theEvent ),
			 key( theKey )
		  {}
		
		const AEEvent& Event() const		{ return event; }
		AEKey Key() const						{ return key; }

		bool Exists() const;
				
		uint32 Length() const;
		AEType Type() const;
		
		void operator>>( Data ) const;
		void operator>>( Buffer& ) const;

		void Get( AEType, Data ) const;
  };

#endif
