// AppleEventHandler.h

#ifndef AppleEventHandler_h
#define AppleEventHandler_h

#ifndef AppleEventMethod_h
#include "AppleEventMethod.h"
#endif
#ifndef AppleEventLink_h
#include "AppleEventLink.h"
#endif

template < class Target >
class AppleEventHandler
  {
	private:
		AppleEventMethod<Target> method;
		AppleEventLink link;
		
	public:
		AppleEventHandler( AEVerb verb,
								 Target& target,
								 typename AppleEventMethod<Target>::Method function )
		  : method( target, function ),
			 link( verb, method )
		  {}

		AppleEventHandler( AEEventClass suite,
								 AEEventID event,
								 Target& target,
								 typename AppleEventMethod<Target>::Method function )
		  : method( target, function ),
			 link( AEVerb( suite, event ), method )
		  {}
  };

#endif
