// AppleEventMethod.h

#ifndef AppleEventMethod_h
#define AppleEventMethod_h

#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef AppleEventMethodBase_h
#include "AppleEventMethodBase.h"
#endif

template < class Target >
class AppleEventMethod: public AppleEventMethodBase
  {
	public:
		typedef void (Target::*Method)( const AEEvent&,
												  AEEvent& reply );
		
	private:
		Target& target;
		Method method;
	
	public:
		AppleEventMethod( Target& theTarget, Method theMethod )
		  : target( theTarget ),
			 method( theMethod )
		  {
			Assert( method != 0 );
		  }
		
		virtual void operator()( const AEEvent& event,
										 AEEvent& reply )
		  {
			(target.*method)( event, reply );
		  }
  };

#endif
