// AEList.cp

#ifndef AEList_h
#include "AEList.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif

AEList::AEList()
  {
	ThrowOSError( AECreateList( 0, 0, false, this ) );
  }

uint32 AEList::Length() const
  {
	Assert( !IsNull() );
	int32 length;
	ThrowOSError( AECountItems( this, &length ) );
	Assert( length >= 0 );
	return uint32( length );
  }

void AEList::Append( const AEDescriptor& in )
  {
	Assert( !IsNull() );
	ThrowOSError( AEPutDesc( this, 0, &in ) );
  }

void AEList::Append( AEType type, ConstData data )
  {
	Assert( !IsNull() );
	ThrowOSError( AEPutPtr( this,
									0,
									type.Type(),
									data.Start(),
									int32( data.Length() ) ) );
  }
