// AEList.h

#ifndef AEList_h
#define AEList_h

#ifndef AEDescriptor_h
#include "AEDescriptor.h"
#endif
#ifndef AEListItem_h
#include "AEListItem.h"
#endif

class AEList: public AEDescriptor
  {
	public:
		AEList();
		explicit AEList( const AEList& source )			: AEDescriptor( source )	{}

		explicit AEList( const AEDescriptor& item )		: AEDescriptor( item, StaticType() )	{}
		explicit AEList( const ConstAEListItem& item )	: AEDescriptor( item, StaticType() )	{}
		explicit AEList( const ConstAEMember& item )		: AEDescriptor( item, StaticType() )	{}
		explicit AEList( const ConstAEParameter& item )	: AEDescriptor( item, StaticType() )	{}
		explicit AEList( const ConstAEAttribute& item )	: AEDescriptor( item, StaticType() )	{}
		
		static AEType StaticType()									{ return AEType( typeAEList ); }
		bool TypeIsCorrect() const									{ return Type() == StaticType(); }
		
		uint32 Length() const;
		
		const ConstAEListItem operator[]( uint32 i ) const	{ return ConstAEListItem( *this, i ); }
		AEListItem operator[]( uint32 i )						{ return AEListItem( *this, i ); }
		
		void Append( const AEDescriptor& );
		void Append( AEType type, ConstData );
		
		// AEGetArray & AEPutArray left for another time.
  };

#endif
