// AEListItem.cp

#ifndef AEListItem_h
#include "AEListItem.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif
#ifndef ConstData_h
#include "ConstData.h"
#endif
#ifndef AEList_h
#include "AEList.h"
#endif

void AEListItem::Remove()
  {
	Assert( !List().IsNull() );
	ThrowOSError( AEDeleteItem( &List(), int32( Index() ) ) );
  }

void AEListItem::operator=( const AEDescriptor& in )
  {
	Assert( !List().IsNull() );
	ThrowOSError( AEPutDesc( &List(), int32( Index() ), &in ) );
  }

void AEListItem::Set( AEType type, ConstData data )
  {
	Assert( !List().IsNull() );
	ThrowOSError( AEPutPtr( &List(),
									int32( Index() ),
									type.Type(),
									data.Start(),
									int32( data.Length() ) ) );
  }
