// ConstAEListItem.h

#ifndef ConstAEListItem_h
#define ConstAEListItem_h

#ifndef AEType_h
#include "AEType.h"
#endif
#ifndef AEKey_h
#include "AEKey.h"
#endif
#ifndef Data_h
#include "Data.h"
#endif

class AEList;
class Buffer;

class ConstAEListItem
  {
	private:
		const AEList& list;
		uint32 index;
		
	public:
		ConstAEListItem( const AEList& theList, uint32 theIndex )
		  : list( theList ),
			 index( theIndex )
		  {}
		
		const AEList& List() const		{ return list; }
		uint32 Index() const				{ return index; }

		bool Exists() const;		
		
		uint32 Length() const;
		AEType Type() const;
		
		AEKey Key() const;
		
		void operator>>( Data ) const;
		void operator>>( Buffer& ) const;

		void Get( AEType, Data ) const;
  };

#endif
