// AppleEventRecorderList.h

#ifndef AppleEventRecorderList_h
#define AppleEventRecorderList_h

#ifndef ListOf_h
#include "ListOf.h"
#endif
#ifndef AppleEventHandler_h
#include "AppleEventHandler.h"
#endif
#ifndef AEAddress_h
#include "AEAddress.h"
#endif

class AppleEventRecorder;

class AppleEventRecorderList
  {
	private:
		ListOf<AppleEventRecorder> recorders;
		AppleEventHandler<AppleEventRecorderList> notifyRecording;
		const AEAddress thisProcess;
		
		AppleEventRecorderList();
		~AppleEventRecorderList();
		
		void StartRecording();
		void StopRecording();
		
		void RecordEvent( const AEEvent& event, AEEvent& reply );
		
	public:
		static AppleEventRecorderList& The();
		
		void Add( AppleEventRecorder& );
		void Remove( AppleEventRecorder& );
		void RemoveWithoutFlushing( AppleEventRecorder& );
		
		void Flush();
  };

#endif
