// ConstAEMember.h

#ifndef ConstAEMember_h
#define ConstAEMember_h

#ifndef AEType_h
#include "AEType.h"
#endif
#ifndef AEKey_h
#include "AEKey.h"
#endif
#ifndef Data_h
#include "Data.h"
#endif

class AEStruct;
class Buffer;

class ConstAEMember
  {
	private:
		const AEStruct& record;
		AEKey key;
	
	public:
		ConstAEMember( const AEStruct& theRecord, AEKey theKey )
		  : record( theRecord ),
			 key( theKey )
		  {}
		
		const AEStruct& Record() const	{ return record; }
		AEKey Key() const						{ return key; }
		
		bool Exists() const;
		
		uint32 Length() const;
		AEType Type() const;
		
		void operator>>( Data ) const;
		void operator>>( Buffer& ) const;

		void Get( AEType, Data ) const;
  };

#endif
