// Application.cp

#ifndef Application_h
#include "Application.h"
#endif
#ifndef Process_h
#include "Process.h"
#endif
#ifndef CursorController_h
#include "CursorController.h"
#endif
#ifndef DialogManagerUser_h
#include "DialogManagerUser.h"
#endif
#ifndef ProcessInfo_h
#include "ProcessInfo.h"
#endif
#ifndef ApplicationFocus_h
#include "ApplicationFocus.h"
#endif
#ifndef Quitter_h
#include "Quitter.h"
#endif

Application::Application( uint32 masterPointers,
								  uint32 extraStackSpace )
  : ApplicationBase( masterPointers, extraStackSpace ),
	 creatingLink( ApplicationFocus::The(), *this ),
	 openingLink(  ApplicationFocus::The(), *this ),
	 quittingLink( ApplicationFocus::The(), Quitter::The() )
  {
	Assert( !ProcessInfo::Application().OnlyBackground() );

	Assert( ProcessInfo::Application().NeedsSuspendResume() );
	Assert( ProcessInfo::Application().ActivatesOnResume() );
	
	DialogManagerUser();
	CursorController::The();
  }
