// ApplicationBase.h

#ifndef ApplicationBase_h
#define ApplicationBase_h

#ifndef ApplicationZoneUser_h
#include "ApplicationZoneUser.h"
#endif
#ifndef EventHandler_h
#include "EventHandler.h"
#endif
#ifndef PreparingToQuit_h
#include "PreparingToQuit.h"
#endif
#ifndef Broadcaster_h
#include "Broadcaster.h"
#endif
#ifndef Opening_h
#include "Opening.h"
#endif
#ifndef Creating_h
#include "Creating.h"
#endif
#ifndef CoreEventHandler_h
#include "CoreEventHandler.h"
#endif

class ApplicationBase: public ApplicationZoneUser,
							  public EventHandler,
							  public Opening,
							  public Creating,
							  public CoreEventHandler
  {
	private:
		static ApplicationBase *the;
		
		// not implemented:
			ApplicationBase( const ApplicationBase& );
			void operator=( const ApplicationBase& );
		
	protected:
		ApplicationBase( uint32 masterPointers = 128,
							  uint32 extraStackSpace = 0 );
		
		~ApplicationBase();
		
	public:
		static ApplicationBase& The() 	{ Assert( the != 0 ); return *the; }
		
		virtual void Run();

		virtual void OpenApplication( const AEEvent& event, AEEvent& reply );
		virtual void OpenDocuments(   const AEEvent& event, AEEvent& reply );
		virtual void PrintDocuments(  const AEEvent& event, AEEvent& reply );
		virtual void QuitApplication( const AEEvent& event, AEEvent& reply );
  };

#endif
