// ApplicationEventHandler.cp

#ifndef ApplicationEventHandler_h
#include "ApplicationEventHandler.h"
#endif
#ifndef UserState_h
#include "UserState.h"
#endif
#ifndef GlobalClipboard_h
#include "GlobalClipboard.h"
#endif
#ifndef ApplicationFocus_h
#include "ApplicationFocus.h"
#endif
#ifndef ResumeEvent_h
#include "ResumeEvent.h"
#endif

void ApplicationEventHandler::HandleSuspendEvent( const SuspendEvent& )
  {
	GlobalClipboard::Validate();
	ApplicationFocus::The().Suspend();
	UserState::The().Announce();
  }

void ApplicationEventHandler::HandleResumeEvent( const ResumeEvent& event )
  {
	if ( event.ConvertClipboard() )
		GlobalClipboard::Changed();

	ApplicationFocus::The().Resume();
	UserState::The().Announce();
  }
