// ClickHandler.cp

#ifndef ClickHandler_h
#include "ClickHandler.h"
#endif
#ifndef MenuBar_h
#include "MenuBar.h"
#endif
#ifndef MouseDownEvent_h
#include "MouseDownEvent.h"
#endif
#ifndef AbstractWindow_h
#include "AbstractWindow.h"
#endif
#ifndef WindowObject_h
#include "WindowObject.h"
#endif

void ClickHandler::HandleClickInDesktop( const MouseDownEvent& )
  {
  }

void ClickHandler::HandleClickInMenuBar( const MouseDownEvent& event )
  {
	MenuBar::The().Click( event );
  }

void ClickHandler::HandleClickInSystemWindow( const MouseDownEvent& event )
  {
	SystemClick( &event.AsReceived(), &event.Window().Port() );
  }

void ClickHandler::HandleClickInWindowContent( const MouseDownEvent& event )
  {
	LocateWindow( event.Window() ).ClickContent( event );
  }

void ClickHandler::HandleClickInDragRegion( const MouseDownEvent& event )
  {
	LocateWindow( event.Window() ).ClickDrag( event );
  }

void ClickHandler::HandleClickInGrowBox( const MouseDownEvent& event )
  {
	LocateWindow( event.Window() ).ClickGrow( event );
  }

void ClickHandler::HandleClickInCloseBox( const MouseDownEvent& event )
  {
	LocateWindow( event.Window() ).ClickClose( event );
  }

void ClickHandler::HandleClickInZoomIn( const MouseDownEvent& event )
  {
	LocateWindow( event.Window() ).ClickZoomIn( event );
  }

void ClickHandler::HandleClickInZoomOut( const MouseDownEvent& event )
  {
	LocateWindow( event.Window() ).ClickZoomOut( event );
  }
