// DiskInsertionEventHandler.cp

#ifndef DiskInsertionEventHandler_h
#include "DiskInsertionEventHandler.h"
#endif
#ifndef DiskInsertionEvent_h
#include "DiskInsertionEvent.h"
#endif
#ifndef PointObject_h
#include "PointObject.h"
#endif
#ifndef SplitIntegers_h
#include "SplitIntegers.h"
#endif
#ifndef DiskInsertionReceiver_h
#include "DiskInsertionReceiver.h"
#endif
#ifndef UserState_h
#include "UserState.h"
#endif

#include <DiskInit.h>

void DiskInsertionEventHandler::HandleDiskInsertionEvent( const DiskInsertionEvent& event )
  {
	OSErr initializationError = noErr;
	
	if ( event.MountError() != noErr )
	  {
		DILoad();
		static const PointObject where( 120, 120 );
		uint32 errorAndDrive = Combine( uint16( event.MountError() ), event.Drive() );
		initializationError = DIBadMount( where, int32(errorAndDrive) );
		DIUnload();
	  }
	
	DiskInsertionReceiver::Send( event, initializationError );
	UserState::The().Announce();
  }
