// EventHandler.h

#ifndef EventHandler_h
#define EventHandler_h

#ifndef MouseEventHandler_h
#include "MouseEventHandler.h"
#endif
#ifndef KeyEventHandler_h
#include "KeyEventHandler.h"
#endif
#ifndef NullEventHandler_h
#include "NullEventHandler.h"
#endif
#ifndef WindowEventHandler_h
#include "WindowEventHandler.h"
#endif
#ifndef DiskInsertionEventHandler_h
#include "DiskInsertionEventHandler.h"
#endif
#ifndef ApplicationEventHandler_h
#include "ApplicationEventHandler.h"
#endif
#ifndef HighLevelEventHandler_h
#include "HighLevelEventHandler.h"
#endif

struct EventRecord;

class EventHandler: public NullEventHandler,
						  public MouseEventHandler,
						  public KeyEventHandler,
						  public WindowEventHandler,
						  public DiskInsertionEventHandler,
						  public ApplicationEventHandler,
						  public HighLevelEventHandler
  {
	protected:
		~EventHandler()					{}
	
	public:
		virtual void HandleEvent( const EventRecord& );
		virtual void HandleOSEvent( const EventRecord& );
  };

#endif
