// KeyEventHandler.h

#ifndef KeyEventHandler_h
#define KeyEventHandler_h

class KeyDownEvent;
class KeyUpEvent;
class AutoKeyEvent;
class KeystrokeEvent;

class KeyEventHandler
  {
	protected:
		~KeyEventHandler()			{}
	
	public:
		virtual void HandleKeyDownEvent( const KeyDownEvent& );
		virtual void HandleKeyUpEvent( const KeyUpEvent& );
		virtual void HandleAutoKeyEvent( const AutoKeyEvent& );
		
		virtual void DispatchKeystroke( const KeystrokeEvent& );
		
		virtual void DispatchCommandKey( const KeystrokeEvent& );
		virtual void DispatchTypingKey( const KeystrokeEvent& );
		virtual void DispatchSpecialKey( const KeystrokeEvent& );
  };

#endif
