// WindowEventHandler.cp

#ifndef WindowEventHandler_h
#include "WindowEventHandler.h"
#endif
#ifndef AbstractWindow_h
#include "AbstractWindow.h"
#endif
#ifndef UserState_h
#include "UserState.h"
#endif
#ifndef ActivateEvent_h
#include "ActivateEvent.h"
#endif
#ifndef DeactivateEvent_h
#include "DeactivateEvent.h"
#endif
#ifndef UpdateEvent_h
#include "UpdateEvent.h"
#endif

void WindowEventHandler::HandleActivateEvent( const ActivateEvent& event )
  {
	event.Window().Activate();
	UserState::The().Announce();
  }

void WindowEventHandler::HandleDeactivateEvent( const DeactivateEvent& event )
  {
	event.Window().Deactivate();
	UserState::The().Announce();
  }

void WindowEventHandler::HandleUpdateEvent( const UpdateEvent& event )
  {
	event.Window().Update();
  }
