// WindowLocator.h

#ifndef WindowLocator_h
#define WindowLocator_h

#ifndef RedBlackLink_h
#include "RedBlackLink.h"
#endif

class AbstractWindow;
class WindowObject;

class WindowLocator
  {
	public:
		typedef RedBlackLinkTree< WindowObject *, AbstractWindow > TreeType;

	private:
		static TreeType& Tree();

	public:
		typedef RedBlackLink< WindowObject *, AbstractWindow > Registration;
		
		static void Register( Registration& );
		
		virtual AbstractWindow& LocateWindow( WindowObject& );
  };

#endif
