// BroadcastLink.h

#ifndef BroadcastLink_h
#define BroadcastLink_h

#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef Broadcaster_h
#include "Broadcaster.h"
#endif

template < class Protocol >
class BroadcastLink
  {
	typedef Broadcaster< Protocol > Source;
	
	private:
		ListLink< Protocol > link;
	
	public:
		BroadcastLink( Protocol& target )
		  : link( &target )
		  {}

		BroadcastLink( Protocol& target, const Source& source )
		  : link( &target )
		  {
			source.receivers.Add( link, afterEnd );
		  }

		bool Receiving() const						{ return link.Owned(); }
		void ReceiveNothing()						{ link.Owner().Remove( link ); }
		void ReceiveFrom( const Source& a )		{ a.receivers.Add( link, afterEnd ); }
  };

#endif
