// Broadcaster.h

#ifndef Broadcaster_h
#define Broadcaster_h

#ifndef ListOf_h
#include "ListOf.h"
#endif

template < class Protocol > class BroadcastLink;
template < class Protocol > class BroadcastLoop;

template < class Protocol >
class Broadcaster: private ListOf< Protocol >
  {
	friend class BroadcastLink< Protocol >;
	friend class BroadcastLoop< Protocol >;
	
	private:
		mutable ListOf< Protocol > receivers;
		
	public:
		void Send( void (Protocol::*message)() );
		
		// For more complex messages, use a BroadcastLoop.
  };

#endif
