// ClickCounter.h

#ifndef ClickCounter_h
#define ClickCounter_h

#ifndef Tick_h
#include "Tick.h"
#endif

class MouseDownEvent;
class MouseUpEvent;

class ClickCounter
  {
	private:
		static bool uncountedClickExists;
		static ClickCounter *lastClicked;
		static Tick mouseUpTime;
		
		uint32 count;
		
		// not implemented:
			ClickCounter( const ClickCounter& );
			void operator=( const ClickCounter& );
		
	public:
		ClickCounter()
		  : count( 0 )
		  {}
		
		~ClickCounter();
		
		static void Record( const MouseDownEvent& );
		static void Record( const MouseUpEvent& );
		
		void Reset()									{ count = 0; }
		
		void Count( const MouseDownEvent&, bool closeEnough = true );
		void TooFarAway();
		
		uint32 Total() const							{ return count; }
  };

#endif
