// Clipboard.h

#ifndef Clipboard_h
#define Clipboard_h

#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef ListOf_h
#include "ListOf.h"
#endif

class ScrapReader;
class ScrapWriter;

class Clipboard
  {
	private:
		ListLink< Clipboard > validLink;
		
		static Clipboard *unexported;
		static ListOf< Clipboard >& ValidList();
		
		// not implemented:
			Clipboard( const Clipboard& );
			void operator=( const Clipboard& );
		
	protected:
		~Clipboard();

		virtual void Import( const ScrapReader& ) = 0;
		virtual void Export( ScrapWriter& ) const = 0;
		virtual void Clear() = 0;
		
	public:
		Clipboard();
		
		bool Valid() const		{ return validLink.Owned(); }
		void Validate();
		void Invalidate();
		
		void MarkValid();
		void Changed();
		
		void Flush() const;

		static void InvalidateAll();
		static void FlushAll();
  };

#endif
