// Cutter.cp

#ifndef Cutter_h
#include "Cutter.h"
#endif
#ifndef Clipboard_h
#include "Clipboard.h"
#endif
#ifndef CantEditInBackground_h
#include "CantEditInBackground.h"
#endif
#ifndef ApplicationFocus_h
#include "ApplicationFocus.h"
#endif
#ifndef GlobalClipboard_h
#include "GlobalClipboard.h"
#endif

Cutter::Cutter( Clipboard& theClipboard )
  : clipboard( theClipboard ),
	 approved( false )
  {
	if ( !ApplicationFocus::The().Active() )
		throw CantEditInBackground();
	
	Clipboard::InvalidateAll();
	GlobalClipboard::Invalidate();
  }

Cutter::~Cutter()
  {
	if ( approved )
		clipboard.Changed();
	 else
	   try
	     {
			clipboard.Invalidate();
		  }
		 catch( ... )
		  {
		  }
  }
