// Cutter.h

#ifndef Cutter_h
#define Cutter_h

class Clipboard;

class Cutter
  {
	private:
		Clipboard& clipboard;
		bool approved;
				
		// not implemented:
			Cutter( const Cutter& );
			void operator=( const Cutter& );
		
	public:
		Cutter( Clipboard& );
		~Cutter();
		
		bool Approved() const	{ return approved; }
		void Approve()				{ approved = true; }
			/*
				If a change to a clipboard is not approved,
				the clipboard will be cleared and all 
				clipboards will be left invalid.
				Thus if an exception is thrown before approval,
				incomplete data won't be propagated.
			*/
  };

#endif
