// ScrapItem.h

#ifndef ScrapItem_h
#define ScrapItem_h

#ifndef ScrapType_h
#include "ScrapType.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

class MasterPointer;

class ScrapItem
  {
	private:
		const ScrapType type;
		bool exists;
		uint32 size;
		int32 offset;
		
		// not implemented:
			ScrapItem( const ScrapItem& );
			void operator=( const ScrapItem& );
		
	public:
		ScrapItem( const ScrapType& theType );
		
		bool Exists() const			{ return exists; }
		uint32 Size() const			{ Assert( exists ); return size; }
		
		void operator>>( MasterPointer& ) const;
  };

#endif
