// Commander.h

#ifndef Commander_h
#define Commander_h

#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef CommandLink_h
#include "CommandLink.h"
#endif

template < class Protocol >
class Commander
  {
	private:
		typedef CommandLink< Protocol > LinkType;
	
	public:
		Commander()
		  {
			Assert( LinkType::ActiveHandler() != 0 );
		  }
		
		Protocol& operator*()					{ Assert( !Null() ); return *LinkType::ActiveHandler(); }

		Protocol *operator->()					{ Assert( !Null() ); return LinkType::ActiveHandler(); }
		
		const Protocol& operator*() const	{ Assert( !Null() ); return *LinkType::ActiveHandler(); }
		
		const Protocol *operator->() const	{ Assert( !Null() ); return LinkType::ActiveHandler(); }

		static bool Null()						{ return LinkType::ActiveHandler() == 0; }
  };

#endif
