// Undoing.cp

#ifndef Undoing_h
#include "Undoing.h"
#endif

bool Undoing::CanUndoOrRedo() const
  {
	return ActionIsDone()
				? CanUndo()
				: CanRedo();
  }

void Undoing::UndoOrRedo()
  {
	if ( ActionIsDone() )
	  {
		if ( CanUndo() )
			Undo();
	  }
	 else
	  {
		if ( CanRedo() )
			Redo();
	  }
  }
