// CheckBox.cp

#ifndef CheckBox_h
#include "CheckBox.h"
#endif
#ifndef __APPEARANCE__
#include <Appearance.h>
#endif
#ifndef Toggle_h
#include "Toggle.h"
#endif

CheckBox::CheckBox( Window& window,
						  Toggle& theTarget,
						  ConstPString title )
  : ControlView( window,
  					  ControlDefinition( kControlCheckBoxProc ),
  					  title,
  					  0, theTarget.Value(), 1 ),
	 target( theTarget ),
	 flip( theTarget, &Toggle::Flip ),
	 box( *this, kControlCheckBoxPart, 0, &flip ),
	 updateValue( theTarget, *this, &CheckBox::UpdateValue )
  {
  }

void CheckBox::UpdateValue()
  {
	SetValue( target.Value() );
  }

int32 CheckBox::BestWidth( Range32 bounds ) const
  {
	return bounds.WeaklyRestrict( RecommendedSize().h );
  }

int32 CheckBox::MinimumHeight() const
  {
	return RecommendedSize().v;
  }

int32 CheckBox::MinimumWidth() const
  {
	return RecommendedSize().h;
  }

int32 CheckBox::MaximumHeight() const
  {
	return RecommendedSize().v;
  }
