// CheckBox.h

#ifndef CheckBox_h
#define CheckBox_h

#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef Method_h
#include "Method.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif
#ifndef ControlNonThumb_h
#include "ControlNonThumb.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif

class Toggle;

class CheckBox: public ControlView,
					 virtual public SuggestsPaneSize
  {
	private:
		Toggle& target;
	
		Method< void (Toggle::*)() > flip;
		ControlNonThumb box;
		Ear<CheckBox> updateValue;

		void UpdateValue();
		
	public:
		CheckBox( Window&, Toggle&, ConstPString );

		ControlView::GetTitle;
		ControlView::SetTitle;
		
		virtual int32 BestWidth( Range32 bounds ) const;
		
		virtual int32 MinimumHeight() const;
		virtual int32 MinimumWidth() const;
		
		virtual int32 MaximumHeight() const;
  };

#endif
