// DisclosureTriangle.cp

#ifndef DisclosureTriangle_h
#include "DisclosureTriangle.h"
#endif
#ifndef __APPEARANCE__
#include <Appearance.h>
#endif
#ifndef Toggle_h
#include "Toggle.h"
#endif

DisclosureTriangle::DisclosureTriangle( Window& window,
													 Toggle& theTarget )
  : ControlView( window,
  					  ControlDefinition( kControlTriangleAutoToggleProc ),
  					  "\p",
  					  0, theTarget.Value(), 1 ),
	 target( theTarget ),
	 flip( theTarget, &Toggle::Flip ),
	 triangle( *this, kControlTrianglePart, 0, &flip ),
	 updateValue( theTarget, *this, &DisclosureTriangle::UpdateValue )
  {
  }

void DisclosureTriangle::UpdateValue()
  {
	SetValue( target.Value() );
  }

int32 DisclosureTriangle::MinimumHeight() const
  {
	return 11;
  }

int32 DisclosureTriangle::MinimumWidth() const
  {
	return 11;
  }

int32 DisclosureTriangle::MaximumHeight() const
  {
	return 11;
  }

int32 DisclosureTriangle::MaximumWidth() const
  {
	return 11;
  }
