// DisclosureTriangle.h

#ifndef DisclosureTriangle_h
#define DisclosureTriangle_h

#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef Method_h
#include "Method.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif
#ifndef ControlNonThumb_h
#include "ControlNonThumb.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif

class Toggle;

class DisclosureTriangle: public ControlView,
								  virtual public SuggestsPaneSize
  {
	private:
		Toggle& target;
	
		Method< void (Toggle::*)() > flip;
		ControlNonThumb triangle;
		Ear<DisclosureTriangle> updateValue;

		void UpdateValue();
		
	public:
		DisclosureTriangle( Window&, Toggle& );
		
		virtual int32 MinimumHeight() const;
		virtual int32 MinimumWidth() const;
		
		virtual int32 MaximumHeight() const;
		virtual int32 MaximumWidth() const;
  };

#endif
