// ControlDrawingContext.cp

#ifndef ControlDrawingContext_h
#include "ControlDrawingContext.h"
#endif
#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef Window_h
#include "Window.h"
#endif

ControlDrawingContext::ControlDrawingContext( ControlView& theView )
  : CanvasLoopBase( theView ),
	 view( theView )
  {
	for ( ; Unfinished(); CanvasLoopBase::operator++() )
	  {
		if ( !Canvas().HasWindow() )
			continue;
		
		if ( &view.OwningWindow().WindowObject() != &Canvas().Window() )
		  {
			Canvas().Invalidate();
			continue;
		  }
		
		Canvas().RestrictToValid();
		if ( !Canvas().Visible() )
			continue;

		canvasMaintainer.Use( Canvas() );
		view.PrepareToDraw( Canvas() );
		return;
	  }

	canvasMaintainer.UseNone();
  }

ControlDrawingContext::~ControlDrawingContext()
  {
	if ( Finished() )
		return;
	
	canvasMaintainer.UseNone();
	view.StopDrawing();

	for ( CanvasLoopBase::operator++();
			Unfinished();
			CanvasLoopBase::operator++() )
		if ( Canvas().HasWindow() )
			Canvas().Invalidate();
  }
