// ControlIdlerList.cp

#ifndef ControlIdlerList_h
#include "ControlIdlerList.h"
#endif
#ifndef LightListLoop_h
#include "LightListLoop.h"
#endif
#ifndef ControlIdler_h
#include "ControlIdler.h"
#endif
#ifndef WindowObject_h
#include "WindowObject.h"
#endif
#ifndef Canvas_h
#include "Canvas.h"
#endif
#ifndef CanvasMaintainer_h
#include "CanvasMaintainer.h"
#endif

ControlIdlerList::ControlIdlerList( WindowObject& theWindow )
  : idle( *this, &ControlIdlerList::Idle, 2, false ),
	 window( theWindow )
  {
  }

void ControlIdlerList::Add( ListLink<ControlIdler>& link )
  {
	if ( controls.IsEmpty() )
		idle.Enable();
	
	controls.Add( link, afterEnd );
  }

void ControlIdlerList::Remove( ListLink<ControlIdler>& link )
  {
	controls.Remove( link );

	if ( controls.IsEmpty() )
		idle.Disable();
  }

void ControlIdlerList::Idle()
  {
	RegionObject combinedArea;
	
	for ( LightListLoop<ControlIdler> control( controls );
			control.Unfinished();
			control++ )
		control->PrepareToIdle( combinedArea );
	
	// Set up and call IdleControls
	  {
		Canvas combinedCanvas( window );
		combinedCanvas.RestrictOnScreen( combinedArea );
		CanvasMaintainer cm( combinedCanvas );
		
		IdleControls( &window.Port() );
	  }
	
	for ( LightListLoop<ControlIdler> control( controls );
			control.Unfinished();
			control++ )
		control->StopIdling();
  }
