// ControlIdlerList.h

#ifndef ControlIdlerList_h
#define ControlIdlerList_h

#ifndef ListOf_h
#include "ListOf.h"
#endif
#ifndef PeriodicMethod_h
#include "PeriodicMethod.h"
#endif

class ControlIdler;
class WindowObject;

/*
	This is a complicated mechanism whose only
	purpose is to get around the restriction
	that IdleControls applies to all the controls
	in a window at once.

	If there were an IdleOneControl procedure,
	the controls that need idle time could just
	use a PeriodicMethod.
*/

class ControlIdlerList
  {
	friend class ControlIdler;
	
	private:
		ListOf< ControlIdler > controls;
		PeriodicMethod<ControlIdlerList> idle;
		WindowObject& window;
		
		void Add( ListLink<ControlIdler>& );
		void Remove( ListLink<ControlIdler>& );
		
		void Idle();
		
	public:
		ControlIdlerList( WindowObject& );
  };

#endif
