// ControlPart.h

#ifndef ControlPart_h
#define ControlPart_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef PointObject_h
#include "PointObject.h"
#endif
#ifndef Functor_h
#include "Functor.h"
#endif
#ifndef ControlView_h
#include "ControlView.h"
#endif

class MouseDownEvent;
class Canvas;

class ControlPart
  {
	friend class ControlThumb;
	friend class ControlNonThumb;
	
	private:
		ControlView& view;
		const int16 code;
		Functor< void(*)() > *track;
		Functor< void(*)() > *hit;
		
		ListLink<ControlPart> link;
		
		static ControlPart *beingTracked;
	
		void Track();
		
		virtual ControlActionUPP Action() = 0;
	
	protected:
		~ControlPart()									{}
	
	public:
		ControlPart( ControlView& theControl,
						 int16 theCode,
						 Functor< void(*)() > *track,
						 Functor< void(*)() > *hit );
				
		void Click( const Canvas&, const MouseDownEvent& );
		
		const ControlView& View() const			{ return view; }
		ControlView& View()							{ return view; }
		
		int16 Code() const							{ return code; }
		
		void Highlight();
		void Unhighlight();
  };

#endif
