// LittleArrows.cp

#ifndef LittleArrows_h
#include "LittleArrows.h"
#endif
#ifndef __APPEARANCE__
#include <Appearance.h>
#endif
#ifndef UpAndDown_h
#include "UpAndDown.h"
#endif
#ifndef Canvas_h
#include "Canvas.h"
#endif

LittleArrows::LittleArrows( Window& window, UpAndDown& theTarget )
  : ControlView( window,
  					  ControlDefinition( kControlLittleArrowsProc ),
  					  "\p",
  					  theTarget.CanGoDown() ? 0 : 1,
  					  1,
  					  theTarget.CanGoUp() ? 2 : 1 ),
  	
	 target( theTarget ),
	 
	 up(   *this, &LittleArrows::Up ),
	 down( *this, &LittleArrows::Down ),
	 
	 upArrow(   *this, kControlUpButtonPart,   &up, 0 ),
	 downArrow( *this, kControlDownButtonPart, &down, 0 ),

	 updateValue( theTarget, *this, &LittleArrows::UpdateValue )
  {
  }

void LittleArrows::Draw( const Canvas& canvas ) const
  {
	EraseRect( &canvas.OnScreen() );
	ControlView::Draw( canvas );
  }

void LittleArrows::UpdateValue()
  {
	SetRangeAndValue( target.CanGoDown() ? 0 : 1,
							1,
							target.CanGoUp() ? 2 : 1 );
  }

void LittleArrows::Up()
  {
	if ( target.CanGoUp() )
		target.Up();
  }

void LittleArrows::Down()
  {
	if ( target.CanGoDown() )
		target.Down();
  }

int32 LittleArrows::MinimumHeight() const
  {
	return height;
  }

int32 LittleArrows::MinimumWidth() const
  {
	return width;
  }

int32 LittleArrows::MaximumHeight() const
  {
	return height;
  }

int32 LittleArrows::MaximumWidth() const
  {
	return width;
  }
