// LittleArrows.h

#ifndef LittleArrows_h
#define LittleArrows_h

#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef Method_h
#include "Method.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif
#ifndef ControlNonThumb_h
#include "ControlNonThumb.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif

class UpAndDown;

class LittleArrows: public ControlView,
						  virtual public SuggestsPaneSize
  {
	private:
		UpAndDown& target;
		
		Method< void (LittleArrows::*)() > up;
		Method< void (LittleArrows::*)() > down;
		
		ControlNonThumb upArrow;
		ControlNonThumb downArrow;
		
		Ear<LittleArrows> updateValue;
		
		enum { width = 13, height = 23 };
		
		void Up();
		void Down();
		
		void UpdateValue();
		
	public:
		LittleArrows( Window&, UpAndDown& );

		virtual void Draw( const Canvas& ) const;

		virtual int32 MinimumHeight() const;
		virtual int32 MinimumWidth() const;
		
		virtual int32 MaximumHeight() const;
		virtual int32 MaximumWidth() const;
  };

#endif
