// PopupMenu.cp

#ifndef PopupMenu_h
#include "PopupMenu.h"
#endif
#ifndef __APPEARANCE__
#include <Appearance.h>
#endif
#ifndef MenuObject_h
#include "MenuObject.h"
#endif

PopupMenu::PopupMenu( Window& window,
							 Announcing<uint16>& theTarget,
							 ConstPString title,
							 const MenuObject& menu )
  : ControlView( window,
  					  ControlDefinition( kControlPopupButtonProc ),
  					  title,
  					  -12345, popupTitleCenterJust, -1,
  					  1, theTarget, menu.Length() ),
	 part( *this, kControlLabelPart /* ?! */, 0, 0 ),
	 updateValue( theTarget, *this, &PopupMenu::UpdateValue ),
	 target( theTarget )
  {
	ControlHandle control( Control() );
	Assert( control != 0 );
	Assert( *control != 0 );
	
	PopupPrivateDataHandle data = 
		reinterpret_cast<PopupPrivateDataHandle>( (*control)->contrlData );
	
	Assert( data != 0 );
	Assert( *data != 0 );
	
	(*data)->mHandle = menu;
	(*data)->mID = menu.ID();
  }

void PopupMenu::Click( const Canvas& canvas,
							  const MouseDownEvent& event )
  {
	ControlView::Click( canvas, event );
	target = Value();
		// Just watching for a hit on the control part
		// won't do, because the CDEF won't report it.
  }

void PopupMenu::UpdateValue()
  {
	SetValue( target );
  }

int32 PopupMenu::BestWidth( Range32 bounds ) const
  {
	return bounds.WeaklyRestrict( RecommendedSize().h );
  }

int32 PopupMenu::MinimumHeight() const
  {
	return RecommendedSize().v;
  }

int32 PopupMenu::MinimumWidth() const
  {
	return RecommendedSize().h;
  }

int32 PopupMenu::MaximumHeight() const
  {
	return RecommendedSize().v;
  }
