// PopupMenu.h

#ifndef PopupMenu_h
#define PopupMenu_h

#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef ControlNonThumb_h
#include "ControlNonThumb.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif
#ifndef Announcing_h
#include "Announcing.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif

class MenuObject;

class PopupMenu: public ControlView,
					  virtual public SuggestsPaneSize
  {
	private:
		Announcing<uint16>& target;

		ControlNonThumb part;
		Ear<PopupMenu> updateValue;

		void UpdateValue();
		
	public:
		PopupMenu( Window&,
					  Announcing<uint16>&,
					  ConstPString,
					  const MenuObject& );

		virtual void Click( const Canvas&,
								  const MouseDownEvent& );

		ControlView::GetTitle;
		ControlView::SetTitle;
		
		virtual int32 BestWidth( Range32 bounds ) const;
		
		virtual int32 MinimumHeight() const;
		virtual int32 MinimumWidth() const;
		
		virtual int32 MaximumHeight() const;
  };

#endif
