// ChasingArrows.cp

#ifndef ChasingArrows_h
#include "ChasingArrows.h"
#endif
#ifndef __APPEARANCE__
#include <Appearance.h>
#endif
#ifndef Window_h
#include "Window.h"
#endif
#ifndef Canvas_h
#include "Canvas.h"
#endif
#ifndef ControlDrawingContext_h
#include "ControlDrawingContext.h"
#endif

ChasingArrows::ChasingArrows( Window& theWindow )
  : ControlView( theWindow,
  					  ControlDefinition( kControlChasingArrowsProc ),
  					  "\p",
  					  0, 0, 0 ),
  	 window( theWindow ),
  	 chase( *this, false )
  {
  }

void ChasingArrows::Start()
  {
	chase.Enable();
	Invalidate();
  }

void ChasingArrows::Stop()
  {
	chase.Disable();
	Invalidate();
  }

void ChasingArrows::Draw( const Canvas& canvas ) const
  {
	if ( Chasing() )
		ControlView::Draw( canvas );
	 else
		EraseRect( &canvas.OnScreen() );
  }

int32 ChasingArrows::MinimumHeight() const
  {
	return 16;
  }

int32 ChasingArrows::MinimumWidth() const
  {
	return 16;
  }

int32 ChasingArrows::MaximumHeight() const
  {
	return 16;
  }

int32 ChasingArrows::MaximumWidth() const
  {
	return 16;
  }
