// ChasingArrows.h

#ifndef ChasingArrows_h
#define ChasingArrows_h

#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif
#ifndef ControlIdler_h
#include "ControlIdler.h"
#endif

class ChasingArrows: public ControlView,
							virtual public SuggestsPaneSize
  {
	private:
		Window& window;
		ControlIdler chase;
		
	public:
		ChasingArrows( Window& );
		
		virtual void Draw( const Canvas& ) const;
		
		bool Chasing() const			{ return chase.Enabled(); }
		void Start();
		void Stop();
		
		virtual int32 MinimumHeight() const;
		virtual int32 MinimumWidth() const;
		
		virtual int32 MaximumHeight() const;
		virtual int32 MaximumWidth() const;
  };

#endif
