// ProgressBar.h

#ifndef ProgressBar_h
#define ProgressBar_h

#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif
#ifndef ControlIdler_h
#include "ControlIdler.h"
#endif

class Progress;

class ProgressBar: public ControlView,
						 virtual public SuggestsPaneSize
  {
	private:
		Window& window;
		const Progress& target;
		bool indeterminate;
		
		ControlIdler spin;
		Ear<ProgressBar> updateValue;
		
		void CheckIndeterminacy();
		void UpdateValue();
		
		enum { largeValue = 30000 };
		
	public:
		ProgressBar( Window&, const Progress& );

		virtual int32 BestWidth( Range32 bounds ) const;
		
		virtual int32 MinimumWidth() const;
		virtual int32 MinimumHeight() const;
		
		virtual int32 MaximumWidth() const;
		virtual int32 MaximumHeight() const;
  };

#endif
