// CancelButton.cp

#ifndef CancelButton_h
#include "CancelButton.h"
#endif
#ifndef Window_h
#include "Window.h"
#endif

CancelButton::CancelButton( Window& window,
									 Functor< void(*)() >& theTarget,
									 ConstPString title )
  : PushButton( window,
  					 theTarget,
  					 title ),
	 CommandHandler<EscapeKeys>( window.Focus() ),
	 CommandHandler<StopKeys>( window.Focus() )
  {
  }

CancelButton::CancelButton( Window& window,
									 Functor< void(*)() >& theTarget,
									 ResourceID cicn,
									 ConstPString title )
  : PushButton( window,
  					 theTarget,
  					 cicn,
  					 title ),
	 CommandHandler<EscapeKeys>( window.Focus() ),
	 CommandHandler<StopKeys>( window.Focus() )
  {
  }

CancelButton::CancelButton( Window& window,
									 Functor< void(*)() >& theTarget,
									 ConstPString title,
									 ResourceID cicn )
  : PushButton( window,
  					 theTarget,
  					 title,
  					 cicn ),
	 CommandHandler<EscapeKeys>( window.Focus() ),
	 CommandHandler<StopKeys>( window.Focus() )
  {
  }

void CancelButton::EscapeKey( const KeystrokeEvent& )
  {
	FakeClick();
  }

void CancelButton::StopKey( const KeystrokeEvent& )
  {
	FakeClick();
  }
