// DefaultButton.cp

#ifndef DefaultButton_h
#include "DefaultButton.h"
#endif
#ifndef __APPEARANCE__
#include <Appearance.h>
#endif
#ifndef Window_h
#include "Window.h"
#endif

DefaultButton::DefaultButton( Window& window,
										Functor< void(*)() >& theTarget,
										ConstPString title )
  : PushButton( window,
  					 theTarget,
  					 title,
  					 Rectangle( 3, 3, -3, -3 ) ),
	 CommandHandler<ReturnKeys>( window.Focus() )
  {
	Boolean isDefault( true );
	
	SetControlData( Control(),
						 kControlButtonPart,
						 kControlPushButtonDefaultTag,
						 sizeof( isDefault ),
						 reinterpret_cast<Ptr>( &isDefault ) );
  }

DefaultButton::DefaultButton( Window& window,
										Functor< void(*)() >& theTarget,
										ResourceID cicn,
										ConstPString title )
  : PushButton( window,
  					 theTarget,
  					 cicn,
  					 title,
  					 Rectangle( 3, 3, -3, -3 ) ),
	 CommandHandler<ReturnKeys>( window.Focus() )
  {
	Boolean isDefault( true );
	
	SetControlData( Control(),
						 kControlButtonPart,
						 kControlPushButtonDefaultTag,
						 sizeof( isDefault ),
						 reinterpret_cast<Ptr>( &isDefault ) );
  }

DefaultButton::DefaultButton( Window& window,
										Functor< void(*)() >& theTarget,
										ConstPString title,
										ResourceID cicn )
  : PushButton( window,
  					 theTarget,
  					 title,
  					 cicn,
  					 Rectangle( 3, 3, -3, -3 ) ),
	 CommandHandler<ReturnKeys>( window.Focus() )
  {
	Boolean isDefault( true );
	
	SetControlData( Control(),
						 kControlButtonPart,
						 kControlPushButtonDefaultTag,
						 sizeof( isDefault ),
						 reinterpret_cast<Ptr>( &isDefault ) );
  }

void DefaultButton::ReturnKey( const KeystrokeEvent& )
  {
	FakeClick();
  }
