// PushButton.h

#ifndef PushButton_h
#define PushButton_h

#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef Functor_h
#include "Functor.h"
#endif
#ifndef ControlNonThumb_h
#include "ControlNonThumb.h"
#endif
#ifndef ResourceID_h
#include "ResourceID.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif

class PushButton: public ControlView,
						virtual public SuggestsPaneSize
  {
	private:
		ControlNonThumb button;
		Functor< void(*)() >& announce;
		const int16 iconWidth;
		
	public:
		PushButton( Window&,
						Functor< void(*)() >&,
						ConstPString,
						Rectangle viewInset = Rectangle::zero );

		PushButton( Window&,
						Functor< void(*)() >&,
						ResourceID cicn,
						ConstPString,
						Rectangle viewInset = Rectangle::zero );

		PushButton( Window&,
						Functor< void(*)() >&,
						ConstPString,
						ResourceID cicn,
						Rectangle viewInset = Rectangle::zero );

		ControlView::GetTitle;
		ControlView::SetTitle;
		
		virtual void Draw( const Canvas& ) const;
		
		void FakeClick();

		virtual int32 BestWidth( Range32 bounds ) const;
		
		virtual int32 MinimumHeight() const;
		virtual int32 MinimumWidth() const;
		
		virtual int32 MaximumHeight() const;
  };

#endif
