// RadioButton.h

#ifndef RadioButton_h
#define RadioButton_h

#ifndef RadioButtonBase_h
#include "RadioButtonBase.h"
#endif
#ifndef Announcing_h
#include "Announcing.h"
#endif

template < class ValueType >
class RadioButton: public RadioButtonBase
  {
	private:
		Announcing< ValueType >& target;
		ValueType value;
	
	protected:
		virtual bool Chosen() const	{ return target == value; }
		virtual void Choose()			{ target = value; }
	
	public:
		RadioButton( Window& window,
						 Announcing<ValueType>& theTarget,
						 const ValueType& theValue,
						 ConstPString title )
		  : RadioButtonBase( window,
									theTarget,
									title,
									theTarget == theValue ),
			 target( theTarget ),
			 value( theValue )
		  {}
  };

#endif
