// RadioButtonBase.cp

#ifndef RadioButtonBase_h
#include "RadioButtonBase.h"
#endif
#ifndef __APPEARANCE__
#include <Appearance.h>
#endif

RadioButtonBase::RadioButtonBase( Window& window,
											 Announcer& theTarget,
											 ConstPString title,
											 bool initialValue )
  : ControlView( window,
  					  ControlDefinition( kControlRadioButtonProc ),
  					  title,
  					  0, initialValue, 1 ),
	 choose( *this, &RadioButtonBase::Choose ),
	 button( *this, kControlRadioButtonPart, 0, &choose ),
	 updateValue( theTarget, *this, &RadioButtonBase::UpdateValue )
  {
  }

void RadioButtonBase::UpdateValue()
  {
	SetValue( Chosen() ? 1 : 0 );
  }

int32 RadioButtonBase::BestWidth( Range32 bounds ) const
  {
	return bounds.WeaklyRestrict( RecommendedSize().h );
  }

int32 RadioButtonBase::MinimumHeight() const
  {
	return RecommendedSize().v;
  }

int32 RadioButtonBase::MinimumWidth() const
  {
	return RecommendedSize().h;
  }

int32 RadioButtonBase::MaximumHeight() const
  {
	return RecommendedSize().v;
  }
