// RadioButtonBase.h

#ifndef RadioButtonBase_h
#define RadioButtonBase_h

#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef Method_h
#include "Method.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif
#ifndef ControlNonThumb_h
#include "ControlNonThumb.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif

class RadioButtonBase: public ControlView,
							  virtual public SuggestsPaneSize
  {
	private:
		Method< void (RadioButtonBase::*)() > choose;
		ControlNonThumb button;
		Ear<RadioButtonBase> updateValue;

		void UpdateValue();
		
	protected:
		~RadioButtonBase()					{}
		
		virtual bool Chosen() const = 0;
		virtual void Choose() = 0;
		
	public:
		RadioButtonBase( Window&,
							  Announcer&,
							  ConstPString,
							  bool initialValue );

		ControlView::GetTitle;
		ControlView::SetTitle;

		virtual int32 BestWidth( Range32 bounds ) const;
		
		virtual int32 MinimumHeight() const;
		virtual int32 MinimumWidth() const;
		
		virtual int32 MaximumHeight() const;
  };

#endif
