// ScrollBar.h

#ifndef ScrollBar_h
#define ScrollBar_h

#ifndef ControlView_h
#include "ControlView.h"
#endif
#ifndef AppearanceManagerUser_h
#include "AppearanceManagerUser.h"
#endif
#ifndef Method_h
#include "Method.h"
#endif
#ifndef ControlNonThumb_h
#include "ControlNonThumb.h"
#endif

class ScrollScaler;
class Scrolling;

class ScrollBar: public ControlView,
					  public AppearanceManagerUser
  {
	private:		
		ControlNonThumb backArrow;
		ControlNonThumb pageBack;
		ControlNonThumb pageForward;
		ControlNonThumb forwardArrow;
		
		Method< void (ScrollBar::*)() > thumbMoved;
		ControlNonThumb thumb;
	 		// Surprisingly, the thumb on a live scroll
	 		// bar is not called as an indicator.

		void ThumbMoved();
		
	protected:
		virtual void PaneSizeChanged();
		
		virtual ScrollScaler Scaler() const = 0;
		virtual uint32 ScrollPosition() const = 0;
		virtual void ScrollTo( URange32 ) = 0;

		void UpdateValue();
		
	public:
		ScrollBar( Window&,
					  Functor< void(*)() > *goBackOneLine,
					  Functor< void(*)() > *goBackOnePage,
					  Functor< void(*)() > *goForwardOnePage,
					  Functor< void(*)() > *goForwardOneLine );
		
		virtual void Draw( const Canvas& ) const;
		
		virtual void Activate();
		virtual void Deactivate();
  };

#endif
