// VerticalScrollBar.h

#ifndef VerticalScrollBar_h
#define VerticalScrollBar_h

#ifndef ScrollBar_h
#include "ScrollBar.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif

class VerticalScrollBar: public ScrollBar,
								 virtual public SuggestsPaneSize
  {
	private:
		Scrolling& target;
		
		Method< void (Scrolling::*)() > backOneLine;
		Method< void (Scrolling::*)() > backOnePage;
		Method< void (Scrolling::*)() > forwardOnePage;
		Method< void (Scrolling::*)() > forwardOneLine;

		Ear<ScrollBar> updateValue;

		uint32 Resolution() const;
		
	protected:
		virtual ScrollScaler Scaler() const;
		virtual uint32 ScrollPosition() const;
		virtual void ScrollTo( URange32 );
		
	public:
		VerticalScrollBar( Window&, Scrolling& );
		
		virtual int32 MinimumHeight() const;
		virtual int32 MinimumWidth() const;
		virtual int32 MaximumWidth() const;
  };

#endif
