// CursorController.h

#ifndef CursorController_h
#define CursorController_h

#ifndef MouseWatcher_h
#include "MouseWatcher.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif
#ifndef CursorUser_h
#include "CursorUser.h"
#endif

class CursorObject;

class CursorController: public MouseWatcher,
								public CursorUser
  {
	private:
		const CursorObject *current;
		bool watchShowing;
		Ear<MouseWatcher> userStateChanged;
		
		CursorController();
		
		virtual void MouseMoved( const MouseEvent&,
										 RegionObject& sleep );
		
		// not implemented:
			CursorController( const CursorController& );
			void operator=( const CursorController& );
	
	public:
		static CursorController& The();
		
		void ShowWatch();
  };

#endif
