// CursorObject.cp

#ifndef CursorObject_h
#include "CursorObject.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

CursorObject::CursorObject( ResourceID resource )
  : cursor( GetCursor( resource.Value() ) )
  {
	Assert( cursor != 0 );
	Assert( *cursor != 0 );
  }

CursorObject::CursorObject( const Cursor *const *theCursor )
  : cursor( theCursor )
  {
  }

const CursorObject& CursorObject::Arrow()
  {
	static const Cursor *pointer( &qd.arrow );
	static const CursorObject arrow( &pointer );
	return arrow;
  }

const CursorObject& CursorObject::IBeam()
  {
	// The "+0" prevents this from being read as a declaration
	static const CursorObject iBeam( ResourceID( iBeamCursor+0 ) );
	return iBeam;
  }

const CursorObject& CursorObject::Cross()
  {
	static const CursorObject cross( ResourceID( crossCursor+0 ) );
	return cross;
  }

const CursorObject& CursorObject::Plus()
  {
	static const CursorObject plus( ResourceID( plusCursor+0 ) );
	return plus;
  }

const CursorObject& CursorObject::Watch()
  {
	static const CursorObject watch( ResourceID( watchCursor+0 ) );
	return watch;
  }
