// CursorObject.h

#ifndef CursorObject_h
#define CursorObject_h

#ifndef ResourceID_h
#include "ResourceID.h"
#endif

#include <QuickDraw.h>

class CursorObject
  {
	private:
		const Cursor *const * cursor;
		
		// not implemented:
			CursorObject( const CursorObject& );
			void operator=( const CursorObject& );
	
	public:
		CursorObject( ResourceID );
		CursorObject( const Cursor *const * );
		
		void Show() const			{ SetCursor( *cursor ); }
		
		static const CursorObject& Arrow();
		static const CursorObject& IBeam();
		static const CursorObject& Cross();
		static const CursorObject& Plus();
		static const CursorObject& Watch();
  };

#endif
