// DebugTimer.cp

#ifndef DebugTimer_h
#include "DebugTimer.h"
#endif
#ifndef __Timer__
#include <Timer.h>
#endif
#ifndef DebugMessage_h
#include "DebugMessage.h"
#endif

#include <Events.h>

DebugTimer::DebugTimer()
  : start( Now() ),
	 running( true )
  {
  }

uint32 DebugTimer::Now()
  {
	return TickCount();
  }

void DebugTimer::Start()
  {
	running = true;
	start = TickCount();
  }

void DebugTimer::Stop()
  {
	uint32 time = Now() - start;
	
	DebugMessage message;
	message << time << " ticks";
	message.Show();

	running = false;
  }

DebugTimer::~DebugTimer()
  {
	if ( running )
		Stop();
  }
