// BackgroundColorMaintainer.cp

#ifndef BackgroundColorMaintainer_h
#include "BackgroundColorMaintainer.h"
#endif
#ifndef GrafPortObject_h
#include "GrafPortObject.h"
#endif

BackgroundColorMaintainer::BackgroundColorMaintainer()
  : port( GrafPortObject::Current() ),
	 old( GrafPortObject::Current().BackgroundColor() )
  {
  }

BackgroundColorMaintainer::BackgroundColorMaintainer( const RGBColor& toUse )
  : port( GrafPortObject::Current() ),
	 old( GrafPortObject::Current().BackgroundColor() )
  {
	port.SetBackgroundColor( toUse );
  }

void BackgroundColorMaintainer::Reset() const
  {
	port.SetBackgroundColor( old );
  }
