// Clipper.cp

#ifndef Clipper_h
#include "Clipper.h"
#endif

Clipper::Clipper()
  {
	GetClip( saved );
	current = saved;
  }

Clipper::Clipper( RgnHandle r )
  {
	GetClip( saved );
	current = saved;
	current &= r;
	Clip();
  }

Clipper::Clipper( const Rect& r )
  {
	GetClip( saved );
	current = saved;
	current &= r;
	Clip();
  }

Clipper::Clipper( const Clipper& c )
  {
	GetClip( saved );
	current = saved;
	current &= c.current;
	Clip();
  }

Clipper::~Clipper()
  {
	SetClip( saved );
  }

void Clipper::BeEmpty()
  {
	current.BeEmpty();
	Clip();
  }

void Clipper::Restore()
  {
	current = saved;
	Clip();
  }

void Clipper::operator=( const Rect& r )
  {
	current = saved;
	current &= r;
	Clip();
  }

void Clipper::operator=( RgnHandle r )
  {
	current = saved;
	current &= r;
	Clip();
  }

void Clipper::operator=( const Clipper& r )
  {
	if ( this == &r )
		return;
	
	current = saved;
	current &= r.current;
	Clip();
  }

void Clipper::operator&=( const Rect& r )
  {
	current &= r;
	Clip();
  }

void Clipper::operator-=( const Rect& r )
  {
	current -= r;
	Clip();
  }

void Clipper::operator&=( RgnHandle r )
  {
	current &= r;
	Clip();
  }

void Clipper::operator-=( RgnHandle r )
  {
	current -= r;
	Clip();
  }

void Clipper::Inset( int16 amount )
  {
	current.Inset( amount );
	Clip();
  }

void Clipper::Inset( Point amount )
  {
	current.Inset( amount );
	Clip();
  }
