// ForegroundColorMaintainer.cp

#ifndef ForegroundColorMaintainer_h
#include "ForegroundColorMaintainer.h"
#endif
#ifndef GrafPortObject_h
#include "GrafPortObject.h"
#endif
#ifndef GraphicsDeviceObject_h
#include "GraphicsDeviceObject.h"
#endif
#ifndef NamedColors_h
#include "NamedColors.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif

ForegroundColorMaintainer::ForegroundColorMaintainer()
  : port( GrafPortObject::Current() ),
	 old( GrafPortObject::Current().ForegroundColor() )
  {
  }

ForegroundColorMaintainer::ForegroundColorMaintainer( const RGBColor& toUse )
  : port( GrafPortObject::Current() ),
	 old( GrafPortObject::Current().ForegroundColor() )
  {
	port.SetForegroundColor( toUse );
  }

ForegroundColorMaintainer::ForegroundColorMaintainer( ThemeTextColor toUse,
																		const GraphicsDeviceObject& device )
  : port( GrafPortObject::Current() ),
	 old( GrafPortObject::Current().ForegroundColor() )
  {
	OSStatus error = SetThemeTextColor( toUse, device.Depth(), device.InColor() );
	OSError::Debug( error );
	if ( error != noErr )
		port.SetForegroundColor( NamedColors::black );
  }

void ForegroundColorMaintainer::Reset() const
  {
	port.SetForegroundColor( old );
  }
