// GraphicsDeviceLoop.h

#ifndef GraphicsDeviceLoop_h
#define GraphicsDeviceLoop_h

#ifndef GraphicsDeviceObject_h
#include "GraphicsDeviceObject.h"
#endif

class GraphicsDeviceLoop
  {
	private:
		GraphicsDeviceObject device;
	
	public:
		GraphicsDeviceLoop()
		  : device( GraphicsDeviceObject::First() )
		  {}
		
		bool Finished() const		{ return device.Null(); }
		bool Unfinished() const		{ return !device.Null(); }
		
		void operator++()				{ Assert( Unfinished() ); device = device.Next(); }
		void operator++(int)			{ operator++(); }

		const GraphicsDeviceObject& operator*() const		{ return device; }
		const GraphicsDeviceObject *operator->() const		{ return &device; }
  };

#endif
