// GraphicsDeviceObject.cp

#ifndef GraphicsDeviceObject_h
#include "GraphicsDeviceObject.h"
#endif
#ifndef ScreenLoop_h
#include "ScreenLoop.h"
#endif

GraphicsDeviceObject GraphicsDeviceObject::Nearest( const Rectangle& target )
  {
	GDHandle nearest = 0;
	uint32 bestArea = 0;
	uint32 bestDistance = maxuint32;
	
	for ( ScreenLoop screen; screen.Unfinished(); screen++ )
	  {
		uint32 area = ( target & (*screen).Bounds() ).Area();
		uint32 distance = target.TaxicabDistanceTo( (*screen).Bounds() );
		
		if ( area > bestArea || distance < bestDistance )
		  {
			nearest = *screen;
			bestArea = area;
			bestDistance = distance;
		  }
	  }
	
	return nearest;
  }
