// NamedColors.h

#ifndef NamedColors_h
#define NamedColors_h

#include <QuickDraw.h>

class NamedColors
  {
	public:
		// Grays
			static const RGBColor white;
			static const RGBColor lightGray;
			static const RGBColor gray;
			static const RGBColor darkGray;
			static const RGBColor black;

		// Other corners of the color cube
			static const RGBColor red;
			static const RGBColor green;
			static const RGBColor blue;

			static const RGBColor cyan;
			static const RGBColor magenta;
			static const RGBColor yellow;
		
		// Face centers
			static const RGBColor lightRed;
			static const RGBColor lightGreen;
			static const RGBColor lightBlue;

			static const RGBColor darkCyan;
			static const RGBColor darkMagenta;
			static const RGBColor darkYellow;
		
		// Edge midpoints
			static const RGBColor darkRed;
			static const RGBColor darkGreen;
			static const RGBColor darkBlue;

			static const RGBColor lightCyan;
			static const RGBColor lightMagenta;
			static const RGBColor lightYellow;
		
			static const RGBColor greenishCyan;
			static const RGBColor blueishCyan;
			
			static const RGBColor reddishMagenta;
			static const RGBColor blueishMagenta;
			
			static const RGBColor reddishYellow;
			static const RGBColor greenishYellow;

		// Corners of the half-size color cube
			static const RGBColor mediumRed;
			static const RGBColor mediumGreen;
			static const RGBColor mediumBlue;

			static const RGBColor mediumCyan;
			static const RGBColor mediumMagenta;
			static const RGBColor mediumYellow;
		
		// Half size face centers
			static const RGBColor mediumLightRed;
			static const RGBColor mediumLightGreen;
			static const RGBColor mediumLightBlue;

			static const RGBColor mediumDarkCyan;
			static const RGBColor mediumDarkMagenta;
			static const RGBColor mediumDarkYellow;
		
		// Half size edge midpoints
			static const RGBColor mediumDarkRed;
			static const RGBColor mediumDarkGreen;
			static const RGBColor mediumDarkBlue;

			static const RGBColor mediumLightCyan;
			static const RGBColor mediumLightMagenta;
			static const RGBColor mediumLightYellow;
		
			static const RGBColor mediumGreenishCyan;
			static const RGBColor mediumBlueishCyan;
			
			static const RGBColor mediumReddishMagenta;
			static const RGBColor mediumBlueishMagenta;
			
			static const RGBColor mediumReddishYellow;
			static const RGBColor mediumGreenishYellow;
			
		// From the Apple Grayscale Appearance
			static const RGBColor appleGray1;
			static const RGBColor appleGray2;
			static const RGBColor appleGray3;
			static const RGBColor appleGray4;
			static const RGBColor appleGray5;
			static const RGBColor appleGray6;
			static const RGBColor appleGray7;
			static const RGBColor appleGray8;
			static const RGBColor appleGray9;
			static const RGBColor appleGray10;
			static const RGBColor appleGray11;
			static const RGBColor appleGray12;
			static const RGBColor appleGrayA1;
			static const RGBColor appleGrayA2;
  };

inline bool operator==( const RGBColor& a, const RGBColor& b )
  {
	return a.red == b.red && a.green == b.green && a.blue == b.blue;
  }

inline bool operator!=( const RGBColor& a, const RGBColor& b )
  {
	return a.red != b.red || a.green != b.green || a.blue != b.blue;
  }

#endif
