// PatternMode.h

#ifndef PatternMode_h
#define PatternMode_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <QuickDraw.h>

class PatternMode
  {
	public:
		enum Mode
		  {
			copy		= ::patCopy,
			orMode	= ::patOr,
			xorMode	= ::patXor,
			bic		= ::patBic,
			notCopy	= ::notPatCopy,
			notOr		= ::notPatOr,
			notXor	= ::notPatXor,
			notBic	= ::notPatBic,
			
			blend				= ::blend,
			addPin			= ::addPin,
			addOver			= ::addOver,
			subPin			= ::subPin,
			transparent		= ::transparent,
			addMax			= ::addMax,
			subOver			= ::subOver,
			addMin			= ::adMin,	/* sic */
			
			copyAndHighlight		= ::patCopy + hilite,
			orModeAndHighlight	= ::patOr + hilite,
			xorModeAndHighlight	= ::patXor + hilite,
			bicAndHighlight		= ::patBic + hilite,
			notCopyAndHighlight	= ::notPatCopy + hilite,
			notOrAndHighlight		= ::notPatOr + hilite,
			notXorAndHighlight	= ::notPatXor + hilite,
			notBicAndHighlight	= ::notPatBic + hilite,
			
			blendAndHighlight				= ::blend + hilite,
			addPinAndHighlight			= ::addPin + hilite,
			addOverAndHighlight			= ::addOver + hilite,
			subPinAndHighlight			= ::subPin + hilite,
			transparentAndHighlight		= ::transparent + hilite,
			addMaxAndHighlight			= ::addMax + hilite,
			subOverAndHighlight			= ::subOver + hilite,
			addMinAndHighlight			= ::adMin + hilite
		  };
	
	private:
		Mode mode;
	
	public:
		PatternMode( Mode m )
		  : mode( m )
		  {}
		
		explicit PatternMode( int16 value )
		  : mode( static_cast<Mode>( value ) )
		  {}
	
		int16 Value() const			{ return mode; }
  };

#endif
