// Point32.h

#ifndef Point32_h
#define Point32_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <MacTypes.h>

class PointObject;
class UPoint32;

class Point32
  {
	public:
		int32 h;
		int32 v;
	
		Point32()										{}
		Point32( const Point& p )					: h(p.h), v(p.v)	{}
		Point32( int32 x, int32 y )				: h(x), v(y)		{}
		Point32( UPoint32 );
		
		static const Point32 zero;
		static const Point32 up;
		static const Point32 down;
		static const Point32 left;
		static const Point32 right;
		static const Point32 upLeft;
		static const Point32 upRight;
		static const Point32 downLeft;
		static const Point32 downRight;
		
		bool operator==( Point32 r ) const		{ return h == r.h && v == r.v; }
		bool operator!=( Point32 r ) const		{ return h != r.h || v != r.v; }
		
		bool AboveLeftOf( Point32 r ) const		{ return h <= r.h && v <= r.v; }
		bool BelowLeftOf( Point32 r ) const		{ return h <= r.h && v >= r.v; }
		bool AboveRightOf( Point32 r ) const	{ return h >= r.h && v <= r.v; }
		bool BelowRightOf( Point32 r ) const	{ return h >= r.h && v >= r.v; }
		
		void BeAboveLeftOf( Point32 r );
		void BeBelowLeftOf( Point32 r );
		void BeAboveRightOf( Point32 r );
		void BeBelowRightOf( Point32 r );
		
		void operator+=( Point32 r );
		void operator-=( Point32 r );
		void operator*=( int32 n );
		void operator/=( int32 n );
		
		const Point32 operator+( Point32 r ) const;
		const Point32 operator-( Point32 r ) const;
		const Point32 operator*( int32 n ) const;
		const Point32 operator/( int32 n ) const;
		
		const PointObject NearestPoint16() const;
		const PointObject AsPointObject() const;
  };

#endif
