// QDPatchBlock.h

#ifndef QDPatchBlock_h
#define QDPatchBlock_h

#ifndef A5_h
#include "A5.h"
#endif
#ifndef ConstData_h
#include "ConstData.h"
#endif

#include <QuickDraw.h>

class GrafPortObject;

class QDPatchBlock: public QDProcs
  {
	private:
		A5 a5;
		A5 portA5;
		
		GrafPortObject& port;
		
		static const QDProcs& MakeStandard();
		static const QDProcs& Standard();
	
		// not implemented:
			QDPatchBlock( const QDPatchBlock& );
			void operator=( const QDPatchBlock& );
		
		static pascal void MyTextProc( int16, int8 *, Point, Point );
		
	public:
		QDPatchBlock( GrafPortObject& );
		~QDPatchBlock();

		GrafPortObject& Port() const	{ return port; }
		
		void ActivateTextPatch();
		void DeactivateTextPatch();

		virtual void DrawText( ConstData text,
									  Point numerator,
									  Point denominator );
  };

#endif
