// QuickDrawError.h

#ifndef QuickDrawError_h
#define QuickDrawError_h

#ifndef OSError_h
#include "OSError.h"
#endif

#include <QuickDraw.h>

class QuickDrawError: public OSError
  {
	public:
		QuickDrawError()						: OSError()		{}
		QuickDrawError( OSErr e )			: OSError( e )	{}
		QuickDrawError( OSError& e )		: OSError( e )	{}
		
		static QuickDrawError Current()
		  {
			return QDErr();
		  }
		
		static void ThrowCurrent();
		static void DebugCurrent();
  };

inline void ThrowQuickDrawError( OSErr e )
  {
	if ( e != noErr )
		throw QuickDrawError(e);
  }

#endif
