// RectangleDifference.cp

#ifndef RectangleDifference_h
#include "RectangleDifference.h"
#endif

#include <QuickDraw.h>
#include <Windows.h>

void RectangleDifference::Paint() const
  {
	if ( outside.top < inside.top )
		PaintRect( &Rectangle( outside.left,   outside.top,
									  outside.right,  inside.top ) );

	if ( outside.left < inside.left )
		PaintRect( &Rectangle( outside.left,   inside.top,
									  inside.left,    inside.bottom ) );

	if ( outside.right > inside.right )
		PaintRect( &Rectangle( inside.right,   inside.top,
									  outside.right,  inside.bottom ) );

	if ( outside.bottom > inside.bottom )
		PaintRect( &Rectangle( outside.left,   inside.bottom,
									  outside.right,  outside.bottom ) );
  }

void RectangleDifference::Erase() const
  {
	if ( outside.top < inside.top )
		EraseRect( &Rectangle( outside.left,   outside.top,
									  outside.right,  inside.top ) );

	if ( outside.left < inside.left )
		EraseRect( &Rectangle( outside.left,   inside.top,
									  inside.left,    inside.bottom ) );

	if ( outside.right > inside.right )
		EraseRect( &Rectangle( inside.right,   inside.top,
									  outside.right,  inside.bottom ) );

	if ( outside.bottom > inside.bottom )
		EraseRect( &Rectangle( outside.left,   inside.bottom,
									  outside.right,  outside.bottom ) );
  }

void RectangleDifference::Validate() const
  {
	if ( outside.top < inside.top )
		ValidRect( &Rectangle( outside.left,   outside.top,
									  outside.right,  inside.top ) );

	if ( outside.left < inside.left )
		ValidRect( &Rectangle( outside.left,   inside.top,
									  inside.left,    inside.bottom ) );

	if ( outside.right > inside.right )
		ValidRect( &Rectangle( inside.right,   inside.top,
									  outside.right,  inside.bottom ) );

	if ( outside.bottom > inside.bottom )
		ValidRect( &Rectangle( outside.left,   inside.bottom,
									  outside.right,  outside.bottom ) );
  }

void RectangleDifference::Invalidate() const
  {
	if ( outside.top < inside.top )
		InvalRect( &Rectangle( outside.left,   outside.top,
									  outside.right,  inside.top ) );

	if ( outside.left < inside.left )
		InvalRect( &Rectangle( outside.left,   inside.top,
									  inside.left,    inside.bottom ) );

	if ( outside.right > inside.right )
		InvalRect( &Rectangle( inside.right,   inside.top,
									  outside.right,  inside.bottom ) );

	if ( outside.bottom > inside.bottom )
		InvalRect( &Rectangle( outside.left,   inside.bottom,
									  outside.right,  outside.bottom ) );
  }
