// RectangleDifference.h

#ifndef RectangleDifference_h
#define RectangleDifference_h

#ifndef Rectangle_h
#include "Rectangle.h"
#endif

class RectangleDifference
  {
	private:
		Rectangle outside;
		Rectangle inside;
	
	public:
		RectangleDifference( const Rect& theOutside,
									const Rect& theInside )
		  : outside( theOutside ),
			 inside( theInside )
		  {}
		
		void Paint() const;
		void Erase() const;
		void Validate() const;
		void Invalidate() const;
  };

inline const RectangleDifference operator-( const Rect& outside, const Rect& inside )
  {
	return RectangleDifference( outside, inside );
  }

inline void Paint( const RectangleDifference& diff )			{ diff.Paint(); }
inline void Erase( const RectangleDifference& diff )			{ diff.Erase(); }
inline void Validate( const RectangleDifference& diff )		{ diff.Validate(); }
inline void Invalidate( const RectangleDifference& diff )	{ diff.Invalidate(); }

#endif
