// SourceMode.h

#ifndef SourceMode_h
#define SourceMode_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <QuickDraw.h>

class SourceMode
  {
	public:
		enum Mode
		  {
			srcCopy		= ::srcCopy,
			srcOr			= ::srcOr,
			srcXor		= ::srcXor,
			srcBic		= ::srcBic,
			notSrcCopy	= ::notSrcCopy,
			notSrcOr		= ::notSrcOr,
			notSrcXor	= ::notSrcXor,
			notSrcBic	= ::notSrcBic,
			
			ditherCopy		= ::ditherCopy | ::srcCopy,
			ditherOr			= ::ditherCopy | ::srcOr,
			ditherXor		= ::ditherCopy | ::srcXor,
			ditherBic		= ::ditherCopy | ::srcBic,
			notDitherCopy	= ::ditherCopy | ::notSrcCopy,
			notDitherOr		= ::ditherCopy | ::notSrcOr,
			notDitherXor	= ::ditherCopy | ::notSrcXor,
			notDitherBic	= ::ditherCopy | ::notSrcBic,
			
			blend				= ::blend,
			addPin			= ::addPin,
			addOver			= ::addOver,
			subPin			= ::subPin,
			transparent		= ::transparent,
			addMax			= ::addMax,
			subOver			= ::subOver,
			addMin			= ::adMin	/* sic */
		  };
	
	private:
		Mode mode;
	
	public:
		SourceMode( Mode m )
		  : mode( m )
		  {}
		
		explicit SourceMode( int16 value )
		  : mode( static_cast<Mode>( value ) )
		  {}
	
		int16 Value() const			{ return mode; }
  };

#endif
