// UPoint32.h

#ifndef UPoint32_h
#define UPoint32_h

#ifndef Integers_h
#include "Integers.h"
#endif

class Point32;
class PointObject;

class UPoint32
  {
	public:
		uint32 h;
		uint32 v;
	
		UPoint32()										{}
		UPoint32( uint32 x, uint32 y )			: h(x), v(y)		{}
		UPoint32( Point32 );
		
		static const UPoint32 zero;
		static const UPoint32 down;
		static const UPoint32 right;
		static const UPoint32 downRight;
		
		bool operator==( UPoint32 r ) const		{ return h == r.h && v == r.v; }
		bool operator!=( UPoint32 r ) const		{ return h != r.h || v != r.v; }
		
		bool AboveLeftOf( UPoint32 r ) const	{ return h <= r.h && v <= r.v; }
		bool BelowLeftOf( UPoint32 r ) const	{ return h <= r.h && v >= r.v; }
		bool AboveRightOf( UPoint32 r ) const	{ return h >= r.h && v <= r.v; }
		bool BelowRightOf( UPoint32 r ) const	{ return h >= r.h && v >= r.v; }
		
		void BeAboveLeftOf( UPoint32 r );
		void BeBelowLeftOf( UPoint32 r );
		void BeAboveRightOf( UPoint32 r );
		void BeBelowRightOf( UPoint32 r );
		
		void operator+=( UPoint32 r );
		void operator-=( UPoint32 r );
		void operator*=( uint32 n );
		void operator/=( uint32 n );
		
		const UPoint32 operator+( UPoint32 r ) const;
		const UPoint32 operator-( UPoint32 r ) const;
		const UPoint32 operator*( uint32 n ) const;
		const UPoint32 operator/( uint32 n ) const;
		
		const PointObject NearestPoint16() const;
		const PointObject AsPointObject() const;
  };

#endif
