// MouseEvent.h

#ifndef MouseEvent_h
#define MouseEvent_h

#ifndef UserEvent_h
#include "UserEvent.h"
#endif
#ifndef ScreenPart_h
#include "ScreenPart.h"
#endif

class MouseEvent: public UserEvent
  {
	private:
		PointObject global;
		::ScreenPart part;
		PointObject local;
		
	public:
		MouseEvent( const EventRecord& event );
		
		::ScreenPart::PartCode ScreenPart() const	{ return part.Type(); }
		
		bool HasWindow() const							{ return part.HasWindow(); }
		WindowObject& Window() const					{ return part.Window(); }
		
		const PointObject& GlobalPoint() const		{ return global; }
		const PointObject& LocalPoint() const		{ Assert( part.HasWindow() ); return local; }
  };

#endif
