// EventQueue.h

#ifndef EventQueue_h
#define EventQueue_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

#include <Events.h>

class WindowObject;

class EventQueue
  {
	private:
		uint32 eventCount;
		EventRecord events[2];
		
		EventQueue();
		
		static bool Valid( const EventRecord& );
		
		void DropInvalidEvents();
		
	public:
		static EventQueue& The();
		
		const EventRecord& operator*()			{ return Current(); }
		const EventRecord *operator->()			{ return &Current(); }
		
		void operator++();
		void operator++(int)							{ operator++(); }

		bool Finished() const						{ return !Unfinished(); }
		bool Unfinished() const;
				
		const EventRecord& Current();
		const EventRecord& Next();
  };

#endif
