// ScreenPart.h

#ifndef ScreenPart_h
#define ScreenPart_h

#ifndef PointObject_h
#include "PointObject.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

#include <Windows.h>

class WindowObject;

class ScreenPart
  {
	public:
		enum PartCode
		  {
			desktop				= ::inDesk,
			menuBar				= ::inMenuBar,
			systemWindow		= ::inSysWindow,
			windowContent		= ::inContent,
			windowDragRegion	= ::inDrag,
			windowGrowBox		= ::inGrow,
			windowCloseBox		= ::inGoAway,
			windowZoomInBox	= ::inZoomIn,
			windowZoomOutBox	= ::inZoomOut
		  };
	
	private:
		PartCode part;
		WindowObject *window;
	
	public:
		ScreenPart( PointObject );
		
		PartCode Type() const			{ return part; }
		
		bool HasWindow() const			{ return window != 0; }
		WindowObject& Window() const	{ Assert( HasWindow() ); return *window; }
  };

#endif
