// FilePermission.h

#ifndef FilePermission_h
#define FilePermission_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <Files.h>

class FilePermission
  {
	private:
		int8 permission;
	
		FilePermission( int8 value )
		  : permission( value )
		  {}
		
	public:
		static FilePermission ReadOnly()			{ return fsRdPerm; }
		static FilePermission ReadWrite()		{ return fsWrPerm; }
		static FilePermission Available()		{ return fsCurPerm; }
		static FilePermission Shared()			{ return fsRdWrShPerm; }
	
		int8 Value() const							{ return permission; }
		
		bool operator==( FilePermission f ) const		{ return permission == f.permission; }
		bool operator!=( FilePermission f ) const		{ return permission != f.permission; }
  };

#endif
