// FileReadingAheadLoop.h

#ifndef FileReadingAheadLoop_h
#define FileReadingAheadLoop_h

#ifndef Data_h
#include "Data.h"
#endif
#ifndef AsyncFileReader_h
#include "AsyncFileReader.h"
#endif

class FileReadingAheadLoop
  {
	private:
		Data bufferSections[2];
		ConstData availableData;
		uint32 nextSectionToRead;
		uint32 remaining;
		AsyncFileReader reader;
		
		void DivideBuffer( Data bufferSpace );
		void LaunchNextRead();
		
	public:
		FileReadingAheadLoop( Data bufferSpace );
		
		FileReadingAheadLoop( Data bufferSpace,
									 const FileReadingPath&,
									 uint32 start = 0,
									 uint32 stop = maxuint32 );
		
		void Start( const FileReadingPath&,
						uint32 start = 0,
						uint32 stop = maxuint32 );
		
		bool Finished() const						{ return remaining <= 0; }
		bool Unfinished() const						{ return remaining > 0; }
		
		bool ReadyToAdvance() const;
		
		void operator++();
		void operator++(int)							{ operator++(); }
		
		const ConstData& operator*() const		{ Assert( Unfinished() ); return availableData; }
		const ConstData *operator->() const		{ Assert( Unfinished() ); return &availableData; }
  };

#endif
