// FileWriter.h

#ifndef FileWriter_h
#define FileWriter_h

#ifndef ConstData_h
#include "ConstData.h"
#endif

#include <Devices.h>

class FileWritingPath;
class ConstBuffer;

class FileWriter: private ParamBlockRec
  {
	private:
		void ThrowError( OSErr );
		
	public:
		FileWriter();
		FileWriter( const FileWritingPath&, uint32 position = 0 );

		void Start( const FileWritingPath&, uint32 position = 0 );
		
		uint32 Position() const				{ return uint32( ioParam.ioPosOffset ); }
		void SetPosition( uint32 p )		{ ioParam.ioPosOffset = int32( p ); }
		
		FileWriter& operator<<( ConstData );
			// The ConstData operator will throw an error
			// if the data cannot be completely written.

		FileWriter& operator<<( ConstBuffer& );
			// The ConstBuffer operator may write only part
			// of the data and not throw, if the OS does not
			// report an error.  I don't know how that could happen. --LL
  };

#endif
