// Drive.cp

#ifndef Drive_h
#include "Drive.h"
#endif
#ifndef TooManyFilesOpenToMount_h
#include "TooManyFilesOpenToMount.h"
#endif
#ifndef VolumeAlreadyOnline_h
#include "VolumeAlreadyOnline.h"
#endif
#ifndef NotAMacintoshDisk_h
#include "NotAMacintoshDisk.h"
#endif
#ifndef BadMasterDirectoryBlock_h
#include "BadMasterDirectoryBlock.h"
#endif

#include <Devices.h>
#include <Errors.h>

Volume Drive::Mount()
  {
	ParamBlockRec block;
	block.ioParam.ioCompletion = 0;
	block.ioParam.ioVRefNum = refNum;
	
	ThrowError( PBMountVol( &block ) );
	
	return Volume( block.ioParam.ioVRefNum );
  }

void Drive::ThrowError( OSErr error )
  {
	if ( error == noErr )
		return;
	
	switch ( error )
	  {
		case tmfoErr:				throw TooManyFilesOpenToMount( error );
		case volOnLinErr:			throw VolumeAlreadyOnline( error );
		case noMacDskErr:			throw NotAMacintoshDisk( error );
		case badMDBErr:			throw BadMasterDirectoryBlock( error );
	  }
	
	throw MountError( error );
  }
