// FileType.h

#ifndef FileType_h
#define FileType_h

#ifndef Integers_h
#include "Integers.h"
#endif

class FileType
  {
	private:
		uint32 type;
			
	public:
		FileType()										: type( '????' )		{}
		explicit FileType( uint32 value )
		  : type( value )
		  {}
	
		uint32 Type() const							{ return type; }
		
		static FileType Application()				{ return FileType( 'APPL' ); }
		static FileType Text()						{ return FileType( 'TEXT' ); }
		static FileType ReadOnlyText()			{ return FileType( 'ttro' ); }
		static FileType Picture()					{ return FileType( 'PICT' ); }
		static FileType Unknown()					{ return FileType( '????' ); }

		static FileType FontResource()			{ return FileType( 'ffil' ); }
		static FileType KeyboardResource()		{ return FileType( 'kfil' ); }
		static FileType ScriptResource()			{ return FileType( 'ifil' ); }
		static FileType SoundResource()			{ return FileType( 'sfil' ); }
		static FileType TrueTypeFontResource()	{ return FileType( 'tfil' ); }
  };

inline bool operator==( FileType a, FileType b )		{ return a.Type() == b.Type(); }
inline bool operator!=( FileType a, FileType b )		{ return a.Type() != b.Type(); }

#endif
