// TypedFileInfoLoop.cp

#ifndef TypedFileInfoLoop_h
#include "TypedFileInfoLoop.h"
#endif

void TypedFileInfoLoop::AdvanceToNextMatch()
  {
	for ( ; Unfinished(); CatInfoLoop::operator++() )
	  {
		if ( (*this)->IsDirectory() )
			continue;
		
		if ( (*this)->File().Type() != type )
			continue;
		
		break;
	  }
  }

TypedFileInfoLoop::TypedFileInfoLoop( FileType theType,
												  Directory folder )
  : CatInfoLoop( folder ),
	 type( theType )
  {
	AdvanceToNextMatch();
  }

void TypedFileInfoLoop::Start( Directory folder )
  {
	CatInfoLoop::Start( folder );
	AdvanceToNextMatch();
  }

void TypedFileInfoLoop::Start( Directory folder,
										 FileType theType )
  {
	type = theType;
	CatInfoLoop::Start( folder );
	AdvanceToNextMatch();
  }

void TypedFileInfoLoop::operator++()
  {
	CatInfoLoop::operator++();
	AdvanceToNextMatch();
  }
