// DirectoryID.h

#ifndef DirectoryID_h
#define DirectoryID_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <Files.h>

class DirectoryID
  {
	private:
		int32 id;
		
	public:
		explicit DirectoryID( int32 value )
		  : id( value )
		  {}
		
		static DirectoryID Root()						{ return DirectoryID( fsRtDirID ); }
		static DirectoryID AboveRoot()				{ return DirectoryID( fsRtParID ); }
		
		int32 Number() const								{ return id; }
		
		bool operator==( DirectoryID f ) const		{ return id == f.id; }
		bool operator!=( DirectoryID f ) const		{ return id != f.id; }
  };

#endif
