// TentativeFile.h

#ifndef TentativeFile_h
#define TentativeFile_h

#ifndef FileLocation_h
#include "FileLocation.h"
#endif

class TentativeFile
  {
	private:
		FileLocation location;
		bool committed;
		
		// not implemented:
			TentativeFile( const TentativeFile& );
			void operator=( const TentativeFile& );
	
	public:
		TentativeFile( const FileLocation&,
							FileType,
							ScriptID script = ScriptID( smSystemScript ) );

		TentativeFile( const FileLocation&,
							FileType,
							FileSignature,
							ScriptID script = ScriptID( smSystemScript ) );
		
		~TentativeFile();
		
		const FileLocation& Location() const		{ return location; }
		
		void Commit()			{ Assert( !committed ); committed = true; }
		
		void CommitReplacing( const FileLocation& );
		
		static FileLocation GoodLocation( Volume, ConstPString nameHint );
		static FileLocation GoodLocation( const FileLocation& hint );
  };

#endif
