// Volume.cp

#ifndef Volume_h
#include "Volume.h"
#endif
#ifndef VolumeBusyError_h
#include "VolumeBusyError.h"
#endif

#include <Devices.h>
#include <Errors.h>

void Volume::Unmount()
  {
	ParamBlockRec block;
	block.ioParam.ioCompletion = 0;
	block.ioParam.ioNamePtr = 0;
	block.ioParam.ioVRefNum = refNum;
	
	ThrowError( PBUnmountVol( &block ) );
  }

void Volume::Eject()
  {
	ParamBlockRec block;
	block.ioParam.ioCompletion = 0;
	block.ioParam.ioNamePtr = 0;
	block.ioParam.ioVRefNum = refNum;
	
	ThrowError( PBEject( &block ) );
  }

void Volume::BeOffline()
  {
	ParamBlockRec block;
	block.ioParam.ioCompletion = 0;
	block.ioParam.ioNamePtr = 0;
	block.ioParam.ioVRefNum = refNum;
	
	ThrowError( PBOffLine( &block ) );
  }

void Volume::Flush()
  {
	ParamBlockRec block;
	block.ioParam.ioCompletion = 0;
	block.ioParam.ioNamePtr = 0;
	block.ioParam.ioVRefNum = refNum;
	
	ThrowError( PBFlushVolSync( &block ) );
  }

void Volume::ThrowError( OSErr error )
  {
	if ( error == noErr )
		return;
	
	switch ( error )
	  {
		case fBsyErr:				throw VolumeBusyError( error );
	  }
	
	throw VolumeError( error );
  }
