// Volume.h

#ifndef Volume_h
#define Volume_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <MacTypes.h>

class Volume
  {
	private:
		int16 refNum;
	
		static void ThrowError( OSErr );
	
	public:
		explicit Volume( int16 value )
		  : refNum( value )
		  {}
	
		int16 RefNum() const							{ return refNum; }
		
		bool operator==( Volume f ) const		{ return refNum == f.refNum; }
		bool operator!=( Volume f ) const		{ return refNum != f.refNum; }

		void Unmount();
		void Eject();
		void BeOffline();
		void Flush();
  };

#endif
