// FontNumber.cp

#ifndef FontNumber_h
#include "FontNumber.h"
#endif
#ifndef ConstPString_h
#include "ConstPString.h"
#endif

#include <Fonts.h>

FontNumber::FontNumber( int16 value )
  : number( ( value == systemFont )
  					? System().Value()
  					: ( value == applFont )
  						? Application().Value()
  						: value )
  {
  }

FontNumber::FontNumber( ConstPString name )
  {
	GetFNum( name, &number );
  }

FontNumber FontNumber::System()
  {
	static int16 font = GetSysFont();
	return FontNumber( font );
  }

FontNumber FontNumber::Application()
  {
	static int16 font = GetAppFont();
	return FontNumber( font );
  }
