// FontSize.cp

#ifndef FontSize_h
#include "FontSize.h"
#endif

#include <Fonts.h>

FontSize::FontSize( uint16 value )
  : size( ( value == 0 ) ? Default().Value() : value )
  {
  }

FontSize FontSize::Default()
  {
	static int16 size = GetDefFontSize();
	return FontSize( size );
  }

void FontSize::operator+=( int16 d )
  {
	int32 result = int32( size ) + int32( d );
	
	Assert( result > 0 );
	Assert( result <= maxint16 );
	
	size = result;
  }

void FontSize::operator-=( int16 d )
  {
	int32 result = int32( size ) - int32( d );
	
	Assert( result > 0 );
	Assert( result <= maxint16 );

	size  = result;
  }

const FontSize FontSize::operator+( int16 d ) const
  {
	int32 result = int32( size ) + int32( d );
	
	Assert( result > 0 );
	Assert( result <= maxint16 );
	
	return FontSize( result );
  }

const FontSize FontSize::operator-( int16 d ) const
  {
	int32 result = int32( size ) - int32( d );
	
	Assert( result > 0 );
	Assert( result <= maxint16 );
	
	return FontSize( result );
  }
