// FontSize.h

#ifndef FontSize_h
#define FontSize_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

class FontSize
  {
	private:
		uint16 size;
		
	public:
		explicit FontSize( uint16 value );
		
		uint16 Value() const							{ return size; }
		
		static FontSize Default();
		
		static FontSize Smallest()					{ return FontSize( 1 ); }
		static FontSize Largest()					{ return FontSize( maxint16 ); }
		
		FontSize operator++()						{ Assert( size < maxint16 ); return FontSize( ++size ); }	
		FontSize operator++(int)					{ Assert( size < maxint16 ); return FontSize( size++ ); }
		
		FontSize operator--()						{ Assert( size > 1 ); return FontSize( --size ); }	
		FontSize operator--(int)					{ Assert( size > 1 ); return FontSize( size-- ); }
		
		void operator+=( int16 d );
		void operator-=( int16 d );
		
		const FontSize operator+( int16 d ) const;
		const FontSize operator-( int16 d ) const;
		
		bool operator==( FontSize f ) const		{ return size == f.size; }
		bool operator!=( FontSize f ) const		{ return size != f.size; }
		bool operator>=( FontSize f ) const		{ return size >= f.size; }
		bool operator<=( FontSize f ) const		{ return size <= f.size; }
		bool operator>( FontSize f ) const		{ return size > f.size; }
		bool operator<( FontSize f ) const		{ return size < f.size; }
  };

#endif
