// IntegerFaceMetrics.h

#ifndef IntegerFaceMetrics_h
#define IntegerFaceMetrics_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <Fonts.h>

class Face;

class IntegerFaceMetrics: public FontInfo
  {
	public:
		IntegerFaceMetrics()							{}
		IntegerFaceMetrics( const Face& );
		
		static const IntegerFaceMetrics& Current();
		
		int16 Ascent() const				{ return ascent; }
		int16 Descent() const			{ return descent; }
		int16 Leading() const			{ return leading; }
		int16 UnleadedHeight() const	{ return int16( ascent + descent ); }
		int16 LeadedHeight() const		{ return int16( ascent + descent + leading ); }
  };

#endif
