// Periodic.h

#ifndef Periodic_h
#define Periodic_h

#ifndef Enableable_h
#include "Enableable.h"
#endif
#ifndef DelayedMethod_h
#include "DelayedMethod.h"
#endif

class Periodic: public Enableable
  {
	private:
		Functor< void(*)() >& toRepeat;
		DelayedMethod< Periodic > repeat;
		uint32 period;
		Tick nextTime;
		bool inProgress;
		
		void Repeat();
	
		virtual void BeEnabled();
		virtual void BeDisabled();
		
	public:
		Periodic( Functor< void(*)() >&,
					 uint32 period,
					 bool startEnabled = true );
		
		uint32 Period() const	{ return period; }
		void SetPeriod( uint32 );
		
		void Synchronize();
  };

#endif
