// PeriodicMethod.h

#ifndef PeriodicMethod_h
#define PeriodicMethod_h

#ifndef Method_h
#include "Method.h"
#endif
#ifndef Periodic_h
#include "Periodic.h"
#endif

template < class TargetType >
class PeriodicMethod: public Periodic
  {
	private:
		Method< void (TargetType::*)() > action;
		
	public:
		PeriodicMethod( TargetType& t,
							 void (TargetType::*m)(),
							 uint32 period,
							 bool startEnabled = true )
		  : action( t, m ),
			 Periodic( action, period, startEnabled )
		  {}
  };

#endif
