// PostponableMethod.h

#ifndef PostponableMethod_h
#define PostponableMethod_h

#ifndef Method_h
#include "Method.h"
#endif
#ifndef Postponer_h
#include "Postponer.h"
#endif

template < class TargetType >
class PostponableMethod: public Postponer
  {
	private:
		Method< void (TargetType::*)() > action;
		
	public:
		PostponableMethod( TargetType& t,
								 void (TargetType::*m)() )
		  : action( t, m ),
			 Postponer( action )
		  {}
  };

#endif
