// Postponer.h

#ifndef Postponer_h
#define Postponer_h

#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef Tick_h
#include "Tick.h"
#endif
#ifndef ListOf_h
#include "ListOf.h"
#endif
#ifndef Functor_h
#include "Functor.h"
#endif

class Postponer
  {
	private:
		ListLink< Postponer > link;
		Functor< void(*)() >& perform;
		
		static ListOf< Postponer >& TheList();
		
	public:
		Postponer( Functor< void(*)() >& );
		~Postponer();
		
		bool Pending() const		{ return link.Owned(); }
		void Schedule();
		void Cancel();
		
		void Flush();
		
		static void Execute();
		static bool CanSleep();
  };

#endif
