// HandleTo.h

#ifndef HandleTo_h
#define HandleTo_h

#ifndef MasterPointerTo_h
#include "MasterPointerTo.h"
#endif

template < class Target >
class HandleTo
  {
	private:
		MasterPointerTo< Target > *handle;

		// not implemented:
			HandleTo( const HandleTo& );
			void operator=( const HandleTo& );
	
	public:
		HandleTo()
		  : handle( &MasterPointerTo<Target>::Make() )
		  {}
		
		~HandleTo()														{ delete handle; }
		
		Target& operator*() const									{ return **handle; }
		Target *operator->() const									{ return handle->operator->(); }
		
		operator Target**() const									{ return handle->Handle(); }
		
		MasterPointerTo< Target >& MasterPointer()			{ return *handle; }
		MasterPointerTo< Target >& MasterPointer() const	{ return *handle; }
  };

#endif
