// HeapZone.cp

#ifndef HeapZone_h
#include "HeapZone.h"
#endif
#ifndef MemoryError_h
#include "MemoryError.h"
#endif

HeapZone& HeapZone::Application()
  {
	static HeapZone& applicationZone( Bless( ApplicationZone() ) );
	return applicationZone;
  }

HeapZone& HeapZone::System()
  {
	static HeapZone& systemZone( Bless( SystemZone() ) );
	return systemZone;
  }

HeapZone& HeapZone::ZoneOfPointer( void *p )
  {
	THz result = PtrZone( (Ptr)p );
	MemoryError::ThrowCurrent();
	return Bless( result );
  }

HeapZone& HeapZone::ZoneOfHandle( Handle h )
  {
	THz result = HandleZone( h );
	MemoryError::ThrowCurrent();
	return Bless( result );
  }
