// HeapZone.h

#ifndef HeapZone_h
#define HeapZone_h

#include <Memory.h>

class HeapZone: public Zone
  {
	public:
		void BeCurrent()										{ SetZone( this ); }
		
		static HeapZone& Bless( THz zone )				{ return *static_cast<HeapZone *>( zone ); }
		
		static HeapZone& Application();
		static HeapZone& System();
		
		static HeapZone& Current()							{ return Bless( GetZone() ); }
		
		static HeapZone& ZoneOfPointer( void *p );
		static HeapZone& ZoneOfHandle( Handle h );
  };

#endif
