// MemoryError.h

#ifndef MemoryError_h
#define MemoryError_h

#ifndef OSError_h
#include "OSError.h"
#endif

#include <Memory.h>

class MemoryError: public OSError
  {
	public:
		MemoryError()						: OSError()		{}
		MemoryError( OSErr e )			: OSError( e )	{}
		MemoryError( OSError& e )		: OSError( e )	{}
		
		static MemoryError Current()
		  {
			return MemError();
		  }
		
		static void ThrowCurrent();
		static void DebugCurrent();
  };

inline void ThrowMemoryError( OSErr e )
  {
	if ( e != noErr )
		throw MemoryError(e);
  }

#endif
