// ExtensibleMenuSection.h

#ifndef ExtensibleMenuSection_h
#define ExtensibleMenuSection_h

#ifndef MenuSection_h
#include "MenuSection.h"
#endif

class ExtensibleMenuSection: public MenuSection
  {
	public:
		ExtensibleMenuSection( Menu& );

		uint16 Length() const;
		
		MenuItem operator[]( uint16 index );
		
		void EnableTail( uint32 begin );
		void DisableTail( uint32 begin );
		
		void EnableAll()									{ EnableTail( 0 ); }
		void DisableAll()									{ DisableTail( 0 ); }
				
		void InsertItem( uint16 index, ConstPString text );
		void AppendItem( ConstPString text )		{ menu.AppendItem( text ); }
		
		void InsertDivider( uint16 index );
		void AppendDivider()								{ menu.AppendDivider(); }
		
		void InsertResources( uint16 index, ResType );
		void AppendResources( ResType type )		{ menu.AppendResources( type ); }
		
		void DeleteItem( uint16 index );
		void DeleteAll();
  };

#endif
