// FixedMenuSection.cp

#ifndef FixedMenuSection_h
#include "FixedMenuSection.h"
#endif

FixedMenuSection::FixedMenuSection( Menu& menu, uint16 length )
  : MenuSection( menu, length )
  {
  }

MenuItem FixedMenuSection::operator[]( uint16 index )
  {
	Assert( index < maxLength );
	return menu[ firstItem + index ];
  }

void FixedMenuSection::EnableAll()
  {
	for ( uint16 i = 0; i < Length(); i++ )
		(*this)[i].Enable(); 
  }

void FixedMenuSection::DisableAll()
  {
	for ( uint16 i = 0; i < Length(); i++ )
		(*this)[i].Disable(); 
  }
