// Menu.h

#ifndef Menu_h
#define Menu_h

#ifndef MenuObject_h
#include "MenuObject.h"
#endif
#ifndef ListLink_h
#include "ListLink.h"
#endif

class Menu: public MenuObject
  {
	friend class MenuSection;
	
	private:
		enum { maxSections = 31 };
		
		MenuSection *sections[ maxSections ];
		uint16 sectionCount;
		
		MenuSection *items[ maxSections ];
		uint16 itemCount;
		
		ListLink< Menu > link;
		
		uint16 NextItem() const		{ return itemCount; }
		void AddFixedSection( MenuSection&, uint16 length );
		void AddExtensibleSection( MenuSection& );
		
	public:
		Menu( MenuID, ConstPString title );
		Menu( ResourceID );
		
		void Prepare();
		void Choose( uint16 );
		
		void Hide();
		void Show();
  };

#endif
