// MenuBar.h

#ifndef MenuBar_h
#define MenuBar_h

#ifndef MenuBarObject_h
#include "MenuBarObject.h"
#endif
#ifndef ListOf_h
#include "ListOf.h"
#endif
#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef PostponedEar_h
#include "PostponedEar.h"
#endif

class Menu;
class KeystrokeEvent;
class MouseDownEvent;

class MenuBar: public MenuBarObject
  {
	private:
		ListOf< Menu > mainMenus;
		ListOf< Menu > secondaryMenus;
		PostponedEar< MenuBar > listenToUserState;
		
		MenuBar();
		
		void Prepare();
		void Choose( MenuResult );
		
	public:
		static MenuBar& The();
		
		void Add( ListLink<Menu>&, AfterEnd );
		void Add( ListLink<Menu>&, AsSecondaryMenu );
		void Add( ListLink<Menu>&, After, const ListLink<Menu>& );

		Menu& operator[]( MenuID ) const;
		
		void Click( const MouseDownEvent& );
		void Key( const KeystrokeEvent& );
  };

#endif
