// MenuResult.h

#ifndef MenuResult_h
#define MenuResult_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef MenuID_h
#include "MenuID.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef SplitIntegers_h
#include "SplitIntegers.h"
#endif

class MenuResult
  {
	private:
		MenuID menu;
		uint16 item;
	
	public:
		MenuResult( int32 combined )
		  : menu( int16( Word1( uint32(combined) ) ) ),
			 item( uint16( Word0( uint32(combined) ) - 1u ) )
		  {
			Assert( combined == 0 || Word0( uint32(combined) ) > 0 );
		  }
		
		MenuResult( MenuID theMenu, uint16 theItem )
		  : menu( theMenu ),
			 item( theItem )
		  {
		  }
		
		bool Null() const			{ return menu == 0; }
		
		MenuID Menu() const
		  {
			Assert( !Null() );
			return menu;
		  }
		
		uint16 Item() const
		  {
			Assert( !Null() );
			return item;
		  }
  };

#endif
