// QuitMenuItem.cp

#ifndef QuitMenuItem_h
#include "QuitMenuItem.h"
#endif

const QuitMenuItem::Entry QuitMenuItem::items[] =
  {
	{ 1,	&Quitting::QuitAskingToSave,	&Quitting::CanStartQuitting },
	{ 2,	&Quitting::StopQuitting,		&Quitting::CanStopQuitting },
	{ 1,	0,										0 }
  };

QuitMenuItem::QuitMenuItem( Menu& menu )
  : SwitchedMenuItem<Quitting, bool>( menu,
  												  &Quitting::IsQuitting,
  												  items,
  												  ResourceID(129) ),
	 commandKey( CommandKey() )
  {
  }

void QuitMenuItem::Prepare()
  {
	if ( Commander<Quitting>::Null() || !Commander<Quitting>()->IsQuitting() )
		SetCommandKey( commandKey );
	 else
		RemoveCommandKey();

	SwitchedMenuItem< Quitting, bool >::Prepare();
  }
