// UndoMenuItem.cp

#ifndef UndoMenuItem_h
#include "UndoMenuItem.h"
#endif
#ifndef Commander_h
#include "Commander.h"
#endif
#ifndef Undoing_h
#include "Undoing.h"
#endif
#ifndef MessageString_h
#include "MessageString.h"
#endif

void UndoMenuItem::Prepare()
  {
	bool isDone;
	bool enabled;
	ConstData actionName;
	
	if ( Commander<Undoing>::Null() )
	  {
		isDone = true;
		enabled = false;
		actionName = ConstData();
	  }
	 else
	  {
		Commander<Undoing> commander;
		isDone = commander->ActionIsDone();
		enabled = commander->CanUndoOrRedo();
		actionName = commander->ActionName();
	  }

	const ResourceID nameResource( 128 );
		/* 
			1: Undo
		   2: Undo ^0
		   3: Can't Undo
		   4: Can't Undo ^0
		   5: Redo
		   6: Redo ^0
		   7: Can't Redo
		   8: Can't Redo ^0
		*/
	int16 nameIndex = 1 + ( isDone               ? 0 : 4 )
							  + ( enabled              ? 0 : 2 )
							  + ( actionName.IsEmpty() ? 0 : 1 );
	
	MessageString name( nameResource, nameIndex );
	if ( !actionName.IsEmpty() )
		name.Substitute( '0', actionName );
	
	SetText( name );
	SetEnabled( enabled );
  }

void UndoMenuItem::Choose()
  {
	Assert( !Commander<Undoing>::Null() );
	
	if ( !Commander<Undoing>::Null() )
		Commander<Undoing>()->UndoOrRedo();
  }
