// Method.cp

#ifndef Method_h
#include "Method.h"
#endif

#if 0

// This is an experimental implementation
// of a BoundMethod that can be passed by value.
// It doesn't work with CW Pro 4 because
// the reinterpret_casts are (incorrectly) rejected.

template < class Signature >
class BoundMethod
  {
  };


template < class R, class P1, class P2, class P3 >
class BoundMethod< R (*)(P1,P2,P3) >
  {
	private:
		class Generic  {};
		typedef R (Generic::*GenericMethod)(P1,P2,P3);
		
		void *object;
		GenericMethod method;
		R (*call)( void *, GenericMethod, P1, P2, P3 );
		
		template < class Base >
		static R Call( void *object, GenericMethod method, P1 p1, P2 p2, P3 p3 )
		  {
			return ( static_cast<Base*>( object )
						->* reinterpret_cast< R (Base::*)( P1, P2, P3 ) >( method ) )
					 ( p1, p2, p3 );
		  }
		
	public:
		template < class Base >
		BoundMethod( Base& theObject, R (Base::*theMethod)( P1, P2, P3 ) )
		  : object( &theObject ),
			 method( reinterpret_cast<GenericMethod>( theMethod ) ),
			 call( &Call<Base> )
		  {
		  }
		
		R operator()( P1 p1, P2 p2, P3 p3 ) const
		  {
			return (*call)( object, method, p1, p2, p3 );
		  }
  };

template < class R >
class BoundMethod< R (*)() >
  {
	private:
		class Generic  {};
		typedef R (Generic::*GenericMethod)();
		
		void *object;
		GenericMethod method;
		R (*call)( void *, GenericMethod );
		
		template < class Base >
		static R Call( void *object, GenericMethod method )
		  {
			return ( static_cast<Base*>( object )
						->* reinterpret_cast< R (Base::*)() >( method ) )
					 ();
		  }
		
	public:
		template < class Base >
		BoundMethod( Base& theObject, R (Base::*theMethod)() )
		  : object( &theObject ),
			 method( reinterpret_cast<GenericMethod>( theMethod ) ),
			 call( &Call<Base> )
		  {
		  }

		template < class Base >
		BoundMethod( const Base& theObject, R (Base::*theMethod)() const )
		  : object( const_cast<Base *>( &theObject ) ),
			 method( GenericMethod( theMethod ) ),
			 call( &Call<Base> )
		  {
		  }
		
		R operator()() const
		  {
			return (*call)( object, method );
		  }
  };

class X
  {
	public:
		void Foo();
		void Bar() const;
  };
class Y
  {
  };

X x;
const X cx = X();

//BoundMethod< void(*)() > m( x, &X::Bar );
//BoundMethod< void(*)() > cm( cx, &X::Foo );

void(X::*z)() = &X::Bar;

#endif
