// Method.h

#ifndef Method_h
#define Method_h

#ifndef Functor_h
#include "Functor.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

template < class Signature >
class Method
  {
	private:
		// not implemented:
			Method( const Method& );
			void operator=( const Method& );
  };

template < class R, class Object >
class Method< R (Object::*)() >
  : public Functor< R (*)() >
  {
	private:
		typedef R (Object::*Member)();
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()()
		  {
			return (object.*member)();
		  }
  };

template < class R, class Object, class P0 >
class Method< R (Object::*)( P0 ) >
  : public Functor< R (*)( P0 ) >
  {
	private:
		typedef R (Object::*Member)( P0 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0 )
		  {
			return (object.*member)( p0 );
		  }
  };

template < class R, class Object, class P0, class P1 >
class Method< R (Object::*)( P0, P1 ) >
  : public Functor< R (*)( P0, P1 ) >
  {
	private:
		typedef R (Object::*Member)( P0, P1 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0, P1 p1 )
		  {
			return (object.*member)( p0, p1 );
		  }
  };

template < class R, class Object, class P0, class P1, class P2 >
class Method< R (Object::*)( P0, P1, P2 ) >
  : public Functor< R (*)( P0, P1, P2 ) >
  {
	private:
		typedef R (Object::*Member)( P0, P1, P2 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0, P1 p1, P2 p2 )
		  {
			return (object.*member)( p0, p1, p2 );
		  }
  };

template < class R, class Object, class P0, class P1, class P2, class P3 >
class Method< R (Object::*)( P0, P1, P2, P3 ) >
  : public Functor< R (*)( P0, P1, P2, P3 ) >
  {
	private:
		typedef R (Object::*Member)( P0, P1, P2, P3 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0, P1 p1, P2 p2, P3 p3 )
		  {
			return (object.*member)( p0, p1, p2, p3 );
		  }
  };

template < class R, class Object, class P0, class P1, class P2, class P3, class P4 >
class Method< R (Object::*)( P0, P1, P2, P3, P4 ) >
  : public Functor< R (*)( P0, P1, P2, P3, P4 ) >
  {
	private:
		typedef R (Object::*Member)( P0, P1, P2, P3, P4 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0, P1 p1, P2 p2, P3 p3, P4 p4 )
		  {
			return (object.*member)( p0, p1, p2, p3, p4 );
		  }
  };

template < class R, class Object, class P0, class P1, class P2, class P3, class P4,
											 class P5 >
class Method< R (Object::*)( P0, P1, P2, P3, P4, P5 ) >
  : public Functor< R (*)( P0, P1, P2, P3, P4, P5 ) >
  {
	private:
		typedef R (Object::*Member)( P0, P1, P2, P3, P4, P5 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0, P1 p1, P2 p2, P3 p3, P4 p4,
									 P5 p5 )
		  {
			return (object.*member)( p0, p1, p2, p3, p4, p5 );
		  }
  };

template < class R, class Object, class P0, class P1, class P2, class P3, class P4,
											 class P5, class P6 >
class Method< R (Object::*)( P0, P1, P2, P3, P4, P5, P6 ) >
  : public Functor< R (*)( P0, P1, P2, P3, P4, P5, P6 ) >
  {
	private:
		typedef R (Object::*Member)( P0, P1, P2, P3, P4, P5, P6 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0, P1 p1, P2 p2, P3 p3, P4 p4,
									 P5 p5, P6 p6 )
		  {
			return (object.*member)( p0, p1, p2, p3, p4, p5, p6 );
		  }
  };

template < class R, class Object, class P0, class P1, class P2, class P3, class P4,
											 class P5, class P6, class P7 >
class Method< R (Object::*)( P0, P1, P2, P3, P4, P5, P6, P7 ) >
  : public Functor< R (*)( P0, P1, P2, P3, P4, P5, P6, P7 ) >
  {
	private:
		typedef R (Object::*Member)( P0, P1, P2, P3, P4, P5, P6, P7 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0, P1 p1, P2 p2, P3 p3, P4 p4,
									 P5 p5, P6 p6, P7 p7 )
		  {
			return (object.*member)( p0, p1, p2, p3, p4, p5, p6, p7 );
		  }
  };

template < class R, class Object, class P0, class P1, class P2, class P3, class P4,
											 class P5, class P6, class P7, class P8 >
class Method< R (Object::*)( P0, P1, P2, P3, P4, P5, P6, P7, P8 ) >
  : public Functor< R (*)( P0, P1, P2, P3, P4, P5, P6, P7, P8 ) >
  {
	private:
		typedef R (Object::*Member)( P0, P1, P2, P3, P4, P5, P6, P7, P8 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0, P1 p1, P2 p2, P3 p3, P4 p4,
									 P5 p5, P6 p6, P7 p7, P8 p8 )
		  {
			return (object.*member)( p0, p1, p2, p3, p4, p5, p6, p7, p8 );
		  }
  };

template < class R, class Object, class P0, class P1, class P2, class P3, class P4,
											 class P5, class P6, class P7, class P8, class P9 >
class Method< R (Object::*)( P0, P1, P2, P3, P4, P5, P6, P7, P8, P9 ) >
  : public Functor< R (*)( P0, P1, P2, P3, P4, P5, P6, P7, P8, P9 ) >
  {
	private:
		typedef R (Object::*Member)( P0, P1, P2, P3, P4, P5, P6, P7, P8, P9 );
		Object& object;
		Member member;
		
	public:
		Method( Object& o, Member m )
		  : object( o ),
			 member( m )
		  {
			Assert( m != 0 );
		  }
		
		virtual R operator()( P0 p0, P1 p1, P2 p2, P3 p3, P4 p4,
									 P5 p5, P6 p6, P7 p7, P8 p8, P9 p9 )
		  {
			return (object.*member)( p0, p1, p2, p3, p4, p5, p6, p7, p8, p9 );
		  }
  };

#endif
