// AppearanceManagerUser.cp

#ifndef AppearanceManagerUser_h
#include "AppearanceManagerUser.h"
#endif
#ifndef __APPEARANCE__
#include <Appearance.h>
#endif
#ifndef OSError_h
#include "OSError.h"
#endif

#include <Gestalt.h>

class AppearanceManagerUser::Initializer
  {
	public:
		Initializer()		{ RegisterAppearanceClient(); }
		~Initializer()		{ UnregisterAppearanceClient(); }
  };

AppearanceManagerUser::AppearanceManagerUser()
  {
	static Initializer initializer;
  }

uint16 AppearanceManagerUser::GetVersion()
  {
	int32 result;
	
	OSErr error = Gestalt( gestaltAppearanceVersion, &result );
	
	if ( error == noErr )
		return uint16( result );
	
	if ( error != gestaltUndefSelectorErr )
		OSError::Debug( error );
	
	error = Gestalt( gestaltAppearanceAttr, &result );

	if ( error == noErr )
		return 0x0100;

	if ( error != gestaltUndefSelectorErr )
		OSError::Debug( error );
		
	return 0;
  }

uint16 AppearanceManagerUser::Version()
  {
	static uint16 version = GetVersion();
	return version;
  }
