// MachineLocationObject.cp

#ifndef MachineLocationObject_h
#include "MachineLocationObject.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

// This is a cheap compile-time assertion that
// the sizes are equal:
	static const void *shouldBeNull
		= sizeof(MachineLocation) - sizeof(MachineLocationObject);

MachineLocationObject& MachineLocationObject::The()
  {
	static MachineLocationObject the;
	return the;
  }

int32 MachineLocationObject::SecondsEastOfGMT() const
  {
	return ( u.gmtDelta & 0x00800000 )
	 		? int32( u.gmtDelta | 0xff000000 )
			: int32( u.gmtDelta & 0x00ffffff );
  }

bool MachineLocationObject::SavingDaylight() const
  {
	return (u.dlsDelta & 0x80) != 0;
  }

void MachineLocationObject::SetSecondsFromGMT( int32 s )
  {
	Assert( s >= -(1L << 23) );
	Assert( s < 1L << 23 );
	
	u.gmtDelta = (s & 0x00ffffff) | (u.gmtDelta & 0xff000000);
  }

void MachineLocationObject::SetSavingDaylight()
  {
	u.dlsDelta |= 0x80;
  }

void MachineLocationObject::ClearSavingDaylight()
  {
	u.dlsDelta &= ~0x80;
  }

void MachineLocationObject::SetSavingDaylight( bool value )
  {
	if ( value )
		SetSavingDaylight();
	 else
		ClearSavingDaylight();
  }
