// MachineLocationObject.h

#ifndef MachineLocationObject_h
#define MachineLocationObject_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <OSUtils.h>

class MachineLocationObject: public MachineLocation
  {
	public:
		MachineLocationObject()
		  { Get(); }
	
		static MachineLocationObject& The();
		
		void Get()							{ ReadLocation( this ); }
		void Set() const					{ WriteLocation( this ); }
		
		Fract Latitude() const			{ return latitude; }
		Fract Longitude() const			{ return longitude; }
		
		int32 SecondsEastOfGMT() const;
		bool SavingDaylight() const;
		
		void SetLatitude( Fract x )	{ latitude = x; }
		void SetLongitude( Fract y )	{ longitude = y; }

		void SetSecondsFromGMT( int32 );
		
		void SetSavingDaylight();
		void ClearSavingDaylight();
		void SetSavingDaylight( bool );
  };

#endif
