// Patch.h

#ifndef Patch_h
#define Patch_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <MacTypes.h>
#include <OSUtils.h>

class PatchBase
  {
	private:
		UniversalProcPtr old;
		int32 procInfo;
		int16 trapNumber;
		TrapType type;
	
		// not implemented:
			PatchBase( const PatchBase& );
			void operator=( const PatchBase& );
		
	public:
		PatchBase( TrapType type,
					  int16 trapNumber,
					  int32 procInfo,
					  const RoutineDescriptor *patch );
		
		~PatchBase();
		
		int32 ProcInfo() const				{ return procInfo; }		  
		UniversalProcPtr Old() const		{ return old; }
  };

#endif
