// Registers.h

#ifndef Registers_h
#define Registers_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef __CONDITIONALMACROS__
#include <ConditionalMacros.h>
#endif

#if !GENERATINGCFM

#pragma parameter __D0 RegisterD0()
uint32 RegisterD0() ONEWORDINLINE( 0x4e71 );		// nop

#pragma parameter __D1 RegisterD1()
uint32 RegisterD1() ONEWORDINLINE( 0x4e71 );		// nop

#pragma parameter __D2 RegisterD2()
uint32 RegisterD2() ONEWORDINLINE( 0x4e71 );		// nop

#pragma parameter __D0 RegisterD3()
uint32 RegisterD3() ONEWORDINLINE( 0x2003 );		// move.l d3,d0

#pragma parameter __D0 RegisterD4()
uint32 RegisterD4() ONEWORDINLINE( 0x2004 );		// move.l d4,d0

#pragma parameter __D0 RegisterD5()
uint32 RegisterD5() ONEWORDINLINE( 0x2005 );		// move.l d5,d0

#pragma parameter __D0 RegisterD6()
uint32 RegisterD6() ONEWORDINLINE( 0x2006 );		// move.l d6,d0

#pragma parameter __D0 RegisterD7()
uint32 RegisterD7() ONEWORDINLINE( 0x2007 );		// move.l d7,d0



#pragma parameter __A0 RegisterA0()
void *RegisterA0() ONEWORDINLINE( 0x4e71 );		// nop

#pragma parameter __A1 RegisterA1()
void *RegisterA1() ONEWORDINLINE( 0x4e71 );		// nop

#pragma parameter __A0 RegisterA2()
void *RegisterA2() ONEWORDINLINE( 0x204a );		// movea.l a2,a0

#pragma parameter __A0 RegisterA3()
void *RegisterA3() ONEWORDINLINE( 0x204b );		// movea.l a3,a0

#pragma parameter __A0 RegisterA4()
void *RegisterA4() ONEWORDINLINE( 0x204c );		// movea.l a4,a0

#pragma parameter __A0 RegisterA5()
void *RegisterA5() ONEWORDINLINE( 0x204d );		// movea.l a5,a0

#pragma parameter __A0 RegisterA6()
void *RegisterA6() ONEWORDINLINE( 0x204e );		// movea.l a6,a0

#pragma parameter __A0 RegisterA7()
void *RegisterA7() ONEWORDINLINE( 0x204f );		// movea.l a7,a0



#pragma parameter SetRegisterD0(__D0)
void SetRegisterD0( uint32 ) ONEWORDINLINE( 0x4e71 );	// nop

#pragma parameter SetRegisterD1(__D1)
void SetRegisterD1( uint32 ) ONEWORDINLINE( 0x4e71 );	// nop

#pragma parameter SetRegisterD2(__D2)
void SetRegisterD2( uint32 ) ONEWORDINLINE( 0x4e71 );	// nop

#pragma parameter SetRegisterD3(__D0)
void SetRegisterD3( uint32 ) ONEWORDINLINE( 0x2600 );	// move.l d0,d3

#pragma parameter SetRegisterD4(__D0)
void SetRegisterD4( uint32 ) ONEWORDINLINE( 0x2800 );	// move.l d0,d4

#pragma parameter SetRegisterD5(__D0)
void SetRegisterD5( uint32 ) ONEWORDINLINE( 0x2a00 );	// move.l d0,d5

#pragma parameter SetRegisterD6(__D0)
void SetRegisterD6( uint32 ) ONEWORDINLINE( 0x2c00 );	// move.l d0,d6

#pragma parameter SetRegisterD7(__D0)
void SetRegisterD7( uint32 ) ONEWORDINLINE( 0x2e00 );	// move.l d0,d7



#pragma parameter SetRegisterA0(__A0)
void SetRegisterA0( void * ) ONEWORDINLINE( 0x4e71 );	// nop

#pragma parameter SetRegisterA1(__A1)
void SetRegisterA1( void * ) ONEWORDINLINE( 0x4e71 );	// nop

#pragma parameter SetRegisterA2(__A0)
void SetRegisterA2( void * ) ONEWORDINLINE( 0x2448 );	// movea.l a0,a2

#pragma parameter SetRegisterA3(__A0)
void SetRegisterA3( void * ) ONEWORDINLINE( 0x2648 );	// movea.l a0,a3

#pragma parameter SetRegisterA4(__A0)
void SetRegisterA4( void * ) ONEWORDINLINE( 0x2848 );	// movea.l a0,a4

#pragma parameter SetRegisterA5(__A0)
void SetRegisterA5( void * ) ONEWORDINLINE( 0x2a48 );	// movea.l a0,a5

#pragma parameter SetRegisterA6(__A0)
void SetRegisterA6( void * ) ONEWORDINLINE( 0x2c48 );	// movea.l a0,a6

#pragma parameter SetRegisterA7(__A0)
void SetRegisterA7( void * ) ONEWORDINLINE( 0x2e48 );	// movea.l a0,a7

#endif

#endif
