// MouseWatcher.h

#ifndef MouseWatcher_h
#define MouseWatcher_h

#ifndef Enableable_h
#include "Enableable.h"
#endif
#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef RegionObject_h
#include "RegionObject.h"
#endif

class MouseEvent;

class MouseWatcher: public Enableable
  {
	private:
		RegionObject sleepRegion;
		ListLink< MouseWatcher > link;
		
		static ListOf< MouseWatcher >& TheList();
		
	protected:
		~MouseWatcher()								{}
		
		virtual void BeEnabled();
		virtual void BeDisabled();
		
		virtual void MouseMoved( const MouseEvent&,
										 RegionObject& sleep ) = 0;
		
		void Invalidate()			{ sleepRegion.BeEmpty(); }
		
	public:
		MouseWatcher( bool startEnabled = true );

		static const RegionObject& MouseSleepRegion();
		static void Report( const MouseEvent& );
  };

#endif
