// NewByNewPtr.cp

#ifndef NewByNewPtr_h
#include "NewByNewPtr.h"
#endif
#ifndef MemoryFullError_h
#include "MemoryFullError.h"
#endif
#ifndef __ERRORS__
#include <Errors.h>
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

void *operator new( size_t size )
  {
	void *result = NewPtr( size );
	OSErr error( MemError() );
	
	if ( error == memFullErr )
		throw MemoryFullError();
	
	if ( error != noErr )
		throw MemoryError( error );
	
	if ( result == 0 )
		throw MemoryFullError();
		
	return result;
  }

void operator delete( void *p )
  {
	Assert( p != 0 );
	
	if ( p == 0 )
		return;
	
	DisposePtr( static_cast<Ptr>( p ) );
	
	MemoryError::DebugCurrent();
  }

void *operator new( size_t size, const nothrow_t& )
  {
	void *result = NewPtr( size );
	OSErr error( MemError() );

	if ( error != noErr && error != memFullErr )
		throw MemoryError( error );
		
	return result;
  }

#if 0
// No placement delete in CW Pro 4
	void operator delete( void *p, const nothrow_t& )
	  {
		::operator delete( p );
	  }
#endif

void *operator new[]( size_t size )
  {
	return ::operator new( size );
  }

void operator delete[]( void *p )
  {
	::operator delete( p );
  }

void *operator new[]( size_t size, const nothrow_t& )
  {
	return ::operator new( size );
  }

#if 0
// No placement delete in CW Pro 4
void operator delete[]( void *p )
  {
	::operator delete( p );
  }
#endif
