// OpenerList.h

#ifndef OpenerList_h
#define OpenerList_h

#ifndef RedBlackLinkTree_h
#include "RedBlackLinkTree.h"
#endif
#ifndef FileType_h
#include "FileType.h"
#endif

class Opener;
class CatInfo;

class OpenerList
  {
	friend class Opener;
	
	private:
		RedBlackLinkTree< uint32, Opener > tree;
	
		OpenerList();
		~OpenerList();	
		
	public:
		static OpenerList& The();
		
		bool IsEmpty()					{ return tree.IsEmpty(); }
		
		Opener *OpenerFor( FileType ) const;
		
		bool CanOpen( const CatInfo& ) const;
		bool CanPrint( const CatInfo& ) const;
		
		void Open( const CatInfo& ) const;
		void Print( const CatInfo& ) const;
  };

#endif
