// Opening.cp

#ifndef Opening_h
#include "Opening.h"
#endif
#ifndef OpenerList_h
#include "OpenerList.h"
#endif
#ifndef CatInfo_h
#include "CatInfo.h"
#endif
#ifndef PointObject_h
#include "PointObject.h"
#endif
#ifndef UserCancelledError_h
#include "UserCancelledError.h"
#endif

#include <StandardFile.h>

bool Opening::CanOpenFile() const
  {
	return !OpenerList::The().IsEmpty();
  }

bool Opening::CanOpen( const CatInfo& file ) const
  {
	return OpenerList::The().CanOpen( file );
  }

FileLocation Opening::ChooseFile() const
  {
	#if GENERATINGCFM
		static RoutineDescriptor FileFilter =
			BUILD_ROUTINE_DESCRIPTOR( uppFileFilterYDProcInfo,
											  &Opening::FileFilter );
	#endif
	
	StandardFileReply reply;
	
	CustomGetFile( &FileFilter,
						-2,	// kUseOpenResourceTypes
						0,		// type list
						&reply,
						0,		// dialog ID
						PointObject( -1, -1 ),
						0,		// dialog hook
						0,		// event filter
						0,		// active item list
						0,		// activate procedure
						const_cast<Opening*>( this ) );
	
	if ( !reply.sfGood )
		throw UserCancelledError();
	
	return FileLocation( reply.sfFile );
  }

void Opening::OpenFile( const CatInfo& file )
  {
	OpenerList::The().Open( file );
  }

void Opening::PrintFile( const CatInfo& file )
  {
	OpenerList::The().Print( file );
  }

void Opening::ChooseAndOpenFile()
  {
	OpenFile( CatInfo( ChooseFile() ) );
  }

pascal Boolean Opening::FileFilter( CInfoPBPtr file, void *self )
  {
	Assert( self != 0 );
	return !static_cast<Opening*>(self)->CanOpen( CatInfo( *file ) );
  }
