// MessageString.cp

#ifndef MessageString_h
#include "MessageString.h"
#endif

#include <TextUtils.h>

MessageString::MessageString( ResourceID resource, uint16 itemNumber )
  {
	Assert( itemNumber > 0 );
	Assert( itemNumber <= maxint16 );
	
	GetIndString( *this, resource.Value(), itemNumber );
	Assert( Length() > 0 );
  }

MessageString::Substitution::~Substitution()
  {
	if ( target == 0 )
		return;
	
	Substitute();
	for ( Substitution *s = this; s != 0; s = s->next )
		s->target = 0;
  }

void MessageString::Substitution::Substitute()
  {
	if ( target->Length() < 2 )
		return;
	
	for ( uint32 i = target->Length() - 1; i > 0; i-- )
	  {
		if ( (*target)[i-1] != '^' )
			continue;
		
		Substitution *s = this;
		
		while ( s != 0 && s->toReplace != (*target)[i] )
			s = s->next;
		
		if ( s == 0 )
			continue;
		
		target->Replace( URange32( i-1, i+1 ), s->replacement );
	  }
  }
