// PageSetupInfo.cp

#ifndef PageSetupInfo_h
#include "PageSetupInfo.h"
#endif
#ifndef PrintManager_h
#include "PrintManager.h"
#endif
#ifndef PrintingError_h
#include "PrintingError.h"
#endif
#ifndef UserCancelledError_h
#include "UserCancelledError.h"
#endif

PageSetupInfo::PageSetupInfo( PrintManager& manager )
  {
	PrintDefault( manager.printHandle );
	ThrowPrintingError( PrError() );
	AsTPrint() = *manager.printHandle;
  }

void PageSetupInfo::ShowDialog( PrintManager& manager )
  {
	*manager.printHandle = AsTPrint();
	PrValidate( manager.printHandle );

	bool okayed = PrStlDialog( manager.printHandle );
	ThrowPrintingError( PrError() );
	
	if ( okayed )
	  {
		AsTPrint() = *manager.printHandle;
		Announce();
	  }
	 else
		throw UserCancelledError();
  }
