// PrintBatch.h

#ifndef PrintBatch_h
#define PrintBatch_h

#ifndef Assert_h
#include "Assert.h"
#endif

#include <Printing.h>

class PrintJob;

class PrintBatch
  {
	private:
		const PrintJob& job;
		TPrPort port;
		char buffer[522];
		bool started;
	
		static bool batchExists;
		
		// not implemented:
			PrintBatch( const PrintBatch& );
			void operator=( const PrintBatch& );
	
	public:
		explicit PrintBatch( const PrintJob& );
		~PrintBatch();
		
		void Start();
		void End();
		
		void Split()							{ End(); Start(); }
		
		TPrPort& Port() 						{ Assert( started ); return port; }
		const TPrPort& Port() const  		{ Assert( started ); return port; }
  };

#endif
