// PrintCopyLoop.h

#ifndef PrintCopyLoop_h
#define PrintCopyLoop_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef PrintBatch_h
#include "PrintBatch.h"
#endif
#ifndef PortMaintainer_h
#include "PortMaintainer.h"
#endif

class PrintJob;

class PrintCopyLoop
  {
	private:
		PortMaintainer oldPort;
		PrintBatch batch;
		uint32 number;
		uint32 stop;
		
		// not implemented:
			PrintCopyLoop( const PrintCopyLoop& );
			void operator=( const PrintCopyLoop& );
	
	public:
		explicit PrintCopyLoop( PrintJob& );
		
		bool Finished() const				{ return number >= stop; }
		bool Unfinished() const				{ return number < stop; }
		
		uint32 Number() const				{ return number; }
		
		void operator++();
		void operator++(int)					{ operator++(); }
		
		PrintBatch& Batch()					{ return batch; }
  };

#endif
