// PrintJob.cp

#ifndef PrintJob_h
#include "PrintJob.h"
#endif
#ifndef PrintingError_h
#include "PrintingError.h"
#endif
#ifndef PrintManager_h
#include "PrintManager.h"
#endif
#ifndef PageSetupInfo_h
#include "PageSetupInfo.h"
#endif
#ifndef PrintJobInfo_h
#include "PrintJobInfo.h"
#endif

PrintJob::PrintJob( const PrintManager& manager,
						  const PageSetupInfo& pageSetup,
						  const PrintJobInfo& jobInfo )
  {
	*printHandle = pageSetup;
	*manager.printHandle = jobInfo;
	PrJobMerge( manager.printHandle, printHandle );
	ThrowPrintingError( PrError() );
	
	// Extract the page range from the print record,
	// replacing it with the maximum range -- we'll
	// do our own page selection.
		firstPage = printHandle->prJob.iFstPage;
		lastPage =  printHandle->prJob.iLstPage;
		printHandle->prJob.iFstPage = 1;
		printHandle->prJob.iLstPage = iPrPgMax;
  }
