// PrintJobInfo.cp

#ifndef PrintJobInfo_h
#include "PrintJobInfo.h"
#endif
#ifndef PrintManager_h
#include "PrintManager.h"
#endif
#ifndef PrintingError_h
#include "PrintingError.h"
#endif
#ifndef UserCancelledError_h
#include "UserCancelledError.h"
#endif

PrintJobInfo::PrintJobInfo( PrintManager& manager )
  {
	PrintDefault( manager.printHandle );
	ThrowPrintingError( PrError() );
	AsTPrint() = *manager.printHandle;
  }

void PrintJobInfo::ShowDialog( PrintManager& manager )
  {
	*manager.printHandle = AsTPrint();
	PrValidate( manager.printHandle );

	bool okayed = PrJobDialog( manager.printHandle );
	ThrowPrintingError( PrError() );
	
	if ( okayed )
		AsTPrint() = *manager.printHandle;
	 else
		throw UserCancelledError();
  }
