// PrintPage.cp

#ifndef PrintPage_h
#include "PrintPage.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef PrintingError_h
#include "PrintingError.h"
#endif

bool PrintPage::pageExists = false;

PrintPage::PrintPage()
  : port( 0 )
  {
	Assert( !pageExists );
	pageExists = true;
  }

PrintPage::~PrintPage()
  {
	if ( port != 0 )
	  {
		PrClosePage( port );
		DebugOSError( PrError() );
	  }
	
	Assert( pageExists );
	pageExists = false;
  }

void PrintPage::Start( TPrPort& thePort )
  {
	Assert( port == 0 );

	PrOpenPage( &thePort, 0 );
	ThrowPrintingError( PrError() );
	
	port = &thePort;
  }

void PrintPage::End()
  {
	Assert( port != 0 );
	
	TPrPort *thePort = port;
	port = 0;
	
	PrClosePage( thePort );
	ThrowPrintingError( PrError() );
  }
