// PrintPageLoop.cp

#ifndef PrintPageLoop_h
#include "PrintPageLoop.h"
#endif
#ifndef PrintCopyLoop_h
#include "PrintCopyLoop.h"
#endif
#ifndef PrintJob_h
#include "PrintJob.h"
#endif

PrintPageLoop::PrintPageLoop( const PrintJob& job,
										PrintCopyLoop& copyLoop )
  : batch( copyLoop.Batch() ),
	 number( job.FirstPage() ),
	 start( job.FirstPage() ),
	 stop( job.LastPage() + 1 )
  {
	if ( Unfinished() )
		page.Start( batch.Port() );
  }

void PrintPageLoop::operator++()
  {
	Assert( Unfinished() );
	page.End();
	
	number++;
	
	if ( Unfinished() )
	  {
		if ( (number - start) % iPFMaxPgs == 0 )
			batch.Split();
	  
		page.Start( batch.Port() );
	  }
  }
