// PrintPageLoop.h

#ifndef PrintPageLoop_h
#define PrintPageLoop_h

#ifndef PrintPage_h
#include "PrintPage.h"
#endif

class PrintJob;
class PrintCopyLoop;
class PrintBatch;

class PrintPageLoop
  {
	private:
		PrintBatch& batch;
		PrintPage page;
		uint32 number;
		const uint32 start;
		const uint32 stop;
		
	public:
		explicit PrintPageLoop( const PrintJob&, PrintCopyLoop& );
		
		bool Finished() const				{ return number >= stop; }
		bool Unfinished() const				{ return number < stop; }
		
		uint32 Number() const				{ return number; }
		
		void operator++();
		void operator++(int)					{ operator++(); }
  };

#endif
