// Process.h

#ifndef Process_h
#define Process_h

#ifndef Integers_h
#include "Integers.h"
#endif

#include <Processes.h>

class Process
  {
	private:
		ProcessSerialNumber psn;
	
	public:
		Process( ProcessSerialNumber thePSN )
		  : psn( thePSN )
		  {}

		enum ApplicationProcess{ application };
		enum FrontProcess{ front };

		Process( ApplicationProcess );
		Process( FrontProcess );
		
		static const Process& Application();
		static Process Front() 								{ return Process( front ); }
		
		bool operator==( const Process& ) const;
		bool operator!=( const Process& r ) const		{ return !(*this == r); }
		
		void Wake() const;
		void MoveToFront() const;
		
		const ProcessSerialNumber& Number() const		{ return psn; }
  };

#endif
