// ProcessLoop.cp

#ifndef ProcessLoop_h
#include "ProcessLoop.h"
#endif
#ifndef ProcessError_h
#include "ProcessError.h"
#endif

const ProcessSerialNumber ProcessLoop::noProcess = { 0, kNoProcess };

ProcessLoop::ProcessLoop()
  : process( noProcess ),
	 finished( false )
  {
	operator++();
  }

void ProcessLoop::operator++()
  {
	ProcessSerialNumber number( process.Number() );
	
	ThrowProcessError( GetNextProcess( &number ) );
	
	if ( number.highLongOfPSN == noProcess.highLongOfPSN
		  && number.lowLongOfPSN == noProcess.lowLongOfPSN )
		finished = true;
	 else
		process = number;
  }
