// SimpleConstProxy.h

#ifndef SimpleConstProxy_h
#define SimpleConstProxy_h

#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef ConstProxy_h
#include "ConstProxy.h"
#endif

template < class Owner, class StoodFor >
class SimpleConstProxy: public ConstProxy< StoodFor >
  {
	typedef StoodFor (Owner::*Getter)() const;
	
	private:
		const Owner& owner;
		const Getter get;
	
	public:
		SimpleConstProxy( const Owner& theOwner, Getter getter )
		  : owner( theOwner ),
			 get( getter )
		  {
			Assert( getter != 0 );
		  }
		
		virtual StoodFor Get() const
		  {
			return (owner.*get)();
		  }
  };

#endif
