// TextEditClipboard.cp

#ifndef TextEditClipboard_h
#include "TextEditClipboard.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif

#include <TextEdit.h>
#include <Errors.h>

TextEditClipboard::~TextEditClipboard()
  {
	try
	  {
		Flush();
	  }
	 catch ( ... )
	  {
	  }
  }

void TextEditClipboard::Import( const ScrapReader& )
  {
	OSErr error = TEFromScrap();
	if ( error != noTypeErr )
		ThrowOSError( error );
  }

void TextEditClipboard::Export( ScrapWriter& ) const
  {
	ThrowOSError( TEToScrap() );
  }

void TextEditClipboard::Clear()
  {
  }

TextEditClipboard& TextEditClipboard::The()
  {
	static TextEditClipboard the;
	return the;
  }

uint32 TextEditClipboard::Length()
  {
	Validate();
	return TEGetScrapLength();
  }
