// TextEditPaster.cp

#ifndef TextEditPaster_h
#include "TextEditPaster.h"
#endif
#ifndef TooLargeForTextEdit_h
#include "TooLargeForTextEdit.h"
#endif

#include <Dialogs.h>

TextEditPaster::TextEditPaster()
  : Paster( TextEditClipboard::The() ),
	 scrapLength( TEGetScrapLength() )
  {
  }

bool TextEditPaster::CanPasteTo( TEHandle te ) const
  {
	if ( scrapLength > maxint16 )
		return false;
	
	uint32 textLength = (*te)->teLength;
	uint32 selectionLength = (*te)->selEnd - (*te)->selStart;

	return textLength - selectionLength + scrapLength <= maxint16;
  }

void TextEditPaster::Paste( TEHandle te ) const
  {
	if ( !CanPasteTo( te ) )
		throw TooLargeForTextEdit();
	
	TEPaste( te );
  }

void TextEditPaster::Paste( DialogRecord& dialog ) const
  {
	if ( dialog.textH != 0 && !CanPasteTo( dialog.textH ) )
		throw TooLargeForTextEdit();

	DialogPaste( &dialog.window.port );
  }
