// GrowBox.cp

#ifndef GrowBox_h
#include "GrowBox.h"
#endif
#ifndef WindowFocus_h
#include "WindowFocus.h"
#endif
#ifndef GrafPortObject_h
#include "GrafPortObject.h"
#endif
#ifndef Canvas_h
#include "Canvas.h"
#endif
#ifndef RectangleDifference_h
#include "RectangleDifference.h"
#endif

GrowBox::GrowBox( WindowFocus& focus )
  : Activator( focus )
  {
  }

void GrowBox::Activate()
  {
	Redraw();
  }

void GrowBox::Deactivate()
  {
	Redraw();
  }
 
void GrowBox::Draw( const Canvas& canvas ) const
  {
	DrawGrowIcon( &canvas.Port() );
	Rectangle drawn( canvas.Port().LocalBounds().right - 15,		canvas.Port().LocalBounds().bottom - 15,
						  canvas.Port().LocalBounds().right,			canvas.Port().LocalBounds().bottom );
	Erase( canvas.OnScreen() - drawn );
  }
