// GrowBox.h

#ifndef GrowBox_h
#define GrowBox_h

#ifndef Activator_h
#include "Activator.h"
#endif
#ifndef ViewCell_h
#include "ViewCell.h"
#endif
#ifndef DrawsSpontaneously_h
#include "DrawsSpontaneously.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif

class WindowFocus;

class GrowBox: virtual public ViewCell,
					virtual public DrawsSpontaneously,
					virtual public SuggestsPaneSize,
					public Activator
  {
	protected:
		virtual void Activate();
		virtual void Deactivate();
	
	public:
		GrowBox( WindowFocus& );
		
		virtual void Draw( const Canvas& ) const;

		virtual int32 MinimumWidth() const		{ return 14; }
		virtual int32 MinimumHeight() const		{ return 14; }
		
		virtual int32 MaximumWidth() const		{ return 14; }
		virtual int32 MaximumHeight() const		{ return 14; }
  };

#endif
