// CanvasColumnLoop.cp

#ifndef CanvasColumnLoop_h
#include "CanvasColumnLoop.h"
#endif

CanvasColumnLoop::CanvasColumnLoop( const Canvas& theParent,
												Range32 firstColumn )
  : parent( theParent ),
	 canvas( theParent ),
	 column( firstColumn )
  {
	if ( Unfinished() )
	  {
		canvas.SliceVertically( column );
		canvasMaintainer.Use( canvas );
	  }
	 else
		canvasMaintainer.UseNone();
  }

void CanvasColumnLoop::NextColumn( uint32 width )
  {
	Assert( Unfinished() );

	Assert( width <= maxint32 - column.End() );
	column = Range32( column.End(), column.End() + width );

	if ( Unfinished() )
	  {
		canvas = parent;
		canvas.SliceVertically( column );
		canvasMaintainer.Use( canvas );
	  }
	 else
		canvasMaintainer.UseNone();
  }
