// CanvasLoopBase.h

#ifndef CanvasLoopBase_h
#define CanvasLoopBase_h

#ifndef Canvas_h
#include "Canvas.h"
#endif
#ifndef Stack_h
#include "Stack.h"
#endif

class Pane;
class DrawsSpontaneously;

class CanvasLoopBase
  {
	private:
		Stack< const Pane *, 24 > path;
		::Canvas canvas;
	
		void FindFirstPath( const DrawsSpontaneously * );
		void AdvancePath();
		
		void AdvancePathUntilReachingPort();
		
		void FindFirstPathToPort( const DrawsSpontaneously * );
		void AdvancePathToPort();
		
		void BuildCanvas();
		void AdvanceUntilVisible();
		
		// not implemented:
			CanvasLoopBase( const CanvasLoopBase& );
			void operator=( const CanvasLoopBase& );
	
	protected:
		::Canvas& Canvas()							{ return canvas; }
		
	public:
		CanvasLoopBase( const DrawsSpontaneously& );
		
		bool Finished() const						{ return path.IsEmpty(); }
		bool Unfinished() const						{ return !path.IsEmpty(); }
		
		void operator++();
		void operator++(int)							{ operator++(); }
		
		const ::Canvas& Canvas() const			{ return canvas; }
		
		const ::Canvas *operator->() const		{ return &canvas; }
		const ::Canvas& operator*() const		{ return canvas; }
  };

#endif
