// CanvasRowLoop.cp

#ifndef CanvasRowLoop_h
#include "CanvasRowLoop.h"
#endif

CanvasRowLoop::CanvasRowLoop( const Canvas& theParent,
										Range32 firstRow )
  : parent( theParent ),
	 canvas( theParent ),
	 row( firstRow )
  {
	if ( Unfinished() )
	  {
		canvas.SliceHorizontally( row );
		canvasMaintainer.Use( canvas );
	  }
	 else
		canvasMaintainer.UseNone();
  }

void CanvasRowLoop::NextRow( uint32 height )
  {
	Assert( Unfinished() );

	Assert( height <= maxint32 - row.End() );
	row = Range32( row.End(), row.End() + height );
	
	if ( Unfinished() )
	  {
		canvas = parent;
		canvas.SliceHorizontally( row );
		canvasMaintainer.Use( canvas );
	  }
	 else
		canvasMaintainer.UseNone();
  }
