// CanvasScreenLoop.h

#ifndef CanvasScreenLoop_h
#define CanvasScreenLoop_h

#ifndef CanvasMaintainer_h
#include "CanvasMaintainer.h"
#endif
#ifndef ScreenLoop_h
#include "ScreenLoop.h"
#endif
#ifndef Canvas_h
#include "Canvas.h"
#endif

class CanvasScreenLoop
  {
	private:
		const Canvas& parent;
		ScreenLoop screen;
		Canvas canvas;
		CanvasMaintainer canvasMaintainer;
	
		void AdvanceUntilVisible();
		
	public:
		CanvasScreenLoop( const Canvas& );
		
		bool Finished() const								{ return screen.Finished(); }
		bool Unfinished() const								{ return screen.Unfinished(); }
		
		void operator++();
		void operator++(int)									{ operator++(); }
		
		const Canvas *operator->() const					{ return &canvas; }
		const Canvas& operator*() const					{ return canvas; }
		
		const GraphicsDeviceObject& Screen() const	{ return *screen; }
  };

#endif
