// CanvasMaintainer.h

#ifndef CanvasMaintainer_h
#define CanvasMaintainer_h

class Canvas;

class CanvasMaintainer
  {
	private:
		const Canvas *const old;
		
		static const Canvas *current;

		// not implemented:
			CanvasMaintainer( const CanvasMaintainer& );
			void operator=( const CanvasMaintainer& );
	
	public:
		CanvasMaintainer()
		  : old( current )
		  {}
		
		CanvasMaintainer( const Canvas& toUse )
		  : old( current )
		  {
			Use( toUse );
		  }
		
		~CanvasMaintainer();
		
		void Use( const Canvas& toUse );
		void UseNone();
  };

#endif
