// JustifiedFrame.h

#ifndef JustifiedFrame_h
#define JustifiedFrame_h

#ifndef PaneStack_h
#include "PaneStack.h"
#endif
#ifndef StackedPane_h
#include "StackedPane.h"
#endif

class Justification;

class JustifiedFrame: public PaneStack
  {
	private:
		StackedPane interior;
		StackedPane exterior;

		const Justification& horizontal;
		const Justification& vertical;
		
	protected:
		virtual void Arrange( UPoint32 size );
		
	public:
		JustifiedFrame( const Announcing<UPoint32>& size,
							 const Justification& h,
							 const Justification& v );
		
		const RectangularPane& Interior() const	{ return interior; }
		RectangularPane& Interior()					{ return interior; }
		
		const RectangularPane& Exterior() const	{ return exterior; }
		RectangularPane& Exterior()					{ return exterior; }

		virtual int32 MinimumWidth() const;
		virtual int32 MinimumHeight() const;
		
		virtual int32 MaximumWidth() const;
		virtual int32 MaximumHeight() const;
		
		virtual int32 ReasonableWidth() const;
		virtual int32 ReasonableHeight() const;
		
		virtual int32 BestWidth( Range32 bounds ) const;
		virtual int32 BestHeight( Range32 bounds ) const;
  };

#endif
