// AcceptsConformanceToSize.h

#ifndef AcceptsConformanceToSize_h
#define AcceptsConformanceToSize_h

#ifndef View_h
#include "View.h"
#endif
#ifndef ConformsToPaneSize_h
#include "ConformsToPaneSize.h"
#endif

class AcceptsConformanceToSize
  {
	friend class ConformsToPaneSize;
	
	private:
		UPoint32 paneSize;
		bool paneSizeKnown;

		ConformsToPaneSize *conformingView;
	
		void SetConformingView( ConformsToPaneSize * );
		
		// not implemented:
			AcceptsConformanceToSize( const AcceptsConformanceToSize& );
			void operator=( const AcceptsConformanceToSize& );
	
	protected:
		AcceptsConformanceToSize();
		~AcceptsConformanceToSize()				{ Clear(); }
		
		void SetContent( View& view )
		  {
			SetConformingView( dynamic_cast<ConformsToPaneSize*>( &view ) );
		  }
		
		void Clear();

		void AnnouncePaneSize( UPoint32 );
  };

#endif
