// AcceptsSizeSuggestions.h

#ifndef AcceptsSizeSuggestions_h
#define AcceptsSizeSuggestions_h

#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif
#ifndef View_h
#include "View.h"
#endif

class SuggestsPaneSize;

class AcceptsSizeSuggestions
  {
	private:
		const SuggestsPaneSize *sizer;
		
	public:
		AcceptsSizeSuggestions()
		  : sizer( &SuggestsPaneSize::Zero() )
		  {}
		
		void SetContent( const View& view )
		  {
			sizer = dynamic_cast<const SuggestsPaneSize*>( &view );
			if ( sizer == 0 )
				sizer = &SuggestsPaneSize::LargestPossible();
		  }
		
		void Clear()					{ sizer = &SuggestsPaneSize::Zero(); }

		void SetSizer( const SuggestsPaneSize& s )		{ sizer = &s; }
		
		const SuggestsPaneSize& Sizer() const				{ return *sizer; }
  };

#endif
