// PaneStack.h

#ifndef PaneStack_h
#define PaneStack_h

#ifndef ListOf_h
#include "ListOf.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif
#ifndef Announcing_h
#include "Announcing.h"
#endif
#ifndef UPoint32_h
#include "UPoint32.h"
#endif
#ifndef LightListLoop_h
#include "LightListLoop.h"
#endif
#ifndef DrawsSpontaneously_h
#include "DrawsSpontaneously.h"
#endif

class PaneStack: virtual public DrawsSpontaneously
  {
	friend class StackedPane;
	
	private:
		ListOf<StackedPane> panes;
		
		Ear<PaneStack> listenToSize;
		const Announcing<UPoint32>& size;
		
		void SizeChanged();
	
	protected:
		typedef LightListLoop<StackedPane> PaneLoop;
		const ListOf<StackedPane>& Panes() const		{ return panes; }

		virtual void Arrange( UPoint32 size ) = 0;
		
	public:
		explicit PaneStack( const Announcing<UPoint32>& );
		
		virtual void Deliver( CellVisitor&, const Canvas& );
  };

#endif
