// StackedPane.h

#ifndef StackedPane_h
#define StackedPane_h

#ifndef RectangularPane_h
#include "RectangularPane.h"
#endif
#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef PaneStack_h
#include "PaneStack.h"
#endif

class StackedPane: public RectangularPane
  {
	private:
		ListLink<StackedPane> link;

	protected:
		virtual void Adjust( Canvas& ) const;
	
	public:
		StackedPane( PaneStack& stack )
		  : RectangularPane( &stack ),
			 link( this )
		  {
			stack.panes.Add( link, afterEnd );
		  }
	
  };

#endif
