// GrafPortRootPane.cp

#ifndef GrafPortRootPane_h
#include "GrafPortRootPane.h"
#endif
#ifndef Canvas_h
#include "Canvas.h"
#endif
#ifndef GrafPortObject_h
#include "GrafPortObject.h"
#endif

GrafPortRootPane::GrafPortRootPane( GrafPortObject& thePort )
  : Pane( 0 ),
	 port( thePort )
  {
  }

void GrafPortRootPane::Adjust( Canvas& canvas ) const
  {
	Assert( !canvas.HasPort() );
	canvas = port;
  }

const UPoint32 GrafPortRootPane::Size() const
  {
	return port.LocalBounds().Size();
  }

void GrafPortRootPane::Deliver( CellVisitor& visitor ) const
  {
	Canvas canvas( port );
	if ( canvas.Visible() )
		Content().Deliver( visitor, canvas );
  }
