// RectangularPane.cp

#ifndef RectangularPane_h
#include "RectangularPane.h"
#endif
#ifndef Canvas_h
#include "Canvas.h"
#endif

RectangularPane::RectangularPane( const DrawsSpontaneously *parent )
  : Pane( parent ),
	 bounds( Rectangle32::zero )
  {
  }

void RectangularPane::Adjust( Canvas& canvas ) const
  {
	Assert( Parent() != 0 );
	canvas.Submap( bounds );
  }

void RectangularPane::SetBounds( Rectangle32 newBounds )
  {
	Assert( Parent() != 0 );
	AnnouncePaneSize( newBounds.Size() );	
	bounds = newBounds;
  }

void RectangularPane::Clear()
  {
	AcceptsSizeSuggestions::Clear();
	Pane::Clear();
	AcceptsConformanceToSize::Clear();
  }
