// WindowRootPane.h

#ifndef WindowRootPane_h
#define WindowRootPane_h

#ifndef Pane_h
#include "Pane.h"
#endif
#ifndef AcceptsSizeSuggestions_h
#include "AcceptsSizeSuggestions.h"
#endif
#ifndef AcceptsConformanceToSize_h
#include "AcceptsConformanceToSize.h"
#endif

class WindowObject;
class PointObject;

class WindowRootPane: public Pane,
							 public AcceptsSizeSuggestions,
							 public AcceptsConformanceToSize
  {
	private:
		WindowObject& window;
		
	public:
		WindowRootPane( WindowObject& );

		virtual inline void SetContent( View& );
		void Clear();

		virtual void Adjust( Canvas& ) const;

		void Deliver( CellVisitor& ) const;
		void AnnounceSizeChange();
		
		const PointObject MinimumSize() const;
		const PointObject MaximumSize() const;
		const PointObject ReasonableSize() const;
		const PointObject BestSize( PointObject maximum ) const;
  };


inline void WindowRootPane::SetContent( View& view )
  {
	AcceptsSizeSuggestions::SetContent( view );
	Pane::SetContent( view );
	AcceptsConformanceToSize::SetContent( view );
  }

#endif
