// PaneColumn.h

#ifndef PaneColumn_h
#define PaneColumn_h

#ifndef TiledView_h
#include "TiledView.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif
#ifndef ConformsToPaneSize_h
#include "ConformsToPaneSize.h"
#endif

class PaneColumn: public TiledView,
						virtual public SuggestsPaneSize,
						virtual public ConformsToPaneSize
  {
	protected:		
		virtual void PaneSizeChanged();
	
	public:
		virtual int32 MinimumWidth() const;
		virtual int32 MinimumHeight() const;
		
		virtual int32 MaximumWidth() const;
		virtual int32 MaximumHeight() const;

		virtual int32 ReasonableWidth() const;
		virtual int32 ReasonableHeight() const;
		
		virtual int32 BestWidth( Range32 bounds ) const;
		virtual int32 BestHeight( Range32 bounds ) const;
  };

#endif
