// PaneColumnOfHeight.h

#ifndef PaneColumnOfHeight_h
#define PaneColumnOfHeight_h

#ifndef PaneColumn_h
#include "PaneColumn.h"
#endif
#ifndef TiledPane_h
#include "TiledPane.h"
#endif

template <uint32 numberOfPanes>
class PaneColumnOfHeight: public PaneColumn
  {
	private:
		TiledPane basePanes[ numberOfPanes ];
	
	public:
		PaneColumnOfHeight()
		  {
			for ( uint32 i = 0; i < numberOfPanes; i++ )
				Add( basePanes[i], afterEnd );
		  }
		
		RectangularPane& operator[]( uint32 i )
		  {
			Assert( i < numberOfPanes );
			return basePanes[i];
		  }
		
		const RectangularPane& operator[]( uint32 i ) const
		  {
			Assert( i < numberOfPanes );
			return basePanes[i];
		  }
  };

#endif
