// PaneRowOfWidth.h

#ifndef PaneRowOfWidth_h
#define PaneRowOfWidth_h

#ifndef PaneRow_h
#include "PaneRow.h"
#endif
#ifndef TiledPane_h
#include "TiledPane.h"
#endif

template <uint32 numberOfPanes>
class PaneRowOfWidth: public PaneRow
  {
	private:
		TiledPane basePanes[ numberOfPanes ];
	
	public:
		PaneRowOfWidth()
		  {
			for ( uint32 i = 0; i < numberOfPanes; i++ )
				Add( basePanes[i], afterEnd );
		  }
		
		RectangularPane& operator[]( uint32 i )
		  {
			Assert( i < numberOfPanes );
			return basePanes[i];
		  }
		
		const RectangularPane& operator[]( uint32 i ) const
		  {
			Assert( i < numberOfPanes );
			return basePanes[i];
		  }
  };

#endif
