// RuledFourSquareTiling.h

#ifndef RuledFourSquareTiling_h
#define RuledFourSquareTiling_h

#ifndef TiledView_h
#include "TiledView.h"
#endif
#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif
#ifndef ConformsToPaneSize_h
#include "ConformsToPaneSize.h"
#endif
#ifndef TiledPane_h
#include "TiledPane.h"
#endif

class RuledFourSquareTiling: public TiledView,
									  virtual public SuggestsPaneSize,
									  virtual public ConformsToPaneSize
  {
	private:
		TiledPane topLeft;
		TiledPane topRight;
		TiledPane bottomLeft;
		TiledPane bottomRight;
		TiledPane horizontalLine;
		TiledPane upperVerticalLine;
		TiledPane lowerVerticalLine;
	
		static int32 TileSum( int32 a, int32 b );
		
		int32 HorizontalSplitPosition() const;
		int32 VerticalSplitPosition() const;
		
	protected:
		virtual void PaneSizeChanged();
	
	public:
		RuledFourSquareTiling();
		
		RectangularPane& TopLeft()							{ return topLeft; }
		RectangularPane& TopRight()						{ return topRight; }
		RectangularPane& BottomLeft()						{ return bottomLeft; }
		RectangularPane& BottomRight()					{ return bottomRight; }

		const RectangularPane& TopLeft() const			{ return topLeft; }
		const RectangularPane& TopRight() const		{ return topRight; }
		const RectangularPane& BottomLeft() const		{ return bottomLeft; }
		const RectangularPane& BottomRight() const	{ return bottomRight; }

		virtual int32 MinimumWidth() const;
		virtual int32 MinimumHeight() const;
		
		virtual int32 MaximumWidth() const;
		virtual int32 MaximumHeight() const;

		virtual int32 ReasonableWidth() const;
		virtual int32 ReasonableHeight() const;
		
		virtual int32 BestWidth( Range32 bounds ) const;
		virtual int32 BestHeight( Range32 bounds ) const;
  };

#endif
