// RuledPaneRowOfWidth.h

#ifndef RuledPaneRowOfWidth_h
#define RuledPaneRowOfWidth_h

#ifndef PaneRowOfWidth_h
#include "PaneRowOfWidth.h"
#endif
#ifndef ViewCell_h
#include "ViewCell.h"
#endif
#ifndef VerticalBar_h
#include "VerticalBar.h"
#endif

template <uint32 nonRulePanes>
class RuledPaneRowOfWidth: public PaneRowOfWidth< 2 * nonRulePanes - 1 >
  {
	public:
		RuledPaneRowOfWidth()
		  {
			static const VerticalBar<1> verticalLine;
			for ( uint32 i = 1; i < 2 * nonRulePanes - 1; i+=2 )
			  {
				PaneRowOfWidth::operator[](i).SetContent( ViewCell::Black() );
				PaneRowOfWidth::operator[](i).SetSizer( verticalLine );
			  }
		  }
		
		RectangularPane& operator[]( uint32 i )
		  {
			return PaneRowOfWidth::operator[]( 2*i );
		  }
		
		RectangularPane& operator[]( uint32 i ) const
		  {
			return PaneRowOfWidth::operator[]( 2*i );
		  }
  };

#endif
