// ConformsToPaneSize.h

#ifndef ConformsToPaneSize_h
#define ConformsToPaneSize_h

#ifndef UPoint32_h
#include "UPoint32.h"
#endif
#ifndef DrawsSpontaneously_h
#include "DrawsSpontaneously.h"
#endif

class AcceptsConformanceToSize;

class ConformsToPaneSize: virtual public DrawsSpontaneously
  {
	friend class AcceptsConformanceToSize;
	
	private:
		AcceptsConformanceToSize *conformTo;

		UPoint32 paneSize;
		bool paneSizeKnown;
	
		// not implemented:
			ConformsToPaneSize( const ConformsToPaneSize& );
			void operator=( const ConformsToPaneSize& );
	
	protected:
		ConformsToPaneSize();
		~ConformsToPaneSize();

		virtual void PaneSizeChanged();
	
		bool PaneSizeKnown() const			{ return paneSizeKnown; }
		UPoint32 PaneSize() const			{ return paneSize; }
  };

#endif
