// DrawsSpontaneously.cp

#ifndef DrawsSpontaneously_h
#include "DrawsSpontaneously.h"
#endif
#ifndef ValidAndInvalidCanvasLoop_h
#include "ValidAndInvalidCanvasLoop.h"
#endif
#ifndef InvalidCanvasLoop_h
#include "InvalidCanvasLoop.h"
#endif
#ifndef CellUpdater_h
#include "CellUpdater.h"
#endif
#ifndef Pane_h
#include "Pane.h"
#endif

DrawsSpontaneously::~DrawsSpontaneously()
  {
	while ( !panes.IsEmpty() )
		(*panes.Last())->Clear();
  }

void DrawsSpontaneously::Invalidate() const
  {
	for ( ValidAndInvalidCanvasLoop canvas( *this );
			canvas.Unfinished();
			canvas++ )
		canvas->Invalidate();
  }

void DrawsSpontaneously::Redraw()
  {
	for ( ValidAndInvalidCanvasLoop canvas( *this );
			canvas.Unfinished();
			canvas++ )
	  {
		Deliver( CellUpdater( canvas->Clip() ), *canvas );
		canvas->Validate();
	  }
  }

void DrawsSpontaneously::Update()
  {
	for ( InvalidCanvasLoop canvas( *this );
			canvas.Unfinished();
			canvas++ )
	  {
		Deliver( CellUpdater( canvas->Clip() ), *canvas );
		canvas->Validate();
	  }
  }
