// SuggestsPaneSize.cp

#ifndef SuggestsPaneSize_h
#include "SuggestsPaneSize.h"
#endif

int32 SuggestsPaneSize::MinimumWidth() const
  {
	return 0;
  }

int32 SuggestsPaneSize::MinimumHeight() const
  {
	return 0;
  }

int32 SuggestsPaneSize::MaximumWidth() const
  {
	return maxint32;
  }

int32 SuggestsPaneSize::MaximumHeight() const
  {
	return maxint32;
  }

int32 SuggestsPaneSize::ReasonableWidth() const
  {
	return MinimumWidth();
  }

int32 SuggestsPaneSize::ReasonableHeight() const
  {
	return MinimumHeight();
  }

int32 SuggestsPaneSize::BestWidth( Range32 bound ) const
  {
	return bound.WeaklyRestrict( MaximumWidth() );
  }

int32 SuggestsPaneSize::BestHeight( Range32 bound ) const
  {
	return bound.WeaklyRestrict( MaximumHeight() );
  }

int32 SuggestsPaneSize::BestRevealedWidth( Range32 bound ) const
  {
	return bound.WeaklyRestrict( BestWidth( bound ) );
  }

int32 SuggestsPaneSize::BestRevealedHeight( Range32 bound ) const
  {
	return bound.WeaklyRestrict( BestHeight( bound ) );
  }

int32 SuggestsPaneSize::BestRevealedLeft( Range32 bound ) const
  {
	return bound.Center();
  }

int32 SuggestsPaneSize::BestRevealedTop( Range32 bound ) const
  {
	return bound.Center();
  }

const SuggestsPaneSize& SuggestsPaneSize::Zero()
  {
	class ZeroSizer: public SuggestsPaneSize
	  {
		public:
			virtual int32 MaximumWidth() const		{ return 0; }
			virtual int32 MaximumHeight() const		{ return 0; }
	  };
	
	static const ZeroSizer zero;
	return zero;
  }

const SuggestsPaneSize& SuggestsPaneSize::LargestPossible()
  {
	static const SuggestsPaneSize largestPossible;
	return largestPossible;
  }

const SuggestsPaneSize& SuggestsPaneSize::SmallestPossible()
  {
	class SmallestPossibleSizer: public SuggestsPaneSize
	  {
		public:
			virtual int32 BestHeight( Range32 bound ) const		{ return bound.Start(); }
			virtual int32 BestWidth( Range32 bound ) const		{ return bound.Start(); }
	  };
	
	static const SmallestPossibleSizer smallestPossible;
	return smallestPossible;
  }
