// CellCursorCollector.h

#ifndef CellCursorCollector_h
#define CellCursorCollector_h

#ifndef CellVisitor_h
#include "CellVisitor.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

class MouseEvent;
class RegionObject;
class CursorObject;

class CellCursorCollector: public CellVisitor
  {
	private:
		const MouseEvent& event;
		RegionObject& region;
		const CursorObject *cursor;
	
	public:
		CellCursorCollector( const MouseEvent& theEvent,
									RegionObject& theRegion );

		virtual void Visit( ViewCell&, const Canvas& );
		
		const CursorObject& Cursor() const
		  {
			Assert( cursor != 0 );
			return *cursor;
		  }
  };

#endif
