// CellUpdater.cp

#ifndef CellUpdater_h
#include "CellUpdater.h"
#endif
#ifndef ViewCell_h
#include "ViewCell.h"
#endif
#ifndef RegionObject_h
#include "RegionObject.h"
#endif
#ifndef Canvas_h
#include "Canvas.h"
#endif
#ifndef CanvasMaintainer_h
#include "CanvasMaintainer.h"
#endif

CellUpdater::CellUpdater( const RegionObject& target )
  : CellVisitor( target.Bounds() ),
	 toUpdate( target )
  {
  }

void CellUpdater::Visit( ViewCell& cell,
								 const Canvas& canvas )
  {
	if ( canvas.Visible() && canvas.Clip().Intersects( toUpdate ) )
	  {
		CanvasMaintainer cm( canvas );
		cell.Draw( canvas );
	  }
  }
