// ViewCell.h

#ifndef ViewCell_h
#define ViewCell_h

#ifndef View_h
#include "View.h"
#endif

class MouseDownEvent;
class MouseEvent;
class RegionObject;
class CursorObject;

/*
	This is the interface by which the screen/mouse user interface
	talks to the content of the program.  Only rather inert things
	can get by with this interface -- anything that needs to talk
	back to the screen should inherit from DrawsSpontaneously.
*/

class ViewCell: virtual public View
  {
	protected:
		~ViewCell()				{}
		
	public:
		virtual void Deliver( CellVisitor&, const Canvas& );
			// End of the line -- deliver to myself!
		
		virtual void Draw( const Canvas& ) const = 0;

		virtual void Click( const Canvas&,
								  const MouseDownEvent& );
		
		virtual void ActivatingClick( const Canvas&,
												const MouseDownEvent& );

		virtual const CursorObject& Cursor( const Canvas&,
														const MouseEvent&,
														RegionObject& ) const;
		
		static ViewCell& Blank();
		static ViewCell& Black();
  };

#endif
