// AbstractWindow.h

#ifndef AbstractWindow_h
#define AbstractWindow_h

class MouseDownEvent;
class CursorObject;
class MouseEvent;
class RegionObject;

class AbstractWindow
  {
	protected:
		~AbstractWindow()		{}
	
	public:
		virtual void Update() = 0;
		
		virtual void Activate() = 0;
		virtual void Deactivate() = 0;
		
		virtual void ClickContent( const MouseDownEvent& ) = 0;
		virtual void ClickDrag( const MouseDownEvent& ) = 0;
		virtual void ClickClose( const MouseDownEvent& ) = 0;
		virtual void ClickZoomIn( const MouseDownEvent& ) = 0;
		virtual void ClickZoomOut( const MouseDownEvent& ) = 0;
		virtual void ClickGrow( const MouseDownEvent& ) = 0;
		
		virtual const CursorObject& Cursor( const MouseEvent&,
														RegionObject& sleep ) = 0;
  };

#endif
