// StrangeWindow.h

#ifndef StrangeWindow_h
#define StrangeWindow_h

#ifndef AbstractWindow_h
#include "AbstractWindow.h"
#endif

class WindowObject;

class StrangeWindow: public AbstractWindow
  {
	private:
		WindowObject *window;
	
	public:
		StrangeWindow( WindowObject *theWindow )
		  : window( theWindow )
		  {
		  }
		
		virtual void Update();
		
		virtual void Activate();
		virtual void Deactivate();
		
		virtual void ClickContent( const MouseDownEvent& );
		virtual void ClickDrag( const MouseDownEvent& );
		virtual void ClickClose( const MouseDownEvent& );
		virtual void ClickZoomIn( const MouseDownEvent& );
		virtual void ClickZoomOut( const MouseDownEvent& );
		virtual void ClickGrow( const MouseDownEvent& );

		virtual const CursorObject& Cursor( const MouseEvent&,
														RegionObject& sleep );
  };

#endif
