// WindowController.h

#ifndef WindowController_h
#define WindowController_h

#ifndef Proxy_h
#include "Proxy.h"
#endif
#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef Rectangle_h
#include "Rectangle.h"
#endif
#ifndef ConstPString_h
#include "ConstPString.h"
#endif

class WindowFocus;

class WindowController
  {
	private:
		Proxy<bool>& visible;
		Proxy<bool>& zoomed;
		Proxy<Rectangle>& bounds;
		Proxy<ConstPString>& name;
		Proxy<uint32>& index;
		
	public:
		WindowController( Proxy<bool>& visibility,
								Proxy<bool>& zoomedness,
								Proxy<Rectangle>& theBounds,
								Proxy<ConstPString>& theName,
								Proxy<uint32>& theIndex )
		  : visible( visibility ),
			 zoomed( zoomedness ),
			 bounds( theBounds ),
			 name( theName ),
			 index( theIndex )
		  {}
		
		Proxy<bool>& Visible()								{ return visible; }
		const ConstProxy<bool>& Visible() const		{ return visible; }
		
		Proxy<bool>& Zoomed()								{ return zoomed; }
		const ConstProxy<bool>& Zoomed() const			{ return zoomed; }
		
		Proxy<Rectangle>& Bounds()							{ return bounds; }
		const ConstProxy<Rectangle>& Bounds() const	{ return bounds; }

		Proxy<ConstPString>& Name()						{ return name; }
		const ConstProxy<ConstPString>& Name() const	{ return name; }
		
		Proxy<uint32>& Index()								{ return index; }
		const ConstProxy<uint32>& Index() const		{ return index; }
		
		
  };

#endif
