// WindowDefinition.cp

#ifndef WindowDefinition_h
#include "WindowDefinition.h"
#endif

const WindowDefinition& WindowDefinition::Document()
  {
	static const WindowDefinition definition
	  (
		WindowObject::document,
		Rectangle( -1, -18, 2, 2 ),
		true, true, true,
		true, false, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::Document( NoCloseBox )
  {
	static const WindowDefinition definition
	  (
		WindowObject::document,
		Rectangle( -1, -18, 2, 2 ),
		false, true, true,
		true, false, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::Document( NoGrowBox )
  {
	static const WindowDefinition definition
	  (
		WindowObject::noGrow,
		Rectangle( -1, -18, 2, 2 ),
		true, false, true,
		true, false, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::Document( NoCloseBox,
																	 NoGrowBox )
  {
	static const WindowDefinition definition
	  (
		WindowObject::noGrow,
		Rectangle( -1, -18, 2, 2 ),
		false, false, true,
		true, false, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::Document( NoZoomBox )
  {
	static const WindowDefinition definition
	  (
		WindowObject::noZoom,
		Rectangle( -1, -18, 2, 2 ),
		true, true, false,
		true, false, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::Document( NoCloseBox,
																	 NoZoomBox )
  {
	static const WindowDefinition definition
	  (
		WindowObject::noZoom,
		Rectangle( -1, -18, 2, 2 ),
		false, true, false,
		true, false, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::Document( NoGrowBox,
																	 NoZoomBox )
  {
	static const WindowDefinition definition
	  (
		WindowObject::noGrowNoZoom,
		Rectangle( -1, -18, 2, 2 ),
		true, false, false,
		true, false, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::Document( NoCloseBox,
																	 NoGrowBox,
																	 NoZoomBox )
  {
	static const WindowDefinition definition
	  (
		WindowObject::noGrowNoZoom,
		Rectangle( -1, -18, 2, 2 ),
		false, false, false,
		true, false, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::Dialog()
  {
	static const WindowDefinition definition
	  (
		WindowObject::dialog,
		Rectangle( -1, -18, 2, 2 ),
		false, false, false,
		false, true, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::MovableModal()
  {
	static const WindowDefinition definition
	  (
		WindowObject::movableModal,
		Rectangle( -1, -18, 2, 2 ),
		true, false, false,
		true, true, false
	  );
	return definition;
  }

const WindowDefinition& WindowDefinition::MovableModal( NoCloseBox )
  {
	static const WindowDefinition definition
	  (
		WindowObject::movableModal,
		Rectangle( -1, -18, 2, 2 ),
		false, false, false,
		true, true, false
	  );
	return definition;
  }
