// WindowInitializer.cp

#ifndef WindowInitializer_h
#include "WindowInitializer.h"
#endif
#ifndef WindowDefaults_h
#include "WindowDefaults.h"
#endif

WindowInitializer::WindowInitializer()
  : useDefaultScreen( true ),
	 useDefaultPosition( true ),
	 useDefaultName( true ),
	 useDefaultIndex( true ),
	 useDefaultVisibility( true ),
	 zoomOpen( false )
  {
  }

GDHandle WindowInitializer::ScreenFor( const WindowDefaults& w ) const
  {
	return useDefaultScreen ? w.DefaultScreen() : screen;
  }

Rectangle WindowInitializer::PositionFor( const WindowDefaults& w ) const
  {
	return useDefaultPosition ? w.DefaultPosition( ScreenFor( w ) ) : position;
  }

ConstPString WindowInitializer::NameFor( const WindowDefaults& w ) const
  {
	if ( useDefaultName )
		w.GetDefaultName( name );
	
	return name;
  }

uint32 WindowInitializer::IndexFor( const WindowDefaults& w ) const
  {
	return useDefaultIndex ? w.DefaultIndex() : index;
  }

bool WindowInitializer::VisibilityFor( const WindowDefaults& w ) const
  {
	return useDefaultVisibility ? w.DefaultVisibility() : visible;
  }
