// WindowPile.h

#ifndef WindowPile_h
#define WindowPile_h

#ifndef Rectangle_h
#include "Rectangle.h"
#endif

class WindowPile
  {
	private:
		Rectangle pile;
		PointObject first;
		PointObject stop;
		PointObject offset;
		bool finished;
		
	public:
		WindowPile( Rectangle available, PointObject bestSize );
		
		bool Finished() const						{ return finished; }
		bool Unfinished() const						{ return !finished; }
		
		void operator++();
		void operator++(int)							{ operator++(); }
		
		const Rectangle& operator*() const		{ return pile; }
		const Rectangle *operator->() const		{ return &pile; }
  };

#endif
