// Buffer.cp

#ifndef Buffer_h
#include "Buffer.h"
#endif
#ifndef ConstBuffer_h
#include "ConstBuffer.h"
#endif

Buffer& operator<<( Buffer& to, ConstBuffer& from )
  {
	ConstData limitedFrom( from.Unused() );
	limitedFrom.LimitLength( to.UnusedLength() );
	
	to << limitedFrom;
	from.AdvanceMark( limitedFrom.Length() );
	
	Assert( to.Exhausted() || from.Exhausted() );
	
	return to;
  }
