// BufferOfSize.h

#ifndef BufferOfSize_h
#define BufferOfSize_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef DebugMessage_h
#include "DebugMessage.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef Range_h
#include "Range.h"
#endif
#ifndef ConstArrayOf_h
#include "ConstArrayOf.h"
#endif
#ifndef ConstData_h
#include "ConstData.h"
#endif
#ifndef ArrayOf_h
#include "ArrayOf.h"
#endif
#ifndef Data_h
#include "Data.h"
#endif
#ifndef Buffer_h
#include "Buffer.h"
#endif
#ifndef BufferMaster_h
#include "BufferMaster.h"
#endif

// The includes above have been flattened so that weak compilers
// can cope better.

template < uint32 size >
class BufferOfSize: public BufferMaster
  {
	private:
		uint8 space[ size ];
	
	public:
		BufferOfSize()
		  : BufferMaster( Data( space, size ) )
		  {}
		
		BufferOfSize( const BufferOfSize<size>& source )
		  : BufferMaster( Data( space, size ) )
		  {
			*this << source.Used();
		  }
  };

#endif
