// ConstBufferOf.cp

#ifndef ConstBufferOf_h
#include "ConstBufferOf.h"
#endif
#ifndef BufferOf_h
#include "BufferOf.h"
#endif

template < class Element >
ConstBufferOf<Element>::ConstBufferOf( ConstArrayType theSpace )
  : space( theSpace ),
	 unused( theSpace )
  {
	Assert( !theSpace.Null() );
  }

template < class Element >
void ConstBufferOf<Element>::Reset( ConstArrayType theSpace )
  {
	Assert( !theSpace.Null() );
	space = theSpace;
	unused = theSpace;
  }

template < class Element >
void ConstBufferOf<Element>::operator>>( ArrayType target )
  {
	AdvanceMark( target << Unused() );
  }

template < class Element >
void ConstBufferOf<Element>::operator>>( BufferType& target )
  {
	uint32 amount = target.Unused() << Unused();
	AdvanceMark( amount );
	target.AdvanceMark( amount );
  }
