// Overflow.cp

#ifndef Overflow_h
#include "Overflow.h"
#endif

bool CanAdd( uint8 a, uint8 b )
  {
	return maxuint8 - a >= b;
  }

bool CanAdd( uint16 a, uint16 b )
  {
	return maxuint16 - a >= b;
  }

bool CanAdd( uint32 a, uint32 b )
  {
	return maxuint32 - a >= b;
  }

bool CanAdd( uint64 a, uint64 b )
  {
	return maxuint64 - a >= b;
  }

bool CanAdd( int8 a, int8 b )
  {
	return ( a >= 0 )
				? ( maxint8 - a >= b )
				: ( minint8 - a <= b );
  }

bool CanAdd( int16 a, int16 b )
  {
	return ( a >= 0 )
				? ( maxint16 - a >= b )
				: ( minint16 - a <= b );
  }

bool CanAdd( int32 a, int32 b )
  {
	return ( a >= 0 )
				? ( maxint32 - a >= b )
				: ( minint32 - a <= b );
  }

bool CanAdd( int64 a, int64 b )
  {
	return ( a >= 0 )
				? ( maxint64 - a >= b )
				: ( minint64 - a <= b );
  }

bool CanAddSigned( int8 a, uint8 b )
  {
	return uint8( maxint8 - a ) >= b;
  }

bool CanAddSigned( int16 a, uint16 b )
  {
	return uint16( maxint16 - a ) >= b;
  }

bool CanAddSigned( int32 a, uint32 b )
  {
	return uint32( maxint32 - a ) >= b;
  }

bool CanAddSigned( int64 a, uint64 b )
  {
	return uint64( maxint64 - a ) >= b;
  }

bool CanAddUnsigned( int8 a, uint8 b )
  {
	return ( a >= 0 )
				? ( uint8( maxuint8 - a ) >= b )
				: ( uint8( -a ) <= b );
  }

bool CanAddUnsigned( int16 a, uint16 b )
  {
	return ( a >= 0 )
				? ( uint16( maxuint16 - a ) >= b )
				: ( uint16( -a ) <= b );
  }

bool CanAddUnsigned( int32 a, uint32 b )
  {
	return ( a >= 0 )
				? ( uint32( maxuint32 - a ) >= b )
				: ( uint32( -a ) <= b );
  }

bool CanAddUnsigned( int64 a, uint64 b )
  {
	return ( a >= 0 )
				? ( uint64( maxuint64 - a ) >= b )
				: ( uint64( -a ) <= b );
  }

bool CanSubtract( uint8 a, uint8 b )
  {
	return a >= b;
  }

bool CanSubtract( uint16 a, uint16 b )
  {
	return a >= b;
  }

bool CanSubtract( uint32 a, uint32 b )
  {
	return a >= b;
  }

bool CanSubtract( uint64 a, uint64 b )
  {
	return a >= b;
  }

bool CanSubtract( int8 a, int8 b )
  {
	return ( a >= 0 )
				? ( a - maxint8 <= b )
				: ( a - minint8 >= b );
  }

bool CanSubtract( int16 a, int16 b )
  {
	return ( a >= 0 )
				? ( a - maxint16 <= b )
				: ( a - minint16 >= b );
  }

bool CanSubtract( int32 a, int32 b )
  {
	return ( a >= 0 )
				? ( a - maxint32 <= b )
				: ( a - minint32 >= b );
  }

bool CanSubtract( int64 a, int64 b )
  {
	return ( a >= 0 )
				? ( a - maxint64 <= b )
				: ( a - minint64 >= b );
  }

bool CanSubtractSigned( int8 a, uint8 b )
  {
	return a >= int8( minint8 + b );
  }

bool CanSubtractSigned( int16 a, uint16 b )
  {
	return a >= int16( minint16 + b );
  }

bool CanSubtractSigned( int32 a, uint32 b )
  {
	return a >= int32( minint32 + b );
  }

bool CanSubtractSigned( int64 a, uint64 b )
  {
	return a >= int64( minint64 + b );
  }

bool CanSubtractSigned( uint8 a, int8 b )
  {
	return ( b >= 0 )
			 ? a >= uint8( minint8 + b )
			 : a <= uint8( maxint8 + b );
  }

bool CanSubtractSigned( uint16 a, int16 b )
  {
	return ( b >= 0 )
			 ? a >= uint16( minint16 + b )
			 : a <= uint16( maxint16 + b );
  }

bool CanSubtractSigned( uint32 a, int32 b )
  {
	return ( b >= 0 )
			 ? a >= uint32( minint32 + b )
			 : a <= uint32( maxint32 + b );
  }

bool CanSubtractSigned( uint64 a, int64 b )
  {
	return ( b >= 0 )
			 ? a >= uint64( minint64 + b )
			 : a <= uint64( maxint64 + b );
  }

bool CanSubtractSigned( uint8 a, uint8 b )
  {
	return ( a <= uint8(maxint8) )
			 ? int8( a ) >= int8( minint8 + b )
			 : a <= uint8( maxint8 - b );
  }

bool CanSubtractSigned( uint16 a, uint16 b )
  {
	return ( a <= uint16(maxint16) )
			 ? int16( a ) >= int16( minint16 + b )
			 : a <= uint16( maxint16 - b );
  }

bool CanSubtractSigned( uint32 a, uint32 b )
  {
	return ( a <= uint32(maxint32) )
			 ? int32( a ) >= int32( minint32 + b )
			 : a <= uint32( maxint32 - b );
  }

bool CanSubtractSigned( uint64 a, uint64 b )
  {
	return ( a <= uint64(maxint64) )
			 ? int64( a ) >= int64( minint64 + b )
			 : a <= uint64( maxint64 - b );
  }

bool CanSubtractUnsigned( int8 a, uint8 b )
  {
	return b <= uint8(maxint8) && a >= int8(b);
  }

bool CanSubtractUnsigned( int16 a, uint16 b )
  {
	return b <= uint16(maxint16) && a >= int16(b);
  }

bool CanSubtractUnsigned( int32 a, uint32 b )
  {
	return b <= uint32(maxint32) && a >= int32(b);
  }

bool CanSubtractUnsigned( int64 a, uint64 b )
  {
	return b <= uint64(maxint64) && a >= int64(b);
  }

bool CanSubtractUnsigned( uint8 a, int8 b )
  {
	return ( b >= 0 )
			 ? a >= uint8( b )
			 : a <= uint8( maxuint8 + b );
  }

bool CanSubtractUnsigned( uint16 a, int16 b )
  {
	return ( b >= 0 )
			 ? a >= uint16( b )
			 : a <= uint16( maxuint16 + b );
  }

bool CanSubtractUnsigned( uint32 a, int32 b )
  {
	return ( b >= 0 )
			 ? a >= uint32( b )
			 : a <= uint32( maxuint32 + b );
  }

bool CanSubtractUnsigned( uint64 a, int64 b )
  {
	return ( b >= 0 )
			 ? a >= uint64( b )
			 : a <= uint64( maxuint64 + b );
  }

bool CanMultiply( uint8 a, uint8 b )
  {
	return a == 0 || maxuint8 / a >= b;
  }

bool CanMultiply( uint16 a, uint16 b )
  {
	return a == 0 || maxuint16 / a >= b;
  }

bool CanMultiply( uint32 a, uint32 b )
  {
	return a == 0 || maxuint32 / a >= b;
  }

bool CanMultiply( uint64 a, uint64 b )
  {
	return a == 0 || maxuint64 / a >= b;
  }

bool CanMultiply( int8 a, int8 b )
  {
	int32 p = int16(a) * int16(b);
	return p >= minint8 && p <= maxint8;
  }

bool CanMultiply( int16 a, int16 b )
  {
	int32 p = int32(a) * int32(b);
	return p >= minint16 && p <= maxint16;
  }

bool CanMultiply( int32 a, int32 b )
  {
	if ( a == 0 )
		return true;
	
	if ( a == -1 )
		return b != minint32;
	
	if ( a > 0 )
		if ( b > 0 )
			return maxint32 / a >= b;
		 else
			return minint32 / a <= b;
	 else
		if ( b > 0 )
			return minint32 / a >= b;
		 else
			return maxint32 / a <= b;
  }

bool CanMultiply( int64 a, int64 b )
  {
	if ( a == 0 )
		return true;
	
	if ( a == -1 )
		return b != minint64;
	
	if ( a > 0 )
		if ( b > 0 )
			return maxint64 / a >= b;
		 else
			return minint64 / a <= b;
	 else
		if ( b > 0 )
			return minint64 / a >= b;
		 else
			return maxint64 / a <= b;
  }
