// Overflow.h

#ifndef Overflow_h
#define Overflow_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

inline uint8 Asuint8( char x )			{ Assert( x >= 0 );                                  return uint8(x); }
inline uint8 Asuint8( int8 x )			{ Assert( x >= 0 );                                  return uint8(x); }
inline uint8 Asuint8( int16 x )			{ Assert( x >= 0 );        Assert( x <= maxuint8 );  return uint8(x); }
inline uint8 Asuint8( int32 x )			{ Assert( x >= 0 );        Assert( x <= maxuint8 );  return uint8(x); }
inline uint8 Asuint8( int64 x )			{ Assert( x >= 0 );        Assert( x <= maxuint8 );  return uint8(x); }
inline uint8 Asuint8( int x )				{ Assert( x >= 0 );        Assert( x <= maxuint8 );  return uint8(x); }
inline uint8 Asuint8( uint16 x )			{                          Assert( x <= maxuint8 );  return uint8(x); }
inline uint8 Asuint8( uint32 x )			{                          Assert( x <= maxuint8 );  return uint8(x); }
inline uint8 Asuint8( uint64 x )			{                          Assert( x <= maxuint8 );  return uint8(x); }

inline int8 Asint8( char x )				{                          Assert( x <= maxint8 );   return int8(x); }
inline int8 Asint8( int16 x )				{ Assert( x >= minint8 );  Assert( x <= maxint8 );   return int8(x); }
inline int8 Asint8( int32 x )				{ Assert( x >= minint8 );  Assert( x <= maxint8 );   return int8(x); }
inline int8 Asint8( int64 x )				{ Assert( x >= minint8 );  Assert( x <= maxint8 );   return int8(x); }
inline int8 Asint8( int x )				{ Assert( x >= minint8 );  Assert( x <= maxint8 );   return int8(x); }
inline int8 Asint8( uint8 x )				{                          Assert( x <= maxint8 );   return int8(x); }
inline int8 Asint8( uint16 x )			{                          Assert( x <= maxint8 );   return int8(x); }
inline int8 Asint8( uint32 x )			{                          Assert( x <= maxint8 );   return int8(x); }
inline int8 Asint8( uint64 x )			{                          Assert( x <= maxint8 );   return int8(x); }

inline uint16 Asuint16( char x )			{ Assert( x >= 0 );                                  return uint16(x); }
inline uint16 Asuint16( int8 x )			{ Assert( x >= 0 );                                  return uint16(x); }
inline uint16 Asuint16( int16 x )		{ Assert( x >= 0 );                                  return uint16(x); }
inline uint16 Asuint16( int32 x )		{ Assert( x >= 0 );        Assert( x <= maxuint16 ); return uint16(x); }
inline uint16 Asuint16( int64 x )		{ Assert( x >= 0 );        Assert( x <= maxuint16 ); return uint16(x); }
inline uint16 Asuint16( int x )			{ Assert( x >= 0 );        Assert( x <= maxuint16 ); return uint16(x); }
inline uint16 Asuint16( uint32 x )		{                          Assert( x <= maxuint16 ); return uint16(x); }
inline uint16 Asuint16( uint64 x )		{                          Assert( x <= maxuint16 ); return uint16(x); }

inline int16 Asint16( int32 x )			{ Assert( x >= minint16 ); Assert( x <= maxint16 );  return int16(x); }
inline int16 Asint16( int64 x )			{ Assert( x >= minint16 ); Assert( x <= maxint16 );  return int16(x); }
inline int16 Asint16( int x )				{ Assert( x >= minint16 ); Assert( x <= maxint16 );  return int16(x); }
inline int16 Asint16( uint16 x )			{                          Assert( x <= maxint16 );  return int16(x); }
inline int16 Asint16( uint32 x )			{                          Assert( x <= maxint16 );  return int16(x); }
inline int16 Asint16( uint64 x )			{                          Assert( x <= maxint16 );  return int16(x); }

inline uint32 Asuint32( char x )			{ Assert( x >= 0 );                                  return uint32(x); }
inline uint32 Asuint32( int8 x )			{ Assert( x >= 0 );                                  return uint32(x); }
inline uint32 Asuint32( int16 x )		{ Assert( x >= 0 );                                  return uint32(x); }
inline uint32 Asuint32( int32 x )		{ Assert( x >= 0 );                                  return uint32(x); }
inline uint32 Asuint32( int64 x )		{ Assert( x >= 0 );        Assert( x <= maxuint32 ); return uint32(x); }
inline uint32 Asuint32( int x )			{ Assert( x >= 0 );        Assert( x <= maxuint32 ); return uint32(x); }
inline uint32 Asuint32( uint64 x )		{                          Assert( x <= maxuint32 ); return uint32(x); }

inline int32 Asint32( int64 x )			{ Assert( x >= minint32 ); Assert( x <= maxint32 );  return int32(x); }
inline int32 Asint32( int x )				{ Assert( x >= minint32 ); Assert( x <= maxint32 );  return int32(x); }
inline int32 Asint32( uint32 x )			{                          Assert( x <= maxint32 );  return int32(x); }
inline int32 Asint32( uint64 x )			{                          Assert( x <= maxint32 );  return int32(x); }

inline uint64 Asuint64( char x )			{ Assert( x >= 0 );                                  return uint64(x); }
inline uint64 Asuint64( int8 x )			{ Assert( x >= 0 );                                  return uint64(x); }
inline uint64 Asuint64( int16 x )		{ Assert( x >= 0 );                                  return uint64(x); }
inline uint64 Asuint64( int32 x )		{ Assert( x >= 0 );                                  return uint64(x); }
inline uint64 Asuint64( int64 x )		{ Assert( x >= 0 );											  return uint64(x); }
inline uint64 Asuint64( int x )			{ Assert( x >= 0 );        Assert( x <= maxuint64 ); return uint64(x); }

inline int64 Asint64( int x )				{ Assert( x >= minint64 ); Assert( x <= maxint64 );  return int64(x); }
inline int64 Asint64( uint64 x )			{                          Assert( x <= maxint64 );  return int64(x); }

bool CanAdd( uint8 a, uint8 b );
bool CanAdd( uint16 a, uint16 b );
bool CanAdd( uint32 a, uint32 b );
bool CanAdd( uint64 a, uint64 b );

bool CanAdd( int8 a, int8 b );
bool CanAdd( int16 a, int16 b );
bool CanAdd( int32 a, int32 b );
bool CanAdd( int64 a, int64 b );

bool CanAddSigned( int8 a, uint8 b );
bool CanAddSigned( int16 a, uint16 b );
bool CanAddSigned( int32 a, uint32 b );
bool CanAddSigned( int64 a, uint64 b );

inline bool CanAddSigned( uint8 a, int8 b )			{ return CanAddSigned( b, a ); }
inline bool CanAddSigned( uint16 a, int16 b )		{ return CanAddSigned( b, a ); }
inline bool CanAddSigned( uint32 a, int32 b )		{ return CanAddSigned( b, a ); }
inline bool CanAddSigned( uint64 a, int64 b )		{ return CanAddSigned( b, a ); }

bool CanAddUnsigned( int8 a, uint8 b );
bool CanAddUnsigned( int16 a, uint16 b );
bool CanAddUnsigned( int32 a, uint32 b );
bool CanAddUnsigned( int64 a, uint64 b );

inline bool CanAddUnsigned( uint8 a, int8 b )		{ return CanAddUnsigned( b, a ); }
inline bool CanAddUnsigned( uint16 a, int16 b )		{ return CanAddUnsigned( b, a ); }
inline bool CanAddUnsigned( uint32 a, int32 b )		{ return CanAddUnsigned( b, a ); }
inline bool CanAddUnsigned( uint64 a, int64 b )		{ return CanAddUnsigned( b, a ); }

bool CanSubtract( uint8 a, uint8 b );
bool CanSubtract( uint16 a, uint16 b );
bool CanSubtract( uint32 a, uint32 b );
bool CanSubtract( uint64 a, uint64 b );

bool CanSubtract( int8 a, int8 b );
bool CanSubtract( int16 a, int16 b );
bool CanSubtract( int32 a, int32 b );
bool CanSubtract( int64 a, int64 b );

bool CanSubtractSigned( int8 a, uint8 b );
bool CanSubtractSigned( int16 a, uint16 b );
bool CanSubtractSigned( int32 a, uint32 b );
bool CanSubtractSigned( int64 a, uint64 b );

bool CanSubtractSigned( uint8 a, int8 b );
bool CanSubtractSigned( uint16 a, int16 b );
bool CanSubtractSigned( uint32 a, int32 b );
bool CanSubtractSigned( uint64 a, int64 b );

bool CanSubtractSigned( uint8 a, uint8 b );
bool CanSubtractSigned( uint16 a, uint16 b );
bool CanSubtractSigned( uint32 a, uint32 b );
bool CanSubtractSigned( uint64 a, uint64 b );

bool CanSubtractUnsigned( int8 a, uint8 b );
bool CanSubtractUnsigned( int16 a, uint16 b );
bool CanSubtractUnsigned( int32 a, uint32 b );
bool CanSubtractUnsigned( int64 a, uint64 b );

bool CanSubtractUnsigned( uint8 a, int8 b );
bool CanSubtractUnsigned( uint16 a, int16 b );
bool CanSubtractUnsigned( uint32 a, int32 b );
bool CanSubtractUnsigned( uint64 a, int64 b );

bool CanMultiply( uint8 a, uint8 b );
bool CanMultiply( uint16 a, uint16 b );
bool CanMultiply( uint32 a, uint32 b );
bool CanMultiply( uint64 a, uint64 b );

bool CanMultiply( int8 a, int8 b );
bool CanMultiply( int16 a, int16 b );
bool CanMultiply( int32 a, int32 b );
bool CanMultiply( int64 a, int64 b );

#endif
