// SplitIntegers.h

#ifndef SplitIntegers_h
#define SplitIntegers_h

#ifndef Integers_h
#include "Integers.h"
#endif

inline uint8 Byte0( uint8 x )							{ return x; }

inline uint8 Byte0( uint16 x )						{ return uint8( ( x       ) ); }
inline uint8 Byte1( uint16 x )						{ return uint8( ( x >>  8 ) ); }

inline uint8 Byte0( uint32 x )						{ return uint8( ( x       ) ); }
inline uint8 Byte1( uint32 x )						{ return uint8( ( x >>  8 ) ); }
inline uint8 Byte2( uint32 x )						{ return uint8( ( x >> 16 ) ); }
inline uint8 Byte3( uint32 x )						{ return uint8( ( x >> 24 ) ); }

inline uint8 Byte0( uint64 x )						{ return uint8( ( x       ) ); }
inline uint8 Byte1( uint64 x )						{ return uint8( ( x >>  8 ) ); }
inline uint8 Byte2( uint64 x )						{ return uint8( ( x >> 16 ) ); }
inline uint8 Byte3( uint64 x )						{ return uint8( ( x >> 24 ) ); }
inline uint8 Byte4( uint64 x )						{ return uint8( ( x >> 32 ) ); }
inline uint8 Byte5( uint64 x )						{ return uint8( ( x >> 40 ) ); }
inline uint8 Byte6( uint64 x )						{ return uint8( ( x >> 48 ) ); }
inline uint8 Byte7( uint64 x )						{ return uint8( ( x >> 56 ) ); }

inline uint16 Word0( uint16 x )						{ return x; }

inline uint16 Word0( uint32 x )						{ return uint16( ( x       ) ); }
inline uint16 Word1( uint32 x )						{ return uint16( ( x >> 16 ) ); }

inline uint16 Word0( uint64 x )						{ return uint16( ( x       ) ); }
inline uint16 Word1( uint64 x )						{ return uint16( ( x >> 16 ) ); }
inline uint16 Word2( uint64 x )						{ return uint16( ( x >> 32 ) ); }
inline uint16 Word3( uint64 x )						{ return uint16( ( x >> 48 ) ); }

inline uint32 LongWord0( uint32 x )					{ return x; }

inline uint32 LongWord0( uint64 x )					{ return uint32( ( x       ) ); }
inline uint32 LongWord1( uint64 x )					{ return uint32( ( x >> 32 ) ); }

inline uint16 Combine( uint8 a, uint8 b )			{ return uint16( uint16( uint16( a ) <<  8 ) | uint16( b ) ); }
inline uint32 Combine( uint16 a, uint16 b )		{ return uint32( uint32( uint32( a ) << 16 ) | uint32( b ) ); }
inline uint64 Combine( uint32 a, uint32 b )		{ return uint64( uint64( uint64( a ) << 32 ) | uint64( b ) ); }

inline uint32 Combine( uint8 a, uint8 b, uint8 c, uint8 d )
												{ return Combine( Combine( a, b ), Combine( c, d ) ); }
														
inline uint64 Combine( uint16 a, uint16 b, uint16 c, uint16 d )
												{ return Combine( Combine( a, b ), Combine( c, d ) ); }

inline uint64 Combine( uint8 a, uint8 b, uint8 c, uint8 d, uint8 e, uint8 f, uint8 g, uint8 h )
												{ return Combine( Combine( Combine( a, b ), Combine( c, d ) ),
																		Combine( Combine( e, f ), Combine( g, h ) ) ); }

#endif
