// LightListLoop.h

#ifndef LightListLoop_h
#define LightListLoop_h

#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef ListOf_h
#include "ListOf.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

template < class Element >
class LightListLoop
  {
	private:
		const ListLink<Element> *link;
	
	public:
		explicit LightListLoop( const ListOf<Element>& list )
		  : link( list.First() )
		  {}

		explicit LightListLoop( const ListLink<Element>& start )
		  : link( &start )
		  {}
		
		bool Unfinished() const			{ return link != 0; }
		bool Finished() const			{ return link == 0; }
		
		void operator++()					{ link = link->Next(); }
		void operator++(int)				{ link = link->Next(); }

		void operator--()					{ link = link->Previous(); }
		void operator--(int)				{ link = link->Previous(); }
		
		Element& operator*() const		{ return **link; }
		Element *operator->() const	{ return &**link; }
  };

#endif
