// ListLink.h

#ifndef ListLink_h
#define ListLink_h

#ifndef ListNode_h
#include "ListNode.h"
#endif
#ifndef Link_h
#include "Link.h"
#endif

template < class TargetType > class ListOf;
template < class TargetType > class ListLoop;

template < class TargetType >
class ListLink: private ListNode,
					 public Link<TargetType>
  {
	friend class ListOf< TargetType >;
	friend class ListLoop< TargetType >;
	
	private:
		static const ListLink<TargetType> *DownCast( const ListNode *n )
		  { return static_cast< const ListLink<TargetType>* >( n ); }

		static ListLink<TargetType> *DownCast( ListNode *n )
		  { return static_cast< ListLink<TargetType>* >( n ); }

		static ListOf<TargetType>& DownCast( List& n )
		  { return static_cast< ListOf<TargetType>& >( n ); }
		
	public:
		ListLink( TargetType *t = 0 )
		  : Link<TargetType>( t )
		  {}
		
		const ListLink<TargetType> *Next() const			{ return DownCast( ListNode::Next() ); }
		const ListLink<TargetType> *Previous() const		{ return DownCast( ListNode::Previous() ); }
		
		ListLink<TargetType> *Next()							{ return DownCast( ListNode::Next() ); }
		ListLink<TargetType> *Previous()						{ return DownCast( ListNode::Previous() ); }
		
		// Access declarations are broken in templates in CW Pro 5
		// ListNode::Owned;
		bool Owned() const										{ return ListNode::Owned(); }
		
		ListOf<TargetType>& Owner() const					{ return DownCast( ListNode::Owner() ); }
  };

#endif
