// ListOf.h

#ifndef ListOf_h
#define ListOf_h

#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef List_h
#include "List.h"
#endif
#ifndef ListLoop_h
#include "ListLoop.h"
#endif

template < class TargetType >
class ListOf: private List
  {
	typedef ListLink< TargetType > Link;
	typedef ListLoop< TargetType > Loop;

	friend class ListLink< TargetType >;
	friend class ListLoop< TargetType >;
	
	private:
		static const ListLink<TargetType> *DownCast( const ListNode *n );
		static ListLink<TargetType> *DownCast( ListNode *n );
		
	public:
		const Link *First() const										{ return DownCast( List::First() ); }
		const Link *Last() const										{ return DownCast( List::Last() ); }

		Link *First()														{ return DownCast( List::First() ); }
		Link *Last()														{ return DownCast( List::Last() ); }
		
		// Access declarations are broken in templates in CW Pro 5
		// ListNode::Owned;
		// List::RemoveAll;
		bool IsEmpty() const												{ return List::IsEmpty(); }
		void RemoveAll()													{ List::RemoveAll(); }
		
		void Add( Link& n, BeforeStart )								{ List::Add( n, beforeStart ); }
		void Add( Link& n, AfterEnd )									{ List::Add( n, afterEnd ); }
		
		void Add( Link& n, Before, const Link& position )		{ List::Add( n, before, position ); }
		void Add( Link& n, After, const Link& position )		{ List::Add( n, after, position ); }
		
		void Add( Link& n, Before, const Loop& position )		{ List::Add( n, before, position ); }
		void Add( Link& n, After, const Loop& position )		{ List::Add( n, after, position ); }
		
		void Remove( Link& n )											{ List::Remove( n ); }
  };

#ifndef ListOf_cp
#include "ListOf.cp"
#endif

#endif
