// AlignedBlock.h

#ifndef AlignedBlock_h
#define AlignedBlock_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef Alignment_h
#include "Alignment.h"
#endif
#ifndef DebugMessage_h
#include "DebugMessage.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef Range_h
#include "Range.h"
#endif
#ifndef ConstArrayOf_h
#include "ConstArrayOf.h"
#endif
#ifndef ConstData_h
#include "ConstData.h"
#endif
#ifndef ArrayOf_h
#include "ArrayOf.h"
#endif
#ifndef Data_h
#include "Data.h"
#endif

// The includes above have been flattened so that weak compilers
// can cope better.

template < uint32 size >
class AlignedBlock
  {
	private:
		union
		  {
			HardestTypeToAlign aligner;
			uint8 space[ size ];
		  };
	
	public:
		void *operator[]( uint32 position )
		  {
			return space + position;
		  }
		
		const void *operator[]( uint32 position ) const
		  {
			return space + position;
		  }
		
		void *Start()						{ return space; }
		const void *Start() const		{ return space; }
		
		operator Data()					{ return Data( space, size ); }
		operator ConstData() const		{ return ConstData( space, size ); }
  };

#endif
