// SingleAllocator.h

#ifndef SingleAllocator_h
#define SingleAllocator_h

#ifndef AlignedBlock_h
#include "AlignedBlock.h"
#endif
#ifndef SingleAllocatorBase_h
#include "SingleAllocatorBase.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

template < class Base, uint32 maxSize >
class SingleAllocator: public SingleAllocatorBase
  {
	private:
		AlignedBlock< maxSize > space;
	
	public:
		SingleAllocator()
		  : SingleAllocatorBase( space )
		  {}
		
		void Delete( Base *p )
		  {
			Assert( p != 0 );
			p->~Base();
			Release( p );
		  }
		
		void DeleteAll()
		  {
			if ( Full() )
				Delete( static_cast<Base *>( (void *)space ) );
		  }
  };

#endif
