// SingleAllocatorBase.cp

#ifndef SingleAllocatorBase_h
#include "SingleAllocatorBase.h"
#endif

SingleAllocatorBase::SingleAllocatorBase( Data theSpace )
  : space( theSpace ),
	 full( 0 )
  {
  }

void *SingleAllocatorBase::Allocate( uint32 size )
  {
	Assert( size <= space.Length() );
	Assert( !full );
	
	if ( full )
		throw SingleAllocatorFull();
	
	full = true;
	return space.Start();
  }

void SingleAllocatorBase::Release( void *p )
  {
	Assert( full );
	Assert( p == space.Start() );
	full = false;
  }
