// SingleAllocatorBase.h

#ifndef SingleAllocatorBase_h
#define SingleAllocatorBase_h

#ifndef Data_h
#include "Data.h"
#endif

class SingleAllocatorFull	{};

class SingleAllocatorBase
  {
	private:
		const Data space;
		bool full;
		
	public:
		SingleAllocatorBase( Data );
		
		bool Full() const		{ return full; }
		bool Empty() const	{ return !full; }
		
		void *Allocate( uint32 size );
		void Release( void *p );
  };

inline void *operator new( size_t size, SingleAllocatorBase& pool )
  { return pool.Allocate( size ); }

#if !defined(__MWERKS__) && !defined(_MSC_VER)
	// placement delete is not implemented by CW Pro 4
	inline void operator delete( void *p,  SingleAllocatorBase& pool )
		{ pool.Release( p ); }
#endif

#endif
