// ConstStackLoop.h

#ifndef ConstStackLoop_h
#define ConstStackLoop_h

#ifndef ConstStackLoopBase_h
#include "ConstStackLoopBase.h"
#endif
#ifndef Stack_h
#include "Stack.h"
#endif

template < class Element >
class ConstStackLoop: private ConstStackLoopBase
  {
	public:
		ConstStackLoop( StackOf<Element>& stack )
		  : ConstStackLoopBase( stack )
		  {}
		
		// Access declarations are broken in templates in CW Pro 5
		//using ConstStackLoopBase::Finished;
		//using ConstStackLoopBase::Unfinished;
		//using ConstStackLoopBase::operator++;
		bool Finished() const			{ return ConstStackLoopBase::Finished(); }
		bool Unfinished() const			{ return ConstStackLoopBase::Unfinished(); }
		void operator++()					{ ConstStackLoopBase::operator++(); }
		void operator++(int)				{ ConstStackLoopBase::operator++(0); }
		
		const Element& operator*() const
		  {
			Assert( Position() != 0 );
			return *static_cast< const Element * >( Position() );
		  }
		
		const Element *operator->() const
		  {
			Assert( Position() != 0 );
			return static_cast< const Element * >( Position() );
		  }
  };

#endif
