// ConstStackLoopBase.cp

#ifndef ConstStackLoopBase_h
#include "ConstStackLoopBase.h"
#endif

void ConstStackLoopBase::AdvancePiece()
  {
	Assert( position != 0 );
	Assert( piece != 0 );
	
	if ( position == piece->storage.End() )
	  {
		piece = piece->deeper;
		position = (piece == 0) ? 0 : piece->storage.Start();
	  }
  }

ConstStackLoopBase::ConstStackLoopBase( const StackBase& stack )
  : piece( stack.topPiece ),
	 position( stack.top ),
	 unitSize( stack.unitSize )
  {
	AdvancePiece();
  }

// A bug in CW Pro 4 gives us compile-time trouble in
// StackLoop<Element> if this is operator++().
void ConstStackLoopBase::Advance()
  {
	Assert( Unfinished() );

	position += unitSize;
	AdvancePiece();
  }
