// ConstStackLoopBase.h

#ifndef ConstStackLoopBase_h
#define ConstStackLoopBase_h

#ifndef StackBase_h
#include "StackBase.h"
#endif

class ConstStackLoopBase
  {
	private:
		const StackBase::Piece *piece;
		const uint8 *position;
		const uint32 unitSize;
		
		void AdvancePiece();
		void Advance();
		
	public:
		ConstStackLoopBase( const StackBase& stack );
		
		bool Finished() const				{ return position == 0; }
		bool Unfinished() const				{ return position != 0; }
		
		void operator++()						{ Advance(); }
		void operator++(int)					{ operator++(); }
		
		const void *Position() const		{ return position; }
  };

#endif
