// Stack.h

#ifndef Stack_h
#define Stack_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef Alignment_h
#include "Alignment.h"
#endif
#ifndef DebugMessage_h
#include "DebugMessage.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef Range_h
#include "Range.h"
#endif
#ifndef ConstArrayOf_h
#include "ConstArrayOf.h"
#endif
#ifndef ConstData_h
#include "ConstData.h"
#endif
#ifndef ArrayOf_h
#include "ArrayOf.h"
#endif
#ifndef Data_h
#include "Data.h"
#endif
#ifndef AlignedBlock_h
#include "AlignedBlock.h"
#endif
#ifndef StackBase_h
#include "StackBase.h"
#endif
#ifndef StackOf_h
#include "StackOf.h"
#endif

// The includes above have been flattened so that weak compilers
// can cope better.

template < class Element, uint32 baseSize >
class Stack: public StackOf<Element>
  {
	private:
		AlignedBlock< baseSize * sizeof( Element ) > space;
	
	public:
		Stack()
		  : StackOf<Element>( space )
		  {}
  };

#endif
