// StackAllocator.h

#ifndef StackAllocator_h
#define StackAllocator_h

#ifndef Integers_h
#include "Integers.h"
#endif
#ifndef Alignment_h
#include "Alignment.h"
#endif
#ifndef DebugMessage_h
#include "DebugMessage.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef Range_h
#include "Range.h"
#endif
#ifndef ConstArrayOf_h
#include "ConstArrayOf.h"
#endif
#ifndef ConstData_h
#include "ConstData.h"
#endif
#ifndef ArrayOf_h
#include "ArrayOf.h"
#endif
#ifndef Data_h
#include "Data.h"
#endif
#ifndef StackAllocatorBase_h
#include "StackAllocatorBase.h"
#endif
#ifndef AlignedBlock_h
#include "AlignedBlock.h"
#endif

// The includes above have been flattened so that weak compilers
// can cope better.

template < uint32 baseSize >
class StackAllocator: public StackAllocatorBase
  {
	private:
		AlignedBlock< baseSize > baseSection;
	
	public:
		StackAllocator()
		  : StackAllocatorBase( baseSection )
		  {}
  };

#endif
