// StackLeveler.h

#ifndef StackLeveler_h
#define StackLeveler_h

#ifndef StackAllocatorBase_h
#include "StackAllocatorBase.h"
#endif

class StackLeveler
  {
	private:
		StackAllocatorBase& stack;
		const void *level;
	
	public:
		StackLeveler( StackAllocatorBase& theStack )
		  : stack( theStack ),
			 level( theStack.Level() )
		  {}
		
		~StackLeveler()
		  {
			stack.ReleaseTo( level );
		  }
		
		void RestoreLevel()
		  {
			stack.ReleaseTo( level );
		  }
  };

#endif
