// StackLoop.h

#ifndef StackLoop_h
#define StackLoop_h

#ifndef StackLoopBase_h
#include "StackLoopBase.h"
#endif
#ifndef Stack_h
#include "Stack.h"
#endif

template < class Element >
class StackLoop: private StackLoopBase
  {
	public:
		StackLoop( StackOf<Element>& stack )
		  : StackLoopBase( stack )
		  {}
		
		// Access declarations are broken in templates in CW Pro 5
		//using StackLoopBase::Finished;
		//using StackLoopBase::Unfinished;
		//using StackLoopBase::operator++;
		bool Finished() const			{ return StackLoopBase::Finished(); }
		bool Unfinished() const			{ return StackLoopBase::Unfinished(); }
		void operator++()					{ StackLoopBase::operator++(); }
		void operator++(int)				{ StackLoopBase::operator++(0); }
		
		Element& operator*() const
		  {
			Assert( Position() != 0 );
			return *static_cast< Element * >( Position() );
		  }
		
		Element *operator->() const
		  {
			Assert( Position() != 0 );
			return static_cast< Element * >( Position() );
		  }
  };

#endif
