// TemporaryMemory.cp

#ifndef TemporaryMemory_h
#include "TemporaryMemory.h"
#endif
#ifndef Bits_h
#include "Bits.h"
#endif

#include <new>

bool TemporaryMemoryBase::TryToAllocate( uint32 size )
  {
	void *space = ::operator new( size, nothrow );

	if ( space == 0 )
		return false;
	
	theMemory = Data( space, size );
	return true;
  }

TemporaryMemoryBase::TemporaryMemoryBase( uint32 idealSize,
														Data minimumSpace )
  : allocated( true )
  {
	if ( idealSize > minimumSpace.Length() )
	  {
		if ( TryToAllocate( idealSize ) )
			return;
		
		idealSize = 1uL << Bits::LastOne( idealSize );
	  }
	
	for ( ; idealSize > minimumSpace.Length(); idealSize /= 2 )
		if ( TryToAllocate( idealSize ) )
			return;
	
	allocated = false;
	theMemory = minimumSpace;
  }

TemporaryMemoryBase::~TemporaryMemoryBase()
  {
	if ( allocated )
		::operator delete( theMemory.Start() );
  }