// TemporaryMemory.h

#ifndef TemporaryMemory_h
#define TemporaryMemory_h

#ifndef Data_h
#include "Data.h"
#endif

class TemporaryMemoryBase
  {
	private:
		Data theMemory;
		bool allocated;
		
		// not implemented:
			TemporaryMemoryBase( const TemporaryMemoryBase& );
			void operator=( const TemporaryMemoryBase& );
	
		bool TryToAllocate( uint32 size );
		
	public:
		TemporaryMemoryBase( uint32 idealSize, Data minimumSpace );
		~TemporaryMemoryBase();
		
		operator Data() const		{ return theMemory; }
		Data Memory() const			{ return theMemory; }
  };

template< uint32 minimumSize >
class TemporaryMemory: public TemporaryMemoryBase
  {
	private:
		uint8 minimumSpace[ minimumSize ];
	
	public:
		TemporaryMemory( uint32 idealSize )
		  : TemporaryMemoryBase( idealSize, Data( minimumSpace, minimumSize ) )
		  {}
  };

#endif
