// Division.h

#ifndef Division_h
#define Division_h

#ifndef Integers_h
#include "Integers.h"
#endif

#if (-1) / 2 == -1   &&   1 / (-2) == -1   &&   (-1) / (-2) == 0

	// built-in division rounds down

	template < class T >
	inline T DivideRoundingDown( T a, T b )
	  {
		return a/b;
	  }

	template < class T >
	inline T DivideRoundingTowardZero( T a, T b )
	  {
		T quotient = a / b;
		if ( quotient < 0 && a % b != 0 )
			quotient += 1;
		return quotient;
	  }

	template < class T >
	inline T RoundingDownRemainder( T a, T b )
	  {
		return a%b;
	  }

	template < class T >
	inline T TowardZeroRemainder( T a, T b )
	  {
		T remainder = a % b;
		if ( remainder != 0 && a/b < 0 )
			remainder -= b;
		return remainder;
	  }

#elif (-1) / 2 == 0   &&   1 / (-2) == 0   &&   (-1) / (-2) == 0

	// built-in division rounds toward zero

	template < class T >
	inline T DivideRoundingDown( T a, T b )
	  {
		T quotient = a / b;
		if ( quotient <= 0 && a%b != 0 && ( (a<0) != (b<0) ) )
			quotient -= 1;
		return quotient;
	  }

	template < class T >
	inline T DivideRoundingTowardZero( T a, T b )
	  {
		return a/b;
	  }

	template < class T >
	inline T RoundingDownRemainder( T a, T b )
	  {
		T remainder = a % b;
		if ( remainder != 0 && ( (a<0) != (b<0) ) )
			remainder += b;
		return remainder;
	  }

	template < class T >
	inline T TowardZeroRemainder( T a, T b )
	  {
		return a%b;
	  }

#else
	#error
#endif

#endif
