// SoftshoeFilter.cp

#ifndef SoftshoeFilter_h
#include "SoftshoeFilter.h"
#endif

#include <Events.h>
#include <LowMem.h>

static GetNextEventFilterUPP oldEventFilter;

static bool CursorIsObscured()
  {
	return *reinterpret_cast< unsigned char * >( 0x8d2 ) != 0;
  }

static bool ShouldDrop( EventKind eventCode )
  {
	if ( eventCode != mouseDown && eventCode != mouseUp )
		return false;
	
	return CursorIsObscured();
  }

static pascal void EventFilter( EventRecord *theEvent,
										  Boolean *result )
  {
	CallGetNextEventFilterProc( oldEventFilter, theEvent, result );

	if ( ShouldDrop( theEvent->what ) )
	  {
		theEvent->what = nullEvent;
		*result = false;
	  }
  }

SoftshoeFilter::SoftshoeFilter()
  {
	static RoutineDescriptor EventFilter =
		BUILD_ROUTINE_DESCRIPTOR( uppGetNextEventFilterProcInfo, &::EventFilter );

	oldEventFilter = LMGetGNEFilter();
	LMSetGNEFilter( &EventFilter );
  }

SoftshoeFilter::~SoftshoeFilter()
  {
	LMSetGNEFilter( oldEventFilter );
  }
