#ifndef _NUBPREFIX_
#define _NUBPREFIX_


#if __MC68K__
	#if __option(macsbug)
		#define DEBUG			1
	#else
		#define DEBUG			0
	#endif
#elif __POWERPC__
	#if __option(traceback )
		#define DEBUG			1
	#else
		#define DEBUG			0
	#endif
#endif

#define DCON					DEBUG


// Project prefix for dprintf calls.  This is optional but should be implemented,
// as it provides the ability to distinguish where the output came from when more
// than one entity is using DCon at the same time.  This must be manually added
// to the beginning of each call: dprintf(kDConPrefix "...
#define kDConPrefix				"Nub: "
#define kDConLogName			"Nub"
#define DCONLOG					DCON && 0


// CallTracing uses DCon to print an indented listing of when a function enters
// and exits, thus generating a call trace.  Optionally, it can also be used to
// (very) roughly measure the amount of time spent inside a function and all of
// its sub-functions.  To enable call tracing you must add a single line to the
// top of any functions to be traced: CallTrace trace("function name");
#define CALLTRACE				0
#define CALLTRACE_TIMER			0


// This overrides DCon functions at boot time and funnels a copy of any output
// destined for DCon straight to a VRAM console.  Later after has DCon has had
// a chance to load it'll turn itself off so as to not be completely annoying.
#define MACPRINTENABLED			1


#endif /* _NUBPREFIX_ */
