#ifndef _PORT_
#define _PORT_

#include <MacTypes.h>
#include <QDOffscreen.h>
#include "ProcInfo.h"

#ifdef __cplusplus
extern "C" {
#endif


typedef struct PortShade
{
	GrafPtr			port;
	Boolean			color;
	union {
		QDProcs		bw;
		CQDProcs	color;
	} stdProcs;
	union {
		QDProcs		bw;
		CQDProcs	color;
	} procs;
} PortShade, *PortShadePtr, **PortShadeHandle;


OSStatus InitializePorts(void);
void FinalizePorts(void);
void AddDirtyRect(GrafPtr port,Rect *dirtyRect);
void FlushScreenBuffer(void);
void MungeCopyBits(BitMap *srcMap,BitMap *dstMap,Rect *srcRect,Rect *dstRect,short mode,RgnHandle maskRgn,CopyBitsProcPtr copyBitsProc);
void RegisterPort(GrafPtr port);
void RescanPorts(void);
void UnregisterPort(GrafPtr port,Boolean afterTheFact);

#ifdef __cplusplus
}
#endif

#endif /* _PORT_ */
